SystemOrganization addCategory: #Express2Cheddar!
SystemOrganization addCategory: #'Express2Cheddar-AdaInterfaceSchema'!
SystemOrganization addCategory: #'Express2Cheddar-AdaInterfaceSchema-classifying'!
SystemOrganization addCategory: #'Express2Cheddar-CheddarConstantsSchema'!
SystemOrganization addCategory: #'Express2Cheddar-CheddarConstantsSchema-classifying'!
SystemOrganization addCategory: #'Express2Cheddar-CheddarDomainsSchema'!
SystemOrganization addCategory: #'Express2Cheddar-CheddarDomainsSchema-classifying'!
SystemOrganization addCategory: #'Express2Cheddar-CheddarDtdSchema'!
SystemOrganization addCategory: #'Express2Cheddar-CheddarDtdSchema-classifying'!
SystemOrganization addCategory: #'Express2Cheddar-DiscriminatedTypeSchema'!
SystemOrganization addCategory: #'Express2Cheddar-DiscriminatedTypeSchema-classifying'!
SystemOrganization addCategory: #'Express2Cheddar-Express2cheddarFacadeSchema'!
SystemOrganization addCategory: #'Express2Cheddar-Express2cheddarSchemaInstance'!
SystemOrganization addCategory: #'Express2Cheddar-PackageSchema'!
SystemOrganization addCategory: #'Express2Cheddar-PackageSchema-classifying'!
SystemOrganization addCategory: #'Express2Cheddar-RecordAndClassSchema'!
SystemOrganization addCategory: #'Express2Cheddar-RecordAndClassSchema-classifying'!
SystemOrganization addCategory: #'Express2Cheddar-XmlIoSchema'!
SystemOrganization addCategory: #'Express2Cheddar-scripts'!
SystemOrganization addCategory: #'Express2Cheddar-scripts'!

PlatypusCoreSchema subclass: #ExChdAdaInterfaceSchemaDefinition
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Express2Cheddar-AdaInterfaceSchema'!

!ExChdAdaInterfaceSchemaDefinition commentStamp: 'platypus comment' prior: 0!
<ISO10303-11-EXPRESS>
SCHEMA ada_interface;
	USE FROM platypus_dictionary_schema;
	USE FROM express_toolsbox_functions;
	USE FROM package;

	ENTITY ada_interface;
		prefix : STRING;
		suffix : OPTIONAL STRING;
		with_it : BOOLEAN;
		use_it : BOOLEAN;
	DERIVE
		full_name : STRING := ada_interface_path ( SELF );
		declaration : STRING := ada_interface_declaration ( SELF );
	END_ENTITY;

	FUNCTION ada_interface_path ( i : ada_interface ) : STRING;
		LOCAL 
			name : STRING := i.prefix;
		END_LOCAL;

		IF EXISTS ( i.suffix ) THEN
			name := name + '.' + i.suffix;
		END_IF;
		RETURN ( name );
	END_FUNCTION;

	FUNCTION ada_interface_declaration ( int : ada_interface ) : STRING;
		LOCAL 
			s : STRING := '';
			name : STRING := ada_interface_path ( int );
		END_LOCAL;

		IF int.with_it THEN
			s := s + 'with ' + name + ';\n';
		END_IF;

		IF int.use_it THEN
			s := s + 'use ' + name + ';\n';
		END_IF;
		RETURN ( s );
	END_FUNCTION;

	FUNCTION ada_interfaces_code ( from_pkg : ada_package; l : LIST OF ada_interface ) : STRING;
		LOCAL 
			found : SET OF STRING := [ ];
			with_suffix : LIST OF ada_interface := [ ];
			with_prefix_only : LIST OF ada_interface := [ ];
			cleaned : LIST OF ada_interface := [ ];
			inserted : BOOLEAN;
			s : STRING := '';
		END_LOCAL;

		REPEAT no := LOINDEX ( l ) TO HIINDEX ( l );
			ALIAS curr FOR l [ no];
				IF NOT EXISTS ( from_pkg ) OR ( upperize ( from_pkg.name ) <> upperize ( curr.prefix ) ) THEN
					IF NOT ( upperize ( curr.full_name ) IN found ) THEN
						found := found + upperize ( curr.full_name );
						cleaned := cleaned + curr;
					END_IF;
				END_IF;
			END_ALIAS;
		END_REPEAT;

		REPEAT no := LOINDEX ( cleaned ) TO HIINDEX ( cleaned );
			ALIAS curr FOR cleaned [ no];
				IF EXISTS ( curr.suffix ) THEN
					with_suffix := with_suffix + curr;
				ELSE
					with_prefix_only := with_prefix_only + curr;
				END_IF;
			END_ALIAS;
		END_REPEAT;
		cleaned := [ ];

		REPEAT no := LOINDEX ( with_prefix_only ) TO HIINDEX ( with_prefix_only );
			cleaned := cleaned + with_prefix_only [ no];
		END_REPEAT;

		REPEAT no := LOINDEX ( with_suffix ) TO HIINDEX ( with_suffix );
			ALIAS curr FOR with_suffix [ no];
				inserted := false;
				REPEAT noi := LOINDEX ( cleaned ) TO HIINDEX ( cleaned );
					ALIAS curri FOR cleaned [ noi];
						IF ( upperize ( curr.prefix ) = upperize ( curri.prefix ) ) THEN
							INSERT ( cleaned, curr, noi );
							inserted := true;
							ESCAPE;
						END_IF;
					END_ALIAS;
				END_REPEAT;
				IF ( inserted = false ) THEN
					cleaned := cleaned + curr;
				END_IF;
			END_ALIAS;
		END_REPEAT;

		REPEAT no := LOINDEX ( cleaned ) TO HIINDEX ( cleaned );
			ALIAS curr FOR cleaned [ no];
				s := s + curr.declaration + '\n';
			END_ALIAS;
		END_REPEAT;
		RETURN ( s );
	END_FUNCTION;
END_SCHEMA;

</ISO10303-11-EXPRESS>!

!ExChdAdaInterfaceSchemaDefinition class methodsFor: 'platypus-generated-platypus-signature' stamp: ''!
iso10303P11Translater
	^ 'Platypus (c) LISYC EA3883, Universite de Bretagne occidentale. Brest.'

! !

!ExChdAdaInterfaceSchemaDefinition class methodsFor: 'platypus-generated-platypus-signature' stamp: ''!
translatedFromISO10303P11
	^ true

! !

!ExChdAdaInterfaceSchemaDefinition class methodsFor: 'platypus-generated-platypus-signature' stamp: ''!
vwNamespaceName
	^ #Express2Cheddar

! !

!ExChdAdaInterfaceSchemaDefinition methodsFor: 'platypus-generated-context-accessing' stamp: ''!
context
	^ self schemaInstance context

! !

!ExChdAdaInterfaceSchemaDefinition methodsFor: 'platypus-generated-entities' stamp: ''!
entityDefinition1
	^ #(#ada_interface #ExChdAdaInterface)

! !

!ExChdAdaInterfaceSchemaDefinition methodsFor: 'platypus-generated-entities' stamp: ''!
entityDefinitionCount
	^ 1

! !

!ExChdAdaInterfaceSchemaDefinition methodsFor: 'platypus-generated-functions' stamp: ''!
functionDeclaration1
	^ #(#ada_interface_path #ExChdAdaInterfacePathFunction)

! !

!ExChdAdaInterfaceSchemaDefinition methodsFor: 'platypus-generated-functions' stamp: ''!
functionDeclaration2
	^ #(#ada_interface_declaration #ExChdAdaInterfaceDeclarationFunction)

! !

!ExChdAdaInterfaceSchemaDefinition methodsFor: 'platypus-generated-functions' stamp: ''!
functionDeclaration3
	^ #(#ada_interfaces_code #ExChdAdaInterfacesCodeFunction)

! !

!ExChdAdaInterfaceSchemaDefinition methodsFor: 'platypus-generated-functions' stamp: ''!
functionDeclarationCount
	^ 3

! !

!ExChdAdaInterfaceSchemaDefinition methodsFor: 'platypus-generated-meta-data-accessing' stamp: ''!
schemaInstanceClassName
	^ #ExChdExpress2cheddarSchemaInstance

! !

PlatypusCoreSchema subclass: #ExChdCheddarConstantsSchemaDefinition
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Express2Cheddar-CheddarConstantsSchema'!

!ExChdCheddarConstantsSchemaDefinition commentStamp: 'platypus comment' prior: 0!
<ISO10303-11-EXPRESS>
SCHEMA cheddar_constants;
	USE FROM express2cheddar_facade;
	USE FROM platypus_dictionary_schema;
	USE FROM cheddar_domains;
	USE FROM ada_interface;
	USE FROM express_dictionary_queries;
	USE FROM express_toolsbox_functions;

	ENTITY ada_constant 
		SUBTYPE OF ( constant_definition );
		final : BOOLEAN;
		other_initializer : OPTIONAL STRING;
	DERIVE
		ads_code : STRING := ada_constant_ads_code ( SELF );
		adb_code : STRING := '';
		ads_interfaces_list : LIST OF ada_interface := ada_constant_interfaces_list ( SELF, true );
		adb_interfaces_list : LIST OF ada_interface := [ ];
	END_ENTITY;

	FUNCTION do_comments_with ( src : STRING ) : STRING;
		(*#  " comments " 
		| r s |
		r := ''.
		s :=  self src val.
		s linesDo: [:l | r := r , '--', l, String cr]. 
		self return: (PltStringLiteral val: r)
     		 #*) (*# <pharo> " comments " 
		| r s |
		r := ''.
		s :=  self src.
		s linesDo: [:l | r := r , '--', l, String cr]. 
		^ self return: r  #*) END_FUNCTION;

	FUNCTION ada_constant_ads_code ( c : ada_constant ) : STRING;
		LOCAL 
			code : STRING := '';
			remarks : LIST OF remark := remarks_for ( c );
			rem : STRING;
			domain : dictionary_instance := basic_ada_domain ( c.domain );
		END_LOCAL;

		IF ( SIZEOF ( remarks ) > 0 ) THEN
			REPEAT no := LOINDEX ( remarks ) TO HIINDEX ( remarks );
				rem := clean_remark_text_of ( remarks [ no] );
				rem := do_comments_with ( rem );
				code := code + rem;
			END_REPEAT;
		END_IF;
		code := code + c.name + ' : ';

		IF c.final THEN
			code := code + 'constant ';
		END_IF;
		code := code + domain.ada_ref_ident;

		IF NOT EXISTS ( c.other_initializer ) THEN
			code := code + ' := ' + basic_ada_type_value_format ( c.initializer, ? ).formated + ';';
		ELSE
			IF c.other_initializer > '' THEN
				code := code + ' := ' + c.other_initializer;
			END_IF;
			code := code + ';';
		END_IF;
		code := code + '\n';
		RETURN ( code );
	END_FUNCTION;

	FUNCTION ada_constant_interfaces_list ( r : ada_constant; ads : BOOLEAN ) : LIST OF ada_interface;
		LOCAL 
			result : LIST OF ada_interface := [ ];
			ada_domain : entity_instance;
		END_LOCAL;
		ada_domain := basic_ada_domain ( r.domain );
		result := domain_interfaces_list ( ada_domain, ads, r.owner );
		RETURN ( result );
	END_FUNCTION;
END_SCHEMA;

</ISO10303-11-EXPRESS>!

!ExChdCheddarConstantsSchemaDefinition class methodsFor: 'platypus-generated-platypus-signature' stamp: ''!
iso10303P11Translater
	^ 'Platypus (c) LISYC EA3883, Universite de Bretagne occidentale. Brest.'

! !

!ExChdCheddarConstantsSchemaDefinition class methodsFor: 'platypus-generated-platypus-signature' stamp: ''!
translatedFromISO10303P11
	^ true

! !

!ExChdCheddarConstantsSchemaDefinition class methodsFor: 'platypus-generated-platypus-signature' stamp: ''!
vwNamespaceName
	^ #Express2Cheddar

! !

!ExChdCheddarConstantsSchemaDefinition methodsFor: 'platypus-generated-context-accessing' stamp: ''!
context
	^ self schemaInstance context

! !

!ExChdCheddarConstantsSchemaDefinition methodsFor: 'platypus-generated-entities' stamp: ''!
entityDefinition1
	^ #(#ada_constant #ExChdAdaConstant)

! !

!ExChdCheddarConstantsSchemaDefinition methodsFor: 'platypus-generated-entities' stamp: ''!
entityDefinitionCount
	^ 1

! !

!ExChdCheddarConstantsSchemaDefinition methodsFor: 'platypus-generated-functions' stamp: ''!
functionDeclaration1
	^ #(#do_comments_with #ExChdDoCommentsWithFunction)

! !

!ExChdCheddarConstantsSchemaDefinition methodsFor: 'platypus-generated-functions' stamp: ''!
functionDeclaration2
	^ #(#ada_constant_ads_code #ExChdAdaConstantAdsCodeFunction)

! !

!ExChdCheddarConstantsSchemaDefinition methodsFor: 'platypus-generated-functions' stamp: ''!
functionDeclaration3
	^ #(#ada_constant_interfaces_list #ExChdAdaConstantInterfacesListFunction)

! !

!ExChdCheddarConstantsSchemaDefinition methodsFor: 'platypus-generated-functions' stamp: ''!
functionDeclarationCount
	^ 3

! !

!ExChdCheddarConstantsSchemaDefinition methodsFor: 'platypus-generated-meta-data-accessing' stamp: ''!
schemaInstanceClassName
	^ #ExChdExpress2cheddarSchemaInstance

! !

PlatypusCoreSchema subclass: #ExChdCheddarDomainsSchemaDefinition
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Express2Cheddar-CheddarDomainsSchema'!

!ExChdCheddarDomainsSchemaDefinition commentStamp: 'platypus comment' prior: 0!
<ISO10303-11-EXPRESS>
SCHEMA cheddar_domains;
	USE FROM express2cheddar_facade;
	USE FROM ada_interface;
	USE FROM platypus_dictionary_schema;
	USE FROM platypus_expressions_schema;
	USE FROM express_toolsbox_functions;
	USE FROM express_dictionary_queries;

	CONSTANT 
		std_io_interfaces : LIST OF ada_interface := [ ada_interface ( 'standards_io', ?, true, true ) ];
	END_CONSTANT;

	ENTITY pragma_convention;
		convention : STRING;
	END_ENTITY;

	ENTITY ada_type 
		SUBTYPE OF ( defined_type );
	DERIVE
		ada_ident : STRING := name;
		ada_ref_ident : STRING := name;
		init_value : STRING := ?;
		dependencies : LIST OF dictionary_instance := dependencies_of ( SELF.owner, SELF.domain.handled );
		refed_by_pointer : BOOLEAN := false;
	END_ENTITY;

	ENTITY cheddar_defined_type 
		SUBTYPE OF ( ada_type );
	DERIVE
		ads_interface_list : LIST OF ada_interface := cheddar_defined_type_interfaces_list ( SELF, true );
		adb_interface_list : LIST OF ada_interface := cheddar_defined_type_interfaces_list ( SELF, false );
		SELF\defined_type.accepted : entity_instance := SELF.accept_cheddar_defined_type;
	END_ENTITY;

	ENTITY constrained_array_type 
		SUBTYPE OF ( cheddar_defined_type );
		min_idx : STRING;
		max_idx : OPTIONAL STRING;
		interfaces : LIST OF ada_interface;
	DERIVE
		adb_interfaces_list : LIST OF ada_interface := [ ];
		ads_interfaces_list : LIST OF ada_interface := interfaces;
		adb_code : STRING := '';
		ads_code : STRING := constrained_array_type_ads_code ( SELF );
	END_ENTITY;

	ENTITY cheddar_entity_definition 
		SUBTYPE OF ( entity_definition );
	DERIVE
		ads_interfaces_list : LIST OF ada_interface := [ ];
		adb_interfaces_list : LIST OF ada_interface := [ ];
		ada_ident : STRING := SELF.name;
		ada_ref_ident : STRING := SELF.name;
		init_value : STRING := ?;
		ads_code : STRING := '';
		adb_code : STRING := '';
	END_ENTITY;

	ENTITY unmapped_type_reference;
		ref : entity_instance;
	DERIVE
		ads_interfaces_list : LIST OF ada_interface := basic_ada_domain ( SELF.ref ).ads_interfaces_list;
		adb_interfaces_list : LIST OF ada_interface := basic_ada_domain ( SELF.ref ).adb_interfaces_list;
		ada_ident : STRING := SELF.name;
		ada_ref_ident : STRING := SELF.name;
		init_value : STRING := basic_ada_domain ( SELF.ref ).init_value;
		ads_code : STRING := '';
		adb_code : STRING := '';
		refed_by_pointer : BOOLEAN := false;
	END_ENTITY;

	ENTITY unmapped_entity_definition;
	DERIVE
		ads_interfaces_list : LIST OF ada_interface := [ ];
		adb_interfaces_list : LIST OF ada_interface := [ ];
		ada_ident : STRING := SELF.name;
		ada_ref_ident : STRING := SELF.name;
		init_value : STRING := ?;
		ads_code : STRING := '';
		adb_code : STRING := '';
	END_ENTITY;

	ENTITY basic_ada_type_getter;
	DERIVE
		accept_string_type : dictionary_instance := ( ada_unbounded_string_type ( ) || ada_primitive_type ( ) || dictionary_instance ( ) );
		accept_integer_type : dictionary_instance := ( ada_natural_type ( ) || ada_primitive_type ( ) || dictionary_instance ( ) );
		accept_real_type : dictionary_instance := ( ada_double_type ( ) || ada_primitive_type ( ) || dictionary_instance ( ) );
		accept_boolean_type : dictionary_instance := ( ada_boolean_type ( ) || ada_primitive_type ( ) || dictionary_instance ( ) );
		accept_enumeration_type : dictionary_instance := SELF\enumeration_type;
		accept_ada_enumeration : dictionary_instance := SELF;
		accept_attribute_reference : dictionary_instance := ( ada_attribute_reference ( ) || ada_named_type_reference ( ) || SELF\attribute_reference );
		accept_defined_type_reference : dictionary_instance := basic_ada_domain ( SELF\defined_type_reference.ref );
		accept_defined_type : dictionary_instance := unmapped_type_reference ( SELF.domain ) || SELF;
		accept_ada_range : dictionary_instance := SELF;
		accept_ada_class_reference : dictionary_instance := SELF;
		accept_ada_record_reference : dictionary_instance := SELF;
		accept_entity_definition_reference : dictionary_instance := ( unmapped_type_reference ( SELF.ref ) || SELF\entity_definition_reference );
		accept_entity_definition : dictionary_instance := ( unmapped_entity_definition ( ) || SELF\entity_definition );
		accept_cheddar_defined_type : dictionary_instance := SELF;
		accept_list_type : dictionary_instance := ( ada_list_type ( ) || SELF\list_type );
		accept_array_type : dictionary_instance := ( ada_array_type ( ) || SELF\array_type );
		accept_set_type : dictionary_instance := ( ada_set_type ( ) || SELF\set_type );
		accept_bag_type : dictionary_instance := ( ada_bag_type ( ) || SELF\bag_type );
		accept_explicit_type_reference : dictionary_instance := SELF;
	END_ENTITY;

	ENTITY ada_primitive_type 
		SUBTYPE OF ( entity_definition );
	DERIVE
		ads_interfaces_list : LIST OF ada_interface := [ ];
		adb_interfaces_list : LIST OF ada_interface := [ ];
		ads_code : STRING := '';
		adb_code : STRING := '';
		put_prefix : STRING := '';
		refed_by_pointer : BOOLEAN := false;
	END_ENTITY;

	ENTITY cheddar_primitive_type 
		SUBTYPE OF ( ada_primitive_type );
	END_ENTITY;

	ENTITY cheddar_law_type 
		SUBTYPE OF ( cheddar_primitive_type );
	DERIVE
		SELF\ada_primitive_type.ads_interfaces_list : LIST OF ada_interface := [ ada_interface ( 'Expression', ?, true, true ), ada_interface ( 'Expression', ?, false, true ) ];
		SELF\ada_primitive_type.adb_interfaces_list : LIST OF ada_interface := [ ];
		ada_ident : STRING := 'law_type';
		ada_ref_ident : STRING := SELF.ada_ident;
		init_value : STRING := ?;
	END_ENTITY;

	ENTITY cheddar_priority_range 
		SUBTYPE OF ( cheddar_defined_type );
	DERIVE
		ads_code : STRING := '
-- Definition of priority range. We choose the most current value :
-- 256 priority levels (from 0 to 255)
-- Zero is the lowest priority level
Type Priority_Range is new Natural range 0 .. 255;
package Priority_Io is new Text_IO.Integer_IO (Priority_Range);
use Priority_Io;
';
		adb_code : STRING := '';
		ads_interfaces_list : LIST OF ada_interface := [ ada_interface ( 'Framework_Config', ?, true, true ), ada_interface ( 'Framework_Config', 'Priority_Io', false, true ) ];
		adb_interfaces_list : LIST OF ada_interface := [ ];
		SELF\ada_type.ada_ident : STRING := 'Priority_Range';
		SELF\ada_type.ada_ref_ident : STRING := SELF.ada_ident;
		SELF\ada_type.init_value : STRING := '0';
	END_ENTITY;

	ENTITY ada_natural_type 
		SUBTYPE OF ( ada_primitive_type );
	DERIVE
		SELF\ada_primitive_type.ads_interfaces_list : LIST OF ada_interface := std_io_interfaces + [ ada_interface ( 'standards_io', 'natural_io', false, true ) ];
		SELF\ada_primitive_type.adb_interfaces_list : LIST OF ada_interface := [ ada_interface ( 'primitive_xml_strings', ?, true, true ) ];
		ada_ident : STRING := 'Natural';
		ada_ref_ident : STRING := SELF.ada_ident;
		init_value : STRING := '0';
		SELF\ada_primitive_type.put_prefix : STRING := 'standards_io.natural_io.';
	END_ENTITY;

	ENTITY ada_unbounded_string_type 
		SUBTYPE OF ( ada_primitive_type );
	DERIVE
		SELF\ada_primitive_type.ads_interfaces_list : LIST OF ada_interface := [ ada_interface ( 'ada.strings', 'unbounded.text_io', true, true ), ada_interface ( 'Text_io', ?, true, true ), ada_interface ( 'Unbounded_Strings', ?, true, true ), ada_interface ( 'Convert_Strings', ?, true, false ), ada_interface ( 'Convert_Unbounded_Strings', ?, true, false ) ];
		SELF\ada_primitive_type.adb_interfaces_list : LIST OF ada_interface := [ ada_interface ( 'Text_io', ?, true, true ), ada_interface ( 'primitive_xml_strings', ?, true, true ) ];
		ada_ident : STRING := 'Unbounded_String';
		ada_ref_ident : STRING := SELF.ada_ident;
		init_value : STRING := 'empty_string';
	END_ENTITY;

	ENTITY cheddar_xml_id_type 
		SUBTYPE OF ( string_type );
	DERIVE
		SELF\ada_unbounded_string_type.ads_interfaces_list : LIST OF ada_interface := [ ada_interface ( 'ada.strings', 'unbounded.text_io', true, true ), ada_interface ( 'Text_io', ?, true, true ), ada_interface ( 'Unbounded_Strings', ?, true, true ), ada_interface ( 'Convert_Strings', ?, true, false ), ada_interface ( 'Convert_Unbounded_Strings', ?, true, false ), ada_interface ( 'id_generators', ?, true, true ) ];
		adb_interfaces_list : LIST OF ada_interface := [ ada_interface ( 'call_framework', ?, true, true ), ada_interface ( 'id_generators', ?, true, true ) ];
		ads_code : STRING := '';
		adb_code : STRING := '';
		put_prefix : STRING := '';
		refed_by_pointer : BOOLEAN := false;
		SELF\ada_unbounded_string_type.init_value : STRING := 'generate_id';
	END_ENTITY;

	ENTITY ada_boolean_type 
		SUBTYPE OF ( ada_primitive_type );
	DERIVE
		SELF\ada_primitive_type.ads_interfaces_list : LIST OF ada_interface := std_io_interfaces + [ ada_interface ( 'standards_io', 'boolean_io', false, true ) ];
		SELF\ada_primitive_type.adb_interfaces_list : LIST OF ada_interface := [ ada_interface ( 'primitive_xml_strings', ?, true, true ) ];
		ada_ident : STRING := 'Boolean';
		ada_ref_ident : STRING := SELF.ada_ident;
		init_value : STRING := 'false';
		SELF\ada_primitive_type.put_prefix : STRING := 'standards_io.boolean_io.';
	END_ENTITY;

	ENTITY ada_real_type 
		SUBTYPE OF ( ada_primitive_type );
	DERIVE
		SELF\ada_primitive_type.ads_interfaces_list : LIST OF ada_interface := std_io_interfaces + [ ada_interface ( 'Ada', 'Numerics.Aux', true, true ), ada_interface ( 'standards_io', 'float_io', false, true ) ];
		SELF\ada_primitive_type.adb_interfaces_list : LIST OF ada_interface := [ ada_interface ( 'primitive_xml_strings', ?, true, true ) ];
		ada_ident : STRING := 'Float';
		ada_ref_ident : STRING := SELF.ada_ident;
		init_value : STRING := '0.0';
		SELF\ada_primitive_type.put_prefix : STRING := 'standards_io.float_io.';
	END_ENTITY;

	ENTITY ada_double_type 
		SUBTYPE OF ( ada_primitive_type );
	DERIVE
		SELF\ada_primitive_type.ads_interfaces_list : LIST OF ada_interface := std_io_interfaces + [ ada_interface ( 'Ada', 'Numerics.Aux', true, true ), ada_interface ( 'standards_io', 'double_io', false, true ) ];
		SELF\ada_primitive_type.adb_interfaces_list : LIST OF ada_interface := [ ada_interface ( 'primitive_xml_strings', ?, true, true ) ];
		ada_ident : STRING := 'Double';
		ada_ref_ident : STRING := SELF.ada_ident;
		init_value : STRING := '0.0';
		SELF\ada_primitive_type.put_prefix : STRING := 'standards_io.double_io.';
	END_ENTITY;

	ENTITY ada_integer_type 
		SUBTYPE OF ( ada_primitive_type );
	DERIVE
		SELF\ada_primitive_type.ads_interfaces_list : LIST OF ada_interface := std_io_interfaces + [ ada_interface ( 'standards_io', 'integer_io', false, true ) ];
		SELF\ada_primitive_type.adb_interfaces_list : LIST OF ada_interface := [ ada_interface ( 'primitive_xml_strings', ?, true, true ) ];
		ada_ident : STRING := 'Integer';
		ada_ref_ident : STRING := SELF.ada_ident;
		init_value : STRING := '0';
		SELF\ada_primitive_type.put_prefix : STRING := 'standards_io.integer_io.';
	END_ENTITY;

	ENTITY ada_named_type_reference 
		SUBTYPE OF ( entity_instance );
	DERIVE
		ads_interfaces_list : LIST OF ada_interface := [ ];
		adb_interfaces_list : LIST OF ada_interface := [ ];
		ada_ident : STRING := SELF.ref.name;
		ada_ref_ident : STRING := SELF.ada_ident;
	END_ENTITY;

	ENTITY ada_record_reference 
		SUBTYPE OF ( ada_named_type_reference );
	DERIVE
		SELF\entity_definition_reference.accepted : entity_instance := SELF.accept_ada_record_reference;
	END_ENTITY;

	ENTITY ada_class_reference 
		SUBTYPE OF ( ada_named_type_reference );
	DERIVE
		SELF\entity_definition_reference.accepted : entity_instance := SELF.accept_ada_class_reference;
		SELF\ada_named_type_reference.ads_interfaces_list : LIST OF ada_interface := [ ada_interface ( SELF.ref.owner.name, ?, true, true ) ];
		SELF\ada_named_type_reference.ada_ident : STRING := SELF.ref.name + '_Ptr';
		init_value : STRING := 'initialize';
	END_ENTITY;

	ENTITY ada_primitive_class_reference 
		SUBTYPE OF ( ada_class_reference );
		pointed_type_name : STRING;
		package_name : STRING;
	DERIVE
		SELF\ada_class_reference.ads_interfaces_list : LIST OF ada_interface := [ ada_interface ( package_name, ?, true, true ) ];
		SELF\ada_class_reference.ada_ident : STRING := pointed_type_name + '_Ptr';
	END_ENTITY;

	ENTITY ada_attribute_reference 
		SUBTYPE OF ( ada_named_type_reference );
	END_ENTITY;

	ENTITY ada_array_type 
		SUBTYPE OF ( array_type );
	DERIVE
		ads_interfaces_list : LIST OF ada_interface := std_io_interfaces;
		adb_interfaces_list : LIST OF ada_interface := [ ];
		ada_ident : STRING := ?;
		ada_ref_ident : STRING := SELF.ada_ident;
		init_value : STRING := ?;
	END_ENTITY;

	ENTITY ada_list_type 
		SUBTYPE OF ( list_type );
	DERIVE
		ads_interfaces_list : LIST OF ada_interface := std_io_interfaces;
		adb_interfaces_list : LIST OF ada_interface := [ ];
		ada_ident : STRING := 'list';
		ada_ref_ident : STRING := SELF.ada_ident;
		init_value : STRING := ?;
	END_ENTITY;

	ENTITY ada_set_type 
		SUBTYPE OF ( set_type );
	DERIVE
		ads_interfaces_list : LIST OF ada_interface := std_io_interfaces;
		adb_interfaces_list : LIST OF ada_interface := [ ];
		ada_ident : STRING := 'set';
		ada_ref_ident : STRING := SELF.ada_ident;
	END_ENTITY;

	ENTITY ada_bag_type 
		SUBTYPE OF ( bag_type );
	DERIVE
		ads_interfaces_list : LIST OF ada_interface := std_io_interfaces;
		adb_interfaces_list : LIST OF ada_interface := [ ];
		ada_ident : STRING := 'bag';
		ada_ref_ident : STRING := SELF.ada_ident;
	END_ENTITY;

	ENTITY ada_enumeration 
		SUBTYPE OF ( ada_type );
		convertion : OPTIONAL STRING;
	DERIVE
		ads_interfaces_list : LIST OF ada_interface := [ ada_interface ( 'Convert_Strings', ?, true, false ), ada_interface ( 'Convert_Unbounded_Strings', ?, true, false ), ada_interface ( 'text_io', ?, true, true ), ada_interface ( 'ada.strings', 'unbounded', true, true ) ];
		adb_interfaces_list : LIST OF ada_interface := [ ada_interface ( 'primitive_xml_strings', ?, true, true ) ];
		ads_code : STRING := enumeration_ads_code ( SELF );
		adb_code : STRING := enumeration_adb_code ( SELF );
		SELF\ada_type.ada_ident : STRING := name;
		SELF\ada_type.ada_ref_ident : STRING := SELF.ada_ident;
		SELF\ada_type.init_value : STRING := NVL ( convertion, domain.elements [ 1 ] );
		io_type_name : STRING := SELF.ada_ident + '_io';
		full_io_type_name : STRING := SELF.owner.name + '.' + SELF.io_type_name;
		SELF\defined_type.accepted : entity_instance := SELF.accept_ada_enumeration;
	END_ENTITY;

	ENTITY basic_ada_type_value_format 
		SUBTYPE OF ( dictionary_instance );
		val : expression;
		basic_ada_type : OPTIONAL dictionary_instance;
	DERIVE
		formated : STRING := basic_ada_expression_value_string ( SELF.val );
	END_ENTITY;

	ENTITY range_type 
		SUBTYPE OF ( defined_type );
		lower : STRING;
		upper : STRING;
		lower_constant : OPTIONAL STRING;
		upper_constant : OPTIONAL STRING;
	DERIVE
		ads_interfaces_list : LIST OF ada_interface := [ ];
		adb_interfaces_list : LIST OF ada_interface := [ ];
		ada_ident : STRING := name;
		ada_ref_ident : STRING := SELF.ada_ident;
		ads_code : STRING := range_type_ads_code ( SELF );
		adb_code : STRING := '';
	END_ENTITY;

	ENTITY explicit_type_reference 
		SUBTYPE OF ( defined_type );
		used_name : OPTIONAL STRING;
		interfaces : LIST OF ada_interface;
	DERIVE
		SELF\defined_type.accepted : entity_instance := SELF.accept_explicit_type_reference;
		ads_interfaces_list : LIST OF ada_interface := SELF.interfaces;
		adb_interfaces_list : LIST OF ada_interface := [ ada_interface ( SELF.owner.name, ?, true, true ) ] + interfaces;
		ada_ident : STRING := SELF.name;
		ptr_type : STRING := SELF.ada_ident + '_Ptr';
		ada_ref_ident : STRING := NVL ( SELF.used_name, SELF.name );
		init_value : STRING := ?;
		ads_code : STRING := '';
		adb_code : STRING := '';
		refed_by_pointer : BOOLEAN := string_ends_with ( SELF.ada_ref_ident, '_Ptr' );
	END_ENTITY;

	ENTITY in_scope_attribute;
	DERIVE
		init_code : STRING := in_scope_attribute_init_code ( SELF );
	END_ENTITY;

	FUNCTION dependencies_of ( o : context_definition; t : dictionary_instance ) : LIST OF dictionary_instance;
		LOCAL 
			r : LIST OF dictionary_instance := [ ];
		END_LOCAL;

		IF ( 'PLATYPUS_DICTIONARY_SCHEMA.AGGREGATION_TYPE' IN TYPEOF ( t ) ) THEN
			r := r + dependencies_of ( o, t.element_type.handled );
		ELSE
			IF is_of_generated_concept_kind ( t ) THEN
				IF ( t.owner = o ) THEN
					r := r + t.dependencies + t;
				END_IF;
			END_IF;
		END_IF;
		RETURN ( r );
	END_FUNCTION;

	FUNCTION constrained_array_type_ads_code ( a : constrained_array_type ) : STRING;
		LOCAL 
			code : STRING := '';
		END_LOCAL;
		code := 'type ' + a.ada_ident + ' is Array ( ';

		IF EXISTS ( a.max_idx ) THEN
			code := code + a.min_idx + ' .. ' + a.max_idx;
		ELSE
			code := code + a.min_idx;
		END_IF;

		ALIAS etype FOR a.domain.element_type.handled;
			IF ( 'RECORD_AND_CLASS.ADA_CLASS' IN TYPEOF ( etype ) ) THEN
				code := code + ' ) of ' + etype.ptr_type + ';\n';
			ELSE
				code := code + ' ) of ' + etype.ada_ident + ';\n';
			END_IF;
		END_ALIAS;
		RETURN ( code );
	END_FUNCTION;

	FUNCTION cheddar_defined_type_interfaces_list ( r : cheddar_defined_type; ads : BOOLEAN ) : LIST OF ada_interface;
		LOCAL 
			result : LIST OF ada_interface := [ ];
		END_LOCAL;

		IF ads THEN
			result := result + ada_interface ( r.owner.name, ?, true, true );
		END_IF;
		RETURN ( result );
	END_FUNCTION;

	FUNCTION basic_ada_domain ( d : dictionary_instance ) : entity_instance;
		RETURN ( ( d || basic_ada_type_getter ( ) ).accepted );
	END_FUNCTION;

	FUNCTION enumeration_ads_code ( e : ada_enumeration ) : STRING;
		LOCAL 
			code : STRING;
			convert_type : STRING := NVL ( e.convertion, e.domain.elements [ LOINDEX ( e.domain.elements ) ] );
		END_LOCAL;
		code := 'type ' + e.name + ' is (\n\t' + StringAggregateConcatSeparatedBy ( e.domain.elements, ',\n\t' ) + ');\n';

		IF ( 'CHEDDAR_DOMAINS.PRAGMA_CONVENTION' IN TYPEOF ( e ) ) THEN
			code := code + 'pragma convention (' + e.convention + ', ' + e.name + ');\n';
		END_IF;
		code := code + '\n' 
		+ 'procedure To_' + e.name + ' is\n' 
		+ 'new Convert_Strings(' + e.name + ', ' + convert_type + ');\n' 
		+ 'procedure To_' + e.name + ' is\n' 
		+ 'new Convert_Unbounded_Strings(' + e.name + ', ' + convert_type + ');\n' 
		+ 'function XML_String (obj : in ' + e.name + ') return Unbounded_String;\n' 
		+ 'function XML_Ref_String (obj : in ' + e.name + ') return Unbounded_String;\n' 
		+ 'package ' + e.name + '_io is new text_io.enumeration_io(' + e.name + ');\n' 
		+ 'use ' + e.name + '_io;\n\n';
		RETURN ( code );
	END_FUNCTION;

	FUNCTION basic_ada_expression_value_string ( e : expression ) : STRING;
		LOCAL 
			code : STRING := '';
		END_LOCAL;

		IF ( 'PLATYPUS_EXPRESSIONS_SCHEMA.IDENTIFIER' IN TYPEOF ( e ) ) THEN
			RETURN ( e.name );
		END_IF;

		IF ( 'PLATYPUS_EXPRESSIONS_SCHEMA.INTEGER_LITERAL' IN TYPEOF ( e ) ) THEN
			RETURN ( FORMAT ( e.val, 'I' ) );
		END_IF;

		IF ( 'PLATYPUS_EXPRESSIONS_SCHEMA.TRUE_CONSTANT' IN TYPEOF ( e ) ) THEN
			RETURN ( 'True' );
		END_IF;

		IF ( 'PLATYPUS_EXPRESSIONS_SCHEMA.FALSE_CONSTANT' IN TYPEOF ( e ) ) THEN
			RETURN ( 'False' );
		END_IF;

		IF ( 'PLATYPUS_EXPRESSIONS_SCHEMA.BINARY_EXPRESSION' IN TYPEOF ( e ) ) THEN
			RETURN ( '(' + basic_ada_expression_value_string ( e.left_expr ) + ' ' + e.op_string + ' ' + basic_ada_expression_value_string ( e.right_expr ) + ')' );
		END_IF;
		RETURN ( 'null' );
	END_FUNCTION;

	FUNCTION enumeration_adb_code ( e : ada_enumeration ) : STRING;
		LOCAL 
			code : STRING;
		END_LOCAL;
		code := 'function XML_String(obj : in ' + e.name + ') return Unbounded_String is\n' 
		+ 'begin\n' 
		+ '	return to_unbounded_string(' + e.name + '''image (obj) );\n' 
		+ 'end XML_String;\n\n' 

		+ 'function XML_Ref_String (obj : in ' + e.name + ') return Unbounded_String is\n' 
		+ 'begin\n' 
		+ '\traise xml_ref_string_error;\n' 
		+ '\treturn to_unbounded_string("");\n' 
		+ 'end XML_Ref_String;\n\n';
		RETURN ( code );
	END_FUNCTION;

	FUNCTION range_type_ads_code ( rt : range_type ) : STRING;
		LOCAL 
			r : STRING := 'type ' + rt.ada_ident + ' is Range ' + rt.lower + ' .. ' + rt.upper + ';\n';
		END_LOCAL;

		IF EXISTS ( rt.lower_constant ) THEN
			r := r + rt.lower_constant + ' : constant ' + rt.ada_ident + ' := ' + rt.ada_ident + '''First;\n';
		END_IF;

		IF EXISTS ( rt.upper_constant ) THEN
			r := r + rt.upper_constant + ' : constant ' + rt.ada_ident + ' := ' + rt.ada_ident + '''Last;\n';
		END_IF;
		RETURN ( r );
	END_FUNCTION;

	FUNCTION in_scope_attribute_init_code ( a : in_scope_attribute ) : STRING;
		LOCAL 
			code : STRING := '';
		END_LOCAL;

		ALIAS domain FOR a.domain.handled;
			IF domain.refed_by_pointer THEN
				code := code + '\n\tif obj.' + a.name + ' /= null then\n' 
				+ '\t\tFree (obj.' + a.name + ' );\n' 
				+ '\tend if;\n' 
				+ '\tobj.' + a.name + ' := new ' + domain.name + ';\n' 
				+ '\tInitialize(obj.' + a.name + '.all);\n';
			END_IF;
		END_ALIAS;
		RETURN ( code );
	END_FUNCTION;

	FUNCTION domain_interfaces_list ( ada_domain : entity_instance; ads : BOOLEAN; pkg : schema_definition ) : LIST OF ada_interface;
		LOCAL 
			result : LIST OF ada_interface := [ ];
		END_LOCAL;

		ALIAS h FOR ada_domain.handled;
			IF ads THEN
				result := result + ada_domain.ads_interfaces_list;
			ELSE
				result := result + ada_domain.adb_interfaces_list;
				IF ( 'CHEDDAR_DOMAINS.ADA_ENUMERATION' IN TYPEOF ( h ) ) THEN
					IF ( h.owner.name <> pkg.name ) THEN
						result := result + ada_interface ( h.owner.name, ?, true, false );
						result := result + ada_interface ( h.full_io_type_name, ?, false, true );
					END_IF;
				END_IF;
			END_IF;
			IF ( 'CHEDDAR_DOMAINS.ADA_PRIMITIVE_TYPE' IN TYPEOF ( h ) ) OR ( 'DISCRIMINATED_TYPE.DISCRIMINATED_TYPE' IN TYPEOF ( h ) ) THEN
				IF ads THEN
					result := result + h.ads_interfaces_list;
				ELSE
					result := result + h.adb_interfaces_list;
				END_IF;
			END_IF;
		END_ALIAS;
		RETURN ( result );
	END_FUNCTION;
END_SCHEMA;

</ISO10303-11-EXPRESS>!

!ExChdCheddarDomainsSchemaDefinition class methodsFor: 'platypus-generated-platypus-signature' stamp: ''!
iso10303P11Translater
	^ 'Platypus (c) LISYC EA3883, Universite de Bretagne occidentale. Brest.'

! !

!ExChdCheddarDomainsSchemaDefinition class methodsFor: 'platypus-generated-platypus-signature' stamp: ''!
translatedFromISO10303P11
	^ true

! !

!ExChdCheddarDomainsSchemaDefinition class methodsFor: 'platypus-generated-platypus-signature' stamp: ''!
vwNamespaceName
	^ #Express2Cheddar

! !

!ExChdCheddarDomainsSchemaDefinition methodsFor: 'platypus-generated-context-accessing' stamp: ''!
context
	^ self schemaInstance context

! !

!ExChdCheddarDomainsSchemaDefinition methodsFor: 'platypus-generated-entities' stamp: ''!
entityDefinition1
	^ #(#pragma_convention #ExChdPragmaConvention)

! !

!ExChdCheddarDomainsSchemaDefinition methodsFor: 'platypus-generated-entities' stamp: ''!
entityDefinition10
	^ #(#cheddar_primitive_type #ExChdCheddarPrimitiveType)

! !

!ExChdCheddarDomainsSchemaDefinition methodsFor: 'platypus-generated-entities' stamp: ''!
entityDefinition11
	^ #(#cheddar_law_type #ExChdCheddarLawType)

! !

!ExChdCheddarDomainsSchemaDefinition methodsFor: 'platypus-generated-entities' stamp: ''!
entityDefinition12
	^ #(#cheddar_priority_range #ExChdCheddarPriorityRange)

! !

!ExChdCheddarDomainsSchemaDefinition methodsFor: 'platypus-generated-entities' stamp: ''!
entityDefinition13
	^ #(#ada_natural_type #ExChdAdaNaturalType)

! !

!ExChdCheddarDomainsSchemaDefinition methodsFor: 'platypus-generated-entities' stamp: ''!
entityDefinition14
	^ #(#ada_unbounded_string_type #ExChdAdaUnboundedStringType)

! !

!ExChdCheddarDomainsSchemaDefinition methodsFor: 'platypus-generated-entities' stamp: ''!
entityDefinition15
	^ #(#cheddar_xml_id_type #ExChdCheddarXmlIdType)

! !

!ExChdCheddarDomainsSchemaDefinition methodsFor: 'platypus-generated-entities' stamp: ''!
entityDefinition16
	^ #(#ada_boolean_type #ExChdAdaBooleanType)

! !

!ExChdCheddarDomainsSchemaDefinition methodsFor: 'platypus-generated-entities' stamp: ''!
entityDefinition17
	^ #(#ada_real_type #ExChdAdaRealType)

! !

!ExChdCheddarDomainsSchemaDefinition methodsFor: 'platypus-generated-entities' stamp: ''!
entityDefinition18
	^ #(#ada_double_type #ExChdAdaDoubleType)

! !

!ExChdCheddarDomainsSchemaDefinition methodsFor: 'platypus-generated-entities' stamp: ''!
entityDefinition19
	^ #(#ada_integer_type #ExChdAdaIntegerType)

! !

!ExChdCheddarDomainsSchemaDefinition methodsFor: 'platypus-generated-entities' stamp: ''!
entityDefinition2
	^ #(#ada_type #ExChdAdaType)

! !

!ExChdCheddarDomainsSchemaDefinition methodsFor: 'platypus-generated-entities' stamp: ''!
entityDefinition20
	^ #(#ada_named_type_reference #ExChdAdaNamedTypeReference)

! !

!ExChdCheddarDomainsSchemaDefinition methodsFor: 'platypus-generated-entities' stamp: ''!
entityDefinition21
	^ #(#ada_record_reference #ExChdAdaRecordReference)

! !

!ExChdCheddarDomainsSchemaDefinition methodsFor: 'platypus-generated-entities' stamp: ''!
entityDefinition22
	^ #(#ada_class_reference #ExChdAdaClassReference)

! !

!ExChdCheddarDomainsSchemaDefinition methodsFor: 'platypus-generated-entities' stamp: ''!
entityDefinition23
	^ #(#ada_primitive_class_reference #ExChdAdaPrimitiveClassReference)

! !

!ExChdCheddarDomainsSchemaDefinition methodsFor: 'platypus-generated-entities' stamp: ''!
entityDefinition24
	^ #(#ada_attribute_reference #ExChdAdaAttributeReference)

! !

!ExChdCheddarDomainsSchemaDefinition methodsFor: 'platypus-generated-entities' stamp: ''!
entityDefinition25
	^ #(#ada_array_type #ExChdAdaArrayType)

! !

!ExChdCheddarDomainsSchemaDefinition methodsFor: 'platypus-generated-entities' stamp: ''!
entityDefinition26
	^ #(#ada_list_type #ExChdAdaListType)

! !

!ExChdCheddarDomainsSchemaDefinition methodsFor: 'platypus-generated-entities' stamp: ''!
entityDefinition27
	^ #(#ada_set_type #ExChdAdaSetType)

! !

!ExChdCheddarDomainsSchemaDefinition methodsFor: 'platypus-generated-entities' stamp: ''!
entityDefinition28
	^ #(#ada_bag_type #ExChdAdaBagType)

! !

!ExChdCheddarDomainsSchemaDefinition methodsFor: 'platypus-generated-entities' stamp: ''!
entityDefinition29
	^ #(#ada_enumeration #ExChdAdaEnumeration)

! !

!ExChdCheddarDomainsSchemaDefinition methodsFor: 'platypus-generated-entities' stamp: ''!
entityDefinition3
	^ #(#cheddar_defined_type #ExChdCheddarDefinedType)

! !

!ExChdCheddarDomainsSchemaDefinition methodsFor: 'platypus-generated-entities' stamp: ''!
entityDefinition30
	^ #(#basic_ada_type_value_format #ExChdBasicAdaTypeValueFormat)

! !

!ExChdCheddarDomainsSchemaDefinition methodsFor: 'platypus-generated-entities' stamp: ''!
entityDefinition31
	^ #(#range_type #ExChdRangeType)

! !

!ExChdCheddarDomainsSchemaDefinition methodsFor: 'platypus-generated-entities' stamp: ''!
entityDefinition32
	^ #(#explicit_type_reference #ExChdExplicitTypeReference)

! !

!ExChdCheddarDomainsSchemaDefinition methodsFor: 'platypus-generated-entities' stamp: ''!
entityDefinition33
	^ #(#in_scope_attribute #ExChdInScopeAttribute)

! !

!ExChdCheddarDomainsSchemaDefinition methodsFor: 'platypus-generated-entities' stamp: ''!
entityDefinition4
	^ #(#constrained_array_type #ExChdConstrainedArrayType)

! !

!ExChdCheddarDomainsSchemaDefinition methodsFor: 'platypus-generated-entities' stamp: ''!
entityDefinition5
	^ #(#cheddar_entity_definition #ExChdCheddarEntityDefinition)

! !

!ExChdCheddarDomainsSchemaDefinition methodsFor: 'platypus-generated-entities' stamp: ''!
entityDefinition6
	^ #(#unmapped_type_reference #ExChdUnmappedTypeReference)

! !

!ExChdCheddarDomainsSchemaDefinition methodsFor: 'platypus-generated-entities' stamp: ''!
entityDefinition7
	^ #(#unmapped_entity_definition #ExChdUnmappedEntityDefinition)

! !

!ExChdCheddarDomainsSchemaDefinition methodsFor: 'platypus-generated-entities' stamp: ''!
entityDefinition8
	^ #(#basic_ada_type_getter #ExChdBasicAdaTypeGetter)

! !

!ExChdCheddarDomainsSchemaDefinition methodsFor: 'platypus-generated-entities' stamp: ''!
entityDefinition9
	^ #(#ada_primitive_type #ExChdAdaPrimitiveType)

! !

!ExChdCheddarDomainsSchemaDefinition methodsFor: 'platypus-generated-entities' stamp: ''!
entityDefinitionCount
	^ 33

! !

!ExChdCheddarDomainsSchemaDefinition methodsFor: 'platypus-generated-functions' stamp: ''!
functionDeclaration1
	^ #(#dependencies_of #ExChdDependenciesOfFunction)

! !

!ExChdCheddarDomainsSchemaDefinition methodsFor: 'platypus-generated-functions' stamp: ''!
functionDeclaration10
	^ #(#domain_interfaces_list #ExChdDomainInterfacesListFunction)

! !

!ExChdCheddarDomainsSchemaDefinition methodsFor: 'platypus-generated-functions' stamp: ''!
functionDeclaration2
	^ #(#constrained_array_type_ads_code #ExChdConstrainedArrayTypeAdsCodeFunction)

! !

!ExChdCheddarDomainsSchemaDefinition methodsFor: 'platypus-generated-functions' stamp: ''!
functionDeclaration3
	^ #(#cheddar_defined_type_interfaces_list #ExChdCheddarDefinedTypeInterfacesListFunction)

! !

!ExChdCheddarDomainsSchemaDefinition methodsFor: 'platypus-generated-functions' stamp: ''!
functionDeclaration4
	^ #(#basic_ada_domain #ExChdBasicAdaDomainFunction)

! !

!ExChdCheddarDomainsSchemaDefinition methodsFor: 'platypus-generated-functions' stamp: ''!
functionDeclaration5
	^ #(#enumeration_ads_code #ExChdEnumerationAdsCodeFunction)

! !

!ExChdCheddarDomainsSchemaDefinition methodsFor: 'platypus-generated-functions' stamp: ''!
functionDeclaration6
	^ #(#basic_ada_expression_value_string #ExChdBasicAdaExpressionValueStringFunction)

! !

!ExChdCheddarDomainsSchemaDefinition methodsFor: 'platypus-generated-functions' stamp: ''!
functionDeclaration7
	^ #(#enumeration_adb_code #ExChdEnumerationAdbCodeFunction)

! !

!ExChdCheddarDomainsSchemaDefinition methodsFor: 'platypus-generated-functions' stamp: ''!
functionDeclaration8
	^ #(#range_type_ads_code #ExChdRangeTypeAdsCodeFunction)

! !

!ExChdCheddarDomainsSchemaDefinition methodsFor: 'platypus-generated-functions' stamp: ''!
functionDeclaration9
	^ #(#in_scope_attribute_init_code #ExChdInScopeAttributeInitCodeFunction)

! !

!ExChdCheddarDomainsSchemaDefinition methodsFor: 'platypus-generated-functions' stamp: ''!
functionDeclarationCount
	^ 10

! !

!ExChdCheddarDomainsSchemaDefinition methodsFor: 'platypus-generated-meta-data-accessing' stamp: ''!
schemaInstanceClassName
	^ #ExChdExpress2cheddarSchemaInstance

! !

PlatypusCoreSchema subclass: #ExChdCheddarDtdSchemaDefinition
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Express2Cheddar-CheddarDtdSchema'!

!ExChdCheddarDtdSchemaDefinition commentStamp: 'platypus comment' prior: 0!
<ISO10303-11-EXPRESS>
SCHEMA cheddar_dtd;
	USE FROM express2cheddar_facade;
	USE FROM platypus_dictionary_schema;
	USE FROM express_toolsbox_functions;
	USE FROM express_dictionary_queries;
	USE FROM record_and_class;
	USE FROM cheddar_domains;
	USE FROM package;
	USE FROM discriminated_type;

	ENTITY dtd_element 
		ABSTRACT SUPERTYPE;
		owner : OPTIONAL dtd_element;
		tag : STRING;
	DERIVE
		dtd_code : STRING := '';
	END_ENTITY;

	ENTITY composite_dtd_element 
		ABSTRACT SUPERTYPE 
		SUBTYPE OF ( dtd_element );
	DERIVE
		subs : LIST OF dtd_element := [ ];
	END_ENTITY;

	ENTITY root_dtd_element 
		SUBTYPE OF ( composite_dtd_element );
	DERIVE
		packages : LIST OF ada_package := xml_packages_with_tag ( SELF.tag );
		SELF\composite_dtd_element.subs : LIST OF package_dtd_element := compute_root_sub_elements ( SELF );
		SELF\dtd_element.dtd_code : STRING := compute_root_dtd_code ( SELF );
		declared_domains : LIST OF dtd_element := get_declared_entity_domains ( subs );
		referenced_entities : LIST OF dtd_element := get_referenced_entity_domains ( subs );
		implicit_domains : LIST OF entity_ref_dtd_element := compute_implicit_domains ( SELF );
	END_ENTITY;

	ENTITY package_dtd_element 
		SUBTYPE OF ( composite_dtd_element );
		package : ada_package;
	DERIVE
		SELF\dtd_element.tag : STRING := lowerize ( package.name );
		SELF\composite_dtd_element.subs : LIST OF dtd_element := compute_package_sub_elements ( SELF );
		SELF\dtd_element.dtd_code : STRING := compute_package_dtd_code ( SELF );
		attributes : LIST OF attribute_dtd_element := compute_package_attribute_dtd_elements ( SELF );
	END_ENTITY;

	ENTITY entity_dtd_element 
		SUBTYPE OF ( composite_dtd_element );
		domain : ada_entity;
	DERIVE
		SELF\dtd_element.tag : STRING := lowerize ( domain.name );
		SELF\composite_dtd_element.subs : LIST OF dtd_element := compute_entity_sub_elements ( SELF );
		SELF\dtd_element.dtd_code : STRING := compute_entity_dtd_code ( SELF );
	END_ENTITY;

	ENTITY ada_class_dtd_element 
		SUBTYPE OF ( entity_dtd_element );
	END_ENTITY;

	ENTITY record_dtd_element 
		SUBTYPE OF ( entity_dtd_element );
	END_ENTITY;

	ENTITY discriminated_type_dtd_element 
		SUBTYPE OF ( entity_dtd_element );
	DERIVE
		SELF\entity_dtd_element.subs : LIST OF dtd_element := compute_discriminated_type_sub_elements ( SELF );
		SELF\entity_dtd_element.dtd_code : STRING := compute_discriminated_type_code ( SELF );
	END_ENTITY;

	ENTITY attribute_dtd_element 
		SUBTYPE OF ( dtd_element );
		attribute : attribute;
		domain : domain_dtd_element;
	DERIVE
		SELF\dtd_element.tag : STRING := lowerize ( attribute.name );
		SELF\dtd_element.dtd_code : STRING := domain.dtd_code;
	END_ENTITY;

	ENTITY domain_dtd_element 
		SUBTYPE OF ( dtd_element );
		domain : entity_instance;
	DERIVE
		as_collection_element_dtd_code_tail : STRING := '';
	END_ENTITY;

	ENTITY simple_domain_dtd_element 
		SUBTYPE OF ( domain_dtd_element );
	DERIVE
		SELF\dtd_element.dtd_code : STRING := '<!!ELEMENT ' + SELF.owner.tag + ' (#PCDATA)>\n';
		SELF\domain_dtd_element.as_collection_element_dtd_code_tail : STRING := '(#PCDATA)>\n';
	END_ENTITY;

	ENTITY collection_dtd_element 
		SUBTYPE OF ( domain_dtd_element );
		element_domain : domain_dtd_element;
	DERIVE
		SELF\dtd_element.dtd_code : STRING := '<!!ELEMENT ' + owner.tag + ' ' + element_domain.as_collection_element_dtd_code_tail;
	END_ENTITY;

	ENTITY entity_ref_dtd_element 
		SUBTYPE OF ( domain_dtd_element );
	DERIVE
		infered_element : entity_dtd_element := ?;
		SELF\dtd_element.dtd_code : STRING := '<!!ELEMENT ' + owner.tag + ' (' + lowerize ( domain.name ) + ')>\n';
	END_ENTITY;

	ENTITY record_ref_dtd_element 
		SUBTYPE OF ( entity_ref_dtd_element );
	DERIVE
		SELF\entity_ref_dtd_element.infered_element : entity_dtd_element := dtd_element ( ?, ? ) || composite_dtd_element ( ) || entity_dtd_element ( domain ) || record_dtd_element ( );
		SELF\domain_dtd_element.as_collection_element_dtd_code_tail : STRING := '(' + lowerize ( domain.handled.name ) + ')*>\n';
	END_ENTITY;

	ENTITY ada_class_ref_dtd_element 
		SUBTYPE OF ( entity_ref_dtd_element );
	DERIVE
		SELF\entity_ref_dtd_element.infered_element : entity_dtd_element := dtd_element ( ?, ? ) || composite_dtd_element ( ) || entity_dtd_element ( domain ) || ada_class_dtd_element ( );
		SELF\entity_ref_dtd_element.dtd_code : STRING := '<!!ELEMENT ' + owner.tag + ' EMPTY>\n' 
		+ '<!!ATTLIST ' + owner.tag + ' ref IDREF #REQUIRED>\n';
		SELF\entity_ref_dtd_element.as_collection_element_dtd_code_tail : STRING := ' EMPTY>\n' 
		+ '<!!ATTLIST ' + owner.owner.tag + ' refs IDREFS #REQUIRED>\n';
	END_ENTITY;

	ENTITY discriminated_type_ref_dtd_element 
		SUBTYPE OF ( entity_ref_dtd_element );
	DERIVE
		SELF\entity_ref_dtd_element.infered_element : entity_dtd_element := dtd_element ( ?, ? ) || composite_dtd_element ( ) || entity_dtd_element ( domain ) || discriminated_type_dtd_element ( );
		SELF\domain_dtd_element.as_collection_element_dtd_code_tail : STRING := '(' + lowerize ( domain.handled.name ) + ')*>\n';
	END_ENTITY;

	ENTITY unknown_domain_dtd_element 
		SUBTYPE OF ( domain_dtd_element );
	DERIVE
		SELF\dtd_element.dtd_code : STRING := '<!!ELEMENT ' + SELF.owner.tag + ' ANY>\n';
		SELF\domain_dtd_element.as_collection_element_dtd_code_tail : STRING := 'ANY>\n';
	END_ENTITY;

	FUNCTION compute_root_dtd_code ( r : root_dtd_element ) : STRING;
		LOCAL 
			s : STRING := '';
			code : STRING;
			lines : LIST OF STRING := [ ];
			licence : STRING := string_replace ( source_licence, '--', '  ' );
			pkgs : LIST OF package_dtd_element := r.subs;
			attributes : LIST OF attribute_dtd_element := [ ];
			acode : STRING;
			previous : LIST OF STRING := [ ];
			implicits : LIST OF dtd_element := r.implicit_domains;
			infered : LIST OF entity_dtd_element := [ ];
			el : entity_dtd_element;
			infered_attributes : LIST OF attribute_dtd_element := [ ];
		END_LOCAL;

		REPEAT no := LOINDEX ( implicits ) TO HIINDEX ( implicits );
			el := implicits [ no].infered_element;
			infered := infered + el;
			infered_attributes := infered_attributes + el.subs;
		END_REPEAT;
		s := s + '<!!--' + licence + '-->\n\n' 

		+ '<!!ELEMENT ' + r.tag + ' (';

		REPEAT no := LOINDEX ( pkgs ) TO HIINDEX ( pkgs );
			s := s + pkgs [ no].tag + '?';
			IF ( no < HIINDEX ( pkgs ) ) THEN
				s := s + ' | ';
			END_IF;
		END_REPEAT;
		s := s + ')*>\n\n';

		REPEAT no := LOINDEX ( pkgs ) TO HIINDEX ( pkgs );
			code := pkgs [ no].dtd_code;
			previous := previous + LinesFromString ( code );
			s := s + code;
		END_REPEAT;
		s := s + '\n';

		REPEAT no := LOINDEX ( infered ) TO HIINDEX ( infered );
			acode := infered [ no].dtd_code;
			IF NOT ( acode IN previous ) THEN
				s := s + acode;
				previous := previous + acode;
			END_IF;
		END_REPEAT;

		REPEAT no := LOINDEX ( pkgs ) TO HIINDEX ( pkgs );
			attributes := attributes + compute_package_attribute_dtd_elements ( pkgs [ no] );
		END_REPEAT;

		REPEAT no := LOINDEX ( attributes ) TO HIINDEX ( attributes );
			acode := attributes [ no].dtd_code;
			IF NOT ( acode IN previous ) THEN
				s := s + attributes [ no].dtd_code;
				previous := previous + acode;
			END_IF;
		END_REPEAT;

		REPEAT no := LOINDEX ( infered_attributes ) TO HIINDEX ( infered_attributes );
			acode := infered_attributes [ no].dtd_code;
			IF NOT ( acode IN previous ) THEN
				s := s + acode;
				previous := previous + acode;
			END_IF;
		END_REPEAT;
		RETURN ( s );
	END_FUNCTION;

	FUNCTION root_dtds : LIST OF root_dtd_element;
		LOCAL 
			xml_pkgs : LIST OF ada_package := xml_packages ( );
			root_names : LIST OF STRING := [ ];
			result : LIST OF root_dtd_element := [ ];
		END_LOCAL;

		REPEAT no := LOINDEX ( xml_pkgs ) TO HIINDEX ( xml_pkgs );
			ALIAS curr_pkg FOR xml_pkgs [ no];
				root_names := root_names + curr_pkg.xml_root_tags;
			END_ALIAS;
		END_REPEAT;
		root_names := SetToList ( ListToSet ( root_names ) );

		REPEAT no := LOINDEX ( root_names ) TO HIINDEX ( root_names );
			result := result + composite_dtd_element ( ) || root_dtd_element ( ) || dtd_element ( ?, root_names [ no] );
		END_REPEAT;
		RETURN ( result );
	END_FUNCTION;

	FUNCTION compute_root_sub_elements ( e : root_dtd_element ) : LIST OF package_dtd_element;
		LOCAL 
			result : LIST OF package_dtd_element := [ ];
		END_LOCAL;

		ALIAS packages FOR e.packages;
			REPEAT no := LOINDEX ( packages ) TO HIINDEX ( packages );
				result := result + ( dtd_element ( e, ? ) || composite_dtd_element ( ) || package_dtd_element ( packages [ no] ) );
			END_REPEAT;
		END_ALIAS;
		RETURN ( result );
	END_FUNCTION;

	FUNCTION compute_package_attribute_dtd_elements ( p : package_dtd_element ) : LIST OF attribute_dtd_element;
		LOCAL 
			subs : LIST OF dtd_element := p.subs;
			r : LIST OF attribute_dtd_element := [ ];
		END_LOCAL;

		REPEAT no := LOINDEX ( subs ) TO HIINDEX ( subs );
			r := r + subs [ no].subs;
		END_REPEAT;
		RETURN ( r );
	END_FUNCTION;

	FUNCTION compute_package_dtd_code ( p : package_dtd_element ) : STRING;
		LOCAL 
			subs : LIST OF dtd_element := p.subs;
			s : STRING := '';
		END_LOCAL;

		IF ( SIZEOF ( subs ) > 0 ) THEN
			s := s + '<!!ELEMENT ' + p.tag + ' (';
			REPEAT no := LOINDEX ( subs ) TO HIINDEX ( subs );
				s := s + subs [ no].tag;
				IF ( no < HIINDEX ( subs ) ) THEN
					s := s + ' | ';
				END_IF;
			END_REPEAT;
			s := s + ')+>\n';
			REPEAT no := LOINDEX ( subs ) TO HIINDEX ( subs );
				s := s + subs [ no].dtd_code;
			END_REPEAT;
			s := s + '\n';
		END_IF;
		RETURN ( s );
	END_FUNCTION;

	FUNCTION compute_package_sub_elements ( e : package_dtd_element ) : LIST OF dtd_element;
		LOCAL 
			result : LIST OF dtd_element := [ ];
			classes : LIST OF ada_entity := package_ada_classes ( e.package );
			records : LIST OF ada_entity := package_records ( e.package );
			discrims : LIST OF discriminated_type := package_discriminated_types ( e.package );
		END_LOCAL;

		REPEAT no := LOINDEX ( classes ) TO HIINDEX ( classes );
			ALIAS curr FOR classes [ no];
				result := result + ( dtd_element ( e, ? ) || composite_dtd_element ( ) || entity_dtd_element ( curr ) || ada_class_dtd_element ( ) );
			END_ALIAS;
		END_REPEAT;

		REPEAT no := LOINDEX ( records ) TO HIINDEX ( records );
			ALIAS curr FOR records [ no];
				result := result + ( dtd_element ( e, ? ) || composite_dtd_element ( ) || entity_dtd_element ( curr ) || record_dtd_element ( ) );
			END_ALIAS;
		END_REPEAT;

		REPEAT no := LOINDEX ( discrims ) TO HIINDEX ( discrims );
			ALIAS curr FOR discrims [ no];
				result := result + ( dtd_element ( e, ? ) || composite_dtd_element ( ) || entity_dtd_element ( curr ) || discriminated_type_dtd_element ( ) );
			END_ALIAS;
		END_REPEAT;
		RETURN ( result );
	END_FUNCTION;

	FUNCTION compute_entity_dtd_code ( ent : entity_dtd_element ) : STRING;
		LOCAL 
			s : STRING := '';
			l : LIST OF STRING := [ ];
			subs : LIST OF dtd_element := ent.subs;
		END_LOCAL;

		REPEAT no := LOINDEX ( subs ) TO HIINDEX ( subs );
			ALIAS curr FOR subs [ no];
				l := l + curr.tag;
			END_ALIAS;
		END_REPEAT;
		s := '<!!ELEMENT ' + ent.tag + ' (' + StringAggregateConcatSeparatedBy ( l, ' | ' ) + ')*>\n';

		IF ( 'RECORD_AND_CLASS.ADA_CLASS' IN TYPEOF ( ent.domain ) ) THEN
			s := s + '<!!ATTLIST ' + ent.tag + ' id ID #REQUIRED>\n';
		END_IF;
		RETURN ( s );
	END_FUNCTION;

	FUNCTION compute_attribute_dtd_list_from_attribute_list ( owner : dtd_element; attrs : LIST OF explicit_attribute ) : LIST OF dtd_element;
		LOCAL 
			result : LIST OF dtd_element := [ ];
		END_LOCAL;

		REPEAT no := LOINDEX ( attrs ) TO HIINDEX ( attrs );
			ALIAS curr FOR attrs [ no];
				IF ( lowerize ( curr.name ) <> lowerize ( xml_id_name ) ) THEN
					result := result + compute_attribute_dtd_element ( owner, curr );
				END_IF;
			END_ALIAS;
		END_REPEAT;
		RETURN ( result );
	END_FUNCTION;

	FUNCTION compute_entity_sub_elements ( e : entity_dtd_element ) : LIST OF dtd_element;
		LOCAL 
			attrs : LIST OF explicit_attribute := inherited_explicit_attributes ( e.domain );
			result : LIST OF dtd_element := compute_attribute_dtd_list_from_attribute_list ( e, attrs );
		END_LOCAL;
		RETURN ( result );
	END_FUNCTION;

	FUNCTION compute_discriminated_type_code ( ent : discriminated_type_dtd_element ) : STRING;
		LOCAL 
			s : STRING := '';
			l : LIST OF STRING := [ ];
			subs : LIST OF dtd_element := ent.subs;
		END_LOCAL;

		REPEAT no := LOINDEX ( subs ) TO HIINDEX ( subs );
			ALIAS curr FOR subs [ no];
				l := l + curr.tag;
			END_ALIAS;
		END_REPEAT;
		s := '<!!ELEMENT ' + ent.tag + ' (' + StringAggregateConcatSeparatedBy ( l, ' | ' ) + ')*>\n';
		RETURN ( s );
	END_FUNCTION;

	FUNCTION compute_discriminated_type_sub_elements ( e : discriminated_type_dtd_element ) : LIST OF dtd_element;
		LOCAL 
			attrs : LIST OF explicit_attribute := discriminated_type_attributes ( e.domain );
			result : LIST OF dtd_element := compute_attribute_dtd_list_from_attribute_list ( e, attrs );
		END_LOCAL;
		RETURN ( result );
	END_FUNCTION;

	FUNCTION compute_attribute_dtd_element ( owner : dtd_element; a : attribute ) : attribute_dtd_element;
		LOCAL 
			domain : entity_instance := basic_ada_domain ( a.domain ).handled;
			result : attribute_dtd_element;
		END_LOCAL;
		result := ( dtd_element ( owner, ? ) || attribute_dtd_element ( a, ? ) );
		result.domain := compute_domain_dtd_element ( result, domain );
		RETURN ( result );
	END_FUNCTION;

	FUNCTION compute_domain_dtd_element ( owner : dtd_element; domain : entity_instance ) : domain_dtd_element;
		LOCAL 
			sub_domain : entity_instance;
			element_domain : entity_instance;
			result : domain_dtd_element;
		END_LOCAL;

		IF ( 'PLATYPUS_DICTIONARY_SCHEMA.DICTIONARY_INSTANCE_REFERENCE' IN TYPEOF ( domain ) ) THEN
			RETURN ( compute_domain_dtd_element ( owner, domain.ref ) );
		ELSE
			IF ( 'CHEDDAR_DOMAINS.ADA_PRIMITIVE_TYPE' IN TYPEOF ( domain ) ) THEN
				RETURN ( simple_domain_dtd_element ( ) || dtd_element ( owner, ? ) || domain_dtd_element ( domain ) );
			ELSE
				IF ( 'CHEDDAR_DOMAINS.ADA_ENUMERATION' IN TYPEOF ( domain ) ) THEN
					RETURN ( simple_domain_dtd_element ( ) || dtd_element ( owner, ? ) || domain_dtd_element ( domain ) );
				ELSE
					IF ( 'CHEDDAR_DOMAINS.CHEDDAR_PRIORITY_RANGE' IN TYPEOF ( domain ) ) THEN
						RETURN ( simple_domain_dtd_element ( ) || dtd_element ( owner, ? ) || domain_dtd_element ( domain ) );
					ELSE
						IF ( 'RECORD_AND_CLASS.RECORD' IN TYPEOF ( domain ) ) THEN
							RETURN ( record_ref_dtd_element ( ) || entity_ref_dtd_element ( ) || dtd_element ( owner, ? ) || domain_dtd_element ( domain ) );
						ELSE
							IF ( 'DISCRIMINATED_TYPE.DISCRIMINATED_TYPE' IN TYPEOF ( domain ) ) THEN
								RETURN ( discriminated_type_ref_dtd_element ( ) || entity_ref_dtd_element ( ) || dtd_element ( owner, ? ) || domain_dtd_element ( domain ) );
							ELSE
								IF ( 'RECORD_AND_CLASS.ADA_CLASS' IN TYPEOF ( domain ) ) THEN
									RETURN ( ada_class_ref_dtd_element ( ) || entity_ref_dtd_element ( ) || dtd_element ( owner, ? ) || domain_dtd_element ( domain ) );
								ELSE
									IF ( 'PLATYPUS_DICTIONARY_SCHEMA.DEFINED_TYPE' IN TYPEOF ( domain ) ) THEN
										sub_domain := basic_ada_domain ( domain.domain );
										IF ( 'PLATYPUS_DICTIONARY_SCHEMA.AGGREGATION_TYPE' IN TYPEOF ( sub_domain ) ) THEN
											element_domain := basic_ada_domain ( sub_domain.element_type );
											result := collection_dtd_element ( ? ) || dtd_element ( owner, ? ) || domain_dtd_element ( domain );
											result.element_domain := compute_domain_dtd_element ( result, element_domain );
											RETURN ( result );
										END_IF;
									END_IF;
								END_IF;
							END_IF;
						END_IF;
					END_IF;
				END_IF;
			END_IF;
		END_IF;
		println ( domain );
		RETURN ( unknown_domain_dtd_element ( ) || dtd_element ( owner, ? ) || domain_dtd_element ( domain ) );
	END_FUNCTION;

	FUNCTION xml_packages : LIST OF ada_package;
		RETURN ( QUERY ( p <* SetToList ( all_ada_packages ( ) ) | SIZEOF ( p.xml_root_tags ) > 0 ) );
	END_FUNCTION;

	FUNCTION get_referenced_entity_domains ( pkgs : LIST OF package_dtd_element ) : LIST OF entity_ref_dtd_element;
		LOCAL 
			attributes : LIST OF attribute_dtd_element := [ ];
			domains : LIST OF entity_ref_dtd_element := [ ];
			names : LIST OF STRING := [ ];
			curr : domain_dtd_element;
		END_LOCAL;

		REPEAT no := LOINDEX ( pkgs ) TO HIINDEX ( pkgs );
			attributes := attributes + compute_package_attribute_dtd_elements ( pkgs [ no] );
		END_REPEAT;

		REPEAT noi := LOINDEX ( attributes ) TO HIINDEX ( attributes );
			curr := ?;
			ALIAS dom FOR attributes [ noi].domain;
				IF ( 'CHEDDAR_DTD.ENTITY_REF_DTD_ELEMENT' IN TYPEOF ( dom ) ) THEN
					curr := dom;
				END_IF;
				IF ( ( 'CHEDDAR_DTD.COLLECTION_DTD_ELEMENT' IN TYPEOF ( dom ) ) AND ( 'CHEDDAR_DTD.ENTITY_REF_DTD_ELEMENT' IN TYPEOF ( dom.element_domain ) ) ) THEN
					curr := dom.element_domain;
				END_IF;
				IF EXISTS ( curr ) THEN
					IF NOT ( lowerize ( curr.domain.name ) IN names ) THEN
						domains := domains + curr;
						names := names + lowerize ( curr.domain.name );
					END_IF;
				END_IF;
			END_ALIAS;
		END_REPEAT;
		RETURN ( domains );
	END_FUNCTION;

	FUNCTION get_declared_entity_domains ( pkgs : LIST OF package_dtd_element ) : LIST OF dtd_element;
		LOCAL 
			result : LIST OF dtd_element := [ ];
		END_LOCAL;

		REPEAT no := LOINDEX ( pkgs ) TO HIINDEX ( pkgs );
			result := result + pkgs [ no].subs;
		END_REPEAT;
		RETURN ( result );
	END_FUNCTION;

	FUNCTION compute_implicit_domains ( r : root_dtd_element ) : LIST OF entity_ref_dtd_element;
		LOCAL 
			refed : LIST OF entity_ref_dtd_element := r.referenced_entities;
			decl : LIST OF dtd_element := r.declared_domains;
			decl_domain : LIST OF entity_instance := [ ];
			not_declared : LIST OF entity_ref_dtd_element := [ ];
		END_LOCAL;

		REPEAT no := LOINDEX ( decl ) TO HIINDEX ( decl );
			ALIAS curr FOR decl [ no];
				decl_domain := decl_domain + curr.domain;
			END_ALIAS;
		END_REPEAT;

		REPEAT no := LOINDEX ( refed ) TO HIINDEX ( refed );
			ALIAS curr FOR refed [ no];
				IF NOT ( curr.domain IN decl_domain ) AND NOT ( curr IN not_declared ) THEN
					not_declared := not_declared + curr;
				END_IF;
			END_ALIAS;
		END_REPEAT;
		RETURN ( not_declared );
	END_FUNCTION;

	FUNCTION xml_packages_with_tag ( tag : STRING ) : LIST OF ada_package;
		RETURN ( QUERY ( p <* xml_packages ( ) | tag IN p.xml_root_tags ) );
	END_FUNCTION;
END_SCHEMA;

</ISO10303-11-EXPRESS>!

!ExChdCheddarDtdSchemaDefinition class methodsFor: 'platypus-generated-platypus-signature' stamp: ''!
iso10303P11Translater
	^ 'Platypus (c) LISYC EA3883, Universite de Bretagne occidentale. Brest.'

! !

!ExChdCheddarDtdSchemaDefinition class methodsFor: 'platypus-generated-platypus-signature' stamp: ''!
translatedFromISO10303P11
	^ true

! !

!ExChdCheddarDtdSchemaDefinition class methodsFor: 'platypus-generated-platypus-signature' stamp: ''!
vwNamespaceName
	^ #Express2Cheddar

! !

!ExChdCheddarDtdSchemaDefinition methodsFor: 'platypus-generated-context-accessing' stamp: ''!
context
	^ self schemaInstance context

! !

!ExChdCheddarDtdSchemaDefinition methodsFor: 'platypus-generated-entities' stamp: ''!
entityDefinition1
	^ #(#dtd_element #ExChdDtdElement)

! !

!ExChdCheddarDtdSchemaDefinition methodsFor: 'platypus-generated-entities' stamp: ''!
entityDefinition10
	^ #(#domain_dtd_element #ExChdDomainDtdElement)

! !

!ExChdCheddarDtdSchemaDefinition methodsFor: 'platypus-generated-entities' stamp: ''!
entityDefinition11
	^ #(#simple_domain_dtd_element #ExChdSimpleDomainDtdElement)

! !

!ExChdCheddarDtdSchemaDefinition methodsFor: 'platypus-generated-entities' stamp: ''!
entityDefinition12
	^ #(#collection_dtd_element #ExChdCollectionDtdElement)

! !

!ExChdCheddarDtdSchemaDefinition methodsFor: 'platypus-generated-entities' stamp: ''!
entityDefinition13
	^ #(#entity_ref_dtd_element #ExChdEntityRefDtdElement)

! !

!ExChdCheddarDtdSchemaDefinition methodsFor: 'platypus-generated-entities' stamp: ''!
entityDefinition14
	^ #(#record_ref_dtd_element #ExChdRecordRefDtdElement)

! !

!ExChdCheddarDtdSchemaDefinition methodsFor: 'platypus-generated-entities' stamp: ''!
entityDefinition15
	^ #(#ada_class_ref_dtd_element #ExChdAdaClassRefDtdElement)

! !

!ExChdCheddarDtdSchemaDefinition methodsFor: 'platypus-generated-entities' stamp: ''!
entityDefinition16
	^ #(#discriminated_type_ref_dtd_element #ExChdDiscriminatedTypeRefDtdElement)

! !

!ExChdCheddarDtdSchemaDefinition methodsFor: 'platypus-generated-entities' stamp: ''!
entityDefinition17
	^ #(#unknown_domain_dtd_element #ExChdUnknownDomainDtdElement)

! !

!ExChdCheddarDtdSchemaDefinition methodsFor: 'platypus-generated-entities' stamp: ''!
entityDefinition2
	^ #(#composite_dtd_element #ExChdCompositeDtdElement)

! !

!ExChdCheddarDtdSchemaDefinition methodsFor: 'platypus-generated-entities' stamp: ''!
entityDefinition3
	^ #(#root_dtd_element #ExChdRootDtdElement)

! !

!ExChdCheddarDtdSchemaDefinition methodsFor: 'platypus-generated-entities' stamp: ''!
entityDefinition4
	^ #(#package_dtd_element #ExChdPackageDtdElement)

! !

!ExChdCheddarDtdSchemaDefinition methodsFor: 'platypus-generated-entities' stamp: ''!
entityDefinition5
	^ #(#entity_dtd_element #ExChdEntityDtdElement)

! !

!ExChdCheddarDtdSchemaDefinition methodsFor: 'platypus-generated-entities' stamp: ''!
entityDefinition6
	^ #(#ada_class_dtd_element #ExChdAdaClassDtdElement)

! !

!ExChdCheddarDtdSchemaDefinition methodsFor: 'platypus-generated-entities' stamp: ''!
entityDefinition7
	^ #(#record_dtd_element #ExChdRecordDtdElement)

! !

!ExChdCheddarDtdSchemaDefinition methodsFor: 'platypus-generated-entities' stamp: ''!
entityDefinition8
	^ #(#discriminated_type_dtd_element #ExChdDiscriminatedTypeDtdElement)

! !

!ExChdCheddarDtdSchemaDefinition methodsFor: 'platypus-generated-entities' stamp: ''!
entityDefinition9
	^ #(#attribute_dtd_element #ExChdAttributeDtdElement)

! !

!ExChdCheddarDtdSchemaDefinition methodsFor: 'platypus-generated-entities' stamp: ''!
entityDefinitionCount
	^ 17

! !

!ExChdCheddarDtdSchemaDefinition methodsFor: 'platypus-generated-functions' stamp: ''!
functionDeclaration1
	^ #(#compute_root_dtd_code #ExChdComputeRootDtdCodeFunction)

! !

!ExChdCheddarDtdSchemaDefinition methodsFor: 'platypus-generated-functions' stamp: ''!
functionDeclaration10
	^ #(#compute_discriminated_type_code #ExChdComputeDiscriminatedTypeCodeFunction)

! !

!ExChdCheddarDtdSchemaDefinition methodsFor: 'platypus-generated-functions' stamp: ''!
functionDeclaration11
	^ #(#compute_discriminated_type_sub_elements #ExChdComputeDiscriminatedTypeSubElementsFunction)

! !

!ExChdCheddarDtdSchemaDefinition methodsFor: 'platypus-generated-functions' stamp: ''!
functionDeclaration12
	^ #(#compute_attribute_dtd_element #ExChdComputeAttributeDtdElementFunction)

! !

!ExChdCheddarDtdSchemaDefinition methodsFor: 'platypus-generated-functions' stamp: ''!
functionDeclaration13
	^ #(#compute_domain_dtd_element #ExChdComputeDomainDtdElementFunction)

! !

!ExChdCheddarDtdSchemaDefinition methodsFor: 'platypus-generated-functions' stamp: ''!
functionDeclaration14
	^ #(#xml_packages #ExChdXmlPackagesFunction)

! !

!ExChdCheddarDtdSchemaDefinition methodsFor: 'platypus-generated-functions' stamp: ''!
functionDeclaration15
	^ #(#get_referenced_entity_domains #ExChdGetReferencedEntityDomainsFunction)

! !

!ExChdCheddarDtdSchemaDefinition methodsFor: 'platypus-generated-functions' stamp: ''!
functionDeclaration16
	^ #(#get_declared_entity_domains #ExChdGetDeclaredEntityDomainsFunction)

! !

!ExChdCheddarDtdSchemaDefinition methodsFor: 'platypus-generated-functions' stamp: ''!
functionDeclaration17
	^ #(#compute_implicit_domains #ExChdComputeImplicitDomainsFunction)

! !

!ExChdCheddarDtdSchemaDefinition methodsFor: 'platypus-generated-functions' stamp: ''!
functionDeclaration18
	^ #(#xml_packages_with_tag #ExChdXmlPackagesWithTagFunction)

! !

!ExChdCheddarDtdSchemaDefinition methodsFor: 'platypus-generated-functions' stamp: ''!
functionDeclaration2
	^ #(#root_dtds #ExChdRootDtdsFunction)

! !

!ExChdCheddarDtdSchemaDefinition methodsFor: 'platypus-generated-functions' stamp: ''!
functionDeclaration3
	^ #(#compute_root_sub_elements #ExChdComputeRootSubElementsFunction)

! !

!ExChdCheddarDtdSchemaDefinition methodsFor: 'platypus-generated-functions' stamp: ''!
functionDeclaration4
	^ #(#compute_package_attribute_dtd_elements #ExChdComputePackageAttributeDtdElementsFunction)

! !

!ExChdCheddarDtdSchemaDefinition methodsFor: 'platypus-generated-functions' stamp: ''!
functionDeclaration5
	^ #(#compute_package_dtd_code #ExChdComputePackageDtdCodeFunction)

! !

!ExChdCheddarDtdSchemaDefinition methodsFor: 'platypus-generated-functions' stamp: ''!
functionDeclaration6
	^ #(#compute_package_sub_elements #ExChdComputePackageSubElementsFunction)

! !

!ExChdCheddarDtdSchemaDefinition methodsFor: 'platypus-generated-functions' stamp: ''!
functionDeclaration7
	^ #(#compute_entity_dtd_code #ExChdComputeEntityDtdCodeFunction)

! !

!ExChdCheddarDtdSchemaDefinition methodsFor: 'platypus-generated-functions' stamp: ''!
functionDeclaration8
	^ #(#compute_attribute_dtd_list_from_attribute_list #ExChdComputeAttributeDtdListFromAttributeListFunction)

! !

!ExChdCheddarDtdSchemaDefinition methodsFor: 'platypus-generated-functions' stamp: ''!
functionDeclaration9
	^ #(#compute_entity_sub_elements #ExChdComputeEntitySubElementsFunction)

! !

!ExChdCheddarDtdSchemaDefinition methodsFor: 'platypus-generated-functions' stamp: ''!
functionDeclarationCount
	^ 18

! !

!ExChdCheddarDtdSchemaDefinition methodsFor: 'platypus-generated-meta-data-accessing' stamp: ''!
schemaInstanceClassName
	^ #ExChdExpress2cheddarSchemaInstance

! !

PlatypusCoreSchema subclass: #ExChdDiscriminatedTypeSchemaDefinition
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Express2Cheddar-DiscriminatedTypeSchema'!

!ExChdDiscriminatedTypeSchemaDefinition commentStamp: 'platypus comment' prior: 0!
<ISO10303-11-EXPRESS>
SCHEMA discriminated_type;
	USE FROM platypus_dictionary_schema;
	USE FROM express_toolsbox_functions;
	USE FROM express_dictionary_queries;
	USE FROM express2cheddar_facade;
	USE FROM record_and_class;
	USE FROM cheddar_domains;
	USE FROM ada_interface;

	ENTITY discriminated_type 
		SUBTYPE OF ( ada_entity );
	DERIVE
		SELF\ada_entity.refed_by_pointer : BOOLEAN := false;
		discriminant : attribute := QUERY ( attr <* attributes | 'DISCRIMINATED_TYPE.DISCRIMINATED_TYPE_DISCRIMINANT' IN TYPEOF ( attr ) ) [ 1 ];
		union_attr : attribute := QUERY ( attr <* attributes | 'DISCRIMINATED_TYPE.DISCRIMINATED_TYPE_UNION' IN TYPEOF ( attr ) ) [ 1 ];
		ads_interfaces_list : LIST OF ada_interface := discriminated_Type_interfaces_list ( SELF, true );
		adb_interfaces_list : LIST OF ada_interface := discriminated_Type_interfaces_list ( SELF, false );
		translated_attributes : LIST OF explicit_attribute := explicit_attributes - discriminant - union_attr;
		SELF\ada_entity.ada_ident : STRING := name;
		SELF\ada_entity.ada_ref_ident : STRING := SELF.ada_ident + '_Ptr';
		SELF\ada_entity.xml_io_record_code : STRING := discriminated_type_xml_io_record_code ( SELF );
		tail_attributes : LIST OF attribute := discriminated_type_tails_attributes ( SELF );
		ads_code : STRING := discriminated_type_ads_code ( SELF );
		adb_code : STRING := discriminated_type_adb_code ( SELF );
	END_ENTITY;

	ENTITY discriminated_type_discriminant 
		SUBTYPE OF ( explicit_attribute );
	END_ENTITY;

	ENTITY discriminated_type_union 
		SUBTYPE OF ( explicit_attribute );
	END_ENTITY;

	ENTITY discriminated_type_union_element_type 
		SUBTYPE OF ( ada_entity );
	DERIVE
		ads_interfaces_list : LIST OF ada_interface := [ ];
		adb_interfaces_list : LIST OF ada_interface := [ ];
		ads_code : STRING := '';
		adb_code : STRING := '';
		union_ads_code : STRING := discriminated_type_union_element_case_code ( SELF );
	END_ENTITY;

	ENTITY discriminated_type_union_type 
		SUBTYPE OF ( ada_entity );
	DERIVE
		ads_interfaces_list : LIST OF ada_interface := discriminated_type_union_type_interfaces_list ( SELF, true );
		adb_interfaces_list : LIST OF ada_interface := discriminated_type_union_type_interfaces_list ( SELF, false );
		ads_code : STRING := '';
		adb_code : STRING := '';
		union_ads_code : STRING := discriminated_type_union_case_code ( SELF );
		all_attributes : LIST OF attribute := inherited_explicit_attributes ( SELF );
	END_ENTITY;

	FUNCTION discriminated_type_attributes ( d : discriminated_type ) : LIST OF attribute;
		LOCAL 
			other_attrs : LIST OF attribute := [ d.discriminant] + d.translated_attributes;
			tail_attrs : LIST OF explicit_attribute := discriminated_type_tails_attributes ( d );
			attrs : LIST OF attribute := other_attrs + tail_attrs;
		END_LOCAL;
		RETURN ( attrs );
	END_FUNCTION;

	FUNCTION discriminated_type_interfaces_list ( r : discriminated_type; ads : BOOLEAN ) : LIST OF ada_interface;
		RETURN ( ada_entity_interfaces_list ( r, ads ) );
	END_FUNCTION;

	FUNCTION discriminated_type_union_type_interfaces_list ( d : discriminated_type_union_type; isAds : BOOLEAN ) : LIST OF ada_interface;
		LOCAL 
			l : LIST OF ada_interface := [ ];
		END_LOCAL;

		REPEAT no := LOINDEX ( d.attributes ) TO HIINDEX ( d.attributes );
			ALIAS curr FOR d.attributes [ no];
				l := l + entity_definition_interfaces_list ( curr.domain.handled, isAds );
			END_ALIAS;
		END_REPEAT;
		RETURN ( l );
	END_FUNCTION;

	FUNCTION discriminated_type_adb_code ( typ : discriminated_type ) : STRING;
		LOCAL 
			code : STRING;
			acode : STRING;
			discrim_attr : attribute := typ.discriminant;
			union_attr : attribute := typ.union_attr;
			union_type : defined_type := union_attr.domain.handled;
			union_attributes : LIST OF attribute := inherited_explicit_attributes ( union_type );
			transl_attrs : LIST OF attribute := typ.translated_attributes;
			v : STRING := 'New_' + typ.name;
		END_LOCAL;
		code := 'procedure Initialize (obj : out ' + typ.name + '_Ptr) is\n' 
		+ 'begin\n' 
		+ '\tobj := NULL;\n' 
		+ 'end Initialize;\n \n' 
		+ 'procedure Put(obj : in ' + typ.name + '_Ptr) is\n' 
		+ 'begin\n' 
		+ '\tif (obj /= NULL) then\n';

		REPEAT no := LOINDEX ( transl_attrs ) TO HIINDEX ( transl_attrs );
			ALIAS attr FOR transl_attrs [ no];
				acode := explicit_attribute_put ( attr );
				IF ( acode > '' ) THEN
					code := code + '\t\t' + acode + '\n';
				END_IF;
			END_ALIAS;
		END_REPEAT;
		code := code + '\t\t' + explicit_attribute_put ( discrim_attr ) + '\n' 
		+ '\t\tput ( "value: " );\n' 
		+ '\t\tcase obj.' + discrim_attr.name + ' is \n';

		REPEAT no := LOINDEX ( union_attributes ) TO HIINDEX ( union_attributes );
			ALIAS union_attr FOR union_attributes [ no];
				ALIAS ada_domain FOR basic_ada_domain ( union_attr.domain ).handled;
					ALIAS element_attributes FOR inherited_explicit_attributes ( ada_domain );
						code := code + '\t\t\twhen ' + union_attr.name + ' => \n';
						REPEAT noi := LOINDEX ( element_attributes ) TO HIINDEX ( element_attributes );
							ALIAS element_attr FOR element_attributes [ noi];
								acode := explicit_attribute_put ( element_attr );
								IF ( acode > '' ) THEN
									code := code + '\t\t\t\t' + acode + '\n';
								END_IF;
							END_ALIAS;
						END_REPEAT;
					END_ALIAS;
				END_ALIAS;
			END_ALIAS;
			code := code + '\n';
		END_REPEAT;
		code := code + '\t\tend case;\n\tend if;\n\tNew_Line;\nend Put;\n\n' 

		+ 'function Copy ( obj : in ' + typ.name + ' ) return ' + typ.ptr_type + ' is\n' 
		+ '\t' + v + ' : ' + typ.ptr_type + ';\n' 
		+ 'begin\n' 
		+ '\t' + v + ' := new ' + typ.name + '''(obj);\n' 
		+ '\treturn (' + v + ');\n' 
		+ 'end Copy;\n\n' 

		+ 'function Copy ( obj : in ' + typ.ptr_type + ' ) return ' + typ.ptr_type + ' is\n' 
		+ 'begin\n' 
		+ '\treturn copy(obj.all);\n' 
		+ 'end Copy;\n\n' 

		+ 'function XML_String(obj : in ' + typ.name + ') return Unbounded_String is\n' 
		+ '\tresult : Unbounded_String;\n' 
		+ 'begin\n' 
		+ '	result := to_unbounded_string("<' + typ.html_tag + '>");\n';

		REPEAT no := LOINDEX ( transl_attrs ) TO HIINDEX ( transl_attrs );
			ALIAS attr FOR transl_attrs [ no];
				acode := explicit_attribute_xml_writer_code ( 'obj', attr );
				IF ( acode > '' ) THEN
					code := code + '\t\t' + acode + '\n';
				END_IF;
			END_ALIAS;
		END_REPEAT;
		code := code + explicit_attribute_xml_writer_code ( 'obj', discrim_attr ) + '\n\n' 

		+ '\tcase obj.' + discrim_attr.name + ' is \n';

		REPEAT no := LOINDEX ( union_attributes ) TO HIINDEX ( union_attributes );
			ALIAS union_attr FOR union_attributes [ no];
				ALIAS ada_domain FOR basic_ada_domain ( union_attr.domain ).handled;
					ALIAS element_attributes FOR inherited_explicit_attributes ( ada_domain );
						code := code + '\t\twhen ' + union_attr.name + ' => \n';
						REPEAT noi := LOINDEX ( element_attributes ) TO HIINDEX ( element_attributes );
							ALIAS element_attr FOR element_attributes [ noi];
								acode := explicit_attribute_xml_writer_code ( 'obj', element_attr );
								IF ( acode > '' ) THEN
									code := code + '\t\t' + acode + '\n';
								END_IF;
							END_ALIAS;
						END_REPEAT;
					END_ALIAS;
				END_ALIAS;
			END_ALIAS;
			code := code + '\n';
		END_REPEAT;
		code := code + '\tend case;\n' 
		+ '\tresult := result & to_unbounded_string("</' + typ.html_tag + '>");\n' 
		+ '\treturn (result);\n' 
		+ 'end XML_String;\n\n' 

		+ 'function XML_String(obj : in ' + typ.name + '_Ptr) return Unbounded_String is\n' 
		+ 'begin\n' 
		+ '	return XML_String(obj.all);\n' 
		+ 'end XML_String;\n\n' 

		+ 'function XML_Ref_String(obj : in ' + typ.name + ') return Unbounded_String is\n' 
		+ '\tresult : Unbounded_String;\n' 
		+ 'begin\n' 
		+ '	raise xml_ref_string_error;\n' 
		+ '	return to_unbounded_string("");\n' 
		+ 'end XML_Ref_String;\n' 
		+ 'function XML_Ref_String(obj : in ' + typ.name + '_Ptr) return Unbounded_String is\n' 
		+ 'begin\n' 
		+ '	return XML_Ref_String(obj.all);\n' 
		+ 'end XML_Ref_String;\n\n';
		RETURN ( code );
	END_FUNCTION;

	FUNCTION discriminated_type_ads_code ( typ : discriminated_type ) : STRING;
		LOCAL 
			result : STRING;
			discrim_attr : attribute := typ.discriminant;
			discrim_type : entity_instance := discrim_attr.domain.handled;
			union_attr : attribute := typ.union_attr;
			union_type : defined_type := union_attr.domain.handled;
			union_selections : LIST OF attribute := inherited_explicit_attributes ( union_type );
			domain : entity_instance;
			transl_attrs : LIST OF attribute := typ.translated_attributes;
		END_LOCAL;
		result := 'type ' + typ.name + ' (' + discrim_attr.name + ' : ' + discrim_type.name + ' ) is record\n';

		REPEAT no := LOINDEX ( transl_attrs ) TO HIINDEX ( transl_attrs );
			ALIAS attr FOR transl_attrs [ no];
				domain := basic_ada_domain ( attr.domain );
				IF ( 'RECORD_AND_CLASS.ADA_CLASS' IN TYPEOF ( domain.handled ) ) THEN
					result := result + '\t' + attr.name + ' : ' + domain.handled.ptr_type + ';\n';
				ELSE
					result := result + '\t' + attr.name + ' : ' + domain.ada_ref_ident + ';\n';
				END_IF;
			END_ALIAS;
		END_REPEAT;
		result := result + '\tcase ' + discrim_attr.name + ' is \n' 
		+ union_type.union_ads_code + '\tend case;\nend record;\n\n' 

		+ 'type ' + typ.ptr_type + ' is access all ' + typ.name + ';\n' 
		+ '\nprocedure Initialize(obj : out ' + typ.ptr_type + ');\n' 
		+ '\nprocedure Put(obj : in ' + typ.ptr_type + ');\n' 
		+ 'function Copy(obj : in ' + typ.ptr_type + ') return ' + typ.ptr_type + ';\n' 
		+ 'function Copy(obj : in ' + typ.name + ') return ' + typ.ptr_type + ';\n' 
		+ 'function XML_String(obj : in ' + typ.name + ') return Unbounded_String;\n' 
		+ '\nfunction XML_String(obj : in ' + typ.ptr_type + ') return Unbounded_String;\n' 
		+ 'procedure Free  is new Unchecked_Deallocation (' + typ.name + ', ' + typ.ptr_type + ');\n' 
		+ 'function XML_Ref_String(obj : in ' + typ.name + ') return Unbounded_String;\n' 
		+ '\nfunction XML_Ref_String(obj : in ' + typ.ptr_type + ') return Unbounded_String;\n';
		RETURN ( result );
	END_FUNCTION;

	FUNCTION discriminated_type_union_case_code ( u : discriminated_type_union_type ) : STRING;
		LOCAL 
			code : STRING := '';
			all_attributes : LIST OF attribute := inherited_explicit_attributes ( u );
		END_LOCAL;

		REPEAT no := LOINDEX ( all_attributes ) TO HIINDEX ( all_attributes );
			ALIAS attr FOR all_attributes [ no];
				ALIAS ada_domain FOR basic_ada_domain ( attr.domain ).handled;
					code := code + '\t\twhen ' + attr.name + ' => \n ' + ada_domain.union_ads_code;
				END_ALIAS;
			END_ALIAS;
			code := code + '\n';
		END_REPEAT;
		RETURN ( code );
	END_FUNCTION;

	FUNCTION discriminated_type_union_element_case_code ( u : discriminated_type_union_element_type ) : STRING;
		LOCAL 
			code : STRING := '';
			all_attributes : LIST OF attribute := inherited_explicit_attributes ( u );
			domain : entity_instance;
		END_LOCAL;

		REPEAT no := LOINDEX ( all_attributes ) TO HIINDEX ( all_attributes );
			ALIAS attr FOR all_attributes [ no];
				domain := basic_ada_domain ( attr.domain );
				IF ( 'RECORD_AND_CLASS.ADA_CLASS' IN TYPEOF ( domain.handled ) ) THEN
					code := code + '\t\t\t' + attr.name + ' : ' + domain.handled.ptr_type + ';\n';
				ELSE
					code := code + '\t\t\t' + attr.name + ' : ' + domain.ada_ref_ident + ';\n';
				END_IF;
			END_ALIAS;
		END_REPEAT;
		RETURN ( code );
	END_FUNCTION;

	FUNCTION discriminated_type_xml_io_record_code ( typ : discriminated_type ) : STRING;
		LOCAL 
			code : STRING := '';
			discrim_attr : attribute := typ.discriminant;
			discrim_type : entity_instance := discrim_attr.domain.handled;
			union_attr : attribute := typ.union_attr;
			union_type : defined_type := union_attr.domain.handled;
			union_attributes : LIST OF attribute := inherited_explicit_attributes ( union_type );
			tails_attrs : LIST OF attribute := typ.tail_attributes;
			transl_attrs : LIST OF attribute := typ.translated_attributes;
		END_LOCAL;
		code := '\ntype ' + typ.name + '_io is record' + '\n\t' + discrim_attr.name + ' : ' + discrim_type.name + ';';

		REPEAT no := LOINDEX ( transl_attrs ) TO HIINDEX ( transl_attrs );
			ALIAS attr FOR transl_attrs [ no];
				code := code + explicit_attribute_xml_io_record_code ( attr );
			END_ALIAS;
		END_REPEAT;

		REPEAT no := LOINDEX ( tails_attrs ) TO HIINDEX ( tails_attrs );
			ALIAS attr FOR tails_attrs [ no];
				code := code + explicit_attribute_xml_io_record_code ( attr );
			END_ALIAS;
		END_REPEAT;
		code := code + '\nend record;\n';
		RETURN ( code );
	END_FUNCTION;

	FUNCTION discriminated_type_tails_attributes ( typ : discriminated_type ) : LIST OF attribute;
		LOCAL 
			union_attr : attribute := typ.union_attr;
			union_type : defined_type := union_attr.domain.handled;
			union_attributes : LIST OF attribute := inherited_explicit_attributes ( union_type );
			found : LIST OF attribute := [ ];
		END_LOCAL;

		REPEAT no := LOINDEX ( union_attributes ) TO HIINDEX ( union_attributes );
			ALIAS curr FOR union_attributes [ no];
				ALIAS handled FOR curr.domain.handled;
					found := found + inherited_explicit_attributes ( handled );
				END_ALIAS;
			END_ALIAS;
		END_REPEAT;
		RETURN ( found );
	END_FUNCTION;

	FUNCTION discriminated_type_xml_end_element_code ( typ : discriminated_type ) : STRING;
		RETURN ( '\nprocedure End_Element(\n' 
			+ '\tHandler : in out Xml_generic_parser;\n' 
			+ '\tobj : in out ' + typ.name + '_io;\n' 
			+ '\tNamespace_Uri : Unicode.CES.Byte_Sequence := "";\n' 
			+ '\tLocal_Name    : Unicode.CES.Byte_Sequence := "";\n' 
			+ '\tQname : Unicode.CES.Byte_Sequence := "") is \nbegin\n' 
			+ discriminated_type_attributes_xml_end_element_code ( typ ) + '\nend End_Element;\n' );
	END_FUNCTION;

	FUNCTION discriminated_type_xml_start_element_code ( typ : discriminated_type ) : STRING;
		LOCAL 
			code : STRING := discriminated_type_attributes_xml_start_element_code ( typ );
		END_LOCAL;

		IF ( code > '' ) THEN
			code := '\nprocedure Start_Element(\n' 
			+ '\tHandler: in out Xml_Generic_Parser;\n' 
			+ '\tobj : in out ' + typ.name + '_io;\n' 
			+ '\tNamespace_Uri : Unicode.CES.Byte_Sequence := "";\n' 
			+ '\tLocal_Name : Unicode.CES.Byte_Sequence := "";\n' 
			+ '\tQname : Unicode.CES.Byte_Sequence := "";\n' 
			+ '\tAtts : Sax.Attributes.Attributes''Class) is \nbegin\n' 
			+ '\tif Get_Length (Atts) > 0 then' + code + '\n' 
			+ '\tend if;\n' 
			+ 'end Start_Element;\n';
		END_IF;
		RETURN ( code );
	END_FUNCTION;

	FUNCTION discriminated_type_attributes_xml_end_element_code ( typ : discriminated_type ) : STRING;
		LOCAL 
			code : STRING := '';
			s : STRING;
			discrim_attr : attribute := typ.discriminant;
			attrs : LIST OF attribute := typ.tail_attributes + typ.translated_attributes;
		END_LOCAL;
		code := code + explicit_attribute_xml_end_element_code ( discrim_attr ) + '\n';

		REPEAT no := LOINDEX ( attrs ) TO HIINDEX ( attrs );
			ALIAS attr FOR attrs [ no];
				s := explicit_attribute_xml_end_element_code ( attr );
				IF ( s > '' ) THEN
					code := code + '\n' 
					+ s;
				END_IF;
			END_ALIAS;
		END_REPEAT;

		IF ( code = '' ) THEN
			code := '\tnull;\n';
		END_IF;
		RETURN ( code );
	END_FUNCTION;

	FUNCTION discriminated_type_attributes_xml_start_element_code ( typ : discriminated_type ) : STRING;
		LOCAL 
			code : STRING := '';
			s : STRING;
			discrim_attr : attribute := typ.discriminant;
			attrs : LIST OF attribute := typ.tail_attributes + typ.translated_attributes;
		END_LOCAL;
		code := explicit_attribute_xml_start_element_code ( discrim_attr );

		REPEAT no := LOINDEX ( attrs ) TO HIINDEX ( attrs );
			ALIAS attr FOR attrs [ no];
				s := explicit_attribute_xml_start_element_code ( attr );
				IF ( s > '' ) THEN
					code := code + '\n' 
					+ s;
				END_IF;
			END_ALIAS;
		END_REPEAT;
		RETURN ( code );
	END_FUNCTION;

	FUNCTION discriminated_type_attributes_xml_io_record_initialize_code ( typ : discriminated_type ) : STRING;
		LOCAL 
			code : STRING := '';
			s : STRING;
			discrim_attr : attribute := typ.discriminant;
			attrs : LIST OF attribute := typ.tail_attributes + typ.translated_attributes;
		END_LOCAL;
		code := code + explicit_attribute_xml_io_record_initialize_code ( discrim_attr ) + '\n';

		REPEAT no := LOINDEX ( attrs ) TO HIINDEX ( attrs );
			ALIAS attr FOR attrs [ no];
				s := explicit_attribute_xml_io_record_initialize_code ( attr );
				IF ( s > '' ) THEN
					code := code + '\n' 
					+ s;
				END_IF;
			END_ALIAS;
		END_REPEAT;
		RETURN ( code );
	END_FUNCTION;

	FUNCTION discriminated_type_xml_io_record_initialize_code ( typ : discriminated_type ) : STRING;
		RETURN ( '\nprocedure Initialize(obj : out ' + typ.name + '_io) is \nbegin ' + discriminated_type_attributes_xml_io_record_initialize_code ( typ ) + '\nend Initialize;\n' );
	END_FUNCTION;
END_SCHEMA;

</ISO10303-11-EXPRESS>!

!ExChdDiscriminatedTypeSchemaDefinition class methodsFor: 'platypus-generated-platypus-signature' stamp: ''!
iso10303P11Translater
	^ 'Platypus (c) LISYC EA3883, Universite de Bretagne occidentale. Brest.'

! !

!ExChdDiscriminatedTypeSchemaDefinition class methodsFor: 'platypus-generated-platypus-signature' stamp: ''!
translatedFromISO10303P11
	^ true

! !

!ExChdDiscriminatedTypeSchemaDefinition class methodsFor: 'platypus-generated-platypus-signature' stamp: ''!
vwNamespaceName
	^ #Express2Cheddar

! !

!ExChdDiscriminatedTypeSchemaDefinition methodsFor: 'platypus-generated-context-accessing' stamp: ''!
context
	^ self schemaInstance context

! !

!ExChdDiscriminatedTypeSchemaDefinition methodsFor: 'platypus-generated-entities' stamp: ''!
entityDefinition1
	^ #(#discriminated_type #ExChdDiscriminatedType)

! !

!ExChdDiscriminatedTypeSchemaDefinition methodsFor: 'platypus-generated-entities' stamp: ''!
entityDefinition2
	^ #(#discriminated_type_discriminant #ExChdDiscriminatedTypeDiscriminant)

! !

!ExChdDiscriminatedTypeSchemaDefinition methodsFor: 'platypus-generated-entities' stamp: ''!
entityDefinition3
	^ #(#discriminated_type_union #ExChdDiscriminatedTypeUnion)

! !

!ExChdDiscriminatedTypeSchemaDefinition methodsFor: 'platypus-generated-entities' stamp: ''!
entityDefinition4
	^ #(#discriminated_type_union_element_type #ExChdDiscriminatedTypeUnionElementType)

! !

!ExChdDiscriminatedTypeSchemaDefinition methodsFor: 'platypus-generated-entities' stamp: ''!
entityDefinition5
	^ #(#discriminated_type_union_type #ExChdDiscriminatedTypeUnionType)

! !

!ExChdDiscriminatedTypeSchemaDefinition methodsFor: 'platypus-generated-entities' stamp: ''!
entityDefinitionCount
	^ 5

! !

!ExChdDiscriminatedTypeSchemaDefinition methodsFor: 'platypus-generated-functions' stamp: ''!
functionDeclaration1
	^ #(#discriminated_type_attributes #ExChdDiscriminatedTypeAttributesFunction)

! !

!ExChdDiscriminatedTypeSchemaDefinition methodsFor: 'platypus-generated-functions' stamp: ''!
functionDeclaration10
	^ #(#discriminated_type_xml_end_element_code #ExChdDiscriminatedTypeXmlEndElementCodeFunction)

! !

!ExChdDiscriminatedTypeSchemaDefinition methodsFor: 'platypus-generated-functions' stamp: ''!
functionDeclaration11
	^ #(#discriminated_type_xml_start_element_code #ExChdDiscriminatedTypeXmlStartElementCodeFunction)

! !

!ExChdDiscriminatedTypeSchemaDefinition methodsFor: 'platypus-generated-functions' stamp: ''!
functionDeclaration12
	^ #(#discriminated_type_attributes_xml_end_element_code #ExChdDiscriminatedTypeAttributesXmlEndElementCodeFunction)

! !

!ExChdDiscriminatedTypeSchemaDefinition methodsFor: 'platypus-generated-functions' stamp: ''!
functionDeclaration13
	^ #(#discriminated_type_attributes_xml_start_element_code #ExChdDiscriminatedTypeAttributesXmlStartElementCodeFunction)

! !

!ExChdDiscriminatedTypeSchemaDefinition methodsFor: 'platypus-generated-functions' stamp: ''!
functionDeclaration14
	^ #(#discriminated_type_attributes_xml_io_record_initialize_code #ExChdDiscriminatedTypeAttributesXmlIoRecordInitializeCodeFunction)

! !

!ExChdDiscriminatedTypeSchemaDefinition methodsFor: 'platypus-generated-functions' stamp: ''!
functionDeclaration15
	^ #(#discriminated_type_xml_io_record_initialize_code #ExChdDiscriminatedTypeXmlIoRecordInitializeCodeFunction)

! !

!ExChdDiscriminatedTypeSchemaDefinition methodsFor: 'platypus-generated-functions' stamp: ''!
functionDeclaration2
	^ #(#discriminated_type_interfaces_list #ExChdDiscriminatedTypeInterfacesListFunction)

! !

!ExChdDiscriminatedTypeSchemaDefinition methodsFor: 'platypus-generated-functions' stamp: ''!
functionDeclaration3
	^ #(#discriminated_type_union_type_interfaces_list #ExChdDiscriminatedTypeUnionTypeInterfacesListFunction)

! !

!ExChdDiscriminatedTypeSchemaDefinition methodsFor: 'platypus-generated-functions' stamp: ''!
functionDeclaration4
	^ #(#discriminated_type_adb_code #ExChdDiscriminatedTypeAdbCodeFunction)

! !

!ExChdDiscriminatedTypeSchemaDefinition methodsFor: 'platypus-generated-functions' stamp: ''!
functionDeclaration5
	^ #(#discriminated_type_ads_code #ExChdDiscriminatedTypeAdsCodeFunction)

! !

!ExChdDiscriminatedTypeSchemaDefinition methodsFor: 'platypus-generated-functions' stamp: ''!
functionDeclaration6
	^ #(#discriminated_type_union_case_code #ExChdDiscriminatedTypeUnionCaseCodeFunction)

! !

!ExChdDiscriminatedTypeSchemaDefinition methodsFor: 'platypus-generated-functions' stamp: ''!
functionDeclaration7
	^ #(#discriminated_type_union_element_case_code #ExChdDiscriminatedTypeUnionElementCaseCodeFunction)

! !

!ExChdDiscriminatedTypeSchemaDefinition methodsFor: 'platypus-generated-functions' stamp: ''!
functionDeclaration8
	^ #(#discriminated_type_xml_io_record_code #ExChdDiscriminatedTypeXmlIoRecordCodeFunction)

! !

!ExChdDiscriminatedTypeSchemaDefinition methodsFor: 'platypus-generated-functions' stamp: ''!
functionDeclaration9
	^ #(#discriminated_type_tails_attributes #ExChdDiscriminatedTypeTailsAttributesFunction)

! !

!ExChdDiscriminatedTypeSchemaDefinition methodsFor: 'platypus-generated-functions' stamp: ''!
functionDeclarationCount
	^ 15

! !

!ExChdDiscriminatedTypeSchemaDefinition methodsFor: 'platypus-generated-meta-data-accessing' stamp: ''!
schemaInstanceClassName
	^ #ExChdExpress2cheddarSchemaInstance

! !

PlatypusCoreSchema subclass: #ExChdExpress2cheddarFacadeSchemaDefinition
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Express2Cheddar-Express2cheddarFacadeSchema'!

!ExChdExpress2cheddarFacadeSchemaDefinition commentStamp: 'platypus comment' prior: 0!
<ISO10303-11-EXPRESS>
SCHEMA express2cheddar_facade;
	USE FROM Package;
	USE FROM record_and_class;
	USE FROM discriminated_type;
	USE FROM platypus_dictionary_schema;
	USE FROM express_toolsbox_functions;
	USE FROM express_dictionary_queries;
	USE FROM cheddar_domains;
	USE FROM cheddar_dtd;

	CONSTANT 
		source_licence : STRING := '' + '------------------------------------------------------------------------------\n' 
		+ '------------------------------------------------------------------------------\n' 
		+ '--  This source file was automatically generated by Platypus\n' 
		+ '--  see http://dossen.univ-brest.fr/apl\n' 
		+ '-- \n' 
		+ '--  Any modification of this file will be lost. \n' 
		+ '--  Please see the "platypus" directory instead : it contains the Cheddar''s\n' 
		+ '--  model and its meta-model. \n' 
		+ '------------------------------------------------------------------------------\n \n' 
		+ '------------------------------------------------------------------------------\n' 
		+ '-- Cheddar is a free real time scheduling tool.\n' 
		+ '-- This program provides services to automatically check temporal constraints\n' 
		+ '-- of real time tasks.\n' 
		+ '--\n' 
		+ '-- Copyright (C) 2002-2014   Frank Singhoff\n' 
		+ '-- Cheddar is developed by the LAB-STICC Team, University of Brest\n' 
		+ '--\n' 
		+ '-- This program is free software; you can redistribute it and/or modify\n' 
		+ '-- it under the terms of the GNU General Public License as published by\n' 
		+ '-- the Free Software Foundation; either version 2 of the License, or\n' 
		+ '-- (at your option) any later version.\n' 
		+ '--\n' 
		+ '-- This program is distributed in the hope that it will be useful,\n' 
		+ '-- but WITHOUT ANY WARRANTY; without even the implied warranty of\n' 
		+ '-- MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the\n' 
		+ '-- GNU General Public License for more details.\n' 
		+ '--\n' 
		+ '-- You should have received a copy of the GNU General Public License\n' 
		+ '-- along with this program; if not, write to the Free Software\n' 
		+ '-- Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA\n' 
		+ '--\n' 
		+ '--\n' 
		+ '-- Contact : cheddar@listes.univ-brest.fr\n' 
		+ '-- 	To post to this mailing list, you must be subscribed\n' 
		+ '-- 	(see http//beru.univ-brest.fr/~singhoff/cheddar for details)\n' 
		+ '--\n' 
		+ '------------------------------------------------------------------------------\n' 
		+ '------------------------------------------------------------------------------\n';
		xml_id_name : STRING := 'cheddar_private_id';
	END_CONSTANT;

	FUNCTION is_of_generated_concept_kind ( c : dictionary_instance ) : BOOLEAN;
		RETURN ( ( 'CHEDDAR_DOMAINS.ADA_TYPE' IN TYPEOF ( c ) ) OR ( 'RECORD_AND_CLASS.ADA_ENTITY' IN TYPEOF ( c ) ) OR ( 'PACKAGE.PACKAGE_ALIAS' IN TYPEOF ( c ) ) OR ( 'RECORD_AND_CLASS.CHEDDAR_FUNCTION_PTR' IN TYPEOF ( c ) ) );
	END_FUNCTION;

	FUNCTION all_ada_packages : SET OF ada_package;
		LOCAL 
			insts : SET OF GENERIC := allModelInstances ( );
		END_LOCAL;
		RETURN ( QUERY ( i <* insts | 'PACKAGE.ADA_PACKAGE' IN TYPEOF ( i ) ) );
	END_FUNCTION;

	FUNCTION ada_package_named ( name : STRING ) : ada_package;
		LOCAL 
			packages : SET OF ada_package := all_ada_packages ( );
			key : STRING := Lowerize ( name );
		END_LOCAL;

		REPEAT no := LOINDEX ( packages ) TO HIINDEX ( packages );
			ALIAS curr FOR packages [ no];
				IF ( Lowerize ( curr.name ) = key ) THEN
					RETURN ( curr );
				END_IF;
			END_ALIAS;
		END_REPEAT;
		RETURN ( ? );
	END_FUNCTION;

	FUNCTION package_ada_classes ( pkg : ada_package ) : LIST OF ada_class;
		LOCAL 
			cls_list : LIST OF ada_class := [ ];
		END_LOCAL;

		ALIAS entities FOR pkg.entities;
			REPEAT noi := LOINDEX ( entities ) TO HIINDEX ( entities );
				IF ( 'RECORD_AND_CLASS.ADA_CLASS' IN TYPEOF ( entities [ noi] ) ) THEN
					cls_list := cls_list + entities [ noi];
				END_IF;
			END_REPEAT;
		END_ALIAS;
		RETURN ( cls_list );
	END_FUNCTION;

	FUNCTION all_ada_classes : LIST OF ada_entity;
		LOCAL 
			cls_list : LIST OF ada_class := [ ];
			all_pkgs : LIST OF ada_package := SetToList ( all_ada_packages ( ) );
		END_LOCAL;

		REPEAT no := LOINDEX ( all_pkgs ) TO HIINDEX ( all_pkgs );
			cls_list := cls_list + package_ada_classes ( all_pkgs [ no] );
		END_REPEAT;
		RETURN ( cls_list );
	END_FUNCTION;

	PROCEDURE prepare_root_ada_classes;
		LOCAL 
			clslist : LIST OF ada_class := all_ada_classes ( );
		END_LOCAL;

		REPEAT no := LOINDEX ( clslist ) TO HIINDEX ( clslist );
			ALIAS curr FOR clslist [ no];
				IF SIZEOF ( curr.supertypes ) = 0 THEN
					IF NOT has_attribute_named ( curr, xml_id_name ) THEN
						add_xml_id_to_ada_class ( curr );
					END_IF;
				END_IF;
			END_ALIAS;
		END_REPEAT;
	END_PROCEDURE;

	FUNCTION all_ada_records : LIST OF ada_entity;
		LOCAL 
			cls_list : LIST OF ada_class := [ ];
			all_pkgs : LIST OF ada_package := SetToList ( all_ada_packages ( ) );
		END_LOCAL;

		REPEAT no := LOINDEX ( all_pkgs ) TO HIINDEX ( all_pkgs );
			ALIAS entities FOR all_pkgs [ no].entities;
				REPEAT noi := LOINDEX ( entities ) TO HIINDEX ( entities );
					IF ( 'RECORD_AND_CLASS.RECORD' IN TYPEOF ( entities [ noi] ) ) THEN
						cls_list := cls_list + entities [ noi];
					END_IF;
				END_REPEAT;
			END_ALIAS;
		END_REPEAT;
		RETURN ( cls_list );
	END_FUNCTION;

	FUNCTION all_ada_discriminated_types : LIST OF ada_entity;
		LOCAL 
			dt_list : LIST OF discriminated_type := [ ];
			all_pkgs : LIST OF ada_package := SetToList ( all_ada_packages ( ) );
		END_LOCAL;

		REPEAT no := LOINDEX ( all_pkgs ) TO HIINDEX ( all_pkgs );
			ALIAS entities FOR all_pkgs [ no].entities;
				REPEAT noi := LOINDEX ( entities ) TO HIINDEX ( entities );
					IF ( 'DISCRIMINATED_TYPE.DISCRIMINATED_TYPE' IN TYPEOF ( entities [ noi] ) ) THEN
						dt_list := dt_list + entities [ noi];
					END_IF;
				END_REPEAT;
			END_ALIAS;
		END_REPEAT;
		RETURN ( dt_list );
	END_FUNCTION;

	PROCEDURE add_xml_id_to_ada_class ( VAR cls : ada_class );
		LOCAL 
			idtype : cheddar_xml_id_type := entity_instance ( ? ) || sdai_instance ( ) || dictionary_instance ( ) || simple_type ( ) || string_type ( ?, false ) || cheddar_xml_id_type ( );
			idattr : explicit_attribute := entity_instance ( cls ) || sdai_instance ( ) || dictionary_instance ( ) || attribute ( xml_id_name, cls, idtype, ? ) || explicit_attribute ( false );
		END_LOCAL;
		idtype.owner := idattr;
		INSERT ( cls.attributes, idattr, 0 );
	END_PROCEDURE;

	FUNCTION package_records ( pkg : ada_package ) : LIST OF record;
		LOCAL 
			rec_list : LIST OF record := [ ];
		END_LOCAL;

		ALIAS entities FOR pkg.entities;
			REPEAT noi := LOINDEX ( entities ) TO HIINDEX ( entities );
				IF ( 'RECORD_AND_CLASS.RECORD' IN TYPEOF ( entities [ noi] ) ) THEN
					rec_list := rec_list + entities [ noi];
				END_IF;
			END_REPEAT;
		END_ALIAS;
		RETURN ( rec_list );
	END_FUNCTION;

	FUNCTION package_discriminated_types ( pkg : ada_package ) : LIST OF discriminated_type;
		LOCAL 
			dt_list : LIST OF discriminated_type := [ ];
		END_LOCAL;

		ALIAS entities FOR pkg.entities;
			REPEAT noi := LOINDEX ( entities ) TO HIINDEX ( entities );
				IF ( 'DISCRIMINATED_TYPE.DISCRIMINATED_TYPE' IN TYPEOF ( entities [ noi] ) ) THEN
					dt_list := dt_list + entities [ noi];
				END_IF;
			END_REPEAT;
		END_ALIAS;
		RETURN ( dt_list );
	END_FUNCTION;

	FUNCTION ada_entity_named ( name : STRING ) : ada_entity;
		LOCAL 
			entities : LIST OF ada_entity := all_ada_entities ( );
			key : STRING := Lowerize ( name );
		END_LOCAL;

		REPEAT no := LOINDEX ( entities ) TO HIINDEX ( entities );
			ALIAS curr FOR entities [ no];
				IF ( Lowerize ( curr.name ) = key ) THEN
					RETURN ( curr );
				END_IF;
			END_ALIAS;
		END_REPEAT;
		RETURN ( ? );
	END_FUNCTION;

	FUNCTION all_ada_entities : LIST OF ada_entity;
		LOCAL 
			ent_list : LIST OF ada_entity := [ ];
			all_pkgs : LIST OF ada_package := SetToList ( all_ada_packages ( ) );
		END_LOCAL;

		REPEAT no := LOINDEX ( all_pkgs ) TO HIINDEX ( all_pkgs );
			ALIAS entities FOR all_pkgs [ no].entities;
				REPEAT noi := LOINDEX ( entities ) TO HIINDEX ( entities );
					IF ( 'RECORD_AND_CLASS.RECORD' IN TYPEOF ( entities [ noi] ) ) THEN
						ent_list := ent_list + entities [ noi];
					END_IF;
					IF ( 'RECORD_AND_CLASS.ADA_CLASS' IN TYPEOF ( entities [ noi] ) ) THEN
						ent_list := ent_list + entities [ noi];
					END_IF;
					IF ( 'DISCRIMINATED_TYPE.DISCRIMINATED_TYPE' IN TYPEOF ( entities [ noi] ) ) THEN
						ent_list := ent_list + entities [ noi];
					END_IF;
				END_REPEAT;
			END_ALIAS;
		END_REPEAT;
		RETURN ( ent_list );
	END_FUNCTION;

	PROCEDURE dtds_Into ( dir : STRING );
		LOCAL 
			roots : LIST OF root_dtd_element := root_dtds ( );
			path : STRING;
		END_LOCAL;
		(*#  MultiByteFileStream defaultToLF  #*) prepare_root_ada_classes;

		IF EXISTS ( dir ) THEN
			path := dir;
		ELSE
			path := '.';
		END_IF;

		REPEAT no := LOINDEX ( roots ) TO HIINDEX ( roots );
			ALIAS curr FOR roots [ no];
				WriteFile ( path + '/' + curr.tag + '.dtd', curr.dtd_code );
			END_ALIAS;
		END_REPEAT;
	END_PROCEDURE;

	PROCEDURE generate_all_into ( dir : STRING );
		(*#  MultiByteFileStream defaultToLF  #*) prepare_root_ada_classes;
		all_packages_code_into ( true, dir, 'Platypus2Cheddar' );
		all_packages_code_into ( false, dir, 'Platypus2Cheddar' );
		dtds_into ( dir );
	END_PROCEDURE;
END_SCHEMA;

</ISO10303-11-EXPRESS>!

!ExChdExpress2cheddarFacadeSchemaDefinition class methodsFor: 'platypus-generated-platypus-signature' stamp: ''!
iso10303P11Translater
	^ 'Platypus (c) LISYC EA3883, Universite de Bretagne occidentale. Brest.'

! !

!ExChdExpress2cheddarFacadeSchemaDefinition class methodsFor: 'platypus-generated-platypus-signature' stamp: ''!
translatedFromISO10303P11
	^ true

! !

!ExChdExpress2cheddarFacadeSchemaDefinition class methodsFor: 'platypus-generated-platypus-signature' stamp: ''!
vwNamespaceName
	^ #Express2Cheddar

! !

!ExChdExpress2cheddarFacadeSchemaDefinition methodsFor: 'platypus-generated-context-accessing' stamp: ''!
context
	^ self schemaInstance context

! !

!ExChdExpress2cheddarFacadeSchemaDefinition methodsFor: 'platypus-generated-entities' stamp: ''!
entityDefinitionCount
	^ 0

! !

!ExChdExpress2cheddarFacadeSchemaDefinition methodsFor: 'platypus-generated-functions' stamp: ''!
functionDeclaration1
	^ #(#is_of_generated_concept_kind #ExChdIsOfGeneratedConceptKindFunction)

! !

!ExChdExpress2cheddarFacadeSchemaDefinition methodsFor: 'platypus-generated-functions' stamp: ''!
functionDeclaration10
	^ #(#ada_entity_named #ExChdAdaEntityNamedFunction)

! !

!ExChdExpress2cheddarFacadeSchemaDefinition methodsFor: 'platypus-generated-functions' stamp: ''!
functionDeclaration11
	^ #(#all_ada_entities #ExChdAllAdaEntitiesFunction)

! !

!ExChdExpress2cheddarFacadeSchemaDefinition methodsFor: 'platypus-generated-functions' stamp: ''!
functionDeclaration2
	^ #(#all_ada_packages #ExChdAllAdaPackagesFunction)

! !

!ExChdExpress2cheddarFacadeSchemaDefinition methodsFor: 'platypus-generated-functions' stamp: ''!
functionDeclaration3
	^ #(#ada_package_named #ExChdAdaPackageNamedFunction)

! !

!ExChdExpress2cheddarFacadeSchemaDefinition methodsFor: 'platypus-generated-functions' stamp: ''!
functionDeclaration4
	^ #(#package_ada_classes #ExChdPackageAdaClassesFunction)

! !

!ExChdExpress2cheddarFacadeSchemaDefinition methodsFor: 'platypus-generated-functions' stamp: ''!
functionDeclaration5
	^ #(#all_ada_classes #ExChdAllAdaClassesFunction)

! !

!ExChdExpress2cheddarFacadeSchemaDefinition methodsFor: 'platypus-generated-functions' stamp: ''!
functionDeclaration6
	^ #(#all_ada_records #ExChdAllAdaRecordsFunction)

! !

!ExChdExpress2cheddarFacadeSchemaDefinition methodsFor: 'platypus-generated-functions' stamp: ''!
functionDeclaration7
	^ #(#all_ada_discriminated_types #ExChdAllAdaDiscriminatedTypesFunction)

! !

!ExChdExpress2cheddarFacadeSchemaDefinition methodsFor: 'platypus-generated-functions' stamp: ''!
functionDeclaration8
	^ #(#package_records #ExChdPackageRecordsFunction)

! !

!ExChdExpress2cheddarFacadeSchemaDefinition methodsFor: 'platypus-generated-functions' stamp: ''!
functionDeclaration9
	^ #(#package_discriminated_types #ExChdPackageDiscriminatedTypesFunction)

! !

!ExChdExpress2cheddarFacadeSchemaDefinition methodsFor: 'platypus-generated-functions' stamp: ''!
functionDeclarationCount
	^ 11

! !

!ExChdExpress2cheddarFacadeSchemaDefinition methodsFor: 'platypus-generated-meta-data-accessing' stamp: ''!
schemaInstanceClassName
	^ #ExChdExpress2cheddarSchemaInstance

! !

PlatypusCoreSchema subclass: #ExChdPackageSchemaDefinition
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Express2Cheddar-PackageSchema'!

!ExChdPackageSchemaDefinition commentStamp: 'platypus comment' prior: 0!
<ISO10303-11-EXPRESS>
SCHEMA package;
	USE FROM platypus_dictionary_schema;
	USE FROM express_toolsbox_functions;
	USE FROM express_dictionary_queries;
	USE FROM express2cheddar_facade;
	USE FROM record_and_class;
	USE FROM cheddar_domains;
	USE FROM ada_interface;
	USE FROM cheddar_constants;
	USE FROM xml_io;

	ENTITY ada_package 
		SUBTYPE OF ( schema_definition );
		ads_interface : LIST OF ada_interface;
		adb_interface : LIST OF ada_interface;
		xml_root_tags : LIST OF STRING;
	DERIVE
		infered_ads_interfaces : LIST OF ada_interface := ada_package_interface ( SELF, true );
		ads_head : STRING := source_licence + '\n' 
		+ ada_interfaces_code ( SELF, ada_package_interface ( SELF, true ) );
		adb_head : STRING := source_licence + '\n' 
		+ ada_interfaces_code ( SELF, ada_package_interface ( SELF, false ) );
		ads_code : STRING := ads_head + '\n\nPackage ' + name + ' is \n \n' 
		+ ada_package_ads_code ( SELF ) + '\nEnd ' + name + ';';
		adb_code : STRING := adb_head + '\n\nPackage Body ' + name + ' is \n \n' 
		+ ada_package_adb_code ( SELF ) + '\nEnd ' + name + ';';
	END_ENTITY;

	ENTITY package_alias;
		package_name : STRING;
		attribute_name : STRING;
	DERIVE
		ptr_type : STRING := SELF.name + '_Ptr';
		ads_interfaces_list : LIST OF ada_interface := [ ];
		adb_interfaces_list : LIST OF ada_interface := [ ada_interface ( SELF.owner.name, ?, true, true ) ];
		ads_code : STRING := 'subtype ' + SELF.name + ' is ' + package_name + '.' + attribute_name + ';\n' 
		+ 'subtype ' + SELF.ptr_type + ' is  ' + package_name + '.' + attribute_name + '_Ptr;\n';
		adb_code : STRING := '';
		init_value : STRING := ?;
		dependencies : LIST OF dictionary_instance := [ SELF ];
		ada_ref_ident : STRING := SELF.ptr_type;
		refed_by_pointer : BOOLEAN := true;
	END_ENTITY;

	ENTITY generic_package_instanciation 
		SUBTYPE OF ( ada_entity );
		generic_package_name : STRING;
		parameters : LIST OF STRING;
		interfaces : LIST OF ada_interface;
	DERIVE
		aliases : LIST OF cheddar_defined_type := generic_package_aliases ( SELF );
		ads_interfaces_list : LIST OF ada_interface := [ ada_interface ( SELF.generic_package_name, ?, true, false ), ada_interface ( SELF.owner.name, SELF.name, false, true ), ada_interface ( 'Unchecked_Deallocation', ?, true, false ) ] + interfaces;
		adb_interfaces_list : LIST OF ada_interface := [ ];
		ads_code : STRING := 'package ' + ada_ident + ' is new ' + generic_package_name + '(' + StringAggregateConcatSeparatedBy ( parameters, ', ' ) + ');\n' 
		+ 'use ' + ada_ident + ';\n' 
		+ generic_package_instanciation_attributes_ads_code ( SELF );
		adb_code : STRING := '';
	END_ENTITY;

	FUNCTION ada_package_adb_code ( pkg : ada_package ) : STRING;
		LOCAL 
			result : STRING;
		END_LOCAL;
		result := ada_package_concepts_list_code ( pkg, pkg.types, false ) + ada_package_concepts_list_code ( pkg, pkg.entities, false );
		RETURN ( result );
	END_FUNCTION;

	FUNCTION ada_package_ads_code ( pkg : ada_package ) : STRING;
		LOCAL 
			result : STRING;
			classes : LIST OF ada_class := QUERY ( e <* pkg.entities | 'RECORD_AND_CLASS.ADA_CLASS' IN TYPEOF ( e ) );
			const_list : LIST OF ada_constant := QUERY ( e <* pkg.constants | 'CHEDDAR_CONSTANTS.ADA_CONSTANT' IN TYPEOF ( e ) );
			private_classes : LIST OF ada_class := QUERY ( e <* classes | e.is_private );
			constrained_arrays : LIST OF defined_type;
		END_LOCAL;
		constrained_arrays := QUERY ( t <* pkg.types | 'CHEDDAR_DOMAINS.CONSTRAINED_ARRAY_TYPE' IN TYPEOF ( t ) );
		result := ada_package_concepts_list_code ( pkg, ( ( pkg.types - constrained_arrays ) + pkg.entities ) + constrained_arrays, true );

		REPEAT no := LOINDEX ( const_list ) TO HIINDEX ( const_list );
			result := result + const_list [ no].ads_code + '\n';
		END_REPEAT;

		IF SIZEOF ( private_classes ) > 0 THEN
			result := result + '\n\nprivate\n \n';
			REPEAT no := LOINDEX ( private_classes ) TO HIINDEX ( private_classes );
				ALIAS supref FOR private_classes [ no].supertypes [ 1 ].ref;
					result := result + '\ntype ' + private_classes [ no].name + ' is new ' + supref.ada_ident + ' with\n' 
					+ ada_class_attributes_ads_code ( private_classes [ no] );
				END_ALIAS;
			END_REPEAT;
		END_IF;
		RETURN ( result );
	END_FUNCTION;

	FUNCTION ada_package_interface ( pkg : ada_package; ads : BOOLEAN ) : LIST OF ada_interface;
		LOCAL 
			ads_list : LIST OF ada_interface := [ ada_interface ( 'Ada.Strings.Unbounded', ?, true, true ), ada_interface ( 'Framework_Config', ?, true, true ), ada_interface ( 'id_generators', ?, true, true ) ];
			adb_list : LIST OF ada_interface := [ ada_interface ( 'Text_io', ?, true, true ), ada_interface ( 'unbounded_strings', ?, true, true ) ];
			wul : LIST OF ada_interface;
			result : LIST OF ada_interface := [ ];
			defs : LIST OF dictionary_instance := pkg.entities + pkg.types + pkg.constants;
			pkgKey : STRING := upperize ( pkg.name );
		END_LOCAL;

		REPEAT no := LOINDEX ( pkg.interface ) TO HIINDEX ( pkg.interface );
			ALIAS curr FOR pkg.interface [ no];
				IF ( 'PACKAGE.ADA_PACKAGE' IN TYPEOF ( curr.native_schema ) ) THEN
					ads_list := ads_list + ADA_INTERFACE ( curr.native_schema.name, ?, true, true );
				END_IF;
			END_ALIAS;
		END_REPEAT;

		REPEAT no := LOINDEX ( defs ) TO HIINDEX ( defs );
			ALIAS e FOR defs [ no];
				IF ( 'CHEDDAR_DOMAINS.CHEDDAR_DEFINED_TYPE' IN TYPEOF ( e ) ) THEN
					ads_list := ads_list + e.ads_interfaces_list;
					adb_list := adb_list + e.adb_interfaces_list;
				END_IF;
				IF ( 'CHEDDAR_DOMAINS.EXPLICIT_TYPE_REFERENCE' IN TYPEOF ( e ) ) THEN
					ads_list := ads_list + e.ads_interfaces_list;
					adb_list := adb_list + e.adb_interfaces_list;
				END_IF;
				IF ( 'CHEDDAR_CONSTANTS.ADA_CONSTANT' IN TYPEOF ( e ) ) THEN
					ads_list := ads_list + e.ads_interfaces_list;
					adb_list := adb_list + e.adb_interfaces_list;
				END_IF;
				IF ( 'RECORD_AND_CLASS.ADA_ENTITY' IN TYPEOF ( e ) ) THEN
					ads_list := ads_list + e.ads_interfaces_list;
					adb_list := adb_list + e.adb_interfaces_list;
				END_IF;
				IF ( 'CHEDDAR_DOMAINS.ADA_ENUMERATION' IN TYPEOF ( e ) ) THEN
					ads_list := ads_list + e.ads_interfaces_list;
					adb_list := adb_list + e.adb_interfaces_list;
				END_IF;
				IF ( 'CHEDDAR_DOMAINS.CONSTRAINED_ARRAY_TYPE' IN TYPEOF ( e ) ) THEN
					ads_list := ads_list + e.ads_interfaces_list;
					adb_list := adb_list + e.adb_interfaces_list;
				END_IF;
				IF ( 'PACKAGE.GENERIC_PACKAGE_INSTANCIATION' IN TYPEOF ( e ) ) THEN
					ads_list := ads_list + e.ads_interfaces_list;
					adb_list := adb_list + e.adb_interfaces_list;
				END_IF;
			END_ALIAS;
		END_REPEAT;

		IF ads THEN
			wul := ads_list + pkg.ads_interface;
		ELSE
			wul := adb_list + pkg.adb_interface;
		END_IF;

		REPEAT no := LOINDEX ( wul ) TO HIINDEX ( wul );
			ALIAS curr FOR wul [ no];
				IF ( upperize ( curr.prefix ) <> pkgKey ) THEN
					result := result + curr;
				END_IF;
			END_ALIAS;
		END_REPEAT;
		RETURN ( result );
	END_FUNCTION;

	FUNCTION all_packages_code ( ads : BOOLEAN ) : STRING;
		RETURN ( all_packages_code_into ( ads, ?, ? ) );
	END_FUNCTION;

	FUNCTION concept_in_list ( c : dictionary_instance; l : LIST OF dictionary_instance ) : BOOLEAN;
		LOCAL 
			key : STRING := upperize ( c.name );
		END_LOCAL;

		REPEAT no := LOINDEX ( l ) TO HIINDEX ( l );
			IF ( upperize ( l [ no].name ) = key ) THEN
				RETURN ( true );
			END_IF;
		END_REPEAT;
		RETURN ( false );
	END_FUNCTION;

	FUNCTION concept_list_local_dependencies ( sch : schema_definition; l : LIST OF dictionary_instance ) : LIST OF dictionary_instance;
		LOCAL 
			wl : LIST OF dictionary_instance := [ ];
			r : LIST OF dictionary_instance := [ ];
		END_LOCAL;

		REPEAT no := LOINDEX ( l ) TO HIINDEX ( l );
			ALIAS c FOR l [ no];
				IF is_of_generated_concept_kind ( c ) THEN
					wl := c.dependencies;
					REPEAT noi := LOINDEX ( wl ) TO HIINDEX ( wl );
						IF NOT concept_in_list ( wl [ noi], r ) THEN
							r := r + wl [ noi];
						END_IF;
					END_REPEAT;
				END_IF;
			END_ALIAS;
		END_REPEAT;
		RETURN ( r );
	END_FUNCTION;

	FUNCTION ada_package_concepts_list_code ( p : ada_package; concepts : LIST OF dictionary_instance; ads : BOOLEAN ) : STRING;
		LOCAL 
			result : STRING := '';
			code : STRING := '';
			contents : LIST OF dictionary_instance := [ ];
		END_LOCAL;

		IF ads THEN
			contents := concepts;
		ELSE
			contents := concepts;
		END_IF;

		REPEAT no := LOINDEX ( contents ) TO HIINDEX ( contents );
			ALIAS c FOR contents [ no];
				IF is_of_generated_concept_kind ( c ) THEN
					IF ads THEN
						code := c.ads_code;
					ELSE
						code := c.adb_code;
					END_IF;
					result := result + code;
					IF ( code > '' ) THEN
						result := result + '\n';
					END_IF;
				END_IF;
			END_ALIAS;
		END_REPEAT;
		RETURN ( result );
	END_FUNCTION;

	FUNCTION ada_package_class_typeof_list ( pkg : ada_package ) : STRING;
		LOCAL 
			result : STRING := '';
			classes : LIST OF ada_class := QUERY ( e <* pkg.entities | 'RECORD_AND_CLASS.ADA_CLASS' IN TYPEOF ( e ) );
		END_LOCAL;

		REPEAT no := LOINDEX ( classes ) TO HIINDEX ( classes );
			ALIAS curr FOR classes [ no];
				result := result + curr.name + '(';
				result := result + StringAggregateConcatSeparatedBy ( TYPEOF ( curr ), ',' );
				result := result + ')\n';
			END_ALIAS;
		END_REPEAT;
		RETURN ( result );
	END_FUNCTION;

	FUNCTION generic_package_aliases ( e : generic_package_instanciation ) : LIST OF cheddar_defined_type;
		LOCAL 
			aliases : LIST OF entity_instance := [ ];
			attrname : STRING;
		END_LOCAL;

		REPEAT no := LOINDEX ( e.attributes ) TO HIINDEX ( e.attributes );
			ALIAS attr FOR e.attributes [ no];
				ALIAS an FOR attr.name;
					IF ( an [ LENGTH ( an ) ] = '_' ) THEN
						attrname := an [ 1 : LENGTH ( an ) - 1 ];
					ELSE
						attrname := an;
					END_IF;
				END_ALIAS;
				aliases := aliases + ( ada_type ( ) || attr.domain || package_alias ( e.name, attrname ) );
			END_ALIAS;
		END_REPEAT;
		RETURN ( aliases );
	END_FUNCTION;

	FUNCTION generic_package_instanciation_attributes_ads_code ( e : generic_package_instanciation ) : STRING;
		LOCAL 
			result : STRING := '';
			aliases : LIST OF cheddar_defined_type := e.aliases;
		END_LOCAL;

		REPEAT no := LOINDEX ( aliases ) TO HIINDEX ( aliases );
			ALIAS attr FOR e.aliases [ no];
				result := result + attr.ads_code;
			END_ALIAS;
		END_REPEAT;
		RETURN ( result );
	END_FUNCTION;

	FUNCTION all_packages_code_into ( ads : BOOLEAN; dir : STRING; targetName : STRING ) : STRING;
		LOCAL 
			code : STRING := '';
			body : STRING;
			pkgs : LIST OF ada_package := SetToList ( all_ada_packages ( ) );
			targetPath : STRING;
		END_LOCAL;

		REPEAT no := LOINDEX ( pkgs ) TO HIINDEX ( pkgs );
			IF ads THEN
				body := pkgs [ no].ads_code;
			ELSE
				body := pkgs [ no].adb_code;
			END_IF;
			IF ( body > '' ) THEN
				code := code + body + '\n\n';
			END_IF;
		END_REPEAT;

		IF ads THEN
			code := code + xml_architecture_io_ads_package_code ( );
		ELSE
			code := code + xml_architecture_io_adb_package_code ( );
		END_IF;

		IF EXISTS ( dir ) THEN
			targetPath := dir;
		ELSE
			targetPath := '.';
		END_IF;

		IF EXISTS ( targetName ) THEN
			targetPath := targetPath + '/' + targetName;
		ELSE
			targetPath := targetPath + '/' + 'Platypus2Cheddar';
		END_IF;

		IF ads THEN
			WriteFile ( targetPath + '.ads', code );
		ELSE
			WriteFile ( targetPath + '.adb', code );
		END_IF;
		RETURN ( code );
	END_FUNCTION;
END_SCHEMA;

</ISO10303-11-EXPRESS>!

!ExChdPackageSchemaDefinition class methodsFor: 'platypus-generated-platypus-signature' stamp: ''!
iso10303P11Translater
	^ 'Platypus (c) LISYC EA3883, Universite de Bretagne occidentale. Brest.'

! !

!ExChdPackageSchemaDefinition class methodsFor: 'platypus-generated-platypus-signature' stamp: ''!
translatedFromISO10303P11
	^ true

! !

!ExChdPackageSchemaDefinition class methodsFor: 'platypus-generated-platypus-signature' stamp: ''!
vwNamespaceName
	^ #Express2Cheddar

! !

!ExChdPackageSchemaDefinition methodsFor: 'platypus-generated-context-accessing' stamp: ''!
context
	^ self schemaInstance context

! !

!ExChdPackageSchemaDefinition methodsFor: 'platypus-generated-entities' stamp: ''!
entityDefinition1
	^ #(#ada_package #ExChdAdaPackage)

! !

!ExChdPackageSchemaDefinition methodsFor: 'platypus-generated-entities' stamp: ''!
entityDefinition2
	^ #(#package_alias #ExChdPackageAlias)

! !

!ExChdPackageSchemaDefinition methodsFor: 'platypus-generated-entities' stamp: ''!
entityDefinition3
	^ #(#generic_package_instanciation #ExChdGenericPackageInstanciation)

! !

!ExChdPackageSchemaDefinition methodsFor: 'platypus-generated-entities' stamp: ''!
entityDefinitionCount
	^ 3

! !

!ExChdPackageSchemaDefinition methodsFor: 'platypus-generated-functions' stamp: ''!
functionDeclaration1
	^ #(#ada_package_adb_code #ExChdAdaPackageAdbCodeFunction)

! !

!ExChdPackageSchemaDefinition methodsFor: 'platypus-generated-functions' stamp: ''!
functionDeclaration10
	^ #(#generic_package_instanciation_attributes_ads_code #ExChdGenericPackageInstanciationAttributesAdsCodeFunction)

! !

!ExChdPackageSchemaDefinition methodsFor: 'platypus-generated-functions' stamp: ''!
functionDeclaration11
	^ #(#all_packages_code_into #ExChdAllPackagesCodeIntoFunction)

! !

!ExChdPackageSchemaDefinition methodsFor: 'platypus-generated-functions' stamp: ''!
functionDeclaration2
	^ #(#ada_package_ads_code #ExChdAdaPackageAdsCodeFunction)

! !

!ExChdPackageSchemaDefinition methodsFor: 'platypus-generated-functions' stamp: ''!
functionDeclaration3
	^ #(#ada_package_interface #ExChdAdaPackageInterfaceFunction)

! !

!ExChdPackageSchemaDefinition methodsFor: 'platypus-generated-functions' stamp: ''!
functionDeclaration4
	^ #(#all_packages_code #ExChdAllPackagesCodeFunction)

! !

!ExChdPackageSchemaDefinition methodsFor: 'platypus-generated-functions' stamp: ''!
functionDeclaration5
	^ #(#concept_in_list #ExChdConceptInListFunction)

! !

!ExChdPackageSchemaDefinition methodsFor: 'platypus-generated-functions' stamp: ''!
functionDeclaration6
	^ #(#concept_list_local_dependencies #ExChdConceptListLocalDependenciesFunction)

! !

!ExChdPackageSchemaDefinition methodsFor: 'platypus-generated-functions' stamp: ''!
functionDeclaration7
	^ #(#ada_package_concepts_list_code #ExChdAdaPackageConceptsListCodeFunction)

! !

!ExChdPackageSchemaDefinition methodsFor: 'platypus-generated-functions' stamp: ''!
functionDeclaration8
	^ #(#ada_package_class_typeof_list #ExChdAdaPackageClassTypeofListFunction)

! !

!ExChdPackageSchemaDefinition methodsFor: 'platypus-generated-functions' stamp: ''!
functionDeclaration9
	^ #(#generic_package_aliases #ExChdGenericPackageAliasesFunction)

! !

!ExChdPackageSchemaDefinition methodsFor: 'platypus-generated-functions' stamp: ''!
functionDeclarationCount
	^ 11

! !

!ExChdPackageSchemaDefinition methodsFor: 'platypus-generated-meta-data-accessing' stamp: ''!
schemaInstanceClassName
	^ #ExChdExpress2cheddarSchemaInstance

! !

PlatypusCoreSchema subclass: #ExChdRecordAndClassSchemaDefinition
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Express2Cheddar-RecordAndClassSchema'!

!ExChdRecordAndClassSchemaDefinition commentStamp: 'platypus comment' prior: 0!
<ISO10303-11-EXPRESS>
SCHEMA record_and_class;
	USE FROM platypus_dictionary_schema;
	USE FROM platypus_environment_schema;
	USE FROM platypus_expressions_schema;
	USE FROM express_toolsbox_functions;
	USE FROM express_dictionary_queries;
	USE FROM express2cheddar_facade;
	USE FROM cheddar_domains;
	USE FROM discriminated_type;
	USE FROM ada_interface;

	ENTITY ada_entity 
		ABSTRACT SUPERTYPE 
		SUBTYPE OF ( entity_definition );
	DERIVE
		refed_by_pointer : BOOLEAN := false;
		ada_ident : STRING := name;
		ada_ref_ident : STRING := SELF.ada_ident;
		ptr_type : STRING := name + '_Ptr';
		explicit_attributes : LIST OF explicit_attribute := QUERY ( a <* attributes | 'PLATYPUS_DICTIONARY_SCHEMA.EXPLICIT_ATTRIBUTE' IN TYPEOF ( a ) );
		derived_attributes : LIST OF explicit_attribute := QUERY ( a <* attributes | 'PLATYPUS_DICTIONARY_SCHEMA.DERIVED_ATTRIBUTE' IN TYPEOF ( a ) );
		put_prefix : STRING := '';
		dependencies : LIST OF dictionary_instance := dependencies_of_ada_entity ( SELF.owner, SELF );
		xml_writer_code : STRING := ?;
		xml_io_record_code : STRING := ?;
		html_tag : STRING := Lowerize ( SELF.name );
	END_ENTITY;

	ENTITY ada_class 
		SUBTYPE OF ( ada_entity );
		is_private : BOOLEAN;
	DERIVE
		SELF\ada_entity.refed_by_pointer : BOOLEAN := true;
		ads_code : STRING := ada_class_ads_code ( SELF, is_private );
		adb_code : STRING := ada_class_adb_code ( SELF );
		init_value : STRING := ?;
		ads_interfaces_list : LIST OF ada_interface := ada_entity_interfaces_list ( SELF, true );
		adb_interfaces_list : LIST OF ada_interface := ada_entity_interfaces_list ( SELF, false );
		SELF\ada_entity.ada_ref_ident : STRING := SELF.ptr_type;
		SELF\ada_entity.xml_writer_code : STRING := ada_class_xml_writer_code ( SELF );
		SELF\ada_entity.xml_io_record_code : STRING := ada_class_xml_io_record_code ( SELF );
	END_ENTITY;

	ENTITY record 
		SUBTYPE OF ( ada_entity );
	DERIVE
		ads_code : STRING := record_ads_code ( SELF );
		adb_code : STRING := record_adb_code ( SELF );
		ads_interfaces_list : LIST OF ada_interface := ada_entity_interfaces_list ( SELF, true );
		adb_interfaces_list : LIST OF ada_interface := ada_entity_interfaces_list ( SELF, false );
		SELF\ada_entity.xml_writer_code : STRING := record_xml_writer_code ( SELF );
		SELF\ada_entity.xml_io_record_code : STRING := record_xml_io_record_code ( SELF );
	END_ENTITY;

	ENTITY cheddar_function_ptr 
		SUBTYPE OF ( entity_definition );
		arguments : STRING;
		returns : STRING;
	DERIVE
		ads_interface_list : LIST OF ada_interface := [ ];
		adb_interface_list : LIST OF ada_interface := [ ];
		ads_code : STRING := 'Type ' + SELF.name + ' is access function (' + SELF.arguments + ') return ' + SELF.returns + ';';
		adb_code : STRING := '';
		dependencies : LIST OF dictionary_instance := [ SELF ];
		refed_by_pointer : BOOLEAN := false;
	END_ENTITY;

	FUNCTION is_generic_object ( e : entity_instance ) : BOOLEAN;

		IF ( 'RECORD_AND_CLASS.ADA_CLASS' IN TYPEOF ( e ) ) THEN
			RETURN ( inherits_from_entity_named ( e, 'generic_object' ) );
		END_IF;
		RETURN ( false );
	END_FUNCTION;

	FUNCTION is_named_object ( e : entity_instance ) : BOOLEAN;

		IF ( 'RECORD_AND_CLASS.ADA_CLASS' IN TYPEOF ( e ) ) THEN
			RETURN ( inherits_from_entity_named ( e, 'named_object' ) );
		END_IF;
		RETURN ( false );
	END_FUNCTION;

	FUNCTION dependencies_of_ada_entity ( o : context_definition; t : ada_entity ) : LIST OF dictionary_instance;
		LOCAL 
			r : LIST OF dictionary_instance := [ ];
			attrs : LIST OF attribute := inherited_explicit_attributes ( t );
		END_LOCAL;

		REPEAT no := LOINDEX ( attrs ) TO HIINDEX ( attrs );
			r := r + dependencies_of ( o, attrs [ no].domain.handled );
		END_REPEAT;
		r := r + t;
		RETURN ( r );
	END_FUNCTION;

	FUNCTION ada_class_ads_code ( cip : ada_class; with_private : BOOLEAN ) : STRING;
		LOCAL 
			result : STRING;
			abstr : STRING := '';
			local_sup : entity_definition := local_root_supertype_of ( cip );
		END_LOCAL;
		result := '\n' 
		+ '-- --------= ' + cip.name + ' =--------\n\n' 

		+ 'type ' + cip.name + ';' + '\ntype ' + cip.ptr_type + ' is access all ' + cip.name + '''Class;\n';

		IF SIZEOF ( cip.supertypes ) > 0 THEN
			ALIAS supref FOR cip.supertypes [ 1 ].ref;
				result := result + 'type ' + cip.name + ' is ' + abstr + 'new ' + supref.ada_ident + ' with ';
			END_ALIAS;
		ELSE
			result := result + 'type ' + cip.name + ' is ' + abstr + 'new Ada.Finalization.Controlled with ';
		END_IF;

		IF with_private THEN
			result := result + 'private;\n';
		ELSE
			result := result + ada_class_attributes_ads_code ( cip );
		END_IF;
		result := result + '\nprocedure Initialize(obj : in out ' + cip.name + ');\n' 
		+ 'procedure Put(obj : in ' + cip.name + ');\n' 
		+ 'procedure Put(obj : in ' + cip.ptr_type + ');\n';
		result := result + 'procedure Put_Name(obj : in ' + cip.ptr_type + ');\n';
		result := result + 'procedure Build_Attributes_XML_String(obj : in ' + cip.name + '; result : in out Unbounded_String);\n' 
		+ 'function XML_String(obj : in ' + cip.name + ') return Unbounded_String;\n' 
		+ 'function XML_String(obj : in ' + cip.ptr_type + ') return Unbounded_String;\n' 
		+ 'function XML_Ref_String(obj : in ' + cip.name + ') return Unbounded_String;\n' 
		+ 'function XML_Ref_String(obj : in ' + cip.ptr_type + ') return Unbounded_String;\n';

		IF is_named_object ( cip ) THEN
			result := result + 'function Get_Name (obj : in ' + cip.name + ') return Unbounded_String;\n' 
			+ 'function Get_Name (obj : in ' + cip.ptr_type + ') return Unbounded_String;\n';
		END_IF;
		result := result + 'function Copy(obj : in ' + cip.ptr_type + ') return ' + local_sup.ptr_type + ';\n' 
		+ 'function Copy(obj : in ' + cip.name + ') return ' + local_sup.ptr_type + ';\n' 
		+ 'function type_of(obj : in ' + cip.name + ') return unbounded_string_list;\n' 
		+ 'function type_of(obj : in ' + cip.ptr_type + ') return unbounded_string_list;\n' 
		+ 'procedure Free  is new Unchecked_Deallocation (' + cip.name + '''Class, ' + cip.ptr_type + ');\n';
		RETURN ( result );
	END_FUNCTION;

	FUNCTION ada_class_adb_code ( cip : ada_class ) : STRING;
		LOCAL 
			code : STRING;
		END_LOCAL;
		code := '\n' 
		+ '-- --------= ' + cip.name + ' =--------\n' 
		+ ada_class_initialize_code ( cip ) + '\n' 
		+ ada_class_copy_code ( cip ) + '\n' 
		+ ada_class_put_code ( cip ) + '\n';

		IF is_named_object ( cip ) THEN
			code := code + ada_class_get_name_code ( cip ) + '\n';
		END_IF;
		code := code + ada_class_typeof_code ( cip ) + '\n' 
		+ ada_class_xml_writer_code ( cip ) + '\n';
		RETURN ( code );
	END_FUNCTION;

	FUNCTION ada_class_xml_writer_code ( cip : ada_class ) : STRING;
		LOCAL 
			code : STRING;
			contents : STRING := '';
			sub : STRING;
		END_LOCAL;
		code := '\nprocedure Build_Attributes_XML_String(obj : in ' + cip.name + '; result : in out Unbounded_String) is \nbegin\n';

		IF SIZEOF ( cip.supertypes ) > 0 THEN
			ALIAS sup FOR cip.supertypes [ LOINDEX ( cip.supertypes ) ].handled;
				contents := contents + '\tBuild_Attributes_XML_String(' + sup.name + '(obj), result);\n';
			END_ALIAS;
		END_IF;

		REPEAT no := LOINDEX ( cip.explicit_attributes ) TO HIINDEX ( cip.explicit_attributes );
			ALIAS attr FOR cip.explicit_attributes [ no];
				sub := explicit_attribute_xml_writer_code ( 'obj', attr );
				IF sub > '' THEN
					contents := contents + sub + '\n';
				END_IF;
			END_ALIAS;
		END_REPEAT;

		IF contents = '' THEN
			contents := '\tnull;\n';
		END_IF;
		code := code + contents + 'end Build_Attributes_XML_String;\n\n' 

		+ 'function XML_String(obj : in ' + cip.name + ') return Unbounded_String is\n' 
		+ '\tresult : Unbounded_String;\n' 
		+ 'begin\n' 
		+ '\tresult := to_unbounded_string("<' + cip.html_tag + ' id=""") & obj.' + xml_id_name + ' & to_unbounded_string(""" >");\n' 
		+ '\tBuild_Attributes_XML_String(obj, result);\n' 
		+ '\tresult := result & to_unbounded_string("</' + cip.html_tag + '>");\n' 
		+ '\treturn (result);\n' 
		+ 'end XML_String;\n\n' 

		+ 'function XML_String(obj : in ' + cip.ptr_type + ') return Unbounded_String is\n' 
		+ 'begin\n' 
		+ '	if obj /= null then\n' 
		+ '		return XML_String(obj.all);\n' 
		+ '	else\n' 
		+ '		return Empty_String;\n' 
		+ '	end if;\n' 
		+ 'end XML_String;\n\n' 

		+ 'function XML_Ref_String(obj : in ' + cip.name + ') return Unbounded_String is\n' 
		+ '\tresult : Unbounded_String;\n' 
		+ 'begin\n' 
		+ '\tresult := to_unbounded_string("<' + cip.html_tag + ' ref=""") & obj.' + xml_id_name + ' & to_unbounded_string(""" />");\n' 
		+ '\treturn (result);\n' 
		+ 'end XML_Ref_String;\n\n' 

		+ 'function XML_Ref_String(obj : in ' + cip.ptr_type + ') return Unbounded_String is\n' 
		+ 'begin\n' 
		+ '\treturn XML_Ref_String(obj.all);\n' 
		+ 'end XML_Ref_String;\n\n';
		RETURN ( code );
	END_FUNCTION;

	FUNCTION record_xml_writer_code ( cip : record ) : STRING;
		LOCAL 
			code : STRING;
			acode : STRING;
		END_LOCAL;
		code := '\nprocedure Build_Attributes_XML_String(obj : in ' + cip.name + '; result : in out Unbounded_String) is \nbegin\n';

		REPEAT no := LOINDEX ( cip.explicit_attributes ) TO HIINDEX ( cip.explicit_attributes );
			ALIAS attr FOR cip.explicit_attributes [ no];
				acode := explicit_attribute_xml_writer_code ( 'obj', attr );
				IF ( acode > '' ) THEN
					code := code + acode + '\n';
				END_IF;
			END_ALIAS;
		END_REPEAT;
		code := code + 'end Build_Attributes_XML_String;\n\n' 

		+ 'function XML_String(obj : in ' + cip.name + ') return Unbounded_String is\n' 
		+ '\tresult : Unbounded_String;\n' 
		+ 'begin\n' 
		+ '\tresult := to_unbounded_string("<' + cip.html_tag + '>");\n' 
		+ '\tBuild_Attributes_XML_String(obj, result);\n' 
		+ '\tresult := result & to_unbounded_string("</' + cip.html_tag + '>");\n' 
		+ '\treturn (result);\n' 
		+ 'end XML_String;\n\n' 

		+ 'function XML_String(obj : in ' + cip.ptr_type + ') return Unbounded_String is\n' 
		+ 'begin\n' 
		+ '	if obj /= null then\n' 
		+ '		return XML_String(obj.all);\n' 
		+ '	else\n' 
		+ '		return Empty_String;\n' 
		+ '	end if;\n' 
		+ 'end XML_String;\n\n' 

		+ 'function XML_Ref_String(obj : in ' + cip.name + ') return Unbounded_String is\n' 
		+ '\tresult : Unbounded_String;\n' 
		+ 'begin\n' 
		+ '	raise xml_ref_string_error;\n' 
		+ '	return to_unbounded_string("");\n' 
		+ 'end XML_Ref_String;\n';
		RETURN ( code );
	END_FUNCTION;

	FUNCTION ada_class_initialize_code ( cip : ada_class ) : STRING;
		LOCAL 
			code : STRING;
			innerCode : STRING := '';
			attrs : LIST OF attribute;
			init : STRING;
		END_LOCAL;
		code := '\nprocedure Initialize(obj : in out ' + cip.name + ') is \nbegin\n';

		IF SIZEOF ( cip.supertypes ) > 0 THEN
			ALIAS sup FOR cip.supertypes [ LOINDEX ( cip.supertypes ) ].handled;
				innerCode := innerCode + '\tinitialize(' + sup.name + '(obj));\n';
			END_ALIAS;
		END_IF;

		REPEAT no := LOINDEX ( cip.explicit_attributes ) TO HIINDEX ( cip.explicit_attributes );
			ALIAS attr FOR cip.explicit_attributes [ no];
				init := explicit_attribute_initialize ( attr );
				IF ( EXISTS ( init ) AND ( init > '' ) ) THEN
					innerCode := innerCode + '\t' + init + '\n';
				END_IF;
			END_ALIAS;
		END_REPEAT;

		REPEAT no := LOINDEX ( cip.derived_attributes ) TO HIINDEX ( cip.derived_attributes );
			ALIAS attr FOR cip.derived_attributes [ no];
				init := derived_attribute_initialize ( attr );
				IF ( EXISTS ( init ) AND ( init > '' ) ) THEN
					innerCode := innerCode + '\t' + init + '\n';
				END_IF;
			END_ALIAS;
		END_REPEAT;

		IF innerCode = '' THEN
			innerCode := '\tnull;\n';
		END_IF;
		code := code + innerCode + 'end Initialize;\n';
		RETURN ( code );
	END_FUNCTION;

	FUNCTION explicit_attribute_initialize ( attr : explicit_attribute ) : STRING;
		LOCAL 
			domain : dictionary_instance := basic_ada_domain ( attr.domain );
			init : STRING := domain.init_value;
		END_LOCAL;

		IF ( attr.name = xml_id_name ) THEN
			RETURN ( 'generate_id( framework_id, obj.' + attr.name + ' );' );
		END_IF;

		IF ( 'CHEDDAR_DOMAINS.IN_SCOPE_ATTRIBUTE' IN TYPEOF ( attr ) ) THEN
			RETURN ( attr.init_code );
		END_IF;

		IF ( 'CHEDDAR_DOMAINS.CHEDDAR_PRIMITIVE_TYPE' IN TYPEOF ( domain.handled ) ) THEN
			init := domain.handled.init_value;
		END_IF;

		IF NOT EXISTS ( init ) THEN
			RETURN ( ? );
		ELSE
			IF init <> 'initialize' THEN
				RETURN ( 'obj.' + attr.name + ' := ' + init + ';' );
			ELSE
				IF domain.handled.refed_by_pointer THEN
					RETURN ( 'initialize( obj.' + attr.name + '.all);' );
				ELSE
					RETURN ( 'initialize( obj.' + attr.name + ');' );
				END_IF;
			END_IF;
		END_IF;
	END_FUNCTION;

	FUNCTION derived_attribute_initialize ( attr : explicit_attribute ) : STRING;
		LOCAL 
			code : STRING;
			val : STRING;
			key : STRING := upperize ( attr.name );
		END_LOCAL;

		IF EXISTS ( attr.redeclaring ) THEN
			IF SIZEOF ( QUERY ( a <* inherited_explicit_attributes ( attr.owner ) | upperize ( a.name ) = key ) ) > 0 THEN
				val := basic_ada_type_value_format ( attr.assign, ? ).formated;
				code := 'obj.' + attr.name + ' := ' + val + ';';
			END_IF;
		END_IF;
		RETURN ( code );
	END_FUNCTION;

	FUNCTION ada_class_typeof_code ( cip : ada_class ) : STRING;
		LOCAL 
			code : STRING;
			sups : LIST OF entity_definition := all_supertypes_of ( cip );
		END_LOCAL;
		code := 'function type_of ( obj : in ' + cip.name + ' ) return unbounded_string_list is\n' 
		+ '\tlist : unbounded_string_list;\n' 
		+ '\ts : unbounded_string_ptr;\n' 
		+ 'begin\n' 
		+ '\t' + 'Initialize(list);\n' 
		+ '\n';

		REPEAT no := LOINDEX ( sups ) TO HIINDEX ( sups );
			ALIAS curr FOR sups [ no];
				code := code + '\t' + 's := new unbounded_string;\n' 
				+ '\t' + 's.all := to_unbounded_string("' + upperize ( curr.owner.name ) + '.' + upperize ( curr.name ) + '");\n' 
				+ '\t' + 'Add (list, s);\n' 
				+ '\n';
			END_ALIAS;
		END_REPEAT;
		code := code + '\treturn list;\nend type_of;\n\n' 

		+ 'function type_of ( obj : in ' + cip.ptr_type + ' ) return unbounded_string_list is\n' 
		+ 'begin\n' 
		+ '\treturn type_of(obj.all);\n' 
		+ 'end type_of;\n';
		RETURN ( code );
	END_FUNCTION;

	FUNCTION ada_class_copy_code ( cip : ada_class ) : STRING;
		LOCAL 
			code : STRING;
			v : STRING := 'New_' + cip.name;
			local_sup : entity_definition := local_root_supertype_of ( cip );
		END_LOCAL;
		code := 'function Copy ( obj : in ' + cip.name + ' ) return ' + local_sup.ptr_type + ' is\n' 
		+ '\t' + v + ' : ' + cip.ptr_type + ';\n' 
		+ 'begin\n' 
		+ '\t' + v + ' := new ' + cip.name + '''(obj);\n';

		IF local_sup.ptr_type <> cip.ptr_type THEN
			code := code + '\treturn ' + local_sup.ptr_type + '(' + v + ');\n';
		ELSE
			code := code + '\treturn (' + v + ');\n';
		END_IF;
		code := code + 'end Copy;\n\n' 

		+ 'function Copy ( obj : in ' + cip.ptr_type + ' ) return ' + local_sup.ptr_type + ' is\n' 
		+ 'begin\n' 
		+ '\treturn copy(obj.all);\n' 
		+ 'end Copy;\n';
		RETURN ( code );
	END_FUNCTION;

	FUNCTION ada_class_put_code ( cip : ada_class ) : STRING;
		LOCAL 
			code : STRING;
			acode : STRING;
		END_LOCAL;
		code := 'procedure Put(obj : in ' + cip.name + ') is \nbegin\n';

		IF SIZEOF ( cip.supertypes ) > 0 THEN
			ALIAS sup FOR cip.supertypes [ LOINDEX ( cip.supertypes ) ].handled;
				code := code + '\tput(' + sup.name + '(obj));\n';
			END_ALIAS;
		END_IF;

		REPEAT no := LOINDEX ( cip.explicit_attributes ) TO HIINDEX ( cip.explicit_attributes );
			ALIAS attr FOR cip.explicit_attributes [ no];
				acode := explicit_attribute_put ( attr );
				IF ( acode > '' ) THEN
					code := code + '\t' + acode + '\n';
				END_IF;
			END_ALIAS;
		END_REPEAT;
		code := code + 'end Put;\n \n' 
		+ 'procedure Put(obj : in ' + cip.ptr_type + ') is\n' 
		+ 'begin\n' 
		+ '\tPut(Obj.All);\n' 
		+ 'end Put;\n \n';
		code := code + 'procedure Put_Name ( obj : in ' + cip.ptr_type + ') is\n' 
		+ 'begin\n';

		IF has_inherited_attribute_named ( cip, 'name' ) THEN
			code := code + '\tPut ( To_String ( Obj.Name ) );\n';
		ELSE
			code := code + '\tPut ( To_String ( Obj.' + xml_id_name + ' ) );\n';
		END_IF;
		code := code + 'end Put_Name;\n';
		RETURN ( code );
	END_FUNCTION;

	FUNCTION ada_class_get_name_code ( cip : ada_class ) : STRING;
		LOCAL 
			code : STRING;
		END_LOCAL;
		code := 'function Get_Name (obj : in ' + cip.name + ') return Unbounded_String is\n' 
		+ 'begin\n';

		IF has_inherited_attribute_named ( cip, 'name' ) THEN
			code := code + '	return obj.name;\n';
		ELSE
			code := code + '	return obj.' + xml_id_name + ';\n';
		END_IF;
		code := code + 'end Get_Name;\n\n' 

		+ 'function Get_Name (obj : in ' + cip.name + '_ptr) return Unbounded_String is\n' 
		+ 'begin\n';

		IF has_inherited_attribute_named ( cip, 'name' ) THEN
			code := code + '	return obj.name;\n';
		ELSE
			code := code + '	return obj.' + xml_id_name + ';\n';
		END_IF;
		code := code + 'end Get_Name;\n';
		RETURN ( code );
	END_FUNCTION;

	FUNCTION ada_class_attributes_ads_code ( cip : ada_class ) : STRING;
		LOCAL 
			result : STRING;
			domain : entity_instance;
		END_LOCAL;

		IF SIZEOF ( cip.explicit_attributes ) = 0 THEN
			result := 'null record;\n';
		ELSE
			result := '\nrecord\n';
			REPEAT no := LOINDEX ( cip.explicit_attributes ) TO HIINDEX ( cip.explicit_attributes );
				ALIAS attr FOR cip.explicit_attributes [ no];
					domain := basic_ada_domain ( attr.domain );
					IF ( 'RECORD_AND_CLASS.ADA_CLASS' IN TYPEOF ( domain.handled ) ) OR ( 'DISCRIMINATED_TYPE.DISCRIMINATED_TYPE' IN TYPEOF ( domain.handled ) ) THEN
						result := result + ' ' + attr.name + ' : ' + domain.handled.ptr_type + ';\n';
					ELSE
						result := result + ' ' + attr.name + ' : ' + domain.ada_ref_ident + ';\n';
					END_IF;
				END_ALIAS;
			END_REPEAT;
			result := result + 'end record;\n';
		END_IF;
		RETURN ( result );
	END_FUNCTION;

	FUNCTION ada_entity_interfaces_list ( r : ada_entity; ads : BOOLEAN ) : LIST OF ada_interface;
		LOCAL 
			result : LIST OF ada_interface := entity_definition_interfaces_list ( r, ads );
		END_LOCAL;

		IF ads THEN
			IF 'PACKAGE.ADA_PACKAGE' IN TYPEOF ( r.owner ) THEN
				result := result + ada_interface ( r.owner.name, ?, true, true );
			END_IF;
			IF ( SIZEOF ( r.supertypes ) > 0 ) THEN
				ALIAS supref FOR r.supertypes [ 1 ].ref;
					IF 'PACKAGE.ADA_PACKAGE' IN TYPEOF ( supref.owner ) THEN
						result := result + ada_interface ( supref.owner.name, ?, true, true );
					END_IF;
				END_ALIAS;
			END_IF;
			result := result + ada_interface ( 'Ada.Finalization', ?, true, false );
			result := result + ada_interface ( 'unbounded_strings', ?, true, true );
			result := result + ada_interface ( 'ada.strings', 'unbounded', true, true );
			result := result + ada_interface ( 'unbounded_strings', 'Unbounded_String_List_Package', false, true );
			result := result + ada_interface ( 'Unchecked_Deallocation', ?, true, false );
			result := result + ada_interface ( 'Primitive_XML_Strings', ?, true, true );
		ELSE
			IF has_attribute_named ( r, xml_id_name ) THEN
				result := result + ada_interface ( 'framework', ?, true, true );
				result := result + ada_interface ( 'id_generators', ?, true, true );
			END_IF;
		END_IF;
		RETURN ( result );
	END_FUNCTION;

	FUNCTION entity_definition_interfaces_list ( r : entity_definition; ads : BOOLEAN ) : LIST OF ada_interface;
		LOCAL 
			result : LIST OF ada_interface := [ ];
			ada_domain : entity_instance;
		END_LOCAL;

		REPEAT no := LOINDEX ( r.explicit_attributes ) TO HIINDEX ( r.explicit_attributes );
			ALIAS curr FOR r.explicit_attributes [ no];
				ada_domain := basic_ada_domain ( curr.domain );
				result := result + domain_interfaces_list ( ada_domain, ads, r.owner );
			END_ALIAS;
		END_REPEAT;
		RETURN ( result );
	END_FUNCTION;

	FUNCTION record_ads_code ( rec : record ) : STRING;
		LOCAL 
			result : STRING;
			domain : entity_instance;
		END_LOCAL;
		result := '\n' 
		+ '-- --------= ' + rec.name + ' =--------\n \n' 
		+ 'type ' + rec.name + ' is\nrecord\n';

		REPEAT no := LOINDEX ( rec.attributes ) TO HIINDEX ( rec.attributes );
			result := result + ' ' + rec.attributes [ no].name + ' : ';
			domain := basic_ada_domain ( rec.attributes [ no].domain );
			IF domain.handled.refed_by_pointer THEN
				result := result + domain.handled.ptr_type + ';\n';
			ELSE
				result := result + domain.ada_ref_ident + ';\n';
			END_IF;
		END_REPEAT;
		result := result + 'end record;\n\n' 

		+ 'type ' + rec.ptr_type + ' is access all ' + rec.name + ';\n\n' 

		+ 'procedure Initialize(obj : out ' + rec.name + ');\n' 
		+ 'procedure Put(obj : in ' + rec.name + ');\n' 
		+ 'procedure Put(obj : in ' + rec.ptr_type + ');\n' 
		+ 'function Copy(obj : in ' + rec.ptr_type + ') return ' + rec.ptr_type + ';\n' 
		+ 'function Copy(obj : in ' + rec.name + ') return ' + rec.ptr_type + ';\n' 
		+ 'procedure Build_Attributes_XML_String(obj : in ' + rec.name + '; result : in out Unbounded_String);\n' 
		+ 'function XML_String(obj : in ' + rec.name + ') return Unbounded_String;\n' 
		+ 'function XML_String(obj : in ' + rec.ptr_type + ') return Unbounded_String;\n' 
		+ 'function XML_Ref_String(obj : in ' + rec.name + ') return Unbounded_String;\n' 
		+ 'procedure Free  is new Unchecked_Deallocation (' + rec.name + ', ' + rec.ptr_type + ');\n';
		RETURN ( result );
	END_FUNCTION;

	FUNCTION record_initialize_code ( rec : record ) : STRING;
		LOCAL 
			code : STRING;
			innerCode : STRING := '';
			attrs : LIST OF attribute;
			init : STRING;
		END_LOCAL;
		code := '\nprocedure Initialize(obj : out ' + rec.name + ') is \nbegin\n';

		REPEAT no := LOINDEX ( rec.explicit_attributes ) TO HIINDEX ( rec.explicit_attributes );
			ALIAS attr FOR rec.explicit_attributes [ no];
				init := explicit_attribute_initialize ( attr );
				IF ( EXISTS ( init ) AND ( init > '' ) ) THEN
					innerCode := innerCode + '\t' + init + '\n';
				END_IF;
			END_ALIAS;
		END_REPEAT;

		IF innerCode = '' THEN
			innerCode := '\tnull;\n';
		END_IF;
		code := code + innerCode + 'end Initialize;\n';
		RETURN ( code );
	END_FUNCTION;

	FUNCTION record_adb_code ( rec : record ) : STRING;
		LOCAL 
			code : STRING;
		END_LOCAL;
		code := '\n' 
		+ '-- --------= ' + rec.name + ' =--------\n' 
		+ record_initialize_code ( rec ) + '\n' 
		+ record_put_code ( rec ) + '\n' 
		+ record_xml_writer_code ( rec ) + '\n' 
		+ record_copy_code ( rec ) + '\n';
		RETURN ( code );
	END_FUNCTION;

	FUNCTION record_put_code ( rec : record ) : STRING;
		LOCAL 
			code : STRING;
			acode : STRING;
		END_LOCAL;
		code := 'procedure Put(obj : in ' + rec.name + ') is \nbegin\n';

		REPEAT no := LOINDEX ( rec.explicit_attributes ) TO HIINDEX ( rec.explicit_attributes );
			ALIAS attr FOR rec.explicit_attributes [ no];
				acode := explicit_attribute_put ( attr );
				IF ( acode > '' ) THEN
					code := code + '\t' + acode + '\n';
				END_IF;
			END_ALIAS;
		END_REPEAT;
		code := code + 'end Put;\n \n' 
		+ 'procedure Put(obj : in ' + rec.ptr_type + ') is\n' 
		+ 'begin\n' 
		+ '\tPut(Obj.All);\n' 
		+ 'end Put;\n';
		RETURN ( code );
	END_FUNCTION;

	FUNCTION explicit_attribute_put ( attr : explicit_attribute ) : STRING;
		LOCAL 
			code : STRING;
			prfx : STRING := '';
			domain : entity_instance := basic_ada_domain ( attr.domain );
		END_LOCAL;
		code := 'put("' + attr.name + ': "); ';

		IF ( 'RECORD_AND_CLASS.CHEDDAR_FUNCTION_PTR' IN TYPEOF ( domain.handled ) ) THEN
			RETURN ( '' );
		END_IF;

		IF ( 'CHEDDAR_DOMAINS.ADA_PRIMITIVE_TYPE' IN TYPEOF ( domain.handled ) ) THEN
			prfx := domain.handled.put_prefix;
		END_IF;

		IF domain.handled.refed_by_pointer THEN
			code := code + 'if obj.' + attr.name + ' /= null then ' + prfx + 'put(obj.' + attr.name + '.all' + '); else put("null"); end if;';
		ELSE
			code := code + prfx + 'put(obj.' + attr.name + '); ';
		END_IF;
		code := code + 'put ( "; " );';
		RETURN ( code );
	END_FUNCTION;

	FUNCTION explicit_attribute_xml_writer_code ( prefix : STRING; attr : explicit_attribute ) : STRING;
		LOCAL 
			code : STRING;
			domain : entity_instance := basic_ada_domain ( attr.domain );
			tag : STRING := Lowerize ( attr.name );
		END_LOCAL;

		IF ( 'RECORD_AND_CLASS.CHEDDAR_FUNCTION_PTR' IN TYPEOF ( domain.handled ) ) THEN
			RETURN ( '' );
		END_IF;

		IF ( attr.name = xml_id_name ) THEN
			RETURN ( '' );
		END_IF;

		IF is_generic_object ( domain.handled ) THEN
			code := '\tresult := result & to_unbounded_string("<' + attr.name + ' ref=""") & ' + prefix + '.' + attr.name + '.' + xml_id_name + ' & to_unbounded_string(""" />");';
		ELSE
			code := '\tif (XML_String(' + prefix + '.' + attr.name + ') /= Empty_String) then\n' 
			+ '\t\tresult := result & to_unbounded_string("<' + tag + '>") & XML_String(' + prefix + '.' + attr.name + ') & to_unbounded_string("</' + tag + '>");\n\tend if;';
		END_IF;
		RETURN ( code );
	END_FUNCTION;

	FUNCTION record_copy_code ( cip : record ) : STRING;
		LOCAL 
			code : STRING;
			v : STRING := 'New_' + cip.name;
		END_LOCAL;
		code := 'function Copy ( obj : in ' + cip.name + ' ) return ' + cip.ptr_type + ' is\n' 
		+ '\t' + v + ' : ' + cip.ptr_type + ';\n' 
		+ 'begin\n' 
		+ '\t' + v + ' := new ' + cip.name + '''(obj);\n';
		code := code + '\treturn (' + v + ');\n';
		code := code + 'end Copy;\n\n' 

		+ 'function Copy ( obj : in ' + cip.ptr_type + ' ) return ' + cip.ptr_type + ' is\n' 
		+ 'begin\n' 
		+ '\treturn copy(obj.all);\n' 
		+ 'end Copy;\n';
		RETURN ( code );
	END_FUNCTION;

	FUNCTION ada_class_xml_io_record_code ( cip : ada_class ) : STRING;
		RETURN ( '\ntype ' + cip.name + '_io is record' + ada_entity_attributes_xml_io_record_code ( cip ) + '\nend record;' );
	END_FUNCTION;

	FUNCTION ada_entity_attributes_xml_io_record_code ( cip : ada_class ) : STRING;
		LOCAL 
			code : STRING := '';
			attrcode : STRING;
		END_LOCAL;

		IF SIZEOF ( cip.supertypes ) > 0 THEN
			ALIAS sup FOR cip.supertypes [ LOINDEX ( cip.supertypes ) ].handled;
				code := code + ada_entity_attributes_xml_io_record_code ( sup );
			END_ALIAS;
		END_IF;

		REPEAT no := LOINDEX ( cip.explicit_attributes ) TO HIINDEX ( cip.explicit_attributes );
			ALIAS attr FOR cip.explicit_attributes [ no];
				attrcode := explicit_attribute_xml_io_record_code ( attr );
				code := code + attrcode;
			END_ALIAS;
		END_REPEAT;

		IF ( code = '' ) THEN
			code := '\tnull;';
		END_IF;
		RETURN ( code );
	END_FUNCTION;

	FUNCTION explicit_attribute_xml_io_record_code ( attr : explicit_attribute ) : STRING;
		LOCAL 
			code : STRING := '';
			domain : entity_instance := basic_ada_domain ( attr.domain );
			init : STRING := domain.init_value;
		END_LOCAL;

		IF ( 'RECORD_AND_CLASS.RECORD' IN TYPEOF ( domain.handled ) ) THEN
			RETURN ( ada_entity_attributes_xml_io_record_code ( domain.handled ) );
		END_IF;

		IF NOT is_generic_object ( domain.handled ) THEN
			IF ( 'CHEDDAR_DOMAINS.ADA_ENUMERATION' IN TYPEOF ( domain.handled ) ) OR EXISTS ( init ) THEN
				IF ( 'CHEDDAR_DOMAINS.ADA_ENUMERATION' IN TYPEOF ( domain.handled ) ) THEN
					code := '\t' + attr.name + ' : ' + domain.ada_ref_ident + ';';
				ELSE
					IF ( init = 'empty_string' ) THEN
						code := '\t' + attr.name + ' : Unbounded_String;';
					ELSE
						IF ( lowerize ( init ) = 'false' ) THEN
							code := '\t' + attr.name + ' : Boolean;';
						ELSE
							IF ( init = '0' ) THEN
								code := '\t' + attr.name + ' : Integer;';
							ELSE
								code := '\t' + attr.name + ' : Double;';
							END_IF;
						END_IF;
					END_IF;
				END_IF;
			END_IF;
		ELSE
			code := '\t' + attr.name + ' : Unbounded_String;';
		END_IF;

		IF ( code > '' ) THEN
			code := '\n' 
			+ code;
		END_IF;
		RETURN ( code );
	END_FUNCTION;

	FUNCTION record_xml_io_record_code ( rec : record ) : STRING;
		RETURN ( '\ntype ' + rec.name + '_io is record' + ada_entity_attributes_xml_io_record_code ( rec ) + '\nend record;\n' );
	END_FUNCTION;

	FUNCTION ada_entity_xml_io_record_initialize_code ( cip : ada_class ) : STRING;
		LOCAL 
			code : STRING := ada_entity_attributes_xml_io_record_initialize_code ( cip );
		END_LOCAL;

		IF ( code = '' ) THEN
			code := '\tnull;';
		END_IF;
		RETURN ( '\nprocedure Initialize(obj : out ' + cip.name + '_io) is \nbegin ' + code + '\nend Initialize;\n' );
	END_FUNCTION;

	FUNCTION ada_entity_attributes_xml_io_record_initialize_code ( cip : ada_class ) : STRING;
		LOCAL 
			code : STRING := '';
			s : STRING;
		END_LOCAL;

		IF SIZEOF ( cip.supertypes ) > 0 THEN
			ALIAS sup FOR cip.supertypes [ LOINDEX ( cip.supertypes ) ].handled;
				code := code + ada_entity_attributes_xml_io_record_initialize_code ( sup );
			END_ALIAS;
		END_IF;

		REPEAT no := LOINDEX ( cip.explicit_attributes ) TO HIINDEX ( cip.explicit_attributes );
			ALIAS attr FOR cip.explicit_attributes [ no];
				s := explicit_attribute_xml_io_record_initialize_code ( attr );
				IF ( s > '' ) THEN
					code := code + '\n' 
					+ s;
				END_IF;
			END_ALIAS;
		END_REPEAT;
		RETURN ( code );
	END_FUNCTION;

	FUNCTION explicit_attribute_xml_io_record_initialize_code ( attr : explicit_attribute ) : STRING;
		LOCAL 
			code : STRING := '';
			domain : entity_instance := basic_ada_domain ( attr.domain );
			init : STRING := domain.init_value;
		END_LOCAL;

		IF NOT is_generic_object ( domain.handled ) THEN
			IF ( 'CHEDDAR_DOMAINS.ADA_ENUMERATION' IN TYPEOF ( domain.handled ) ) THEN
				code := '\tobj.' + attr.name + ' := ' + domain.ada_ref_ident + '''first;';
			ELSE
				IF EXISTS ( init ) THEN
					code := '\tobj.' + attr.name + ' := ' + init + ';';
				END_IF;
			END_IF;
		ELSE
			code := '\tobj.' + attr.name + ' := empty_string;';
		END_IF;
		RETURN ( code );
	END_FUNCTION;

	FUNCTION ada_entity_xml_start_element_code ( cip : ada_entity ) : STRING;
		LOCAL 
			code : STRING;
		END_LOCAL;

		IF ( 'RECORD_AND_CLASS.RECORD' IN TYPEOF ( cip ) ) THEN
			code := '\nprocedure Start_Element(\n' 
			+ '\tHandler: in out Xml_Generic_Parser;\n' 
			+ '\tobj : in out ' + cip.name + '_io;\n' 
			+ '\tNamespace_Uri : Unicode.CES.Byte_Sequence := "";\n' 
			+ '\tLocal_Name : Unicode.CES.Byte_Sequence := "";\n' 
			+ '\tQname : Unicode.CES.Byte_Sequence := "";\n' 
			+ '\tAtts : Sax.Attributes.Attributes''Class) is\n' 
			+ 'begin\n' 
			+ '\tif To_String (To_Lower (Qname)) = "' + cip.html_tag + '" then\n' 
			+ '\t\tinitialize(obj);\n' 
			+ '\tend if;\n' 
			+ 'end Start_Element;\n';
		ELSE
			code := ada_entity_attributes_xml_start_element_code ( cip );
			IF ( code > '' ) THEN
				code := '\nprocedure Start_Element(\n' 
				+ '\tHandler: in out Xml_Generic_Parser;\n' 
				+ '\tobj : in out ' + cip.name + '_io;\n' 
				+ '\tNamespace_Uri : Unicode.CES.Byte_Sequence := "";\n' 
				+ '\tLocal_Name : Unicode.CES.Byte_Sequence := "";\n' 
				+ '\tQname : Unicode.CES.Byte_Sequence := "";\n' 
				+ '\tAtts : Sax.Attributes.Attributes''Class) is \nbegin\n' 
				+ '\tif Get_Length (Atts) > 0 then' + code + '\n' 
				+ '\tend if;\n' 
				+ 'end Start_Element;\n';
			END_IF;
		END_IF;
		RETURN ( code );
	END_FUNCTION;

	FUNCTION ada_entity_attributes_xml_start_element_code ( cip : ada_class ) : STRING;
		LOCAL 
			code : STRING := '';
			s : STRING;
		END_LOCAL;

		IF SIZEOF ( cip.supertypes ) > 0 THEN
			ALIAS sup FOR cip.supertypes [ LOINDEX ( cip.supertypes ) ].handled;
				code := code + ada_entity_attributes_xml_start_element_code ( sup );
			END_ALIAS;
		END_IF;

		REPEAT no := LOINDEX ( cip.explicit_attributes ) TO HIINDEX ( cip.explicit_attributes );
			ALIAS attr FOR cip.explicit_attributes [ no];
				s := explicit_attribute_xml_start_element_code ( attr );
				IF ( s > '' ) THEN
					code := code + s;
				END_IF;
			END_ALIAS;
		END_REPEAT;
		RETURN ( code );
	END_FUNCTION;

	FUNCTION explicit_attribute_xml_end_element_code ( attr : explicit_attribute ) : STRING;
		LOCAL 
			code : STRING := '';
			domain : entity_instance := basic_ada_domain ( attr.domain );
			init : STRING := domain.init_value;
			io_domain : STRING;
		END_LOCAL;

		IF NOT is_generic_object ( domain.handled ) THEN
			IF ( 'CHEDDAR_DOMAINS.ADA_ENUMERATION' IN TYPEOF ( domain.handled ) ) OR EXISTS ( init ) THEN
				IF ( 'CHEDDAR_DOMAINS.ADA_ENUMERATION' IN TYPEOF ( domain.handled ) ) THEN
					io_domain := domain.ada_ident;
				ELSE
					IF ( init = 'empty_string' ) THEN
						io_domain := 'String';
					ELSE
						IF ( lowerize ( init ) = 'false' ) THEN
							io_domain := 'Boolean';
						ELSE
							IF ( init = '0' ) THEN
								io_domain := 'Integer';
							ELSE
								io_domain := 'Double';
							END_IF;
						END_IF;
					END_IF;
				END_IF;
				IF init = 'empty_string' THEN
					code := '\n\tif To_String (To_Lower (Qname)) = "' + lowerize ( attr.name ) + '" then\n' 
					+ '\t\tobj.' + attr.name + ' := handler.Parameter_List (1);\n' 
					+ '\tend if;';
				ELSE
					code := '\n\tif To_String (To_Lower (Qname)) = "' + lowerize ( attr.name ) + '" then\n' 
					+ '\t\tTo_' + io_domain + ' (handler.Parameter_List (1), obj.' + attr.name + ', Handler.Ok);\n' 
					+ '\t\tif not Handler.Ok then\n' 
					+ '\t\t\tPut_Line ("Warning : Error on data type From " & To_String (Handler.Locator));\n' 
					+ '\t\tend if;\n' 
					+ '\tend if;';
				END_IF;
			END_IF;
		END_IF;
		RETURN ( code );
	END_FUNCTION;

	FUNCTION explicit_attribute_xml_start_element_code ( attr : explicit_attribute ) : STRING;
		LOCAL 
			code : STRING := '';
			domain : entity_instance := basic_ada_domain ( attr.domain );
			sub_domain : entity_instance;
			element_domain : entity_instance;
		END_LOCAL;

		IF is_generic_object ( domain.handled ) THEN
			code := '\n\t\tif To_String (To_Lower (Qname)) = "' + lowerize ( attr.name ) + '" then\n' 
			+ '\t\t\tfor J in 0 .. Get_Length (Atts) - 1 loop\n' 
			+ '\t\t\t\tif To_String (To_Lower (Get_Qname (Atts, J))) = "ref" then\n' 
			+ '\t\t\t\t\tobj.' + attr.name + ' := To_Unbounded_String (Get_Value (Atts, J));\n' 
			+ '\t\t\t\tend if;\n' 
			+ '\t\t\tend loop;\n' 
			+ '\t\tend if;';
		END_IF;
		RETURN ( code );
	END_FUNCTION;

	FUNCTION ada_entity_xml_end_element_code ( cip : ada_entity ) : STRING;
		RETURN ( '\nprocedure End_Element(\n' 
			+ '\tHandler : in out Xml_generic_parser;\n' 
			+ '\tobj : in out ' + cip.name + '_io;\n' 
			+ '\tNamespace_Uri : Unicode.CES.Byte_Sequence := "";\n' 
			+ '\tLocal_Name    : Unicode.CES.Byte_Sequence := "";\n' 
			+ '\tQname : Unicode.CES.Byte_Sequence := "") is \nbegin\n' 
			+ ada_entity_attributes_xml_end_element_code ( cip ) + '\nend End_Element;\n' );
	END_FUNCTION;

	FUNCTION ada_entity_attributes_xml_end_element_code ( cip : ada_class ) : STRING;
		LOCAL 
			code : STRING := '';
			s : STRING;
		END_LOCAL;

		IF SIZEOF ( cip.supertypes ) > 0 THEN
			ALIAS sup FOR cip.supertypes [ LOINDEX ( cip.supertypes ) ].handled;
				code := code + ada_entity_attributes_xml_end_element_code ( sup );
			END_ALIAS;
		END_IF;

		REPEAT no := LOINDEX ( cip.explicit_attributes ) TO HIINDEX ( cip.explicit_attributes );
			ALIAS attr FOR cip.explicit_attributes [ no];
				s := explicit_attribute_xml_end_element_code ( attr );
				IF ( s > '' ) THEN
					code := code + '\n' 
					+ s;
				END_IF;
			END_ALIAS;
		END_REPEAT;

		IF ( code = '' ) THEN
			code := '\tnull;\n';
		END_IF;
		RETURN ( code );
	END_FUNCTION;
END_SCHEMA;

</ISO10303-11-EXPRESS>!

!ExChdRecordAndClassSchemaDefinition class methodsFor: 'platypus-generated-platypus-signature' stamp: ''!
iso10303P11Translater
	^ 'Platypus (c) LISYC EA3883, Universite de Bretagne occidentale. Brest.'

! !

!ExChdRecordAndClassSchemaDefinition class methodsFor: 'platypus-generated-platypus-signature' stamp: ''!
translatedFromISO10303P11
	^ true

! !

!ExChdRecordAndClassSchemaDefinition class methodsFor: 'platypus-generated-platypus-signature' stamp: ''!
vwNamespaceName
	^ #Express2Cheddar

! !

!ExChdRecordAndClassSchemaDefinition methodsFor: 'platypus-generated-context-accessing' stamp: ''!
context
	^ self schemaInstance context

! !

!ExChdRecordAndClassSchemaDefinition methodsFor: 'platypus-generated-entities' stamp: ''!
entityDefinition1
	^ #(#ada_entity #ExChdAdaEntity)

! !

!ExChdRecordAndClassSchemaDefinition methodsFor: 'platypus-generated-entities' stamp: ''!
entityDefinition2
	^ #(#ada_class #ExChdAdaClass)

! !

!ExChdRecordAndClassSchemaDefinition methodsFor: 'platypus-generated-entities' stamp: ''!
entityDefinition3
	^ #(#record #ExChdRecord)

! !

!ExChdRecordAndClassSchemaDefinition methodsFor: 'platypus-generated-entities' stamp: ''!
entityDefinition4
	^ #(#cheddar_function_ptr #ExChdCheddarFunctionPtr)

! !

!ExChdRecordAndClassSchemaDefinition methodsFor: 'platypus-generated-entities' stamp: ''!
entityDefinitionCount
	^ 4

! !

!ExChdRecordAndClassSchemaDefinition methodsFor: 'platypus-generated-functions' stamp: ''!
functionDeclaration1
	^ #(#is_generic_object #ExChdIsGenericObjectFunction)

! !

!ExChdRecordAndClassSchemaDefinition methodsFor: 'platypus-generated-functions' stamp: ''!
functionDeclaration10
	^ #(#derived_attribute_initialize #ExChdDerivedAttributeInitializeFunction)

! !

!ExChdRecordAndClassSchemaDefinition methodsFor: 'platypus-generated-functions' stamp: ''!
functionDeclaration11
	^ #(#ada_class_typeof_code #ExChdAdaClassTypeofCodeFunction)

! !

!ExChdRecordAndClassSchemaDefinition methodsFor: 'platypus-generated-functions' stamp: ''!
functionDeclaration12
	^ #(#ada_class_copy_code #ExChdAdaClassCopyCodeFunction)

! !

!ExChdRecordAndClassSchemaDefinition methodsFor: 'platypus-generated-functions' stamp: ''!
functionDeclaration13
	^ #(#ada_class_put_code #ExChdAdaClassPutCodeFunction)

! !

!ExChdRecordAndClassSchemaDefinition methodsFor: 'platypus-generated-functions' stamp: ''!
functionDeclaration14
	^ #(#ada_class_get_name_code #ExChdAdaClassGetNameCodeFunction)

! !

!ExChdRecordAndClassSchemaDefinition methodsFor: 'platypus-generated-functions' stamp: ''!
functionDeclaration15
	^ #(#ada_class_attributes_ads_code #ExChdAdaClassAttributesAdsCodeFunction)

! !

!ExChdRecordAndClassSchemaDefinition methodsFor: 'platypus-generated-functions' stamp: ''!
functionDeclaration16
	^ #(#ada_entity_interfaces_list #ExChdAdaEntityInterfacesListFunction)

! !

!ExChdRecordAndClassSchemaDefinition methodsFor: 'platypus-generated-functions' stamp: ''!
functionDeclaration17
	^ #(#entity_definition_interfaces_list #ExChdEntityDefinitionInterfacesListFunction)

! !

!ExChdRecordAndClassSchemaDefinition methodsFor: 'platypus-generated-functions' stamp: ''!
functionDeclaration18
	^ #(#record_ads_code #ExChdRecordAdsCodeFunction)

! !

!ExChdRecordAndClassSchemaDefinition methodsFor: 'platypus-generated-functions' stamp: ''!
functionDeclaration19
	^ #(#record_initialize_code #ExChdRecordInitializeCodeFunction)

! !

!ExChdRecordAndClassSchemaDefinition methodsFor: 'platypus-generated-functions' stamp: ''!
functionDeclaration2
	^ #(#is_named_object #ExChdIsNamedObjectFunction)

! !

!ExChdRecordAndClassSchemaDefinition methodsFor: 'platypus-generated-functions' stamp: ''!
functionDeclaration20
	^ #(#record_adb_code #ExChdRecordAdbCodeFunction)

! !

!ExChdRecordAndClassSchemaDefinition methodsFor: 'platypus-generated-functions' stamp: ''!
functionDeclaration21
	^ #(#record_put_code #ExChdRecordPutCodeFunction)

! !

!ExChdRecordAndClassSchemaDefinition methodsFor: 'platypus-generated-functions' stamp: ''!
functionDeclaration22
	^ #(#explicit_attribute_put #ExChdExplicitAttributePutFunction)

! !

!ExChdRecordAndClassSchemaDefinition methodsFor: 'platypus-generated-functions' stamp: ''!
functionDeclaration23
	^ #(#explicit_attribute_xml_writer_code #ExChdExplicitAttributeXmlWriterCodeFunction)

! !

!ExChdRecordAndClassSchemaDefinition methodsFor: 'platypus-generated-functions' stamp: ''!
functionDeclaration24
	^ #(#record_copy_code #ExChdRecordCopyCodeFunction)

! !

!ExChdRecordAndClassSchemaDefinition methodsFor: 'platypus-generated-functions' stamp: ''!
functionDeclaration25
	^ #(#ada_class_xml_io_record_code #ExChdAdaClassXmlIoRecordCodeFunction)

! !

!ExChdRecordAndClassSchemaDefinition methodsFor: 'platypus-generated-functions' stamp: ''!
functionDeclaration26
	^ #(#ada_entity_attributes_xml_io_record_code #ExChdAdaEntityAttributesXmlIoRecordCodeFunction)

! !

!ExChdRecordAndClassSchemaDefinition methodsFor: 'platypus-generated-functions' stamp: ''!
functionDeclaration27
	^ #(#explicit_attribute_xml_io_record_code #ExChdExplicitAttributeXmlIoRecordCodeFunction)

! !

!ExChdRecordAndClassSchemaDefinition methodsFor: 'platypus-generated-functions' stamp: ''!
functionDeclaration28
	^ #(#record_xml_io_record_code #ExChdRecordXmlIoRecordCodeFunction)

! !

!ExChdRecordAndClassSchemaDefinition methodsFor: 'platypus-generated-functions' stamp: ''!
functionDeclaration29
	^ #(#ada_entity_xml_io_record_initialize_code #ExChdAdaEntityXmlIoRecordInitializeCodeFunction)

! !

!ExChdRecordAndClassSchemaDefinition methodsFor: 'platypus-generated-functions' stamp: ''!
functionDeclaration3
	^ #(#dependencies_of_ada_entity #ExChdDependenciesOfAdaEntityFunction)

! !

!ExChdRecordAndClassSchemaDefinition methodsFor: 'platypus-generated-functions' stamp: ''!
functionDeclaration30
	^ #(#ada_entity_attributes_xml_io_record_initialize_code #ExChdAdaEntityAttributesXmlIoRecordInitializeCodeFunction)

! !

!ExChdRecordAndClassSchemaDefinition methodsFor: 'platypus-generated-functions' stamp: ''!
functionDeclaration31
	^ #(#explicit_attribute_xml_io_record_initialize_code #ExChdExplicitAttributeXmlIoRecordInitializeCodeFunction)

! !

!ExChdRecordAndClassSchemaDefinition methodsFor: 'platypus-generated-functions' stamp: ''!
functionDeclaration32
	^ #(#ada_entity_xml_start_element_code #ExChdAdaEntityXmlStartElementCodeFunction)

! !

!ExChdRecordAndClassSchemaDefinition methodsFor: 'platypus-generated-functions' stamp: ''!
functionDeclaration33
	^ #(#ada_entity_attributes_xml_start_element_code #ExChdAdaEntityAttributesXmlStartElementCodeFunction)

! !

!ExChdRecordAndClassSchemaDefinition methodsFor: 'platypus-generated-functions' stamp: ''!
functionDeclaration34
	^ #(#explicit_attribute_xml_end_element_code #ExChdExplicitAttributeXmlEndElementCodeFunction)

! !

!ExChdRecordAndClassSchemaDefinition methodsFor: 'platypus-generated-functions' stamp: ''!
functionDeclaration35
	^ #(#explicit_attribute_xml_start_element_code #ExChdExplicitAttributeXmlStartElementCodeFunction)

! !

!ExChdRecordAndClassSchemaDefinition methodsFor: 'platypus-generated-functions' stamp: ''!
functionDeclaration36
	^ #(#ada_entity_xml_end_element_code #ExChdAdaEntityXmlEndElementCodeFunction)

! !

!ExChdRecordAndClassSchemaDefinition methodsFor: 'platypus-generated-functions' stamp: ''!
functionDeclaration37
	^ #(#ada_entity_attributes_xml_end_element_code #ExChdAdaEntityAttributesXmlEndElementCodeFunction)

! !

!ExChdRecordAndClassSchemaDefinition methodsFor: 'platypus-generated-functions' stamp: ''!
functionDeclaration4
	^ #(#ada_class_ads_code #ExChdAdaClassAdsCodeFunction)

! !

!ExChdRecordAndClassSchemaDefinition methodsFor: 'platypus-generated-functions' stamp: ''!
functionDeclaration5
	^ #(#ada_class_adb_code #ExChdAdaClassAdbCodeFunction)

! !

!ExChdRecordAndClassSchemaDefinition methodsFor: 'platypus-generated-functions' stamp: ''!
functionDeclaration6
	^ #(#ada_class_xml_writer_code #ExChdAdaClassXmlWriterCodeFunction)

! !

!ExChdRecordAndClassSchemaDefinition methodsFor: 'platypus-generated-functions' stamp: ''!
functionDeclaration7
	^ #(#record_xml_writer_code #ExChdRecordXmlWriterCodeFunction)

! !

!ExChdRecordAndClassSchemaDefinition methodsFor: 'platypus-generated-functions' stamp: ''!
functionDeclaration8
	^ #(#ada_class_initialize_code #ExChdAdaClassInitializeCodeFunction)

! !

!ExChdRecordAndClassSchemaDefinition methodsFor: 'platypus-generated-functions' stamp: ''!
functionDeclaration9
	^ #(#explicit_attribute_initialize #ExChdExplicitAttributeInitializeFunction)

! !

!ExChdRecordAndClassSchemaDefinition methodsFor: 'platypus-generated-functions' stamp: ''!
functionDeclarationCount
	^ 37

! !

!ExChdRecordAndClassSchemaDefinition methodsFor: 'platypus-generated-meta-data-accessing' stamp: ''!
schemaInstanceClassName
	^ #ExChdExpress2cheddarSchemaInstance

! !

PlatypusCoreSchema subclass: #ExChdXmlIoSchemaDefinition
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Express2Cheddar-XmlIoSchema'!

!ExChdXmlIoSchemaDefinition commentStamp: 'platypus comment' prior: 0!
<ISO10303-11-EXPRESS>
SCHEMA xml_io;
	USE FROM platypus_dictionary_schema;
	USE FROM express_toolsbox_functions;
	USE FROM express2cheddar_facade;
	USE FROM record_and_class;
	USE FROM discriminated_type;
	USE FROM ada_interface;
	USE FROM package;

	FUNCTION xml_architecture_io_ads_package_code : STRING;
		LOCAL 
			test : STRING := '';
			code : STRING := '';
			pkgs : LIST OF ada_package := SetToList ( all_ada_packages ( ) );
			allcls : LIST OF ada_class := all_ada_classes ( );
			allrecs : LIST OF ada_class := all_ada_records ( );
			alldts : LIST OF discriminated_type := all_ada_discriminated_types ( );
			interfaces : LIST OF ada_interface := [ ada_interface ( 'Sax', 'Readers', true, true ), ada_interface ( 'Networks', ?, true, true ), ada_interface ( 'Sax', 'Exceptions', true, true ), ada_interface ( 'Sax', 'Locators', true, true ), ada_interface ( 'Sax', 'Attributes', true, true ), ada_interface ( 'Unicode', 'CES', true, true ), ada_interface ( 'Unicode', ?, true, true ), ada_interface ( 'xml_generic_parsers', ?, true, true ), ada_interface ( 'Ada', 'Text_IO', true, true ), ada_interface ( 'Ada', 'Strings.Unbounded', true, true ), ada_interface ( 'Strings', ?, true, true ), ada_interface ( 'Unbounded_Strings', ?, true, true ), ada_interface ( 'Ada', 'Numerics.Aux', true, true ), ada_interface ( 'call_framework_interface', ?, true, true ), ada_interface ( 'Debug', ?, true, true ) ];
		END_LOCAL;
		code := source_licence + '\n';

		REPEAT no := LOINDEX ( pkgs ) TO HIINDEX ( pkgs );
			interfaces := interfaces + ada_interface ( pkgs [ no].name, ?, true, true );
			interfaces := interfaces + ada_package_interface ( pkgs [ no], true );
		END_REPEAT;
		code := source_licence + ada_interfaces_code ( ?, interfaces );
		code := code + 'package xml_architecture_io is\n\n' 

		+ '-- Attributes of the discriminated types\n\n';

		REPEAT no := LOINDEX ( alldts ) TO HIINDEX ( alldts );
			code := code + alldts [ no].xml_io_record_code + '\n';
		END_REPEAT;
		code := code + '\nprocedure Start_Element(' + '\n	Handler: in out Xml_Generic_Parser;' + '\n	ref : in out unbounded_string;' + '\n	id : in out unbounded_string;' + '\n	Namespace_Uri : Unicode.CES.Byte_Sequence := "";' + '\n	Local_Name : Unicode.CES.Byte_Sequence := "";' + '\n	Qname : Unicode.CES.Byte_Sequence := "";' + '\n	Atts : Sax.Attributes.Attributes''Class);\n';

		REPEAT no := LOINDEX ( alldts ) TO HIINDEX ( alldts );
			test := discriminated_type_xml_start_element_code ( alldts [ no] );
			IF ( test > '' ) THEN
				code := code + '\nprocedure Start_Element(\n' 
				+ '\tHandler : in out Xml_generic_parser;\n' 
				+ '\tobj : in out ' + alldts [ no].name + '_io;\n' 
				+ '\tNamespace_Uri : Unicode.CES.Byte_Sequence := "";\n' 
				+ '\tLocal_Name : Unicode.CES.Byte_Sequence := "";\n' 
				+ '\tQname : Unicode.CES.Byte_Sequence := "";\n' 
				+ '\tAtts : Sax.Attributes.Attributes''Class);\n';
			END_IF;
			code := code + '\nprocedure End_Element(\n' 
			+ '\tHandler : in out Xml_generic_parser;\n' 
			+ '\tobj : in out ' + alldts [ no].name + '_io;\n' 
			+ '\tNamespace_Uri : Unicode.CES.Byte_Sequence := "";\n' 
			+ '\tLocal_Name : Unicode.CES.Byte_Sequence := "";\n' 
			+ '\tQname : Unicode.CES.Byte_Sequence := "");\n';
		END_REPEAT;

		REPEAT no := LOINDEX ( alldts ) TO HIINDEX ( alldts );
			code := code + '\nprocedure Initialize(obj : out ' + alldts [ no].name + '_io);';
		END_REPEAT;
		code := code + '\n\n' 

		+ '-- Attributes of the parsed entities\n\n';

		REPEAT no := LOINDEX ( allrecs ) TO HIINDEX ( allrecs );
			code := code + allrecs [ no].xml_io_record_code + '\n';
		END_REPEAT;
		code := code + '\n';

		REPEAT no := LOINDEX ( allrecs ) TO HIINDEX ( allrecs );
			code := code + '\nprocedure Initialize(obj : out ' + allrecs [ no].name + '_io);';
		END_REPEAT;
		code := code + '\n';

		REPEAT no := LOINDEX ( allrecs ) TO HIINDEX ( allrecs );
			test := ada_entity_xml_start_element_code ( allrecs [ no] );
			IF ( test > '' ) THEN
				code := code + '\nprocedure Start_Element(\n' 
				+ '\tHandler : in out Xml_generic_parser;\n' 
				+ '\tobj : in out ' + allrecs [ no].name + '_io;\n' 
				+ '\tNamespace_Uri : Unicode.CES.Byte_Sequence := "";\n' 
				+ '\tLocal_Name : Unicode.CES.Byte_Sequence := "";\n' 
				+ '\tQname : Unicode.CES.Byte_Sequence := "";\n' 
				+ '\tAtts : Sax.Attributes.Attributes''Class);\n';
			END_IF;
			code := code + '\nprocedure End_Element(\n' 
			+ '\tHandler : in out Xml_generic_parser;\n' 
			+ '\tobj : in out ' + allrecs [ no].name + '_io;\n' 
			+ '\tNamespace_Uri : Unicode.CES.Byte_Sequence := "";\n' 
			+ '\tLocal_Name : Unicode.CES.Byte_Sequence := "";\n' 
			+ '\tQname : Unicode.CES.Byte_Sequence := "");\n';
		END_REPEAT;

		REPEAT no := LOINDEX ( allcls ) TO HIINDEX ( allcls );
			code := code + allcls [ no].xml_io_record_code + '\n';
		END_REPEAT;
		code := code + '\n';

		REPEAT no := LOINDEX ( allcls ) TO HIINDEX ( allcls );
			code := code + '\nprocedure Initialize(obj : out ' + allcls [ no].name + '_io);';
		END_REPEAT;
		code := code + '\n';

		REPEAT no := LOINDEX ( allcls ) TO HIINDEX ( allcls );
			test := ada_entity_xml_start_element_code ( allcls [ no] );
			IF ( test > '' ) THEN
				code := code + '\nprocedure Start_Element(\n' 
				+ '\tHandler : in out Xml_generic_parser;\n' 
				+ '\tobj : in out ' + allcls [ no].name + '_io;\n' 
				+ '\tNamespace_Uri : Unicode.CES.Byte_Sequence := "";\n' 
				+ '\tLocal_Name : Unicode.CES.Byte_Sequence := "";\n' 
				+ '\tQname : Unicode.CES.Byte_Sequence := "";\n' 
				+ '\tAtts : Sax.Attributes.Attributes''Class);\n';
			END_IF;
			code := code + '\nprocedure End_Element(\n' 
			+ '\tHandler : in out Xml_generic_parser;\n' 
			+ '\tobj : in out ' + allcls [ no].name + '_io;\n' 
			+ '\tNamespace_Uri : Unicode.CES.Byte_Sequence := "";\n' 
			+ '\tLocal_Name : Unicode.CES.Byte_Sequence := "";\n' 
			+ '\tQname : Unicode.CES.Byte_Sequence := "");\n';
		END_REPEAT;
		code := code + '\n\nend xml_architecture_io;\n';
		RETURN ( code );
	END_FUNCTION;

	FUNCTION xml_architecture_io_adb_package_code : STRING;
		LOCAL 
			code : STRING := '';
			allcls : LIST OF ada_class := all_ada_classes ( );
			allrecs : LIST OF record := all_ada_records ( );
			allents : LIST OF ada_entity := allcls + allrecs;
			strtab : LIST OF STRING := [ ];
			alldts : LIST OF discriminated_type := all_ada_discriminated_types ( );
		END_LOCAL;
		code := source_licence + '\n';
		code := code + 'package body xml_architecture_io is\n\n';
		code := code + '\n';
		code := code + '\nprocedure Start_Element(' + '\n	Handler: in out Xml_Generic_Parser;' + '\n	ref : in out unbounded_string;' + '\n	id : in out unbounded_string;' + '\n	Namespace_Uri : Unicode.CES.Byte_Sequence := "";' + '\n	Local_Name : Unicode.CES.Byte_Sequence := "";' + '\n	Qname : Unicode.CES.Byte_Sequence := "";' + '\n	Atts : Sax.Attributes.Attributes''Class) is' + '\nbegin' + '\n	if Get_Length (Atts) > 0 then' + '\n		if (To_String (To_Lower (Qname)) = "' + Lowerize ( allents [ LOINDEX ( allents ) ].name ) + '")';

		REPEAT no := LOINDEX ( allents ) + 1 TO HIINDEX ( allents );
			code := code + '\n\t\t\t OR (To_String (To_Lower (Qname)) = "' + Lowerize ( allents [ no].name ) + '")';
		END_REPEAT;
		code := code + ' then' + '\n			for J in 0 .. Get_Length (Atts) - 1 loop' + '\n				if To_String (To_Lower (Get_Qname (Atts, J))) = "id" then' + '\n					id := To_Unbounded_String (Get_Value (Atts, J));' + '\n				end if;' + '\n				if To_String (To_Lower (Get_Qname (Atts, J))) = "ref" then' + '\n					ref := To_Unbounded_String (Get_Value (Atts, J));' + '\n				end if;' + '\n			end loop;' + '\n		end if;' + '\n	end if;' + '\nend Start_Element;\n\n';

		REPEAT no := LOINDEX ( alldts ) TO HIINDEX ( alldts );
			code := code + discriminated_type_xml_io_record_initialize_code ( alldts [ no] );
			code := code + discriminated_type_xml_start_element_code ( alldts [ no] );
			code := code + discriminated_type_xml_end_element_code ( alldts [ no] );
		END_REPEAT;

		REPEAT no := LOINDEX ( allrecs ) TO HIINDEX ( allrecs );
			code := code + ada_entity_xml_io_record_initialize_code ( allrecs [ no] );
			code := code + ada_entity_xml_start_element_code ( allrecs [ no] );
			code := code + ada_entity_xml_end_element_code ( allrecs [ no] );
		END_REPEAT;

		REPEAT no := LOINDEX ( allcls ) TO HIINDEX ( allcls );
			code := code + ada_entity_xml_io_record_initialize_code ( allcls [ no] );
			code := code + ada_entity_xml_start_element_code ( allcls [ no] );
			code := code + ada_entity_xml_end_element_code ( allcls [ no] );
		END_REPEAT;
		code := code + 'end xml_architecture_io;\n';
		RETURN ( code );
	END_FUNCTION;
END_SCHEMA;

</ISO10303-11-EXPRESS>!

!ExChdXmlIoSchemaDefinition class methodsFor: 'platypus-generated-platypus-signature' stamp: ''!
iso10303P11Translater
	^ 'Platypus (c) LISYC EA3883, Universite de Bretagne occidentale. Brest.'

! !

!ExChdXmlIoSchemaDefinition class methodsFor: 'platypus-generated-platypus-signature' stamp: ''!
translatedFromISO10303P11
	^ true

! !

!ExChdXmlIoSchemaDefinition class methodsFor: 'platypus-generated-platypus-signature' stamp: ''!
vwNamespaceName
	^ #Express2Cheddar

! !

!ExChdXmlIoSchemaDefinition methodsFor: 'platypus-generated-context-accessing' stamp: ''!
context
	^ self schemaInstance context

! !

!ExChdXmlIoSchemaDefinition methodsFor: 'platypus-generated-entities' stamp: ''!
entityDefinitionCount
	^ 0

! !

!ExChdXmlIoSchemaDefinition methodsFor: 'platypus-generated-functions' stamp: ''!
functionDeclaration1
	^ #(#xml_architecture_io_ads_package_code #ExChdXmlArchitectureIoAdsPackageCodeFunction)

! !

!ExChdXmlIoSchemaDefinition methodsFor: 'platypus-generated-functions' stamp: ''!
functionDeclaration2
	^ #(#xml_architecture_io_adb_package_code #ExChdXmlArchitectureIoAdbPackageCodeFunction)

! !

!ExChdXmlIoSchemaDefinition methodsFor: 'platypus-generated-functions' stamp: ''!
functionDeclarationCount
	^ 2

! !

!ExChdXmlIoSchemaDefinition methodsFor: 'platypus-generated-meta-data-accessing' stamp: ''!
schemaInstanceClassName
	^ #ExChdExpress2cheddarSchemaInstance

! !

PlatypusCoreRepository subclass: #ExChdExpress2cheddarRepository
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Express2Cheddar-Express2cheddarSchemaInstance'!

!ExChdExpress2cheddarRepository class methodsFor: 'platypus-generated-accessing' stamp: ''!
generatedMetaDataSchemaInstanceName
	^ #ExChdExpress2cheddarSchemaInstance

! !

!ExChdExpress2cheddarRepository class methodsFor: 'platypus-generated-platypus-signature' stamp: ''!
iso10303P11Translater
	^ 'Platypus (c) LISYC EA3883, Universite de Bretagne occidentale. Brest.'

! !

!ExChdExpress2cheddarRepository class methodsFor: 'platypus-generated-platypus-signature' stamp: ''!
translatedFromISO10303P11
	^ true

! !

!ExChdExpress2cheddarRepository class methodsFor: 'platypus-generated-platypus-signature' stamp: ''!
vwNamespaceName
	^ #Express2Cheddar

! !

PltSchemaDefinition subclass: #ExChdAdaPackage
	instanceVariableNames: 'adbInterface adsInterface xmlRootTags'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Express2Cheddar-PackageSchema'!

!ExChdAdaPackage commentStamp: 'platypus comment' prior: 0!
<ISO10303-11-EXPRESS>
ENTITY ada_package 
	SUBTYPE OF ( schema_definition );
	ads_interface : LIST OF ada_interface;
	adb_interface : LIST OF ada_interface;
	xml_root_tags : LIST OF STRING;
DERIVE
	infered_ads_interfaces : LIST OF ada_interface := ada_package_interface ( SELF, true );
	ads_head : STRING := source_licence + '\n' 
	+ ada_interfaces_code ( SELF, ada_package_interface ( SELF, true ) );
	adb_head : STRING := source_licence + '\n' 
	+ ada_interfaces_code ( SELF, ada_package_interface ( SELF, false ) );
	ads_code : STRING := ads_head + '\n\nPackage ' + name + ' is \n \n' 
	+ ada_package_ads_code ( SELF ) + '\nEnd ' + name + ';';
	adb_code : STRING := adb_head + '\n\nPackage Body ' + name + ' is \n \n' 
	+ ada_package_adb_code ( SELF ) + '\nEnd ' + name + ';';
END_ENTITY;
</ISO10303-11-EXPRESS>!

!ExChdAdaPackage class methodsFor: 'platypus-generated-platypus-signature' stamp: ''!
iso10303P11Translater
	^ 'Platypus (c) LISYC EA3883, Universite de Bretagne occidentale. Brest.'

! !

!ExChdAdaPackage class methodsFor: 'platypus-generated-meta-data-accessing' stamp: ''!
schemaDefinition
	^ ExChdPackageSchemaDefinition singleton

! !

!ExChdAdaPackage class methodsFor: 'platypus-generated-meta-data-accessing' stamp: ''!
schemaInstance
	^ ExChdExpress2cheddarSchemaInstance singleton

! !

!ExChdAdaPackage class methodsFor: 'platypus-generated-platypus-signature' stamp: ''!
translatedFromISO10303P11
	^ true

! !

!ExChdAdaPackage class methodsFor: 'platypus-generated-platypus-signature' stamp: ''!
vwNamespaceName
	^ #Express2Cheddar

! !

!ExChdAdaPackage methodsFor: 'platypus-generated-visiting' stamp: ''!
accept: aVisitor
	^ aVisitor acceptAdaPackage: self

! !

!ExChdAdaPackage methodsFor: 'platypus-generated-copying' stamp: ''!
adaPackageCopyTo: another
	another fastSetAdsInterface: self adsInterface.
	another fastSetAdbInterface: self adbInterface.
	another fastSetXmlRootTags: self xmlRootTags

! !

!ExChdAdaPackage methodsFor: 'platypus-generated-group-accessing' stamp: ''!
adaPackageFromValues: values
	| valuesloc |
	valuesloc := values asOrderedCollection.
	self setAdsInterface: valuesloc removeFirst.
	self setAdbInterface: valuesloc removeFirst.
	self setXmlRootTags: valuesloc removeFirst.
	^ valuesloc

! !

!ExChdAdaPackage methodsFor: 'platypus-generated-group-accessing' stamp: ''!
adaPackageToValues: values
	values add: self adsInterface.
	values add: self adbInterface.
	values add: self xmlRootTags.
	^ values

! !

!ExChdAdaPackage methodsFor: 'platypus-generated-deriving' stamp: ''!
adbCode
	^ self adbCodeUsingContext: self class context

! !

!ExChdAdaPackage methodsFor: 'platypus-generated-deriving' stamp: ''!
adbCodeUsingContext: aContext
	^ self adbCodeUsingContext: aContext receiver: self

! !

!ExChdAdaPackage methodsFor: 'platypus-generated-deriving' stamp: ''!
adbCodeUsingContext: aContext receiver: aReceiver
	^ (((((((aReceiver adbHeadUsingContext: aContext) pltPlus: '\n\nPackage Body ') pltPlus: aReceiver name)
		pltPlus: ' is \n \n')
		pltPlus:
			(ExChdAdaPackageAdbCodeFunction
				invokeFromValues:
					(OrderedCollection new
						add: aReceiver;
						yourself))) pltPlus: '\nEnd ') pltPlus: aReceiver name) pltPlus: ';'

! !

!ExChdAdaPackage methodsFor: 'platypus-generated-deriving' stamp: ''!
adbHead
	^ self adbHeadUsingContext: self class context

! !

!ExChdAdaPackage methodsFor: 'platypus-generated-deriving' stamp: ''!
adbHeadUsingContext: aContext
	^ self adbHeadUsingContext: aContext receiver: self

! !

!ExChdAdaPackage methodsFor: 'platypus-generated-deriving' stamp: ''!
adbHeadUsingContext: aContext receiver: aReceiver
	^ (((((((((((((((((((((((((((((((((((((((''
		pltPlus: '------------------------------------------------------------------------------\n')
		pltPlus: '------------------------------------------------------------------------------\n')
		pltPlus: '--  This source file was automatically generated by Platypus\n')
		pltPlus: '--  see http://dossen.univ-brest.fr/apl\n') pltPlus: '-- \n')
		pltPlus: '--  Any modification of this file will be lost. \n')
		pltPlus: '--  Please see the "platypus" directory instead : it contains the Cheddar''s\n')
		pltPlus: '--  model and its meta-model. \n')
		pltPlus: '------------------------------------------------------------------------------\n \n')
		pltPlus: '------------------------------------------------------------------------------\n')
		pltPlus: '-- Cheddar is a free real time scheduling tool.\n')
		pltPlus: '-- This program provides services to automatically check temporal constraints\n')
		pltPlus: '-- of real time tasks.\n') pltPlus: '--\n') pltPlus: '-- Copyright (C) 2002-2014   Frank Singhoff\n')
		pltPlus: '-- Cheddar is developed by the LAB-STICC Team, University of Brest\n') pltPlus: '--\n')
		pltPlus: '-- This program is free software; you can redistribute it and/or modify\n')
		pltPlus: '-- it under the terms of the GNU General Public License as published by\n')
		pltPlus: '-- the Free Software Foundation; either version 2 of the License, or\n')
		pltPlus: '-- (at your option) any later version.\n') pltPlus: '--\n')
		pltPlus: '-- This program is distributed in the hope that it will be useful,\n')
		pltPlus: '-- but WITHOUT ANY WARRANTY; without even the implied warranty of\n')
		pltPlus: '-- MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the\n')
		pltPlus: '-- GNU General Public License for more details.\n') pltPlus: '--\n')
		pltPlus: '-- You should have received a copy of the GNU General Public License\n')
		pltPlus: '-- along with this program; if not, write to the Free Software\n')
		pltPlus: '-- Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA\n') pltPlus: '--\n')
		pltPlus: '--\n') pltPlus: '-- Contact : cheddar@listes.univ-brest.fr\n')
		pltPlus: '-- 	To post to this mailing list, you must be subscribed\n')
		pltPlus: '-- 	(see http//beru.univ-brest.fr/~singhoff/cheddar for details)\n') pltPlus: '--\n')
		pltPlus: '------------------------------------------------------------------------------\n')
		pltPlus: '------------------------------------------------------------------------------\n') pltPlus: '\n')
		pltPlus:
			(ExChdAdaInterfacesCodeFunction
				invokeFromValues:
					(OrderedCollection new
						add: aReceiver;
						add:
								(ExChdAdaPackageInterfaceFunction
										invokeFromValues:
											(OrderedCollection new
												add: aReceiver;
												add: false;
												yourself));
						yourself))

! !

!ExChdAdaPackage methodsFor: 'platypus-generated-accessing' stamp: ''!
adbInterface
	^ adbInterface

! !

!ExChdAdaPackage methodsFor: 'platypus-generated-accessing' stamp: ''!
adbInterface: aListOfExChdAdaInterface
	adbInterface := aListOfExChdAdaInterface
		ifNil: [ OrderedCollection new ]
		ifNotNil: [ aListOfExChdAdaInterface as: OrderedCollection ]

! !

!ExChdAdaPackage methodsFor: 'platypus-generated-with-context-accessing' stamp: ''!
adbInterfaceUsingContext: aContext
	^ self adbInterface

! !

!ExChdAdaPackage methodsFor: 'platypus-generated-deriving' stamp: ''!
adsCode
	^ self adsCodeUsingContext: self class context

! !

!ExChdAdaPackage methodsFor: 'platypus-generated-deriving' stamp: ''!
adsCodeUsingContext: aContext
	^ self adsCodeUsingContext: aContext receiver: self

! !

!ExChdAdaPackage methodsFor: 'platypus-generated-deriving' stamp: ''!
adsCodeUsingContext: aContext receiver: aReceiver
	^ (((((((aReceiver adsHeadUsingContext: aContext) pltPlus: '\n\nPackage ') pltPlus: aReceiver name)
		pltPlus: ' is \n \n')
		pltPlus:
			(ExChdAdaPackageAdsCodeFunction
				invokeFromValues:
					(OrderedCollection new
						add: aReceiver;
						yourself))) pltPlus: '\nEnd ') pltPlus: aReceiver name) pltPlus: ';'

! !

!ExChdAdaPackage methodsFor: 'platypus-generated-deriving' stamp: ''!
adsHead
	^ self adsHeadUsingContext: self class context

! !

!ExChdAdaPackage methodsFor: 'platypus-generated-deriving' stamp: ''!
adsHeadUsingContext: aContext
	^ self adsHeadUsingContext: aContext receiver: self

! !

!ExChdAdaPackage methodsFor: 'platypus-generated-deriving' stamp: ''!
adsHeadUsingContext: aContext receiver: aReceiver
	^ (((((((((((((((((((((((((((((((((((((((''
		pltPlus: '------------------------------------------------------------------------------\n')
		pltPlus: '------------------------------------------------------------------------------\n')
		pltPlus: '--  This source file was automatically generated by Platypus\n')
		pltPlus: '--  see http://dossen.univ-brest.fr/apl\n') pltPlus: '-- \n')
		pltPlus: '--  Any modification of this file will be lost. \n')
		pltPlus: '--  Please see the "platypus" directory instead : it contains the Cheddar''s\n')
		pltPlus: '--  model and its meta-model. \n')
		pltPlus: '------------------------------------------------------------------------------\n \n')
		pltPlus: '------------------------------------------------------------------------------\n')
		pltPlus: '-- Cheddar is a free real time scheduling tool.\n')
		pltPlus: '-- This program provides services to automatically check temporal constraints\n')
		pltPlus: '-- of real time tasks.\n') pltPlus: '--\n') pltPlus: '-- Copyright (C) 2002-2014   Frank Singhoff\n')
		pltPlus: '-- Cheddar is developed by the LAB-STICC Team, University of Brest\n') pltPlus: '--\n')
		pltPlus: '-- This program is free software; you can redistribute it and/or modify\n')
		pltPlus: '-- it under the terms of the GNU General Public License as published by\n')
		pltPlus: '-- the Free Software Foundation; either version 2 of the License, or\n')
		pltPlus: '-- (at your option) any later version.\n') pltPlus: '--\n')
		pltPlus: '-- This program is distributed in the hope that it will be useful,\n')
		pltPlus: '-- but WITHOUT ANY WARRANTY; without even the implied warranty of\n')
		pltPlus: '-- MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the\n')
		pltPlus: '-- GNU General Public License for more details.\n') pltPlus: '--\n')
		pltPlus: '-- You should have received a copy of the GNU General Public License\n')
		pltPlus: '-- along with this program; if not, write to the Free Software\n')
		pltPlus: '-- Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA\n') pltPlus: '--\n')
		pltPlus: '--\n') pltPlus: '-- Contact : cheddar@listes.univ-brest.fr\n')
		pltPlus: '-- 	To post to this mailing list, you must be subscribed\n')
		pltPlus: '-- 	(see http//beru.univ-brest.fr/~singhoff/cheddar for details)\n') pltPlus: '--\n')
		pltPlus: '------------------------------------------------------------------------------\n')
		pltPlus: '------------------------------------------------------------------------------\n') pltPlus: '\n')
		pltPlus:
			(ExChdAdaInterfacesCodeFunction
				invokeFromValues:
					(OrderedCollection new
						add: aReceiver;
						add:
								(ExChdAdaPackageInterfaceFunction
										invokeFromValues:
											(OrderedCollection new
												add: aReceiver;
												add: true;
												yourself));
						yourself))

! !

!ExChdAdaPackage methodsFor: 'platypus-generated-accessing' stamp: ''!
adsInterface
	^ adsInterface

! !

!ExChdAdaPackage methodsFor: 'platypus-generated-accessing' stamp: ''!
adsInterface: aListOfExChdAdaInterface
	adsInterface := aListOfExChdAdaInterface
		ifNil: [ OrderedCollection new ]
		ifNotNil: [ aListOfExChdAdaInterface as: OrderedCollection ]

! !

!ExChdAdaPackage methodsFor: 'platypus-generated-with-context-accessing' stamp: ''!
adsInterfaceUsingContext: aContext
	^ self adsInterface

! !

!ExChdAdaPackage methodsFor: 'platypus-generated-fast-set-accessing' stamp: ''!
fastSetAdbInterface: aListOfExChdAdaInterface
	adbInterface := aListOfExChdAdaInterface

! !

!ExChdAdaPackage methodsFor: 'platypus-generated-fast-set-accessing' stamp: ''!
fastSetAdsInterface: aListOfExChdAdaInterface
	adsInterface := aListOfExChdAdaInterface

! !

!ExChdAdaPackage methodsFor: 'platypus-generated-fast-set-accessing' stamp: ''!
fastSetXmlRootTags: aListOfString
	xmlRootTags := aListOfString

! !

!ExChdAdaPackage methodsFor: 'platypus-generated-group-accessing' stamp: ''!
fromValues: values
	^ self adaPackageFromValues: (super fromValues: values)

! !

!ExChdAdaPackage methodsFor: 'platypus-generated-deriving' stamp: ''!
inferedAdsInterfaces
	^ self inferedAdsInterfacesUsingContext: self class context

! !

!ExChdAdaPackage methodsFor: 'platypus-generated-deriving' stamp: ''!
inferedAdsInterfacesUsingContext: aContext
	^ self inferedAdsInterfacesUsingContext: aContext receiver: self

! !

!ExChdAdaPackage methodsFor: 'platypus-generated-deriving' stamp: ''!
inferedAdsInterfacesUsingContext: aContext receiver: aReceiver
	^ ExChdAdaPackageInterfaceFunction
		invokeFromValues:
			(OrderedCollection new
				add: aReceiver;
				add: true;
				yourself)

! !

!ExChdAdaPackage methodsFor: 'platypus-generated-classifying' stamp: ''!
isExChdAdaPackage
	^ true

! !

!ExChdAdaPackage methodsFor: 'platypus-generated-group-accessing' stamp: ''!
localFromValues: values
	^ self adaPackageFromValues: values

! !

!ExChdAdaPackage methodsFor: 'platypus-generated-group-accessing' stamp: ''!
localToValues: values
	^ self adaPackageToValues: values

! !

!ExChdAdaPackage methodsFor: 'platypus-generated-copying' stamp: ''!
pltCopyGroup: aClassSymbol to: anObject
	self class name == aClassSymbol
		ifTrue: [ self pltCopyTo: anObject ]
		ifFalse: [ super pltCopyGroup: aClassSymbol to: anObject ]

! !

!ExChdAdaPackage methodsFor: 'platypus-generated-copying' stamp: ''!
pltCopyTo: another
	super pltCopyTo: another.
	self adaPackageCopyTo: another

! !

!ExChdAdaPackage methodsFor: 'platypus-generated-copying' stamp: ''!
pltLocalCopyTo: another
	self adaPackageCopyTo: another

! !

!ExChdAdaPackage methodsFor: 'platypus-generated-set-accessing' stamp: ''!
setAdbInterface: aListOfExChdAdaInterface
	self adbInterface: aListOfExChdAdaInterface

! !

!ExChdAdaPackage methodsFor: 'platypus-generated-set-accessing' stamp: ''!
setAdsInterface: aListOfExChdAdaInterface
	self adsInterface: aListOfExChdAdaInterface

! !

!ExChdAdaPackage methodsFor: 'platypus-generated-set-accessing' stamp: ''!
setXmlRootTags: aListOfString
	self xmlRootTags: aListOfString

! !

!ExChdAdaPackage methodsFor: 'platypus-generated-initializing' stamp: ''!
stepInitialize
	super stepInitialize.
	adsInterface := OrderedCollection new.
	adbInterface := OrderedCollection new.
	xmlRootTags := OrderedCollection new

! !

!ExChdAdaPackage methodsFor: 'platypus-generated-group-accessing' stamp: ''!
toValues: values
	^ self adaPackageToValues: (super toValues: values)

! !

!ExChdAdaPackage methodsFor: 'platypus-generated-accessing' stamp: ''!
xmlRootTags
	^ xmlRootTags

! !

!ExChdAdaPackage methodsFor: 'platypus-generated-accessing' stamp: ''!
xmlRootTags: aListOfString
	xmlRootTags := aListOfString ifNil: [ OrderedCollection new ] ifNotNil: [ aListOfString as: OrderedCollection ]

! !

!ExChdAdaPackage methodsFor: 'platypus-generated-with-context-accessing' stamp: ''!
xmlRootTagsUsingContext: aContext
	^ self xmlRootTags

! !

PltExplicitAttribute subclass: #ExChdDiscriminatedTypeDiscriminant
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Express2Cheddar-DiscriminatedTypeSchema'!

!ExChdDiscriminatedTypeDiscriminant commentStamp: 'platypus comment' prior: 0!
<ISO10303-11-EXPRESS>
ENTITY discriminated_type_discriminant 
	SUBTYPE OF ( explicit_attribute );
END_ENTITY;
</ISO10303-11-EXPRESS>!

!ExChdDiscriminatedTypeDiscriminant class methodsFor: 'platypus-generated-platypus-signature' stamp: ''!
iso10303P11Translater
	^ 'Platypus (c) LISYC EA3883, Universite de Bretagne occidentale. Brest.'

! !

!ExChdDiscriminatedTypeDiscriminant class methodsFor: 'platypus-generated-meta-data-accessing' stamp: ''!
schemaDefinition
	^ ExChdDiscriminatedTypeSchemaDefinition singleton

! !

!ExChdDiscriminatedTypeDiscriminant class methodsFor: 'platypus-generated-meta-data-accessing' stamp: ''!
schemaInstance
	^ ExChdExpress2cheddarSchemaInstance singleton

! !

!ExChdDiscriminatedTypeDiscriminant class methodsFor: 'platypus-generated-platypus-signature' stamp: ''!
translatedFromISO10303P11
	^ true

! !

!ExChdDiscriminatedTypeDiscriminant class methodsFor: 'platypus-generated-platypus-signature' stamp: ''!
vwNamespaceName
	^ #Express2Cheddar

! !

!ExChdDiscriminatedTypeDiscriminant methodsFor: 'platypus-generated-visiting' stamp: ''!
accept: aVisitor
	^ aVisitor acceptDiscriminatedTypeDiscriminant: self

! !

!ExChdDiscriminatedTypeDiscriminant methodsFor: 'platypus-generated-copying' stamp: ''!
discriminatedTypeDiscriminantCopyTo: another
	

! !

!ExChdDiscriminatedTypeDiscriminant methodsFor: 'platypus-generated-group-accessing' stamp: ''!
discriminatedTypeDiscriminantFromValues: values
	| valuesloc |
	valuesloc := values asOrderedCollection.
	^ valuesloc

! !

!ExChdDiscriminatedTypeDiscriminant methodsFor: 'platypus-generated-group-accessing' stamp: ''!
discriminatedTypeDiscriminantToValues: values
	^ values

! !

!ExChdDiscriminatedTypeDiscriminant methodsFor: 'platypus-generated-group-accessing' stamp: ''!
fromValues: values
	^ self discriminatedTypeDiscriminantFromValues: (super fromValues: values)

! !

!ExChdDiscriminatedTypeDiscriminant methodsFor: 'platypus-generated-classifying' stamp: ''!
isExChdDiscriminatedTypeDiscriminant
	^ true

! !

!ExChdDiscriminatedTypeDiscriminant methodsFor: 'platypus-generated-group-accessing' stamp: ''!
localFromValues: values
	^ self discriminatedTypeDiscriminantFromValues: values

! !

!ExChdDiscriminatedTypeDiscriminant methodsFor: 'platypus-generated-group-accessing' stamp: ''!
localToValues: values
	^ self discriminatedTypeDiscriminantToValues: values

! !

!ExChdDiscriminatedTypeDiscriminant methodsFor: 'platypus-generated-copying' stamp: ''!
pltCopyGroup: aClassSymbol to: anObject
	self class name == aClassSymbol
		ifTrue: [ self pltCopyTo: anObject ]
		ifFalse: [ super pltCopyGroup: aClassSymbol to: anObject ]

! !

!ExChdDiscriminatedTypeDiscriminant methodsFor: 'platypus-generated-copying' stamp: ''!
pltCopyTo: another
	super pltCopyTo: another.
	self discriminatedTypeDiscriminantCopyTo: another

! !

!ExChdDiscriminatedTypeDiscriminant methodsFor: 'platypus-generated-copying' stamp: ''!
pltLocalCopyTo: another
	self discriminatedTypeDiscriminantCopyTo: another

! !

!ExChdDiscriminatedTypeDiscriminant methodsFor: 'platypus-generated-initializing' stamp: ''!
stepInitialize
	super stepInitialize

! !

!ExChdDiscriminatedTypeDiscriminant methodsFor: 'platypus-generated-group-accessing' stamp: ''!
toValues: values
	^ self discriminatedTypeDiscriminantToValues: (super toValues: values)

! !

PltExplicitAttribute subclass: #ExChdDiscriminatedTypeUnion
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Express2Cheddar-DiscriminatedTypeSchema'!

!ExChdDiscriminatedTypeUnion commentStamp: 'platypus comment' prior: 0!
<ISO10303-11-EXPRESS>
ENTITY discriminated_type_union 
	SUBTYPE OF ( explicit_attribute );
END_ENTITY;
</ISO10303-11-EXPRESS>!

!ExChdDiscriminatedTypeUnion class methodsFor: 'platypus-generated-platypus-signature' stamp: ''!
iso10303P11Translater
	^ 'Platypus (c) LISYC EA3883, Universite de Bretagne occidentale. Brest.'

! !

!ExChdDiscriminatedTypeUnion class methodsFor: 'platypus-generated-meta-data-accessing' stamp: ''!
schemaDefinition
	^ ExChdDiscriminatedTypeSchemaDefinition singleton

! !

!ExChdDiscriminatedTypeUnion class methodsFor: 'platypus-generated-meta-data-accessing' stamp: ''!
schemaInstance
	^ ExChdExpress2cheddarSchemaInstance singleton

! !

!ExChdDiscriminatedTypeUnion class methodsFor: 'platypus-generated-platypus-signature' stamp: ''!
translatedFromISO10303P11
	^ true

! !

!ExChdDiscriminatedTypeUnion class methodsFor: 'platypus-generated-platypus-signature' stamp: ''!
vwNamespaceName
	^ #Express2Cheddar

! !

!ExChdDiscriminatedTypeUnion methodsFor: 'platypus-generated-visiting' stamp: ''!
accept: aVisitor
	^ aVisitor acceptDiscriminatedTypeUnion: self

! !

!ExChdDiscriminatedTypeUnion methodsFor: 'platypus-generated-copying' stamp: ''!
discriminatedTypeUnionCopyTo: another
	

! !

!ExChdDiscriminatedTypeUnion methodsFor: 'platypus-generated-group-accessing' stamp: ''!
discriminatedTypeUnionFromValues: values
	| valuesloc |
	valuesloc := values asOrderedCollection.
	^ valuesloc

! !

!ExChdDiscriminatedTypeUnion methodsFor: 'platypus-generated-group-accessing' stamp: ''!
discriminatedTypeUnionToValues: values
	^ values

! !

!ExChdDiscriminatedTypeUnion methodsFor: 'platypus-generated-group-accessing' stamp: ''!
fromValues: values
	^ self discriminatedTypeUnionFromValues: (super fromValues: values)

! !

!ExChdDiscriminatedTypeUnion methodsFor: 'platypus-generated-classifying' stamp: ''!
isExChdDiscriminatedTypeUnion
	^ true

! !

!ExChdDiscriminatedTypeUnion methodsFor: 'platypus-generated-group-accessing' stamp: ''!
localFromValues: values
	^ self discriminatedTypeUnionFromValues: values

! !

!ExChdDiscriminatedTypeUnion methodsFor: 'platypus-generated-group-accessing' stamp: ''!
localToValues: values
	^ self discriminatedTypeUnionToValues: values

! !

!ExChdDiscriminatedTypeUnion methodsFor: 'platypus-generated-copying' stamp: ''!
pltCopyGroup: aClassSymbol to: anObject
	self class name == aClassSymbol
		ifTrue: [ self pltCopyTo: anObject ]
		ifFalse: [ super pltCopyGroup: aClassSymbol to: anObject ]

! !

!ExChdDiscriminatedTypeUnion methodsFor: 'platypus-generated-copying' stamp: ''!
pltCopyTo: another
	super pltCopyTo: another.
	self discriminatedTypeUnionCopyTo: another

! !

!ExChdDiscriminatedTypeUnion methodsFor: 'platypus-generated-copying' stamp: ''!
pltLocalCopyTo: another
	self discriminatedTypeUnionCopyTo: another

! !

!ExChdDiscriminatedTypeUnion methodsFor: 'platypus-generated-initializing' stamp: ''!
stepInitialize
	super stepInitialize

! !

!ExChdDiscriminatedTypeUnion methodsFor: 'platypus-generated-group-accessing' stamp: ''!
toValues: values
	^ self discriminatedTypeUnionToValues: (super toValues: values)

! !

PltStringType subclass: #ExChdCheddarXmlIdType
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Express2Cheddar-CheddarDomainsSchema'!

!ExChdCheddarXmlIdType commentStamp: 'platypus comment' prior: 0!
<ISO10303-11-EXPRESS>
ENTITY cheddar_xml_id_type 
	SUBTYPE OF ( string_type );
DERIVE
	SELF\ada_unbounded_string_type.ads_interfaces_list : LIST OF ada_interface := [ ada_interface ( 'ada.strings', 'unbounded.text_io', true, true ), ada_interface ( 'Text_io', ?, true, true ), ada_interface ( 'Unbounded_Strings', ?, true, true ), ada_interface ( 'Convert_Strings', ?, true, false ), ada_interface ( 'Convert_Unbounded_Strings', ?, true, false ), ada_interface ( 'id_generators', ?, true, true ) ];
	adb_interfaces_list : LIST OF ada_interface := [ ada_interface ( 'call_framework', ?, true, true ), ada_interface ( 'id_generators', ?, true, true ) ];
	ads_code : STRING := '';
	adb_code : STRING := '';
	put_prefix : STRING := '';
	refed_by_pointer : BOOLEAN := false;
	SELF\ada_unbounded_string_type.init_value : STRING := 'generate_id';
END_ENTITY;
</ISO10303-11-EXPRESS>!

!ExChdCheddarXmlIdType class methodsFor: 'platypus-generated-platypus-signature' stamp: ''!
iso10303P11Translater
	^ 'Platypus (c) LISYC EA3883, Universite de Bretagne occidentale. Brest.'

! !

!ExChdCheddarXmlIdType class methodsFor: 'platypus-generated-meta-data-accessing' stamp: ''!
schemaDefinition
	^ ExChdCheddarDomainsSchemaDefinition singleton

! !

!ExChdCheddarXmlIdType class methodsFor: 'platypus-generated-meta-data-accessing' stamp: ''!
schemaInstance
	^ ExChdExpress2cheddarSchemaInstance singleton

! !

!ExChdCheddarXmlIdType class methodsFor: 'platypus-generated-platypus-signature' stamp: ''!
translatedFromISO10303P11
	^ true

! !

!ExChdCheddarXmlIdType class methodsFor: 'platypus-generated-platypus-signature' stamp: ''!
vwNamespaceName
	^ #Express2Cheddar

! !

!ExChdCheddarXmlIdType methodsFor: 'platypus-generated-visiting' stamp: ''!
accept: aVisitor
	^ aVisitor acceptCheddarXmlIdType: self

! !

!ExChdCheddarXmlIdType methodsFor: 'platypus-generated-deriving' stamp: ''!
adbCode
	^ self adbCodeUsingContext: self class context

! !

!ExChdCheddarXmlIdType methodsFor: 'platypus-generated-deriving' stamp: ''!
adbCodeUsingContext: aContext
	^ self adbCodeUsingContext: aContext receiver: self

! !

!ExChdCheddarXmlIdType methodsFor: 'platypus-generated-deriving' stamp: ''!
adbCodeUsingContext: aContext receiver: aReceiver
	^ ''

! !

!ExChdCheddarXmlIdType methodsFor: 'platypus-generated-deriving' stamp: ''!
adbInterfacesList
	^ self adbInterfacesListUsingContext: self class context

! !

!ExChdCheddarXmlIdType methodsFor: 'platypus-generated-deriving' stamp: ''!
adbInterfacesListUsingContext: aContext
	^ self adbInterfacesListUsingContext: aContext receiver: self

! !

!ExChdCheddarXmlIdType methodsFor: 'platypus-generated-deriving' stamp: ''!
adbInterfacesListUsingContext: aContext receiver: aReceiver
	^ PlatypusCoreAggregateInitializer
		collectionFrom:
			(OrderedCollection new
				add:
						(ExChdAdaInterface new
								adaInterfaceFromValues:
										(OrderedCollection new
												add: 'call_framework';
												add: nil;
												add: true;
												add: true;
												yourself);
								yourself);
				add:
						(ExChdAdaInterface new
								adaInterfaceFromValues:
										(OrderedCollection new
												add: 'id_generators';
												add: nil;
												add: true;
												add: true;
												yourself);
								yourself);
				yourself)

! !

!ExChdCheddarXmlIdType methodsFor: 'platypus-generated-deriving' stamp: ''!
adsCode
	^ self adsCodeUsingContext: self class context

! !

!ExChdCheddarXmlIdType methodsFor: 'platypus-generated-deriving' stamp: ''!
adsCodeUsingContext: aContext
	^ self adsCodeUsingContext: aContext receiver: self

! !

!ExChdCheddarXmlIdType methodsFor: 'platypus-generated-deriving' stamp: ''!
adsCodeUsingContext: aContext receiver: aReceiver
	^ ''

! !

!ExChdCheddarXmlIdType methodsFor: 'platypus-generated-deriving' stamp: ''!
adsInterfacesList
	^ self adsInterfacesListUsingContext: self class context

! !

!ExChdCheddarXmlIdType methodsFor: 'platypus-generated-deriving' stamp: ''!
adsInterfacesListUsingContext: aContext
	^ self adsInterfacesListUsingContext: aContext receiver: self

! !

!ExChdCheddarXmlIdType methodsFor: 'platypus-generated-deriving' stamp: ''!
adsInterfacesListUsingContext: aContext receiver: aReceiver
	^ PlatypusCoreAggregateInitializer
		collectionFrom:
			(OrderedCollection new
				add:
						(ExChdAdaInterface new
								adaInterfaceFromValues:
										(OrderedCollection new
												add: 'ada.strings';
												add: 'unbounded.text_io';
												add: true;
												add: true;
												yourself);
								yourself);
				add:
						(ExChdAdaInterface new
								adaInterfaceFromValues:
										(OrderedCollection new
												add: 'Text_io';
												add: nil;
												add: true;
												add: true;
												yourself);
								yourself);
				add:
						(ExChdAdaInterface new
								adaInterfaceFromValues:
										(OrderedCollection new
												add: 'Unbounded_Strings';
												add: nil;
												add: true;
												add: true;
												yourself);
								yourself);
				add:
						(ExChdAdaInterface new
								adaInterfaceFromValues:
										(OrderedCollection new
												add: 'Convert_Strings';
												add: nil;
												add: true;
												add: false;
												yourself);
								yourself);
				add:
						(ExChdAdaInterface new
								adaInterfaceFromValues:
										(OrderedCollection new
												add: 'Convert_Unbounded_Strings';
												add: nil;
												add: true;
												add: false;
												yourself);
								yourself);
				add:
						(ExChdAdaInterface new
								adaInterfaceFromValues:
										(OrderedCollection new
												add: 'id_generators';
												add: nil;
												add: true;
												add: true;
												yourself);
								yourself);
				yourself)

! !

!ExChdCheddarXmlIdType methodsFor: 'platypus-generated-copying' stamp: ''!
cheddarXmlIdTypeCopyTo: another
	

! !

!ExChdCheddarXmlIdType methodsFor: 'platypus-generated-group-accessing' stamp: ''!
cheddarXmlIdTypeFromValues: values
	| valuesloc |
	valuesloc := values asOrderedCollection.
	^ valuesloc

! !

!ExChdCheddarXmlIdType methodsFor: 'platypus-generated-group-accessing' stamp: ''!
cheddarXmlIdTypeToValues: values
	^ values

! !

!ExChdCheddarXmlIdType methodsFor: 'platypus-generated-group-accessing' stamp: ''!
fromValues: values
	^ self cheddarXmlIdTypeFromValues: (super fromValues: values)

! !

!ExChdCheddarXmlIdType methodsFor: 'platypus-generated-deriving' stamp: ''!
initValue
	^ self initValueUsingContext: self class context

! !

!ExChdCheddarXmlIdType methodsFor: 'platypus-generated-deriving' stamp: ''!
initValueUsingContext: aContext
	^ self initValueUsingContext: aContext receiver: self

! !

!ExChdCheddarXmlIdType methodsFor: 'platypus-generated-deriving' stamp: ''!
initValueUsingContext: aContext receiver: aReceiver
	^ 'generate_id'

! !

!ExChdCheddarXmlIdType methodsFor: 'platypus-generated-classifying' stamp: ''!
isExChdCheddarXmlIdType
	^ true

! !

!ExChdCheddarXmlIdType methodsFor: 'platypus-generated-group-accessing' stamp: ''!
localFromValues: values
	^ self cheddarXmlIdTypeFromValues: values

! !

!ExChdCheddarXmlIdType methodsFor: 'platypus-generated-group-accessing' stamp: ''!
localToValues: values
	^ self cheddarXmlIdTypeToValues: values

! !

!ExChdCheddarXmlIdType methodsFor: 'platypus-generated-copying' stamp: ''!
pltCopyGroup: aClassSymbol to: anObject
	self class name == aClassSymbol
		ifTrue: [ self pltCopyTo: anObject ]
		ifFalse: [ super pltCopyGroup: aClassSymbol to: anObject ]

! !

!ExChdCheddarXmlIdType methodsFor: 'platypus-generated-copying' stamp: ''!
pltCopyTo: another
	super pltCopyTo: another.
	self cheddarXmlIdTypeCopyTo: another

! !

!ExChdCheddarXmlIdType methodsFor: 'platypus-generated-copying' stamp: ''!
pltLocalCopyTo: another
	self cheddarXmlIdTypeCopyTo: another

! !

!ExChdCheddarXmlIdType methodsFor: 'platypus-generated-deriving' stamp: ''!
putPrefix
	^ self putPrefixUsingContext: self class context

! !

!ExChdCheddarXmlIdType methodsFor: 'platypus-generated-deriving' stamp: ''!
putPrefixUsingContext: aContext
	^ self putPrefixUsingContext: aContext receiver: self

! !

!ExChdCheddarXmlIdType methodsFor: 'platypus-generated-deriving' stamp: ''!
putPrefixUsingContext: aContext receiver: aReceiver
	^ ''

! !

!ExChdCheddarXmlIdType methodsFor: 'platypus-generated-deriving' stamp: ''!
refedByPointer
	^ self refedByPointerUsingContext: self class context

! !

!ExChdCheddarXmlIdType methodsFor: 'platypus-generated-deriving' stamp: ''!
refedByPointerUsingContext: aContext
	^ self refedByPointerUsingContext: aContext receiver: self

! !

!ExChdCheddarXmlIdType methodsFor: 'platypus-generated-deriving' stamp: ''!
refedByPointerUsingContext: aContext receiver: aReceiver
	^ false

! !

!ExChdCheddarXmlIdType methodsFor: 'platypus-generated-initializing' stamp: ''!
stepInitialize
	super stepInitialize

! !

!ExChdCheddarXmlIdType methodsFor: 'platypus-generated-group-accessing' stamp: ''!
toValues: values
	^ self cheddarXmlIdTypeToValues: (super toValues: values)

! !

PltConstantDefinition subclass: #ExChdAdaConstant
	instanceVariableNames: 'final otherInitializer'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Express2Cheddar-CheddarConstantsSchema'!

!ExChdAdaConstant commentStamp: 'platypus comment' prior: 0!
<ISO10303-11-EXPRESS>
ENTITY ada_constant 
	SUBTYPE OF ( constant_definition );
	final : BOOLEAN;
	other_initializer : OPTIONAL STRING;
DERIVE
	ads_code : STRING := ada_constant_ads_code ( SELF );
	adb_code : STRING := '';
	ads_interfaces_list : LIST OF ada_interface := ada_constant_interfaces_list ( SELF, true );
	adb_interfaces_list : LIST OF ada_interface := [ ];
END_ENTITY;
</ISO10303-11-EXPRESS>!

!ExChdAdaConstant class methodsFor: 'platypus-generated-platypus-signature' stamp: ''!
iso10303P11Translater
	^ 'Platypus (c) LISYC EA3883, Universite de Bretagne occidentale. Brest.'

! !

!ExChdAdaConstant class methodsFor: 'platypus-generated-meta-data-accessing' stamp: ''!
schemaDefinition
	^ ExChdCheddarConstantsSchemaDefinition singleton

! !

!ExChdAdaConstant class methodsFor: 'platypus-generated-meta-data-accessing' stamp: ''!
schemaInstance
	^ ExChdExpress2cheddarSchemaInstance singleton

! !

!ExChdAdaConstant class methodsFor: 'platypus-generated-platypus-signature' stamp: ''!
translatedFromISO10303P11
	^ true

! !

!ExChdAdaConstant class methodsFor: 'platypus-generated-platypus-signature' stamp: ''!
vwNamespaceName
	^ #Express2Cheddar

! !

!ExChdAdaConstant methodsFor: 'platypus-generated-visiting' stamp: ''!
accept: aVisitor
	^ aVisitor acceptAdaConstant: self

! !

!ExChdAdaConstant methodsFor: 'platypus-generated-copying' stamp: ''!
adaConstantCopyTo: another
	another fastSetFinal: self final.
	another fastSetOtherInitializer: self otherInitializer

! !

!ExChdAdaConstant methodsFor: 'platypus-generated-group-accessing' stamp: ''!
adaConstantFromValues: values
	| valuesloc |
	valuesloc := values asOrderedCollection.
	self setFinal: valuesloc removeFirst.
	self setOtherInitializer: valuesloc removeFirst.
	^ valuesloc

! !

!ExChdAdaConstant methodsFor: 'platypus-generated-group-accessing' stamp: ''!
adaConstantToValues: values
	values add: self final.
	values add: self otherInitializer.
	^ values

! !

!ExChdAdaConstant methodsFor: 'platypus-generated-deriving' stamp: ''!
adbCode
	^ self adbCodeUsingContext: self class context

! !

!ExChdAdaConstant methodsFor: 'platypus-generated-deriving' stamp: ''!
adbCodeUsingContext: aContext
	^ self adbCodeUsingContext: aContext receiver: self

! !

!ExChdAdaConstant methodsFor: 'platypus-generated-deriving' stamp: ''!
adbCodeUsingContext: aContext receiver: aReceiver
	^ ''

! !

!ExChdAdaConstant methodsFor: 'platypus-generated-deriving' stamp: ''!
adbInterfacesList
	^ self adbInterfacesListUsingContext: self class context

! !

!ExChdAdaConstant methodsFor: 'platypus-generated-deriving' stamp: ''!
adbInterfacesListUsingContext: aContext
	^ self adbInterfacesListUsingContext: aContext receiver: self

! !

!ExChdAdaConstant methodsFor: 'platypus-generated-deriving' stamp: ''!
adbInterfacesListUsingContext: aContext receiver: aReceiver
	^ Array new

! !

!ExChdAdaConstant methodsFor: 'platypus-generated-deriving' stamp: ''!
adsCode
	^ self adsCodeUsingContext: self class context

! !

!ExChdAdaConstant methodsFor: 'platypus-generated-deriving' stamp: ''!
adsCodeUsingContext: aContext
	^ self adsCodeUsingContext: aContext receiver: self

! !

!ExChdAdaConstant methodsFor: 'platypus-generated-deriving' stamp: ''!
adsCodeUsingContext: aContext receiver: aReceiver
	^ ExChdAdaConstantAdsCodeFunction
		invokeFromValues:
			(OrderedCollection new
				add: aReceiver;
				yourself)

! !

!ExChdAdaConstant methodsFor: 'platypus-generated-deriving' stamp: ''!
adsInterfacesList
	^ self adsInterfacesListUsingContext: self class context

! !

!ExChdAdaConstant methodsFor: 'platypus-generated-deriving' stamp: ''!
adsInterfacesListUsingContext: aContext
	^ self adsInterfacesListUsingContext: aContext receiver: self

! !

!ExChdAdaConstant methodsFor: 'platypus-generated-deriving' stamp: ''!
adsInterfacesListUsingContext: aContext receiver: aReceiver
	^ ExChdAdaConstantInterfacesListFunction
		invokeFromValues:
			(OrderedCollection new
				add: aReceiver;
				add: true;
				yourself)

! !

!ExChdAdaConstant methodsFor: 'platypus-generated-fast-set-accessing' stamp: ''!
fastSetFinal: aBoolean
	final := aBoolean

! !

!ExChdAdaConstant methodsFor: 'platypus-generated-fast-set-accessing' stamp: ''!
fastSetOtherInitializer: aString
	otherInitializer := aString

! !

!ExChdAdaConstant methodsFor: 'platypus-generated-accessing' stamp: ''!
final
	^ final

! !

!ExChdAdaConstant methodsFor: 'platypus-generated-accessing' stamp: ''!
final: aBoolean
	final := aBoolean

! !

!ExChdAdaConstant methodsFor: 'platypus-generated-with-context-accessing' stamp: ''!
finalUsingContext: aContext
	^ self final

! !

!ExChdAdaConstant methodsFor: 'platypus-generated-group-accessing' stamp: ''!
fromValues: values
	^ self adaConstantFromValues: (super fromValues: values)

! !

!ExChdAdaConstant methodsFor: 'platypus-generated-classifying' stamp: ''!
isExChdAdaConstant
	^ true

! !

!ExChdAdaConstant methodsFor: 'platypus-generated-group-accessing' stamp: ''!
localFromValues: values
	^ self adaConstantFromValues: values

! !

!ExChdAdaConstant methodsFor: 'platypus-generated-group-accessing' stamp: ''!
localToValues: values
	^ self adaConstantToValues: values

! !

!ExChdAdaConstant methodsFor: 'platypus-generated-accessing' stamp: ''!
otherInitializer
	^ otherInitializer

! !

!ExChdAdaConstant methodsFor: 'platypus-generated-accessing' stamp: ''!
otherInitializer: aString
	otherInitializer := aString

! !

!ExChdAdaConstant methodsFor: 'platypus-generated-with-context-accessing' stamp: ''!
otherInitializerUsingContext: aContext
	^ self otherInitializer

! !

!ExChdAdaConstant methodsFor: 'platypus-generated-copying' stamp: ''!
pltCopyGroup: aClassSymbol to: anObject
	self class name == aClassSymbol
		ifTrue: [ self pltCopyTo: anObject ]
		ifFalse: [ super pltCopyGroup: aClassSymbol to: anObject ]

! !

!ExChdAdaConstant methodsFor: 'platypus-generated-copying' stamp: ''!
pltCopyTo: another
	super pltCopyTo: another.
	self adaConstantCopyTo: another

! !

!ExChdAdaConstant methodsFor: 'platypus-generated-copying' stamp: ''!
pltLocalCopyTo: another
	self adaConstantCopyTo: another

! !

!ExChdAdaConstant methodsFor: 'platypus-generated-set-accessing' stamp: ''!
setFinal: aBoolean
	self final: aBoolean

! !

!ExChdAdaConstant methodsFor: 'platypus-generated-set-accessing' stamp: ''!
setOtherInitializer: aString
	self otherInitializer: aString

! !

!ExChdAdaConstant methodsFor: 'platypus-generated-initializing' stamp: ''!
stepInitialize
	super stepInitialize.
	final := false.
	otherInitializer := nil

! !

!ExChdAdaConstant methodsFor: 'platypus-generated-group-accessing' stamp: ''!
toValues: values
	^ self adaConstantToValues: (super toValues: values)

! !

PlatypusCoreAlgorithmDeclaration subclass: #ExChdAdaClassAdbCodeFunction
	instanceVariableNames: 'cip code'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Express2Cheddar-RecordAndClassSchema'!

!ExChdAdaClassAdbCodeFunction commentStamp: 'platypus comment' prior: 0!
<ISO10303-11-EXPRESS>
FUNCTION ada_class_adb_code ( cip : ada_class ) : STRING;
	LOCAL 
		code : STRING;
	END_LOCAL;
	code := '\n' 
	+ '-- --------= ' + cip.name + ' =--------\n' 
	+ ada_class_initialize_code ( cip ) + '\n' 
	+ ada_class_copy_code ( cip ) + '\n' 
	+ ada_class_put_code ( cip ) + '\n';

	IF is_named_object ( cip ) THEN
		code := code + ada_class_get_name_code ( cip ) + '\n';
	END_IF;
	code := code + ada_class_typeof_code ( cip ) + '\n' 
	+ ada_class_xml_writer_code ( cip ) + '\n';
	RETURN ( code );
END_FUNCTION;
</ISO10303-11-EXPRESS>!

!ExChdAdaClassAdbCodeFunction class methodsFor: 'platypus-generated-platypus-signature' stamp: ''!
iso10303P11Translater
	^ 'Platypus (c) LISYC EA3883, Universite de Bretagne occidentale. Brest.'

! !

!ExChdAdaClassAdbCodeFunction class methodsFor: 'platypus-generated-meta-data-accessing' stamp: ''!
schemaDefinition
	^ ExChdRecordAndClassSchemaDefinition singleton

! !

!ExChdAdaClassAdbCodeFunction class methodsFor: 'platypus-generated-platypus-signature' stamp: ''!
translatedFromISO10303P11
	^ true

! !

!ExChdAdaClassAdbCodeFunction class methodsFor: 'platypus-generated-platypus-signature' stamp: ''!
vwNamespaceName
	^ #Express2Cheddar

! !

!ExChdAdaClassAdbCodeFunction methodsFor: 'platypus-generated-accessing' stamp: ''!
cip
	^ cip

! !

!ExChdAdaClassAdbCodeFunction methodsFor: 'platypus-generated-accessing' stamp: ''!
cip: aExChdAdaClass
	cip := aExChdAdaClass

! !

!ExChdAdaClassAdbCodeFunction methodsFor: 'platypus-generated-accessing' stamp: ''!
code
	^ code

! !

!ExChdAdaClassAdbCodeFunction methodsFor: 'platypus-generated-accessing' stamp: ''!
code: aString
	code := aString

! !

!ExChdAdaClassAdbCodeFunction methodsFor: 'platypus-generated-accessing' stamp: ''!
fromValues: values
	self cip: (values at: 1)

! !

!ExChdAdaClassAdbCodeFunction methodsFor: 'platypus-generated-invoking' stamp: ''!
invoke
	" ---------- locals assignments ----------"

	" ---------- statements ----------"

	self
		code:
			((((((((('\n' pltPlus: '-- --------= ') pltPlus: (self cip nameUsingContext: self class context))
				pltPlus: ' =--------\n')
				pltPlus:
					(ExChdAdaClassInitializeCodeFunction
						invokeFromValues:
							(OrderedCollection new
								add: self cip;
								yourself))) pltPlus: '\n')
				pltPlus:
					(ExChdAdaClassCopyCodeFunction
						invokeFromValues:
							(OrderedCollection new
								add: self cip;
								yourself))) pltPlus: '\n')
				pltPlus:
					(ExChdAdaClassPutCodeFunction
						invokeFromValues:
							(OrderedCollection new
								add: self cip;
								yourself))) pltPlus: '\n').
	(ExChdIsNamedObjectFunction
		invokeFromValues:
			(OrderedCollection new
				add: self cip;
				yourself))
		ifTrue: [ 
			self
				code:
					((self code
						pltPlus:
							(ExChdAdaClassGetNameCodeFunction
								invokeFromValues:
									(OrderedCollection new
										add: self cip;
										yourself))) pltPlus: '\n') ].
	self
		code:
			((((self code
				pltPlus:
					(ExChdAdaClassTypeofCodeFunction
						invokeFromValues:
							(OrderedCollection new
								add: self cip;
								yourself))) pltPlus: '\n')
				pltPlus:
					(ExChdAdaClassXmlWriterCodeFunction
						invokeFromValues:
							(OrderedCollection new
								add: self cip;
								yourself))) pltPlus: '\n').
	^ self return: self code

! !

PlatypusCoreAlgorithmDeclaration subclass: #ExChdAdaClassAdsCodeFunction
	instanceVariableNames: 'cip withPrivate result abstr localSup'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Express2Cheddar-RecordAndClassSchema'!

!ExChdAdaClassAdsCodeFunction commentStamp: 'platypus comment' prior: 0!
<ISO10303-11-EXPRESS>
FUNCTION ada_class_ads_code ( cip : ada_class; with_private : BOOLEAN ) : STRING;
	LOCAL 
		result : STRING;
		abstr : STRING := '';
		local_sup : entity_definition := local_root_supertype_of ( cip );
	END_LOCAL;
	result := '\n' 
	+ '-- --------= ' + cip.name + ' =--------\n\n' 

	+ 'type ' + cip.name + ';' + '\ntype ' + cip.ptr_type + ' is access all ' + cip.name + '''Class;\n';

	IF SIZEOF ( cip.supertypes ) > 0 THEN

		ALIAS supref FOR cip.supertypes [ 1 ].ref;
			result := result + 'type ' + cip.name + ' is ' + abstr + 'new ' + supref.ada_ident + ' with ';
		END_ALIAS;
	ELSE
		result := result + 'type ' + cip.name + ' is ' + abstr + 'new Ada.Finalization.Controlled with ';
	END_IF;

	IF with_private THEN
		result := result + 'private;\n';
	ELSE
		result := result + ada_class_attributes_ads_code ( cip );
	END_IF;
	result := result + '\nprocedure Initialize(obj : in out ' + cip.name + ');\n' 
	+ 'procedure Put(obj : in ' + cip.name + ');\n' 
	+ 'procedure Put(obj : in ' + cip.ptr_type + ');\n';
	result := result + 'procedure Put_Name(obj : in ' + cip.ptr_type + ');\n';
	result := result + 'procedure Build_Attributes_XML_String(obj : in ' + cip.name + '; result : in out Unbounded_String);\n' 
	+ 'function XML_String(obj : in ' + cip.name + ') return Unbounded_String;\n' 
	+ 'function XML_String(obj : in ' + cip.ptr_type + ') return Unbounded_String;\n' 
	+ 'function XML_Ref_String(obj : in ' + cip.name + ') return Unbounded_String;\n' 
	+ 'function XML_Ref_String(obj : in ' + cip.ptr_type + ') return Unbounded_String;\n';

	IF is_named_object ( cip ) THEN
		result := result + 'function Get_Name (obj : in ' + cip.name + ') return Unbounded_String;\n' 
		+ 'function Get_Name (obj : in ' + cip.ptr_type + ') return Unbounded_String;\n';
	END_IF;
	result := result + 'function Copy(obj : in ' + cip.ptr_type + ') return ' + local_sup.ptr_type + ';\n' 
	+ 'function Copy(obj : in ' + cip.name + ') return ' + local_sup.ptr_type + ';\n' 
	+ 'function type_of(obj : in ' + cip.name + ') return unbounded_string_list;\n' 
	+ 'function type_of(obj : in ' + cip.ptr_type + ') return unbounded_string_list;\n' 
	+ 'procedure Free  is new Unchecked_Deallocation (' + cip.name + '''Class, ' + cip.ptr_type + ');\n';
	RETURN ( result );
END_FUNCTION;
</ISO10303-11-EXPRESS>!

!ExChdAdaClassAdsCodeFunction class methodsFor: 'platypus-generated-platypus-signature' stamp: ''!
iso10303P11Translater
	^ 'Platypus (c) LISYC EA3883, Universite de Bretagne occidentale. Brest.'

! !

!ExChdAdaClassAdsCodeFunction class methodsFor: 'platypus-generated-meta-data-accessing' stamp: ''!
schemaDefinition
	^ ExChdRecordAndClassSchemaDefinition singleton

! !

!ExChdAdaClassAdsCodeFunction class methodsFor: 'platypus-generated-platypus-signature' stamp: ''!
translatedFromISO10303P11
	^ true

! !

!ExChdAdaClassAdsCodeFunction class methodsFor: 'platypus-generated-platypus-signature' stamp: ''!
vwNamespaceName
	^ #Express2Cheddar

! !

!ExChdAdaClassAdsCodeFunction methodsFor: 'platypus-generated-accessing' stamp: ''!
abstr
	^ abstr

! !

!ExChdAdaClassAdsCodeFunction methodsFor: 'platypus-generated-accessing' stamp: ''!
abstr: aString1
	abstr := aString1

! !

!ExChdAdaClassAdsCodeFunction methodsFor: 'platypus-generated-accessing' stamp: ''!
cip
	^ cip

! !

!ExChdAdaClassAdsCodeFunction methodsFor: 'platypus-generated-accessing' stamp: ''!
cip: aExChdAdaClass
	cip := aExChdAdaClass

! !

!ExChdAdaClassAdsCodeFunction methodsFor: 'platypus-generated-accessing' stamp: ''!
cip: aExChdAdaClass withPrivate: aBoolean
	self cip: aExChdAdaClass.
	self withPrivate: aBoolean

! !

!ExChdAdaClassAdsCodeFunction methodsFor: 'platypus-generated-accessing' stamp: ''!
fromValues: values
	self cip: (values at: 1).
	self withPrivate: (values at: 2)

! !

!ExChdAdaClassAdsCodeFunction methodsFor: 'platypus-generated-invoking' stamp: ''!
invoke
	" ---------- locals assignments ----------"

	self abstr: ''.
	self
		localSup:
			(PTsLocalRootSupertypeOfFunction
				invokeFromValues:
					(OrderedCollection new
						add: self cip;
						yourself)).	" ---------- statements ----------"
	self
		result:
			((((((((((('\n' pltPlus: '-- --------= ') pltPlus: (self cip nameUsingContext: self class context))
				pltPlus: ' =--------\n\n') pltPlus: 'type ') pltPlus: (self cip nameUsingContext: self class context)) pltPlus: ';')
				pltPlus: '\ntype ') pltPlus: (self cip ptrTypeUsingContext: self class context)) pltPlus: ' is access all ')
				pltPlus: (self cip nameUsingContext: self class context)) pltPlus: '''Class;\n').
	(PltSIZEOFFunction
		invokeFromValues:
			(OrderedCollection new
				add: (self cip supertypesUsingContext: self class context);
				yourself)) > 0
		ifTrue: [ 
			PlatypusCoreAliasStatement
				alias: (((self cip supertypesUsingContext: self class context) pltAt: 1) refUsingContext: self class context)
				statementsBlock: [ :supref500 | 
					self
						result:
							(((((((self result pltPlus: 'type ') pltPlus: (self cip nameUsingContext: self class context)) pltPlus: ' is ')
								pltPlus: self abstr) pltPlus: 'new ') pltPlus: (supref500 adaIdentUsingContext: self class context))
								pltPlus: ' with ') ] ]
		ifFalse: [ 
			self
				result:
					(((((self result pltPlus: 'type ') pltPlus: (self cip nameUsingContext: self class context)) pltPlus: ' is ')
						pltPlus: self abstr) pltPlus: 'new Ada.Finalization.Controlled with ') ].
	self withPrivate
		ifTrue: [ self result: (self result pltPlus: 'private;\n') ]
		ifFalse: [ 
			self
				result:
					(self result
						pltPlus:
							(ExChdAdaClassAttributesAdsCodeFunction
								invokeFromValues:
									(OrderedCollection new
										add: self cip;
										yourself))) ].
	self
		result:
			(((((((((self result pltPlus: '\nprocedure Initialize(obj : in out ')
				pltPlus: (self cip nameUsingContext: self class context)) pltPlus: ');\n') pltPlus: 'procedure Put(obj : in ')
				pltPlus: (self cip nameUsingContext: self class context)) pltPlus: ');\n') pltPlus: 'procedure Put(obj : in ')
				pltPlus: (self cip ptrTypeUsingContext: self class context)) pltPlus: ');\n').
	self
		result:
			(((self result pltPlus: 'procedure Put_Name(obj : in ') pltPlus: (self cip ptrTypeUsingContext: self class context))
				pltPlus: ');\n').
	self
		result:
			(((((((((((((((self result pltPlus: 'procedure Build_Attributes_XML_String(obj : in ')
				pltPlus: (self cip nameUsingContext: self class context)) pltPlus: '; result : in out Unbounded_String);\n')
				pltPlus: 'function XML_String(obj : in ') pltPlus: (self cip nameUsingContext: self class context))
				pltPlus: ') return Unbounded_String;\n') pltPlus: 'function XML_String(obj : in ')
				pltPlus: (self cip ptrTypeUsingContext: self class context)) pltPlus: ') return Unbounded_String;\n')
				pltPlus: 'function XML_Ref_String(obj : in ') pltPlus: (self cip nameUsingContext: self class context))
				pltPlus: ') return Unbounded_String;\n') pltPlus: 'function XML_Ref_String(obj : in ')
				pltPlus: (self cip ptrTypeUsingContext: self class context)) pltPlus: ') return Unbounded_String;\n').
	(ExChdIsNamedObjectFunction
		invokeFromValues:
			(OrderedCollection new
				add: self cip;
				yourself))
		ifTrue: [ 
			self
				result:
					((((((self result pltPlus: 'function Get_Name (obj : in ') pltPlus: (self cip nameUsingContext: self class context))
						pltPlus: ') return Unbounded_String;\n') pltPlus: 'function Get_Name (obj : in ')
						pltPlus: (self cip ptrTypeUsingContext: self class context)) pltPlus: ') return Unbounded_String;\n') ].
	self
		result:
			(((((((((((((((((((((self result pltPlus: 'function Copy(obj : in ')
				pltPlus: (self cip ptrTypeUsingContext: self class context)) pltPlus: ') return ')
				pltPlus: (self localSup ptrTypeUsingContext: self class context)) pltPlus: ';\n') pltPlus: 'function Copy(obj : in ')
				pltPlus: (self cip nameUsingContext: self class context)) pltPlus: ') return ')
				pltPlus: (self localSup ptrTypeUsingContext: self class context)) pltPlus: ';\n')
				pltPlus: 'function type_of(obj : in ') pltPlus: (self cip nameUsingContext: self class context))
				pltPlus: ') return unbounded_string_list;\n') pltPlus: 'function type_of(obj : in ')
				pltPlus: (self cip ptrTypeUsingContext: self class context)) pltPlus: ') return unbounded_string_list;\n')
				pltPlus: 'procedure Free  is new Unchecked_Deallocation (') pltPlus: (self cip nameUsingContext: self class context))
				pltPlus: '''Class, ') pltPlus: (self cip ptrTypeUsingContext: self class context)) pltPlus: ');\n').
	^ self return: self result

! !

!ExChdAdaClassAdsCodeFunction methodsFor: 'platypus-generated-accessing' stamp: ''!
localSup
	^ localSup

! !

!ExChdAdaClassAdsCodeFunction methodsFor: 'platypus-generated-accessing' stamp: ''!
localSup: aExChdEntityDefinition
	localSup := aExChdEntityDefinition

! !

!ExChdAdaClassAdsCodeFunction methodsFor: 'platypus-generated-accessing' stamp: ''!
result
	^ result

! !

!ExChdAdaClassAdsCodeFunction methodsFor: 'platypus-generated-accessing' stamp: ''!
result: aString
	result := aString

! !

!ExChdAdaClassAdsCodeFunction methodsFor: 'platypus-generated-accessing' stamp: ''!
withPrivate
	^ withPrivate

! !

!ExChdAdaClassAdsCodeFunction methodsFor: 'platypus-generated-accessing' stamp: ''!
withPrivate: aBoolean
	withPrivate := aBoolean

! !

PlatypusCoreAlgorithmDeclaration subclass: #ExChdAdaClassAttributesAdsCodeFunction
	instanceVariableNames: 'cip result domain'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Express2Cheddar-RecordAndClassSchema'!

!ExChdAdaClassAttributesAdsCodeFunction commentStamp: 'platypus comment' prior: 0!
<ISO10303-11-EXPRESS>
FUNCTION ada_class_attributes_ads_code ( cip : ada_class ) : STRING;
	LOCAL 
		result : STRING;
		domain : entity_instance;
	END_LOCAL;

	IF SIZEOF ( cip.explicit_attributes ) = 0 THEN
		result := 'null record;\n';
	ELSE
		result := '\nrecord\n';

		REPEAT no := LOINDEX ( cip.explicit_attributes ) TO HIINDEX ( cip.explicit_attributes );
			ALIAS attr FOR cip.explicit_attributes [ no];
				domain := basic_ada_domain ( attr.domain );
				IF ( 'RECORD_AND_CLASS.ADA_CLASS' IN TYPEOF ( domain.handled ) ) OR ( 'DISCRIMINATED_TYPE.DISCRIMINATED_TYPE' IN TYPEOF ( domain.handled ) ) THEN
					result := result + ' ' + attr.name + ' : ' + domain.handled.ptr_type + ';\n';
				ELSE
					result := result + ' ' + attr.name + ' : ' + domain.ada_ref_ident + ';\n';
				END_IF;
			END_ALIAS;
		END_REPEAT;
		result := result + 'end record;\n';
	END_IF;
	RETURN ( result );
END_FUNCTION;
</ISO10303-11-EXPRESS>!

!ExChdAdaClassAttributesAdsCodeFunction class methodsFor: 'platypus-generated-platypus-signature' stamp: ''!
iso10303P11Translater
	^ 'Platypus (c) LISYC EA3883, Universite de Bretagne occidentale. Brest.'

! !

!ExChdAdaClassAttributesAdsCodeFunction class methodsFor: 'platypus-generated-meta-data-accessing' stamp: ''!
schemaDefinition
	^ ExChdRecordAndClassSchemaDefinition singleton

! !

!ExChdAdaClassAttributesAdsCodeFunction class methodsFor: 'platypus-generated-platypus-signature' stamp: ''!
translatedFromISO10303P11
	^ true

! !

!ExChdAdaClassAttributesAdsCodeFunction class methodsFor: 'platypus-generated-platypus-signature' stamp: ''!
vwNamespaceName
	^ #Express2Cheddar

! !

!ExChdAdaClassAttributesAdsCodeFunction methodsFor: 'platypus-generated-accessing' stamp: ''!
cip
	^ cip

! !

!ExChdAdaClassAttributesAdsCodeFunction methodsFor: 'platypus-generated-accessing' stamp: ''!
cip: aExChdAdaClass
	cip := aExChdAdaClass

! !

!ExChdAdaClassAttributesAdsCodeFunction methodsFor: 'platypus-generated-accessing' stamp: ''!
domain
	^ domain

! !

!ExChdAdaClassAttributesAdsCodeFunction methodsFor: 'platypus-generated-accessing' stamp: ''!
domain: aExChdEntityInstance
	domain := aExChdEntityInstance

! !

!ExChdAdaClassAttributesAdsCodeFunction methodsFor: 'platypus-generated-accessing' stamp: ''!
fromValues: values
	self cip: (values at: 1)

! !

!ExChdAdaClassAttributesAdsCodeFunction methodsFor: 'platypus-generated-invoking' stamp: ''!
invoke
	" ---------- locals assignments ----------"

	" ---------- statements ----------"

	(PltSIZEOFFunction
		invokeFromValues:
			(OrderedCollection new
				add: (self cip explicitAttributesUsingContext: self class context);
				yourself)) = 0
		ifTrue: [ self result: 'null record;\n' ]
		ifFalse: [ 
			self result: '\nrecord\n'.
			PlatypusCoreRepeatStatement
				repeat: [ :no574 | 
					PlatypusCoreAliasStatement
						alias: ((self cip explicitAttributesUsingContext: self class context) pltAt: no574)
						statementsBlock: [ :attr3281 | 
							self
								domain:
									(ExChdBasicAdaDomainFunction
										invokeFromValues:
											(OrderedCollection new
												add: (attr3281 domainUsingContext: self class context);
												yourself)).
							(((PltTYPEOFFunction
								invokeFromValues:
									(OrderedCollection new
										add: (self domain handledUsingContext: self class context);
										yourself)) includes: 'RECORD_AND_CLASS.ADA_CLASS')
								or: [ 
									(PltTYPEOFFunction
										invokeFromValues:
											(OrderedCollection new
												add: (self domain handledUsingContext: self class context);
												yourself)) includes: 'DISCRIMINATED_TYPE.DISCRIMINATED_TYPE' ])
								ifTrue: [ 
									self
										result:
											(((((self result pltPlus: ' ') pltPlus: (attr3281 nameUsingContext: self class context)) pltPlus: ' : ')
												pltPlus: ((self domain handledUsingContext: self class context) ptrTypeUsingContext: self class context))
												pltPlus: ';\n') ]
								ifFalse: [ 
									self
										result:
											(((((self result pltPlus: ' ') pltPlus: (attr3281 nameUsingContext: self class context)) pltPlus: ' : ')
												pltPlus: (self domain adaRefIdentUsingContext: self class context)) pltPlus: ';\n') ] ] ]
				from:
					(PltLOINDEXFunction
						invokeFromValues:
							(OrderedCollection new
								add: (self cip explicitAttributesUsingContext: self class context);
								yourself))
				to:
					(PltHIINDEXFunction
						invokeFromValues:
							(OrderedCollection new
								add: (self cip explicitAttributesUsingContext: self class context);
								yourself)).
			self result: (self result pltPlus: 'end record;\n') ].
	^ self return: self result

! !

!ExChdAdaClassAttributesAdsCodeFunction methodsFor: 'platypus-generated-accessing' stamp: ''!
result
	^ result

! !

!ExChdAdaClassAttributesAdsCodeFunction methodsFor: 'platypus-generated-accessing' stamp: ''!
result: aString
	result := aString

! !

PlatypusCoreAlgorithmDeclaration subclass: #ExChdAdaClassCopyCodeFunction
	instanceVariableNames: 'cip code v localSup'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Express2Cheddar-RecordAndClassSchema'!

!ExChdAdaClassCopyCodeFunction commentStamp: 'platypus comment' prior: 0!
<ISO10303-11-EXPRESS>
FUNCTION ada_class_copy_code ( cip : ada_class ) : STRING;
	LOCAL 
		code : STRING;
		v : STRING := 'New_' + cip.name;
		local_sup : entity_definition := local_root_supertype_of ( cip );
	END_LOCAL;
	code := 'function Copy ( obj : in ' + cip.name + ' ) return ' + local_sup.ptr_type + ' is\n' 
	+ '\t' + v + ' : ' + cip.ptr_type + ';\n' 
	+ 'begin\n' 
	+ '\t' + v + ' := new ' + cip.name + '''(obj);\n';

	IF local_sup.ptr_type <> cip.ptr_type THEN
		code := code + '\treturn ' + local_sup.ptr_type + '(' + v + ');\n';
	ELSE
		code := code + '\treturn (' + v + ');\n';
	END_IF;
	code := code + 'end Copy;\n\n' 

	+ 'function Copy ( obj : in ' + cip.ptr_type + ' ) return ' + local_sup.ptr_type + ' is\n' 
	+ 'begin\n' 
	+ '\treturn copy(obj.all);\n' 
	+ 'end Copy;\n';
	RETURN ( code );
END_FUNCTION;
</ISO10303-11-EXPRESS>!

!ExChdAdaClassCopyCodeFunction class methodsFor: 'platypus-generated-platypus-signature' stamp: ''!
iso10303P11Translater
	^ 'Platypus (c) LISYC EA3883, Universite de Bretagne occidentale. Brest.'

! !

!ExChdAdaClassCopyCodeFunction class methodsFor: 'platypus-generated-meta-data-accessing' stamp: ''!
schemaDefinition
	^ ExChdRecordAndClassSchemaDefinition singleton

! !

!ExChdAdaClassCopyCodeFunction class methodsFor: 'platypus-generated-platypus-signature' stamp: ''!
translatedFromISO10303P11
	^ true

! !

!ExChdAdaClassCopyCodeFunction class methodsFor: 'platypus-generated-platypus-signature' stamp: ''!
vwNamespaceName
	^ #Express2Cheddar

! !

!ExChdAdaClassCopyCodeFunction methodsFor: 'platypus-generated-accessing' stamp: ''!
cip
	^ cip

! !

!ExChdAdaClassCopyCodeFunction methodsFor: 'platypus-generated-accessing' stamp: ''!
cip: aExChdAdaClass
	cip := aExChdAdaClass

! !

!ExChdAdaClassCopyCodeFunction methodsFor: 'platypus-generated-accessing' stamp: ''!
code
	^ code

! !

!ExChdAdaClassCopyCodeFunction methodsFor: 'platypus-generated-accessing' stamp: ''!
code: aString
	code := aString

! !

!ExChdAdaClassCopyCodeFunction methodsFor: 'platypus-generated-accessing' stamp: ''!
fromValues: values
	self cip: (values at: 1)

! !

!ExChdAdaClassCopyCodeFunction methodsFor: 'platypus-generated-invoking' stamp: ''!
invoke
	" ---------- locals assignments ----------"

	self v: ('New_' pltPlus: (self cip nameUsingContext: self class context)).
	self
		localSup:
			(PTsLocalRootSupertypeOfFunction
				invokeFromValues:
					(OrderedCollection new
						add: self cip;
						yourself)).	" ---------- statements ----------"
	self
		code:
			((((((((((((((('function Copy ( obj : in ' pltPlus: (self cip nameUsingContext: self class context))
				pltPlus: ' ) return ') pltPlus: (self localSup ptrTypeUsingContext: self class context)) pltPlus: ' is\n')
				pltPlus: '\t') pltPlus: self v) pltPlus: ' : ') pltPlus: (self cip ptrTypeUsingContext: self class context))
				pltPlus: ';\n') pltPlus: 'begin\n') pltPlus: '\t') pltPlus: self v) pltPlus: ' := new ')
				pltPlus: (self cip nameUsingContext: self class context)) pltPlus: '''(obj);\n').
	(self localSup ptrTypeUsingContext: self class context) ~= (self cip ptrTypeUsingContext: self class context)
		ifTrue: [ 
			self
				code:
					(((((self code pltPlus: '\treturn ') pltPlus: (self localSup ptrTypeUsingContext: self class context)) pltPlus: '(')
						pltPlus: self v) pltPlus: ');\n') ]
		ifFalse: [ self code: (((self code pltPlus: '\treturn (') pltPlus: self v) pltPlus: ');\n') ].
	self
		code:
			(((((((((self code pltPlus: 'end Copy;\n\n') pltPlus: 'function Copy ( obj : in ')
				pltPlus: (self cip ptrTypeUsingContext: self class context)) pltPlus: ' ) return ')
				pltPlus: (self localSup ptrTypeUsingContext: self class context)) pltPlus: ' is\n') pltPlus: 'begin\n')
				pltPlus: '\treturn copy(obj.all);\n') pltPlus: 'end Copy;\n').
	^ self return: self code

! !

!ExChdAdaClassCopyCodeFunction methodsFor: 'platypus-generated-accessing' stamp: ''!
localSup
	^ localSup

! !

!ExChdAdaClassCopyCodeFunction methodsFor: 'platypus-generated-accessing' stamp: ''!
localSup: aExChdEntityDefinition
	localSup := aExChdEntityDefinition

! !

!ExChdAdaClassCopyCodeFunction methodsFor: 'platypus-generated-accessing' stamp: ''!
v
	^ v

! !

!ExChdAdaClassCopyCodeFunction methodsFor: 'platypus-generated-accessing' stamp: ''!
v: aString1
	v := aString1

! !

PlatypusCoreAlgorithmDeclaration subclass: #ExChdAdaClassGetNameCodeFunction
	instanceVariableNames: 'cip code'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Express2Cheddar-RecordAndClassSchema'!

!ExChdAdaClassGetNameCodeFunction commentStamp: 'platypus comment' prior: 0!
<ISO10303-11-EXPRESS>
FUNCTION ada_class_get_name_code ( cip : ada_class ) : STRING;
	LOCAL 
		code : STRING;
	END_LOCAL;
	code := 'function Get_Name (obj : in ' + cip.name + ') return Unbounded_String is\n' 
	+ 'begin\n';

	IF has_inherited_attribute_named ( cip, 'name' ) THEN
		code := code + '	return obj.name;\n';
	ELSE
		code := code + '	return obj.' + xml_id_name + ';\n';
	END_IF;
	code := code + 'end Get_Name;\n\n' 

	+ 'function Get_Name (obj : in ' + cip.name + '_ptr) return Unbounded_String is\n' 
	+ 'begin\n';

	IF has_inherited_attribute_named ( cip, 'name' ) THEN
		code := code + '	return obj.name;\n';
	ELSE
		code := code + '	return obj.' + xml_id_name + ';\n';
	END_IF;
	code := code + 'end Get_Name;\n';
	RETURN ( code );
END_FUNCTION;
</ISO10303-11-EXPRESS>!

!ExChdAdaClassGetNameCodeFunction class methodsFor: 'platypus-generated-platypus-signature' stamp: ''!
iso10303P11Translater
	^ 'Platypus (c) LISYC EA3883, Universite de Bretagne occidentale. Brest.'

! !

!ExChdAdaClassGetNameCodeFunction class methodsFor: 'platypus-generated-meta-data-accessing' stamp: ''!
schemaDefinition
	^ ExChdRecordAndClassSchemaDefinition singleton

! !

!ExChdAdaClassGetNameCodeFunction class methodsFor: 'platypus-generated-platypus-signature' stamp: ''!
translatedFromISO10303P11
	^ true

! !

!ExChdAdaClassGetNameCodeFunction class methodsFor: 'platypus-generated-platypus-signature' stamp: ''!
vwNamespaceName
	^ #Express2Cheddar

! !

!ExChdAdaClassGetNameCodeFunction methodsFor: 'platypus-generated-accessing' stamp: ''!
cip
	^ cip

! !

!ExChdAdaClassGetNameCodeFunction methodsFor: 'platypus-generated-accessing' stamp: ''!
cip: aExChdAdaClass
	cip := aExChdAdaClass

! !

!ExChdAdaClassGetNameCodeFunction methodsFor: 'platypus-generated-accessing' stamp: ''!
code
	^ code

! !

!ExChdAdaClassGetNameCodeFunction methodsFor: 'platypus-generated-accessing' stamp: ''!
code: aString
	code := aString

! !

!ExChdAdaClassGetNameCodeFunction methodsFor: 'platypus-generated-accessing' stamp: ''!
fromValues: values
	self cip: (values at: 1)

! !

!ExChdAdaClassGetNameCodeFunction methodsFor: 'platypus-generated-invoking' stamp: ''!
invoke
	" ---------- locals assignments ----------"

	" ---------- statements ----------"

	self
		code:
			((('function Get_Name (obj : in ' pltPlus: (self cip nameUsingContext: self class context))
				pltPlus: ') return Unbounded_String is\n') pltPlus: 'begin\n').
	(PTsHasInheritedAttributeNamedFunction
		invokeFromValues:
			(OrderedCollection new
				add: self cip;
				add: 'name';
				yourself))
		ifTrue: [ self code: (self code pltPlus: '	return obj.name;\n') ]
		ifFalse: [ self code: (((self code pltPlus: '	return obj.') pltPlus: 'cheddar_private_id') pltPlus: ';\n') ].
	self
		code:
			(((((self code pltPlus: 'end Get_Name;\n\n') pltPlus: 'function Get_Name (obj : in ')
				pltPlus: (self cip nameUsingContext: self class context)) pltPlus: '_ptr) return Unbounded_String is\n')
				pltPlus: 'begin\n').
	(PTsHasInheritedAttributeNamedFunction
		invokeFromValues:
			(OrderedCollection new
				add: self cip;
				add: 'name';
				yourself))
		ifTrue: [ self code: (self code pltPlus: '	return obj.name;\n') ]
		ifFalse: [ self code: (((self code pltPlus: '	return obj.') pltPlus: 'cheddar_private_id') pltPlus: ';\n') ].
	self code: (self code pltPlus: 'end Get_Name;\n').
	^ self return: self code

! !

PlatypusCoreAlgorithmDeclaration subclass: #ExChdAdaClassInitializeCodeFunction
	instanceVariableNames: 'cip code innerCode attrs init'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Express2Cheddar-RecordAndClassSchema'!

!ExChdAdaClassInitializeCodeFunction commentStamp: 'platypus comment' prior: 0!
<ISO10303-11-EXPRESS>
FUNCTION ada_class_initialize_code ( cip : ada_class ) : STRING;
	LOCAL 
		code : STRING;
		innerCode : STRING := '';
		attrs : LIST OF attribute;
		init : STRING;
	END_LOCAL;
	code := '\nprocedure Initialize(obj : in out ' + cip.name + ') is \nbegin\n';

	IF SIZEOF ( cip.supertypes ) > 0 THEN

		ALIAS sup FOR cip.supertypes [ LOINDEX ( cip.supertypes ) ].handled;
			innerCode := innerCode + '\tinitialize(' + sup.name + '(obj));\n';
		END_ALIAS;
	END_IF;

	REPEAT no := LOINDEX ( cip.explicit_attributes ) TO HIINDEX ( cip.explicit_attributes );

		ALIAS attr FOR cip.explicit_attributes [ no];
			init := explicit_attribute_initialize ( attr );
			IF ( EXISTS ( init ) AND ( init > '' ) ) THEN
				innerCode := innerCode + '\t' + init + '\n';
			END_IF;
		END_ALIAS;
	END_REPEAT;

	REPEAT no := LOINDEX ( cip.derived_attributes ) TO HIINDEX ( cip.derived_attributes );

		ALIAS attr FOR cip.derived_attributes [ no];
			init := derived_attribute_initialize ( attr );
			IF ( EXISTS ( init ) AND ( init > '' ) ) THEN
				innerCode := innerCode + '\t' + init + '\n';
			END_IF;
		END_ALIAS;
	END_REPEAT;

	IF innerCode = '' THEN
		innerCode := '\tnull;\n';
	END_IF;
	code := code + innerCode + 'end Initialize;\n';
	RETURN ( code );
END_FUNCTION;
</ISO10303-11-EXPRESS>!

!ExChdAdaClassInitializeCodeFunction class methodsFor: 'platypus-generated-platypus-signature' stamp: ''!
iso10303P11Translater
	^ 'Platypus (c) LISYC EA3883, Universite de Bretagne occidentale. Brest.'

! !

!ExChdAdaClassInitializeCodeFunction class methodsFor: 'platypus-generated-meta-data-accessing' stamp: ''!
schemaDefinition
	^ ExChdRecordAndClassSchemaDefinition singleton

! !

!ExChdAdaClassInitializeCodeFunction class methodsFor: 'platypus-generated-platypus-signature' stamp: ''!
translatedFromISO10303P11
	^ true

! !

!ExChdAdaClassInitializeCodeFunction class methodsFor: 'platypus-generated-platypus-signature' stamp: ''!
vwNamespaceName
	^ #Express2Cheddar

! !

!ExChdAdaClassInitializeCodeFunction methodsFor: 'platypus-generated-accessing' stamp: ''!
attrs
	^ attrs

! !

!ExChdAdaClassInitializeCodeFunction methodsFor: 'platypus-generated-accessing' stamp: ''!
attrs: aListOfExChdAttribute
	attrs := aListOfExChdAttribute
		ifNil: [ OrderedCollection new ]
		ifNotNil: [ aListOfExChdAttribute as: OrderedCollection ]

! !

!ExChdAdaClassInitializeCodeFunction methodsFor: 'platypus-generated-accessing' stamp: ''!
cip
	^ cip

! !

!ExChdAdaClassInitializeCodeFunction methodsFor: 'platypus-generated-accessing' stamp: ''!
cip: aExChdAdaClass
	cip := aExChdAdaClass

! !

!ExChdAdaClassInitializeCodeFunction methodsFor: 'platypus-generated-accessing' stamp: ''!
code
	^ code

! !

!ExChdAdaClassInitializeCodeFunction methodsFor: 'platypus-generated-accessing' stamp: ''!
code: aString
	code := aString

! !

!ExChdAdaClassInitializeCodeFunction methodsFor: 'platypus-generated-accessing' stamp: ''!
fromValues: values
	self cip: (values at: 1)

! !

!ExChdAdaClassInitializeCodeFunction methodsFor: 'platypus-generated-accessing' stamp: ''!
init
	^ init

! !

!ExChdAdaClassInitializeCodeFunction methodsFor: 'platypus-generated-accessing' stamp: ''!
init: aString2
	init := aString2

! !

!ExChdAdaClassInitializeCodeFunction methodsFor: 'platypus-generated-accessing' stamp: ''!
innerCode
	^ innerCode

! !

!ExChdAdaClassInitializeCodeFunction methodsFor: 'platypus-generated-accessing' stamp: ''!
innerCode: aString1
	innerCode := aString1

! !

!ExChdAdaClassInitializeCodeFunction methodsFor: 'platypus-generated-invoking' stamp: ''!
invoke
	" ---------- locals assignments ----------"

	self innerCode: ''.	" ---------- statements ----------"
	self
		code:
			(('\nprocedure Initialize(obj : in out ' pltPlus: (self cip nameUsingContext: self class context))
				pltPlus: ') is \nbegin\n').
	(PltSIZEOFFunction
		invokeFromValues:
			(OrderedCollection new
				add: (self cip supertypesUsingContext: self class context);
				yourself)) > 0
		ifTrue: [ 
			PlatypusCoreAliasStatement
				alias:
					(((self cip supertypesUsingContext: self class context)
						pltAt:
							(PltLOINDEXFunction
								invokeFromValues:
									(OrderedCollection new
										add: (self cip supertypesUsingContext: self class context);
										yourself))) handledUsingContext: self class context)
				statementsBlock: [ :sup3260 | 
					self
						innerCode:
							(((self innerCode pltPlus: '\tinitialize(') pltPlus: (sup3260 nameUsingContext: self class context))
								pltPlus: '(obj));\n') ] ].
	PlatypusCoreRepeatStatement
		repeat: [ :no692 | 
			PlatypusCoreAliasStatement
				alias: ((self cip explicitAttributesUsingContext: self class context) pltAt: no692)
				statementsBlock: [ :attr3269 | 
					self
						init:
							(ExChdExplicitAttributeInitializeFunction
								invokeFromValues:
									(OrderedCollection new
										add: attr3269;
										yourself)).
					((PltEXISTSFunction
						invokeFromValues:
							(OrderedCollection new
								add: self init;
								yourself)) and: [ self init > '' ])
						ifTrue: [ self innerCode: (((self innerCode pltPlus: '\t') pltPlus: self init) pltPlus: '\n') ] ] ]
		from:
			(PltLOINDEXFunction
				invokeFromValues:
					(OrderedCollection new
						add: (self cip explicitAttributesUsingContext: self class context);
						yourself))
		to:
			(PltHIINDEXFunction
				invokeFromValues:
					(OrderedCollection new
						add: (self cip explicitAttributesUsingContext: self class context);
						yourself)).
	PlatypusCoreRepeatStatement
		repeat: [ :no2051 | 
			PlatypusCoreAliasStatement
				alias: ((self cip derivedAttributesUsingContext: self class context) pltAt: no2051)
				statementsBlock: [ :attr532 | 
					self
						init:
							(ExChdDerivedAttributeInitializeFunction
								invokeFromValues:
									(OrderedCollection new
										add: attr532;
										yourself)).
					((PltEXISTSFunction
						invokeFromValues:
							(OrderedCollection new
								add: self init;
								yourself)) and: [ self init > '' ])
						ifTrue: [ self innerCode: (((self innerCode pltPlus: '\t') pltPlus: self init) pltPlus: '\n') ] ] ]
		from:
			(PltLOINDEXFunction
				invokeFromValues:
					(OrderedCollection new
						add: (self cip derivedAttributesUsingContext: self class context);
						yourself))
		to:
			(PltHIINDEXFunction
				invokeFromValues:
					(OrderedCollection new
						add: (self cip derivedAttributesUsingContext: self class context);
						yourself)).
	self innerCode = ''
		ifTrue: [ self innerCode: '\tnull;\n' ].
	self code: ((self code pltPlus: self innerCode) pltPlus: 'end Initialize;\n').
	^ self return: self code

! !

PlatypusCoreAlgorithmDeclaration subclass: #ExChdAdaClassPutCodeFunction
	instanceVariableNames: 'cip code acode'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Express2Cheddar-RecordAndClassSchema'!

!ExChdAdaClassPutCodeFunction commentStamp: 'platypus comment' prior: 0!
<ISO10303-11-EXPRESS>
FUNCTION ada_class_put_code ( cip : ada_class ) : STRING;
	LOCAL 
		code : STRING;
		acode : STRING;
	END_LOCAL;
	code := 'procedure Put(obj : in ' + cip.name + ') is \nbegin\n';

	IF SIZEOF ( cip.supertypes ) > 0 THEN

		ALIAS sup FOR cip.supertypes [ LOINDEX ( cip.supertypes ) ].handled;
			code := code + '\tput(' + sup.name + '(obj));\n';
		END_ALIAS;
	END_IF;

	REPEAT no := LOINDEX ( cip.explicit_attributes ) TO HIINDEX ( cip.explicit_attributes );

		ALIAS attr FOR cip.explicit_attributes [ no];
			acode := explicit_attribute_put ( attr );
			IF ( acode > '' ) THEN
				code := code + '\t' + acode + '\n';
			END_IF;
		END_ALIAS;
	END_REPEAT;
	code := code + 'end Put;\n \n' 
	+ 'procedure Put(obj : in ' + cip.ptr_type + ') is\n' 
	+ 'begin\n' 
	+ '\tPut(Obj.All);\n' 
	+ 'end Put;\n \n';
	code := code + 'procedure Put_Name ( obj : in ' + cip.ptr_type + ') is\n' 
	+ 'begin\n';

	IF has_inherited_attribute_named ( cip, 'name' ) THEN
		code := code + '\tPut ( To_String ( Obj.Name ) );\n';
	ELSE
		code := code + '\tPut ( To_String ( Obj.' + xml_id_name + ' ) );\n';
	END_IF;
	code := code + 'end Put_Name;\n';
	RETURN ( code );
END_FUNCTION;
</ISO10303-11-EXPRESS>!

!ExChdAdaClassPutCodeFunction class methodsFor: 'platypus-generated-platypus-signature' stamp: ''!
iso10303P11Translater
	^ 'Platypus (c) LISYC EA3883, Universite de Bretagne occidentale. Brest.'

! !

!ExChdAdaClassPutCodeFunction class methodsFor: 'platypus-generated-meta-data-accessing' stamp: ''!
schemaDefinition
	^ ExChdRecordAndClassSchemaDefinition singleton

! !

!ExChdAdaClassPutCodeFunction class methodsFor: 'platypus-generated-platypus-signature' stamp: ''!
translatedFromISO10303P11
	^ true

! !

!ExChdAdaClassPutCodeFunction class methodsFor: 'platypus-generated-platypus-signature' stamp: ''!
vwNamespaceName
	^ #Express2Cheddar

! !

!ExChdAdaClassPutCodeFunction methodsFor: 'platypus-generated-accessing' stamp: ''!
acode
	^ acode

! !

!ExChdAdaClassPutCodeFunction methodsFor: 'platypus-generated-accessing' stamp: ''!
acode: aString1
	acode := aString1

! !

!ExChdAdaClassPutCodeFunction methodsFor: 'platypus-generated-accessing' stamp: ''!
cip
	^ cip

! !

!ExChdAdaClassPutCodeFunction methodsFor: 'platypus-generated-accessing' stamp: ''!
cip: aExChdAdaClass
	cip := aExChdAdaClass

! !

!ExChdAdaClassPutCodeFunction methodsFor: 'platypus-generated-accessing' stamp: ''!
code
	^ code

! !

!ExChdAdaClassPutCodeFunction methodsFor: 'platypus-generated-accessing' stamp: ''!
code: aString
	code := aString

! !

!ExChdAdaClassPutCodeFunction methodsFor: 'platypus-generated-accessing' stamp: ''!
fromValues: values
	self cip: (values at: 1)

! !

!ExChdAdaClassPutCodeFunction methodsFor: 'platypus-generated-invoking' stamp: ''!
invoke
	" ---------- locals assignments ----------"

	" ---------- statements ----------"

	self
		code: (('procedure Put(obj : in ' pltPlus: (self cip nameUsingContext: self class context)) pltPlus: ') is \nbegin\n').
	(PltSIZEOFFunction
		invokeFromValues:
			(OrderedCollection new
				add: (self cip supertypesUsingContext: self class context);
				yourself)) > 0
		ifTrue: [ 
			PlatypusCoreAliasStatement
				alias:
					(((self cip supertypesUsingContext: self class context)
						pltAt:
							(PltLOINDEXFunction
								invokeFromValues:
									(OrderedCollection new
										add: (self cip supertypesUsingContext: self class context);
										yourself))) handledUsingContext: self class context)
				statementsBlock: [ :sup2112 | 
					self
						code:
							(((self code pltPlus: '\tput(') pltPlus: (sup2112 nameUsingContext: self class context)) pltPlus: '(obj));\n') ] ].
	PlatypusCoreRepeatStatement
		repeat: [ :no418 | 
			PlatypusCoreAliasStatement
				alias: ((self cip explicitAttributesUsingContext: self class context) pltAt: no418)
				statementsBlock: [ :attr2995 | 
					self
						acode:
							(ExChdExplicitAttributePutFunction
								invokeFromValues:
									(OrderedCollection new
										add: attr2995;
										yourself)).
					self acode > ''
						ifTrue: [ self code: (((self code pltPlus: '\t') pltPlus: self acode) pltPlus: '\n') ] ] ]
		from:
			(PltLOINDEXFunction
				invokeFromValues:
					(OrderedCollection new
						add: (self cip explicitAttributesUsingContext: self class context);
						yourself))
		to:
			(PltHIINDEXFunction
				invokeFromValues:
					(OrderedCollection new
						add: (self cip explicitAttributesUsingContext: self class context);
						yourself)).
	self
		code:
			(((((((self code pltPlus: 'end Put;\n \n') pltPlus: 'procedure Put(obj : in ')
				pltPlus: (self cip ptrTypeUsingContext: self class context)) pltPlus: ') is\n') pltPlus: 'begin\n')
				pltPlus: '\tPut(Obj.All);\n') pltPlus: 'end Put;\n \n').
	self
		code:
			((((self code pltPlus: 'procedure Put_Name ( obj : in ') pltPlus: (self cip ptrTypeUsingContext: self class context))
				pltPlus: ') is\n') pltPlus: 'begin\n').
	(PTsHasInheritedAttributeNamedFunction
		invokeFromValues:
			(OrderedCollection new
				add: self cip;
				add: 'name';
				yourself))
		ifTrue: [ self code: (self code pltPlus: '\tPut ( To_String ( Obj.Name ) );\n') ]
		ifFalse: [ self code: (((self code pltPlus: '\tPut ( To_String ( Obj.') pltPlus: 'cheddar_private_id') pltPlus: ' ) );\n') ].
	self code: (self code pltPlus: 'end Put_Name;\n').
	^ self return: self code

! !

PlatypusCoreAlgorithmDeclaration subclass: #ExChdAdaClassTypeofCodeFunction
	instanceVariableNames: 'cip code sups'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Express2Cheddar-RecordAndClassSchema'!

!ExChdAdaClassTypeofCodeFunction commentStamp: 'platypus comment' prior: 0!
<ISO10303-11-EXPRESS>
FUNCTION ada_class_typeof_code ( cip : ada_class ) : STRING;
	LOCAL 
		code : STRING;
		sups : LIST OF entity_definition := all_supertypes_of ( cip );
	END_LOCAL;
	code := 'function type_of ( obj : in ' + cip.name + ' ) return unbounded_string_list is\n' 
	+ '\tlist : unbounded_string_list;\n' 
	+ '\ts : unbounded_string_ptr;\n' 
	+ 'begin\n' 
	+ '\t' + 'Initialize(list);\n' 
	+ '\n';

	REPEAT no := LOINDEX ( sups ) TO HIINDEX ( sups );

		ALIAS curr FOR sups [ no];
			code := code + '\t' + 's := new unbounded_string;\n' 
			+ '\t' + 's.all := to_unbounded_string("' + upperize ( curr.owner.name ) + '.' + upperize ( curr.name ) + '");\n' 
			+ '\t' + 'Add (list, s);\n' 
			+ '\n';
		END_ALIAS;
	END_REPEAT;
	code := code + '\treturn list;\nend type_of;\n\n' 

	+ 'function type_of ( obj : in ' + cip.ptr_type + ' ) return unbounded_string_list is\n' 
	+ 'begin\n' 
	+ '\treturn type_of(obj.all);\n' 
	+ 'end type_of;\n';
	RETURN ( code );
END_FUNCTION;
</ISO10303-11-EXPRESS>!

!ExChdAdaClassTypeofCodeFunction class methodsFor: 'platypus-generated-platypus-signature' stamp: ''!
iso10303P11Translater
	^ 'Platypus (c) LISYC EA3883, Universite de Bretagne occidentale. Brest.'

! !

!ExChdAdaClassTypeofCodeFunction class methodsFor: 'platypus-generated-meta-data-accessing' stamp: ''!
schemaDefinition
	^ ExChdRecordAndClassSchemaDefinition singleton

! !

!ExChdAdaClassTypeofCodeFunction class methodsFor: 'platypus-generated-platypus-signature' stamp: ''!
translatedFromISO10303P11
	^ true

! !

!ExChdAdaClassTypeofCodeFunction class methodsFor: 'platypus-generated-platypus-signature' stamp: ''!
vwNamespaceName
	^ #Express2Cheddar

! !

!ExChdAdaClassTypeofCodeFunction methodsFor: 'platypus-generated-accessing' stamp: ''!
cip
	^ cip

! !

!ExChdAdaClassTypeofCodeFunction methodsFor: 'platypus-generated-accessing' stamp: ''!
cip: aExChdAdaClass
	cip := aExChdAdaClass

! !

!ExChdAdaClassTypeofCodeFunction methodsFor: 'platypus-generated-accessing' stamp: ''!
code
	^ code

! !

!ExChdAdaClassTypeofCodeFunction methodsFor: 'platypus-generated-accessing' stamp: ''!
code: aString
	code := aString

! !

!ExChdAdaClassTypeofCodeFunction methodsFor: 'platypus-generated-accessing' stamp: ''!
fromValues: values
	self cip: (values at: 1)

! !

!ExChdAdaClassTypeofCodeFunction methodsFor: 'platypus-generated-invoking' stamp: ''!
invoke
	" ---------- locals assignments ----------"

	self
		sups:
			(PTsAllSupertypesOfFunction
				invokeFromValues:
					(OrderedCollection new
						add: self cip;
						yourself)).	" ---------- statements ----------"
	self
		code:
			(((((((('function type_of ( obj : in ' pltPlus: (self cip nameUsingContext: self class context))
				pltPlus: ' ) return unbounded_string_list is\n') pltPlus: '\tlist : unbounded_string_list;\n')
				pltPlus: '\ts : unbounded_string_ptr;\n') pltPlus: 'begin\n') pltPlus: '\t') pltPlus: 'Initialize(list);\n')
				pltPlus: '\n').
	PlatypusCoreRepeatStatement
		repeat: [ :no2600 | 
			PlatypusCoreAliasStatement
				alias: (self sups pltAt: no2600)
				statementsBlock: [ :curr323 | 
					self
						code:
							(((((((((((self code pltPlus: '\t') pltPlus: 's := new unbounded_string;\n') pltPlus: '\t')
								pltPlus: 's.all := to_unbounded_string("')
								pltPlus:
									(PTsUpperizeFunction
										invokeFromValues:
											(OrderedCollection new
												add: ((curr323 ownerUsingContext: self class context) nameUsingContext: self class context);
												yourself))) pltPlus: '.')
								pltPlus:
									(PTsUpperizeFunction
										invokeFromValues:
											(OrderedCollection new
												add: (curr323 nameUsingContext: self class context);
												yourself))) pltPlus: '");\n') pltPlus: '\t') pltPlus: 'Add (list, s);\n') pltPlus: '\n') ] ]
		from:
			(PltLOINDEXFunction
				invokeFromValues:
					(OrderedCollection new
						add: self sups;
						yourself))
		to:
			(PltHIINDEXFunction
				invokeFromValues:
					(OrderedCollection new
						add: self sups;
						yourself)).
	self
		code:
			(((((((self code pltPlus: '\treturn list;\nend type_of;\n\n') pltPlus: 'function type_of ( obj : in ')
				pltPlus: (self cip ptrTypeUsingContext: self class context)) pltPlus: ' ) return unbounded_string_list is\n')
				pltPlus: 'begin\n') pltPlus: '\treturn type_of(obj.all);\n') pltPlus: 'end type_of;\n').
	^ self return: self code

! !

!ExChdAdaClassTypeofCodeFunction methodsFor: 'platypus-generated-accessing' stamp: ''!
sups
	^ sups

! !

!ExChdAdaClassTypeofCodeFunction methodsFor: 'platypus-generated-accessing' stamp: ''!
sups: aListOfExChdEntityDefinition
	sups := aListOfExChdEntityDefinition
		ifNil: [ OrderedCollection new ]
		ifNotNil: [ aListOfExChdEntityDefinition as: OrderedCollection ]

! !

PlatypusCoreAlgorithmDeclaration subclass: #ExChdAdaClassXmlIoRecordCodeFunction
	instanceVariableNames: 'cip'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Express2Cheddar-RecordAndClassSchema'!

!ExChdAdaClassXmlIoRecordCodeFunction commentStamp: 'platypus comment' prior: 0!
<ISO10303-11-EXPRESS>
FUNCTION ada_class_xml_io_record_code ( cip : ada_class ) : STRING;
	RETURN ( '\ntype ' + cip.name + '_io is record' + ada_entity_attributes_xml_io_record_code ( cip ) + '\nend record;' );
END_FUNCTION;
</ISO10303-11-EXPRESS>!

!ExChdAdaClassXmlIoRecordCodeFunction class methodsFor: 'platypus-generated-platypus-signature' stamp: ''!
iso10303P11Translater
	^ 'Platypus (c) LISYC EA3883, Universite de Bretagne occidentale. Brest.'

! !

!ExChdAdaClassXmlIoRecordCodeFunction class methodsFor: 'platypus-generated-meta-data-accessing' stamp: ''!
schemaDefinition
	^ ExChdRecordAndClassSchemaDefinition singleton

! !

!ExChdAdaClassXmlIoRecordCodeFunction class methodsFor: 'platypus-generated-platypus-signature' stamp: ''!
translatedFromISO10303P11
	^ true

! !

!ExChdAdaClassXmlIoRecordCodeFunction class methodsFor: 'platypus-generated-platypus-signature' stamp: ''!
vwNamespaceName
	^ #Express2Cheddar

! !

!ExChdAdaClassXmlIoRecordCodeFunction methodsFor: 'platypus-generated-accessing' stamp: ''!
cip
	^ cip

! !

!ExChdAdaClassXmlIoRecordCodeFunction methodsFor: 'platypus-generated-accessing' stamp: ''!
cip: aExChdAdaClass
	cip := aExChdAdaClass

! !

!ExChdAdaClassXmlIoRecordCodeFunction methodsFor: 'platypus-generated-accessing' stamp: ''!
fromValues: values
	self cip: (values at: 1)

! !

!ExChdAdaClassXmlIoRecordCodeFunction methodsFor: 'platypus-generated-invoking' stamp: ''!
invoke
	" ---------- locals assignments ----------"

	" ---------- statements ----------"

	^ self
		return:
			(((('\ntype ' pltPlus: (self cip nameUsingContext: self class context)) pltPlus: '_io is record')
				pltPlus:
					(ExChdAdaEntityAttributesXmlIoRecordCodeFunction
						invokeFromValues:
							(OrderedCollection new
								add: self cip;
								yourself))) pltPlus: '\nend record;')

! !

PlatypusCoreAlgorithmDeclaration subclass: #ExChdAdaClassXmlWriterCodeFunction
	instanceVariableNames: 'cip code contents sub'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Express2Cheddar-RecordAndClassSchema'!

!ExChdAdaClassXmlWriterCodeFunction commentStamp: 'platypus comment' prior: 0!
<ISO10303-11-EXPRESS>
FUNCTION ada_class_xml_writer_code ( cip : ada_class ) : STRING;
	LOCAL 
		code : STRING;
		contents : STRING := '';
		sub : STRING;
	END_LOCAL;
	code := '\nprocedure Build_Attributes_XML_String(obj : in ' + cip.name + '; result : in out Unbounded_String) is \nbegin\n';

	IF SIZEOF ( cip.supertypes ) > 0 THEN

		ALIAS sup FOR cip.supertypes [ LOINDEX ( cip.supertypes ) ].handled;
			contents := contents + '\tBuild_Attributes_XML_String(' + sup.name + '(obj), result);\n';
		END_ALIAS;
	END_IF;

	REPEAT no := LOINDEX ( cip.explicit_attributes ) TO HIINDEX ( cip.explicit_attributes );

		ALIAS attr FOR cip.explicit_attributes [ no];
			sub := explicit_attribute_xml_writer_code ( 'obj', attr );
			IF sub > '' THEN
				contents := contents + sub + '\n';
			END_IF;
		END_ALIAS;
	END_REPEAT;

	IF contents = '' THEN
		contents := '\tnull;\n';
	END_IF;
	code := code + contents + 'end Build_Attributes_XML_String;\n\n' 

	+ 'function XML_String(obj : in ' + cip.name + ') return Unbounded_String is\n' 
	+ '\tresult : Unbounded_String;\n' 
	+ 'begin\n' 
	+ '\tresult := to_unbounded_string("<' + cip.html_tag + ' id=""") & obj.' + xml_id_name + ' & to_unbounded_string(""" >");\n' 
	+ '\tBuild_Attributes_XML_String(obj, result);\n' 
	+ '\tresult := result & to_unbounded_string("</' + cip.html_tag + '>");\n' 
	+ '\treturn (result);\n' 
	+ 'end XML_String;\n\n' 

	+ 'function XML_String(obj : in ' + cip.ptr_type + ') return Unbounded_String is\n' 
	+ 'begin\n' 
	+ '	if obj /= null then\n' 
	+ '		return XML_String(obj.all);\n' 
	+ '	else\n' 
	+ '		return Empty_String;\n' 
	+ '	end if;\n' 
	+ 'end XML_String;\n\n' 

	+ 'function XML_Ref_String(obj : in ' + cip.name + ') return Unbounded_String is\n' 
	+ '\tresult : Unbounded_String;\n' 
	+ 'begin\n' 
	+ '\tresult := to_unbounded_string("<' + cip.html_tag + ' ref=""") & obj.' + xml_id_name + ' & to_unbounded_string(""" />");\n' 
	+ '\treturn (result);\n' 
	+ 'end XML_Ref_String;\n\n' 

	+ 'function XML_Ref_String(obj : in ' + cip.ptr_type + ') return Unbounded_String is\n' 
	+ 'begin\n' 
	+ '\treturn XML_Ref_String(obj.all);\n' 
	+ 'end XML_Ref_String;\n\n';
	RETURN ( code );
END_FUNCTION;
</ISO10303-11-EXPRESS>!

!ExChdAdaClassXmlWriterCodeFunction class methodsFor: 'platypus-generated-platypus-signature' stamp: ''!
iso10303P11Translater
	^ 'Platypus (c) LISYC EA3883, Universite de Bretagne occidentale. Brest.'

! !

!ExChdAdaClassXmlWriterCodeFunction class methodsFor: 'platypus-generated-meta-data-accessing' stamp: ''!
schemaDefinition
	^ ExChdRecordAndClassSchemaDefinition singleton

! !

!ExChdAdaClassXmlWriterCodeFunction class methodsFor: 'platypus-generated-platypus-signature' stamp: ''!
translatedFromISO10303P11
	^ true

! !

!ExChdAdaClassXmlWriterCodeFunction class methodsFor: 'platypus-generated-platypus-signature' stamp: ''!
vwNamespaceName
	^ #Express2Cheddar

! !

!ExChdAdaClassXmlWriterCodeFunction methodsFor: 'platypus-generated-accessing' stamp: ''!
cip
	^ cip

! !

!ExChdAdaClassXmlWriterCodeFunction methodsFor: 'platypus-generated-accessing' stamp: ''!
cip: aExChdAdaClass
	cip := aExChdAdaClass

! !

!ExChdAdaClassXmlWriterCodeFunction methodsFor: 'platypus-generated-accessing' stamp: ''!
code
	^ code

! !

!ExChdAdaClassXmlWriterCodeFunction methodsFor: 'platypus-generated-accessing' stamp: ''!
code: aString
	code := aString

! !

!ExChdAdaClassXmlWriterCodeFunction methodsFor: 'platypus-generated-accessing' stamp: ''!
contents
	^ contents

! !

!ExChdAdaClassXmlWriterCodeFunction methodsFor: 'platypus-generated-accessing' stamp: ''!
contents: aString1
	contents := aString1

! !

!ExChdAdaClassXmlWriterCodeFunction methodsFor: 'platypus-generated-accessing' stamp: ''!
fromValues: values
	self cip: (values at: 1)

! !

!ExChdAdaClassXmlWriterCodeFunction methodsFor: 'platypus-generated-invoking' stamp: ''!
invoke
	" ---------- locals assignments ----------"

	self contents: ''.	" ---------- statements ----------"
	self
		code:
			(('\nprocedure Build_Attributes_XML_String(obj : in ' pltPlus: (self cip nameUsingContext: self class context))
				pltPlus: '; result : in out Unbounded_String) is \nbegin\n').
	(PltSIZEOFFunction
		invokeFromValues:
			(OrderedCollection new
				add: (self cip supertypesUsingContext: self class context);
				yourself)) > 0
		ifTrue: [ 
			PlatypusCoreAliasStatement
				alias:
					(((self cip supertypesUsingContext: self class context)
						pltAt:
							(PltLOINDEXFunction
								invokeFromValues:
									(OrderedCollection new
										add: (self cip supertypesUsingContext: self class context);
										yourself))) handledUsingContext: self class context)
				statementsBlock: [ :sup1130 | 
					self
						contents:
							(((self contents pltPlus: '\tBuild_Attributes_XML_String(') pltPlus: (sup1130 nameUsingContext: self class context))
								pltPlus: '(obj), result);\n') ] ].
	PlatypusCoreRepeatStatement
		repeat: [ :no3556 | 
			PlatypusCoreAliasStatement
				alias: ((self cip explicitAttributesUsingContext: self class context) pltAt: no3556)
				statementsBlock: [ :attr2037 | 
					self
						sub:
							(ExChdExplicitAttributeXmlWriterCodeFunction
								invokeFromValues:
									(OrderedCollection new
										add: 'obj';
										add: attr2037;
										yourself)).
					self sub > ''
						ifTrue: [ self contents: ((self contents pltPlus: self sub) pltPlus: '\n') ] ] ]
		from:
			(PltLOINDEXFunction
				invokeFromValues:
					(OrderedCollection new
						add: (self cip explicitAttributesUsingContext: self class context);
						yourself))
		to:
			(PltHIINDEXFunction
				invokeFromValues:
					(OrderedCollection new
						add: (self cip explicitAttributesUsingContext: self class context);
						yourself)).
	self contents = ''
		ifTrue: [ self contents: '\tnull;\n' ].
	self
		code:
			((((((((((((((((((((((((((((((((((((((((((((((self code pltPlus: self contents)
				pltPlus: 'end Build_Attributes_XML_String;\n\n') pltPlus: 'function XML_String(obj : in ')
				pltPlus: (self cip nameUsingContext: self class context)) pltPlus: ') return Unbounded_String is\n')
				pltPlus: '\tresult : Unbounded_String;\n') pltPlus: 'begin\n') pltPlus: '\tresult := to_unbounded_string("<')
				pltPlus: (self cip htmlTagUsingContext: self class context)) pltPlus: ' id=""") & obj.')
				pltPlus: 'cheddar_private_id') pltPlus: ' & to_unbounded_string(""" >");\n')
				pltPlus: '\tBuild_Attributes_XML_String(obj, result);\n') pltPlus: '\tresult := result & to_unbounded_string("</')
				pltPlus: (self cip htmlTagUsingContext: self class context)) pltPlus: '>");\n') pltPlus: '\treturn (result);\n')
				pltPlus: 'end XML_String;\n\n') pltPlus: 'function XML_String(obj : in ')
				pltPlus: (self cip ptrTypeUsingContext: self class context)) pltPlus: ') return Unbounded_String is\n')
				pltPlus: 'begin\n') pltPlus: '	if obj /= null then\n') pltPlus: '		return XML_String(obj.all);\n')
				pltPlus: '	else\n') pltPlus: '		return Empty_String;\n') pltPlus: '	end if;\n') pltPlus: 'end XML_String;\n\n')
				pltPlus: 'function XML_Ref_String(obj : in ') pltPlus: (self cip nameUsingContext: self class context))
				pltPlus: ') return Unbounded_String is\n') pltPlus: '\tresult : Unbounded_String;\n') pltPlus: 'begin\n')
				pltPlus: '\tresult := to_unbounded_string("<') pltPlus: (self cip htmlTagUsingContext: self class context))
				pltPlus: ' ref=""") & obj.') pltPlus: 'cheddar_private_id') pltPlus: ' & to_unbounded_string(""" />");\n')
				pltPlus: '\treturn (result);\n') pltPlus: 'end XML_Ref_String;\n\n') pltPlus: 'function XML_Ref_String(obj : in ')
				pltPlus: (self cip ptrTypeUsingContext: self class context)) pltPlus: ') return Unbounded_String is\n')
				pltPlus: 'begin\n') pltPlus: '\treturn XML_Ref_String(obj.all);\n') pltPlus: 'end XML_Ref_String;\n\n').
	^ self return: self code

! !

!ExChdAdaClassXmlWriterCodeFunction methodsFor: 'platypus-generated-accessing' stamp: ''!
sub
	^ sub

! !

!ExChdAdaClassXmlWriterCodeFunction methodsFor: 'platypus-generated-accessing' stamp: ''!
sub: aString2
	sub := aString2

! !

PlatypusCoreAlgorithmDeclaration subclass: #ExChdAdaConstantAdsCodeFunction
	instanceVariableNames: 'c code remarks rem domain'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Express2Cheddar-CheddarConstantsSchema'!

!ExChdAdaConstantAdsCodeFunction commentStamp: 'platypus comment' prior: 0!
<ISO10303-11-EXPRESS>
FUNCTION ada_constant_ads_code ( c : ada_constant ) : STRING;
	LOCAL 
		code : STRING := '';
		remarks : LIST OF remark := remarks_for ( c );
		rem : STRING;
		domain : dictionary_instance := basic_ada_domain ( c.domain );
	END_LOCAL;

	IF ( SIZEOF ( remarks ) > 0 ) THEN

		REPEAT no := LOINDEX ( remarks ) TO HIINDEX ( remarks );
			rem := clean_remark_text_of ( remarks [ no] );
			rem := do_comments_with ( rem );
			code := code + rem;
		END_REPEAT;
	END_IF;
	code := code + c.name + ' : ';

	IF c.final THEN
		code := code + 'constant ';
	END_IF;
	code := code + domain.ada_ref_ident;

	IF NOT EXISTS ( c.other_initializer ) THEN
		code := code + ' := ' + basic_ada_type_value_format ( c.initializer, ? ).formated + ';';
	ELSE

		IF c.other_initializer > '' THEN
			code := code + ' := ' + c.other_initializer;
		END_IF;
		code := code + ';';
	END_IF;
	code := code + '\n';
	RETURN ( code );
END_FUNCTION;
</ISO10303-11-EXPRESS>!

!ExChdAdaConstantAdsCodeFunction class methodsFor: 'platypus-generated-platypus-signature' stamp: ''!
iso10303P11Translater
	^ 'Platypus (c) LISYC EA3883, Universite de Bretagne occidentale. Brest.'

! !

!ExChdAdaConstantAdsCodeFunction class methodsFor: 'platypus-generated-meta-data-accessing' stamp: ''!
schemaDefinition
	^ ExChdCheddarConstantsSchemaDefinition singleton

! !

!ExChdAdaConstantAdsCodeFunction class methodsFor: 'platypus-generated-platypus-signature' stamp: ''!
translatedFromISO10303P11
	^ true

! !

!ExChdAdaConstantAdsCodeFunction class methodsFor: 'platypus-generated-platypus-signature' stamp: ''!
vwNamespaceName
	^ #Express2Cheddar

! !

!ExChdAdaConstantAdsCodeFunction methodsFor: 'platypus-generated-accessing' stamp: ''!
c
	^ c

! !

!ExChdAdaConstantAdsCodeFunction methodsFor: 'platypus-generated-accessing' stamp: ''!
c: aExChdAdaConstant
	c := aExChdAdaConstant

! !

!ExChdAdaConstantAdsCodeFunction methodsFor: 'platypus-generated-accessing' stamp: ''!
code
	^ code

! !

!ExChdAdaConstantAdsCodeFunction methodsFor: 'platypus-generated-accessing' stamp: ''!
code: aString
	code := aString

! !

!ExChdAdaConstantAdsCodeFunction methodsFor: 'platypus-generated-accessing' stamp: ''!
domain
	^ domain

! !

!ExChdAdaConstantAdsCodeFunction methodsFor: 'platypus-generated-accessing' stamp: ''!
domain: aExChdDictionaryInstance
	domain := aExChdDictionaryInstance

! !

!ExChdAdaConstantAdsCodeFunction methodsFor: 'platypus-generated-accessing' stamp: ''!
fromValues: values
	self c: (values at: 1)

! !

!ExChdAdaConstantAdsCodeFunction methodsFor: 'platypus-generated-invoking' stamp: ''!
invoke
	" ---------- locals assignments ----------"

	self code: ''.
	self
		remarks:
			(PTsRemarksForFunction
				invokeFromValues:
					(OrderedCollection new
						add: self c;
						yourself)).
	self
		domain:
			(ExChdBasicAdaDomainFunction
				invokeFromValues:
					(OrderedCollection new
						add: (self c domainUsingContext: self class context);
						yourself)).	" ---------- statements ----------"
	(PltSIZEOFFunction
		invokeFromValues:
			(OrderedCollection new
				add: self remarks;
				yourself)) > 0
		ifTrue: [ 
			PlatypusCoreRepeatStatement
				repeat: [ :no2259 | 
					self
						rem:
							(PTsCleanRemarkTextOfFunction
								invokeFromValues:
									(OrderedCollection new
										add: (self remarks pltAt: no2259);
										yourself)).
					self
						rem:
							(ExChdDoCommentsWithFunction
								invokeFromValues:
									(OrderedCollection new
										add: self rem;
										yourself)).
					self code: (self code pltPlus: self rem) ]
				from:
					(PltLOINDEXFunction
						invokeFromValues:
							(OrderedCollection new
								add: self remarks;
								yourself))
				to:
					(PltHIINDEXFunction
						invokeFromValues:
							(OrderedCollection new
								add: self remarks;
								yourself)) ].
	self code: ((self code pltPlus: (self c nameUsingContext: self class context)) pltPlus: ' : ').
	(self c finalUsingContext: self class context)
		ifTrue: [ self code: (self code pltPlus: 'constant ') ].
	self code: (self code pltPlus: (self domain adaRefIdentUsingContext: self class context)).
	(PltEXISTSFunction
		invokeFromValues:
			(OrderedCollection new
				add: (self c otherInitializerUsingContext: self class context);
				yourself)) not
		ifTrue: [ 
			self
				code:
					(((self code pltPlus: ' := ')
						pltPlus:
							((ExChdBasicAdaTypeValueFormat new
								basicAdaTypeValueFormatFromValues:
										(OrderedCollection new
												add: (self c initializerUsingContext: self class context);
												add: nil;
												yourself);
								yourself) formatedUsingContext: self class context)) pltPlus: ';') ]
		ifFalse: [ 
			(self c otherInitializerUsingContext: self class context) > ''
				ifTrue: [ self code: ((self code pltPlus: ' := ') pltPlus: (self c otherInitializerUsingContext: self class context)) ].
			self code: (self code pltPlus: ';') ].
	self code: (self code pltPlus: '\n').
	^ self return: self code

! !

!ExChdAdaConstantAdsCodeFunction methodsFor: 'platypus-generated-accessing' stamp: ''!
rem
	^ rem

! !

!ExChdAdaConstantAdsCodeFunction methodsFor: 'platypus-generated-accessing' stamp: ''!
rem: aString1
	rem := aString1

! !

!ExChdAdaConstantAdsCodeFunction methodsFor: 'platypus-generated-accessing' stamp: ''!
remarks
	^ remarks

! !

!ExChdAdaConstantAdsCodeFunction methodsFor: 'platypus-generated-accessing' stamp: ''!
remarks: aListOfExChdRemark
	remarks := aListOfExChdRemark ifNil: [ OrderedCollection new ] ifNotNil: [ aListOfExChdRemark as: OrderedCollection ]

! !

PlatypusCoreAlgorithmDeclaration subclass: #ExChdAdaConstantInterfacesListFunction
	instanceVariableNames: 'r ads result adaDomain'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Express2Cheddar-CheddarConstantsSchema'!

!ExChdAdaConstantInterfacesListFunction commentStamp: 'platypus comment' prior: 0!
<ISO10303-11-EXPRESS>
FUNCTION ada_constant_interfaces_list ( r : ada_constant; ads : BOOLEAN ) : LIST OF ada_interface;
	LOCAL 
		result : LIST OF ada_interface := [ ];
		ada_domain : entity_instance;
	END_LOCAL;
	ada_domain := basic_ada_domain ( r.domain );
	result := domain_interfaces_list ( ada_domain, ads, r.owner );
	RETURN ( result );
END_FUNCTION;
</ISO10303-11-EXPRESS>!

!ExChdAdaConstantInterfacesListFunction class methodsFor: 'platypus-generated-platypus-signature' stamp: ''!
iso10303P11Translater
	^ 'Platypus (c) LISYC EA3883, Universite de Bretagne occidentale. Brest.'

! !

!ExChdAdaConstantInterfacesListFunction class methodsFor: 'platypus-generated-meta-data-accessing' stamp: ''!
schemaDefinition
	^ ExChdCheddarConstantsSchemaDefinition singleton

! !

!ExChdAdaConstantInterfacesListFunction class methodsFor: 'platypus-generated-platypus-signature' stamp: ''!
translatedFromISO10303P11
	^ true

! !

!ExChdAdaConstantInterfacesListFunction class methodsFor: 'platypus-generated-platypus-signature' stamp: ''!
vwNamespaceName
	^ #Express2Cheddar

! !

!ExChdAdaConstantInterfacesListFunction methodsFor: 'platypus-generated-accessing' stamp: ''!
adaDomain
	^ adaDomain

! !

!ExChdAdaConstantInterfacesListFunction methodsFor: 'platypus-generated-accessing' stamp: ''!
adaDomain: aExChdEntityInstance
	adaDomain := aExChdEntityInstance

! !

!ExChdAdaConstantInterfacesListFunction methodsFor: 'platypus-generated-accessing' stamp: ''!
ads
	^ ads

! !

!ExChdAdaConstantInterfacesListFunction methodsFor: 'platypus-generated-accessing' stamp: ''!
ads: aBoolean
	ads := aBoolean

! !

!ExChdAdaConstantInterfacesListFunction methodsFor: 'platypus-generated-accessing' stamp: ''!
fromValues: values
	self r: (values at: 1).
	self ads: (values at: 2)

! !

!ExChdAdaConstantInterfacesListFunction methodsFor: 'platypus-generated-invoking' stamp: ''!
invoke
	" ---------- locals assignments ----------"

	self result: Array new.	" ---------- statements ----------"
	self
		adaDomain:
			(ExChdBasicAdaDomainFunction
				invokeFromValues:
					(OrderedCollection new
						add: (self r domainUsingContext: self class context);
						yourself)).
	self
		result:
			(ExChdDomainInterfacesListFunction
				invokeFromValues:
					(OrderedCollection new
						add: self adaDomain;
						add: self ads;
						add: (self r ownerUsingContext: self class context);
						yourself)).
	^ self return: self result

! !

!ExChdAdaConstantInterfacesListFunction methodsFor: 'platypus-generated-accessing' stamp: ''!
r
	^ r

! !

!ExChdAdaConstantInterfacesListFunction methodsFor: 'platypus-generated-accessing' stamp: ''!
r: aExChdAdaConstant
	r := aExChdAdaConstant

! !

!ExChdAdaConstantInterfacesListFunction methodsFor: 'platypus-generated-accessing' stamp: ''!
r: aExChdAdaConstant ads: aBoolean
	self r: aExChdAdaConstant.
	self ads: aBoolean

! !

!ExChdAdaConstantInterfacesListFunction methodsFor: 'platypus-generated-accessing' stamp: ''!
result
	^ result

! !

!ExChdAdaConstantInterfacesListFunction methodsFor: 'platypus-generated-accessing' stamp: ''!
result: aListOfExChdAdaInterface
	result := aListOfExChdAdaInterface
		ifNil: [ OrderedCollection new ]
		ifNotNil: [ aListOfExChdAdaInterface as: OrderedCollection ]

! !

PlatypusCoreAlgorithmDeclaration subclass: #ExChdAdaEntityAttributesXmlEndElementCodeFunction
	instanceVariableNames: 'cip code s'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Express2Cheddar-RecordAndClassSchema'!

!ExChdAdaEntityAttributesXmlEndElementCodeFunction commentStamp: 'platypus comment' prior: 0!
<ISO10303-11-EXPRESS>
FUNCTION ada_entity_attributes_xml_end_element_code ( cip : ada_class ) : STRING;
	LOCAL 
		code : STRING := '';
		s : STRING;
	END_LOCAL;

	IF SIZEOF ( cip.supertypes ) > 0 THEN

		ALIAS sup FOR cip.supertypes [ LOINDEX ( cip.supertypes ) ].handled;
			code := code + ada_entity_attributes_xml_end_element_code ( sup );
		END_ALIAS;
	END_IF;

	REPEAT no := LOINDEX ( cip.explicit_attributes ) TO HIINDEX ( cip.explicit_attributes );

		ALIAS attr FOR cip.explicit_attributes [ no];
			s := explicit_attribute_xml_end_element_code ( attr );
			IF ( s > '' ) THEN
				code := code + '\n' 
				+ s;
			END_IF;
		END_ALIAS;
	END_REPEAT;

	IF ( code = '' ) THEN
		code := '\tnull;\n';
	END_IF;
	RETURN ( code );
END_FUNCTION;
</ISO10303-11-EXPRESS>!

!ExChdAdaEntityAttributesXmlEndElementCodeFunction class methodsFor: 'platypus-generated-platypus-signature' stamp: ''!
iso10303P11Translater
	^ 'Platypus (c) LISYC EA3883, Universite de Bretagne occidentale. Brest.'

! !

!ExChdAdaEntityAttributesXmlEndElementCodeFunction class methodsFor: 'platypus-generated-meta-data-accessing' stamp: ''!
schemaDefinition
	^ ExChdRecordAndClassSchemaDefinition singleton

! !

!ExChdAdaEntityAttributesXmlEndElementCodeFunction class methodsFor: 'platypus-generated-platypus-signature' stamp: ''!
translatedFromISO10303P11
	^ true

! !

!ExChdAdaEntityAttributesXmlEndElementCodeFunction class methodsFor: 'platypus-generated-platypus-signature' stamp: ''!
vwNamespaceName
	^ #Express2Cheddar

! !

!ExChdAdaEntityAttributesXmlEndElementCodeFunction methodsFor: 'platypus-generated-accessing' stamp: ''!
cip
	^ cip

! !

!ExChdAdaEntityAttributesXmlEndElementCodeFunction methodsFor: 'platypus-generated-accessing' stamp: ''!
cip: aExChdAdaClass
	cip := aExChdAdaClass

! !

!ExChdAdaEntityAttributesXmlEndElementCodeFunction methodsFor: 'platypus-generated-accessing' stamp: ''!
code
	^ code

! !

!ExChdAdaEntityAttributesXmlEndElementCodeFunction methodsFor: 'platypus-generated-accessing' stamp: ''!
code: aString
	code := aString

! !

!ExChdAdaEntityAttributesXmlEndElementCodeFunction methodsFor: 'platypus-generated-accessing' stamp: ''!
fromValues: values
	self cip: (values at: 1)

! !

!ExChdAdaEntityAttributesXmlEndElementCodeFunction methodsFor: 'platypus-generated-invoking' stamp: ''!
invoke
	" ---------- locals assignments ----------"

	self code: ''.	" ---------- statements ----------"
	(PltSIZEOFFunction
		invokeFromValues:
			(OrderedCollection new
				add: (self cip supertypesUsingContext: self class context);
				yourself)) > 0
		ifTrue: [ 
			PlatypusCoreAliasStatement
				alias:
					(((self cip supertypesUsingContext: self class context)
						pltAt:
							(PltLOINDEXFunction
								invokeFromValues:
									(OrderedCollection new
										add: (self cip supertypesUsingContext: self class context);
										yourself))) handledUsingContext: self class context)
				statementsBlock: [ :sup2874 | 
					self
						code:
							(self code
								pltPlus:
									(ExChdAdaEntityAttributesXmlEndElementCodeFunction
										invokeFromValues:
											(OrderedCollection new
												add: sup2874;
												yourself))) ] ].
	PlatypusCoreRepeatStatement
		repeat: [ :no283 | 
			PlatypusCoreAliasStatement
				alias: ((self cip explicitAttributesUsingContext: self class context) pltAt: no283)
				statementsBlock: [ :attr2860 | 
					self
						s:
							(ExChdExplicitAttributeXmlEndElementCodeFunction
								invokeFromValues:
									(OrderedCollection new
										add: attr2860;
										yourself)).
					self s > ''
						ifTrue: [ self code: ((self code pltPlus: '\n') pltPlus: self s) ] ] ]
		from:
			(PltLOINDEXFunction
				invokeFromValues:
					(OrderedCollection new
						add: (self cip explicitAttributesUsingContext: self class context);
						yourself))
		to:
			(PltHIINDEXFunction
				invokeFromValues:
					(OrderedCollection new
						add: (self cip explicitAttributesUsingContext: self class context);
						yourself)).
	self code = ''
		ifTrue: [ self code: '\tnull;\n' ].
	^ self return: self code

! !

!ExChdAdaEntityAttributesXmlEndElementCodeFunction methodsFor: 'platypus-generated-accessing' stamp: ''!
s
	^ s

! !

!ExChdAdaEntityAttributesXmlEndElementCodeFunction methodsFor: 'platypus-generated-accessing' stamp: ''!
s: aString1
	s := aString1

! !

PlatypusCoreAlgorithmDeclaration subclass: #ExChdAdaEntityAttributesXmlIoRecordCodeFunction
	instanceVariableNames: 'cip code attrcode'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Express2Cheddar-RecordAndClassSchema'!

!ExChdAdaEntityAttributesXmlIoRecordCodeFunction commentStamp: 'platypus comment' prior: 0!
<ISO10303-11-EXPRESS>
FUNCTION ada_entity_attributes_xml_io_record_code ( cip : ada_class ) : STRING;
	LOCAL 
		code : STRING := '';
		attrcode : STRING;
	END_LOCAL;

	IF SIZEOF ( cip.supertypes ) > 0 THEN

		ALIAS sup FOR cip.supertypes [ LOINDEX ( cip.supertypes ) ].handled;
			code := code + ada_entity_attributes_xml_io_record_code ( sup );
		END_ALIAS;
	END_IF;

	REPEAT no := LOINDEX ( cip.explicit_attributes ) TO HIINDEX ( cip.explicit_attributes );

		ALIAS attr FOR cip.explicit_attributes [ no];
			attrcode := explicit_attribute_xml_io_record_code ( attr );
			code := code + attrcode;
		END_ALIAS;
	END_REPEAT;

	IF ( code = '' ) THEN
		code := '\tnull;';
	END_IF;
	RETURN ( code );
END_FUNCTION;
</ISO10303-11-EXPRESS>!

!ExChdAdaEntityAttributesXmlIoRecordCodeFunction class methodsFor: 'platypus-generated-platypus-signature' stamp: ''!
iso10303P11Translater
	^ 'Platypus (c) LISYC EA3883, Universite de Bretagne occidentale. Brest.'

! !

!ExChdAdaEntityAttributesXmlIoRecordCodeFunction class methodsFor: 'platypus-generated-meta-data-accessing' stamp: ''!
schemaDefinition
	^ ExChdRecordAndClassSchemaDefinition singleton

! !

!ExChdAdaEntityAttributesXmlIoRecordCodeFunction class methodsFor: 'platypus-generated-platypus-signature' stamp: ''!
translatedFromISO10303P11
	^ true

! !

!ExChdAdaEntityAttributesXmlIoRecordCodeFunction class methodsFor: 'platypus-generated-platypus-signature' stamp: ''!
vwNamespaceName
	^ #Express2Cheddar

! !

!ExChdAdaEntityAttributesXmlIoRecordCodeFunction methodsFor: 'platypus-generated-accessing' stamp: ''!
attrcode
	^ attrcode

! !

!ExChdAdaEntityAttributesXmlIoRecordCodeFunction methodsFor: 'platypus-generated-accessing' stamp: ''!
attrcode: aString1
	attrcode := aString1

! !

!ExChdAdaEntityAttributesXmlIoRecordCodeFunction methodsFor: 'platypus-generated-accessing' stamp: ''!
cip
	^ cip

! !

!ExChdAdaEntityAttributesXmlIoRecordCodeFunction methodsFor: 'platypus-generated-accessing' stamp: ''!
cip: aExChdAdaClass
	cip := aExChdAdaClass

! !

!ExChdAdaEntityAttributesXmlIoRecordCodeFunction methodsFor: 'platypus-generated-accessing' stamp: ''!
code
	^ code

! !

!ExChdAdaEntityAttributesXmlIoRecordCodeFunction methodsFor: 'platypus-generated-accessing' stamp: ''!
code: aString
	code := aString

! !

!ExChdAdaEntityAttributesXmlIoRecordCodeFunction methodsFor: 'platypus-generated-accessing' stamp: ''!
fromValues: values
	self cip: (values at: 1)

! !

!ExChdAdaEntityAttributesXmlIoRecordCodeFunction methodsFor: 'platypus-generated-invoking' stamp: ''!
invoke
	" ---------- locals assignments ----------"

	self code: ''.	" ---------- statements ----------"
	(PltSIZEOFFunction
		invokeFromValues:
			(OrderedCollection new
				add: (self cip supertypesUsingContext: self class context);
				yourself)) > 0
		ifTrue: [ 
			PlatypusCoreAliasStatement
				alias:
					(((self cip supertypesUsingContext: self class context)
						pltAt:
							(PltLOINDEXFunction
								invokeFromValues:
									(OrderedCollection new
										add: (self cip supertypesUsingContext: self class context);
										yourself))) handledUsingContext: self class context)
				statementsBlock: [ :sup3170 | 
					self
						code:
							(self code
								pltPlus:
									(ExChdAdaEntityAttributesXmlIoRecordCodeFunction
										invokeFromValues:
											(OrderedCollection new
												add: sup3170;
												yourself))) ] ].
	PlatypusCoreRepeatStatement
		repeat: [ :no575 | 
			PlatypusCoreAliasStatement
				alias: ((self cip explicitAttributesUsingContext: self class context) pltAt: no575)
				statementsBlock: [ :attr3152 | 
					self
						attrcode:
							(ExChdExplicitAttributeXmlIoRecordCodeFunction
								invokeFromValues:
									(OrderedCollection new
										add: attr3152;
										yourself)).
					self code: (self code pltPlus: self attrcode) ] ]
		from:
			(PltLOINDEXFunction
				invokeFromValues:
					(OrderedCollection new
						add: (self cip explicitAttributesUsingContext: self class context);
						yourself))
		to:
			(PltHIINDEXFunction
				invokeFromValues:
					(OrderedCollection new
						add: (self cip explicitAttributesUsingContext: self class context);
						yourself)).
	self code = ''
		ifTrue: [ self code: '\tnull;' ].
	^ self return: self code

! !

PlatypusCoreAlgorithmDeclaration subclass: #ExChdAdaEntityAttributesXmlIoRecordInitializeCodeFunction
	instanceVariableNames: 'cip code s'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Express2Cheddar-RecordAndClassSchema'!

!ExChdAdaEntityAttributesXmlIoRecordInitializeCodeFunction commentStamp: 'platypus comment' prior: 0!
<ISO10303-11-EXPRESS>
FUNCTION ada_entity_attributes_xml_io_record_initialize_code ( cip : ada_class ) : STRING;
	LOCAL 
		code : STRING := '';
		s : STRING;
	END_LOCAL;

	IF SIZEOF ( cip.supertypes ) > 0 THEN

		ALIAS sup FOR cip.supertypes [ LOINDEX ( cip.supertypes ) ].handled;
			code := code + ada_entity_attributes_xml_io_record_initialize_code ( sup );
		END_ALIAS;
	END_IF;

	REPEAT no := LOINDEX ( cip.explicit_attributes ) TO HIINDEX ( cip.explicit_attributes );

		ALIAS attr FOR cip.explicit_attributes [ no];
			s := explicit_attribute_xml_io_record_initialize_code ( attr );
			IF ( s > '' ) THEN
				code := code + '\n' 
				+ s;
			END_IF;
		END_ALIAS;
	END_REPEAT;
	RETURN ( code );
END_FUNCTION;
</ISO10303-11-EXPRESS>!

!ExChdAdaEntityAttributesXmlIoRecordInitializeCodeFunction class methodsFor: 'platypus-generated-platypus-signature' stamp: ''!
iso10303P11Translater
	^ 'Platypus (c) LISYC EA3883, Universite de Bretagne occidentale. Brest.'

! !

!ExChdAdaEntityAttributesXmlIoRecordInitializeCodeFunction class methodsFor: 'platypus-generated-meta-data-accessing' stamp: ''!
schemaDefinition
	^ ExChdRecordAndClassSchemaDefinition singleton

! !

!ExChdAdaEntityAttributesXmlIoRecordInitializeCodeFunction class methodsFor: 'platypus-generated-platypus-signature' stamp: ''!
translatedFromISO10303P11
	^ true

! !

!ExChdAdaEntityAttributesXmlIoRecordInitializeCodeFunction class methodsFor: 'platypus-generated-platypus-signature' stamp: ''!
vwNamespaceName
	^ #Express2Cheddar

! !

!ExChdAdaEntityAttributesXmlIoRecordInitializeCodeFunction methodsFor: 'platypus-generated-accessing' stamp: ''!
cip
	^ cip

! !

!ExChdAdaEntityAttributesXmlIoRecordInitializeCodeFunction methodsFor: 'platypus-generated-accessing' stamp: ''!
cip: aExChdAdaClass
	cip := aExChdAdaClass

! !

!ExChdAdaEntityAttributesXmlIoRecordInitializeCodeFunction methodsFor: 'platypus-generated-accessing' stamp: ''!
code
	^ code

! !

!ExChdAdaEntityAttributesXmlIoRecordInitializeCodeFunction methodsFor: 'platypus-generated-accessing' stamp: ''!
code: aString
	code := aString

! !

!ExChdAdaEntityAttributesXmlIoRecordInitializeCodeFunction methodsFor: 'platypus-generated-accessing' stamp: ''!
fromValues: values
	self cip: (values at: 1)

! !

!ExChdAdaEntityAttributesXmlIoRecordInitializeCodeFunction methodsFor: 'platypus-generated-invoking' stamp: ''!
invoke
	" ---------- locals assignments ----------"

	self code: ''.	" ---------- statements ----------"
	(PltSIZEOFFunction
		invokeFromValues:
			(OrderedCollection new
				add: (self cip supertypesUsingContext: self class context);
				yourself)) > 0
		ifTrue: [ 
			PlatypusCoreAliasStatement
				alias:
					(((self cip supertypesUsingContext: self class context)
						pltAt:
							(PltLOINDEXFunction
								invokeFromValues:
									(OrderedCollection new
										add: (self cip supertypesUsingContext: self class context);
										yourself))) handledUsingContext: self class context)
				statementsBlock: [ :sup2722 | 
					self
						code:
							(self code
								pltPlus:
									(ExChdAdaEntityAttributesXmlIoRecordInitializeCodeFunction
										invokeFromValues:
											(OrderedCollection new
												add: sup2722;
												yourself))) ] ].
	PlatypusCoreRepeatStatement
		repeat: [ :no139 | 
			PlatypusCoreAliasStatement
				alias: ((self cip explicitAttributesUsingContext: self class context) pltAt: no139)
				statementsBlock: [ :attr2716 | 
					self
						s:
							(ExChdExplicitAttributeXmlIoRecordInitializeCodeFunction
								invokeFromValues:
									(OrderedCollection new
										add: attr2716;
										yourself)).
					self s > ''
						ifTrue: [ self code: ((self code pltPlus: '\n') pltPlus: self s) ] ] ]
		from:
			(PltLOINDEXFunction
				invokeFromValues:
					(OrderedCollection new
						add: (self cip explicitAttributesUsingContext: self class context);
						yourself))
		to:
			(PltHIINDEXFunction
				invokeFromValues:
					(OrderedCollection new
						add: (self cip explicitAttributesUsingContext: self class context);
						yourself)).
	^ self return: self code

! !

!ExChdAdaEntityAttributesXmlIoRecordInitializeCodeFunction methodsFor: 'platypus-generated-accessing' stamp: ''!
s
	^ s

! !

!ExChdAdaEntityAttributesXmlIoRecordInitializeCodeFunction methodsFor: 'platypus-generated-accessing' stamp: ''!
s: aString1
	s := aString1

! !

PlatypusCoreAlgorithmDeclaration subclass: #ExChdAdaEntityAttributesXmlStartElementCodeFunction
	instanceVariableNames: 'cip code s'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Express2Cheddar-RecordAndClassSchema'!

!ExChdAdaEntityAttributesXmlStartElementCodeFunction commentStamp: 'platypus comment' prior: 0!
<ISO10303-11-EXPRESS>
FUNCTION ada_entity_attributes_xml_start_element_code ( cip : ada_class ) : STRING;
	LOCAL 
		code : STRING := '';
		s : STRING;
	END_LOCAL;

	IF SIZEOF ( cip.supertypes ) > 0 THEN

		ALIAS sup FOR cip.supertypes [ LOINDEX ( cip.supertypes ) ].handled;
			code := code + ada_entity_attributes_xml_start_element_code ( sup );
		END_ALIAS;
	END_IF;

	REPEAT no := LOINDEX ( cip.explicit_attributes ) TO HIINDEX ( cip.explicit_attributes );

		ALIAS attr FOR cip.explicit_attributes [ no];
			s := explicit_attribute_xml_start_element_code ( attr );
			IF ( s > '' ) THEN
				code := code + s;
			END_IF;
		END_ALIAS;
	END_REPEAT;
	RETURN ( code );
END_FUNCTION;
</ISO10303-11-EXPRESS>!

!ExChdAdaEntityAttributesXmlStartElementCodeFunction class methodsFor: 'platypus-generated-platypus-signature' stamp: ''!
iso10303P11Translater
	^ 'Platypus (c) LISYC EA3883, Universite de Bretagne occidentale. Brest.'

! !

!ExChdAdaEntityAttributesXmlStartElementCodeFunction class methodsFor: 'platypus-generated-meta-data-accessing' stamp: ''!
schemaDefinition
	^ ExChdRecordAndClassSchemaDefinition singleton

! !

!ExChdAdaEntityAttributesXmlStartElementCodeFunction class methodsFor: 'platypus-generated-platypus-signature' stamp: ''!
translatedFromISO10303P11
	^ true

! !

!ExChdAdaEntityAttributesXmlStartElementCodeFunction class methodsFor: 'platypus-generated-platypus-signature' stamp: ''!
vwNamespaceName
	^ #Express2Cheddar

! !

!ExChdAdaEntityAttributesXmlStartElementCodeFunction methodsFor: 'platypus-generated-accessing' stamp: ''!
cip
	^ cip

! !

!ExChdAdaEntityAttributesXmlStartElementCodeFunction methodsFor: 'platypus-generated-accessing' stamp: ''!
cip: aExChdAdaClass
	cip := aExChdAdaClass

! !

!ExChdAdaEntityAttributesXmlStartElementCodeFunction methodsFor: 'platypus-generated-accessing' stamp: ''!
code
	^ code

! !

!ExChdAdaEntityAttributesXmlStartElementCodeFunction methodsFor: 'platypus-generated-accessing' stamp: ''!
code: aString
	code := aString

! !

!ExChdAdaEntityAttributesXmlStartElementCodeFunction methodsFor: 'platypus-generated-accessing' stamp: ''!
fromValues: values
	self cip: (values at: 1)

! !

!ExChdAdaEntityAttributesXmlStartElementCodeFunction methodsFor: 'platypus-generated-invoking' stamp: ''!
invoke
	" ---------- locals assignments ----------"

	self code: ''.	" ---------- statements ----------"
	(PltSIZEOFFunction
		invokeFromValues:
			(OrderedCollection new
				add: (self cip supertypesUsingContext: self class context);
				yourself)) > 0
		ifTrue: [ 
			PlatypusCoreAliasStatement
				alias:
					(((self cip supertypesUsingContext: self class context)
						pltAt:
							(PltLOINDEXFunction
								invokeFromValues:
									(OrderedCollection new
										add: (self cip supertypesUsingContext: self class context);
										yourself))) handledUsingContext: self class context)
				statementsBlock: [ :sup1322 | 
					self
						code:
							(self code
								pltPlus:
									(ExChdAdaEntityAttributesXmlStartElementCodeFunction
										invokeFromValues:
											(OrderedCollection new
												add: sup1322;
												yourself))) ] ].
	PlatypusCoreRepeatStatement
		repeat: [ :no2820 | 
			PlatypusCoreAliasStatement
				alias: ((self cip explicitAttributesUsingContext: self class context) pltAt: no2820)
				statementsBlock: [ :attr1301 | 
					self
						s:
							(ExChdExplicitAttributeXmlStartElementCodeFunction
								invokeFromValues:
									(OrderedCollection new
										add: attr1301;
										yourself)).
					self s > ''
						ifTrue: [ self code: (self code pltPlus: self s) ] ] ]
		from:
			(PltLOINDEXFunction
				invokeFromValues:
					(OrderedCollection new
						add: (self cip explicitAttributesUsingContext: self class context);
						yourself))
		to:
			(PltHIINDEXFunction
				invokeFromValues:
					(OrderedCollection new
						add: (self cip explicitAttributesUsingContext: self class context);
						yourself)).
	^ self return: self code

! !

!ExChdAdaEntityAttributesXmlStartElementCodeFunction methodsFor: 'platypus-generated-accessing' stamp: ''!
s
	^ s

! !

!ExChdAdaEntityAttributesXmlStartElementCodeFunction methodsFor: 'platypus-generated-accessing' stamp: ''!
s: aString1
	s := aString1

! !

PlatypusCoreAlgorithmDeclaration subclass: #ExChdAdaEntityInterfacesListFunction
	instanceVariableNames: 'r ads result'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Express2Cheddar-RecordAndClassSchema'!

!ExChdAdaEntityInterfacesListFunction commentStamp: 'platypus comment' prior: 0!
<ISO10303-11-EXPRESS>
FUNCTION ada_entity_interfaces_list ( r : ada_entity; ads : BOOLEAN ) : LIST OF ada_interface;
	LOCAL 
		result : LIST OF ada_interface := entity_definition_interfaces_list ( r, ads );
	END_LOCAL;

	IF ads THEN

		IF 'PACKAGE.ADA_PACKAGE' IN TYPEOF ( r.owner ) THEN
			result := result + ada_interface ( r.owner.name, ?, true, true );
		END_IF;

		IF ( SIZEOF ( r.supertypes ) > 0 ) THEN
			ALIAS supref FOR r.supertypes [ 1 ].ref;
				IF 'PACKAGE.ADA_PACKAGE' IN TYPEOF ( supref.owner ) THEN
					result := result + ada_interface ( supref.owner.name, ?, true, true );
				END_IF;
			END_ALIAS;
		END_IF;
		result := result + ada_interface ( 'Ada.Finalization', ?, true, false );
		result := result + ada_interface ( 'unbounded_strings', ?, true, true );
		result := result + ada_interface ( 'ada.strings', 'unbounded', true, true );
		result := result + ada_interface ( 'unbounded_strings', 'Unbounded_String_List_Package', false, true );
		result := result + ada_interface ( 'Unchecked_Deallocation', ?, true, false );
		result := result + ada_interface ( 'Primitive_XML_Strings', ?, true, true );
	ELSE

		IF has_attribute_named ( r, xml_id_name ) THEN
			result := result + ada_interface ( 'framework', ?, true, true );
			result := result + ada_interface ( 'id_generators', ?, true, true );
		END_IF;
	END_IF;
	RETURN ( result );
END_FUNCTION;
</ISO10303-11-EXPRESS>!

!ExChdAdaEntityInterfacesListFunction class methodsFor: 'platypus-generated-platypus-signature' stamp: ''!
iso10303P11Translater
	^ 'Platypus (c) LISYC EA3883, Universite de Bretagne occidentale. Brest.'

! !

!ExChdAdaEntityInterfacesListFunction class methodsFor: 'platypus-generated-meta-data-accessing' stamp: ''!
schemaDefinition
	^ ExChdRecordAndClassSchemaDefinition singleton

! !

!ExChdAdaEntityInterfacesListFunction class methodsFor: 'platypus-generated-platypus-signature' stamp: ''!
translatedFromISO10303P11
	^ true

! !

!ExChdAdaEntityInterfacesListFunction class methodsFor: 'platypus-generated-platypus-signature' stamp: ''!
vwNamespaceName
	^ #Express2Cheddar

! !

!ExChdAdaEntityInterfacesListFunction methodsFor: 'platypus-generated-accessing' stamp: ''!
ads
	^ ads

! !

!ExChdAdaEntityInterfacesListFunction methodsFor: 'platypus-generated-accessing' stamp: ''!
ads: aBoolean
	ads := aBoolean

! !

!ExChdAdaEntityInterfacesListFunction methodsFor: 'platypus-generated-accessing' stamp: ''!
fromValues: values
	self r: (values at: 1).
	self ads: (values at: 2)

! !

!ExChdAdaEntityInterfacesListFunction methodsFor: 'platypus-generated-invoking' stamp: ''!
invoke
	" ---------- locals assignments ----------"

	self
		result:
			(ExChdEntityDefinitionInterfacesListFunction
				invokeFromValues:
					(OrderedCollection new
						add: self r;
						add: self ads;
						yourself)).	" ---------- statements ----------"
	self ads
		ifTrue: [ 
			((PltTYPEOFFunction
				invokeFromValues:
					(OrderedCollection new
						add: (self r ownerUsingContext: self class context);
						yourself)) includes: 'PACKAGE.ADA_PACKAGE')
				ifTrue: [ 
					self
						result:
							(self result
								pltPlus:
									(ExChdAdaInterface new
										adaInterfaceFromValues:
												(OrderedCollection new
														add: ((self r ownerUsingContext: self class context) nameUsingContext: self class context);
														add: nil;
														add: true;
														add: true;
														yourself);
										yourself)) ].
			(PltSIZEOFFunction
				invokeFromValues:
					(OrderedCollection new
						add: (self r supertypesUsingContext: self class context);
						yourself)) > 0
				ifTrue: [ 
					PlatypusCoreAliasStatement
						alias: (((self r supertypesUsingContext: self class context) pltAt: 1) refUsingContext: self class context)
						statementsBlock: [ :supref586 | 
							((PltTYPEOFFunction
								invokeFromValues:
									(OrderedCollection new
										add: (supref586 ownerUsingContext: self class context);
										yourself)) includes: 'PACKAGE.ADA_PACKAGE')
								ifTrue: [ 
									self
										result:
											(self result
												pltPlus:
													(ExChdAdaInterface new
														adaInterfaceFromValues:
																(OrderedCollection new
																		add: ((supref586 ownerUsingContext: self class context) nameUsingContext: self class context);
																		add: nil;
																		add: true;
																		add: true;
																		yourself);
														yourself)) ] ] ].
			self
				result:
					(self result
						pltPlus:
							(ExChdAdaInterface new
								adaInterfaceFromValues:
										(OrderedCollection new
												add: 'Ada.Finalization';
												add: nil;
												add: true;
												add: false;
												yourself);
								yourself)).
			self
				result:
					(self result
						pltPlus:
							(ExChdAdaInterface new
								adaInterfaceFromValues:
										(OrderedCollection new
												add: 'unbounded_strings';
												add: nil;
												add: true;
												add: true;
												yourself);
								yourself)).
			self
				result:
					(self result
						pltPlus:
							(ExChdAdaInterface new
								adaInterfaceFromValues:
										(OrderedCollection new
												add: 'ada.strings';
												add: 'unbounded';
												add: true;
												add: true;
												yourself);
								yourself)).
			self
				result:
					(self result
						pltPlus:
							(ExChdAdaInterface new
								adaInterfaceFromValues:
										(OrderedCollection new
												add: 'unbounded_strings';
												add: 'Unbounded_String_List_Package';
												add: false;
												add: true;
												yourself);
								yourself)).
			self
				result:
					(self result
						pltPlus:
							(ExChdAdaInterface new
								adaInterfaceFromValues:
										(OrderedCollection new
												add: 'Unchecked_Deallocation';
												add: nil;
												add: true;
												add: false;
												yourself);
								yourself)).
			self
				result:
					(self result
						pltPlus:
							(ExChdAdaInterface new
								adaInterfaceFromValues:
										(OrderedCollection new
												add: 'Primitive_XML_Strings';
												add: nil;
												add: true;
												add: true;
												yourself);
								yourself)) ]
		ifFalse: [ 
			(PTsHasAttributeNamedFunction
				invokeFromValues:
					(OrderedCollection new
						add: self r;
						add: 'cheddar_private_id';
						yourself))
				ifTrue: [ 
					self
						result:
							(self result
								pltPlus:
									(ExChdAdaInterface new
										adaInterfaceFromValues:
												(OrderedCollection new
														add: 'framework';
														add: nil;
														add: true;
														add: true;
														yourself);
										yourself)).
					self
						result:
							(self result
								pltPlus:
									(ExChdAdaInterface new
										adaInterfaceFromValues:
												(OrderedCollection new
														add: 'id_generators';
														add: nil;
														add: true;
														add: true;
														yourself);
										yourself)) ] ].
	^ self return: self result

! !

!ExChdAdaEntityInterfacesListFunction methodsFor: 'platypus-generated-accessing' stamp: ''!
r
	^ r

! !

!ExChdAdaEntityInterfacesListFunction methodsFor: 'platypus-generated-accessing' stamp: ''!
r: aExChdAdaEntity
	r := aExChdAdaEntity

! !

!ExChdAdaEntityInterfacesListFunction methodsFor: 'platypus-generated-accessing' stamp: ''!
r: aExChdAdaEntity ads: aBoolean
	self r: aExChdAdaEntity.
	self ads: aBoolean

! !

!ExChdAdaEntityInterfacesListFunction methodsFor: 'platypus-generated-accessing' stamp: ''!
result
	^ result

! !

!ExChdAdaEntityInterfacesListFunction methodsFor: 'platypus-generated-accessing' stamp: ''!
result: aListOfExChdAdaInterface
	result := aListOfExChdAdaInterface
		ifNil: [ OrderedCollection new ]
		ifNotNil: [ aListOfExChdAdaInterface as: OrderedCollection ]

! !

PlatypusCoreAlgorithmDeclaration subclass: #ExChdAdaEntityNamedFunction
	instanceVariableNames: 'name entities key'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Express2Cheddar-Express2cheddarFacadeSchema'!

!ExChdAdaEntityNamedFunction commentStamp: 'platypus comment' prior: 0!
<ISO10303-11-EXPRESS>
FUNCTION ada_entity_named ( name : STRING ) : ada_entity;
	LOCAL 
		entities : LIST OF ada_entity := all_ada_entities ( );
		key : STRING := Lowerize ( name );
	END_LOCAL;

	REPEAT no := LOINDEX ( entities ) TO HIINDEX ( entities );

		ALIAS curr FOR entities [ no];
			IF ( Lowerize ( curr.name ) = key ) THEN
				RETURN ( curr );
			END_IF;
		END_ALIAS;
	END_REPEAT;
	RETURN ( ? );
END_FUNCTION;
</ISO10303-11-EXPRESS>!

!ExChdAdaEntityNamedFunction class methodsFor: 'platypus-generated-platypus-signature' stamp: ''!
iso10303P11Translater
	^ 'Platypus (c) LISYC EA3883, Universite de Bretagne occidentale. Brest.'

! !

!ExChdAdaEntityNamedFunction class methodsFor: 'platypus-generated-meta-data-accessing' stamp: ''!
schemaDefinition
	^ ExChdExpress2cheddarFacadeSchemaDefinition singleton

! !

!ExChdAdaEntityNamedFunction class methodsFor: 'platypus-generated-platypus-signature' stamp: ''!
translatedFromISO10303P11
	^ true

! !

!ExChdAdaEntityNamedFunction class methodsFor: 'platypus-generated-platypus-signature' stamp: ''!
vwNamespaceName
	^ #Express2Cheddar

! !

!ExChdAdaEntityNamedFunction methodsFor: 'platypus-generated-accessing' stamp: ''!
entities
	^ entities

! !

!ExChdAdaEntityNamedFunction methodsFor: 'platypus-generated-accessing' stamp: ''!
entities: aListOfExChdAdaEntity
	entities := aListOfExChdAdaEntity
		ifNil: [ OrderedCollection new ]
		ifNotNil: [ aListOfExChdAdaEntity as: OrderedCollection ]

! !

!ExChdAdaEntityNamedFunction methodsFor: 'platypus-generated-accessing' stamp: ''!
fromValues: values
	self name: (values at: 1)

! !

!ExChdAdaEntityNamedFunction methodsFor: 'platypus-generated-invoking' stamp: ''!
invoke
	" ---------- locals assignments ----------"

	self entities: ExChdAllAdaEntitiesFunction invoke.
	self
		key:
			(PTsLowerizeFunction
				invokeFromValues:
					(OrderedCollection new
						add: self name;
						yourself)).	" ---------- statements ----------"
	PlatypusCoreRepeatStatement
		repeat: [ :no2282 | 
			PlatypusCoreAliasStatement
				alias: (self entities pltAt: no2282)
				statementsBlock: [ :curr9 | 
					(PTsLowerizeFunction
						invokeFromValues:
							(OrderedCollection new
								add: (curr9 nameUsingContext: self class context);
								yourself)) = self key
						ifTrue: [ ^ self return: curr9 ] ] ]
		from:
			(PltLOINDEXFunction
				invokeFromValues:
					(OrderedCollection new
						add: self entities;
						yourself))
		to:
			(PltHIINDEXFunction
				invokeFromValues:
					(OrderedCollection new
						add: self entities;
						yourself)).
	^ self return: nil

! !

!ExChdAdaEntityNamedFunction methodsFor: 'platypus-generated-accessing' stamp: ''!
key
	^ key

! !

!ExChdAdaEntityNamedFunction methodsFor: 'platypus-generated-accessing' stamp: ''!
key: aString
	key := aString

! !

!ExChdAdaEntityNamedFunction methodsFor: 'platypus-generated-accessing' stamp: ''!
name
	^ name

! !

!ExChdAdaEntityNamedFunction methodsFor: 'platypus-generated-accessing' stamp: ''!
name: aString
	name := aString

! !

PlatypusCoreAlgorithmDeclaration subclass: #ExChdAdaEntityXmlEndElementCodeFunction
	instanceVariableNames: 'cip'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Express2Cheddar-RecordAndClassSchema'!

!ExChdAdaEntityXmlEndElementCodeFunction commentStamp: 'platypus comment' prior: 0!
<ISO10303-11-EXPRESS>
FUNCTION ada_entity_xml_end_element_code ( cip : ada_entity ) : STRING;
	RETURN ( '\nprocedure End_Element(\n' 
		+ '\tHandler : in out Xml_generic_parser;\n' 
		+ '\tobj : in out ' + cip.name + '_io;\n' 
		+ '\tNamespace_Uri : Unicode.CES.Byte_Sequence := "";\n' 
		+ '\tLocal_Name    : Unicode.CES.Byte_Sequence := "";\n' 
		+ '\tQname : Unicode.CES.Byte_Sequence := "") is \nbegin\n' 
		+ ada_entity_attributes_xml_end_element_code ( cip ) + '\nend End_Element;\n' );
END_FUNCTION;
</ISO10303-11-EXPRESS>!

!ExChdAdaEntityXmlEndElementCodeFunction class methodsFor: 'platypus-generated-platypus-signature' stamp: ''!
iso10303P11Translater
	^ 'Platypus (c) LISYC EA3883, Universite de Bretagne occidentale. Brest.'

! !

!ExChdAdaEntityXmlEndElementCodeFunction class methodsFor: 'platypus-generated-meta-data-accessing' stamp: ''!
schemaDefinition
	^ ExChdRecordAndClassSchemaDefinition singleton

! !

!ExChdAdaEntityXmlEndElementCodeFunction class methodsFor: 'platypus-generated-platypus-signature' stamp: ''!
translatedFromISO10303P11
	^ true

! !

!ExChdAdaEntityXmlEndElementCodeFunction class methodsFor: 'platypus-generated-platypus-signature' stamp: ''!
vwNamespaceName
	^ #Express2Cheddar

! !

!ExChdAdaEntityXmlEndElementCodeFunction methodsFor: 'platypus-generated-accessing' stamp: ''!
cip
	^ cip

! !

!ExChdAdaEntityXmlEndElementCodeFunction methodsFor: 'platypus-generated-accessing' stamp: ''!
cip: aExChdAdaEntity
	cip := aExChdAdaEntity

! !

!ExChdAdaEntityXmlEndElementCodeFunction methodsFor: 'platypus-generated-accessing' stamp: ''!
fromValues: values
	self cip: (values at: 1)

! !

!ExChdAdaEntityXmlEndElementCodeFunction methodsFor: 'platypus-generated-invoking' stamp: ''!
invoke
	" ---------- locals assignments ----------"

	" ---------- statements ----------"

	^ self
		return:
			((((((((('\nprocedure End_Element(\n' pltPlus: '\tHandler : in out Xml_generic_parser;\n') pltPlus: '\tobj : in out ')
				pltPlus: (self cip nameUsingContext: self class context)) pltPlus: '_io;\n')
				pltPlus: '\tNamespace_Uri : Unicode.CES.Byte_Sequence := "";\n')
				pltPlus: '\tLocal_Name    : Unicode.CES.Byte_Sequence := "";\n')
				pltPlus: '\tQname : Unicode.CES.Byte_Sequence := "") is \nbegin\n')
				pltPlus:
					(ExChdAdaEntityAttributesXmlEndElementCodeFunction
						invokeFromValues:
							(OrderedCollection new
								add: self cip;
								yourself))) pltPlus: '\nend End_Element;\n')

! !

PlatypusCoreAlgorithmDeclaration subclass: #ExChdAdaEntityXmlIoRecordInitializeCodeFunction
	instanceVariableNames: 'cip code'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Express2Cheddar-RecordAndClassSchema'!

!ExChdAdaEntityXmlIoRecordInitializeCodeFunction commentStamp: 'platypus comment' prior: 0!
<ISO10303-11-EXPRESS>
FUNCTION ada_entity_xml_io_record_initialize_code ( cip : ada_class ) : STRING;
	LOCAL 
		code : STRING := ada_entity_attributes_xml_io_record_initialize_code ( cip );
	END_LOCAL;

	IF ( code = '' ) THEN
		code := '\tnull;';
	END_IF;
	RETURN ( '\nprocedure Initialize(obj : out ' + cip.name + '_io) is \nbegin ' + code + '\nend Initialize;\n' );
END_FUNCTION;
</ISO10303-11-EXPRESS>!

!ExChdAdaEntityXmlIoRecordInitializeCodeFunction class methodsFor: 'platypus-generated-platypus-signature' stamp: ''!
iso10303P11Translater
	^ 'Platypus (c) LISYC EA3883, Universite de Bretagne occidentale. Brest.'

! !

!ExChdAdaEntityXmlIoRecordInitializeCodeFunction class methodsFor: 'platypus-generated-meta-data-accessing' stamp: ''!
schemaDefinition
	^ ExChdRecordAndClassSchemaDefinition singleton

! !

!ExChdAdaEntityXmlIoRecordInitializeCodeFunction class methodsFor: 'platypus-generated-platypus-signature' stamp: ''!
translatedFromISO10303P11
	^ true

! !

!ExChdAdaEntityXmlIoRecordInitializeCodeFunction class methodsFor: 'platypus-generated-platypus-signature' stamp: ''!
vwNamespaceName
	^ #Express2Cheddar

! !

!ExChdAdaEntityXmlIoRecordInitializeCodeFunction methodsFor: 'platypus-generated-accessing' stamp: ''!
cip
	^ cip

! !

!ExChdAdaEntityXmlIoRecordInitializeCodeFunction methodsFor: 'platypus-generated-accessing' stamp: ''!
cip: aExChdAdaClass
	cip := aExChdAdaClass

! !

!ExChdAdaEntityXmlIoRecordInitializeCodeFunction methodsFor: 'platypus-generated-accessing' stamp: ''!
code
	^ code

! !

!ExChdAdaEntityXmlIoRecordInitializeCodeFunction methodsFor: 'platypus-generated-accessing' stamp: ''!
code: aString
	code := aString

! !

!ExChdAdaEntityXmlIoRecordInitializeCodeFunction methodsFor: 'platypus-generated-accessing' stamp: ''!
fromValues: values
	self cip: (values at: 1)

! !

!ExChdAdaEntityXmlIoRecordInitializeCodeFunction methodsFor: 'platypus-generated-invoking' stamp: ''!
invoke
	" ---------- locals assignments ----------"

	self
		code:
			(ExChdAdaEntityAttributesXmlIoRecordInitializeCodeFunction
				invokeFromValues:
					(OrderedCollection new
						add: self cip;
						yourself)).	" ---------- statements ----------"
	self code = ''
		ifTrue: [ self code: '\tnull;' ].
	^ self
		return:
			(((('\nprocedure Initialize(obj : out ' pltPlus: (self cip nameUsingContext: self class context))
				pltPlus: '_io) is \nbegin ') pltPlus: self code) pltPlus: '\nend Initialize;\n')

! !

PlatypusCoreAlgorithmDeclaration subclass: #ExChdAdaEntityXmlStartElementCodeFunction
	instanceVariableNames: 'cip code'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Express2Cheddar-RecordAndClassSchema'!

!ExChdAdaEntityXmlStartElementCodeFunction commentStamp: 'platypus comment' prior: 0!
<ISO10303-11-EXPRESS>
FUNCTION ada_entity_xml_start_element_code ( cip : ada_entity ) : STRING;
	LOCAL 
		code : STRING;
	END_LOCAL;

	IF ( 'RECORD_AND_CLASS.RECORD' IN TYPEOF ( cip ) ) THEN
		code := '\nprocedure Start_Element(\n' 
		+ '\tHandler: in out Xml_Generic_Parser;\n' 
		+ '\tobj : in out ' + cip.name + '_io;\n' 
		+ '\tNamespace_Uri : Unicode.CES.Byte_Sequence := "";\n' 
		+ '\tLocal_Name : Unicode.CES.Byte_Sequence := "";\n' 
		+ '\tQname : Unicode.CES.Byte_Sequence := "";\n' 
		+ '\tAtts : Sax.Attributes.Attributes''Class) is\n' 
		+ 'begin\n' 
		+ '\tif To_String (To_Lower (Qname)) = "' + cip.html_tag + '" then\n' 
		+ '\t\tinitialize(obj);\n' 
		+ '\tend if;\n' 
		+ 'end Start_Element;\n';
	ELSE
		code := ada_entity_attributes_xml_start_element_code ( cip );

		IF ( code > '' ) THEN
			code := '\nprocedure Start_Element(\n' 
			+ '\tHandler: in out Xml_Generic_Parser;\n' 
			+ '\tobj : in out ' + cip.name + '_io;\n' 
			+ '\tNamespace_Uri : Unicode.CES.Byte_Sequence := "";\n' 
			+ '\tLocal_Name : Unicode.CES.Byte_Sequence := "";\n' 
			+ '\tQname : Unicode.CES.Byte_Sequence := "";\n' 
			+ '\tAtts : Sax.Attributes.Attributes''Class) is \nbegin\n' 
			+ '\tif Get_Length (Atts) > 0 then' + code + '\n' 
			+ '\tend if;\n' 
			+ 'end Start_Element;\n';
		END_IF;
	END_IF;
	RETURN ( code );
END_FUNCTION;
</ISO10303-11-EXPRESS>!

!ExChdAdaEntityXmlStartElementCodeFunction class methodsFor: 'platypus-generated-platypus-signature' stamp: ''!
iso10303P11Translater
	^ 'Platypus (c) LISYC EA3883, Universite de Bretagne occidentale. Brest.'

! !

!ExChdAdaEntityXmlStartElementCodeFunction class methodsFor: 'platypus-generated-meta-data-accessing' stamp: ''!
schemaDefinition
	^ ExChdRecordAndClassSchemaDefinition singleton

! !

!ExChdAdaEntityXmlStartElementCodeFunction class methodsFor: 'platypus-generated-platypus-signature' stamp: ''!
translatedFromISO10303P11
	^ true

! !

!ExChdAdaEntityXmlStartElementCodeFunction class methodsFor: 'platypus-generated-platypus-signature' stamp: ''!
vwNamespaceName
	^ #Express2Cheddar

! !

!ExChdAdaEntityXmlStartElementCodeFunction methodsFor: 'platypus-generated-accessing' stamp: ''!
cip
	^ cip

! !

!ExChdAdaEntityXmlStartElementCodeFunction methodsFor: 'platypus-generated-accessing' stamp: ''!
cip: aExChdAdaEntity
	cip := aExChdAdaEntity

! !

!ExChdAdaEntityXmlStartElementCodeFunction methodsFor: 'platypus-generated-accessing' stamp: ''!
code
	^ code

! !

!ExChdAdaEntityXmlStartElementCodeFunction methodsFor: 'platypus-generated-accessing' stamp: ''!
code: aString
	code := aString

! !

!ExChdAdaEntityXmlStartElementCodeFunction methodsFor: 'platypus-generated-accessing' stamp: ''!
fromValues: values
	self cip: (values at: 1)

! !

!ExChdAdaEntityXmlStartElementCodeFunction methodsFor: 'platypus-generated-invoking' stamp: ''!
invoke
	" ---------- locals assignments ----------"

	" ---------- statements ----------"

	((PltTYPEOFFunction
		invokeFromValues:
			(OrderedCollection new
				add: self cip;
				yourself)) includes: 'RECORD_AND_CLASS.RECORD')
		ifTrue: [ 
			self
				code:
					((((((((((((((('\nprocedure Start_Element(\n' pltPlus: '\tHandler: in out Xml_Generic_Parser;\n')
						pltPlus: '\tobj : in out ') pltPlus: (self cip nameUsingContext: self class context)) pltPlus: '_io;\n')
						pltPlus: '\tNamespace_Uri : Unicode.CES.Byte_Sequence := "";\n')
						pltPlus: '\tLocal_Name : Unicode.CES.Byte_Sequence := "";\n')
						pltPlus: '\tQname : Unicode.CES.Byte_Sequence := "";\n')
						pltPlus: '\tAtts : Sax.Attributes.Attributes''Class) is\n') pltPlus: 'begin\n')
						pltPlus: '\tif To_String (To_Lower (Qname)) = "') pltPlus: (self cip htmlTagUsingContext: self class context))
						pltPlus: '" then\n') pltPlus: '\t\tinitialize(obj);\n') pltPlus: '\tend if;\n') pltPlus: 'end Start_Element;\n') ]
		ifFalse: [ 
			self
				code:
					(ExChdAdaEntityAttributesXmlStartElementCodeFunction
						invokeFromValues:
							(OrderedCollection new
								add: self cip;
								yourself)).
			self code > ''
				ifTrue: [ 
					self
						code:
							((((((((((((('\nprocedure Start_Element(\n' pltPlus: '\tHandler: in out Xml_Generic_Parser;\n')
								pltPlus: '\tobj : in out ') pltPlus: (self cip nameUsingContext: self class context)) pltPlus: '_io;\n')
								pltPlus: '\tNamespace_Uri : Unicode.CES.Byte_Sequence := "";\n')
								pltPlus: '\tLocal_Name : Unicode.CES.Byte_Sequence := "";\n')
								pltPlus: '\tQname : Unicode.CES.Byte_Sequence := "";\n')
								pltPlus: '\tAtts : Sax.Attributes.Attributes''Class) is \nbegin\n') pltPlus: '\tif Get_Length (Atts) > 0 then')
								pltPlus: self code) pltPlus: '\n') pltPlus: '\tend if;\n') pltPlus: 'end Start_Element;\n') ] ].
	^ self return: self code

! !

PlatypusCoreAlgorithmDeclaration subclass: #ExChdAdaInterfaceDeclarationFunction
	instanceVariableNames: 'int s name'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Express2Cheddar-AdaInterfaceSchema'!

!ExChdAdaInterfaceDeclarationFunction commentStamp: 'platypus comment' prior: 0!
<ISO10303-11-EXPRESS>
FUNCTION ada_interface_declaration ( int : ada_interface ) : STRING;
	LOCAL 
		s : STRING := '';
		name : STRING := ada_interface_path ( int );
	END_LOCAL;

	IF int.with_it THEN
		s := s + 'with ' + name + ';\n';
	END_IF;

	IF int.use_it THEN
		s := s + 'use ' + name + ';\n';
	END_IF;
	RETURN ( s );
END_FUNCTION;
</ISO10303-11-EXPRESS>!

!ExChdAdaInterfaceDeclarationFunction class methodsFor: 'platypus-generated-platypus-signature' stamp: ''!
iso10303P11Translater
	^ 'Platypus (c) LISYC EA3883, Universite de Bretagne occidentale. Brest.'

! !

!ExChdAdaInterfaceDeclarationFunction class methodsFor: 'platypus-generated-meta-data-accessing' stamp: ''!
schemaDefinition
	^ ExChdAdaInterfaceSchemaDefinition singleton

! !

!ExChdAdaInterfaceDeclarationFunction class methodsFor: 'platypus-generated-platypus-signature' stamp: ''!
translatedFromISO10303P11
	^ true

! !

!ExChdAdaInterfaceDeclarationFunction class methodsFor: 'platypus-generated-platypus-signature' stamp: ''!
vwNamespaceName
	^ #Express2Cheddar

! !

!ExChdAdaInterfaceDeclarationFunction methodsFor: 'platypus-generated-accessing' stamp: ''!
fromValues: values
	self int: (values at: 1)

! !

!ExChdAdaInterfaceDeclarationFunction methodsFor: 'platypus-generated-accessing' stamp: ''!
int
	^ int

! !

!ExChdAdaInterfaceDeclarationFunction methodsFor: 'platypus-generated-accessing' stamp: ''!
int: aExChdAdaInterface
	int := aExChdAdaInterface

! !

!ExChdAdaInterfaceDeclarationFunction methodsFor: 'platypus-generated-invoking' stamp: ''!
invoke
	" ---------- locals assignments ----------"

	self s: ''.
	self
		name:
			(ExChdAdaInterfacePathFunction
				invokeFromValues:
					(OrderedCollection new
						add: self int;
						yourself)).	" ---------- statements ----------"
	(self int withItUsingContext: self class context)
		ifTrue: [ self s: (((self s pltPlus: 'with ') pltPlus: self name) pltPlus: ';\n') ].
	(self int useItUsingContext: self class context)
		ifTrue: [ self s: (((self s pltPlus: 'use ') pltPlus: self name) pltPlus: ';\n') ].
	^ self return: self s

! !

!ExChdAdaInterfaceDeclarationFunction methodsFor: 'platypus-generated-accessing' stamp: ''!
name
	^ name

! !

!ExChdAdaInterfaceDeclarationFunction methodsFor: 'platypus-generated-accessing' stamp: ''!
name: aString1
	name := aString1

! !

!ExChdAdaInterfaceDeclarationFunction methodsFor: 'platypus-generated-accessing' stamp: ''!
s
	^ s

! !

!ExChdAdaInterfaceDeclarationFunction methodsFor: 'platypus-generated-accessing' stamp: ''!
s: aString
	s := aString

! !

PlatypusCoreAlgorithmDeclaration subclass: #ExChdAdaInterfacePathFunction
	instanceVariableNames: 'i name'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Express2Cheddar-AdaInterfaceSchema'!

!ExChdAdaInterfacePathFunction commentStamp: 'platypus comment' prior: 0!
<ISO10303-11-EXPRESS>
FUNCTION ada_interface_path ( i : ada_interface ) : STRING;
	LOCAL 
		name : STRING := i.prefix;
	END_LOCAL;

	IF EXISTS ( i.suffix ) THEN
		name := name + '.' + i.suffix;
	END_IF;
	RETURN ( name );
END_FUNCTION;
</ISO10303-11-EXPRESS>!

!ExChdAdaInterfacePathFunction class methodsFor: 'platypus-generated-platypus-signature' stamp: ''!
iso10303P11Translater
	^ 'Platypus (c) LISYC EA3883, Universite de Bretagne occidentale. Brest.'

! !

!ExChdAdaInterfacePathFunction class methodsFor: 'platypus-generated-meta-data-accessing' stamp: ''!
schemaDefinition
	^ ExChdAdaInterfaceSchemaDefinition singleton

! !

!ExChdAdaInterfacePathFunction class methodsFor: 'platypus-generated-platypus-signature' stamp: ''!
translatedFromISO10303P11
	^ true

! !

!ExChdAdaInterfacePathFunction class methodsFor: 'platypus-generated-platypus-signature' stamp: ''!
vwNamespaceName
	^ #Express2Cheddar

! !

!ExChdAdaInterfacePathFunction methodsFor: 'platypus-generated-accessing' stamp: ''!
fromValues: values
	self i: (values at: 1)

! !

!ExChdAdaInterfacePathFunction methodsFor: 'platypus-generated-accessing' stamp: ''!
i
	^ i

! !

!ExChdAdaInterfacePathFunction methodsFor: 'platypus-generated-accessing' stamp: ''!
i: aExChdAdaInterface
	i := aExChdAdaInterface

! !

!ExChdAdaInterfacePathFunction methodsFor: 'platypus-generated-invoking' stamp: ''!
invoke
	" ---------- locals assignments ----------"

	self name: (self i prefixUsingContext: self class context).	" ---------- statements ----------"
	(PltEXISTSFunction
		invokeFromValues:
			(OrderedCollection new
				add: (self i suffixUsingContext: self class context);
				yourself))
		ifTrue: [ self name: ((self name pltPlus: '.') pltPlus: (self i suffixUsingContext: self class context)) ].
	^ self return: self name

! !

!ExChdAdaInterfacePathFunction methodsFor: 'platypus-generated-accessing' stamp: ''!
name
	^ name

! !

!ExChdAdaInterfacePathFunction methodsFor: 'platypus-generated-accessing' stamp: ''!
name: aString
	name := aString

! !

PlatypusCoreAlgorithmDeclaration subclass: #ExChdAdaInterfacesCodeFunction
	instanceVariableNames: 'fromPkg l found withSuffix withPrefixOnly cleaned inserted s'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Express2Cheddar-AdaInterfaceSchema'!

!ExChdAdaInterfacesCodeFunction commentStamp: 'platypus comment' prior: 0!
<ISO10303-11-EXPRESS>
FUNCTION ada_interfaces_code ( from_pkg : ada_package; l : LIST OF ada_interface ) : STRING;
	LOCAL 
		found : SET OF STRING := [ ];
		with_suffix : LIST OF ada_interface := [ ];
		with_prefix_only : LIST OF ada_interface := [ ];
		cleaned : LIST OF ada_interface := [ ];
		inserted : BOOLEAN;
		s : STRING := '';
	END_LOCAL;

	REPEAT no := LOINDEX ( l ) TO HIINDEX ( l );

		ALIAS curr FOR l [ no];
			IF NOT EXISTS ( from_pkg ) OR ( upperize ( from_pkg.name ) <> upperize ( curr.prefix ) ) THEN
				IF NOT ( upperize ( curr.full_name ) IN found ) THEN
					found := found + upperize ( curr.full_name );
					cleaned := cleaned + curr;
				END_IF;
			END_IF;
		END_ALIAS;
	END_REPEAT;

	REPEAT no := LOINDEX ( cleaned ) TO HIINDEX ( cleaned );

		ALIAS curr FOR cleaned [ no];
			IF EXISTS ( curr.suffix ) THEN
				with_suffix := with_suffix + curr;
			ELSE
				with_prefix_only := with_prefix_only + curr;
			END_IF;
		END_ALIAS;
	END_REPEAT;
	cleaned := [ ];

	REPEAT no := LOINDEX ( with_prefix_only ) TO HIINDEX ( with_prefix_only );
		cleaned := cleaned + with_prefix_only [ no];
	END_REPEAT;

	REPEAT no := LOINDEX ( with_suffix ) TO HIINDEX ( with_suffix );

		ALIAS curr FOR with_suffix [ no];
			inserted := false;
			REPEAT noi := LOINDEX ( cleaned ) TO HIINDEX ( cleaned );
				ALIAS curri FOR cleaned [ noi];
					IF ( upperize ( curr.prefix ) = upperize ( curri.prefix ) ) THEN
						INSERT ( cleaned, curr, noi );
						inserted := true;
						ESCAPE;
					END_IF;
				END_ALIAS;
			END_REPEAT;
			IF ( inserted = false ) THEN
				cleaned := cleaned + curr;
			END_IF;
		END_ALIAS;
	END_REPEAT;

	REPEAT no := LOINDEX ( cleaned ) TO HIINDEX ( cleaned );

		ALIAS curr FOR cleaned [ no];
			s := s + curr.declaration + '\n';
		END_ALIAS;
	END_REPEAT;
	RETURN ( s );
END_FUNCTION;
</ISO10303-11-EXPRESS>!

!ExChdAdaInterfacesCodeFunction class methodsFor: 'platypus-generated-platypus-signature' stamp: ''!
iso10303P11Translater
	^ 'Platypus (c) LISYC EA3883, Universite de Bretagne occidentale. Brest.'

! !

!ExChdAdaInterfacesCodeFunction class methodsFor: 'platypus-generated-meta-data-accessing' stamp: ''!
schemaDefinition
	^ ExChdAdaInterfaceSchemaDefinition singleton

! !

!ExChdAdaInterfacesCodeFunction class methodsFor: 'platypus-generated-platypus-signature' stamp: ''!
translatedFromISO10303P11
	^ true

! !

!ExChdAdaInterfacesCodeFunction class methodsFor: 'platypus-generated-platypus-signature' stamp: ''!
vwNamespaceName
	^ #Express2Cheddar

! !

!ExChdAdaInterfacesCodeFunction methodsFor: 'platypus-generated-accessing' stamp: ''!
cleaned
	^ cleaned

! !

!ExChdAdaInterfacesCodeFunction methodsFor: 'platypus-generated-accessing' stamp: ''!
cleaned: aListOfExChdAdaInterface2
	cleaned := aListOfExChdAdaInterface2
		ifNil: [ OrderedCollection new ]
		ifNotNil: [ aListOfExChdAdaInterface2 as: OrderedCollection ]

! !

!ExChdAdaInterfacesCodeFunction methodsFor: 'platypus-generated-accessing' stamp: ''!
found
	^ found

! !

!ExChdAdaInterfacesCodeFunction methodsFor: 'platypus-generated-accessing' stamp: ''!
found: aSetOfString
	found := aSetOfString ifNil: [ Set new ] ifNotNil: [ aSetOfString as: Set ]

! !

!ExChdAdaInterfacesCodeFunction methodsFor: 'platypus-generated-accessing' stamp: ''!
fromPkg
	^ fromPkg

! !

!ExChdAdaInterfacesCodeFunction methodsFor: 'platypus-generated-accessing' stamp: ''!
fromPkg: aExChdAdaPackage
	fromPkg := aExChdAdaPackage

! !

!ExChdAdaInterfacesCodeFunction methodsFor: 'platypus-generated-accessing' stamp: ''!
fromPkg: aExChdAdaPackage l: aListOfExChdAdaInterface
	self fromPkg: aExChdAdaPackage.
	self l: aListOfExChdAdaInterface

! !

!ExChdAdaInterfacesCodeFunction methodsFor: 'platypus-generated-accessing' stamp: ''!
fromValues: values
	self fromPkg: (values at: 1).
	self l: (values at: 2)

! !

!ExChdAdaInterfacesCodeFunction methodsFor: 'platypus-generated-accessing' stamp: ''!
inserted
	^ inserted

! !

!ExChdAdaInterfacesCodeFunction methodsFor: 'platypus-generated-accessing' stamp: ''!
inserted: aBoolean
	inserted := aBoolean

! !

!ExChdAdaInterfacesCodeFunction methodsFor: 'platypus-generated-invoking' stamp: ''!
invoke
	" ---------- locals assignments ----------"

	self found: Array new.
	self withSuffix: Array new.
	self withPrefixOnly: Array new.
	self cleaned: Array new.
	self s: ''.	" ---------- statements ----------"
	PlatypusCoreRepeatStatement
		repeat: [ :no678 | 
			PlatypusCoreAliasStatement
				alias: (self l pltAt: no678)
				statementsBlock: [ :curr2428 | 
					((PltEXISTSFunction
						invokeFromValues:
							(OrderedCollection new
								add: self fromPkg;
								yourself)) not
						or: [ 
							(PTsUpperizeFunction
								invokeFromValues:
									(OrderedCollection new
										add: (self fromPkg nameUsingContext: self class context);
										yourself))
								~=
									(PTsUpperizeFunction
										invokeFromValues:
											(OrderedCollection new
												add: (curr2428 prefixUsingContext: self class context);
												yourself)) ])
						ifTrue: [ 
							(self found
								includes:
									(PTsUpperizeFunction
										invokeFromValues:
											(OrderedCollection new
												add: (curr2428 fullNameUsingContext: self class context);
												yourself))) not
								ifTrue: [ 
									self
										found:
											(self found
												pltPlus:
													(PTsUpperizeFunction
														invokeFromValues:
															(OrderedCollection new
																add: (curr2428 fullNameUsingContext: self class context);
																yourself))).
									self cleaned: (self cleaned pltPlus: curr2428) ] ] ] ]
		from:
			(PltLOINDEXFunction
				invokeFromValues:
					(OrderedCollection new
						add: self l;
						yourself))
		to:
			(PltHIINDEXFunction
				invokeFromValues:
					(OrderedCollection new
						add: self l;
						yourself)).
	PlatypusCoreRepeatStatement
		repeat: [ :no1622 | 
			PlatypusCoreAliasStatement
				alias: (self cleaned pltAt: no1622)
				statementsBlock: [ :curr3445 | 
					(PltEXISTSFunction
						invokeFromValues:
							(OrderedCollection new
								add: (curr3445 suffixUsingContext: self class context);
								yourself))
						ifTrue: [ self withSuffix: (self withSuffix pltPlus: curr3445) ]
						ifFalse: [ self withPrefixOnly: (self withPrefixOnly pltPlus: curr3445) ] ] ]
		from:
			(PltLOINDEXFunction
				invokeFromValues:
					(OrderedCollection new
						add: self cleaned;
						yourself))
		to:
			(PltHIINDEXFunction
				invokeFromValues:
					(OrderedCollection new
						add: self cleaned;
						yourself)).
	self cleaned: Array new.
	PlatypusCoreRepeatStatement
		repeat: [ :no3634 | self cleaned: (self cleaned pltPlus: (self withPrefixOnly pltAt: no3634)) ]
		from:
			(PltLOINDEXFunction
				invokeFromValues:
					(OrderedCollection new
						add: self withPrefixOnly;
						yourself))
		to:
			(PltHIINDEXFunction
				invokeFromValues:
					(OrderedCollection new
						add: self withPrefixOnly;
						yourself)).
	PlatypusCoreRepeatStatement
		repeat: [ :no1540 | 
			PlatypusCoreAliasStatement
				alias: (self withSuffix pltAt: no1540)
				statementsBlock: [ :curr3367 | 
					self inserted: false.
					PlatypusCoreRepeatStatement
						repeat: [ :noi487 | 
							PlatypusCoreAliasStatement
								alias: (self cleaned pltAt: noi487)
								statementsBlock: [ :curri2644 | 
									(PTsUpperizeFunction
										invokeFromValues:
											(OrderedCollection new
												add: (curr3367 prefixUsingContext: self class context);
												yourself))
										=
											(PTsUpperizeFunction
												invokeFromValues:
													(OrderedCollection new
														add: (curri2644 prefixUsingContext: self class context);
														yourself))
										ifTrue: [ 
											PltINSERTProcedure
												invokeFromValues:
													(OrderedCollection new
														add: self cleaned;
														add: curr3367;
														add: noi487;
														yourself).
											self inserted: true.
											PlatypusExpressEscapeStatementException signal ] ] ]
						from:
							(PltLOINDEXFunction
								invokeFromValues:
									(OrderedCollection new
										add: self cleaned;
										yourself))
						to:
							(PltHIINDEXFunction
								invokeFromValues:
									(OrderedCollection new
										add: self cleaned;
										yourself)).
					self inserted = false
						ifTrue: [ self cleaned: (self cleaned pltPlus: curr3367) ] ] ]
		from:
			(PltLOINDEXFunction
				invokeFromValues:
					(OrderedCollection new
						add: self withSuffix;
						yourself))
		to:
			(PltHIINDEXFunction
				invokeFromValues:
					(OrderedCollection new
						add: self withSuffix;
						yourself)).
	PlatypusCoreRepeatStatement
		repeat: [ :no1693 | 
			PlatypusCoreAliasStatement
				alias: (self cleaned pltAt: no1693)
				statementsBlock: [ :curr3516 | self s: ((self s pltPlus: (curr3516 declarationUsingContext: self class context)) pltPlus: '\n') ] ]
		from:
			(PltLOINDEXFunction
				invokeFromValues:
					(OrderedCollection new
						add: self cleaned;
						yourself))
		to:
			(PltHIINDEXFunction
				invokeFromValues:
					(OrderedCollection new
						add: self cleaned;
						yourself)).
	^ self return: self s

! !

!ExChdAdaInterfacesCodeFunction methodsFor: 'platypus-generated-accessing' stamp: ''!
l
	^ l

! !

!ExChdAdaInterfacesCodeFunction methodsFor: 'platypus-generated-accessing' stamp: ''!
l: aListOfExChdAdaInterface
	l := aListOfExChdAdaInterface
		ifNil: [ OrderedCollection new ]
		ifNotNil: [ aListOfExChdAdaInterface as: OrderedCollection ]

! !

!ExChdAdaInterfacesCodeFunction methodsFor: 'platypus-generated-accessing' stamp: ''!
s
	^ s

! !

!ExChdAdaInterfacesCodeFunction methodsFor: 'platypus-generated-accessing' stamp: ''!
s: aString
	s := aString

! !

!ExChdAdaInterfacesCodeFunction methodsFor: 'platypus-generated-accessing' stamp: ''!
withPrefixOnly
	^ withPrefixOnly

! !

!ExChdAdaInterfacesCodeFunction methodsFor: 'platypus-generated-accessing' stamp: ''!
withPrefixOnly: aListOfExChdAdaInterface1
	withPrefixOnly := aListOfExChdAdaInterface1
		ifNil: [ OrderedCollection new ]
		ifNotNil: [ aListOfExChdAdaInterface1 as: OrderedCollection ]

! !

!ExChdAdaInterfacesCodeFunction methodsFor: 'platypus-generated-accessing' stamp: ''!
withSuffix
	^ withSuffix

! !

!ExChdAdaInterfacesCodeFunction methodsFor: 'platypus-generated-accessing' stamp: ''!
withSuffix: aListOfExChdAdaInterface
	withSuffix := aListOfExChdAdaInterface
		ifNil: [ OrderedCollection new ]
		ifNotNil: [ aListOfExChdAdaInterface as: OrderedCollection ]

! !

PlatypusCoreAlgorithmDeclaration subclass: #ExChdAdaPackageAdbCodeFunction
	instanceVariableNames: 'pkg result'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Express2Cheddar-PackageSchema'!

!ExChdAdaPackageAdbCodeFunction commentStamp: 'platypus comment' prior: 0!
<ISO10303-11-EXPRESS>
FUNCTION ada_package_adb_code ( pkg : ada_package ) : STRING;
	LOCAL 
		result : STRING;
	END_LOCAL;
	result := ada_package_concepts_list_code ( pkg, pkg.types, false ) + ada_package_concepts_list_code ( pkg, pkg.entities, false );
	RETURN ( result );
END_FUNCTION;
</ISO10303-11-EXPRESS>!

!ExChdAdaPackageAdbCodeFunction class methodsFor: 'platypus-generated-platypus-signature' stamp: ''!
iso10303P11Translater
	^ 'Platypus (c) LISYC EA3883, Universite de Bretagne occidentale. Brest.'

! !

!ExChdAdaPackageAdbCodeFunction class methodsFor: 'platypus-generated-meta-data-accessing' stamp: ''!
schemaDefinition
	^ ExChdPackageSchemaDefinition singleton

! !

!ExChdAdaPackageAdbCodeFunction class methodsFor: 'platypus-generated-platypus-signature' stamp: ''!
translatedFromISO10303P11
	^ true

! !

!ExChdAdaPackageAdbCodeFunction class methodsFor: 'platypus-generated-platypus-signature' stamp: ''!
vwNamespaceName
	^ #Express2Cheddar

! !

!ExChdAdaPackageAdbCodeFunction methodsFor: 'platypus-generated-accessing' stamp: ''!
fromValues: values
	self pkg: (values at: 1)

! !

!ExChdAdaPackageAdbCodeFunction methodsFor: 'platypus-generated-invoking' stamp: ''!
invoke
	" ---------- locals assignments ----------"

	" ---------- statements ----------"

	self
		result:
			((ExChdAdaPackageConceptsListCodeFunction
				invokeFromValues:
					(OrderedCollection new
						add: self pkg;
						add: (self pkg typesUsingContext: self class context);
						add: false;
						yourself))
				pltPlus:
					(ExChdAdaPackageConceptsListCodeFunction
						invokeFromValues:
							(OrderedCollection new
								add: self pkg;
								add: (self pkg entitiesUsingContext: self class context);
								add: false;
								yourself))).
	^ self return: self result

! !

!ExChdAdaPackageAdbCodeFunction methodsFor: 'platypus-generated-accessing' stamp: ''!
pkg
	^ pkg

! !

!ExChdAdaPackageAdbCodeFunction methodsFor: 'platypus-generated-accessing' stamp: ''!
pkg: aExChdAdaPackage
	pkg := aExChdAdaPackage

! !

!ExChdAdaPackageAdbCodeFunction methodsFor: 'platypus-generated-accessing' stamp: ''!
result
	^ result

! !

!ExChdAdaPackageAdbCodeFunction methodsFor: 'platypus-generated-accessing' stamp: ''!
result: aString
	result := aString

! !

PlatypusCoreAlgorithmDeclaration subclass: #ExChdAdaPackageAdsCodeFunction
	instanceVariableNames: 'pkg result classes constList privateClasses constrainedArrays'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Express2Cheddar-PackageSchema'!

!ExChdAdaPackageAdsCodeFunction commentStamp: 'platypus comment' prior: 0!
<ISO10303-11-EXPRESS>
FUNCTION ada_package_ads_code ( pkg : ada_package ) : STRING;
	LOCAL 
		result : STRING;
		classes : LIST OF ada_class := QUERY ( e <* pkg.entities | 'RECORD_AND_CLASS.ADA_CLASS' IN TYPEOF ( e ) );
		const_list : LIST OF ada_constant := QUERY ( e <* pkg.constants | 'CHEDDAR_CONSTANTS.ADA_CONSTANT' IN TYPEOF ( e ) );
		private_classes : LIST OF ada_class := QUERY ( e <* classes | e.is_private );
		constrained_arrays : LIST OF defined_type;
	END_LOCAL;
	constrained_arrays := QUERY ( t <* pkg.types | 'CHEDDAR_DOMAINS.CONSTRAINED_ARRAY_TYPE' IN TYPEOF ( t ) );
	result := ada_package_concepts_list_code ( pkg, ( ( pkg.types - constrained_arrays ) + pkg.entities ) + constrained_arrays, true );

	REPEAT no := LOINDEX ( const_list ) TO HIINDEX ( const_list );
		result := result + const_list [ no].ads_code + '\n';
	END_REPEAT;

	IF SIZEOF ( private_classes ) > 0 THEN
		result := result + '\n\nprivate\n \n';

		REPEAT no := LOINDEX ( private_classes ) TO HIINDEX ( private_classes );
			ALIAS supref FOR private_classes [ no].supertypes [ 1 ].ref;
				result := result + '\ntype ' + private_classes [ no].name + ' is new ' + supref.ada_ident + ' with\n' 
				+ ada_class_attributes_ads_code ( private_classes [ no] );
			END_ALIAS;
		END_REPEAT;
	END_IF;
	RETURN ( result );
END_FUNCTION;
</ISO10303-11-EXPRESS>!

!ExChdAdaPackageAdsCodeFunction class methodsFor: 'platypus-generated-platypus-signature' stamp: ''!
iso10303P11Translater
	^ 'Platypus (c) LISYC EA3883, Universite de Bretagne occidentale. Brest.'

! !

!ExChdAdaPackageAdsCodeFunction class methodsFor: 'platypus-generated-meta-data-accessing' stamp: ''!
schemaDefinition
	^ ExChdPackageSchemaDefinition singleton

! !

!ExChdAdaPackageAdsCodeFunction class methodsFor: 'platypus-generated-platypus-signature' stamp: ''!
translatedFromISO10303P11
	^ true

! !

!ExChdAdaPackageAdsCodeFunction class methodsFor: 'platypus-generated-platypus-signature' stamp: ''!
vwNamespaceName
	^ #Express2Cheddar

! !

!ExChdAdaPackageAdsCodeFunction methodsFor: 'platypus-generated-accessing' stamp: ''!
classes
	^ classes

! !

!ExChdAdaPackageAdsCodeFunction methodsFor: 'platypus-generated-accessing' stamp: ''!
classes: aListOfExChdAdaClass
	classes := aListOfExChdAdaClass
		ifNil: [ OrderedCollection new ]
		ifNotNil: [ aListOfExChdAdaClass as: OrderedCollection ]

! !

!ExChdAdaPackageAdsCodeFunction methodsFor: 'platypus-generated-accessing' stamp: ''!
constList
	^ constList

! !

!ExChdAdaPackageAdsCodeFunction methodsFor: 'platypus-generated-accessing' stamp: ''!
constList: aListOfExChdAdaConstant
	constList := aListOfExChdAdaConstant
		ifNil: [ OrderedCollection new ]
		ifNotNil: [ aListOfExChdAdaConstant as: OrderedCollection ]

! !

!ExChdAdaPackageAdsCodeFunction methodsFor: 'platypus-generated-accessing' stamp: ''!
constrainedArrays
	^ constrainedArrays

! !

!ExChdAdaPackageAdsCodeFunction methodsFor: 'platypus-generated-accessing' stamp: ''!
constrainedArrays: aListOfExChdDefinedType
	constrainedArrays := aListOfExChdDefinedType
		ifNil: [ OrderedCollection new ]
		ifNotNil: [ aListOfExChdDefinedType as: OrderedCollection ]

! !

!ExChdAdaPackageAdsCodeFunction methodsFor: 'platypus-generated-accessing' stamp: ''!
fromValues: values
	self pkg: (values at: 1)

! !

!ExChdAdaPackageAdsCodeFunction methodsFor: 'platypus-generated-invoking' stamp: ''!
invoke
	" ---------- locals assignments ----------"

	self
		classes:
			((self pkg entitiesUsingContext: self class context)
				select: [ :e3002 | 
					(PltTYPEOFFunction
						invokeFromValues:
							(OrderedCollection new
								add: e3002;
								yourself)) includes: 'RECORD_AND_CLASS.ADA_CLASS' ]).
	self
		constList:
			((self pkg constantsUsingContext: self class context)
				select: [ :e668 | 
					(PltTYPEOFFunction
						invokeFromValues:
							(OrderedCollection new
								add: e668;
								yourself)) includes: 'CHEDDAR_CONSTANTS.ADA_CONSTANT' ]).
	self privateClasses: (self classes select: [ :e3773 | e3773 isPrivateUsingContext: self class context ]).	" ---------- statements ----------"
	self
		constrainedArrays:
			((self pkg typesUsingContext: self class context)
				select: [ :t3360 | 
					(PltTYPEOFFunction
						invokeFromValues:
							(OrderedCollection new
								add: t3360;
								yourself)) includes: 'CHEDDAR_DOMAINS.CONSTRAINED_ARRAY_TYPE' ]).
	self
		result:
			(ExChdAdaPackageConceptsListCodeFunction
				invokeFromValues:
					(OrderedCollection new
						add: self pkg;
						add:
								((((self pkg typesUsingContext: self class context) pltMinus: self constrainedArrays)
										pltPlus: (self pkg entitiesUsingContext: self class context)) pltPlus: self constrainedArrays);
						add: true;
						yourself)).
	PlatypusCoreRepeatStatement
		repeat: [ :no402 | 
			self
				result:
					((self result pltPlus: ((self constList pltAt: no402) adsCodeUsingContext: self class context)) pltPlus: '\n') ]
		from:
			(PltLOINDEXFunction
				invokeFromValues:
					(OrderedCollection new
						add: self constList;
						yourself))
		to:
			(PltHIINDEXFunction
				invokeFromValues:
					(OrderedCollection new
						add: self constList;
						yourself)).
	(PltSIZEOFFunction
		invokeFromValues:
			(OrderedCollection new
				add: self privateClasses;
				yourself)) > 0
		ifTrue: [ 
			self result: (self result pltPlus: '\n\nprivate\n \n').
			PlatypusCoreRepeatStatement
				repeat: [ :no2528 | 
					PlatypusCoreAliasStatement
						alias:
							((((self privateClasses pltAt: no2528) supertypesUsingContext: self class context) pltAt: 1)
								refUsingContext: self class context)
						statementsBlock: [ :supref3520 | 
							self
								result:
									((((((self result pltPlus: '\ntype ')
										pltPlus: ((self privateClasses pltAt: no2528) nameUsingContext: self class context)) pltPlus: ' is new ')
										pltPlus: (supref3520 adaIdentUsingContext: self class context)) pltPlus: ' with\n')
										pltPlus:
											(ExChdAdaClassAttributesAdsCodeFunction
												invokeFromValues:
													(OrderedCollection new
														add: (self privateClasses pltAt: no2528);
														yourself))) ] ]
				from:
					(PltLOINDEXFunction
						invokeFromValues:
							(OrderedCollection new
								add: self privateClasses;
								yourself))
				to:
					(PltHIINDEXFunction
						invokeFromValues:
							(OrderedCollection new
								add: self privateClasses;
								yourself)) ].
	^ self return: self result

! !

!ExChdAdaPackageAdsCodeFunction methodsFor: 'platypus-generated-accessing' stamp: ''!
pkg
	^ pkg

! !

!ExChdAdaPackageAdsCodeFunction methodsFor: 'platypus-generated-accessing' stamp: ''!
pkg: aExChdAdaPackage
	pkg := aExChdAdaPackage

! !

!ExChdAdaPackageAdsCodeFunction methodsFor: 'platypus-generated-accessing' stamp: ''!
privateClasses
	^ privateClasses

! !

!ExChdAdaPackageAdsCodeFunction methodsFor: 'platypus-generated-accessing' stamp: ''!
privateClasses: aListOfExChdAdaClass1
	privateClasses := aListOfExChdAdaClass1
		ifNil: [ OrderedCollection new ]
		ifNotNil: [ aListOfExChdAdaClass1 as: OrderedCollection ]

! !

!ExChdAdaPackageAdsCodeFunction methodsFor: 'platypus-generated-accessing' stamp: ''!
result
	^ result

! !

!ExChdAdaPackageAdsCodeFunction methodsFor: 'platypus-generated-accessing' stamp: ''!
result: aString
	result := aString

! !

PlatypusCoreAlgorithmDeclaration subclass: #ExChdAdaPackageClassTypeofListFunction
	instanceVariableNames: 'pkg result classes'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Express2Cheddar-PackageSchema'!

!ExChdAdaPackageClassTypeofListFunction commentStamp: 'platypus comment' prior: 0!
<ISO10303-11-EXPRESS>
FUNCTION ada_package_class_typeof_list ( pkg : ada_package ) : STRING;
	LOCAL 
		result : STRING := '';
		classes : LIST OF ada_class := QUERY ( e <* pkg.entities | 'RECORD_AND_CLASS.ADA_CLASS' IN TYPEOF ( e ) );
	END_LOCAL;

	REPEAT no := LOINDEX ( classes ) TO HIINDEX ( classes );

		ALIAS curr FOR classes [ no];
			result := result + curr.name + '(';
			result := result + StringAggregateConcatSeparatedBy ( TYPEOF ( curr ), ',' );
			result := result + ')\n';
		END_ALIAS;
	END_REPEAT;
	RETURN ( result );
END_FUNCTION;
</ISO10303-11-EXPRESS>!

!ExChdAdaPackageClassTypeofListFunction class methodsFor: 'platypus-generated-platypus-signature' stamp: ''!
iso10303P11Translater
	^ 'Platypus (c) LISYC EA3883, Universite de Bretagne occidentale. Brest.'

! !

!ExChdAdaPackageClassTypeofListFunction class methodsFor: 'platypus-generated-meta-data-accessing' stamp: ''!
schemaDefinition
	^ ExChdPackageSchemaDefinition singleton

! !

!ExChdAdaPackageClassTypeofListFunction class methodsFor: 'platypus-generated-platypus-signature' stamp: ''!
translatedFromISO10303P11
	^ true

! !

!ExChdAdaPackageClassTypeofListFunction class methodsFor: 'platypus-generated-platypus-signature' stamp: ''!
vwNamespaceName
	^ #Express2Cheddar

! !

!ExChdAdaPackageClassTypeofListFunction methodsFor: 'platypus-generated-accessing' stamp: ''!
classes
	^ classes

! !

!ExChdAdaPackageClassTypeofListFunction methodsFor: 'platypus-generated-accessing' stamp: ''!
classes: aListOfExChdAdaClass
	classes := aListOfExChdAdaClass
		ifNil: [ OrderedCollection new ]
		ifNotNil: [ aListOfExChdAdaClass as: OrderedCollection ]

! !

!ExChdAdaPackageClassTypeofListFunction methodsFor: 'platypus-generated-accessing' stamp: ''!
fromValues: values
	self pkg: (values at: 1)

! !

!ExChdAdaPackageClassTypeofListFunction methodsFor: 'platypus-generated-invoking' stamp: ''!
invoke
	" ---------- locals assignments ----------"

	self result: ''.
	self
		classes:
			((self pkg entitiesUsingContext: self class context)
				select: [ :e2744 | 
					(PltTYPEOFFunction
						invokeFromValues:
							(OrderedCollection new
								add: e2744;
								yourself)) includes: 'RECORD_AND_CLASS.ADA_CLASS' ]).	" ---------- statements ----------"
	PlatypusCoreRepeatStatement
		repeat: [ :no1703 | 
			PlatypusCoreAliasStatement
				alias: (self classes pltAt: no1703)
				statementsBlock: [ :curr3526 | 
					self result: ((self result pltPlus: (curr3526 nameUsingContext: self class context)) pltPlus: '(').
					self
						result:
							(self result
								pltPlus:
									(PTsStringAggregateConcatSeparatedByFunction
										invokeFromValues:
											(OrderedCollection new
												add:
														(PltTYPEOFFunction
																invokeFromValues:
																	(OrderedCollection new
																		add: curr3526;
																		yourself));
												add: ',';
												yourself))).
					self result: (self result pltPlus: ')\n') ] ]
		from:
			(PltLOINDEXFunction
				invokeFromValues:
					(OrderedCollection new
						add: self classes;
						yourself))
		to:
			(PltHIINDEXFunction
				invokeFromValues:
					(OrderedCollection new
						add: self classes;
						yourself)).
	^ self return: self result

! !

!ExChdAdaPackageClassTypeofListFunction methodsFor: 'platypus-generated-accessing' stamp: ''!
pkg
	^ pkg

! !

!ExChdAdaPackageClassTypeofListFunction methodsFor: 'platypus-generated-accessing' stamp: ''!
pkg: aExChdAdaPackage
	pkg := aExChdAdaPackage

! !

!ExChdAdaPackageClassTypeofListFunction methodsFor: 'platypus-generated-accessing' stamp: ''!
result
	^ result

! !

!ExChdAdaPackageClassTypeofListFunction methodsFor: 'platypus-generated-accessing' stamp: ''!
result: aString
	result := aString

! !

PlatypusCoreAlgorithmDeclaration subclass: #ExChdAdaPackageConceptsListCodeFunction
	instanceVariableNames: 'p concepts ads result code contents'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Express2Cheddar-PackageSchema'!

!ExChdAdaPackageConceptsListCodeFunction commentStamp: 'platypus comment' prior: 0!
<ISO10303-11-EXPRESS>
FUNCTION ada_package_concepts_list_code ( p : ada_package; concepts : LIST OF dictionary_instance; ads : BOOLEAN ) : STRING;
	LOCAL 
		result : STRING := '';
		code : STRING := '';
		contents : LIST OF dictionary_instance := [ ];
	END_LOCAL;

	IF ads THEN
		contents := concepts;
	ELSE
		contents := concepts;
	END_IF;

	REPEAT no := LOINDEX ( contents ) TO HIINDEX ( contents );

		ALIAS c FOR contents [ no];
			IF is_of_generated_concept_kind ( c ) THEN
				IF ads THEN
					code := c.ads_code;
				ELSE
					code := c.adb_code;
				END_IF;
				result := result + code;
				IF ( code > '' ) THEN
					result := result + '\n';
				END_IF;
			END_IF;
		END_ALIAS;
	END_REPEAT;
	RETURN ( result );
END_FUNCTION;
</ISO10303-11-EXPRESS>!

!ExChdAdaPackageConceptsListCodeFunction class methodsFor: 'platypus-generated-platypus-signature' stamp: ''!
iso10303P11Translater
	^ 'Platypus (c) LISYC EA3883, Universite de Bretagne occidentale. Brest.'

! !

!ExChdAdaPackageConceptsListCodeFunction class methodsFor: 'platypus-generated-meta-data-accessing' stamp: ''!
schemaDefinition
	^ ExChdPackageSchemaDefinition singleton

! !

!ExChdAdaPackageConceptsListCodeFunction class methodsFor: 'platypus-generated-platypus-signature' stamp: ''!
translatedFromISO10303P11
	^ true

! !

!ExChdAdaPackageConceptsListCodeFunction class methodsFor: 'platypus-generated-platypus-signature' stamp: ''!
vwNamespaceName
	^ #Express2Cheddar

! !

!ExChdAdaPackageConceptsListCodeFunction methodsFor: 'platypus-generated-accessing' stamp: ''!
ads
	^ ads

! !

!ExChdAdaPackageConceptsListCodeFunction methodsFor: 'platypus-generated-accessing' stamp: ''!
ads: aBoolean
	ads := aBoolean

! !

!ExChdAdaPackageConceptsListCodeFunction methodsFor: 'platypus-generated-accessing' stamp: ''!
code
	^ code

! !

!ExChdAdaPackageConceptsListCodeFunction methodsFor: 'platypus-generated-accessing' stamp: ''!
code: aString1
	code := aString1

! !

!ExChdAdaPackageConceptsListCodeFunction methodsFor: 'platypus-generated-accessing' stamp: ''!
concepts
	^ concepts

! !

!ExChdAdaPackageConceptsListCodeFunction methodsFor: 'platypus-generated-accessing' stamp: ''!
concepts: aListOfExChdDictionaryInstance
	concepts := aListOfExChdDictionaryInstance
		ifNil: [ OrderedCollection new ]
		ifNotNil: [ aListOfExChdDictionaryInstance as: OrderedCollection ]

! !

!ExChdAdaPackageConceptsListCodeFunction methodsFor: 'platypus-generated-accessing' stamp: ''!
contents
	^ contents

! !

!ExChdAdaPackageConceptsListCodeFunction methodsFor: 'platypus-generated-accessing' stamp: ''!
contents: aListOfExChdDictionaryInstance
	contents := aListOfExChdDictionaryInstance
		ifNil: [ OrderedCollection new ]
		ifNotNil: [ aListOfExChdDictionaryInstance as: OrderedCollection ]

! !

!ExChdAdaPackageConceptsListCodeFunction methodsFor: 'platypus-generated-accessing' stamp: ''!
fromValues: values
	self p: (values at: 1).
	self concepts: (values at: 2).
	self ads: (values at: 3)

! !

!ExChdAdaPackageConceptsListCodeFunction methodsFor: 'platypus-generated-invoking' stamp: ''!
invoke
	" ---------- locals assignments ----------"

	self result: ''.
	self code: ''.
	self contents: Array new.	" ---------- statements ----------"
	self ads
		ifTrue: [ self contents: self concepts ]
		ifFalse: [ self contents: self concepts ].
	PlatypusCoreRepeatStatement
		repeat: [ :no166 | 
			PlatypusCoreAliasStatement
				alias: (self contents pltAt: no166)
				statementsBlock: [ :c1920 | 
					(ExChdIsOfGeneratedConceptKindFunction
						invokeFromValues:
							(OrderedCollection new
								add: c1920;
								yourself))
						ifTrue: [ 
							self ads
								ifTrue: [ self code: (c1920 adsCodeUsingContext: self class context) ]
								ifFalse: [ self code: (c1920 adbCodeUsingContext: self class context) ].
							self result: (self result pltPlus: self code).
							self code > ''
								ifTrue: [ self result: (self result pltPlus: '\n') ] ] ] ]
		from:
			(PltLOINDEXFunction
				invokeFromValues:
					(OrderedCollection new
						add: self contents;
						yourself))
		to:
			(PltHIINDEXFunction
				invokeFromValues:
					(OrderedCollection new
						add: self contents;
						yourself)).
	^ self return: self result

! !

!ExChdAdaPackageConceptsListCodeFunction methodsFor: 'platypus-generated-accessing' stamp: ''!
p
	^ p

! !

!ExChdAdaPackageConceptsListCodeFunction methodsFor: 'platypus-generated-accessing' stamp: ''!
p: aExChdAdaPackage
	p := aExChdAdaPackage

! !

!ExChdAdaPackageConceptsListCodeFunction methodsFor: 'platypus-generated-accessing' stamp: ''!
p: aExChdAdaPackage concepts: aListOfExChdDictionaryInstance ads: aBoolean
	self p: aExChdAdaPackage.
	self concepts: aListOfExChdDictionaryInstance.
	self ads: aBoolean

! !

!ExChdAdaPackageConceptsListCodeFunction methodsFor: 'platypus-generated-accessing' stamp: ''!
result
	^ result

! !

!ExChdAdaPackageConceptsListCodeFunction methodsFor: 'platypus-generated-accessing' stamp: ''!
result: aString
	result := aString

! !

PlatypusCoreAlgorithmDeclaration subclass: #ExChdAdaPackageInterfaceFunction
	instanceVariableNames: 'pkg ads adsList adbList wul result defs pkgKey'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Express2Cheddar-PackageSchema'!

!ExChdAdaPackageInterfaceFunction commentStamp: 'platypus comment' prior: 0!
<ISO10303-11-EXPRESS>
FUNCTION ada_package_interface ( pkg : ada_package; ads : BOOLEAN ) : LIST OF ada_interface;
	LOCAL 
		ads_list : LIST OF ada_interface := [ ada_interface ( 'Ada.Strings.Unbounded', ?, true, true ), ada_interface ( 'Framework_Config', ?, true, true ), ada_interface ( 'id_generators', ?, true, true ) ];
		adb_list : LIST OF ada_interface := [ ada_interface ( 'Text_io', ?, true, true ), ada_interface ( 'unbounded_strings', ?, true, true ) ];
		wul : LIST OF ada_interface;
		result : LIST OF ada_interface := [ ];
		defs : LIST OF dictionary_instance := pkg.entities + pkg.types + pkg.constants;
		pkgKey : STRING := upperize ( pkg.name );
	END_LOCAL;

	REPEAT no := LOINDEX ( pkg.interface ) TO HIINDEX ( pkg.interface );

		ALIAS curr FOR pkg.interface [ no];
			IF ( 'PACKAGE.ADA_PACKAGE' IN TYPEOF ( curr.native_schema ) ) THEN
				ads_list := ads_list + ADA_INTERFACE ( curr.native_schema.name, ?, true, true );
			END_IF;
		END_ALIAS;
	END_REPEAT;

	REPEAT no := LOINDEX ( defs ) TO HIINDEX ( defs );

		ALIAS e FOR defs [ no];
			IF ( 'CHEDDAR_DOMAINS.CHEDDAR_DEFINED_TYPE' IN TYPEOF ( e ) ) THEN
				ads_list := ads_list + e.ads_interfaces_list;
				adb_list := adb_list + e.adb_interfaces_list;
			END_IF;
			IF ( 'CHEDDAR_DOMAINS.EXPLICIT_TYPE_REFERENCE' IN TYPEOF ( e ) ) THEN
				ads_list := ads_list + e.ads_interfaces_list;
				adb_list := adb_list + e.adb_interfaces_list;
			END_IF;
			IF ( 'CHEDDAR_CONSTANTS.ADA_CONSTANT' IN TYPEOF ( e ) ) THEN
				ads_list := ads_list + e.ads_interfaces_list;
				adb_list := adb_list + e.adb_interfaces_list;
			END_IF;
			IF ( 'RECORD_AND_CLASS.ADA_ENTITY' IN TYPEOF ( e ) ) THEN
				ads_list := ads_list + e.ads_interfaces_list;
				adb_list := adb_list + e.adb_interfaces_list;
			END_IF;
			IF ( 'CHEDDAR_DOMAINS.ADA_ENUMERATION' IN TYPEOF ( e ) ) THEN
				ads_list := ads_list + e.ads_interfaces_list;
				adb_list := adb_list + e.adb_interfaces_list;
			END_IF;
			IF ( 'CHEDDAR_DOMAINS.CONSTRAINED_ARRAY_TYPE' IN TYPEOF ( e ) ) THEN
				ads_list := ads_list + e.ads_interfaces_list;
				adb_list := adb_list + e.adb_interfaces_list;
			END_IF;
			IF ( 'PACKAGE.GENERIC_PACKAGE_INSTANCIATION' IN TYPEOF ( e ) ) THEN
				ads_list := ads_list + e.ads_interfaces_list;
				adb_list := adb_list + e.adb_interfaces_list;
			END_IF;
		END_ALIAS;
	END_REPEAT;

	IF ads THEN
		wul := ads_list + pkg.ads_interface;
	ELSE
		wul := adb_list + pkg.adb_interface;
	END_IF;

	REPEAT no := LOINDEX ( wul ) TO HIINDEX ( wul );

		ALIAS curr FOR wul [ no];
			IF ( upperize ( curr.prefix ) <> pkgKey ) THEN
				result := result + curr;
			END_IF;
		END_ALIAS;
	END_REPEAT;
	RETURN ( result );
END_FUNCTION;
</ISO10303-11-EXPRESS>!

!ExChdAdaPackageInterfaceFunction class methodsFor: 'platypus-generated-platypus-signature' stamp: ''!
iso10303P11Translater
	^ 'Platypus (c) LISYC EA3883, Universite de Bretagne occidentale. Brest.'

! !

!ExChdAdaPackageInterfaceFunction class methodsFor: 'platypus-generated-meta-data-accessing' stamp: ''!
schemaDefinition
	^ ExChdPackageSchemaDefinition singleton

! !

!ExChdAdaPackageInterfaceFunction class methodsFor: 'platypus-generated-platypus-signature' stamp: ''!
translatedFromISO10303P11
	^ true

! !

!ExChdAdaPackageInterfaceFunction class methodsFor: 'platypus-generated-platypus-signature' stamp: ''!
vwNamespaceName
	^ #Express2Cheddar

! !

!ExChdAdaPackageInterfaceFunction methodsFor: 'platypus-generated-accessing' stamp: ''!
adbList
	^ adbList

! !

!ExChdAdaPackageInterfaceFunction methodsFor: 'platypus-generated-accessing' stamp: ''!
adbList: aListOfExChdAdaInterface1
	adbList := aListOfExChdAdaInterface1
		ifNil: [ OrderedCollection new ]
		ifNotNil: [ aListOfExChdAdaInterface1 as: OrderedCollection ]

! !

!ExChdAdaPackageInterfaceFunction methodsFor: 'platypus-generated-accessing' stamp: ''!
ads
	^ ads

! !

!ExChdAdaPackageInterfaceFunction methodsFor: 'platypus-generated-accessing' stamp: ''!
ads: aBoolean
	ads := aBoolean

! !

!ExChdAdaPackageInterfaceFunction methodsFor: 'platypus-generated-accessing' stamp: ''!
adsList
	^ adsList

! !

!ExChdAdaPackageInterfaceFunction methodsFor: 'platypus-generated-accessing' stamp: ''!
adsList: aListOfExChdAdaInterface
	adsList := aListOfExChdAdaInterface
		ifNil: [ OrderedCollection new ]
		ifNotNil: [ aListOfExChdAdaInterface as: OrderedCollection ]

! !

!ExChdAdaPackageInterfaceFunction methodsFor: 'platypus-generated-accessing' stamp: ''!
defs
	^ defs

! !

!ExChdAdaPackageInterfaceFunction methodsFor: 'platypus-generated-accessing' stamp: ''!
defs: aListOfExChdDictionaryInstance
	defs := aListOfExChdDictionaryInstance
		ifNil: [ OrderedCollection new ]
		ifNotNil: [ aListOfExChdDictionaryInstance as: OrderedCollection ]

! !

!ExChdAdaPackageInterfaceFunction methodsFor: 'platypus-generated-accessing' stamp: ''!
fromValues: values
	self pkg: (values at: 1).
	self ads: (values at: 2)

! !

!ExChdAdaPackageInterfaceFunction methodsFor: 'platypus-generated-invoking' stamp: ''!
invoke
	" ---------- locals assignments ----------"

	self
		adsList:
			(PlatypusCoreAggregateInitializer
				collectionFrom:
					(OrderedCollection new
						add:
								(ExChdAdaInterface new
										adaInterfaceFromValues:
												(OrderedCollection new
														add: 'Ada.Strings.Unbounded';
														add: nil;
														add: true;
														add: true;
														yourself);
										yourself);
						add:
								(ExChdAdaInterface new
										adaInterfaceFromValues:
												(OrderedCollection new
														add: 'Framework_Config';
														add: nil;
														add: true;
														add: true;
														yourself);
										yourself);
						add:
								(ExChdAdaInterface new
										adaInterfaceFromValues:
												(OrderedCollection new
														add: 'id_generators';
														add: nil;
														add: true;
														add: true;
														yourself);
										yourself);
						yourself)).
	self
		adbList:
			(PlatypusCoreAggregateInitializer
				collectionFrom:
					(OrderedCollection new
						add:
								(ExChdAdaInterface new
										adaInterfaceFromValues:
												(OrderedCollection new
														add: 'Text_io';
														add: nil;
														add: true;
														add: true;
														yourself);
										yourself);
						add:
								(ExChdAdaInterface new
										adaInterfaceFromValues:
												(OrderedCollection new
														add: 'unbounded_strings';
														add: nil;
														add: true;
														add: true;
														yourself);
										yourself);
						yourself)).
	self result: Array new.
	self
		defs:
			(((self pkg entitiesUsingContext: self class context) pltPlus: (self pkg typesUsingContext: self class context))
				pltPlus: (self pkg constantsUsingContext: self class context)).
	self
		pkgKey:
			(PTsUpperizeFunction
				invokeFromValues:
					(OrderedCollection new
						add: (self pkg nameUsingContext: self class context);
						yourself)).	" ---------- statements ----------"
	PlatypusCoreRepeatStatement
		repeat: [ :no526 | 
			PlatypusCoreAliasStatement
				alias: ((self pkg interfaceUsingContext: self class context) pltAt: no526)
				statementsBlock: [ :curr3097 | 
					((PltTYPEOFFunction
						invokeFromValues:
							(OrderedCollection new
								add: (curr3097 nativeSchemaUsingContext: self class context);
								yourself)) includes: 'PACKAGE.ADA_PACKAGE')
						ifTrue: [ 
							self
								adsList:
									(self adsList
										pltPlus:
											(ExChdAdaInterface new
												adaInterfaceFromValues:
														(OrderedCollection new
																add: ((curr3097 nativeSchemaUsingContext: self class context) nameUsingContext: self class context);
																add: nil;
																add: true;
																add: true;
																yourself);
												yourself)) ] ] ]
		from:
			(PltLOINDEXFunction
				invokeFromValues:
					(OrderedCollection new
						add: (self pkg interfaceUsingContext: self class context);
						yourself))
		to:
			(PltHIINDEXFunction
				invokeFromValues:
					(OrderedCollection new
						add: (self pkg interfaceUsingContext: self class context);
						yourself)).
	PlatypusCoreRepeatStatement
		repeat: [ :no1935 | 
			PlatypusCoreAliasStatement
				alias: (self defs pltAt: no1935)
				statementsBlock: [ :e3685 | 
					((PltTYPEOFFunction
						invokeFromValues:
							(OrderedCollection new
								add: e3685;
								yourself)) includes: 'CHEDDAR_DOMAINS.CHEDDAR_DEFINED_TYPE')
						ifTrue: [ 
							self adsList: (self adsList pltPlus: (e3685 adsInterfacesListUsingContext: self class context)).
							self adbList: (self adbList pltPlus: (e3685 adbInterfacesListUsingContext: self class context)) ].
					((PltTYPEOFFunction
						invokeFromValues:
							(OrderedCollection new
								add: e3685;
								yourself)) includes: 'CHEDDAR_DOMAINS.EXPLICIT_TYPE_REFERENCE')
						ifTrue: [ 
							self adsList: (self adsList pltPlus: (e3685 adsInterfacesListUsingContext: self class context)).
							self adbList: (self adbList pltPlus: (e3685 adbInterfacesListUsingContext: self class context)) ].
					((PltTYPEOFFunction
						invokeFromValues:
							(OrderedCollection new
								add: e3685;
								yourself)) includes: 'CHEDDAR_CONSTANTS.ADA_CONSTANT')
						ifTrue: [ 
							self adsList: (self adsList pltPlus: (e3685 adsInterfacesListUsingContext: self class context)).
							self adbList: (self adbList pltPlus: (e3685 adbInterfacesListUsingContext: self class context)) ].
					((PltTYPEOFFunction
						invokeFromValues:
							(OrderedCollection new
								add: e3685;
								yourself)) includes: 'RECORD_AND_CLASS.ADA_ENTITY')
						ifTrue: [ 
							self adsList: (self adsList pltPlus: (e3685 adsInterfacesListUsingContext: self class context)).
							self adbList: (self adbList pltPlus: (e3685 adbInterfacesListUsingContext: self class context)) ].
					((PltTYPEOFFunction
						invokeFromValues:
							(OrderedCollection new
								add: e3685;
								yourself)) includes: 'CHEDDAR_DOMAINS.ADA_ENUMERATION')
						ifTrue: [ 
							self adsList: (self adsList pltPlus: (e3685 adsInterfacesListUsingContext: self class context)).
							self adbList: (self adbList pltPlus: (e3685 adbInterfacesListUsingContext: self class context)) ].
					((PltTYPEOFFunction
						invokeFromValues:
							(OrderedCollection new
								add: e3685;
								yourself)) includes: 'CHEDDAR_DOMAINS.CONSTRAINED_ARRAY_TYPE')
						ifTrue: [ 
							self adsList: (self adsList pltPlus: (e3685 adsInterfacesListUsingContext: self class context)).
							self adbList: (self adbList pltPlus: (e3685 adbInterfacesListUsingContext: self class context)) ].
					((PltTYPEOFFunction
						invokeFromValues:
							(OrderedCollection new
								add: e3685;
								yourself)) includes: 'PACKAGE.GENERIC_PACKAGE_INSTANCIATION')
						ifTrue: [ 
							self adsList: (self adsList pltPlus: (e3685 adsInterfacesListUsingContext: self class context)).
							self adbList: (self adbList pltPlus: (e3685 adbInterfacesListUsingContext: self class context)) ] ] ]
		from:
			(PltLOINDEXFunction
				invokeFromValues:
					(OrderedCollection new
						add: self defs;
						yourself))
		to:
			(PltHIINDEXFunction
				invokeFromValues:
					(OrderedCollection new
						add: self defs;
						yourself)).
	self ads
		ifTrue: [ self wul: (self adsList pltPlus: (self pkg adsInterfaceUsingContext: self class context)) ]
		ifFalse: [ self wul: (self adbList pltPlus: (self pkg adbInterfaceUsingContext: self class context)) ].
	PlatypusCoreRepeatStatement
		repeat: [ :no1022 | 
			PlatypusCoreAliasStatement
				alias: (self wul pltAt: no1022)
				statementsBlock: [ :curr2841 | 
					(PTsUpperizeFunction
						invokeFromValues:
							(OrderedCollection new
								add: (curr2841 prefixUsingContext: self class context);
								yourself)) ~= self pkgKey
						ifTrue: [ self result: (self result pltPlus: curr2841) ] ] ]
		from:
			(PltLOINDEXFunction
				invokeFromValues:
					(OrderedCollection new
						add: self wul;
						yourself))
		to:
			(PltHIINDEXFunction
				invokeFromValues:
					(OrderedCollection new
						add: self wul;
						yourself)).
	^ self return: self result

! !

!ExChdAdaPackageInterfaceFunction methodsFor: 'platypus-generated-accessing' stamp: ''!
pkg
	^ pkg

! !

!ExChdAdaPackageInterfaceFunction methodsFor: 'platypus-generated-accessing' stamp: ''!
pkg: aExChdAdaPackage
	pkg := aExChdAdaPackage

! !

!ExChdAdaPackageInterfaceFunction methodsFor: 'platypus-generated-accessing' stamp: ''!
pkg: aExChdAdaPackage ads: aBoolean
	self pkg: aExChdAdaPackage.
	self ads: aBoolean

! !

!ExChdAdaPackageInterfaceFunction methodsFor: 'platypus-generated-accessing' stamp: ''!
pkgKey
	^ pkgKey

! !

!ExChdAdaPackageInterfaceFunction methodsFor: 'platypus-generated-accessing' stamp: ''!
pkgKey: aString
	pkgKey := aString

! !

!ExChdAdaPackageInterfaceFunction methodsFor: 'platypus-generated-accessing' stamp: ''!
result
	^ result

! !

!ExChdAdaPackageInterfaceFunction methodsFor: 'platypus-generated-accessing' stamp: ''!
result: aListOfExChdAdaInterface3
	result := aListOfExChdAdaInterface3
		ifNil: [ OrderedCollection new ]
		ifNotNil: [ aListOfExChdAdaInterface3 as: OrderedCollection ]

! !

!ExChdAdaPackageInterfaceFunction methodsFor: 'platypus-generated-accessing' stamp: ''!
wul
	^ wul

! !

!ExChdAdaPackageInterfaceFunction methodsFor: 'platypus-generated-accessing' stamp: ''!
wul: aListOfExChdAdaInterface2
	wul := aListOfExChdAdaInterface2
		ifNil: [ OrderedCollection new ]
		ifNotNil: [ aListOfExChdAdaInterface2 as: OrderedCollection ]

! !

PlatypusCoreAlgorithmDeclaration subclass: #ExChdAdaPackageNamedFunction
	instanceVariableNames: 'name packages key'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Express2Cheddar-Express2cheddarFacadeSchema'!

!ExChdAdaPackageNamedFunction commentStamp: 'platypus comment' prior: 0!
<ISO10303-11-EXPRESS>
FUNCTION ada_package_named ( name : STRING ) : ada_package;
	LOCAL 
		packages : SET OF ada_package := all_ada_packages ( );
		key : STRING := Lowerize ( name );
	END_LOCAL;

	REPEAT no := LOINDEX ( packages ) TO HIINDEX ( packages );

		ALIAS curr FOR packages [ no];
			IF ( Lowerize ( curr.name ) = key ) THEN
				RETURN ( curr );
			END_IF;
		END_ALIAS;
	END_REPEAT;
	RETURN ( ? );
END_FUNCTION;
</ISO10303-11-EXPRESS>!

!ExChdAdaPackageNamedFunction class methodsFor: 'platypus-generated-platypus-signature' stamp: ''!
iso10303P11Translater
	^ 'Platypus (c) LISYC EA3883, Universite de Bretagne occidentale. Brest.'

! !

!ExChdAdaPackageNamedFunction class methodsFor: 'platypus-generated-meta-data-accessing' stamp: ''!
schemaDefinition
	^ ExChdExpress2cheddarFacadeSchemaDefinition singleton

! !

!ExChdAdaPackageNamedFunction class methodsFor: 'platypus-generated-platypus-signature' stamp: ''!
translatedFromISO10303P11
	^ true

! !

!ExChdAdaPackageNamedFunction class methodsFor: 'platypus-generated-platypus-signature' stamp: ''!
vwNamespaceName
	^ #Express2Cheddar

! !

!ExChdAdaPackageNamedFunction methodsFor: 'platypus-generated-accessing' stamp: ''!
fromValues: values
	self name: (values at: 1)

! !

!ExChdAdaPackageNamedFunction methodsFor: 'platypus-generated-invoking' stamp: ''!
invoke
	" ---------- locals assignments ----------"

	self packages: ExChdAllAdaPackagesFunction invoke.
	self
		key:
			(PTsLowerizeFunction
				invokeFromValues:
					(OrderedCollection new
						add: self name;
						yourself)).	" ---------- statements ----------"
	PlatypusCoreRepeatStatement
		repeat: [ :no831 | 
			PlatypusCoreAliasStatement
				alias: (self packages pltAt: no831)
				statementsBlock: [ :curr2606 | 
					(PTsLowerizeFunction
						invokeFromValues:
							(OrderedCollection new
								add: (curr2606 nameUsingContext: self class context);
								yourself)) = self key
						ifTrue: [ ^ self return: curr2606 ] ] ]
		from:
			(PltLOINDEXFunction
				invokeFromValues:
					(OrderedCollection new
						add: self packages;
						yourself))
		to:
			(PltHIINDEXFunction
				invokeFromValues:
					(OrderedCollection new
						add: self packages;
						yourself)).
	^ self return: nil

! !

!ExChdAdaPackageNamedFunction methodsFor: 'platypus-generated-accessing' stamp: ''!
key
	^ key

! !

!ExChdAdaPackageNamedFunction methodsFor: 'platypus-generated-accessing' stamp: ''!
key: aString
	key := aString

! !

!ExChdAdaPackageNamedFunction methodsFor: 'platypus-generated-accessing' stamp: ''!
name
	^ name

! !

!ExChdAdaPackageNamedFunction methodsFor: 'platypus-generated-accessing' stamp: ''!
name: aString
	name := aString

! !

!ExChdAdaPackageNamedFunction methodsFor: 'platypus-generated-accessing' stamp: ''!
packages
	^ packages

! !

!ExChdAdaPackageNamedFunction methodsFor: 'platypus-generated-accessing' stamp: ''!
packages: aSetOfExChdAdaPackage
	packages := aSetOfExChdAdaPackage ifNil: [ Set new ] ifNotNil: [ aSetOfExChdAdaPackage as: Set ]

! !

PlatypusCoreAlgorithmDeclaration subclass: #ExChdAddXmlIdToAdaClassProcedure
	instanceVariableNames: 'cls idtype idattr'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Express2Cheddar-Express2cheddarFacadeSchema'!

!ExChdAddXmlIdToAdaClassProcedure commentStamp: 'platypus comment' prior: 0!
<ISO10303-11-EXPRESS>
PROCEDURE add_xml_id_to_ada_class ( VAR cls : ada_class );
	LOCAL 
		idtype : cheddar_xml_id_type := entity_instance ( ? ) || sdai_instance ( ) || dictionary_instance ( ) || simple_type ( ) || string_type ( ?, false ) || cheddar_xml_id_type ( );
		idattr : explicit_attribute := entity_instance ( cls ) || sdai_instance ( ) || dictionary_instance ( ) || attribute ( xml_id_name, cls, idtype, ? ) || explicit_attribute ( false );
	END_LOCAL;
	idtype.owner := idattr;
	INSERT ( cls.attributes, idattr, 0 );
END_PROCEDURE;
</ISO10303-11-EXPRESS>!

!ExChdAddXmlIdToAdaClassProcedure class methodsFor: 'platypus-generated-platypus-signature' stamp: ''!
iso10303P11Translater
	^ 'Platypus (c) LISYC EA3883, Universite de Bretagne occidentale. Brest.'

! !

!ExChdAddXmlIdToAdaClassProcedure class methodsFor: 'platypus-generated-meta-data-accessing' stamp: ''!
schemaDefinition
	^ ExChdExpress2cheddarFacadeSchemaDefinition singleton

! !

!ExChdAddXmlIdToAdaClassProcedure class methodsFor: 'platypus-generated-platypus-signature' stamp: ''!
translatedFromISO10303P11
	^ true

! !

!ExChdAddXmlIdToAdaClassProcedure class methodsFor: 'platypus-generated-platypus-signature' stamp: ''!
vwNamespaceName
	^ #Express2Cheddar

! !

!ExChdAddXmlIdToAdaClassProcedure methodsFor: 'platypus-generated-accessing' stamp: ''!
cls
	^ cls

! !

!ExChdAddXmlIdToAdaClassProcedure methodsFor: 'platypus-generated-accessing' stamp: ''!
cls: aExChdAdaClass
	cls := aExChdAdaClass

! !

!ExChdAddXmlIdToAdaClassProcedure methodsFor: 'platypus-generated-accessing' stamp: ''!
fromValues: values
	self cls: (values at: 1)

! !

!ExChdAddXmlIdToAdaClassProcedure methodsFor: 'platypus-generated-accessing' stamp: ''!
idattr
	^ idattr

! !

!ExChdAddXmlIdToAdaClassProcedure methodsFor: 'platypus-generated-accessing' stamp: ''!
idattr: aExChdExplicitAttribute
	idattr := aExChdExplicitAttribute

! !

!ExChdAddXmlIdToAdaClassProcedure methodsFor: 'platypus-generated-accessing' stamp: ''!
idtype
	^ idtype

! !

!ExChdAddXmlIdToAdaClassProcedure methodsFor: 'platypus-generated-accessing' stamp: ''!
idtype: aExChdCheddarXmlIdType
	idtype := aExChdCheddarXmlIdType

! !

!ExChdAddXmlIdToAdaClassProcedure methodsFor: 'platypus-generated-invoking' stamp: ''!
invoke
	" ---------- locals assignments ----------"

	self
		idtype:
			(PlatypusComplexInstance
				fromRecords:
					(OrderedCollection new
						add:
								(PlatypusComplexInstance
										fromRecords:
											(OrderedCollection new
												add:
														(PlatypusComplexInstance
																fromRecords:
																	(OrderedCollection new
																		add:
																				(PlatypusComplexInstance
																						fromRecords:
																							(OrderedCollection new
																								add:
																										(PlatypusComplexInstance
																												fromRecords:
																													(OrderedCollection new
																														add:
																																(PltEntityInstance new
																																		entityInstanceFromValues:
																																				(OrderedCollection new
																																						add: nil;
																																						yourself);
																																		yourself);
																														add: PltSdaiInstance new;
																														yourself)) pltAsObject;
																								add: PltDictionaryInstance new;
																								yourself)) pltAsObject;
																		add: PltSimpleType new;
																		yourself)) pltAsObject;
												add:
														(PltStringType new
																stringTypeFromValues:
																		(OrderedCollection new
																				add: nil;
																				add: false;
																				yourself);
																yourself);
												yourself)) pltAsObject;
						add: ExChdCheddarXmlIdType new;
						yourself)) pltAsObject.
	self
		idattr:
			(PlatypusComplexInstance
				fromRecords:
					(OrderedCollection new
						add:
								(PlatypusComplexInstance
										fromRecords:
											(OrderedCollection new
												add:
														(PlatypusComplexInstance
																fromRecords:
																	(OrderedCollection new
																		add:
																				(PlatypusComplexInstance
																						fromRecords:
																							(OrderedCollection new
																								add:
																										(PltEntityInstance new
																												entityInstanceFromValues:
																														(OrderedCollection new
																																add: self cls;
																																yourself);
																												yourself);
																								add: PltSdaiInstance new;
																								yourself)) pltAsObject;
																		add: PltDictionaryInstance new;
																		yourself)) pltAsObject;
												add:
														(PltAttribute new
																attributeFromValues:
																		(OrderedCollection new
																				add: 'cheddar_private_id';
																				add: self cls;
																				add: self idtype;
																				add: nil;
																				yourself);
																yourself);
												yourself)) pltAsObject;
						add:
								(PltExplicitAttribute new
										explicitAttributeFromValues:
												(OrderedCollection new
														add: false;
														yourself);
										yourself);
						yourself)) pltAsObject.	" ---------- statements ----------"
	self idtype owner: self idattr.
	PltINSERTProcedure
		invokeFromValues:
			(OrderedCollection new
				add: (self cls attributesUsingContext: self class context);
				add: self idattr;
				add: 0;
				yourself)

! !

PlatypusCoreAlgorithmDeclaration subclass: #ExChdAllAdaClassesFunction
	instanceVariableNames: 'clsList allPkgs'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Express2Cheddar-Express2cheddarFacadeSchema'!

!ExChdAllAdaClassesFunction commentStamp: 'platypus comment' prior: 0!
<ISO10303-11-EXPRESS>
FUNCTION all_ada_classes : LIST OF ada_entity;
	LOCAL 
		cls_list : LIST OF ada_class := [ ];
		all_pkgs : LIST OF ada_package := SetToList ( all_ada_packages ( ) );
	END_LOCAL;

	REPEAT no := LOINDEX ( all_pkgs ) TO HIINDEX ( all_pkgs );
		cls_list := cls_list + package_ada_classes ( all_pkgs [ no] );
	END_REPEAT;
	RETURN ( cls_list );
END_FUNCTION;
</ISO10303-11-EXPRESS>!

!ExChdAllAdaClassesFunction class methodsFor: 'platypus-generated-platypus-signature' stamp: ''!
iso10303P11Translater
	^ 'Platypus (c) LISYC EA3883, Universite de Bretagne occidentale. Brest.'

! !

!ExChdAllAdaClassesFunction class methodsFor: 'platypus-generated-meta-data-accessing' stamp: ''!
schemaDefinition
	^ ExChdExpress2cheddarFacadeSchemaDefinition singleton

! !

!ExChdAllAdaClassesFunction class methodsFor: 'platypus-generated-platypus-signature' stamp: ''!
translatedFromISO10303P11
	^ true

! !

!ExChdAllAdaClassesFunction class methodsFor: 'platypus-generated-platypus-signature' stamp: ''!
vwNamespaceName
	^ #Express2Cheddar

! !

!ExChdAllAdaClassesFunction methodsFor: 'platypus-generated-accessing' stamp: ''!
allPkgs
	^ allPkgs

! !

!ExChdAllAdaClassesFunction methodsFor: 'platypus-generated-accessing' stamp: ''!
allPkgs: aListOfExChdAdaPackage
	allPkgs := aListOfExChdAdaPackage
		ifNil: [ OrderedCollection new ]
		ifNotNil: [ aListOfExChdAdaPackage as: OrderedCollection ]

! !

!ExChdAllAdaClassesFunction methodsFor: 'platypus-generated-accessing' stamp: ''!
clsList
	^ clsList

! !

!ExChdAllAdaClassesFunction methodsFor: 'platypus-generated-accessing' stamp: ''!
clsList: aListOfExChdAdaClass
	clsList := aListOfExChdAdaClass
		ifNil: [ OrderedCollection new ]
		ifNotNil: [ aListOfExChdAdaClass as: OrderedCollection ]

! !

!ExChdAllAdaClassesFunction methodsFor: 'platypus-generated-invoking' stamp: ''!
invoke
	" ---------- locals assignments ----------"

	self clsList: Array new.
	self
		allPkgs:
			(PTsSetToListFunction
				invokeFromValues:
					(OrderedCollection new
						add: ExChdAllAdaPackagesFunction invoke;
						yourself)).	" ---------- statements ----------"
	PlatypusCoreRepeatStatement
		repeat: [ :no353 | 
			self
				clsList:
					(self clsList
						pltPlus:
							(ExChdPackageAdaClassesFunction
								invokeFromValues:
									(OrderedCollection new
										add: (self allPkgs pltAt: no353);
										yourself))) ]
		from:
			(PltLOINDEXFunction
				invokeFromValues:
					(OrderedCollection new
						add: self allPkgs;
						yourself))
		to:
			(PltHIINDEXFunction
				invokeFromValues:
					(OrderedCollection new
						add: self allPkgs;
						yourself)).
	^ self return: self clsList

! !

PlatypusCoreAlgorithmDeclaration subclass: #ExChdAllAdaDiscriminatedTypesFunction
	instanceVariableNames: 'dtList allPkgs'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Express2Cheddar-Express2cheddarFacadeSchema'!

!ExChdAllAdaDiscriminatedTypesFunction commentStamp: 'platypus comment' prior: 0!
<ISO10303-11-EXPRESS>
FUNCTION all_ada_discriminated_types : LIST OF ada_entity;
	LOCAL 
		dt_list : LIST OF discriminated_type := [ ];
		all_pkgs : LIST OF ada_package := SetToList ( all_ada_packages ( ) );
	END_LOCAL;

	REPEAT no := LOINDEX ( all_pkgs ) TO HIINDEX ( all_pkgs );

		ALIAS entities FOR all_pkgs [ no].entities;
			REPEAT noi := LOINDEX ( entities ) TO HIINDEX ( entities );
				IF ( 'DISCRIMINATED_TYPE.DISCRIMINATED_TYPE' IN TYPEOF ( entities [ noi] ) ) THEN
					dt_list := dt_list + entities [ noi];
				END_IF;
			END_REPEAT;
		END_ALIAS;
	END_REPEAT;
	RETURN ( dt_list );
END_FUNCTION;
</ISO10303-11-EXPRESS>!

!ExChdAllAdaDiscriminatedTypesFunction class methodsFor: 'platypus-generated-platypus-signature' stamp: ''!
iso10303P11Translater
	^ 'Platypus (c) LISYC EA3883, Universite de Bretagne occidentale. Brest.'

! !

!ExChdAllAdaDiscriminatedTypesFunction class methodsFor: 'platypus-generated-meta-data-accessing' stamp: ''!
schemaDefinition
	^ ExChdExpress2cheddarFacadeSchemaDefinition singleton

! !

!ExChdAllAdaDiscriminatedTypesFunction class methodsFor: 'platypus-generated-platypus-signature' stamp: ''!
translatedFromISO10303P11
	^ true

! !

!ExChdAllAdaDiscriminatedTypesFunction class methodsFor: 'platypus-generated-platypus-signature' stamp: ''!
vwNamespaceName
	^ #Express2Cheddar

! !

!ExChdAllAdaDiscriminatedTypesFunction methodsFor: 'platypus-generated-accessing' stamp: ''!
allPkgs
	^ allPkgs

! !

!ExChdAllAdaDiscriminatedTypesFunction methodsFor: 'platypus-generated-accessing' stamp: ''!
allPkgs: aListOfExChdAdaPackage
	allPkgs := aListOfExChdAdaPackage
		ifNil: [ OrderedCollection new ]
		ifNotNil: [ aListOfExChdAdaPackage as: OrderedCollection ]

! !

!ExChdAllAdaDiscriminatedTypesFunction methodsFor: 'platypus-generated-accessing' stamp: ''!
dtList
	^ dtList

! !

!ExChdAllAdaDiscriminatedTypesFunction methodsFor: 'platypus-generated-accessing' stamp: ''!
dtList: aListOfExChdDiscriminatedType
	dtList := aListOfExChdDiscriminatedType
		ifNil: [ OrderedCollection new ]
		ifNotNil: [ aListOfExChdDiscriminatedType as: OrderedCollection ]

! !

!ExChdAllAdaDiscriminatedTypesFunction methodsFor: 'platypus-generated-invoking' stamp: ''!
invoke
	" ---------- locals assignments ----------"

	self dtList: Array new.
	self
		allPkgs:
			(PTsSetToListFunction
				invokeFromValues:
					(OrderedCollection new
						add: ExChdAllAdaPackagesFunction invoke;
						yourself)).	" ---------- statements ----------"
	PlatypusCoreRepeatStatement
		repeat: [ :no2154 | 
			PlatypusCoreAliasStatement
				alias: ((self allPkgs pltAt: no2154) entitiesUsingContext: self class context)
				statementsBlock: [ :entities633 | 
					PlatypusCoreRepeatStatement
						repeat: [ :noi2452 | 
							((PltTYPEOFFunction
								invokeFromValues:
									(OrderedCollection new
										add: (entities633 pltAt: noi2452);
										yourself)) includes: 'DISCRIMINATED_TYPE.DISCRIMINATED_TYPE')
								ifTrue: [ self dtList: (self dtList pltPlus: (entities633 pltAt: noi2452)) ] ]
						from:
							(PltLOINDEXFunction
								invokeFromValues:
									(OrderedCollection new
										add: entities633;
										yourself))
						to:
							(PltHIINDEXFunction
								invokeFromValues:
									(OrderedCollection new
										add: entities633;
										yourself)) ] ]
		from:
			(PltLOINDEXFunction
				invokeFromValues:
					(OrderedCollection new
						add: self allPkgs;
						yourself))
		to:
			(PltHIINDEXFunction
				invokeFromValues:
					(OrderedCollection new
						add: self allPkgs;
						yourself)).
	^ self return: self dtList

! !

PlatypusCoreAlgorithmDeclaration subclass: #ExChdAllAdaEntitiesFunction
	instanceVariableNames: 'entList allPkgs'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Express2Cheddar-Express2cheddarFacadeSchema'!

!ExChdAllAdaEntitiesFunction commentStamp: 'platypus comment' prior: 0!
<ISO10303-11-EXPRESS>
FUNCTION all_ada_entities : LIST OF ada_entity;
	LOCAL 
		ent_list : LIST OF ada_entity := [ ];
		all_pkgs : LIST OF ada_package := SetToList ( all_ada_packages ( ) );
	END_LOCAL;

	REPEAT no := LOINDEX ( all_pkgs ) TO HIINDEX ( all_pkgs );

		ALIAS entities FOR all_pkgs [ no].entities;
			REPEAT noi := LOINDEX ( entities ) TO HIINDEX ( entities );
				IF ( 'RECORD_AND_CLASS.RECORD' IN TYPEOF ( entities [ noi] ) ) THEN
					ent_list := ent_list + entities [ noi];
				END_IF;
				IF ( 'RECORD_AND_CLASS.ADA_CLASS' IN TYPEOF ( entities [ noi] ) ) THEN
					ent_list := ent_list + entities [ noi];
				END_IF;
				IF ( 'DISCRIMINATED_TYPE.DISCRIMINATED_TYPE' IN TYPEOF ( entities [ noi] ) ) THEN
					ent_list := ent_list + entities [ noi];
				END_IF;
			END_REPEAT;
		END_ALIAS;
	END_REPEAT;
	RETURN ( ent_list );
END_FUNCTION;
</ISO10303-11-EXPRESS>!

!ExChdAllAdaEntitiesFunction class methodsFor: 'platypus-generated-platypus-signature' stamp: ''!
iso10303P11Translater
	^ 'Platypus (c) LISYC EA3883, Universite de Bretagne occidentale. Brest.'

! !

!ExChdAllAdaEntitiesFunction class methodsFor: 'platypus-generated-meta-data-accessing' stamp: ''!
schemaDefinition
	^ ExChdExpress2cheddarFacadeSchemaDefinition singleton

! !

!ExChdAllAdaEntitiesFunction class methodsFor: 'platypus-generated-platypus-signature' stamp: ''!
translatedFromISO10303P11
	^ true

! !

!ExChdAllAdaEntitiesFunction class methodsFor: 'platypus-generated-platypus-signature' stamp: ''!
vwNamespaceName
	^ #Express2Cheddar

! !

!ExChdAllAdaEntitiesFunction methodsFor: 'platypus-generated-accessing' stamp: ''!
allPkgs
	^ allPkgs

! !

!ExChdAllAdaEntitiesFunction methodsFor: 'platypus-generated-accessing' stamp: ''!
allPkgs: aListOfExChdAdaPackage
	allPkgs := aListOfExChdAdaPackage
		ifNil: [ OrderedCollection new ]
		ifNotNil: [ aListOfExChdAdaPackage as: OrderedCollection ]

! !

!ExChdAllAdaEntitiesFunction methodsFor: 'platypus-generated-accessing' stamp: ''!
entList
	^ entList

! !

!ExChdAllAdaEntitiesFunction methodsFor: 'platypus-generated-accessing' stamp: ''!
entList: aListOfExChdAdaEntity
	entList := aListOfExChdAdaEntity
		ifNil: [ OrderedCollection new ]
		ifNotNil: [ aListOfExChdAdaEntity as: OrderedCollection ]

! !

!ExChdAllAdaEntitiesFunction methodsFor: 'platypus-generated-invoking' stamp: ''!
invoke
	" ---------- locals assignments ----------"

	self entList: Array new.
	self
		allPkgs:
			(PTsSetToListFunction
				invokeFromValues:
					(OrderedCollection new
						add: ExChdAllAdaPackagesFunction invoke;
						yourself)).	" ---------- statements ----------"
	PlatypusCoreRepeatStatement
		repeat: [ :no3513 | 
			PlatypusCoreAliasStatement
				alias: ((self allPkgs pltAt: no3513) entitiesUsingContext: self class context)
				statementsBlock: [ :entities1992 | 
					PlatypusCoreRepeatStatement
						repeat: [ :noi3811 | 
							((PltTYPEOFFunction
								invokeFromValues:
									(OrderedCollection new
										add: (entities1992 pltAt: noi3811);
										yourself)) includes: 'RECORD_AND_CLASS.RECORD')
								ifTrue: [ self entList: (self entList pltPlus: (entities1992 pltAt: noi3811)) ].
							((PltTYPEOFFunction
								invokeFromValues:
									(OrderedCollection new
										add: (entities1992 pltAt: noi3811);
										yourself)) includes: 'RECORD_AND_CLASS.ADA_CLASS')
								ifTrue: [ self entList: (self entList pltPlus: (entities1992 pltAt: noi3811)) ].
							((PltTYPEOFFunction
								invokeFromValues:
									(OrderedCollection new
										add: (entities1992 pltAt: noi3811);
										yourself)) includes: 'DISCRIMINATED_TYPE.DISCRIMINATED_TYPE')
								ifTrue: [ self entList: (self entList pltPlus: (entities1992 pltAt: noi3811)) ] ]
						from:
							(PltLOINDEXFunction
								invokeFromValues:
									(OrderedCollection new
										add: entities1992;
										yourself))
						to:
							(PltHIINDEXFunction
								invokeFromValues:
									(OrderedCollection new
										add: entities1992;
										yourself)) ] ]
		from:
			(PltLOINDEXFunction
				invokeFromValues:
					(OrderedCollection new
						add: self allPkgs;
						yourself))
		to:
			(PltHIINDEXFunction
				invokeFromValues:
					(OrderedCollection new
						add: self allPkgs;
						yourself)).
	^ self return: self entList

! !

PlatypusCoreAlgorithmDeclaration subclass: #ExChdAllAdaPackagesFunction
	instanceVariableNames: 'insts'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Express2Cheddar-Express2cheddarFacadeSchema'!

!ExChdAllAdaPackagesFunction commentStamp: 'platypus comment' prior: 0!
<ISO10303-11-EXPRESS>
FUNCTION all_ada_packages : SET OF ada_package;
	LOCAL 
		insts : SET OF GENERIC := allModelInstances ( );
	END_LOCAL;
	RETURN ( QUERY ( i <* insts | 'PACKAGE.ADA_PACKAGE' IN TYPEOF ( i ) ) );
END_FUNCTION;
</ISO10303-11-EXPRESS>!

!ExChdAllAdaPackagesFunction class methodsFor: 'platypus-generated-platypus-signature' stamp: ''!
iso10303P11Translater
	^ 'Platypus (c) LISYC EA3883, Universite de Bretagne occidentale. Brest.'

! !

!ExChdAllAdaPackagesFunction class methodsFor: 'platypus-generated-meta-data-accessing' stamp: ''!
schemaDefinition
	^ ExChdExpress2cheddarFacadeSchemaDefinition singleton

! !

!ExChdAllAdaPackagesFunction class methodsFor: 'platypus-generated-platypus-signature' stamp: ''!
translatedFromISO10303P11
	^ true

! !

!ExChdAllAdaPackagesFunction class methodsFor: 'platypus-generated-platypus-signature' stamp: ''!
vwNamespaceName
	^ #Express2Cheddar

! !

!ExChdAllAdaPackagesFunction methodsFor: 'platypus-generated-accessing' stamp: ''!
insts
	^ insts

! !

!ExChdAllAdaPackagesFunction methodsFor: 'platypus-generated-accessing' stamp: ''!
insts: aSetOfObject
	insts := aSetOfObject ifNil: [ Set new ] ifNotNil: [ aSetOfObject as: Set ]

! !

!ExChdAllAdaPackagesFunction methodsFor: 'platypus-generated-invoking' stamp: ''!
invoke
	" ---------- locals assignments ----------"

	self insts: PTsAllModelInstancesFunction invoke.	" ---------- statements ----------"
	^ self
		return:
			(self insts
				select: [ :i1175 | 
					(PltTYPEOFFunction
						invokeFromValues:
							(OrderedCollection new
								add: i1175;
								yourself)) includes: 'PACKAGE.ADA_PACKAGE' ])

! !

PlatypusCoreAlgorithmDeclaration subclass: #ExChdAllAdaRecordsFunction
	instanceVariableNames: 'clsList allPkgs'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Express2Cheddar-Express2cheddarFacadeSchema'!

!ExChdAllAdaRecordsFunction commentStamp: 'platypus comment' prior: 0!
<ISO10303-11-EXPRESS>
FUNCTION all_ada_records : LIST OF ada_entity;
	LOCAL 
		cls_list : LIST OF ada_class := [ ];
		all_pkgs : LIST OF ada_package := SetToList ( all_ada_packages ( ) );
	END_LOCAL;

	REPEAT no := LOINDEX ( all_pkgs ) TO HIINDEX ( all_pkgs );

		ALIAS entities FOR all_pkgs [ no].entities;
			REPEAT noi := LOINDEX ( entities ) TO HIINDEX ( entities );
				IF ( 'RECORD_AND_CLASS.RECORD' IN TYPEOF ( entities [ noi] ) ) THEN
					cls_list := cls_list + entities [ noi];
				END_IF;
			END_REPEAT;
		END_ALIAS;
	END_REPEAT;
	RETURN ( cls_list );
END_FUNCTION;
</ISO10303-11-EXPRESS>!

!ExChdAllAdaRecordsFunction class methodsFor: 'platypus-generated-platypus-signature' stamp: ''!
iso10303P11Translater
	^ 'Platypus (c) LISYC EA3883, Universite de Bretagne occidentale. Brest.'

! !

!ExChdAllAdaRecordsFunction class methodsFor: 'platypus-generated-meta-data-accessing' stamp: ''!
schemaDefinition
	^ ExChdExpress2cheddarFacadeSchemaDefinition singleton

! !

!ExChdAllAdaRecordsFunction class methodsFor: 'platypus-generated-platypus-signature' stamp: ''!
translatedFromISO10303P11
	^ true

! !

!ExChdAllAdaRecordsFunction class methodsFor: 'platypus-generated-platypus-signature' stamp: ''!
vwNamespaceName
	^ #Express2Cheddar

! !

!ExChdAllAdaRecordsFunction methodsFor: 'platypus-generated-accessing' stamp: ''!
allPkgs
	^ allPkgs

! !

!ExChdAllAdaRecordsFunction methodsFor: 'platypus-generated-accessing' stamp: ''!
allPkgs: aListOfExChdAdaPackage
	allPkgs := aListOfExChdAdaPackage
		ifNil: [ OrderedCollection new ]
		ifNotNil: [ aListOfExChdAdaPackage as: OrderedCollection ]

! !

!ExChdAllAdaRecordsFunction methodsFor: 'platypus-generated-accessing' stamp: ''!
clsList
	^ clsList

! !

!ExChdAllAdaRecordsFunction methodsFor: 'platypus-generated-accessing' stamp: ''!
clsList: aListOfExChdAdaClass
	clsList := aListOfExChdAdaClass
		ifNil: [ OrderedCollection new ]
		ifNotNil: [ aListOfExChdAdaClass as: OrderedCollection ]

! !

!ExChdAllAdaRecordsFunction methodsFor: 'platypus-generated-invoking' stamp: ''!
invoke
	" ---------- locals assignments ----------"

	self clsList: Array new.
	self
		allPkgs:
			(PTsSetToListFunction
				invokeFromValues:
					(OrderedCollection new
						add: ExChdAllAdaPackagesFunction invoke;
						yourself)).	" ---------- statements ----------"
	PlatypusCoreRepeatStatement
		repeat: [ :no1947 | 
			PlatypusCoreAliasStatement
				alias: ((self allPkgs pltAt: no1947) entitiesUsingContext: self class context)
				statementsBlock: [ :entities426 | 
					PlatypusCoreRepeatStatement
						repeat: [ :noi2245 | 
							((PltTYPEOFFunction
								invokeFromValues:
									(OrderedCollection new
										add: (entities426 pltAt: noi2245);
										yourself)) includes: 'RECORD_AND_CLASS.RECORD')
								ifTrue: [ self clsList: (self clsList pltPlus: (entities426 pltAt: noi2245)) ] ]
						from:
							(PltLOINDEXFunction
								invokeFromValues:
									(OrderedCollection new
										add: entities426;
										yourself))
						to:
							(PltHIINDEXFunction
								invokeFromValues:
									(OrderedCollection new
										add: entities426;
										yourself)) ] ]
		from:
			(PltLOINDEXFunction
				invokeFromValues:
					(OrderedCollection new
						add: self allPkgs;
						yourself))
		to:
			(PltHIINDEXFunction
				invokeFromValues:
					(OrderedCollection new
						add: self allPkgs;
						yourself)).
	^ self return: self clsList

! !

PlatypusCoreAlgorithmDeclaration subclass: #ExChdAllPackagesCodeFunction
	instanceVariableNames: 'ads'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Express2Cheddar-PackageSchema'!

!ExChdAllPackagesCodeFunction commentStamp: 'platypus comment' prior: 0!
<ISO10303-11-EXPRESS>
FUNCTION all_packages_code ( ads : BOOLEAN ) : STRING;
	RETURN ( all_packages_code_into ( ads, ?, ? ) );
END_FUNCTION;
</ISO10303-11-EXPRESS>!

!ExChdAllPackagesCodeFunction class methodsFor: 'platypus-generated-platypus-signature' stamp: ''!
iso10303P11Translater
	^ 'Platypus (c) LISYC EA3883, Universite de Bretagne occidentale. Brest.'

! !

!ExChdAllPackagesCodeFunction class methodsFor: 'platypus-generated-meta-data-accessing' stamp: ''!
schemaDefinition
	^ ExChdPackageSchemaDefinition singleton

! !

!ExChdAllPackagesCodeFunction class methodsFor: 'platypus-generated-platypus-signature' stamp: ''!
translatedFromISO10303P11
	^ true

! !

!ExChdAllPackagesCodeFunction class methodsFor: 'platypus-generated-platypus-signature' stamp: ''!
vwNamespaceName
	^ #Express2Cheddar

! !

!ExChdAllPackagesCodeFunction methodsFor: 'platypus-generated-accessing' stamp: ''!
ads
	^ ads

! !

!ExChdAllPackagesCodeFunction methodsFor: 'platypus-generated-accessing' stamp: ''!
ads: aBoolean
	ads := aBoolean

! !

!ExChdAllPackagesCodeFunction methodsFor: 'platypus-generated-accessing' stamp: ''!
fromValues: values
	self ads: (values at: 1)

! !

!ExChdAllPackagesCodeFunction methodsFor: 'platypus-generated-invoking' stamp: ''!
invoke
	" ---------- locals assignments ----------"

	" ---------- statements ----------"

	^ self
		return:
			(ExChdAllPackagesCodeIntoFunction
				invokeFromValues:
					(OrderedCollection new
						add: self ads;
						add: nil;
						add: nil;
						yourself))

! !

PlatypusCoreAlgorithmDeclaration subclass: #ExChdAllPackagesCodeIntoFunction
	instanceVariableNames: 'ads dir targetName code body pkgs targetPath'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Express2Cheddar-PackageSchema'!

!ExChdAllPackagesCodeIntoFunction commentStamp: 'platypus comment' prior: 0!
<ISO10303-11-EXPRESS>
FUNCTION all_packages_code_into ( ads : BOOLEAN; dir : STRING; targetName : STRING ) : STRING;
	LOCAL 
		code : STRING := '';
		body : STRING;
		pkgs : LIST OF ada_package := SetToList ( all_ada_packages ( ) );
		targetPath : STRING;
	END_LOCAL;

	REPEAT no := LOINDEX ( pkgs ) TO HIINDEX ( pkgs );

		IF ads THEN
			body := pkgs [ no].ads_code;
		ELSE
			body := pkgs [ no].adb_code;
		END_IF;

		IF ( body > '' ) THEN
			code := code + body + '\n\n';
		END_IF;
	END_REPEAT;

	IF ads THEN
		code := code + xml_architecture_io_ads_package_code ( );
	ELSE
		code := code + xml_architecture_io_adb_package_code ( );
	END_IF;

	IF EXISTS ( dir ) THEN
		targetPath := dir;
	ELSE
		targetPath := '.';
	END_IF;

	IF EXISTS ( targetName ) THEN
		targetPath := targetPath + '/' + targetName;
	ELSE
		targetPath := targetPath + '/' + 'Platypus2Cheddar';
	END_IF;

	IF ads THEN
		WriteFile ( targetPath + '.ads', code );
	ELSE
		WriteFile ( targetPath + '.adb', code );
	END_IF;
	RETURN ( code );
END_FUNCTION;
</ISO10303-11-EXPRESS>!

!ExChdAllPackagesCodeIntoFunction class methodsFor: 'platypus-generated-platypus-signature' stamp: ''!
iso10303P11Translater
	^ 'Platypus (c) LISYC EA3883, Universite de Bretagne occidentale. Brest.'

! !

!ExChdAllPackagesCodeIntoFunction class methodsFor: 'platypus-generated-meta-data-accessing' stamp: ''!
schemaDefinition
	^ ExChdPackageSchemaDefinition singleton

! !

!ExChdAllPackagesCodeIntoFunction class methodsFor: 'platypus-generated-platypus-signature' stamp: ''!
translatedFromISO10303P11
	^ true

! !

!ExChdAllPackagesCodeIntoFunction class methodsFor: 'platypus-generated-platypus-signature' stamp: ''!
vwNamespaceName
	^ #Express2Cheddar

! !

!ExChdAllPackagesCodeIntoFunction methodsFor: 'platypus-generated-accessing' stamp: ''!
ads
	^ ads

! !

!ExChdAllPackagesCodeIntoFunction methodsFor: 'platypus-generated-accessing' stamp: ''!
ads: aBoolean
	ads := aBoolean

! !

!ExChdAllPackagesCodeIntoFunction methodsFor: 'platypus-generated-accessing' stamp: ''!
ads: aBoolean dir: aString targetName: aString1
	self ads: aBoolean.
	self dir: aString.
	self targetName: aString1

! !

!ExChdAllPackagesCodeIntoFunction methodsFor: 'platypus-generated-accessing' stamp: ''!
body
	^ body

! !

!ExChdAllPackagesCodeIntoFunction methodsFor: 'platypus-generated-accessing' stamp: ''!
body: aString1
	body := aString1

! !

!ExChdAllPackagesCodeIntoFunction methodsFor: 'platypus-generated-accessing' stamp: ''!
code
	^ code

! !

!ExChdAllPackagesCodeIntoFunction methodsFor: 'platypus-generated-accessing' stamp: ''!
code: aString
	code := aString

! !

!ExChdAllPackagesCodeIntoFunction methodsFor: 'platypus-generated-accessing' stamp: ''!
dir
	^ dir

! !

!ExChdAllPackagesCodeIntoFunction methodsFor: 'platypus-generated-accessing' stamp: ''!
dir: aString
	dir := aString

! !

!ExChdAllPackagesCodeIntoFunction methodsFor: 'platypus-generated-accessing' stamp: ''!
fromValues: values
	self ads: (values at: 1).
	self dir: (values at: 2).
	self targetName: (values at: 3)

! !

!ExChdAllPackagesCodeIntoFunction methodsFor: 'platypus-generated-invoking' stamp: ''!
invoke
	" ---------- locals assignments ----------"

	self code: ''.
	self
		pkgs:
			(PTsSetToListFunction
				invokeFromValues:
					(OrderedCollection new
						add: ExChdAllAdaPackagesFunction invoke;
						yourself)).	" ---------- statements ----------"
	PlatypusCoreRepeatStatement
		repeat: [ :no3794 | 
			self ads
				ifTrue: [ self body: ((self pkgs pltAt: no3794) adsCodeUsingContext: self class context) ]
				ifFalse: [ self body: ((self pkgs pltAt: no3794) adbCodeUsingContext: self class context) ].
			self body > ''
				ifTrue: [ self code: ((self code pltPlus: self body) pltPlus: '\n\n') ] ]
		from:
			(PltLOINDEXFunction
				invokeFromValues:
					(OrderedCollection new
						add: self pkgs;
						yourself))
		to:
			(PltHIINDEXFunction
				invokeFromValues:
					(OrderedCollection new
						add: self pkgs;
						yourself)).
	self ads
		ifTrue: [ self code: (self code pltPlus: ExChdXmlArchitectureIoAdsPackageCodeFunction invoke) ]
		ifFalse: [ self code: (self code pltPlus: ExChdXmlArchitectureIoAdbPackageCodeFunction invoke) ].
	(PltEXISTSFunction
		invokeFromValues:
			(OrderedCollection new
				add: self dir;
				yourself))
		ifTrue: [ self targetPath: self dir ]
		ifFalse: [ self targetPath: '.' ].
	(PltEXISTSFunction
		invokeFromValues:
			(OrderedCollection new
				add: self targetName;
				yourself))
		ifTrue: [ self targetPath: ((self targetPath pltPlus: '/') pltPlus: self targetName) ]
		ifFalse: [ self targetPath: ((self targetPath pltPlus: '/') pltPlus: 'Platypus2Cheddar') ].
	self ads
		ifTrue: [ 
			PTsWriteFileProcedure
				invokeFromValues:
					(OrderedCollection new
						add: (self targetPath pltPlus: '.ads');
						add: self code;
						yourself) ]
		ifFalse: [ 
			PTsWriteFileProcedure
				invokeFromValues:
					(OrderedCollection new
						add: (self targetPath pltPlus: '.adb');
						add: self code;
						yourself) ].
	^ self return: self code

! !

!ExChdAllPackagesCodeIntoFunction methodsFor: 'platypus-generated-accessing' stamp: ''!
pkgs
	^ pkgs

! !

!ExChdAllPackagesCodeIntoFunction methodsFor: 'platypus-generated-accessing' stamp: ''!
pkgs: aListOfExChdAdaPackage
	pkgs := aListOfExChdAdaPackage
		ifNil: [ OrderedCollection new ]
		ifNotNil: [ aListOfExChdAdaPackage as: OrderedCollection ]

! !

!ExChdAllPackagesCodeIntoFunction methodsFor: 'platypus-generated-accessing' stamp: ''!
targetName
	^ targetName

! !

!ExChdAllPackagesCodeIntoFunction methodsFor: 'platypus-generated-accessing' stamp: ''!
targetName: aString1
	targetName := aString1

! !

!ExChdAllPackagesCodeIntoFunction methodsFor: 'platypus-generated-accessing' stamp: ''!
targetPath
	^ targetPath

! !

!ExChdAllPackagesCodeIntoFunction methodsFor: 'platypus-generated-accessing' stamp: ''!
targetPath: aString2
	targetPath := aString2

! !

PlatypusCoreAlgorithmDeclaration subclass: #ExChdBasicAdaDomainFunction
	instanceVariableNames: 'd'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Express2Cheddar-CheddarDomainsSchema'!

!ExChdBasicAdaDomainFunction commentStamp: 'platypus comment' prior: 0!
<ISO10303-11-EXPRESS>
FUNCTION basic_ada_domain ( d : dictionary_instance ) : entity_instance;
	RETURN ( ( d || basic_ada_type_getter ( ) ).accepted );
END_FUNCTION;
</ISO10303-11-EXPRESS>!

!ExChdBasicAdaDomainFunction class methodsFor: 'platypus-generated-platypus-signature' stamp: ''!
iso10303P11Translater
	^ 'Platypus (c) LISYC EA3883, Universite de Bretagne occidentale. Brest.'

! !

!ExChdBasicAdaDomainFunction class methodsFor: 'platypus-generated-meta-data-accessing' stamp: ''!
schemaDefinition
	^ ExChdCheddarDomainsSchemaDefinition singleton

! !

!ExChdBasicAdaDomainFunction class methodsFor: 'platypus-generated-platypus-signature' stamp: ''!
translatedFromISO10303P11
	^ true

! !

!ExChdBasicAdaDomainFunction class methodsFor: 'platypus-generated-platypus-signature' stamp: ''!
vwNamespaceName
	^ #Express2Cheddar

! !

!ExChdBasicAdaDomainFunction methodsFor: 'platypus-generated-accessing' stamp: ''!
d
	^ d

! !

!ExChdBasicAdaDomainFunction methodsFor: 'platypus-generated-accessing' stamp: ''!
d: aExChdDictionaryInstance
	d := aExChdDictionaryInstance

! !

!ExChdBasicAdaDomainFunction methodsFor: 'platypus-generated-accessing' stamp: ''!
fromValues: values
	self d: (values at: 1)

! !

!ExChdBasicAdaDomainFunction methodsFor: 'platypus-generated-invoking' stamp: ''!
invoke
	" ---------- locals assignments ----------"

	" ---------- statements ----------"

	^ self
		return:
			((PlatypusComplexInstance
				fromRecords:
					(OrderedCollection new
						add: self d;
						add: ExChdBasicAdaTypeGetter new;
						yourself)) pltAsObject acceptedUsingContext: self class context)

! !

PlatypusCoreAlgorithmDeclaration subclass: #ExChdBasicAdaExpressionValueStringFunction
	instanceVariableNames: 'e code'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Express2Cheddar-CheddarDomainsSchema'!

!ExChdBasicAdaExpressionValueStringFunction commentStamp: 'platypus comment' prior: 0!
<ISO10303-11-EXPRESS>
FUNCTION basic_ada_expression_value_string ( e : expression ) : STRING;
	LOCAL 
		code : STRING := '';
	END_LOCAL;

	IF ( 'PLATYPUS_EXPRESSIONS_SCHEMA.IDENTIFIER' IN TYPEOF ( e ) ) THEN
		RETURN ( e.name );
	END_IF;

	IF ( 'PLATYPUS_EXPRESSIONS_SCHEMA.INTEGER_LITERAL' IN TYPEOF ( e ) ) THEN
		RETURN ( FORMAT ( e.val, 'I' ) );
	END_IF;

	IF ( 'PLATYPUS_EXPRESSIONS_SCHEMA.TRUE_CONSTANT' IN TYPEOF ( e ) ) THEN
		RETURN ( 'True' );
	END_IF;

	IF ( 'PLATYPUS_EXPRESSIONS_SCHEMA.FALSE_CONSTANT' IN TYPEOF ( e ) ) THEN
		RETURN ( 'False' );
	END_IF;

	IF ( 'PLATYPUS_EXPRESSIONS_SCHEMA.BINARY_EXPRESSION' IN TYPEOF ( e ) ) THEN
		RETURN ( '(' + basic_ada_expression_value_string ( e.left_expr ) + ' ' + e.op_string + ' ' + basic_ada_expression_value_string ( e.right_expr ) + ')' );
	END_IF;
	RETURN ( 'null' );
END_FUNCTION;
</ISO10303-11-EXPRESS>!

!ExChdBasicAdaExpressionValueStringFunction class methodsFor: 'platypus-generated-platypus-signature' stamp: ''!
iso10303P11Translater
	^ 'Platypus (c) LISYC EA3883, Universite de Bretagne occidentale. Brest.'

! !

!ExChdBasicAdaExpressionValueStringFunction class methodsFor: 'platypus-generated-meta-data-accessing' stamp: ''!
schemaDefinition
	^ ExChdCheddarDomainsSchemaDefinition singleton

! !

!ExChdBasicAdaExpressionValueStringFunction class methodsFor: 'platypus-generated-platypus-signature' stamp: ''!
translatedFromISO10303P11
	^ true

! !

!ExChdBasicAdaExpressionValueStringFunction class methodsFor: 'platypus-generated-platypus-signature' stamp: ''!
vwNamespaceName
	^ #Express2Cheddar

! !

!ExChdBasicAdaExpressionValueStringFunction methodsFor: 'platypus-generated-accessing' stamp: ''!
code
	^ code

! !

!ExChdBasicAdaExpressionValueStringFunction methodsFor: 'platypus-generated-accessing' stamp: ''!
code: aString
	code := aString

! !

!ExChdBasicAdaExpressionValueStringFunction methodsFor: 'platypus-generated-accessing' stamp: ''!
e
	^ e

! !

!ExChdBasicAdaExpressionValueStringFunction methodsFor: 'platypus-generated-accessing' stamp: ''!
e: aExChdExpression
	e := aExChdExpression

! !

!ExChdBasicAdaExpressionValueStringFunction methodsFor: 'platypus-generated-accessing' stamp: ''!
fromValues: values
	self e: (values at: 1)

! !

!ExChdBasicAdaExpressionValueStringFunction methodsFor: 'platypus-generated-invoking' stamp: ''!
invoke
	" ---------- locals assignments ----------"

	self code: ''.	" ---------- statements ----------"
	((PltTYPEOFFunction
		invokeFromValues:
			(OrderedCollection new
				add: self e;
				yourself)) includes: 'PLATYPUS_EXPRESSIONS_SCHEMA.IDENTIFIER')
		ifTrue: [ ^ self return: (self e nameUsingContext: self class context) ].
	((PltTYPEOFFunction
		invokeFromValues:
			(OrderedCollection new
				add: self e;
				yourself)) includes: 'PLATYPUS_EXPRESSIONS_SCHEMA.INTEGER_LITERAL')
		ifTrue: [ 
			^ self
				return:
					(PltFORMATFunction
						invokeFromValues:
							(OrderedCollection new
								add: (self e valUsingContext: self class context);
								add: 'I';
								yourself)) ].
	((PltTYPEOFFunction
		invokeFromValues:
			(OrderedCollection new
				add: self e;
				yourself)) includes: 'PLATYPUS_EXPRESSIONS_SCHEMA.TRUE_CONSTANT')
		ifTrue: [ ^ self return: 'True' ].
	((PltTYPEOFFunction
		invokeFromValues:
			(OrderedCollection new
				add: self e;
				yourself)) includes: 'PLATYPUS_EXPRESSIONS_SCHEMA.FALSE_CONSTANT')
		ifTrue: [ ^ self return: 'False' ].
	((PltTYPEOFFunction
		invokeFromValues:
			(OrderedCollection new
				add: self e;
				yourself)) includes: 'PLATYPUS_EXPRESSIONS_SCHEMA.BINARY_EXPRESSION')
		ifTrue: [ 
			^ self
				return:
					(((((('('
						pltPlus:
							(ExChdBasicAdaExpressionValueStringFunction
								invokeFromValues:
									(OrderedCollection new
										add: (self e leftExprUsingContext: self class context);
										yourself))) pltPlus: ' ') pltPlus: (self e opStringUsingContext: self class context)) pltPlus: ' ')
						pltPlus:
							(ExChdBasicAdaExpressionValueStringFunction
								invokeFromValues:
									(OrderedCollection new
										add: (self e rightExprUsingContext: self class context);
										yourself))) pltPlus: ')') ].
	^ self return: 'null'

! !

PlatypusCoreAlgorithmDeclaration subclass: #ExChdCheddarDefinedTypeInterfacesListFunction
	instanceVariableNames: 'r ads result'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Express2Cheddar-CheddarDomainsSchema'!

!ExChdCheddarDefinedTypeInterfacesListFunction commentStamp: 'platypus comment' prior: 0!
<ISO10303-11-EXPRESS>
FUNCTION cheddar_defined_type_interfaces_list ( r : cheddar_defined_type; ads : BOOLEAN ) : LIST OF ada_interface;
	LOCAL 
		result : LIST OF ada_interface := [ ];
	END_LOCAL;

	IF ads THEN
		result := result + ada_interface ( r.owner.name, ?, true, true );
	END_IF;
	RETURN ( result );
END_FUNCTION;
</ISO10303-11-EXPRESS>!

!ExChdCheddarDefinedTypeInterfacesListFunction class methodsFor: 'platypus-generated-platypus-signature' stamp: ''!
iso10303P11Translater
	^ 'Platypus (c) LISYC EA3883, Universite de Bretagne occidentale. Brest.'

! !

!ExChdCheddarDefinedTypeInterfacesListFunction class methodsFor: 'platypus-generated-meta-data-accessing' stamp: ''!
schemaDefinition
	^ ExChdCheddarDomainsSchemaDefinition singleton

! !

!ExChdCheddarDefinedTypeInterfacesListFunction class methodsFor: 'platypus-generated-platypus-signature' stamp: ''!
translatedFromISO10303P11
	^ true

! !

!ExChdCheddarDefinedTypeInterfacesListFunction class methodsFor: 'platypus-generated-platypus-signature' stamp: ''!
vwNamespaceName
	^ #Express2Cheddar

! !

!ExChdCheddarDefinedTypeInterfacesListFunction methodsFor: 'platypus-generated-accessing' stamp: ''!
ads
	^ ads

! !

!ExChdCheddarDefinedTypeInterfacesListFunction methodsFor: 'platypus-generated-accessing' stamp: ''!
ads: aBoolean
	ads := aBoolean

! !

!ExChdCheddarDefinedTypeInterfacesListFunction methodsFor: 'platypus-generated-accessing' stamp: ''!
fromValues: values
	self r: (values at: 1).
	self ads: (values at: 2)

! !

!ExChdCheddarDefinedTypeInterfacesListFunction methodsFor: 'platypus-generated-invoking' stamp: ''!
invoke
	" ---------- locals assignments ----------"

	self result: Array new.	" ---------- statements ----------"
	self ads
		ifTrue: [ 
			self
				result:
					(self result
						pltPlus:
							(ExChdAdaInterface new
								adaInterfaceFromValues:
										(OrderedCollection new
												add: ((self r ownerUsingContext: self class context) nameUsingContext: self class context);
												add: nil;
												add: true;
												add: true;
												yourself);
								yourself)) ].
	^ self return: self result

! !

!ExChdCheddarDefinedTypeInterfacesListFunction methodsFor: 'platypus-generated-accessing' stamp: ''!
r
	^ r

! !

!ExChdCheddarDefinedTypeInterfacesListFunction methodsFor: 'platypus-generated-accessing' stamp: ''!
r: aExChdCheddarDefinedType
	r := aExChdCheddarDefinedType

! !

!ExChdCheddarDefinedTypeInterfacesListFunction methodsFor: 'platypus-generated-accessing' stamp: ''!
r: aExChdCheddarDefinedType ads: aBoolean
	self r: aExChdCheddarDefinedType.
	self ads: aBoolean

! !

!ExChdCheddarDefinedTypeInterfacesListFunction methodsFor: 'platypus-generated-accessing' stamp: ''!
result
	^ result

! !

!ExChdCheddarDefinedTypeInterfacesListFunction methodsFor: 'platypus-generated-accessing' stamp: ''!
result: aListOfExChdAdaInterface
	result := aListOfExChdAdaInterface
		ifNil: [ OrderedCollection new ]
		ifNotNil: [ aListOfExChdAdaInterface as: OrderedCollection ]

! !

PlatypusCoreAlgorithmDeclaration subclass: #ExChdComputeAttributeDtdElementFunction
	instanceVariableNames: 'owner a domain result'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Express2Cheddar-CheddarDtdSchema'!

!ExChdComputeAttributeDtdElementFunction commentStamp: 'platypus comment' prior: 0!
<ISO10303-11-EXPRESS>
FUNCTION compute_attribute_dtd_element ( owner : dtd_element; a : attribute ) : attribute_dtd_element;
	LOCAL 
		domain : entity_instance := basic_ada_domain ( a.domain ).handled;
		result : attribute_dtd_element;
	END_LOCAL;
	result := ( dtd_element ( owner, ? ) || attribute_dtd_element ( a, ? ) );
	result.domain := compute_domain_dtd_element ( result, domain );
	RETURN ( result );
END_FUNCTION;
</ISO10303-11-EXPRESS>!

!ExChdComputeAttributeDtdElementFunction class methodsFor: 'platypus-generated-platypus-signature' stamp: ''!
iso10303P11Translater
	^ 'Platypus (c) LISYC EA3883, Universite de Bretagne occidentale. Brest.'

! !

!ExChdComputeAttributeDtdElementFunction class methodsFor: 'platypus-generated-meta-data-accessing' stamp: ''!
schemaDefinition
	^ ExChdCheddarDtdSchemaDefinition singleton

! !

!ExChdComputeAttributeDtdElementFunction class methodsFor: 'platypus-generated-platypus-signature' stamp: ''!
translatedFromISO10303P11
	^ true

! !

!ExChdComputeAttributeDtdElementFunction class methodsFor: 'platypus-generated-platypus-signature' stamp: ''!
vwNamespaceName
	^ #Express2Cheddar

! !

!ExChdComputeAttributeDtdElementFunction methodsFor: 'platypus-generated-accessing' stamp: ''!
a
	^ a

! !

!ExChdComputeAttributeDtdElementFunction methodsFor: 'platypus-generated-accessing' stamp: ''!
a: aExChdAttribute
	a := aExChdAttribute

! !

!ExChdComputeAttributeDtdElementFunction methodsFor: 'platypus-generated-accessing' stamp: ''!
domain
	^ domain

! !

!ExChdComputeAttributeDtdElementFunction methodsFor: 'platypus-generated-accessing' stamp: ''!
domain: aExChdEntityInstance
	domain := aExChdEntityInstance

! !

!ExChdComputeAttributeDtdElementFunction methodsFor: 'platypus-generated-accessing' stamp: ''!
fromValues: values
	self owner: (values at: 1).
	self a: (values at: 2)

! !

!ExChdComputeAttributeDtdElementFunction methodsFor: 'platypus-generated-invoking' stamp: ''!
invoke
	" ---------- locals assignments ----------"

	self
		domain:
			((ExChdBasicAdaDomainFunction
				invokeFromValues:
					(OrderedCollection new
						add: (self a domainUsingContext: self class context);
						yourself)) handledUsingContext: self class context).	" ---------- statements ----------"
	self
		result:
			(PlatypusComplexInstance
				fromRecords:
					(OrderedCollection new
						add:
								(ExChdDtdElement new
										dtdElementFromValues:
												(OrderedCollection new
														add: self owner;
														add: nil;
														yourself);
										yourself);
						add:
								(ExChdAttributeDtdElement new
										attributeDtdElementFromValues:
												(OrderedCollection new
														add: self a;
														add: nil;
														yourself);
										yourself);
						yourself)) pltAsObject.
	self result
		domain:
			(ExChdComputeDomainDtdElementFunction
				invokeFromValues:
					(OrderedCollection new
						add: self result;
						add: self domain;
						yourself)).
	^ self return: self result

! !

!ExChdComputeAttributeDtdElementFunction methodsFor: 'platypus-generated-accessing' stamp: ''!
owner
	^ owner

! !

!ExChdComputeAttributeDtdElementFunction methodsFor: 'platypus-generated-accessing' stamp: ''!
owner: aExChdDtdElement
	owner := aExChdDtdElement

! !

!ExChdComputeAttributeDtdElementFunction methodsFor: 'platypus-generated-accessing' stamp: ''!
owner: aExChdDtdElement a: aExChdAttribute
	self owner: aExChdDtdElement.
	self a: aExChdAttribute

! !

!ExChdComputeAttributeDtdElementFunction methodsFor: 'platypus-generated-accessing' stamp: ''!
result
	^ result

! !

!ExChdComputeAttributeDtdElementFunction methodsFor: 'platypus-generated-accessing' stamp: ''!
result: aExChdAttributeDtdElement
	result := aExChdAttributeDtdElement

! !

PlatypusCoreAlgorithmDeclaration subclass: #ExChdComputeAttributeDtdListFromAttributeListFunction
	instanceVariableNames: 'owner attrs result'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Express2Cheddar-CheddarDtdSchema'!

!ExChdComputeAttributeDtdListFromAttributeListFunction commentStamp: 'platypus comment' prior: 0!
<ISO10303-11-EXPRESS>
FUNCTION compute_attribute_dtd_list_from_attribute_list ( owner : dtd_element; attrs : LIST OF explicit_attribute ) : LIST OF dtd_element;
	LOCAL 
		result : LIST OF dtd_element := [ ];
	END_LOCAL;

	REPEAT no := LOINDEX ( attrs ) TO HIINDEX ( attrs );

		ALIAS curr FOR attrs [ no];
			IF ( lowerize ( curr.name ) <> lowerize ( xml_id_name ) ) THEN
				result := result + compute_attribute_dtd_element ( owner, curr );
			END_IF;
		END_ALIAS;
	END_REPEAT;
	RETURN ( result );
END_FUNCTION;
</ISO10303-11-EXPRESS>!

!ExChdComputeAttributeDtdListFromAttributeListFunction class methodsFor: 'platypus-generated-platypus-signature' stamp: ''!
iso10303P11Translater
	^ 'Platypus (c) LISYC EA3883, Universite de Bretagne occidentale. Brest.'

! !

!ExChdComputeAttributeDtdListFromAttributeListFunction class methodsFor: 'platypus-generated-meta-data-accessing' stamp: ''!
schemaDefinition
	^ ExChdCheddarDtdSchemaDefinition singleton

! !

!ExChdComputeAttributeDtdListFromAttributeListFunction class methodsFor: 'platypus-generated-platypus-signature' stamp: ''!
translatedFromISO10303P11
	^ true

! !

!ExChdComputeAttributeDtdListFromAttributeListFunction class methodsFor: 'platypus-generated-platypus-signature' stamp: ''!
vwNamespaceName
	^ #Express2Cheddar

! !

!ExChdComputeAttributeDtdListFromAttributeListFunction methodsFor: 'platypus-generated-accessing' stamp: ''!
attrs
	^ attrs

! !

!ExChdComputeAttributeDtdListFromAttributeListFunction methodsFor: 'platypus-generated-accessing' stamp: ''!
attrs: aListOfExChdExplicitAttribute
	attrs := aListOfExChdExplicitAttribute
		ifNil: [ OrderedCollection new ]
		ifNotNil: [ aListOfExChdExplicitAttribute as: OrderedCollection ]

! !

!ExChdComputeAttributeDtdListFromAttributeListFunction methodsFor: 'platypus-generated-accessing' stamp: ''!
fromValues: values
	self owner: (values at: 1).
	self attrs: (values at: 2)

! !

!ExChdComputeAttributeDtdListFromAttributeListFunction methodsFor: 'platypus-generated-invoking' stamp: ''!
invoke
	" ---------- locals assignments ----------"

	self result: Array new.	" ---------- statements ----------"
	PlatypusCoreRepeatStatement
		repeat: [ :no1842 | 
			PlatypusCoreAliasStatement
				alias: (self attrs pltAt: no1842)
				statementsBlock: [ :curr3665 | 
					(PTsLowerizeFunction
						invokeFromValues:
							(OrderedCollection new
								add: (curr3665 nameUsingContext: self class context);
								yourself))
						~=
							(PTsLowerizeFunction
								invokeFromValues:
									(OrderedCollection new
										add: 'cheddar_private_id';
										yourself))
						ifTrue: [ 
							self
								result:
									(self result
										pltPlus:
											(ExChdComputeAttributeDtdElementFunction
												invokeFromValues:
													(OrderedCollection new
														add: self owner;
														add: curr3665;
														yourself))) ] ] ]
		from:
			(PltLOINDEXFunction
				invokeFromValues:
					(OrderedCollection new
						add: self attrs;
						yourself))
		to:
			(PltHIINDEXFunction
				invokeFromValues:
					(OrderedCollection new
						add: self attrs;
						yourself)).
	^ self return: self result

! !

!ExChdComputeAttributeDtdListFromAttributeListFunction methodsFor: 'platypus-generated-accessing' stamp: ''!
owner
	^ owner

! !

!ExChdComputeAttributeDtdListFromAttributeListFunction methodsFor: 'platypus-generated-accessing' stamp: ''!
owner: aExChdDtdElement
	owner := aExChdDtdElement

! !

!ExChdComputeAttributeDtdListFromAttributeListFunction methodsFor: 'platypus-generated-accessing' stamp: ''!
owner: aExChdDtdElement attrs: aListOfExChdExplicitAttribute
	self owner: aExChdDtdElement.
	self attrs: aListOfExChdExplicitAttribute

! !

!ExChdComputeAttributeDtdListFromAttributeListFunction methodsFor: 'platypus-generated-accessing' stamp: ''!
result
	^ result

! !

!ExChdComputeAttributeDtdListFromAttributeListFunction methodsFor: 'platypus-generated-accessing' stamp: ''!
result: aListOfExChdDtdElement
	result := aListOfExChdDtdElement
		ifNil: [ OrderedCollection new ]
		ifNotNil: [ aListOfExChdDtdElement as: OrderedCollection ]

! !

PlatypusCoreAlgorithmDeclaration subclass: #ExChdComputeDiscriminatedTypeCodeFunction
	instanceVariableNames: 'ent s l subs'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Express2Cheddar-CheddarDtdSchema'!

!ExChdComputeDiscriminatedTypeCodeFunction commentStamp: 'platypus comment' prior: 0!
<ISO10303-11-EXPRESS>
FUNCTION compute_discriminated_type_code ( ent : discriminated_type_dtd_element ) : STRING;
	LOCAL 
		s : STRING := '';
		l : LIST OF STRING := [ ];
		subs : LIST OF dtd_element := ent.subs;
	END_LOCAL;

	REPEAT no := LOINDEX ( subs ) TO HIINDEX ( subs );

		ALIAS curr FOR subs [ no];
			l := l + curr.tag;
		END_ALIAS;
	END_REPEAT;
	s := '<!!ELEMENT ' + ent.tag + ' (' + StringAggregateConcatSeparatedBy ( l, ' | ' ) + ')*>\n';
	RETURN ( s );
END_FUNCTION;
</ISO10303-11-EXPRESS>!

!ExChdComputeDiscriminatedTypeCodeFunction class methodsFor: 'platypus-generated-platypus-signature' stamp: ''!
iso10303P11Translater
	^ 'Platypus (c) LISYC EA3883, Universite de Bretagne occidentale. Brest.'

! !

!ExChdComputeDiscriminatedTypeCodeFunction class methodsFor: 'platypus-generated-meta-data-accessing' stamp: ''!
schemaDefinition
	^ ExChdCheddarDtdSchemaDefinition singleton

! !

!ExChdComputeDiscriminatedTypeCodeFunction class methodsFor: 'platypus-generated-platypus-signature' stamp: ''!
translatedFromISO10303P11
	^ true

! !

!ExChdComputeDiscriminatedTypeCodeFunction class methodsFor: 'platypus-generated-platypus-signature' stamp: ''!
vwNamespaceName
	^ #Express2Cheddar

! !

!ExChdComputeDiscriminatedTypeCodeFunction methodsFor: 'platypus-generated-accessing' stamp: ''!
ent
	^ ent

! !

!ExChdComputeDiscriminatedTypeCodeFunction methodsFor: 'platypus-generated-accessing' stamp: ''!
ent: aExChdDiscriminatedTypeDtdElement
	ent := aExChdDiscriminatedTypeDtdElement

! !

!ExChdComputeDiscriminatedTypeCodeFunction methodsFor: 'platypus-generated-accessing' stamp: ''!
fromValues: values
	self ent: (values at: 1)

! !

!ExChdComputeDiscriminatedTypeCodeFunction methodsFor: 'platypus-generated-invoking' stamp: ''!
invoke
	" ---------- locals assignments ----------"

	self s: ''.
	self l: Array new.
	self subs: (self ent subsUsingContext: self class context).	" ---------- statements ----------"
	PlatypusCoreRepeatStatement
		repeat: [ :no3169 | 
			PlatypusCoreAliasStatement
				alias: (self subs pltAt: no3169)
				statementsBlock: [ :curr892 | self l: (self l pltPlus: (curr892 tagUsingContext: self class context)) ] ]
		from:
			(PltLOINDEXFunction
				invokeFromValues:
					(OrderedCollection new
						add: self subs;
						yourself))
		to:
			(PltHIINDEXFunction
				invokeFromValues:
					(OrderedCollection new
						add: self subs;
						yourself)).
	self
		s:
			(((('<!!ELEMENT ' pltPlus: (self ent tagUsingContext: self class context)) pltPlus: ' (')
				pltPlus:
					(PTsStringAggregateConcatSeparatedByFunction
						invokeFromValues:
							(OrderedCollection new
								add: self l;
								add: ' | ';
								yourself))) pltPlus: ')*>\n').
	^ self return: self s

! !

!ExChdComputeDiscriminatedTypeCodeFunction methodsFor: 'platypus-generated-accessing' stamp: ''!
l
	^ l

! !

!ExChdComputeDiscriminatedTypeCodeFunction methodsFor: 'platypus-generated-accessing' stamp: ''!
l: aListOfString
	l := aListOfString ifNil: [ OrderedCollection new ] ifNotNil: [ aListOfString as: OrderedCollection ]

! !

!ExChdComputeDiscriminatedTypeCodeFunction methodsFor: 'platypus-generated-accessing' stamp: ''!
s
	^ s

! !

!ExChdComputeDiscriminatedTypeCodeFunction methodsFor: 'platypus-generated-accessing' stamp: ''!
s: aString
	s := aString

! !

!ExChdComputeDiscriminatedTypeCodeFunction methodsFor: 'platypus-generated-accessing' stamp: ''!
subs
	^ subs

! !

!ExChdComputeDiscriminatedTypeCodeFunction methodsFor: 'platypus-generated-accessing' stamp: ''!
subs: aListOfExChdDtdElement
	subs := aListOfExChdDtdElement
		ifNil: [ OrderedCollection new ]
		ifNotNil: [ aListOfExChdDtdElement as: OrderedCollection ]

! !

PlatypusCoreAlgorithmDeclaration subclass: #ExChdComputeDiscriminatedTypeSubElementsFunction
	instanceVariableNames: 'e attrs result'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Express2Cheddar-CheddarDtdSchema'!

!ExChdComputeDiscriminatedTypeSubElementsFunction commentStamp: 'platypus comment' prior: 0!
<ISO10303-11-EXPRESS>
FUNCTION compute_discriminated_type_sub_elements ( e : discriminated_type_dtd_element ) : LIST OF dtd_element;
	LOCAL 
		attrs : LIST OF explicit_attribute := discriminated_type_attributes ( e.domain );
		result : LIST OF dtd_element := compute_attribute_dtd_list_from_attribute_list ( e, attrs );
	END_LOCAL;
	RETURN ( result );
END_FUNCTION;
</ISO10303-11-EXPRESS>!

!ExChdComputeDiscriminatedTypeSubElementsFunction class methodsFor: 'platypus-generated-platypus-signature' stamp: ''!
iso10303P11Translater
	^ 'Platypus (c) LISYC EA3883, Universite de Bretagne occidentale. Brest.'

! !

!ExChdComputeDiscriminatedTypeSubElementsFunction class methodsFor: 'platypus-generated-meta-data-accessing' stamp: ''!
schemaDefinition
	^ ExChdCheddarDtdSchemaDefinition singleton

! !

!ExChdComputeDiscriminatedTypeSubElementsFunction class methodsFor: 'platypus-generated-platypus-signature' stamp: ''!
translatedFromISO10303P11
	^ true

! !

!ExChdComputeDiscriminatedTypeSubElementsFunction class methodsFor: 'platypus-generated-platypus-signature' stamp: ''!
vwNamespaceName
	^ #Express2Cheddar

! !

!ExChdComputeDiscriminatedTypeSubElementsFunction methodsFor: 'platypus-generated-accessing' stamp: ''!
attrs
	^ attrs

! !

!ExChdComputeDiscriminatedTypeSubElementsFunction methodsFor: 'platypus-generated-accessing' stamp: ''!
attrs: aListOfExChdExplicitAttribute
	attrs := aListOfExChdExplicitAttribute
		ifNil: [ OrderedCollection new ]
		ifNotNil: [ aListOfExChdExplicitAttribute as: OrderedCollection ]

! !

!ExChdComputeDiscriminatedTypeSubElementsFunction methodsFor: 'platypus-generated-accessing' stamp: ''!
e
	^ e

! !

!ExChdComputeDiscriminatedTypeSubElementsFunction methodsFor: 'platypus-generated-accessing' stamp: ''!
e: aExChdDiscriminatedTypeDtdElement
	e := aExChdDiscriminatedTypeDtdElement

! !

!ExChdComputeDiscriminatedTypeSubElementsFunction methodsFor: 'platypus-generated-accessing' stamp: ''!
fromValues: values
	self e: (values at: 1)

! !

!ExChdComputeDiscriminatedTypeSubElementsFunction methodsFor: 'platypus-generated-invoking' stamp: ''!
invoke
	" ---------- locals assignments ----------"

	self
		attrs:
			(ExChdDiscriminatedTypeAttributesFunction
				invokeFromValues:
					(OrderedCollection new
						add: (self e domainUsingContext: self class context);
						yourself)).
	self
		result:
			(ExChdComputeAttributeDtdListFromAttributeListFunction
				invokeFromValues:
					(OrderedCollection new
						add: self e;
						add: self attrs;
						yourself)).	" ---------- statements ----------"
	^ self return: self result

! !

!ExChdComputeDiscriminatedTypeSubElementsFunction methodsFor: 'platypus-generated-accessing' stamp: ''!
result
	^ result

! !

!ExChdComputeDiscriminatedTypeSubElementsFunction methodsFor: 'platypus-generated-accessing' stamp: ''!
result: aListOfExChdDtdElement
	result := aListOfExChdDtdElement
		ifNil: [ OrderedCollection new ]
		ifNotNil: [ aListOfExChdDtdElement as: OrderedCollection ]

! !

PlatypusCoreAlgorithmDeclaration subclass: #ExChdComputeDomainDtdElementFunction
	instanceVariableNames: 'owner domain subDomain elementDomain result'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Express2Cheddar-CheddarDtdSchema'!

!ExChdComputeDomainDtdElementFunction commentStamp: 'platypus comment' prior: 0!
<ISO10303-11-EXPRESS>
FUNCTION compute_domain_dtd_element ( owner : dtd_element; domain : entity_instance ) : domain_dtd_element;
	LOCAL 
		sub_domain : entity_instance;
		element_domain : entity_instance;
		result : domain_dtd_element;
	END_LOCAL;

	IF ( 'PLATYPUS_DICTIONARY_SCHEMA.DICTIONARY_INSTANCE_REFERENCE' IN TYPEOF ( domain ) ) THEN
		RETURN ( compute_domain_dtd_element ( owner, domain.ref ) );
	ELSE

		IF ( 'CHEDDAR_DOMAINS.ADA_PRIMITIVE_TYPE' IN TYPEOF ( domain ) ) THEN
			RETURN ( simple_domain_dtd_element ( ) || dtd_element ( owner, ? ) || domain_dtd_element ( domain ) );
		ELSE
			IF ( 'CHEDDAR_DOMAINS.ADA_ENUMERATION' IN TYPEOF ( domain ) ) THEN
				RETURN ( simple_domain_dtd_element ( ) || dtd_element ( owner, ? ) || domain_dtd_element ( domain ) );
			ELSE
				IF ( 'CHEDDAR_DOMAINS.CHEDDAR_PRIORITY_RANGE' IN TYPEOF ( domain ) ) THEN
					RETURN ( simple_domain_dtd_element ( ) || dtd_element ( owner, ? ) || domain_dtd_element ( domain ) );
				ELSE
					IF ( 'RECORD_AND_CLASS.RECORD' IN TYPEOF ( domain ) ) THEN
						RETURN ( record_ref_dtd_element ( ) || entity_ref_dtd_element ( ) || dtd_element ( owner, ? ) || domain_dtd_element ( domain ) );
					ELSE
						IF ( 'DISCRIMINATED_TYPE.DISCRIMINATED_TYPE' IN TYPEOF ( domain ) ) THEN
							RETURN ( discriminated_type_ref_dtd_element ( ) || entity_ref_dtd_element ( ) || dtd_element ( owner, ? ) || domain_dtd_element ( domain ) );
						ELSE
							IF ( 'RECORD_AND_CLASS.ADA_CLASS' IN TYPEOF ( domain ) ) THEN
								RETURN ( ada_class_ref_dtd_element ( ) || entity_ref_dtd_element ( ) || dtd_element ( owner, ? ) || domain_dtd_element ( domain ) );
							ELSE
								IF ( 'PLATYPUS_DICTIONARY_SCHEMA.DEFINED_TYPE' IN TYPEOF ( domain ) ) THEN
									sub_domain := basic_ada_domain ( domain.domain );
									IF ( 'PLATYPUS_DICTIONARY_SCHEMA.AGGREGATION_TYPE' IN TYPEOF ( sub_domain ) ) THEN
										element_domain := basic_ada_domain ( sub_domain.element_type );
										result := collection_dtd_element ( ? ) || dtd_element ( owner, ? ) || domain_dtd_element ( domain );
										result.element_domain := compute_domain_dtd_element ( result, element_domain );
										RETURN ( result );
									END_IF;
								END_IF;
							END_IF;
						END_IF;
					END_IF;
				END_IF;
			END_IF;
		END_IF;
	END_IF;
	println ( domain );
	RETURN ( unknown_domain_dtd_element ( ) || dtd_element ( owner, ? ) || domain_dtd_element ( domain ) );
END_FUNCTION;
</ISO10303-11-EXPRESS>!

!ExChdComputeDomainDtdElementFunction class methodsFor: 'platypus-generated-platypus-signature' stamp: ''!
iso10303P11Translater
	^ 'Platypus (c) LISYC EA3883, Universite de Bretagne occidentale. Brest.'

! !

!ExChdComputeDomainDtdElementFunction class methodsFor: 'platypus-generated-meta-data-accessing' stamp: ''!
schemaDefinition
	^ ExChdCheddarDtdSchemaDefinition singleton

! !

!ExChdComputeDomainDtdElementFunction class methodsFor: 'platypus-generated-platypus-signature' stamp: ''!
translatedFromISO10303P11
	^ true

! !

!ExChdComputeDomainDtdElementFunction class methodsFor: 'platypus-generated-platypus-signature' stamp: ''!
vwNamespaceName
	^ #Express2Cheddar

! !

!ExChdComputeDomainDtdElementFunction methodsFor: 'platypus-generated-accessing' stamp: ''!
domain
	^ domain

! !

!ExChdComputeDomainDtdElementFunction methodsFor: 'platypus-generated-accessing' stamp: ''!
domain: aExChdEntityInstance
	domain := aExChdEntityInstance

! !

!ExChdComputeDomainDtdElementFunction methodsFor: 'platypus-generated-accessing' stamp: ''!
elementDomain
	^ elementDomain

! !

!ExChdComputeDomainDtdElementFunction methodsFor: 'platypus-generated-accessing' stamp: ''!
elementDomain: aExChdEntityInstance1
	elementDomain := aExChdEntityInstance1

! !

!ExChdComputeDomainDtdElementFunction methodsFor: 'platypus-generated-accessing' stamp: ''!
fromValues: values
	self owner: (values at: 1).
	self domain: (values at: 2)

! !

!ExChdComputeDomainDtdElementFunction methodsFor: 'platypus-generated-invoking' stamp: ''!
invoke
	" ---------- locals assignments ----------"

	" ---------- statements ----------"

	((PltTYPEOFFunction
		invokeFromValues:
			(OrderedCollection new
				add: self domain;
				yourself)) includes: 'PLATYPUS_DICTIONARY_SCHEMA.DICTIONARY_INSTANCE_REFERENCE')
		ifTrue: [ 
			^ self
				return:
					(ExChdComputeDomainDtdElementFunction
						invokeFromValues:
							(OrderedCollection new
								add: self owner;
								add: (self domain refUsingContext: self class context);
								yourself)) ]
		ifFalse: [ 
			((PltTYPEOFFunction
				invokeFromValues:
					(OrderedCollection new
						add: self domain;
						yourself)) includes: 'CHEDDAR_DOMAINS.ADA_PRIMITIVE_TYPE')
				ifTrue: [ 
					^ self
						return:
							(PlatypusComplexInstance
								fromRecords:
									(OrderedCollection new
										add:
												(PlatypusComplexInstance
														fromRecords:
															(OrderedCollection new
																add: ExChdSimpleDomainDtdElement new;
																add:
																		(ExChdDtdElement new
																				dtdElementFromValues:
																						(OrderedCollection new
																								add: self owner;
																								add: nil;
																								yourself);
																				yourself);
																yourself)) pltAsObject;
										add:
												(ExChdDomainDtdElement new
														domainDtdElementFromValues:
																(OrderedCollection new
																		add: self domain;
																		yourself);
														yourself);
										yourself)) pltAsObject ]
				ifFalse: [ 
					((PltTYPEOFFunction
						invokeFromValues:
							(OrderedCollection new
								add: self domain;
								yourself)) includes: 'CHEDDAR_DOMAINS.ADA_ENUMERATION')
						ifTrue: [ 
							^ self
								return:
									(PlatypusComplexInstance
										fromRecords:
											(OrderedCollection new
												add:
														(PlatypusComplexInstance
																fromRecords:
																	(OrderedCollection new
																		add: ExChdSimpleDomainDtdElement new;
																		add:
																				(ExChdDtdElement new
																						dtdElementFromValues:
																								(OrderedCollection new
																										add: self owner;
																										add: nil;
																										yourself);
																						yourself);
																		yourself)) pltAsObject;
												add:
														(ExChdDomainDtdElement new
																domainDtdElementFromValues:
																		(OrderedCollection new
																				add: self domain;
																				yourself);
																yourself);
												yourself)) pltAsObject ]
						ifFalse: [ 
							((PltTYPEOFFunction
								invokeFromValues:
									(OrderedCollection new
										add: self domain;
										yourself)) includes: 'CHEDDAR_DOMAINS.CHEDDAR_PRIORITY_RANGE')
								ifTrue: [ 
									^ self
										return:
											(PlatypusComplexInstance
												fromRecords:
													(OrderedCollection new
														add:
																(PlatypusComplexInstance
																		fromRecords:
																			(OrderedCollection new
																				add: ExChdSimpleDomainDtdElement new;
																				add:
																						(ExChdDtdElement new
																								dtdElementFromValues:
																										(OrderedCollection new
																												add: self owner;
																												add: nil;
																												yourself);
																								yourself);
																				yourself)) pltAsObject;
														add:
																(ExChdDomainDtdElement new
																		domainDtdElementFromValues:
																				(OrderedCollection new
																						add: self domain;
																						yourself);
																		yourself);
														yourself)) pltAsObject ]
								ifFalse: [ 
									((PltTYPEOFFunction
										invokeFromValues:
											(OrderedCollection new
												add: self domain;
												yourself)) includes: 'RECORD_AND_CLASS.RECORD')
										ifTrue: [ 
											^ self
												return:
													(PlatypusComplexInstance
														fromRecords:
															(OrderedCollection new
																add:
																		(PlatypusComplexInstance
																				fromRecords:
																					(OrderedCollection new
																						add:
																								(PlatypusComplexInstance
																										fromRecords:
																											(OrderedCollection new
																												add: ExChdRecordRefDtdElement new;
																												add: ExChdEntityRefDtdElement new;
																												yourself)) pltAsObject;
																						add:
																								(ExChdDtdElement new
																										dtdElementFromValues:
																												(OrderedCollection new
																														add: self owner;
																														add: nil;
																														yourself);
																										yourself);
																						yourself)) pltAsObject;
																add:
																		(ExChdDomainDtdElement new
																				domainDtdElementFromValues:
																						(OrderedCollection new
																								add: self domain;
																								yourself);
																				yourself);
																yourself)) pltAsObject ]
										ifFalse: [ 
											((PltTYPEOFFunction
												invokeFromValues:
													(OrderedCollection new
														add: self domain;
														yourself)) includes: 'DISCRIMINATED_TYPE.DISCRIMINATED_TYPE')
												ifTrue: [ 
													^ self
														return:
															(PlatypusComplexInstance
																fromRecords:
																	(OrderedCollection new
																		add:
																				(PlatypusComplexInstance
																						fromRecords:
																							(OrderedCollection new
																								add:
																										(PlatypusComplexInstance
																												fromRecords:
																													(OrderedCollection new
																														add: ExChdDiscriminatedTypeRefDtdElement new;
																														add: ExChdEntityRefDtdElement new;
																														yourself)) pltAsObject;
																								add:
																										(ExChdDtdElement new
																												dtdElementFromValues:
																														(OrderedCollection new
																																add: self owner;
																																add: nil;
																																yourself);
																												yourself);
																								yourself)) pltAsObject;
																		add:
																				(ExChdDomainDtdElement new
																						domainDtdElementFromValues:
																								(OrderedCollection new
																										add: self domain;
																										yourself);
																						yourself);
																		yourself)) pltAsObject ]
												ifFalse: [ 
													((PltTYPEOFFunction
														invokeFromValues:
															(OrderedCollection new
																add: self domain;
																yourself)) includes: 'RECORD_AND_CLASS.ADA_CLASS')
														ifTrue: [ 
															^ self
																return:
																	(PlatypusComplexInstance
																		fromRecords:
																			(OrderedCollection new
																				add:
																						(PlatypusComplexInstance
																								fromRecords:
																									(OrderedCollection new
																										add:
																												(PlatypusComplexInstance
																														fromRecords:
																															(OrderedCollection new
																																add: ExChdAdaClassRefDtdElement new;
																																add: ExChdEntityRefDtdElement new;
																																yourself)) pltAsObject;
																										add:
																												(ExChdDtdElement new
																														dtdElementFromValues:
																																(OrderedCollection new
																																		add: self owner;
																																		add: nil;
																																		yourself);
																														yourself);
																										yourself)) pltAsObject;
																				add:
																						(ExChdDomainDtdElement new
																								domainDtdElementFromValues:
																										(OrderedCollection new
																												add: self domain;
																												yourself);
																								yourself);
																				yourself)) pltAsObject ]
														ifFalse: [ 
															((PltTYPEOFFunction
																invokeFromValues:
																	(OrderedCollection new
																		add: self domain;
																		yourself)) includes: 'PLATYPUS_DICTIONARY_SCHEMA.DEFINED_TYPE')
																ifTrue: [ 
																	self
																		subDomain:
																			(ExChdBasicAdaDomainFunction
																				invokeFromValues:
																					(OrderedCollection new
																						add: (self domain domainUsingContext: self class context);
																						yourself)).
																	((PltTYPEOFFunction
																		invokeFromValues:
																			(OrderedCollection new
																				add: self subDomain;
																				yourself)) includes: 'PLATYPUS_DICTIONARY_SCHEMA.AGGREGATION_TYPE')
																		ifTrue: [ 
																			self
																				elementDomain:
																					(ExChdBasicAdaDomainFunction
																						invokeFromValues:
																							(OrderedCollection new
																								add: (self subDomain elementTypeUsingContext: self class context);
																								yourself)).
																			self
																				result:
																					(PlatypusComplexInstance
																						fromRecords:
																							(OrderedCollection new
																								add:
																										(PlatypusComplexInstance
																												fromRecords:
																													(OrderedCollection new
																														add:
																																(ExChdCollectionDtdElement new
																																		collectionDtdElementFromValues:
																																				(OrderedCollection new
																																						add: nil;
																																						yourself);
																																		yourself);
																														add:
																																(ExChdDtdElement new
																																		dtdElementFromValues:
																																				(OrderedCollection new
																																						add: self owner;
																																						add: nil;
																																						yourself);
																																		yourself);
																														yourself)) pltAsObject;
																								add:
																										(ExChdDomainDtdElement new
																												domainDtdElementFromValues:
																														(OrderedCollection new
																																add: self domain;
																																yourself);
																												yourself);
																								yourself)) pltAsObject.
																			self result
																				elementDomain:
																					(ExChdComputeDomainDtdElementFunction
																						invokeFromValues:
																							(OrderedCollection new
																								add: self result;
																								add: self elementDomain;
																								yourself)).
																			^ self return: self result ] ] ] ] ] ] ] ] ].
	PTsPrintLnProcedure
		invokeFromValues:
			(OrderedCollection new
				add: self domain;
				yourself).
	^ self
		return:
			(PlatypusComplexInstance
				fromRecords:
					(OrderedCollection new
						add:
								(PlatypusComplexInstance
										fromRecords:
											(OrderedCollection new
												add: ExChdUnknownDomainDtdElement new;
												add:
														(ExChdDtdElement new
																dtdElementFromValues:
																		(OrderedCollection new
																				add: self owner;
																				add: nil;
																				yourself);
																yourself);
												yourself)) pltAsObject;
						add:
								(ExChdDomainDtdElement new
										domainDtdElementFromValues:
												(OrderedCollection new
														add: self domain;
														yourself);
										yourself);
						yourself)) pltAsObject

! !

!ExChdComputeDomainDtdElementFunction methodsFor: 'platypus-generated-accessing' stamp: ''!
owner
	^ owner

! !

!ExChdComputeDomainDtdElementFunction methodsFor: 'platypus-generated-accessing' stamp: ''!
owner: aExChdDtdElement
	owner := aExChdDtdElement

! !

!ExChdComputeDomainDtdElementFunction methodsFor: 'platypus-generated-accessing' stamp: ''!
owner: aExChdDtdElement domain: aExChdEntityInstance
	self owner: aExChdDtdElement.
	self domain: aExChdEntityInstance

! !

!ExChdComputeDomainDtdElementFunction methodsFor: 'platypus-generated-accessing' stamp: ''!
result
	^ result

! !

!ExChdComputeDomainDtdElementFunction methodsFor: 'platypus-generated-accessing' stamp: ''!
result: aExChdDomainDtdElement
	result := aExChdDomainDtdElement

! !

!ExChdComputeDomainDtdElementFunction methodsFor: 'platypus-generated-accessing' stamp: ''!
subDomain
	^ subDomain

! !

!ExChdComputeDomainDtdElementFunction methodsFor: 'platypus-generated-accessing' stamp: ''!
subDomain: aExChdEntityInstance
	subDomain := aExChdEntityInstance

! !

PlatypusCoreAlgorithmDeclaration subclass: #ExChdComputeEntityDtdCodeFunction
	instanceVariableNames: 'ent s l subs'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Express2Cheddar-CheddarDtdSchema'!

!ExChdComputeEntityDtdCodeFunction commentStamp: 'platypus comment' prior: 0!
<ISO10303-11-EXPRESS>
FUNCTION compute_entity_dtd_code ( ent : entity_dtd_element ) : STRING;
	LOCAL 
		s : STRING := '';
		l : LIST OF STRING := [ ];
		subs : LIST OF dtd_element := ent.subs;
	END_LOCAL;

	REPEAT no := LOINDEX ( subs ) TO HIINDEX ( subs );

		ALIAS curr FOR subs [ no];
			l := l + curr.tag;
		END_ALIAS;
	END_REPEAT;
	s := '<!!ELEMENT ' + ent.tag + ' (' + StringAggregateConcatSeparatedBy ( l, ' | ' ) + ')*>\n';

	IF ( 'RECORD_AND_CLASS.ADA_CLASS' IN TYPEOF ( ent.domain ) ) THEN
		s := s + '<!!ATTLIST ' + ent.tag + ' id ID #REQUIRED>\n';
	END_IF;
	RETURN ( s );
END_FUNCTION;
</ISO10303-11-EXPRESS>!

!ExChdComputeEntityDtdCodeFunction class methodsFor: 'platypus-generated-platypus-signature' stamp: ''!
iso10303P11Translater
	^ 'Platypus (c) LISYC EA3883, Universite de Bretagne occidentale. Brest.'

! !

!ExChdComputeEntityDtdCodeFunction class methodsFor: 'platypus-generated-meta-data-accessing' stamp: ''!
schemaDefinition
	^ ExChdCheddarDtdSchemaDefinition singleton

! !

!ExChdComputeEntityDtdCodeFunction class methodsFor: 'platypus-generated-platypus-signature' stamp: ''!
translatedFromISO10303P11
	^ true

! !

!ExChdComputeEntityDtdCodeFunction class methodsFor: 'platypus-generated-platypus-signature' stamp: ''!
vwNamespaceName
	^ #Express2Cheddar

! !

!ExChdComputeEntityDtdCodeFunction methodsFor: 'platypus-generated-accessing' stamp: ''!
ent
	^ ent

! !

!ExChdComputeEntityDtdCodeFunction methodsFor: 'platypus-generated-accessing' stamp: ''!
ent: aExChdEntityDtdElement
	ent := aExChdEntityDtdElement

! !

!ExChdComputeEntityDtdCodeFunction methodsFor: 'platypus-generated-accessing' stamp: ''!
fromValues: values
	self ent: (values at: 1)

! !

!ExChdComputeEntityDtdCodeFunction methodsFor: 'platypus-generated-invoking' stamp: ''!
invoke
	" ---------- locals assignments ----------"

	self s: ''.
	self l: Array new.
	self subs: (self ent subsUsingContext: self class context).	" ---------- statements ----------"
	PlatypusCoreRepeatStatement
		repeat: [ :no953 | 
			PlatypusCoreAliasStatement
				alias: (self subs pltAt: no953)
				statementsBlock: [ :curr2772 | self l: (self l pltPlus: (curr2772 tagUsingContext: self class context)) ] ]
		from:
			(PltLOINDEXFunction
				invokeFromValues:
					(OrderedCollection new
						add: self subs;
						yourself))
		to:
			(PltHIINDEXFunction
				invokeFromValues:
					(OrderedCollection new
						add: self subs;
						yourself)).
	self
		s:
			(((('<!!ELEMENT ' pltPlus: (self ent tagUsingContext: self class context)) pltPlus: ' (')
				pltPlus:
					(PTsStringAggregateConcatSeparatedByFunction
						invokeFromValues:
							(OrderedCollection new
								add: self l;
								add: ' | ';
								yourself))) pltPlus: ')*>\n').
	((PltTYPEOFFunction
		invokeFromValues:
			(OrderedCollection new
				add: (self ent domainUsingContext: self class context);
				yourself)) includes: 'RECORD_AND_CLASS.ADA_CLASS')
		ifTrue: [ 
			self
				s:
					(((self s pltPlus: '<!!ATTLIST ') pltPlus: (self ent tagUsingContext: self class context))
						pltPlus: ' id ID #REQUIRED>\n') ].
	^ self return: self s

! !

!ExChdComputeEntityDtdCodeFunction methodsFor: 'platypus-generated-accessing' stamp: ''!
l
	^ l

! !

!ExChdComputeEntityDtdCodeFunction methodsFor: 'platypus-generated-accessing' stamp: ''!
l: aListOfString
	l := aListOfString ifNil: [ OrderedCollection new ] ifNotNil: [ aListOfString as: OrderedCollection ]

! !

!ExChdComputeEntityDtdCodeFunction methodsFor: 'platypus-generated-accessing' stamp: ''!
s
	^ s

! !

!ExChdComputeEntityDtdCodeFunction methodsFor: 'platypus-generated-accessing' stamp: ''!
s: aString
	s := aString

! !

!ExChdComputeEntityDtdCodeFunction methodsFor: 'platypus-generated-accessing' stamp: ''!
subs
	^ subs

! !

!ExChdComputeEntityDtdCodeFunction methodsFor: 'platypus-generated-accessing' stamp: ''!
subs: aListOfExChdDtdElement
	subs := aListOfExChdDtdElement
		ifNil: [ OrderedCollection new ]
		ifNotNil: [ aListOfExChdDtdElement as: OrderedCollection ]

! !

PlatypusCoreAlgorithmDeclaration subclass: #ExChdComputeEntitySubElementsFunction
	instanceVariableNames: 'e attrs result'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Express2Cheddar-CheddarDtdSchema'!

!ExChdComputeEntitySubElementsFunction commentStamp: 'platypus comment' prior: 0!
<ISO10303-11-EXPRESS>
FUNCTION compute_entity_sub_elements ( e : entity_dtd_element ) : LIST OF dtd_element;
	LOCAL 
		attrs : LIST OF explicit_attribute := inherited_explicit_attributes ( e.domain );
		result : LIST OF dtd_element := compute_attribute_dtd_list_from_attribute_list ( e, attrs );
	END_LOCAL;
	RETURN ( result );
END_FUNCTION;
</ISO10303-11-EXPRESS>!

!ExChdComputeEntitySubElementsFunction class methodsFor: 'platypus-generated-platypus-signature' stamp: ''!
iso10303P11Translater
	^ 'Platypus (c) LISYC EA3883, Universite de Bretagne occidentale. Brest.'

! !

!ExChdComputeEntitySubElementsFunction class methodsFor: 'platypus-generated-meta-data-accessing' stamp: ''!
schemaDefinition
	^ ExChdCheddarDtdSchemaDefinition singleton

! !

!ExChdComputeEntitySubElementsFunction class methodsFor: 'platypus-generated-platypus-signature' stamp: ''!
translatedFromISO10303P11
	^ true

! !

!ExChdComputeEntitySubElementsFunction class methodsFor: 'platypus-generated-platypus-signature' stamp: ''!
vwNamespaceName
	^ #Express2Cheddar

! !

!ExChdComputeEntitySubElementsFunction methodsFor: 'platypus-generated-accessing' stamp: ''!
attrs
	^ attrs

! !

!ExChdComputeEntitySubElementsFunction methodsFor: 'platypus-generated-accessing' stamp: ''!
attrs: aListOfExChdExplicitAttribute
	attrs := aListOfExChdExplicitAttribute
		ifNil: [ OrderedCollection new ]
		ifNotNil: [ aListOfExChdExplicitAttribute as: OrderedCollection ]

! !

!ExChdComputeEntitySubElementsFunction methodsFor: 'platypus-generated-accessing' stamp: ''!
e
	^ e

! !

!ExChdComputeEntitySubElementsFunction methodsFor: 'platypus-generated-accessing' stamp: ''!
e: aExChdEntityDtdElement
	e := aExChdEntityDtdElement

! !

!ExChdComputeEntitySubElementsFunction methodsFor: 'platypus-generated-accessing' stamp: ''!
fromValues: values
	self e: (values at: 1)

! !

!ExChdComputeEntitySubElementsFunction methodsFor: 'platypus-generated-invoking' stamp: ''!
invoke
	" ---------- locals assignments ----------"

	self
		attrs:
			(PTsInheritedExplicitAttributesFunction
				invokeFromValues:
					(OrderedCollection new
						add: (self e domainUsingContext: self class context);
						yourself)).
	self
		result:
			(ExChdComputeAttributeDtdListFromAttributeListFunction
				invokeFromValues:
					(OrderedCollection new
						add: self e;
						add: self attrs;
						yourself)).	" ---------- statements ----------"
	^ self return: self result

! !

!ExChdComputeEntitySubElementsFunction methodsFor: 'platypus-generated-accessing' stamp: ''!
result
	^ result

! !

!ExChdComputeEntitySubElementsFunction methodsFor: 'platypus-generated-accessing' stamp: ''!
result: aListOfExChdDtdElement
	result := aListOfExChdDtdElement
		ifNil: [ OrderedCollection new ]
		ifNotNil: [ aListOfExChdDtdElement as: OrderedCollection ]

! !

PlatypusCoreAlgorithmDeclaration subclass: #ExChdComputeImplicitDomainsFunction
	instanceVariableNames: 'r refed decl declDomain notDeclared'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Express2Cheddar-CheddarDtdSchema'!

!ExChdComputeImplicitDomainsFunction commentStamp: 'platypus comment' prior: 0!
<ISO10303-11-EXPRESS>
FUNCTION compute_implicit_domains ( r : root_dtd_element ) : LIST OF entity_ref_dtd_element;
	LOCAL 
		refed : LIST OF entity_ref_dtd_element := r.referenced_entities;
		decl : LIST OF dtd_element := r.declared_domains;
		decl_domain : LIST OF entity_instance := [ ];
		not_declared : LIST OF entity_ref_dtd_element := [ ];
	END_LOCAL;

	REPEAT no := LOINDEX ( decl ) TO HIINDEX ( decl );

		ALIAS curr FOR decl [ no];
			decl_domain := decl_domain + curr.domain;
		END_ALIAS;
	END_REPEAT;

	REPEAT no := LOINDEX ( refed ) TO HIINDEX ( refed );

		ALIAS curr FOR refed [ no];
			IF NOT ( curr.domain IN decl_domain ) AND NOT ( curr IN not_declared ) THEN
				not_declared := not_declared + curr;
			END_IF;
		END_ALIAS;
	END_REPEAT;
	RETURN ( not_declared );
END_FUNCTION;
</ISO10303-11-EXPRESS>!

!ExChdComputeImplicitDomainsFunction class methodsFor: 'platypus-generated-platypus-signature' stamp: ''!
iso10303P11Translater
	^ 'Platypus (c) LISYC EA3883, Universite de Bretagne occidentale. Brest.'

! !

!ExChdComputeImplicitDomainsFunction class methodsFor: 'platypus-generated-meta-data-accessing' stamp: ''!
schemaDefinition
	^ ExChdCheddarDtdSchemaDefinition singleton

! !

!ExChdComputeImplicitDomainsFunction class methodsFor: 'platypus-generated-platypus-signature' stamp: ''!
translatedFromISO10303P11
	^ true

! !

!ExChdComputeImplicitDomainsFunction class methodsFor: 'platypus-generated-platypus-signature' stamp: ''!
vwNamespaceName
	^ #Express2Cheddar

! !

!ExChdComputeImplicitDomainsFunction methodsFor: 'platypus-generated-accessing' stamp: ''!
decl
	^ decl

! !

!ExChdComputeImplicitDomainsFunction methodsFor: 'platypus-generated-accessing' stamp: ''!
decl: aListOfExChdDtdElement
	decl := aListOfExChdDtdElement
		ifNil: [ OrderedCollection new ]
		ifNotNil: [ aListOfExChdDtdElement as: OrderedCollection ]

! !

!ExChdComputeImplicitDomainsFunction methodsFor: 'platypus-generated-accessing' stamp: ''!
declDomain
	^ declDomain

! !

!ExChdComputeImplicitDomainsFunction methodsFor: 'platypus-generated-accessing' stamp: ''!
declDomain: aListOfExChdEntityInstance
	declDomain := aListOfExChdEntityInstance
		ifNil: [ OrderedCollection new ]
		ifNotNil: [ aListOfExChdEntityInstance as: OrderedCollection ]

! !

!ExChdComputeImplicitDomainsFunction methodsFor: 'platypus-generated-accessing' stamp: ''!
fromValues: values
	self r: (values at: 1)

! !

!ExChdComputeImplicitDomainsFunction methodsFor: 'platypus-generated-invoking' stamp: ''!
invoke
	" ---------- locals assignments ----------"

	self refed: (self r referencedEntitiesUsingContext: self class context).
	self decl: (self r declaredDomainsUsingContext: self class context).
	self declDomain: Array new.
	self notDeclared: Array new.	" ---------- statements ----------"
	PlatypusCoreRepeatStatement
		repeat: [ :no392 | 
			PlatypusCoreAliasStatement
				alias: (self decl pltAt: no392)
				statementsBlock: [ :curr2211 | self declDomain: (self declDomain pltPlus: (curr2211 domainUsingContext: self class context)) ] ]
		from:
			(PltLOINDEXFunction
				invokeFromValues:
					(OrderedCollection new
						add: self decl;
						yourself))
		to:
			(PltHIINDEXFunction
				invokeFromValues:
					(OrderedCollection new
						add: self decl;
						yourself)).
	PlatypusCoreRepeatStatement
		repeat: [ :no758 | 
			PlatypusCoreAliasStatement
				alias: (self refed pltAt: no758)
				statementsBlock: [ :curr2581 | 
					((self declDomain includes: (curr2581 domainUsingContext: self class context)) not
						and: [ (self notDeclared includes: curr2581) not ])
						ifTrue: [ self notDeclared: (self notDeclared pltPlus: curr2581) ] ] ]
		from:
			(PltLOINDEXFunction
				invokeFromValues:
					(OrderedCollection new
						add: self refed;
						yourself))
		to:
			(PltHIINDEXFunction
				invokeFromValues:
					(OrderedCollection new
						add: self refed;
						yourself)).
	^ self return: self notDeclared

! !

!ExChdComputeImplicitDomainsFunction methodsFor: 'platypus-generated-accessing' stamp: ''!
notDeclared
	^ notDeclared

! !

!ExChdComputeImplicitDomainsFunction methodsFor: 'platypus-generated-accessing' stamp: ''!
notDeclared: aListOfExChdEntityRefDtdElement1
	notDeclared := aListOfExChdEntityRefDtdElement1
		ifNil: [ OrderedCollection new ]
		ifNotNil: [ aListOfExChdEntityRefDtdElement1 as: OrderedCollection ]

! !

!ExChdComputeImplicitDomainsFunction methodsFor: 'platypus-generated-accessing' stamp: ''!
r
	^ r

! !

!ExChdComputeImplicitDomainsFunction methodsFor: 'platypus-generated-accessing' stamp: ''!
r: aExChdRootDtdElement
	r := aExChdRootDtdElement

! !

!ExChdComputeImplicitDomainsFunction methodsFor: 'platypus-generated-accessing' stamp: ''!
refed
	^ refed

! !

!ExChdComputeImplicitDomainsFunction methodsFor: 'platypus-generated-accessing' stamp: ''!
refed: aListOfExChdEntityRefDtdElement
	refed := aListOfExChdEntityRefDtdElement
		ifNil: [ OrderedCollection new ]
		ifNotNil: [ aListOfExChdEntityRefDtdElement as: OrderedCollection ]

! !

PlatypusCoreAlgorithmDeclaration subclass: #ExChdComputePackageAttributeDtdElementsFunction
	instanceVariableNames: 'p subs r'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Express2Cheddar-CheddarDtdSchema'!

!ExChdComputePackageAttributeDtdElementsFunction commentStamp: 'platypus comment' prior: 0!
<ISO10303-11-EXPRESS>
FUNCTION compute_package_attribute_dtd_elements ( p : package_dtd_element ) : LIST OF attribute_dtd_element;
	LOCAL 
		subs : LIST OF dtd_element := p.subs;
		r : LIST OF attribute_dtd_element := [ ];
	END_LOCAL;

	REPEAT no := LOINDEX ( subs ) TO HIINDEX ( subs );
		r := r + subs [ no].subs;
	END_REPEAT;
	RETURN ( r );
END_FUNCTION;
</ISO10303-11-EXPRESS>!

!ExChdComputePackageAttributeDtdElementsFunction class methodsFor: 'platypus-generated-platypus-signature' stamp: ''!
iso10303P11Translater
	^ 'Platypus (c) LISYC EA3883, Universite de Bretagne occidentale. Brest.'

! !

!ExChdComputePackageAttributeDtdElementsFunction class methodsFor: 'platypus-generated-meta-data-accessing' stamp: ''!
schemaDefinition
	^ ExChdCheddarDtdSchemaDefinition singleton

! !

!ExChdComputePackageAttributeDtdElementsFunction class methodsFor: 'platypus-generated-platypus-signature' stamp: ''!
translatedFromISO10303P11
	^ true

! !

!ExChdComputePackageAttributeDtdElementsFunction class methodsFor: 'platypus-generated-platypus-signature' stamp: ''!
vwNamespaceName
	^ #Express2Cheddar

! !

!ExChdComputePackageAttributeDtdElementsFunction methodsFor: 'platypus-generated-accessing' stamp: ''!
fromValues: values
	self p: (values at: 1)

! !

!ExChdComputePackageAttributeDtdElementsFunction methodsFor: 'platypus-generated-invoking' stamp: ''!
invoke
	" ---------- locals assignments ----------"

	self subs: (self p subsUsingContext: self class context).
	self r: Array new.	" ---------- statements ----------"
	PlatypusCoreRepeatStatement
		repeat: [ :no3571 | self r: (self r pltPlus: ((self subs pltAt: no3571) subsUsingContext: self class context)) ]
		from:
			(PltLOINDEXFunction
				invokeFromValues:
					(OrderedCollection new
						add: self subs;
						yourself))
		to:
			(PltHIINDEXFunction
				invokeFromValues:
					(OrderedCollection new
						add: self subs;
						yourself)).
	^ self return: self r

! !

!ExChdComputePackageAttributeDtdElementsFunction methodsFor: 'platypus-generated-accessing' stamp: ''!
p
	^ p

! !

!ExChdComputePackageAttributeDtdElementsFunction methodsFor: 'platypus-generated-accessing' stamp: ''!
p: aExChdPackageDtdElement
	p := aExChdPackageDtdElement

! !

!ExChdComputePackageAttributeDtdElementsFunction methodsFor: 'platypus-generated-accessing' stamp: ''!
r
	^ r

! !

!ExChdComputePackageAttributeDtdElementsFunction methodsFor: 'platypus-generated-accessing' stamp: ''!
r: aListOfExChdAttributeDtdElement
	r := aListOfExChdAttributeDtdElement
		ifNil: [ OrderedCollection new ]
		ifNotNil: [ aListOfExChdAttributeDtdElement as: OrderedCollection ]

! !

!ExChdComputePackageAttributeDtdElementsFunction methodsFor: 'platypus-generated-accessing' stamp: ''!
subs
	^ subs

! !

!ExChdComputePackageAttributeDtdElementsFunction methodsFor: 'platypus-generated-accessing' stamp: ''!
subs: aListOfExChdDtdElement
	subs := aListOfExChdDtdElement
		ifNil: [ OrderedCollection new ]
		ifNotNil: [ aListOfExChdDtdElement as: OrderedCollection ]

! !

PlatypusCoreAlgorithmDeclaration subclass: #ExChdComputePackageDtdCodeFunction
	instanceVariableNames: 'p subs s'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Express2Cheddar-CheddarDtdSchema'!

!ExChdComputePackageDtdCodeFunction commentStamp: 'platypus comment' prior: 0!
<ISO10303-11-EXPRESS>
FUNCTION compute_package_dtd_code ( p : package_dtd_element ) : STRING;
	LOCAL 
		subs : LIST OF dtd_element := p.subs;
		s : STRING := '';
	END_LOCAL;

	IF ( SIZEOF ( subs ) > 0 ) THEN
		s := s + '<!!ELEMENT ' + p.tag + ' (';

		REPEAT no := LOINDEX ( subs ) TO HIINDEX ( subs );
			s := s + subs [ no].tag;
			IF ( no < HIINDEX ( subs ) ) THEN
				s := s + ' | ';
			END_IF;
		END_REPEAT;
		s := s + ')+>\n';

		REPEAT no := LOINDEX ( subs ) TO HIINDEX ( subs );
			s := s + subs [ no].dtd_code;
		END_REPEAT;
		s := s + '\n';
	END_IF;
	RETURN ( s );
END_FUNCTION;
</ISO10303-11-EXPRESS>!

!ExChdComputePackageDtdCodeFunction class methodsFor: 'platypus-generated-platypus-signature' stamp: ''!
iso10303P11Translater
	^ 'Platypus (c) LISYC EA3883, Universite de Bretagne occidentale. Brest.'

! !

!ExChdComputePackageDtdCodeFunction class methodsFor: 'platypus-generated-meta-data-accessing' stamp: ''!
schemaDefinition
	^ ExChdCheddarDtdSchemaDefinition singleton

! !

!ExChdComputePackageDtdCodeFunction class methodsFor: 'platypus-generated-platypus-signature' stamp: ''!
translatedFromISO10303P11
	^ true

! !

!ExChdComputePackageDtdCodeFunction class methodsFor: 'platypus-generated-platypus-signature' stamp: ''!
vwNamespaceName
	^ #Express2Cheddar

! !

!ExChdComputePackageDtdCodeFunction methodsFor: 'platypus-generated-accessing' stamp: ''!
fromValues: values
	self p: (values at: 1)

! !

!ExChdComputePackageDtdCodeFunction methodsFor: 'platypus-generated-invoking' stamp: ''!
invoke
	" ---------- locals assignments ----------"

	self subs: (self p subsUsingContext: self class context).
	self s: ''.	" ---------- statements ----------"
	(PltSIZEOFFunction
		invokeFromValues:
			(OrderedCollection new
				add: self subs;
				yourself)) > 0
		ifTrue: [ 
			self s: (((self s pltPlus: '<!!ELEMENT ') pltPlus: (self p tagUsingContext: self class context)) pltPlus: ' (').
			PlatypusCoreRepeatStatement
				repeat: [ :no3934 | 
					self s: (self s pltPlus: ((self subs pltAt: no3934) tagUsingContext: self class context)).
					no3934
						<
							(PltHIINDEXFunction
								invokeFromValues:
									(OrderedCollection new
										add: self subs;
										yourself))
						ifTrue: [ self s: (self s pltPlus: ' | ') ] ]
				from:
					(PltLOINDEXFunction
						invokeFromValues:
							(OrderedCollection new
								add: self subs;
								yourself))
				to:
					(PltHIINDEXFunction
						invokeFromValues:
							(OrderedCollection new
								add: self subs;
								yourself)).
			self s: (self s pltPlus: ')+>\n').
			PlatypusCoreRepeatStatement
				repeat: [ :no578 | self s: (self s pltPlus: ((self subs pltAt: no578) dtdCodeUsingContext: self class context)) ]
				from:
					(PltLOINDEXFunction
						invokeFromValues:
							(OrderedCollection new
								add: self subs;
								yourself))
				to:
					(PltHIINDEXFunction
						invokeFromValues:
							(OrderedCollection new
								add: self subs;
								yourself)).
			self s: (self s pltPlus: '\n') ].
	^ self return: self s

! !

!ExChdComputePackageDtdCodeFunction methodsFor: 'platypus-generated-accessing' stamp: ''!
p
	^ p

! !

!ExChdComputePackageDtdCodeFunction methodsFor: 'platypus-generated-accessing' stamp: ''!
p: aExChdPackageDtdElement
	p := aExChdPackageDtdElement

! !

!ExChdComputePackageDtdCodeFunction methodsFor: 'platypus-generated-accessing' stamp: ''!
s
	^ s

! !

!ExChdComputePackageDtdCodeFunction methodsFor: 'platypus-generated-accessing' stamp: ''!
s: aString
	s := aString

! !

!ExChdComputePackageDtdCodeFunction methodsFor: 'platypus-generated-accessing' stamp: ''!
subs
	^ subs

! !

!ExChdComputePackageDtdCodeFunction methodsFor: 'platypus-generated-accessing' stamp: ''!
subs: aListOfExChdDtdElement
	subs := aListOfExChdDtdElement
		ifNil: [ OrderedCollection new ]
		ifNotNil: [ aListOfExChdDtdElement as: OrderedCollection ]

! !

PlatypusCoreAlgorithmDeclaration subclass: #ExChdComputePackageSubElementsFunction
	instanceVariableNames: 'e result classes records discrims'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Express2Cheddar-CheddarDtdSchema'!

!ExChdComputePackageSubElementsFunction commentStamp: 'platypus comment' prior: 0!
<ISO10303-11-EXPRESS>
FUNCTION compute_package_sub_elements ( e : package_dtd_element ) : LIST OF dtd_element;
	LOCAL 
		result : LIST OF dtd_element := [ ];
		classes : LIST OF ada_entity := package_ada_classes ( e.package );
		records : LIST OF ada_entity := package_records ( e.package );
		discrims : LIST OF discriminated_type := package_discriminated_types ( e.package );
	END_LOCAL;

	REPEAT no := LOINDEX ( classes ) TO HIINDEX ( classes );

		ALIAS curr FOR classes [ no];
			result := result + ( dtd_element ( e, ? ) || composite_dtd_element ( ) || entity_dtd_element ( curr ) || ada_class_dtd_element ( ) );
		END_ALIAS;
	END_REPEAT;

	REPEAT no := LOINDEX ( records ) TO HIINDEX ( records );

		ALIAS curr FOR records [ no];
			result := result + ( dtd_element ( e, ? ) || composite_dtd_element ( ) || entity_dtd_element ( curr ) || record_dtd_element ( ) );
		END_ALIAS;
	END_REPEAT;

	REPEAT no := LOINDEX ( discrims ) TO HIINDEX ( discrims );

		ALIAS curr FOR discrims [ no];
			result := result + ( dtd_element ( e, ? ) || composite_dtd_element ( ) || entity_dtd_element ( curr ) || discriminated_type_dtd_element ( ) );
		END_ALIAS;
	END_REPEAT;
	RETURN ( result );
END_FUNCTION;
</ISO10303-11-EXPRESS>!

!ExChdComputePackageSubElementsFunction class methodsFor: 'platypus-generated-platypus-signature' stamp: ''!
iso10303P11Translater
	^ 'Platypus (c) LISYC EA3883, Universite de Bretagne occidentale. Brest.'

! !

!ExChdComputePackageSubElementsFunction class methodsFor: 'platypus-generated-meta-data-accessing' stamp: ''!
schemaDefinition
	^ ExChdCheddarDtdSchemaDefinition singleton

! !

!ExChdComputePackageSubElementsFunction class methodsFor: 'platypus-generated-platypus-signature' stamp: ''!
translatedFromISO10303P11
	^ true

! !

!ExChdComputePackageSubElementsFunction class methodsFor: 'platypus-generated-platypus-signature' stamp: ''!
vwNamespaceName
	^ #Express2Cheddar

! !

!ExChdComputePackageSubElementsFunction methodsFor: 'platypus-generated-accessing' stamp: ''!
classes
	^ classes

! !

!ExChdComputePackageSubElementsFunction methodsFor: 'platypus-generated-accessing' stamp: ''!
classes: aListOfExChdAdaEntity
	classes := aListOfExChdAdaEntity
		ifNil: [ OrderedCollection new ]
		ifNotNil: [ aListOfExChdAdaEntity as: OrderedCollection ]

! !

!ExChdComputePackageSubElementsFunction methodsFor: 'platypus-generated-accessing' stamp: ''!
discrims
	^ discrims

! !

!ExChdComputePackageSubElementsFunction methodsFor: 'platypus-generated-accessing' stamp: ''!
discrims: aListOfExChdDiscriminatedType
	discrims := aListOfExChdDiscriminatedType
		ifNil: [ OrderedCollection new ]
		ifNotNil: [ aListOfExChdDiscriminatedType as: OrderedCollection ]

! !

!ExChdComputePackageSubElementsFunction methodsFor: 'platypus-generated-accessing' stamp: ''!
e
	^ e

! !

!ExChdComputePackageSubElementsFunction methodsFor: 'platypus-generated-accessing' stamp: ''!
e: aExChdPackageDtdElement
	e := aExChdPackageDtdElement

! !

!ExChdComputePackageSubElementsFunction methodsFor: 'platypus-generated-accessing' stamp: ''!
fromValues: values
	self e: (values at: 1)

! !

!ExChdComputePackageSubElementsFunction methodsFor: 'platypus-generated-invoking' stamp: ''!
invoke
	" ---------- locals assignments ----------"

	self result: Array new.
	self
		classes:
			(ExChdPackageAdaClassesFunction
				invokeFromValues:
					(OrderedCollection new
						add: (self e packageUsingContext: self class context);
						yourself)).
	self
		records:
			(ExChdPackageRecordsFunction
				invokeFromValues:
					(OrderedCollection new
						add: (self e packageUsingContext: self class context);
						yourself)).
	self
		discrims:
			(ExChdPackageDiscriminatedTypesFunction
				invokeFromValues:
					(OrderedCollection new
						add: (self e packageUsingContext: self class context);
						yourself)).	" ---------- statements ----------"
	PlatypusCoreRepeatStatement
		repeat: [ :no713 | 
			PlatypusCoreAliasStatement
				alias: (self classes pltAt: no713)
				statementsBlock: [ :curr2536 | 
					self
						result:
							(self result
								pltPlus:
									(PlatypusComplexInstance
										fromRecords:
											(OrderedCollection new
												add:
														(PlatypusComplexInstance
																fromRecords:
																	(OrderedCollection new
																		add:
																				(PlatypusComplexInstance
																						fromRecords:
																							(OrderedCollection new
																								add:
																										(ExChdDtdElement new
																												dtdElementFromValues:
																														(OrderedCollection new
																																add: self e;
																																add: nil;
																																yourself);
																												yourself);
																								add: ExChdCompositeDtdElement new;
																								yourself)) pltAsObject;
																		add:
																				(ExChdEntityDtdElement new
																						entityDtdElementFromValues:
																								(OrderedCollection new
																										add: curr2536;
																										yourself);
																						yourself);
																		yourself)) pltAsObject;
												add: ExChdAdaClassDtdElement new;
												yourself)) pltAsObject) ] ]
		from:
			(PltLOINDEXFunction
				invokeFromValues:
					(OrderedCollection new
						add: self classes;
						yourself))
		to:
			(PltHIINDEXFunction
				invokeFromValues:
					(OrderedCollection new
						add: self classes;
						yourself)).
	PlatypusCoreRepeatStatement
		repeat: [ :no2751 | 
			PlatypusCoreAliasStatement
				alias: (self records pltAt: no2751)
				statementsBlock: [ :curr478 | 
					self
						result:
							(self result
								pltPlus:
									(PlatypusComplexInstance
										fromRecords:
											(OrderedCollection new
												add:
														(PlatypusComplexInstance
																fromRecords:
																	(OrderedCollection new
																		add:
																				(PlatypusComplexInstance
																						fromRecords:
																							(OrderedCollection new
																								add:
																										(ExChdDtdElement new
																												dtdElementFromValues:
																														(OrderedCollection new
																																add: self e;
																																add: nil;
																																yourself);
																												yourself);
																								add: ExChdCompositeDtdElement new;
																								yourself)) pltAsObject;
																		add:
																				(ExChdEntityDtdElement new
																						entityDtdElementFromValues:
																								(OrderedCollection new
																										add: curr478;
																										yourself);
																						yourself);
																		yourself)) pltAsObject;
												add: ExChdRecordDtdElement new;
												yourself)) pltAsObject) ] ]
		from:
			(PltLOINDEXFunction
				invokeFromValues:
					(OrderedCollection new
						add: self records;
						yourself))
		to:
			(PltHIINDEXFunction
				invokeFromValues:
					(OrderedCollection new
						add: self records;
						yourself)).
	PlatypusCoreRepeatStatement
		repeat: [ :no1259 | 
			PlatypusCoreAliasStatement
				alias: (self discrims pltAt: no1259)
				statementsBlock: [ :curr3082 | 
					self
						result:
							(self result
								pltPlus:
									(PlatypusComplexInstance
										fromRecords:
											(OrderedCollection new
												add:
														(PlatypusComplexInstance
																fromRecords:
																	(OrderedCollection new
																		add:
																				(PlatypusComplexInstance
																						fromRecords:
																							(OrderedCollection new
																								add:
																										(ExChdDtdElement new
																												dtdElementFromValues:
																														(OrderedCollection new
																																add: self e;
																																add: nil;
																																yourself);
																												yourself);
																								add: ExChdCompositeDtdElement new;
																								yourself)) pltAsObject;
																		add:
																				(ExChdEntityDtdElement new
																						entityDtdElementFromValues:
																								(OrderedCollection new
																										add: curr3082;
																										yourself);
																						yourself);
																		yourself)) pltAsObject;
												add: ExChdDiscriminatedTypeDtdElement new;
												yourself)) pltAsObject) ] ]
		from:
			(PltLOINDEXFunction
				invokeFromValues:
					(OrderedCollection new
						add: self discrims;
						yourself))
		to:
			(PltHIINDEXFunction
				invokeFromValues:
					(OrderedCollection new
						add: self discrims;
						yourself)).
	^ self return: self result

! !

!ExChdComputePackageSubElementsFunction methodsFor: 'platypus-generated-accessing' stamp: ''!
records
	^ records

! !

!ExChdComputePackageSubElementsFunction methodsFor: 'platypus-generated-accessing' stamp: ''!
records: aListOfExChdAdaEntity1
	records := aListOfExChdAdaEntity1
		ifNil: [ OrderedCollection new ]
		ifNotNil: [ aListOfExChdAdaEntity1 as: OrderedCollection ]

! !

!ExChdComputePackageSubElementsFunction methodsFor: 'platypus-generated-accessing' stamp: ''!
result
	^ result

! !

!ExChdComputePackageSubElementsFunction methodsFor: 'platypus-generated-accessing' stamp: ''!
result: aListOfExChdDtdElement
	result := aListOfExChdDtdElement
		ifNil: [ OrderedCollection new ]
		ifNotNil: [ aListOfExChdDtdElement as: OrderedCollection ]

! !

PlatypusCoreAlgorithmDeclaration subclass: #ExChdComputeRootDtdCodeFunction
	instanceVariableNames: 'r s code lines licence pkgs attributes acode previous implicits infered el inferedAttributes'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Express2Cheddar-CheddarDtdSchema'!

!ExChdComputeRootDtdCodeFunction commentStamp: 'platypus comment' prior: 0!
<ISO10303-11-EXPRESS>
FUNCTION compute_root_dtd_code ( r : root_dtd_element ) : STRING;
	LOCAL 
		s : STRING := '';
		code : STRING;
		lines : LIST OF STRING := [ ];
		licence : STRING := string_replace ( source_licence, '--', '  ' );
		pkgs : LIST OF package_dtd_element := r.subs;
		attributes : LIST OF attribute_dtd_element := [ ];
		acode : STRING;
		previous : LIST OF STRING := [ ];
		implicits : LIST OF dtd_element := r.implicit_domains;
		infered : LIST OF entity_dtd_element := [ ];
		el : entity_dtd_element;
		infered_attributes : LIST OF attribute_dtd_element := [ ];
	END_LOCAL;

	REPEAT no := LOINDEX ( implicits ) TO HIINDEX ( implicits );
		el := implicits [ no].infered_element;
		infered := infered + el;
		infered_attributes := infered_attributes + el.subs;
	END_REPEAT;
	s := s + '<!!--' + licence + '-->\n\n' 

	+ '<!!ELEMENT ' + r.tag + ' (';

	REPEAT no := LOINDEX ( pkgs ) TO HIINDEX ( pkgs );
		s := s + pkgs [ no].tag + '?';

		IF ( no < HIINDEX ( pkgs ) ) THEN
			s := s + ' | ';
		END_IF;
	END_REPEAT;
	s := s + ')*>\n\n';

	REPEAT no := LOINDEX ( pkgs ) TO HIINDEX ( pkgs );
		code := pkgs [ no].dtd_code;
		previous := previous + LinesFromString ( code );
		s := s + code;
	END_REPEAT;
	s := s + '\n';

	REPEAT no := LOINDEX ( infered ) TO HIINDEX ( infered );
		acode := infered [ no].dtd_code;

		IF NOT ( acode IN previous ) THEN
			s := s + acode;
			previous := previous + acode;
		END_IF;
	END_REPEAT;

	REPEAT no := LOINDEX ( pkgs ) TO HIINDEX ( pkgs );
		attributes := attributes + compute_package_attribute_dtd_elements ( pkgs [ no] );
	END_REPEAT;

	REPEAT no := LOINDEX ( attributes ) TO HIINDEX ( attributes );
		acode := attributes [ no].dtd_code;

		IF NOT ( acode IN previous ) THEN
			s := s + attributes [ no].dtd_code;
			previous := previous + acode;
		END_IF;
	END_REPEAT;

	REPEAT no := LOINDEX ( infered_attributes ) TO HIINDEX ( infered_attributes );
		acode := infered_attributes [ no].dtd_code;

		IF NOT ( acode IN previous ) THEN
			s := s + acode;
			previous := previous + acode;
		END_IF;
	END_REPEAT;
	RETURN ( s );
END_FUNCTION;
</ISO10303-11-EXPRESS>!

!ExChdComputeRootDtdCodeFunction class methodsFor: 'platypus-generated-platypus-signature' stamp: ''!
iso10303P11Translater
	^ 'Platypus (c) LISYC EA3883, Universite de Bretagne occidentale. Brest.'

! !

!ExChdComputeRootDtdCodeFunction class methodsFor: 'platypus-generated-meta-data-accessing' stamp: ''!
schemaDefinition
	^ ExChdCheddarDtdSchemaDefinition singleton

! !

!ExChdComputeRootDtdCodeFunction class methodsFor: 'platypus-generated-platypus-signature' stamp: ''!
translatedFromISO10303P11
	^ true

! !

!ExChdComputeRootDtdCodeFunction class methodsFor: 'platypus-generated-platypus-signature' stamp: ''!
vwNamespaceName
	^ #Express2Cheddar

! !

!ExChdComputeRootDtdCodeFunction methodsFor: 'platypus-generated-accessing' stamp: ''!
acode
	^ acode

! !

!ExChdComputeRootDtdCodeFunction methodsFor: 'platypus-generated-accessing' stamp: ''!
acode: aString3
	acode := aString3

! !

!ExChdComputeRootDtdCodeFunction methodsFor: 'platypus-generated-accessing' stamp: ''!
attributes
	^ attributes

! !

!ExChdComputeRootDtdCodeFunction methodsFor: 'platypus-generated-accessing' stamp: ''!
attributes: aListOfExChdAttributeDtdElement
	attributes := aListOfExChdAttributeDtdElement
		ifNil: [ OrderedCollection new ]
		ifNotNil: [ aListOfExChdAttributeDtdElement as: OrderedCollection ]

! !

!ExChdComputeRootDtdCodeFunction methodsFor: 'platypus-generated-accessing' stamp: ''!
code
	^ code

! !

!ExChdComputeRootDtdCodeFunction methodsFor: 'platypus-generated-accessing' stamp: ''!
code: aString1
	code := aString1

! !

!ExChdComputeRootDtdCodeFunction methodsFor: 'platypus-generated-accessing' stamp: ''!
el
	^ el

! !

!ExChdComputeRootDtdCodeFunction methodsFor: 'platypus-generated-accessing' stamp: ''!
el: aExChdEntityDtdElement
	el := aExChdEntityDtdElement

! !

!ExChdComputeRootDtdCodeFunction methodsFor: 'platypus-generated-accessing' stamp: ''!
fromValues: values
	self r: (values at: 1)

! !

!ExChdComputeRootDtdCodeFunction methodsFor: 'platypus-generated-accessing' stamp: ''!
implicits
	^ implicits

! !

!ExChdComputeRootDtdCodeFunction methodsFor: 'platypus-generated-accessing' stamp: ''!
implicits: aListOfExChdDtdElement
	implicits := aListOfExChdDtdElement
		ifNil: [ OrderedCollection new ]
		ifNotNil: [ aListOfExChdDtdElement as: OrderedCollection ]

! !

!ExChdComputeRootDtdCodeFunction methodsFor: 'platypus-generated-accessing' stamp: ''!
infered
	^ infered

! !

!ExChdComputeRootDtdCodeFunction methodsFor: 'platypus-generated-accessing' stamp: ''!
infered: aListOfExChdEntityDtdElement
	infered := aListOfExChdEntityDtdElement
		ifNil: [ OrderedCollection new ]
		ifNotNil: [ aListOfExChdEntityDtdElement as: OrderedCollection ]

! !

!ExChdComputeRootDtdCodeFunction methodsFor: 'platypus-generated-accessing' stamp: ''!
inferedAttributes
	^ inferedAttributes

! !

!ExChdComputeRootDtdCodeFunction methodsFor: 'platypus-generated-accessing' stamp: ''!
inferedAttributes: aListOfExChdAttributeDtdElement1
	inferedAttributes := aListOfExChdAttributeDtdElement1
		ifNil: [ OrderedCollection new ]
		ifNotNil: [ aListOfExChdAttributeDtdElement1 as: OrderedCollection ]

! !

!ExChdComputeRootDtdCodeFunction methodsFor: 'platypus-generated-invoking' stamp: ''!
invoke
	" ---------- locals assignments ----------"

	self s: ''.
	self lines: Array new.
	self
		licence:
			(PTsStringReplaceFunction
				invokeFromValues:
					(OrderedCollection new
						add:
								((((((((((((((((((((((((((((((((((((((''
										pltPlus: '------------------------------------------------------------------------------\n')
										pltPlus: '------------------------------------------------------------------------------\n')
										pltPlus: '--  This source file was automatically generated by Platypus\n')
										pltPlus: '--  see http://dossen.univ-brest.fr/apl\n') pltPlus: '-- \n')
										pltPlus: '--  Any modification of this file will be lost. \n')
										pltPlus: '--  Please see the "platypus" directory instead : it contains the Cheddar''s\n')
										pltPlus: '--  model and its meta-model. \n')
										pltPlus: '------------------------------------------------------------------------------\n \n')
										pltPlus: '------------------------------------------------------------------------------\n')
										pltPlus: '-- Cheddar is a free real time scheduling tool.\n')
										pltPlus: '-- This program provides services to automatically check temporal constraints\n')
										pltPlus: '-- of real time tasks.\n') pltPlus: '--\n') pltPlus: '-- Copyright (C) 2002-2014   Frank Singhoff\n')
										pltPlus: '-- Cheddar is developed by the LAB-STICC Team, University of Brest\n') pltPlus: '--\n')
										pltPlus: '-- This program is free software; you can redistribute it and/or modify\n')
										pltPlus: '-- it under the terms of the GNU General Public License as published by\n')
										pltPlus: '-- the Free Software Foundation; either version 2 of the License, or\n')
										pltPlus: '-- (at your option) any later version.\n') pltPlus: '--\n')
										pltPlus: '-- This program is distributed in the hope that it will be useful,\n')
										pltPlus: '-- but WITHOUT ANY WARRANTY; without even the implied warranty of\n')
										pltPlus: '-- MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the\n')
										pltPlus: '-- GNU General Public License for more details.\n') pltPlus: '--\n')
										pltPlus: '-- You should have received a copy of the GNU General Public License\n')
										pltPlus: '-- along with this program; if not, write to the Free Software\n')
										pltPlus: '-- Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA\n') pltPlus: '--\n')
										pltPlus: '--\n') pltPlus: '-- Contact : cheddar@listes.univ-brest.fr\n')
										pltPlus: '-- 	To post to this mailing list, you must be subscribed\n')
										pltPlus: '-- 	(see http//beru.univ-brest.fr/~singhoff/cheddar for details)\n') pltPlus: '--\n')
										pltPlus: '------------------------------------------------------------------------------\n')
										pltPlus: '------------------------------------------------------------------------------\n');
						add: '--';
						add: '  ';
						yourself)).
	self pkgs: (self r subsUsingContext: self class context).
	self attributes: Array new.
	self previous: Array new.
	self implicits: (self r implicitDomainsUsingContext: self class context).
	self infered: Array new.
	self inferedAttributes: Array new.	" ---------- statements ----------"
	PlatypusCoreRepeatStatement
		repeat: [ :no2721 | 
			self el: ((self implicits pltAt: no2721) inferedElementUsingContext: self class context).
			self infered: (self infered pltPlus: self el).
			self inferedAttributes: (self inferedAttributes pltPlus: (self el subsUsingContext: self class context)) ]
		from:
			(PltLOINDEXFunction
				invokeFromValues:
					(OrderedCollection new
						add: self implicits;
						yourself))
		to:
			(PltHIINDEXFunction
				invokeFromValues:
					(OrderedCollection new
						add: self implicits;
						yourself)).
	self
		s:
			((((((self s pltPlus: '<!!--') pltPlus: self licence) pltPlus: '-->\n\n') pltPlus: '<!!ELEMENT ')
				pltPlus: (self r tagUsingContext: self class context)) pltPlus: ' (').
	PlatypusCoreRepeatStatement
		repeat: [ :no1850 | 
			self s: ((self s pltPlus: ((self pkgs pltAt: no1850) tagUsingContext: self class context)) pltPlus: '?').
			no1850
				<
					(PltHIINDEXFunction
						invokeFromValues:
							(OrderedCollection new
								add: self pkgs;
								yourself))
				ifTrue: [ self s: (self s pltPlus: ' | ') ] ]
		from:
			(PltLOINDEXFunction
				invokeFromValues:
					(OrderedCollection new
						add: self pkgs;
						yourself))
		to:
			(PltHIINDEXFunction
				invokeFromValues:
					(OrderedCollection new
						add: self pkgs;
						yourself)).
	self s: (self s pltPlus: ')*>\n\n').
	PlatypusCoreRepeatStatement
		repeat: [ :no2920 | 
			self code: ((self pkgs pltAt: no2920) dtdCodeUsingContext: self class context).
			self
				previous:
					(self previous
						pltPlus:
							(PTsLinesFromStringFunction
								invokeFromValues:
									(OrderedCollection new
										add: self code;
										yourself))).
			self s: (self s pltPlus: self code) ]
		from:
			(PltLOINDEXFunction
				invokeFromValues:
					(OrderedCollection new
						add: self pkgs;
						yourself))
		to:
			(PltHIINDEXFunction
				invokeFromValues:
					(OrderedCollection new
						add: self pkgs;
						yourself)).
	self s: (self s pltPlus: '\n').
	PlatypusCoreRepeatStatement
		repeat: [ :no1754 | 
			self acode: ((self infered pltAt: no1754) dtdCodeUsingContext: self class context).
			(self previous includes: self acode) not
				ifTrue: [ 
					self s: (self s pltPlus: self acode).
					self previous: (self previous pltPlus: self acode) ] ]
		from:
			(PltLOINDEXFunction
				invokeFromValues:
					(OrderedCollection new
						add: self infered;
						yourself))
		to:
			(PltHIINDEXFunction
				invokeFromValues:
					(OrderedCollection new
						add: self infered;
						yourself)).
	PlatypusCoreRepeatStatement
		repeat: [ :no33 | 
			self
				attributes:
					(self attributes
						pltPlus:
							(ExChdComputePackageAttributeDtdElementsFunction
								invokeFromValues:
									(OrderedCollection new
										add: (self pkgs pltAt: no33);
										yourself))) ]
		from:
			(PltLOINDEXFunction
				invokeFromValues:
					(OrderedCollection new
						add: self pkgs;
						yourself))
		to:
			(PltHIINDEXFunction
				invokeFromValues:
					(OrderedCollection new
						add: self pkgs;
						yourself)).
	PlatypusCoreRepeatStatement
		repeat: [ :no71 | 
			self acode: ((self attributes pltAt: no71) dtdCodeUsingContext: self class context).
			(self previous includes: self acode) not
				ifTrue: [ 
					self s: (self s pltPlus: ((self attributes pltAt: no71) dtdCodeUsingContext: self class context)).
					self previous: (self previous pltPlus: self acode) ] ]
		from:
			(PltLOINDEXFunction
				invokeFromValues:
					(OrderedCollection new
						add: self attributes;
						yourself))
		to:
			(PltHIINDEXFunction
				invokeFromValues:
					(OrderedCollection new
						add: self attributes;
						yourself)).
	PlatypusCoreRepeatStatement
		repeat: [ :no2320 | 
			self acode: ((self inferedAttributes pltAt: no2320) dtdCodeUsingContext: self class context).
			(self previous includes: self acode) not
				ifTrue: [ 
					self s: (self s pltPlus: self acode).
					self previous: (self previous pltPlus: self acode) ] ]
		from:
			(PltLOINDEXFunction
				invokeFromValues:
					(OrderedCollection new
						add: self inferedAttributes;
						yourself))
		to:
			(PltHIINDEXFunction
				invokeFromValues:
					(OrderedCollection new
						add: self inferedAttributes;
						yourself)).
	^ self return: self s

! !

!ExChdComputeRootDtdCodeFunction methodsFor: 'platypus-generated-accessing' stamp: ''!
licence
	^ licence

! !

!ExChdComputeRootDtdCodeFunction methodsFor: 'platypus-generated-accessing' stamp: ''!
licence: aString2
	licence := aString2

! !

!ExChdComputeRootDtdCodeFunction methodsFor: 'platypus-generated-accessing' stamp: ''!
lines
	^ lines

! !

!ExChdComputeRootDtdCodeFunction methodsFor: 'platypus-generated-accessing' stamp: ''!
lines: aListOfString
	lines := aListOfString ifNil: [ OrderedCollection new ] ifNotNil: [ aListOfString as: OrderedCollection ]

! !

!ExChdComputeRootDtdCodeFunction methodsFor: 'platypus-generated-accessing' stamp: ''!
pkgs
	^ pkgs

! !

!ExChdComputeRootDtdCodeFunction methodsFor: 'platypus-generated-accessing' stamp: ''!
pkgs: aListOfExChdPackageDtdElement
	pkgs := aListOfExChdPackageDtdElement
		ifNil: [ OrderedCollection new ]
		ifNotNil: [ aListOfExChdPackageDtdElement as: OrderedCollection ]

! !

!ExChdComputeRootDtdCodeFunction methodsFor: 'platypus-generated-accessing' stamp: ''!
previous
	^ previous

! !

!ExChdComputeRootDtdCodeFunction methodsFor: 'platypus-generated-accessing' stamp: ''!
previous: aListOfString1
	previous := aListOfString1 ifNil: [ OrderedCollection new ] ifNotNil: [ aListOfString1 as: OrderedCollection ]

! !

!ExChdComputeRootDtdCodeFunction methodsFor: 'platypus-generated-accessing' stamp: ''!
r
	^ r

! !

!ExChdComputeRootDtdCodeFunction methodsFor: 'platypus-generated-accessing' stamp: ''!
r: aExChdRootDtdElement
	r := aExChdRootDtdElement

! !

!ExChdComputeRootDtdCodeFunction methodsFor: 'platypus-generated-accessing' stamp: ''!
s
	^ s

! !

!ExChdComputeRootDtdCodeFunction methodsFor: 'platypus-generated-accessing' stamp: ''!
s: aString
	s := aString

! !

PlatypusCoreAlgorithmDeclaration subclass: #ExChdComputeRootSubElementsFunction
	instanceVariableNames: 'e result'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Express2Cheddar-CheddarDtdSchema'!

!ExChdComputeRootSubElementsFunction commentStamp: 'platypus comment' prior: 0!
<ISO10303-11-EXPRESS>
FUNCTION compute_root_sub_elements ( e : root_dtd_element ) : LIST OF package_dtd_element;
	LOCAL 
		result : LIST OF package_dtd_element := [ ];
	END_LOCAL;

	ALIAS packages FOR e.packages;

		REPEAT no := LOINDEX ( packages ) TO HIINDEX ( packages );
			result := result + ( dtd_element ( e, ? ) || composite_dtd_element ( ) || package_dtd_element ( packages [ no] ) );
		END_REPEAT;
	END_ALIAS;
	RETURN ( result );
END_FUNCTION;
</ISO10303-11-EXPRESS>!

!ExChdComputeRootSubElementsFunction class methodsFor: 'platypus-generated-platypus-signature' stamp: ''!
iso10303P11Translater
	^ 'Platypus (c) LISYC EA3883, Universite de Bretagne occidentale. Brest.'

! !

!ExChdComputeRootSubElementsFunction class methodsFor: 'platypus-generated-meta-data-accessing' stamp: ''!
schemaDefinition
	^ ExChdCheddarDtdSchemaDefinition singleton

! !

!ExChdComputeRootSubElementsFunction class methodsFor: 'platypus-generated-platypus-signature' stamp: ''!
translatedFromISO10303P11
	^ true

! !

!ExChdComputeRootSubElementsFunction class methodsFor: 'platypus-generated-platypus-signature' stamp: ''!
vwNamespaceName
	^ #Express2Cheddar

! !

!ExChdComputeRootSubElementsFunction methodsFor: 'platypus-generated-accessing' stamp: ''!
e
	^ e

! !

!ExChdComputeRootSubElementsFunction methodsFor: 'platypus-generated-accessing' stamp: ''!
e: aExChdRootDtdElement
	e := aExChdRootDtdElement

! !

!ExChdComputeRootSubElementsFunction methodsFor: 'platypus-generated-accessing' stamp: ''!
fromValues: values
	self e: (values at: 1)

! !

!ExChdComputeRootSubElementsFunction methodsFor: 'platypus-generated-invoking' stamp: ''!
invoke
	" ---------- locals assignments ----------"

	self result: Array new.	" ---------- statements ----------"
	PlatypusCoreAliasStatement
		alias: (self e packagesUsingContext: self class context)
		statementsBlock: [ :packages2501 | 
			PlatypusCoreRepeatStatement
				repeat: [ :no71 | 
					self
						result:
							(self result
								pltPlus:
									(PlatypusComplexInstance
										fromRecords:
											(OrderedCollection new
												add:
														(PlatypusComplexInstance
																fromRecords:
																	(OrderedCollection new
																		add:
																				(ExChdDtdElement new
																						dtdElementFromValues:
																								(OrderedCollection new
																										add: self e;
																										add: nil;
																										yourself);
																						yourself);
																		add: ExChdCompositeDtdElement new;
																		yourself)) pltAsObject;
												add:
														(ExChdPackageDtdElement new
																packageDtdElementFromValues:
																		(OrderedCollection new
																				add: (packages2501 pltAt: no71);
																				yourself);
																yourself);
												yourself)) pltAsObject) ]
				from:
					(PltLOINDEXFunction
						invokeFromValues:
							(OrderedCollection new
								add: packages2501;
								yourself))
				to:
					(PltHIINDEXFunction
						invokeFromValues:
							(OrderedCollection new
								add: packages2501;
								yourself)) ].
	^ self return: self result

! !

!ExChdComputeRootSubElementsFunction methodsFor: 'platypus-generated-accessing' stamp: ''!
result
	^ result

! !

!ExChdComputeRootSubElementsFunction methodsFor: 'platypus-generated-accessing' stamp: ''!
result: aListOfExChdPackageDtdElement
	result := aListOfExChdPackageDtdElement
		ifNil: [ OrderedCollection new ]
		ifNotNil: [ aListOfExChdPackageDtdElement as: OrderedCollection ]

! !

PlatypusCoreAlgorithmDeclaration subclass: #ExChdConceptInListFunction
	instanceVariableNames: 'c l key'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Express2Cheddar-PackageSchema'!

!ExChdConceptInListFunction commentStamp: 'platypus comment' prior: 0!
<ISO10303-11-EXPRESS>
FUNCTION concept_in_list ( c : dictionary_instance; l : LIST OF dictionary_instance ) : BOOLEAN;
	LOCAL 
		key : STRING := upperize ( c.name );
	END_LOCAL;

	REPEAT no := LOINDEX ( l ) TO HIINDEX ( l );

		IF ( upperize ( l [ no].name ) = key ) THEN
			RETURN ( true );
		END_IF;
	END_REPEAT;
	RETURN ( false );
END_FUNCTION;
</ISO10303-11-EXPRESS>!

!ExChdConceptInListFunction class methodsFor: 'platypus-generated-platypus-signature' stamp: ''!
iso10303P11Translater
	^ 'Platypus (c) LISYC EA3883, Universite de Bretagne occidentale. Brest.'

! !

!ExChdConceptInListFunction class methodsFor: 'platypus-generated-meta-data-accessing' stamp: ''!
schemaDefinition
	^ ExChdPackageSchemaDefinition singleton

! !

!ExChdConceptInListFunction class methodsFor: 'platypus-generated-platypus-signature' stamp: ''!
translatedFromISO10303P11
	^ true

! !

!ExChdConceptInListFunction class methodsFor: 'platypus-generated-platypus-signature' stamp: ''!
vwNamespaceName
	^ #Express2Cheddar

! !

!ExChdConceptInListFunction methodsFor: 'platypus-generated-accessing' stamp: ''!
c
	^ c

! !

!ExChdConceptInListFunction methodsFor: 'platypus-generated-accessing' stamp: ''!
c: aExChdDictionaryInstance
	c := aExChdDictionaryInstance

! !

!ExChdConceptInListFunction methodsFor: 'platypus-generated-accessing' stamp: ''!
c: aExChdDictionaryInstance l: aListOfExChdDictionaryInstance
	self c: aExChdDictionaryInstance.
	self l: aListOfExChdDictionaryInstance

! !

!ExChdConceptInListFunction methodsFor: 'platypus-generated-accessing' stamp: ''!
fromValues: values
	self c: (values at: 1).
	self l: (values at: 2)

! !

!ExChdConceptInListFunction methodsFor: 'platypus-generated-invoking' stamp: ''!
invoke
	" ---------- locals assignments ----------"

	self
		key:
			(PTsUpperizeFunction
				invokeFromValues:
					(OrderedCollection new
						add: (self c nameUsingContext: self class context);
						yourself)).	" ---------- statements ----------"
	PlatypusCoreRepeatStatement
		repeat: [ :no224 | 
			(PTsUpperizeFunction
				invokeFromValues:
					(OrderedCollection new
						add: ((self l pltAt: no224) nameUsingContext: self class context);
						yourself)) = self key
				ifTrue: [ ^ self return: true ] ]
		from:
			(PltLOINDEXFunction
				invokeFromValues:
					(OrderedCollection new
						add: self l;
						yourself))
		to:
			(PltHIINDEXFunction
				invokeFromValues:
					(OrderedCollection new
						add: self l;
						yourself)).
	^ self return: false

! !

!ExChdConceptInListFunction methodsFor: 'platypus-generated-accessing' stamp: ''!
key
	^ key

! !

!ExChdConceptInListFunction methodsFor: 'platypus-generated-accessing' stamp: ''!
key: aString
	key := aString

! !

!ExChdConceptInListFunction methodsFor: 'platypus-generated-accessing' stamp: ''!
l
	^ l

! !

!ExChdConceptInListFunction methodsFor: 'platypus-generated-accessing' stamp: ''!
l: aListOfExChdDictionaryInstance
	l := aListOfExChdDictionaryInstance
		ifNil: [ OrderedCollection new ]
		ifNotNil: [ aListOfExChdDictionaryInstance as: OrderedCollection ]

! !

PlatypusCoreAlgorithmDeclaration subclass: #ExChdConceptListLocalDependenciesFunction
	instanceVariableNames: 'sch l wl r'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Express2Cheddar-PackageSchema'!

!ExChdConceptListLocalDependenciesFunction commentStamp: 'platypus comment' prior: 0!
<ISO10303-11-EXPRESS>
FUNCTION concept_list_local_dependencies ( sch : schema_definition; l : LIST OF dictionary_instance ) : LIST OF dictionary_instance;
	LOCAL 
		wl : LIST OF dictionary_instance := [ ];
		r : LIST OF dictionary_instance := [ ];
	END_LOCAL;

	REPEAT no := LOINDEX ( l ) TO HIINDEX ( l );

		ALIAS c FOR l [ no];
			IF is_of_generated_concept_kind ( c ) THEN
				wl := c.dependencies;
				REPEAT noi := LOINDEX ( wl ) TO HIINDEX ( wl );
					IF NOT concept_in_list ( wl [ noi], r ) THEN
						r := r + wl [ noi];
					END_IF;
				END_REPEAT;
			END_IF;
		END_ALIAS;
	END_REPEAT;
	RETURN ( r );
END_FUNCTION;
</ISO10303-11-EXPRESS>!

!ExChdConceptListLocalDependenciesFunction class methodsFor: 'platypus-generated-platypus-signature' stamp: ''!
iso10303P11Translater
	^ 'Platypus (c) LISYC EA3883, Universite de Bretagne occidentale. Brest.'

! !

!ExChdConceptListLocalDependenciesFunction class methodsFor: 'platypus-generated-meta-data-accessing' stamp: ''!
schemaDefinition
	^ ExChdPackageSchemaDefinition singleton

! !

!ExChdConceptListLocalDependenciesFunction class methodsFor: 'platypus-generated-platypus-signature' stamp: ''!
translatedFromISO10303P11
	^ true

! !

!ExChdConceptListLocalDependenciesFunction class methodsFor: 'platypus-generated-platypus-signature' stamp: ''!
vwNamespaceName
	^ #Express2Cheddar

! !

!ExChdConceptListLocalDependenciesFunction methodsFor: 'platypus-generated-accessing' stamp: ''!
fromValues: values
	self sch: (values at: 1).
	self l: (values at: 2)

! !

!ExChdConceptListLocalDependenciesFunction methodsFor: 'platypus-generated-invoking' stamp: ''!
invoke
	" ---------- locals assignments ----------"

	self wl: Array new.
	self r: Array new.	" ---------- statements ----------"
	PlatypusCoreRepeatStatement
		repeat: [ :no992 | 
			PlatypusCoreAliasStatement
				alias: (self l pltAt: no992)
				statementsBlock: [ :c2673 | 
					(ExChdIsOfGeneratedConceptKindFunction
						invokeFromValues:
							(OrderedCollection new
								add: c2673;
								yourself))
						ifTrue: [ 
							self wl: (c2673 dependenciesUsingContext: self class context).
							PlatypusCoreRepeatStatement
								repeat: [ :noi2776 | 
									(ExChdConceptInListFunction
										invokeFromValues:
											(OrderedCollection new
												add: (self wl pltAt: noi2776);
												add: self r;
												yourself)) not
										ifTrue: [ self r: (self r pltPlus: (self wl pltAt: noi2776)) ] ]
								from:
									(PltLOINDEXFunction
										invokeFromValues:
											(OrderedCollection new
												add: self wl;
												yourself))
								to:
									(PltHIINDEXFunction
										invokeFromValues:
											(OrderedCollection new
												add: self wl;
												yourself)) ] ] ]
		from:
			(PltLOINDEXFunction
				invokeFromValues:
					(OrderedCollection new
						add: self l;
						yourself))
		to:
			(PltHIINDEXFunction
				invokeFromValues:
					(OrderedCollection new
						add: self l;
						yourself)).
	^ self return: self r

! !

!ExChdConceptListLocalDependenciesFunction methodsFor: 'platypus-generated-accessing' stamp: ''!
l
	^ l

! !

!ExChdConceptListLocalDependenciesFunction methodsFor: 'platypus-generated-accessing' stamp: ''!
l: aListOfExChdDictionaryInstance
	l := aListOfExChdDictionaryInstance
		ifNil: [ OrderedCollection new ]
		ifNotNil: [ aListOfExChdDictionaryInstance as: OrderedCollection ]

! !

!ExChdConceptListLocalDependenciesFunction methodsFor: 'platypus-generated-accessing' stamp: ''!
r
	^ r

! !

!ExChdConceptListLocalDependenciesFunction methodsFor: 'platypus-generated-accessing' stamp: ''!
r: aListOfExChdDictionaryInstance1
	r := aListOfExChdDictionaryInstance1
		ifNil: [ OrderedCollection new ]
		ifNotNil: [ aListOfExChdDictionaryInstance1 as: OrderedCollection ]

! !

!ExChdConceptListLocalDependenciesFunction methodsFor: 'platypus-generated-accessing' stamp: ''!
sch
	^ sch

! !

!ExChdConceptListLocalDependenciesFunction methodsFor: 'platypus-generated-accessing' stamp: ''!
sch: aExChdSchemaDefinition
	sch := aExChdSchemaDefinition

! !

!ExChdConceptListLocalDependenciesFunction methodsFor: 'platypus-generated-accessing' stamp: ''!
sch: aExChdSchemaDefinition l: aListOfExChdDictionaryInstance
	self sch: aExChdSchemaDefinition.
	self l: aListOfExChdDictionaryInstance

! !

!ExChdConceptListLocalDependenciesFunction methodsFor: 'platypus-generated-accessing' stamp: ''!
wl
	^ wl

! !

!ExChdConceptListLocalDependenciesFunction methodsFor: 'platypus-generated-accessing' stamp: ''!
wl: aListOfExChdDictionaryInstance
	wl := aListOfExChdDictionaryInstance
		ifNil: [ OrderedCollection new ]
		ifNotNil: [ aListOfExChdDictionaryInstance as: OrderedCollection ]

! !

PlatypusCoreAlgorithmDeclaration subclass: #ExChdConstrainedArrayTypeAdsCodeFunction
	instanceVariableNames: 'a code'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Express2Cheddar-CheddarDomainsSchema'!

!ExChdConstrainedArrayTypeAdsCodeFunction commentStamp: 'platypus comment' prior: 0!
<ISO10303-11-EXPRESS>
FUNCTION constrained_array_type_ads_code ( a : constrained_array_type ) : STRING;
	LOCAL 
		code : STRING := '';
	END_LOCAL;
	code := 'type ' + a.ada_ident + ' is Array ( ';

	IF EXISTS ( a.max_idx ) THEN
		code := code + a.min_idx + ' .. ' + a.max_idx;
	ELSE
		code := code + a.min_idx;
	END_IF;

	ALIAS etype FOR a.domain.element_type.handled;

		IF ( 'RECORD_AND_CLASS.ADA_CLASS' IN TYPEOF ( etype ) ) THEN
			code := code + ' ) of ' + etype.ptr_type + ';\n';
		ELSE
			code := code + ' ) of ' + etype.ada_ident + ';\n';
		END_IF;
	END_ALIAS;
	RETURN ( code );
END_FUNCTION;
</ISO10303-11-EXPRESS>!

!ExChdConstrainedArrayTypeAdsCodeFunction class methodsFor: 'platypus-generated-platypus-signature' stamp: ''!
iso10303P11Translater
	^ 'Platypus (c) LISYC EA3883, Universite de Bretagne occidentale. Brest.'

! !

!ExChdConstrainedArrayTypeAdsCodeFunction class methodsFor: 'platypus-generated-meta-data-accessing' stamp: ''!
schemaDefinition
	^ ExChdCheddarDomainsSchemaDefinition singleton

! !

!ExChdConstrainedArrayTypeAdsCodeFunction class methodsFor: 'platypus-generated-platypus-signature' stamp: ''!
translatedFromISO10303P11
	^ true

! !

!ExChdConstrainedArrayTypeAdsCodeFunction class methodsFor: 'platypus-generated-platypus-signature' stamp: ''!
vwNamespaceName
	^ #Express2Cheddar

! !

!ExChdConstrainedArrayTypeAdsCodeFunction methodsFor: 'platypus-generated-accessing' stamp: ''!
a
	^ a

! !

!ExChdConstrainedArrayTypeAdsCodeFunction methodsFor: 'platypus-generated-accessing' stamp: ''!
a: aExChdConstrainedArrayType
	a := aExChdConstrainedArrayType

! !

!ExChdConstrainedArrayTypeAdsCodeFunction methodsFor: 'platypus-generated-accessing' stamp: ''!
code
	^ code

! !

!ExChdConstrainedArrayTypeAdsCodeFunction methodsFor: 'platypus-generated-accessing' stamp: ''!
code: aString
	code := aString

! !

!ExChdConstrainedArrayTypeAdsCodeFunction methodsFor: 'platypus-generated-accessing' stamp: ''!
fromValues: values
	self a: (values at: 1)

! !

!ExChdConstrainedArrayTypeAdsCodeFunction methodsFor: 'platypus-generated-invoking' stamp: ''!
invoke
	" ---------- locals assignments ----------"

	self code: ''.	" ---------- statements ----------"
	self code: (('type ' pltPlus: (self a adaIdentUsingContext: self class context)) pltPlus: ' is Array ( ').
	(PltEXISTSFunction
		invokeFromValues:
			(OrderedCollection new
				add: (self a maxIdxUsingContext: self class context);
				yourself))
		ifTrue: [ 
			self
				code:
					(((self code pltPlus: (self a minIdxUsingContext: self class context)) pltPlus: ' .. ')
						pltPlus: (self a maxIdxUsingContext: self class context)) ]
		ifFalse: [ self code: (self code pltPlus: (self a minIdxUsingContext: self class context)) ].
	PlatypusCoreAliasStatement
		alias:
			(((self a domainUsingContext: self class context) elementTypeUsingContext: self class context)
				handledUsingContext: self class context)
		statementsBlock: [ :etype1823 | 
			((PltTYPEOFFunction
				invokeFromValues:
					(OrderedCollection new
						add: etype1823;
						yourself)) includes: 'RECORD_AND_CLASS.ADA_CLASS')
				ifTrue: [ self code: (((self code pltPlus: ' ) of ') pltPlus: (etype1823 ptrTypeUsingContext: self class context)) pltPlus: ';\n') ]
				ifFalse: [ 
					self
						code:
							(((self code pltPlus: ' ) of ') pltPlus: (etype1823 adaIdentUsingContext: self class context)) pltPlus: ';\n') ] ].
	^ self return: self code

! !

PlatypusCoreAlgorithmDeclaration subclass: #ExChdDependenciesOfAdaEntityFunction
	instanceVariableNames: 'o t r attrs'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Express2Cheddar-RecordAndClassSchema'!

!ExChdDependenciesOfAdaEntityFunction commentStamp: 'platypus comment' prior: 0!
<ISO10303-11-EXPRESS>
FUNCTION dependencies_of_ada_entity ( o : context_definition; t : ada_entity ) : LIST OF dictionary_instance;
	LOCAL 
		r : LIST OF dictionary_instance := [ ];
		attrs : LIST OF attribute := inherited_explicit_attributes ( t );
	END_LOCAL;

	REPEAT no := LOINDEX ( attrs ) TO HIINDEX ( attrs );
		r := r + dependencies_of ( o, attrs [ no].domain.handled );
	END_REPEAT;
	r := r + t;
	RETURN ( r );
END_FUNCTION;
</ISO10303-11-EXPRESS>!

!ExChdDependenciesOfAdaEntityFunction class methodsFor: 'platypus-generated-platypus-signature' stamp: ''!
iso10303P11Translater
	^ 'Platypus (c) LISYC EA3883, Universite de Bretagne occidentale. Brest.'

! !

!ExChdDependenciesOfAdaEntityFunction class methodsFor: 'platypus-generated-meta-data-accessing' stamp: ''!
schemaDefinition
	^ ExChdRecordAndClassSchemaDefinition singleton

! !

!ExChdDependenciesOfAdaEntityFunction class methodsFor: 'platypus-generated-platypus-signature' stamp: ''!
translatedFromISO10303P11
	^ true

! !

!ExChdDependenciesOfAdaEntityFunction class methodsFor: 'platypus-generated-platypus-signature' stamp: ''!
vwNamespaceName
	^ #Express2Cheddar

! !

!ExChdDependenciesOfAdaEntityFunction methodsFor: 'platypus-generated-accessing' stamp: ''!
attrs
	^ attrs

! !

!ExChdDependenciesOfAdaEntityFunction methodsFor: 'platypus-generated-accessing' stamp: ''!
attrs: aListOfExChdAttribute
	attrs := aListOfExChdAttribute
		ifNil: [ OrderedCollection new ]
		ifNotNil: [ aListOfExChdAttribute as: OrderedCollection ]

! !

!ExChdDependenciesOfAdaEntityFunction methodsFor: 'platypus-generated-accessing' stamp: ''!
fromValues: values
	self o: (values at: 1).
	self t: (values at: 2)

! !

!ExChdDependenciesOfAdaEntityFunction methodsFor: 'platypus-generated-invoking' stamp: ''!
invoke
	" ---------- locals assignments ----------"

	self r: Array new.
	self
		attrs:
			(PTsInheritedExplicitAttributesFunction
				invokeFromValues:
					(OrderedCollection new
						add: self t;
						yourself)).	" ---------- statements ----------"
	PlatypusCoreRepeatStatement
		repeat: [ :no2525 | 
			self
				r:
					(self r
						pltPlus:
							(ExChdDependenciesOfFunction
								invokeFromValues:
									(OrderedCollection new
										add: self o;
										add:
												(((self attrs pltAt: no2525) domainUsingContext: self class context) handledUsingContext: self class context);
										yourself))) ]
		from:
			(PltLOINDEXFunction
				invokeFromValues:
					(OrderedCollection new
						add: self attrs;
						yourself))
		to:
			(PltHIINDEXFunction
				invokeFromValues:
					(OrderedCollection new
						add: self attrs;
						yourself)).
	self r: (self r pltPlus: self t).
	^ self return: self r

! !

!ExChdDependenciesOfAdaEntityFunction methodsFor: 'platypus-generated-accessing' stamp: ''!
o
	^ o

! !

!ExChdDependenciesOfAdaEntityFunction methodsFor: 'platypus-generated-accessing' stamp: ''!
o: aExChdContextDefinition
	o := aExChdContextDefinition

! !

!ExChdDependenciesOfAdaEntityFunction methodsFor: 'platypus-generated-accessing' stamp: ''!
o: aExChdContextDefinition t: aExChdAdaEntity
	self o: aExChdContextDefinition.
	self t: aExChdAdaEntity

! !

!ExChdDependenciesOfAdaEntityFunction methodsFor: 'platypus-generated-accessing' stamp: ''!
r
	^ r

! !

!ExChdDependenciesOfAdaEntityFunction methodsFor: 'platypus-generated-accessing' stamp: ''!
r: aListOfExChdDictionaryInstance
	r := aListOfExChdDictionaryInstance
		ifNil: [ OrderedCollection new ]
		ifNotNil: [ aListOfExChdDictionaryInstance as: OrderedCollection ]

! !

!ExChdDependenciesOfAdaEntityFunction methodsFor: 'platypus-generated-accessing' stamp: ''!
t
	^ t

! !

!ExChdDependenciesOfAdaEntityFunction methodsFor: 'platypus-generated-accessing' stamp: ''!
t: aExChdAdaEntity
	t := aExChdAdaEntity

! !

PlatypusCoreAlgorithmDeclaration subclass: #ExChdDependenciesOfFunction
	instanceVariableNames: 'o t r'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Express2Cheddar-CheddarDomainsSchema'!

!ExChdDependenciesOfFunction commentStamp: 'platypus comment' prior: 0!
<ISO10303-11-EXPRESS>
FUNCTION dependencies_of ( o : context_definition; t : dictionary_instance ) : LIST OF dictionary_instance;
	LOCAL 
		r : LIST OF dictionary_instance := [ ];
	END_LOCAL;

	IF ( 'PLATYPUS_DICTIONARY_SCHEMA.AGGREGATION_TYPE' IN TYPEOF ( t ) ) THEN
		r := r + dependencies_of ( o, t.element_type.handled );
	ELSE

		IF is_of_generated_concept_kind ( t ) THEN
			IF ( t.owner = o ) THEN
				r := r + t.dependencies + t;
			END_IF;
		END_IF;
	END_IF;
	RETURN ( r );
END_FUNCTION;
</ISO10303-11-EXPRESS>!

!ExChdDependenciesOfFunction class methodsFor: 'platypus-generated-platypus-signature' stamp: ''!
iso10303P11Translater
	^ 'Platypus (c) LISYC EA3883, Universite de Bretagne occidentale. Brest.'

! !

!ExChdDependenciesOfFunction class methodsFor: 'platypus-generated-meta-data-accessing' stamp: ''!
schemaDefinition
	^ ExChdCheddarDomainsSchemaDefinition singleton

! !

!ExChdDependenciesOfFunction class methodsFor: 'platypus-generated-platypus-signature' stamp: ''!
translatedFromISO10303P11
	^ true

! !

!ExChdDependenciesOfFunction class methodsFor: 'platypus-generated-platypus-signature' stamp: ''!
vwNamespaceName
	^ #Express2Cheddar

! !

!ExChdDependenciesOfFunction methodsFor: 'platypus-generated-accessing' stamp: ''!
fromValues: values
	self o: (values at: 1).
	self t: (values at: 2)

! !

!ExChdDependenciesOfFunction methodsFor: 'platypus-generated-invoking' stamp: ''!
invoke
	" ---------- locals assignments ----------"

	self r: Array new.	" ---------- statements ----------"
	((PltTYPEOFFunction
		invokeFromValues:
			(OrderedCollection new
				add: self t;
				yourself)) includes: 'PLATYPUS_DICTIONARY_SCHEMA.AGGREGATION_TYPE')
		ifTrue: [ 
			self
				r:
					(self r
						pltPlus:
							(ExChdDependenciesOfFunction
								invokeFromValues:
									(OrderedCollection new
										add: self o;
										add: ((self t elementTypeUsingContext: self class context) handledUsingContext: self class context);
										yourself))) ]
		ifFalse: [ 
			(ExChdIsOfGeneratedConceptKindFunction
				invokeFromValues:
					(OrderedCollection new
						add: self t;
						yourself))
				ifTrue: [ 
					(self t ownerUsingContext: self class context) = self o
						ifTrue: [ self r: ((self r pltPlus: (self t dependenciesUsingContext: self class context)) pltPlus: self t) ] ] ].
	^ self return: self r

! !

!ExChdDependenciesOfFunction methodsFor: 'platypus-generated-accessing' stamp: ''!
o
	^ o

! !

!ExChdDependenciesOfFunction methodsFor: 'platypus-generated-accessing' stamp: ''!
o: aExChdContextDefinition
	o := aExChdContextDefinition

! !

!ExChdDependenciesOfFunction methodsFor: 'platypus-generated-accessing' stamp: ''!
o: aExChdContextDefinition t: aExChdDictionaryInstance
	self o: aExChdContextDefinition.
	self t: aExChdDictionaryInstance

! !

!ExChdDependenciesOfFunction methodsFor: 'platypus-generated-accessing' stamp: ''!
r
	^ r

! !

!ExChdDependenciesOfFunction methodsFor: 'platypus-generated-accessing' stamp: ''!
r: aListOfExChdDictionaryInstance
	r := aListOfExChdDictionaryInstance
		ifNil: [ OrderedCollection new ]
		ifNotNil: [ aListOfExChdDictionaryInstance as: OrderedCollection ]

! !

!ExChdDependenciesOfFunction methodsFor: 'platypus-generated-accessing' stamp: ''!
t
	^ t

! !

!ExChdDependenciesOfFunction methodsFor: 'platypus-generated-accessing' stamp: ''!
t: aExChdDictionaryInstance
	t := aExChdDictionaryInstance

! !

PlatypusCoreAlgorithmDeclaration subclass: #ExChdDerivedAttributeInitializeFunction
	instanceVariableNames: 'attr code val key'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Express2Cheddar-RecordAndClassSchema'!

!ExChdDerivedAttributeInitializeFunction commentStamp: 'platypus comment' prior: 0!
<ISO10303-11-EXPRESS>
FUNCTION derived_attribute_initialize ( attr : explicit_attribute ) : STRING;
	LOCAL 
		code : STRING;
		val : STRING;
		key : STRING := upperize ( attr.name );
	END_LOCAL;

	IF EXISTS ( attr.redeclaring ) THEN

		IF SIZEOF ( QUERY ( a <* inherited_explicit_attributes ( attr.owner ) | upperize ( a.name ) = key ) ) > 0 THEN
			val := basic_ada_type_value_format ( attr.assign, ? ).formated;
			code := 'obj.' + attr.name + ' := ' + val + ';';
		END_IF;
	END_IF;
	RETURN ( code );
END_FUNCTION;
</ISO10303-11-EXPRESS>!

!ExChdDerivedAttributeInitializeFunction class methodsFor: 'platypus-generated-platypus-signature' stamp: ''!
iso10303P11Translater
	^ 'Platypus (c) LISYC EA3883, Universite de Bretagne occidentale. Brest.'

! !

!ExChdDerivedAttributeInitializeFunction class methodsFor: 'platypus-generated-meta-data-accessing' stamp: ''!
schemaDefinition
	^ ExChdRecordAndClassSchemaDefinition singleton

! !

!ExChdDerivedAttributeInitializeFunction class methodsFor: 'platypus-generated-platypus-signature' stamp: ''!
translatedFromISO10303P11
	^ true

! !

!ExChdDerivedAttributeInitializeFunction class methodsFor: 'platypus-generated-platypus-signature' stamp: ''!
vwNamespaceName
	^ #Express2Cheddar

! !

!ExChdDerivedAttributeInitializeFunction methodsFor: 'platypus-generated-accessing' stamp: ''!
attr
	^ attr

! !

!ExChdDerivedAttributeInitializeFunction methodsFor: 'platypus-generated-accessing' stamp: ''!
attr: aExChdExplicitAttribute
	attr := aExChdExplicitAttribute

! !

!ExChdDerivedAttributeInitializeFunction methodsFor: 'platypus-generated-accessing' stamp: ''!
code
	^ code

! !

!ExChdDerivedAttributeInitializeFunction methodsFor: 'platypus-generated-accessing' stamp: ''!
code: aString
	code := aString

! !

!ExChdDerivedAttributeInitializeFunction methodsFor: 'platypus-generated-accessing' stamp: ''!
fromValues: values
	self attr: (values at: 1)

! !

!ExChdDerivedAttributeInitializeFunction methodsFor: 'platypus-generated-invoking' stamp: ''!
invoke
	" ---------- locals assignments ----------"

	self
		key:
			(PTsUpperizeFunction
				invokeFromValues:
					(OrderedCollection new
						add: (self attr nameUsingContext: self class context);
						yourself)).	" ---------- statements ----------"
	(PltEXISTSFunction
		invokeFromValues:
			(OrderedCollection new
				add: (self attr redeclaringUsingContext: self class context);
				yourself))
		ifTrue: [ 
			(PltSIZEOFFunction
				invokeFromValues:
					(OrderedCollection new
						add:
								((PTsInheritedExplicitAttributesFunction
										invokeFromValues:
											(OrderedCollection new
												add: (self attr ownerUsingContext: self class context);
												yourself))
										select: [ :a1884 | 
											(PTsUpperizeFunction
												invokeFromValues:
													(OrderedCollection new
														add: (a1884 nameUsingContext: self class context);
														yourself)) = self key ]);
						yourself)) > 0
				ifTrue: [ 
					self
						val:
							((ExChdBasicAdaTypeValueFormat new
								basicAdaTypeValueFormatFromValues:
										(OrderedCollection new
												add: (self attr assignUsingContext: self class context);
												add: nil;
												yourself);
								yourself) formatedUsingContext: self class context).
					self
						code:
							(((('obj.' pltPlus: (self attr nameUsingContext: self class context)) pltPlus: ' := ') pltPlus: self val) pltPlus: ';') ] ].
	^ self return: self code

! !

!ExChdDerivedAttributeInitializeFunction methodsFor: 'platypus-generated-accessing' stamp: ''!
key
	^ key

! !

!ExChdDerivedAttributeInitializeFunction methodsFor: 'platypus-generated-accessing' stamp: ''!
key: aString2
	key := aString2

! !

!ExChdDerivedAttributeInitializeFunction methodsFor: 'platypus-generated-accessing' stamp: ''!
val
	^ val

! !

!ExChdDerivedAttributeInitializeFunction methodsFor: 'platypus-generated-accessing' stamp: ''!
val: aString1
	val := aString1

! !

PlatypusCoreAlgorithmDeclaration subclass: #ExChdDiscriminatedTypeAdbCodeFunction
	instanceVariableNames: 'typ code acode discrimAttr unionAttr unionType unionAttributes translAttrs v'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Express2Cheddar-DiscriminatedTypeSchema'!

!ExChdDiscriminatedTypeAdbCodeFunction commentStamp: 'platypus comment' prior: 0!
<ISO10303-11-EXPRESS>
FUNCTION discriminated_type_adb_code ( typ : discriminated_type ) : STRING;
	LOCAL 
		code : STRING;
		acode : STRING;
		discrim_attr : attribute := typ.discriminant;
		union_attr : attribute := typ.union_attr;
		union_type : defined_type := union_attr.domain.handled;
		union_attributes : LIST OF attribute := inherited_explicit_attributes ( union_type );
		transl_attrs : LIST OF attribute := typ.translated_attributes;
		v : STRING := 'New_' + typ.name;
	END_LOCAL;
	code := 'procedure Initialize (obj : out ' + typ.name + '_Ptr) is\n' 
	+ 'begin\n' 
	+ '\tobj := NULL;\n' 
	+ 'end Initialize;\n \n' 
	+ 'procedure Put(obj : in ' + typ.name + '_Ptr) is\n' 
	+ 'begin\n' 
	+ '\tif (obj /= NULL) then\n';

	REPEAT no := LOINDEX ( transl_attrs ) TO HIINDEX ( transl_attrs );

		ALIAS attr FOR transl_attrs [ no];
			acode := explicit_attribute_put ( attr );
			IF ( acode > '' ) THEN
				code := code + '\t\t' + acode + '\n';
			END_IF;
		END_ALIAS;
	END_REPEAT;
	code := code + '\t\t' + explicit_attribute_put ( discrim_attr ) + '\n' 
	+ '\t\tput ( "value: " );\n' 
	+ '\t\tcase obj.' + discrim_attr.name + ' is \n';

	REPEAT no := LOINDEX ( union_attributes ) TO HIINDEX ( union_attributes );

		ALIAS union_attr FOR union_attributes [ no];
			ALIAS ada_domain FOR basic_ada_domain ( union_attr.domain ).handled;
				ALIAS element_attributes FOR inherited_explicit_attributes ( ada_domain );
					code := code + '\t\t\twhen ' + union_attr.name + ' => \n';
					REPEAT noi := LOINDEX ( element_attributes ) TO HIINDEX ( element_attributes );
						ALIAS element_attr FOR element_attributes [ noi];
							acode := explicit_attribute_put ( element_attr );
							IF ( acode > '' ) THEN
								code := code + '\t\t\t\t' + acode + '\n';
							END_IF;
						END_ALIAS;
					END_REPEAT;
				END_ALIAS;
			END_ALIAS;
		END_ALIAS;
		code := code + '\n';
	END_REPEAT;
	code := code + '\t\tend case;\n\tend if;\n\tNew_Line;\nend Put;\n\n' 

	+ 'function Copy ( obj : in ' + typ.name + ' ) return ' + typ.ptr_type + ' is\n' 
	+ '\t' + v + ' : ' + typ.ptr_type + ';\n' 
	+ 'begin\n' 
	+ '\t' + v + ' := new ' + typ.name + '''(obj);\n' 
	+ '\treturn (' + v + ');\n' 
	+ 'end Copy;\n\n' 

	+ 'function Copy ( obj : in ' + typ.ptr_type + ' ) return ' + typ.ptr_type + ' is\n' 
	+ 'begin\n' 
	+ '\treturn copy(obj.all);\n' 
	+ 'end Copy;\n\n' 

	+ 'function XML_String(obj : in ' + typ.name + ') return Unbounded_String is\n' 
	+ '\tresult : Unbounded_String;\n' 
	+ 'begin\n' 
	+ '	result := to_unbounded_string("<' + typ.html_tag + '>");\n';

	REPEAT no := LOINDEX ( transl_attrs ) TO HIINDEX ( transl_attrs );

		ALIAS attr FOR transl_attrs [ no];
			acode := explicit_attribute_xml_writer_code ( 'obj', attr );
			IF ( acode > '' ) THEN
				code := code + '\t\t' + acode + '\n';
			END_IF;
		END_ALIAS;
	END_REPEAT;
	code := code + explicit_attribute_xml_writer_code ( 'obj', discrim_attr ) + '\n\n' 

	+ '\tcase obj.' + discrim_attr.name + ' is \n';

	REPEAT no := LOINDEX ( union_attributes ) TO HIINDEX ( union_attributes );

		ALIAS union_attr FOR union_attributes [ no];
			ALIAS ada_domain FOR basic_ada_domain ( union_attr.domain ).handled;
				ALIAS element_attributes FOR inherited_explicit_attributes ( ada_domain );
					code := code + '\t\twhen ' + union_attr.name + ' => \n';
					REPEAT noi := LOINDEX ( element_attributes ) TO HIINDEX ( element_attributes );
						ALIAS element_attr FOR element_attributes [ noi];
							acode := explicit_attribute_xml_writer_code ( 'obj', element_attr );
							IF ( acode > '' ) THEN
								code := code + '\t\t' + acode + '\n';
							END_IF;
						END_ALIAS;
					END_REPEAT;
				END_ALIAS;
			END_ALIAS;
		END_ALIAS;
		code := code + '\n';
	END_REPEAT;
	code := code + '\tend case;\n' 
	+ '\tresult := result & to_unbounded_string("</' + typ.html_tag + '>");\n' 
	+ '\treturn (result);\n' 
	+ 'end XML_String;\n\n' 

	+ 'function XML_String(obj : in ' + typ.name + '_Ptr) return Unbounded_String is\n' 
	+ 'begin\n' 
	+ '	return XML_String(obj.all);\n' 
	+ 'end XML_String;\n\n' 

	+ 'function XML_Ref_String(obj : in ' + typ.name + ') return Unbounded_String is\n' 
	+ '\tresult : Unbounded_String;\n' 
	+ 'begin\n' 
	+ '	raise xml_ref_string_error;\n' 
	+ '	return to_unbounded_string("");\n' 
	+ 'end XML_Ref_String;\n' 
	+ 'function XML_Ref_String(obj : in ' + typ.name + '_Ptr) return Unbounded_String is\n' 
	+ 'begin\n' 
	+ '	return XML_Ref_String(obj.all);\n' 
	+ 'end XML_Ref_String;\n\n';
	RETURN ( code );
END_FUNCTION;
</ISO10303-11-EXPRESS>!

!ExChdDiscriminatedTypeAdbCodeFunction class methodsFor: 'platypus-generated-platypus-signature' stamp: ''!
iso10303P11Translater
	^ 'Platypus (c) LISYC EA3883, Universite de Bretagne occidentale. Brest.'

! !

!ExChdDiscriminatedTypeAdbCodeFunction class methodsFor: 'platypus-generated-meta-data-accessing' stamp: ''!
schemaDefinition
	^ ExChdDiscriminatedTypeSchemaDefinition singleton

! !

!ExChdDiscriminatedTypeAdbCodeFunction class methodsFor: 'platypus-generated-platypus-signature' stamp: ''!
translatedFromISO10303P11
	^ true

! !

!ExChdDiscriminatedTypeAdbCodeFunction class methodsFor: 'platypus-generated-platypus-signature' stamp: ''!
vwNamespaceName
	^ #Express2Cheddar

! !

!ExChdDiscriminatedTypeAdbCodeFunction methodsFor: 'platypus-generated-accessing' stamp: ''!
acode
	^ acode

! !

!ExChdDiscriminatedTypeAdbCodeFunction methodsFor: 'platypus-generated-accessing' stamp: ''!
acode: aString1
	acode := aString1

! !

!ExChdDiscriminatedTypeAdbCodeFunction methodsFor: 'platypus-generated-accessing' stamp: ''!
code
	^ code

! !

!ExChdDiscriminatedTypeAdbCodeFunction methodsFor: 'platypus-generated-accessing' stamp: ''!
code: aString
	code := aString

! !

!ExChdDiscriminatedTypeAdbCodeFunction methodsFor: 'platypus-generated-accessing' stamp: ''!
discrimAttr
	^ discrimAttr

! !

!ExChdDiscriminatedTypeAdbCodeFunction methodsFor: 'platypus-generated-accessing' stamp: ''!
discrimAttr: aExChdAttribute
	discrimAttr := aExChdAttribute

! !

!ExChdDiscriminatedTypeAdbCodeFunction methodsFor: 'platypus-generated-accessing' stamp: ''!
fromValues: values
	self typ: (values at: 1)

! !

!ExChdDiscriminatedTypeAdbCodeFunction methodsFor: 'platypus-generated-invoking' stamp: ''!
invoke
	" ---------- locals assignments ----------"

	self discrimAttr: (self typ discriminantUsingContext: self class context).
	self unionAttr: (self typ unionAttrUsingContext: self class context).
	self unionType: ((self unionAttr domainUsingContext: self class context) handledUsingContext: self class context).
	self
		unionAttributes:
			(PTsInheritedExplicitAttributesFunction
				invokeFromValues:
					(OrderedCollection new
						add: self unionType;
						yourself)).
	self translAttrs: (self typ translatedAttributesUsingContext: self class context).
	self v: ('New_' pltPlus: (self typ nameUsingContext: self class context)).	" ---------- statements ----------"
	self
		code:
			(((((((((('procedure Initialize (obj : out ' pltPlus: (self typ nameUsingContext: self class context))
				pltPlus: '_Ptr) is\n') pltPlus: 'begin\n') pltPlus: '\tobj := NULL;\n') pltPlus: 'end Initialize;\n \n')
				pltPlus: 'procedure Put(obj : in ') pltPlus: (self typ nameUsingContext: self class context)) pltPlus: '_Ptr) is\n')
				pltPlus: 'begin\n') pltPlus: '\tif (obj /= NULL) then\n').
	PlatypusCoreRepeatStatement
		repeat: [ :no1219 | 
			PlatypusCoreAliasStatement
				alias: (self translAttrs pltAt: no1219)
				statementsBlock: [ :attr3046 | 
					self
						acode:
							(ExChdExplicitAttributePutFunction
								invokeFromValues:
									(OrderedCollection new
										add: attr3046;
										yourself)).
					self acode > ''
						ifTrue: [ self code: (((self code pltPlus: '\t\t') pltPlus: self acode) pltPlus: '\n') ] ] ]
		from:
			(PltLOINDEXFunction
				invokeFromValues:
					(OrderedCollection new
						add: self translAttrs;
						yourself))
		to:
			(PltHIINDEXFunction
				invokeFromValues:
					(OrderedCollection new
						add: self translAttrs;
						yourself)).
	self
		code:
			(((((((self code pltPlus: '\t\t')
				pltPlus:
					(ExChdExplicitAttributePutFunction
						invokeFromValues:
							(OrderedCollection new
								add: self discrimAttr;
								yourself))) pltPlus: '\n') pltPlus: '\t\tput ( "value: " );\n') pltPlus: '\t\tcase obj.')
				pltPlus: (self discrimAttr nameUsingContext: self class context)) pltPlus: ' is \n').
	PlatypusCoreRepeatStatement
		repeat: [ :no2718 | 
			PlatypusCoreAliasStatement
				alias: (self unionAttributes pltAt: no2718)
				statementsBlock: [ :unionAttr459 | 
					PlatypusCoreAliasStatement
						alias:
							((ExChdBasicAdaDomainFunction
								invokeFromValues:
									(OrderedCollection new
										add: (unionAttr459 domainUsingContext: self class context);
										yourself)) handledUsingContext: self class context)
						statementsBlock: [ :adaDomain110 | 
							PlatypusCoreAliasStatement
								alias:
									(PTsInheritedExplicitAttributesFunction
										invokeFromValues:
											(OrderedCollection new
												add: adaDomain110;
												yourself))
								statementsBlock: [ :elementAttributes2436 | 
									self
										code:
											(((self code pltPlus: '\t\t\twhen ') pltPlus: (unionAttr459 nameUsingContext: self class context)) pltPlus: ' => \n').
									PlatypusCoreRepeatStatement
										repeat: [ :noi610 | 
											PlatypusCoreAliasStatement
												alias: (elementAttributes2436 pltAt: noi610)
												statementsBlock: [ :elementAttr3039 | 
													self
														acode:
															(ExChdExplicitAttributePutFunction
																invokeFromValues:
																	(OrderedCollection new
																		add: elementAttr3039;
																		yourself)).
													self acode > ''
														ifTrue: [ self code: (((self code pltPlus: '\t\t\t\t') pltPlus: self acode) pltPlus: '\n') ] ] ]
										from:
											(PltLOINDEXFunction
												invokeFromValues:
													(OrderedCollection new
														add: elementAttributes2436;
														yourself))
										to:
											(PltHIINDEXFunction
												invokeFromValues:
													(OrderedCollection new
														add: elementAttributes2436;
														yourself)) ] ] ].
			self code: (self code pltPlus: '\n') ]
		from:
			(PltLOINDEXFunction
				invokeFromValues:
					(OrderedCollection new
						add: self unionAttributes;
						yourself))
		to:
			(PltHIINDEXFunction
				invokeFromValues:
					(OrderedCollection new
						add: self unionAttributes;
						yourself)).
	self
		code:
			(((((((((((((((((((((((((((((((((((((self code pltPlus: '\t\tend case;\n\tend if;\n\tNew_Line;\nend Put;\n\n')
				pltPlus: 'function Copy ( obj : in ') pltPlus: (self typ nameUsingContext: self class context))
				pltPlus: ' ) return ') pltPlus: (self typ ptrTypeUsingContext: self class context)) pltPlus: ' is\n') pltPlus: '\t')
				pltPlus: self v) pltPlus: ' : ') pltPlus: (self typ ptrTypeUsingContext: self class context)) pltPlus: ';\n')
				pltPlus: 'begin\n') pltPlus: '\t') pltPlus: self v) pltPlus: ' := new ')
				pltPlus: (self typ nameUsingContext: self class context)) pltPlus: '''(obj);\n') pltPlus: '\treturn (')
				pltPlus: self v) pltPlus: ');\n') pltPlus: 'end Copy;\n\n') pltPlus: 'function Copy ( obj : in ')
				pltPlus: (self typ ptrTypeUsingContext: self class context)) pltPlus: ' ) return ')
				pltPlus: (self typ ptrTypeUsingContext: self class context)) pltPlus: ' is\n') pltPlus: 'begin\n')
				pltPlus: '\treturn copy(obj.all);\n') pltPlus: 'end Copy;\n\n') pltPlus: 'function XML_String(obj : in ')
				pltPlus: (self typ nameUsingContext: self class context)) pltPlus: ') return Unbounded_String is\n')
				pltPlus: '\tresult : Unbounded_String;\n') pltPlus: 'begin\n') pltPlus: '	result := to_unbounded_string("<')
				pltPlus: (self typ htmlTagUsingContext: self class context)) pltPlus: '>");\n').
	PlatypusCoreRepeatStatement
		repeat: [ :no1134 | 
			PlatypusCoreAliasStatement
				alias: (self translAttrs pltAt: no1134)
				statementsBlock: [ :attr2961 | 
					self
						acode:
							(ExChdExplicitAttributeXmlWriterCodeFunction
								invokeFromValues:
									(OrderedCollection new
										add: 'obj';
										add: attr2961;
										yourself)).
					self acode > ''
						ifTrue: [ self code: (((self code pltPlus: '\t\t') pltPlus: self acode) pltPlus: '\n') ] ] ]
		from:
			(PltLOINDEXFunction
				invokeFromValues:
					(OrderedCollection new
						add: self translAttrs;
						yourself))
		to:
			(PltHIINDEXFunction
				invokeFromValues:
					(OrderedCollection new
						add: self translAttrs;
						yourself)).
	self
		code:
			(((((self code
				pltPlus:
					(ExChdExplicitAttributeXmlWriterCodeFunction
						invokeFromValues:
							(OrderedCollection new
								add: 'obj';
								add: self discrimAttr;
								yourself))) pltPlus: '\n\n') pltPlus: '\tcase obj.')
				pltPlus: (self discrimAttr nameUsingContext: self class context)) pltPlus: ' is \n').
	PlatypusCoreRepeatStatement
		repeat: [ :no2160 | 
			PlatypusCoreAliasStatement
				alias: (self unionAttributes pltAt: no2160)
				statementsBlock: [ :unionAttr4002 | 
					PlatypusCoreAliasStatement
						alias:
							((ExChdBasicAdaDomainFunction
								invokeFromValues:
									(OrderedCollection new
										add: (unionAttr4002 domainUsingContext: self class context);
										yourself)) handledUsingContext: self class context)
						statementsBlock: [ :adaDomain3653 | 
							PlatypusCoreAliasStatement
								alias:
									(PTsInheritedExplicitAttributesFunction
										invokeFromValues:
											(OrderedCollection new
												add: adaDomain3653;
												yourself))
								statementsBlock: [ :elementAttributes1883 | 
									self
										code:
											(((self code pltPlus: '\t\twhen ') pltPlus: (unionAttr4002 nameUsingContext: self class context)) pltPlus: ' => \n').
									PlatypusCoreRepeatStatement
										repeat: [ :noi56 | 
											PlatypusCoreAliasStatement
												alias: (elementAttributes1883 pltAt: noi56)
												statementsBlock: [ :elementAttr2485 | 
													self
														acode:
															(ExChdExplicitAttributeXmlWriterCodeFunction
																invokeFromValues:
																	(OrderedCollection new
																		add: 'obj';
																		add: elementAttr2485;
																		yourself)).
													self acode > ''
														ifTrue: [ self code: (((self code pltPlus: '\t\t') pltPlus: self acode) pltPlus: '\n') ] ] ]
										from:
											(PltLOINDEXFunction
												invokeFromValues:
													(OrderedCollection new
														add: elementAttributes1883;
														yourself))
										to:
											(PltHIINDEXFunction
												invokeFromValues:
													(OrderedCollection new
														add: elementAttributes1883;
														yourself)) ] ] ].
			self code: (self code pltPlus: '\n') ]
		from:
			(PltLOINDEXFunction
				invokeFromValues:
					(OrderedCollection new
						add: self unionAttributes;
						yourself))
		to:
			(PltHIINDEXFunction
				invokeFromValues:
					(OrderedCollection new
						add: self unionAttributes;
						yourself)).
	self
		code:
			((((((((((((((((((((((((((self code pltPlus: '\tend case;\n') pltPlus: '\tresult := result & to_unbounded_string("</')
				pltPlus: (self typ htmlTagUsingContext: self class context)) pltPlus: '>");\n') pltPlus: '\treturn (result);\n')
				pltPlus: 'end XML_String;\n\n') pltPlus: 'function XML_String(obj : in ')
				pltPlus: (self typ nameUsingContext: self class context)) pltPlus: '_Ptr) return Unbounded_String is\n')
				pltPlus: 'begin\n') pltPlus: '	return XML_String(obj.all);\n') pltPlus: 'end XML_String;\n\n')
				pltPlus: 'function XML_Ref_String(obj : in ') pltPlus: (self typ nameUsingContext: self class context))
				pltPlus: ') return Unbounded_String is\n') pltPlus: '\tresult : Unbounded_String;\n') pltPlus: 'begin\n')
				pltPlus: '	raise xml_ref_string_error;\n') pltPlus: '	return to_unbounded_string("");\n')
				pltPlus: 'end XML_Ref_String;\n') pltPlus: 'function XML_Ref_String(obj : in ')
				pltPlus: (self typ nameUsingContext: self class context)) pltPlus: '_Ptr) return Unbounded_String is\n')
				pltPlus: 'begin\n') pltPlus: '	return XML_Ref_String(obj.all);\n') pltPlus: 'end XML_Ref_String;\n\n').
	^ self return: self code

! !

!ExChdDiscriminatedTypeAdbCodeFunction methodsFor: 'platypus-generated-accessing' stamp: ''!
translAttrs
	^ translAttrs

! !

!ExChdDiscriminatedTypeAdbCodeFunction methodsFor: 'platypus-generated-accessing' stamp: ''!
translAttrs: aListOfExChdAttribute1
	translAttrs := aListOfExChdAttribute1
		ifNil: [ OrderedCollection new ]
		ifNotNil: [ aListOfExChdAttribute1 as: OrderedCollection ]

! !

!ExChdDiscriminatedTypeAdbCodeFunction methodsFor: 'platypus-generated-accessing' stamp: ''!
typ
	^ typ

! !

!ExChdDiscriminatedTypeAdbCodeFunction methodsFor: 'platypus-generated-accessing' stamp: ''!
typ: aExChdDiscriminatedType
	typ := aExChdDiscriminatedType

! !

!ExChdDiscriminatedTypeAdbCodeFunction methodsFor: 'platypus-generated-accessing' stamp: ''!
unionAttr
	^ unionAttr

! !

!ExChdDiscriminatedTypeAdbCodeFunction methodsFor: 'platypus-generated-accessing' stamp: ''!
unionAttr: aExChdAttribute1
	unionAttr := aExChdAttribute1

! !

!ExChdDiscriminatedTypeAdbCodeFunction methodsFor: 'platypus-generated-accessing' stamp: ''!
unionAttributes
	^ unionAttributes

! !

!ExChdDiscriminatedTypeAdbCodeFunction methodsFor: 'platypus-generated-accessing' stamp: ''!
unionAttributes: aListOfExChdAttribute
	unionAttributes := aListOfExChdAttribute
		ifNil: [ OrderedCollection new ]
		ifNotNil: [ aListOfExChdAttribute as: OrderedCollection ]

! !

!ExChdDiscriminatedTypeAdbCodeFunction methodsFor: 'platypus-generated-accessing' stamp: ''!
unionType
	^ unionType

! !

!ExChdDiscriminatedTypeAdbCodeFunction methodsFor: 'platypus-generated-accessing' stamp: ''!
unionType: aExChdDefinedType
	unionType := aExChdDefinedType

! !

!ExChdDiscriminatedTypeAdbCodeFunction methodsFor: 'platypus-generated-accessing' stamp: ''!
v
	^ v

! !

!ExChdDiscriminatedTypeAdbCodeFunction methodsFor: 'platypus-generated-accessing' stamp: ''!
v: aString2
	v := aString2

! !

PlatypusCoreAlgorithmDeclaration subclass: #ExChdDiscriminatedTypeAdsCodeFunction
	instanceVariableNames: 'typ result discrimAttr discrimType unionAttr unionType unionSelections domain translAttrs'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Express2Cheddar-DiscriminatedTypeSchema'!

!ExChdDiscriminatedTypeAdsCodeFunction commentStamp: 'platypus comment' prior: 0!
<ISO10303-11-EXPRESS>
FUNCTION discriminated_type_ads_code ( typ : discriminated_type ) : STRING;
	LOCAL 
		result : STRING;
		discrim_attr : attribute := typ.discriminant;
		discrim_type : entity_instance := discrim_attr.domain.handled;
		union_attr : attribute := typ.union_attr;
		union_type : defined_type := union_attr.domain.handled;
		union_selections : LIST OF attribute := inherited_explicit_attributes ( union_type );
		domain : entity_instance;
		transl_attrs : LIST OF attribute := typ.translated_attributes;
	END_LOCAL;
	result := 'type ' + typ.name + ' (' + discrim_attr.name + ' : ' + discrim_type.name + ' ) is record\n';

	REPEAT no := LOINDEX ( transl_attrs ) TO HIINDEX ( transl_attrs );

		ALIAS attr FOR transl_attrs [ no];
			domain := basic_ada_domain ( attr.domain );
			IF ( 'RECORD_AND_CLASS.ADA_CLASS' IN TYPEOF ( domain.handled ) ) THEN
				result := result + '\t' + attr.name + ' : ' + domain.handled.ptr_type + ';\n';
			ELSE
				result := result + '\t' + attr.name + ' : ' + domain.ada_ref_ident + ';\n';
			END_IF;
		END_ALIAS;
	END_REPEAT;
	result := result + '\tcase ' + discrim_attr.name + ' is \n' 
	+ union_type.union_ads_code + '\tend case;\nend record;\n\n' 

	+ 'type ' + typ.ptr_type + ' is access all ' + typ.name + ';\n' 
	+ '\nprocedure Initialize(obj : out ' + typ.ptr_type + ');\n' 
	+ '\nprocedure Put(obj : in ' + typ.ptr_type + ');\n' 
	+ 'function Copy(obj : in ' + typ.ptr_type + ') return ' + typ.ptr_type + ';\n' 
	+ 'function Copy(obj : in ' + typ.name + ') return ' + typ.ptr_type + ';\n' 
	+ 'function XML_String(obj : in ' + typ.name + ') return Unbounded_String;\n' 
	+ '\nfunction XML_String(obj : in ' + typ.ptr_type + ') return Unbounded_String;\n' 
	+ 'procedure Free  is new Unchecked_Deallocation (' + typ.name + ', ' + typ.ptr_type + ');\n' 
	+ 'function XML_Ref_String(obj : in ' + typ.name + ') return Unbounded_String;\n' 
	+ '\nfunction XML_Ref_String(obj : in ' + typ.ptr_type + ') return Unbounded_String;\n';
	RETURN ( result );
END_FUNCTION;
</ISO10303-11-EXPRESS>!

!ExChdDiscriminatedTypeAdsCodeFunction class methodsFor: 'platypus-generated-platypus-signature' stamp: ''!
iso10303P11Translater
	^ 'Platypus (c) LISYC EA3883, Universite de Bretagne occidentale. Brest.'

! !

!ExChdDiscriminatedTypeAdsCodeFunction class methodsFor: 'platypus-generated-meta-data-accessing' stamp: ''!
schemaDefinition
	^ ExChdDiscriminatedTypeSchemaDefinition singleton

! !

!ExChdDiscriminatedTypeAdsCodeFunction class methodsFor: 'platypus-generated-platypus-signature' stamp: ''!
translatedFromISO10303P11
	^ true

! !

!ExChdDiscriminatedTypeAdsCodeFunction class methodsFor: 'platypus-generated-platypus-signature' stamp: ''!
vwNamespaceName
	^ #Express2Cheddar

! !

!ExChdDiscriminatedTypeAdsCodeFunction methodsFor: 'platypus-generated-accessing' stamp: ''!
discrimAttr
	^ discrimAttr

! !

!ExChdDiscriminatedTypeAdsCodeFunction methodsFor: 'platypus-generated-accessing' stamp: ''!
discrimAttr: aExChdAttribute
	discrimAttr := aExChdAttribute

! !

!ExChdDiscriminatedTypeAdsCodeFunction methodsFor: 'platypus-generated-accessing' stamp: ''!
discrimType
	^ discrimType

! !

!ExChdDiscriminatedTypeAdsCodeFunction methodsFor: 'platypus-generated-accessing' stamp: ''!
discrimType: aExChdEntityInstance
	discrimType := aExChdEntityInstance

! !

!ExChdDiscriminatedTypeAdsCodeFunction methodsFor: 'platypus-generated-accessing' stamp: ''!
domain
	^ domain

! !

!ExChdDiscriminatedTypeAdsCodeFunction methodsFor: 'platypus-generated-accessing' stamp: ''!
domain: aExChdEntityInstance1
	domain := aExChdEntityInstance1

! !

!ExChdDiscriminatedTypeAdsCodeFunction methodsFor: 'platypus-generated-accessing' stamp: ''!
fromValues: values
	self typ: (values at: 1)

! !

!ExChdDiscriminatedTypeAdsCodeFunction methodsFor: 'platypus-generated-invoking' stamp: ''!
invoke
	" ---------- locals assignments ----------"

	self discrimAttr: (self typ discriminantUsingContext: self class context).
	self discrimType: ((self discrimAttr domainUsingContext: self class context) handledUsingContext: self class context).
	self unionAttr: (self typ unionAttrUsingContext: self class context).
	self unionType: ((self unionAttr domainUsingContext: self class context) handledUsingContext: self class context).
	self
		unionSelections:
			(PTsInheritedExplicitAttributesFunction
				invokeFromValues:
					(OrderedCollection new
						add: self unionType;
						yourself)).
	self translAttrs: (self typ translatedAttributesUsingContext: self class context).	" ---------- statements ----------"
	self
		result:
			(((((('type ' pltPlus: (self typ nameUsingContext: self class context)) pltPlus: ' (')
				pltPlus: (self discrimAttr nameUsingContext: self class context)) pltPlus: ' : ')
				pltPlus: (self discrimType nameUsingContext: self class context)) pltPlus: ' ) is record\n').
	PlatypusCoreRepeatStatement
		repeat: [ :no2639 | 
			PlatypusCoreAliasStatement
				alias: (self translAttrs pltAt: no2639)
				statementsBlock: [ :attr370 | 
					self
						domain:
							(ExChdBasicAdaDomainFunction
								invokeFromValues:
									(OrderedCollection new
										add: (attr370 domainUsingContext: self class context);
										yourself)).
					((PltTYPEOFFunction
						invokeFromValues:
							(OrderedCollection new
								add: (self domain handledUsingContext: self class context);
								yourself)) includes: 'RECORD_AND_CLASS.ADA_CLASS')
						ifTrue: [ 
							self
								result:
									(((((self result pltPlus: '\t') pltPlus: (attr370 nameUsingContext: self class context)) pltPlus: ' : ')
										pltPlus: ((self domain handledUsingContext: self class context) ptrTypeUsingContext: self class context))
										pltPlus: ';\n') ]
						ifFalse: [ 
							self
								result:
									(((((self result pltPlus: '\t') pltPlus: (attr370 nameUsingContext: self class context)) pltPlus: ' : ')
										pltPlus: (self domain adaRefIdentUsingContext: self class context)) pltPlus: ';\n') ] ] ]
		from:
			(PltLOINDEXFunction
				invokeFromValues:
					(OrderedCollection new
						add: self translAttrs;
						yourself))
		to:
			(PltHIINDEXFunction
				invokeFromValues:
					(OrderedCollection new
						add: self translAttrs;
						yourself)).
	self
		result:
			(((((((((((((((((((((((((((((((((((((((((((self result pltPlus: '\tcase ')
				pltPlus: (self discrimAttr nameUsingContext: self class context)) pltPlus: ' is \n')
				pltPlus: (self unionType unionAdsCodeUsingContext: self class context)) pltPlus: '\tend case;\nend record;\n\n')
				pltPlus: 'type ') pltPlus: (self typ ptrTypeUsingContext: self class context)) pltPlus: ' is access all ')
				pltPlus: (self typ nameUsingContext: self class context)) pltPlus: ';\n')
				pltPlus: '\nprocedure Initialize(obj : out ') pltPlus: (self typ ptrTypeUsingContext: self class context))
				pltPlus: ');\n') pltPlus: '\nprocedure Put(obj : in ') pltPlus: (self typ ptrTypeUsingContext: self class context))
				pltPlus: ');\n') pltPlus: 'function Copy(obj : in ') pltPlus: (self typ ptrTypeUsingContext: self class context))
				pltPlus: ') return ') pltPlus: (self typ ptrTypeUsingContext: self class context)) pltPlus: ';\n')
				pltPlus: 'function Copy(obj : in ') pltPlus: (self typ nameUsingContext: self class context)) pltPlus: ') return ')
				pltPlus: (self typ ptrTypeUsingContext: self class context)) pltPlus: ';\n')
				pltPlus: 'function XML_String(obj : in ') pltPlus: (self typ nameUsingContext: self class context))
				pltPlus: ') return Unbounded_String;\n') pltPlus: '\nfunction XML_String(obj : in ')
				pltPlus: (self typ ptrTypeUsingContext: self class context)) pltPlus: ') return Unbounded_String;\n')
				pltPlus: 'procedure Free  is new Unchecked_Deallocation (') pltPlus: (self typ nameUsingContext: self class context))
				pltPlus: ', ') pltPlus: (self typ ptrTypeUsingContext: self class context)) pltPlus: ');\n')
				pltPlus: 'function XML_Ref_String(obj : in ') pltPlus: (self typ nameUsingContext: self class context))
				pltPlus: ') return Unbounded_String;\n') pltPlus: '\nfunction XML_Ref_String(obj : in ')
				pltPlus: (self typ ptrTypeUsingContext: self class context)) pltPlus: ') return Unbounded_String;\n').
	^ self return: self result

! !

!ExChdDiscriminatedTypeAdsCodeFunction methodsFor: 'platypus-generated-accessing' stamp: ''!
result
	^ result

! !

!ExChdDiscriminatedTypeAdsCodeFunction methodsFor: 'platypus-generated-accessing' stamp: ''!
result: aString
	result := aString

! !

!ExChdDiscriminatedTypeAdsCodeFunction methodsFor: 'platypus-generated-accessing' stamp: ''!
translAttrs
	^ translAttrs

! !

!ExChdDiscriminatedTypeAdsCodeFunction methodsFor: 'platypus-generated-accessing' stamp: ''!
translAttrs: aListOfExChdAttribute1
	translAttrs := aListOfExChdAttribute1
		ifNil: [ OrderedCollection new ]
		ifNotNil: [ aListOfExChdAttribute1 as: OrderedCollection ]

! !

!ExChdDiscriminatedTypeAdsCodeFunction methodsFor: 'platypus-generated-accessing' stamp: ''!
typ
	^ typ

! !

!ExChdDiscriminatedTypeAdsCodeFunction methodsFor: 'platypus-generated-accessing' stamp: ''!
typ: aExChdDiscriminatedType
	typ := aExChdDiscriminatedType

! !

!ExChdDiscriminatedTypeAdsCodeFunction methodsFor: 'platypus-generated-accessing' stamp: ''!
unionAttr
	^ unionAttr

! !

!ExChdDiscriminatedTypeAdsCodeFunction methodsFor: 'platypus-generated-accessing' stamp: ''!
unionAttr: aExChdAttribute1
	unionAttr := aExChdAttribute1

! !

!ExChdDiscriminatedTypeAdsCodeFunction methodsFor: 'platypus-generated-accessing' stamp: ''!
unionSelections
	^ unionSelections

! !

!ExChdDiscriminatedTypeAdsCodeFunction methodsFor: 'platypus-generated-accessing' stamp: ''!
unionSelections: aListOfExChdAttribute
	unionSelections := aListOfExChdAttribute
		ifNil: [ OrderedCollection new ]
		ifNotNil: [ aListOfExChdAttribute as: OrderedCollection ]

! !

!ExChdDiscriminatedTypeAdsCodeFunction methodsFor: 'platypus-generated-accessing' stamp: ''!
unionType
	^ unionType

! !

!ExChdDiscriminatedTypeAdsCodeFunction methodsFor: 'platypus-generated-accessing' stamp: ''!
unionType: aExChdDefinedType
	unionType := aExChdDefinedType

! !

PlatypusCoreAlgorithmDeclaration subclass: #ExChdDiscriminatedTypeAttributesFunction
	instanceVariableNames: 'd otherAttrs tailAttrs attrs'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Express2Cheddar-DiscriminatedTypeSchema'!

!ExChdDiscriminatedTypeAttributesFunction commentStamp: 'platypus comment' prior: 0!
<ISO10303-11-EXPRESS>
FUNCTION discriminated_type_attributes ( d : discriminated_type ) : LIST OF attribute;
	LOCAL 
		other_attrs : LIST OF attribute := [ d.discriminant] + d.translated_attributes;
		tail_attrs : LIST OF explicit_attribute := discriminated_type_tails_attributes ( d );
		attrs : LIST OF attribute := other_attrs + tail_attrs;
	END_LOCAL;
	RETURN ( attrs );
END_FUNCTION;
</ISO10303-11-EXPRESS>!

!ExChdDiscriminatedTypeAttributesFunction class methodsFor: 'platypus-generated-platypus-signature' stamp: ''!
iso10303P11Translater
	^ 'Platypus (c) LISYC EA3883, Universite de Bretagne occidentale. Brest.'

! !

!ExChdDiscriminatedTypeAttributesFunction class methodsFor: 'platypus-generated-meta-data-accessing' stamp: ''!
schemaDefinition
	^ ExChdDiscriminatedTypeSchemaDefinition singleton

! !

!ExChdDiscriminatedTypeAttributesFunction class methodsFor: 'platypus-generated-platypus-signature' stamp: ''!
translatedFromISO10303P11
	^ true

! !

!ExChdDiscriminatedTypeAttributesFunction class methodsFor: 'platypus-generated-platypus-signature' stamp: ''!
vwNamespaceName
	^ #Express2Cheddar

! !

!ExChdDiscriminatedTypeAttributesFunction methodsFor: 'platypus-generated-accessing' stamp: ''!
attrs
	^ attrs

! !

!ExChdDiscriminatedTypeAttributesFunction methodsFor: 'platypus-generated-accessing' stamp: ''!
attrs: aListOfExChdAttribute1
	attrs := aListOfExChdAttribute1
		ifNil: [ OrderedCollection new ]
		ifNotNil: [ aListOfExChdAttribute1 as: OrderedCollection ]

! !

!ExChdDiscriminatedTypeAttributesFunction methodsFor: 'platypus-generated-accessing' stamp: ''!
d
	^ d

! !

!ExChdDiscriminatedTypeAttributesFunction methodsFor: 'platypus-generated-accessing' stamp: ''!
d: aExChdDiscriminatedType
	d := aExChdDiscriminatedType

! !

!ExChdDiscriminatedTypeAttributesFunction methodsFor: 'platypus-generated-accessing' stamp: ''!
fromValues: values
	self d: (values at: 1)

! !

!ExChdDiscriminatedTypeAttributesFunction methodsFor: 'platypus-generated-invoking' stamp: ''!
invoke
	" ---------- locals assignments ----------"

	self
		otherAttrs:
			((PlatypusCoreAggregateInitializer
				collectionFrom:
					(OrderedCollection new
						add: (self d discriminantUsingContext: self class context);
						yourself)) pltPlus: (self d translatedAttributesUsingContext: self class context)).
	self
		tailAttrs:
			(ExChdDiscriminatedTypeTailsAttributesFunction
				invokeFromValues:
					(OrderedCollection new
						add: self d;
						yourself)).
	self attrs: (self otherAttrs pltPlus: self tailAttrs).	" ---------- statements ----------"
	^ self return: self attrs

! !

!ExChdDiscriminatedTypeAttributesFunction methodsFor: 'platypus-generated-accessing' stamp: ''!
otherAttrs
	^ otherAttrs

! !

!ExChdDiscriminatedTypeAttributesFunction methodsFor: 'platypus-generated-accessing' stamp: ''!
otherAttrs: aListOfExChdAttribute
	otherAttrs := aListOfExChdAttribute
		ifNil: [ OrderedCollection new ]
		ifNotNil: [ aListOfExChdAttribute as: OrderedCollection ]

! !

!ExChdDiscriminatedTypeAttributesFunction methodsFor: 'platypus-generated-accessing' stamp: ''!
tailAttrs
	^ tailAttrs

! !

!ExChdDiscriminatedTypeAttributesFunction methodsFor: 'platypus-generated-accessing' stamp: ''!
tailAttrs: aListOfExChdExplicitAttribute
	tailAttrs := aListOfExChdExplicitAttribute
		ifNil: [ OrderedCollection new ]
		ifNotNil: [ aListOfExChdExplicitAttribute as: OrderedCollection ]

! !

PlatypusCoreAlgorithmDeclaration subclass: #ExChdDiscriminatedTypeAttributesXmlEndElementCodeFunction
	instanceVariableNames: 'typ code s discrimAttr attrs'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Express2Cheddar-DiscriminatedTypeSchema'!

!ExChdDiscriminatedTypeAttributesXmlEndElementCodeFunction commentStamp: 'platypus comment' prior: 0!
<ISO10303-11-EXPRESS>
FUNCTION discriminated_type_attributes_xml_end_element_code ( typ : discriminated_type ) : STRING;
	LOCAL 
		code : STRING := '';
		s : STRING;
		discrim_attr : attribute := typ.discriminant;
		attrs : LIST OF attribute := typ.tail_attributes + typ.translated_attributes;
	END_LOCAL;
	code := code + explicit_attribute_xml_end_element_code ( discrim_attr ) + '\n';

	REPEAT no := LOINDEX ( attrs ) TO HIINDEX ( attrs );

		ALIAS attr FOR attrs [ no];
			s := explicit_attribute_xml_end_element_code ( attr );
			IF ( s > '' ) THEN
				code := code + '\n' 
				+ s;
			END_IF;
		END_ALIAS;
	END_REPEAT;

	IF ( code = '' ) THEN
		code := '\tnull;\n';
	END_IF;
	RETURN ( code );
END_FUNCTION;
</ISO10303-11-EXPRESS>!

!ExChdDiscriminatedTypeAttributesXmlEndElementCodeFunction class methodsFor: 'platypus-generated-platypus-signature' stamp: ''!
iso10303P11Translater
	^ 'Platypus (c) LISYC EA3883, Universite de Bretagne occidentale. Brest.'

! !

!ExChdDiscriminatedTypeAttributesXmlEndElementCodeFunction class methodsFor: 'platypus-generated-meta-data-accessing' stamp: ''!
schemaDefinition
	^ ExChdDiscriminatedTypeSchemaDefinition singleton

! !

!ExChdDiscriminatedTypeAttributesXmlEndElementCodeFunction class methodsFor: 'platypus-generated-platypus-signature' stamp: ''!
translatedFromISO10303P11
	^ true

! !

!ExChdDiscriminatedTypeAttributesXmlEndElementCodeFunction class methodsFor: 'platypus-generated-platypus-signature' stamp: ''!
vwNamespaceName
	^ #Express2Cheddar

! !

!ExChdDiscriminatedTypeAttributesXmlEndElementCodeFunction methodsFor: 'platypus-generated-accessing' stamp: ''!
attrs
	^ attrs

! !

!ExChdDiscriminatedTypeAttributesXmlEndElementCodeFunction methodsFor: 'platypus-generated-accessing' stamp: ''!
attrs: aListOfExChdAttribute
	attrs := aListOfExChdAttribute
		ifNil: [ OrderedCollection new ]
		ifNotNil: [ aListOfExChdAttribute as: OrderedCollection ]

! !

!ExChdDiscriminatedTypeAttributesXmlEndElementCodeFunction methodsFor: 'platypus-generated-accessing' stamp: ''!
code
	^ code

! !

!ExChdDiscriminatedTypeAttributesXmlEndElementCodeFunction methodsFor: 'platypus-generated-accessing' stamp: ''!
code: aString
	code := aString

! !

!ExChdDiscriminatedTypeAttributesXmlEndElementCodeFunction methodsFor: 'platypus-generated-accessing' stamp: ''!
discrimAttr
	^ discrimAttr

! !

!ExChdDiscriminatedTypeAttributesXmlEndElementCodeFunction methodsFor: 'platypus-generated-accessing' stamp: ''!
discrimAttr: aExChdAttribute
	discrimAttr := aExChdAttribute

! !

!ExChdDiscriminatedTypeAttributesXmlEndElementCodeFunction methodsFor: 'platypus-generated-accessing' stamp: ''!
fromValues: values
	self typ: (values at: 1)

! !

!ExChdDiscriminatedTypeAttributesXmlEndElementCodeFunction methodsFor: 'platypus-generated-invoking' stamp: ''!
invoke
	" ---------- locals assignments ----------"

	self code: ''.
	self discrimAttr: (self typ discriminantUsingContext: self class context).
	self
		attrs:
			((self typ tailAttributesUsingContext: self class context)
				pltPlus: (self typ translatedAttributesUsingContext: self class context)).	" ---------- statements ----------"
	self
		code:
			((self code
				pltPlus:
					(ExChdExplicitAttributeXmlEndElementCodeFunction
						invokeFromValues:
							(OrderedCollection new
								add: self discrimAttr;
								yourself))) pltPlus: '\n').
	PlatypusCoreRepeatStatement
		repeat: [ :no1907 | 
			PlatypusCoreAliasStatement
				alias: (self attrs pltAt: no1907)
				statementsBlock: [ :attr3730 | 
					self
						s:
							(ExChdExplicitAttributeXmlEndElementCodeFunction
								invokeFromValues:
									(OrderedCollection new
										add: attr3730;
										yourself)).
					self s > ''
						ifTrue: [ self code: ((self code pltPlus: '\n') pltPlus: self s) ] ] ]
		from:
			(PltLOINDEXFunction
				invokeFromValues:
					(OrderedCollection new
						add: self attrs;
						yourself))
		to:
			(PltHIINDEXFunction
				invokeFromValues:
					(OrderedCollection new
						add: self attrs;
						yourself)).
	self code = ''
		ifTrue: [ self code: '\tnull;\n' ].
	^ self return: self code

! !

!ExChdDiscriminatedTypeAttributesXmlEndElementCodeFunction methodsFor: 'platypus-generated-accessing' stamp: ''!
s
	^ s

! !

!ExChdDiscriminatedTypeAttributesXmlEndElementCodeFunction methodsFor: 'platypus-generated-accessing' stamp: ''!
s: aString1
	s := aString1

! !

!ExChdDiscriminatedTypeAttributesXmlEndElementCodeFunction methodsFor: 'platypus-generated-accessing' stamp: ''!
typ
	^ typ

! !

!ExChdDiscriminatedTypeAttributesXmlEndElementCodeFunction methodsFor: 'platypus-generated-accessing' stamp: ''!
typ: aExChdDiscriminatedType
	typ := aExChdDiscriminatedType

! !

PlatypusCoreAlgorithmDeclaration subclass: #ExChdDiscriminatedTypeAttributesXmlIoRecordInitializeCodeFunction
	instanceVariableNames: 'typ code s discrimAttr attrs'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Express2Cheddar-DiscriminatedTypeSchema'!

!ExChdDiscriminatedTypeAttributesXmlIoRecordInitializeCodeFunction commentStamp: 'platypus comment' prior: 0!
<ISO10303-11-EXPRESS>
FUNCTION discriminated_type_attributes_xml_io_record_initialize_code ( typ : discriminated_type ) : STRING;
	LOCAL 
		code : STRING := '';
		s : STRING;
		discrim_attr : attribute := typ.discriminant;
		attrs : LIST OF attribute := typ.tail_attributes + typ.translated_attributes;
	END_LOCAL;
	code := code + explicit_attribute_xml_io_record_initialize_code ( discrim_attr ) + '\n';

	REPEAT no := LOINDEX ( attrs ) TO HIINDEX ( attrs );

		ALIAS attr FOR attrs [ no];
			s := explicit_attribute_xml_io_record_initialize_code ( attr );
			IF ( s > '' ) THEN
				code := code + '\n' 
				+ s;
			END_IF;
		END_ALIAS;
	END_REPEAT;
	RETURN ( code );
END_FUNCTION;
</ISO10303-11-EXPRESS>!

!ExChdDiscriminatedTypeAttributesXmlIoRecordInitializeCodeFunction class methodsFor: 'platypus-generated-platypus-signature' stamp: ''!
iso10303P11Translater
	^ 'Platypus (c) LISYC EA3883, Universite de Bretagne occidentale. Brest.'

! !

!ExChdDiscriminatedTypeAttributesXmlIoRecordInitializeCodeFunction class methodsFor: 'platypus-generated-meta-data-accessing' stamp: ''!
schemaDefinition
	^ ExChdDiscriminatedTypeSchemaDefinition singleton

! !

!ExChdDiscriminatedTypeAttributesXmlIoRecordInitializeCodeFunction class methodsFor: 'platypus-generated-platypus-signature' stamp: ''!
translatedFromISO10303P11
	^ true

! !

!ExChdDiscriminatedTypeAttributesXmlIoRecordInitializeCodeFunction class methodsFor: 'platypus-generated-platypus-signature' stamp: ''!
vwNamespaceName
	^ #Express2Cheddar

! !

!ExChdDiscriminatedTypeAttributesXmlIoRecordInitializeCodeFunction methodsFor: 'platypus-generated-accessing' stamp: ''!
attrs
	^ attrs

! !

!ExChdDiscriminatedTypeAttributesXmlIoRecordInitializeCodeFunction methodsFor: 'platypus-generated-accessing' stamp: ''!
attrs: aListOfExChdAttribute
	attrs := aListOfExChdAttribute
		ifNil: [ OrderedCollection new ]
		ifNotNil: [ aListOfExChdAttribute as: OrderedCollection ]

! !

!ExChdDiscriminatedTypeAttributesXmlIoRecordInitializeCodeFunction methodsFor: 'platypus-generated-accessing' stamp: ''!
code
	^ code

! !

!ExChdDiscriminatedTypeAttributesXmlIoRecordInitializeCodeFunction methodsFor: 'platypus-generated-accessing' stamp: ''!
code: aString
	code := aString

! !

!ExChdDiscriminatedTypeAttributesXmlIoRecordInitializeCodeFunction methodsFor: 'platypus-generated-accessing' stamp: ''!
discrimAttr
	^ discrimAttr

! !

!ExChdDiscriminatedTypeAttributesXmlIoRecordInitializeCodeFunction methodsFor: 'platypus-generated-accessing' stamp: ''!
discrimAttr: aExChdAttribute
	discrimAttr := aExChdAttribute

! !

!ExChdDiscriminatedTypeAttributesXmlIoRecordInitializeCodeFunction methodsFor: 'platypus-generated-accessing' stamp: ''!
fromValues: values
	self typ: (values at: 1)

! !

!ExChdDiscriminatedTypeAttributesXmlIoRecordInitializeCodeFunction methodsFor: 'platypus-generated-invoking' stamp: ''!
invoke
	" ---------- locals assignments ----------"

	self code: ''.
	self discrimAttr: (self typ discriminantUsingContext: self class context).
	self
		attrs:
			((self typ tailAttributesUsingContext: self class context)
				pltPlus: (self typ translatedAttributesUsingContext: self class context)).	" ---------- statements ----------"
	self
		code:
			((self code
				pltPlus:
					(ExChdExplicitAttributeXmlIoRecordInitializeCodeFunction
						invokeFromValues:
							(OrderedCollection new
								add: self discrimAttr;
								yourself))) pltPlus: '\n').
	PlatypusCoreRepeatStatement
		repeat: [ :no228 | 
			PlatypusCoreAliasStatement
				alias: (self attrs pltAt: no228)
				statementsBlock: [ :attr2051 | 
					self
						s:
							(ExChdExplicitAttributeXmlIoRecordInitializeCodeFunction
								invokeFromValues:
									(OrderedCollection new
										add: attr2051;
										yourself)).
					self s > ''
						ifTrue: [ self code: ((self code pltPlus: '\n') pltPlus: self s) ] ] ]
		from:
			(PltLOINDEXFunction
				invokeFromValues:
					(OrderedCollection new
						add: self attrs;
						yourself))
		to:
			(PltHIINDEXFunction
				invokeFromValues:
					(OrderedCollection new
						add: self attrs;
						yourself)).
	^ self return: self code

! !

!ExChdDiscriminatedTypeAttributesXmlIoRecordInitializeCodeFunction methodsFor: 'platypus-generated-accessing' stamp: ''!
s
	^ s

! !

!ExChdDiscriminatedTypeAttributesXmlIoRecordInitializeCodeFunction methodsFor: 'platypus-generated-accessing' stamp: ''!
s: aString1
	s := aString1

! !

!ExChdDiscriminatedTypeAttributesXmlIoRecordInitializeCodeFunction methodsFor: 'platypus-generated-accessing' stamp: ''!
typ
	^ typ

! !

!ExChdDiscriminatedTypeAttributesXmlIoRecordInitializeCodeFunction methodsFor: 'platypus-generated-accessing' stamp: ''!
typ: aExChdDiscriminatedType
	typ := aExChdDiscriminatedType

! !

PlatypusCoreAlgorithmDeclaration subclass: #ExChdDiscriminatedTypeAttributesXmlStartElementCodeFunction
	instanceVariableNames: 'typ code s discrimAttr attrs'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Express2Cheddar-DiscriminatedTypeSchema'!

!ExChdDiscriminatedTypeAttributesXmlStartElementCodeFunction commentStamp: 'platypus comment' prior: 0!
<ISO10303-11-EXPRESS>
FUNCTION discriminated_type_attributes_xml_start_element_code ( typ : discriminated_type ) : STRING;
	LOCAL 
		code : STRING := '';
		s : STRING;
		discrim_attr : attribute := typ.discriminant;
		attrs : LIST OF attribute := typ.tail_attributes + typ.translated_attributes;
	END_LOCAL;
	code := explicit_attribute_xml_start_element_code ( discrim_attr );

	REPEAT no := LOINDEX ( attrs ) TO HIINDEX ( attrs );

		ALIAS attr FOR attrs [ no];
			s := explicit_attribute_xml_start_element_code ( attr );
			IF ( s > '' ) THEN
				code := code + '\n' 
				+ s;
			END_IF;
		END_ALIAS;
	END_REPEAT;
	RETURN ( code );
END_FUNCTION;
</ISO10303-11-EXPRESS>!

!ExChdDiscriminatedTypeAttributesXmlStartElementCodeFunction class methodsFor: 'platypus-generated-platypus-signature' stamp: ''!
iso10303P11Translater
	^ 'Platypus (c) LISYC EA3883, Universite de Bretagne occidentale. Brest.'

! !

!ExChdDiscriminatedTypeAttributesXmlStartElementCodeFunction class methodsFor: 'platypus-generated-meta-data-accessing' stamp: ''!
schemaDefinition
	^ ExChdDiscriminatedTypeSchemaDefinition singleton

! !

!ExChdDiscriminatedTypeAttributesXmlStartElementCodeFunction class methodsFor: 'platypus-generated-platypus-signature' stamp: ''!
translatedFromISO10303P11
	^ true

! !

!ExChdDiscriminatedTypeAttributesXmlStartElementCodeFunction class methodsFor: 'platypus-generated-platypus-signature' stamp: ''!
vwNamespaceName
	^ #Express2Cheddar

! !

!ExChdDiscriminatedTypeAttributesXmlStartElementCodeFunction methodsFor: 'platypus-generated-accessing' stamp: ''!
attrs
	^ attrs

! !

!ExChdDiscriminatedTypeAttributesXmlStartElementCodeFunction methodsFor: 'platypus-generated-accessing' stamp: ''!
attrs: aListOfExChdAttribute
	attrs := aListOfExChdAttribute
		ifNil: [ OrderedCollection new ]
		ifNotNil: [ aListOfExChdAttribute as: OrderedCollection ]

! !

!ExChdDiscriminatedTypeAttributesXmlStartElementCodeFunction methodsFor: 'platypus-generated-accessing' stamp: ''!
code
	^ code

! !

!ExChdDiscriminatedTypeAttributesXmlStartElementCodeFunction methodsFor: 'platypus-generated-accessing' stamp: ''!
code: aString
	code := aString

! !

!ExChdDiscriminatedTypeAttributesXmlStartElementCodeFunction methodsFor: 'platypus-generated-accessing' stamp: ''!
discrimAttr
	^ discrimAttr

! !

!ExChdDiscriminatedTypeAttributesXmlStartElementCodeFunction methodsFor: 'platypus-generated-accessing' stamp: ''!
discrimAttr: aExChdAttribute
	discrimAttr := aExChdAttribute

! !

!ExChdDiscriminatedTypeAttributesXmlStartElementCodeFunction methodsFor: 'platypus-generated-accessing' stamp: ''!
fromValues: values
	self typ: (values at: 1)

! !

!ExChdDiscriminatedTypeAttributesXmlStartElementCodeFunction methodsFor: 'platypus-generated-invoking' stamp: ''!
invoke
	" ---------- locals assignments ----------"

	self code: ''.
	self discrimAttr: (self typ discriminantUsingContext: self class context).
	self
		attrs:
			((self typ tailAttributesUsingContext: self class context)
				pltPlus: (self typ translatedAttributesUsingContext: self class context)).	" ---------- statements ----------"
	self
		code:
			(ExChdExplicitAttributeXmlStartElementCodeFunction
				invokeFromValues:
					(OrderedCollection new
						add: self discrimAttr;
						yourself)).
	PlatypusCoreRepeatStatement
		repeat: [ :no1605 | 
			PlatypusCoreAliasStatement
				alias: (self attrs pltAt: no1605)
				statementsBlock: [ :attr1042 | 
					self
						s:
							(ExChdExplicitAttributeXmlStartElementCodeFunction
								invokeFromValues:
									(OrderedCollection new
										add: attr1042;
										yourself)).
					self s > ''
						ifTrue: [ self code: ((self code pltPlus: '\n') pltPlus: self s) ] ] ]
		from:
			(PltLOINDEXFunction
				invokeFromValues:
					(OrderedCollection new
						add: self attrs;
						yourself))
		to:
			(PltHIINDEXFunction
				invokeFromValues:
					(OrderedCollection new
						add: self attrs;
						yourself)).
	^ self return: self code

! !

!ExChdDiscriminatedTypeAttributesXmlStartElementCodeFunction methodsFor: 'platypus-generated-accessing' stamp: ''!
s
	^ s

! !

!ExChdDiscriminatedTypeAttributesXmlStartElementCodeFunction methodsFor: 'platypus-generated-accessing' stamp: ''!
s: aString1
	s := aString1

! !

!ExChdDiscriminatedTypeAttributesXmlStartElementCodeFunction methodsFor: 'platypus-generated-accessing' stamp: ''!
typ
	^ typ

! !

!ExChdDiscriminatedTypeAttributesXmlStartElementCodeFunction methodsFor: 'platypus-generated-accessing' stamp: ''!
typ: aExChdDiscriminatedType
	typ := aExChdDiscriminatedType

! !

PlatypusCoreAlgorithmDeclaration subclass: #ExChdDiscriminatedTypeInterfacesListFunction
	instanceVariableNames: 'r ads'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Express2Cheddar-DiscriminatedTypeSchema'!

!ExChdDiscriminatedTypeInterfacesListFunction commentStamp: 'platypus comment' prior: 0!
<ISO10303-11-EXPRESS>
FUNCTION discriminated_type_interfaces_list ( r : discriminated_type; ads : BOOLEAN ) : LIST OF ada_interface;
	RETURN ( ada_entity_interfaces_list ( r, ads ) );
END_FUNCTION;
</ISO10303-11-EXPRESS>!

!ExChdDiscriminatedTypeInterfacesListFunction class methodsFor: 'platypus-generated-platypus-signature' stamp: ''!
iso10303P11Translater
	^ 'Platypus (c) LISYC EA3883, Universite de Bretagne occidentale. Brest.'

! !

!ExChdDiscriminatedTypeInterfacesListFunction class methodsFor: 'platypus-generated-meta-data-accessing' stamp: ''!
schemaDefinition
	^ ExChdDiscriminatedTypeSchemaDefinition singleton

! !

!ExChdDiscriminatedTypeInterfacesListFunction class methodsFor: 'platypus-generated-platypus-signature' stamp: ''!
translatedFromISO10303P11
	^ true

! !

!ExChdDiscriminatedTypeInterfacesListFunction class methodsFor: 'platypus-generated-platypus-signature' stamp: ''!
vwNamespaceName
	^ #Express2Cheddar

! !

!ExChdDiscriminatedTypeInterfacesListFunction methodsFor: 'platypus-generated-accessing' stamp: ''!
ads
	^ ads

! !

!ExChdDiscriminatedTypeInterfacesListFunction methodsFor: 'platypus-generated-accessing' stamp: ''!
ads: aBoolean
	ads := aBoolean

! !

!ExChdDiscriminatedTypeInterfacesListFunction methodsFor: 'platypus-generated-accessing' stamp: ''!
fromValues: values
	self r: (values at: 1).
	self ads: (values at: 2)

! !

!ExChdDiscriminatedTypeInterfacesListFunction methodsFor: 'platypus-generated-invoking' stamp: ''!
invoke
	" ---------- locals assignments ----------"

	" ---------- statements ----------"

	^ self
		return:
			(ExChdAdaEntityInterfacesListFunction
				invokeFromValues:
					(OrderedCollection new
						add: self r;
						add: self ads;
						yourself))

! !

!ExChdDiscriminatedTypeInterfacesListFunction methodsFor: 'platypus-generated-accessing' stamp: ''!
r
	^ r

! !

!ExChdDiscriminatedTypeInterfacesListFunction methodsFor: 'platypus-generated-accessing' stamp: ''!
r: aExChdDiscriminatedType
	r := aExChdDiscriminatedType

! !

!ExChdDiscriminatedTypeInterfacesListFunction methodsFor: 'platypus-generated-accessing' stamp: ''!
r: aExChdDiscriminatedType ads: aBoolean
	self r: aExChdDiscriminatedType.
	self ads: aBoolean

! !

PlatypusCoreAlgorithmDeclaration subclass: #ExChdDiscriminatedTypeTailsAttributesFunction
	instanceVariableNames: 'typ unionAttr unionType unionAttributes found'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Express2Cheddar-DiscriminatedTypeSchema'!

!ExChdDiscriminatedTypeTailsAttributesFunction commentStamp: 'platypus comment' prior: 0!
<ISO10303-11-EXPRESS>
FUNCTION discriminated_type_tails_attributes ( typ : discriminated_type ) : LIST OF attribute;
	LOCAL 
		union_attr : attribute := typ.union_attr;
		union_type : defined_type := union_attr.domain.handled;
		union_attributes : LIST OF attribute := inherited_explicit_attributes ( union_type );
		found : LIST OF attribute := [ ];
	END_LOCAL;

	REPEAT no := LOINDEX ( union_attributes ) TO HIINDEX ( union_attributes );

		ALIAS curr FOR union_attributes [ no];
			ALIAS handled FOR curr.domain.handled;
				found := found + inherited_explicit_attributes ( handled );
			END_ALIAS;
		END_ALIAS;
	END_REPEAT;
	RETURN ( found );
END_FUNCTION;
</ISO10303-11-EXPRESS>!

!ExChdDiscriminatedTypeTailsAttributesFunction class methodsFor: 'platypus-generated-platypus-signature' stamp: ''!
iso10303P11Translater
	^ 'Platypus (c) LISYC EA3883, Universite de Bretagne occidentale. Brest.'

! !

!ExChdDiscriminatedTypeTailsAttributesFunction class methodsFor: 'platypus-generated-meta-data-accessing' stamp: ''!
schemaDefinition
	^ ExChdDiscriminatedTypeSchemaDefinition singleton

! !

!ExChdDiscriminatedTypeTailsAttributesFunction class methodsFor: 'platypus-generated-platypus-signature' stamp: ''!
translatedFromISO10303P11
	^ true

! !

!ExChdDiscriminatedTypeTailsAttributesFunction class methodsFor: 'platypus-generated-platypus-signature' stamp: ''!
vwNamespaceName
	^ #Express2Cheddar

! !

!ExChdDiscriminatedTypeTailsAttributesFunction methodsFor: 'platypus-generated-accessing' stamp: ''!
found
	^ found

! !

!ExChdDiscriminatedTypeTailsAttributesFunction methodsFor: 'platypus-generated-accessing' stamp: ''!
found: aListOfExChdAttribute1
	found := aListOfExChdAttribute1
		ifNil: [ OrderedCollection new ]
		ifNotNil: [ aListOfExChdAttribute1 as: OrderedCollection ]

! !

!ExChdDiscriminatedTypeTailsAttributesFunction methodsFor: 'platypus-generated-accessing' stamp: ''!
fromValues: values
	self typ: (values at: 1)

! !

!ExChdDiscriminatedTypeTailsAttributesFunction methodsFor: 'platypus-generated-invoking' stamp: ''!
invoke
	" ---------- locals assignments ----------"

	self unionAttr: (self typ unionAttrUsingContext: self class context).
	self unionType: ((self unionAttr domainUsingContext: self class context) handledUsingContext: self class context).
	self
		unionAttributes:
			(PTsInheritedExplicitAttributesFunction
				invokeFromValues:
					(OrderedCollection new
						add: self unionType;
						yourself)).
	self found: Array new.	" ---------- statements ----------"
	PlatypusCoreRepeatStatement
		repeat: [ :no213 | 
			PlatypusCoreAliasStatement
				alias: (self unionAttributes pltAt: no213)
				statementsBlock: [ :curr2044 | 
					PlatypusCoreAliasStatement
						alias: ((curr2044 domainUsingContext: self class context) handledUsingContext: self class context)
						statementsBlock: [ :handled3586 | 
							self
								found:
									(self found
										pltPlus:
											(PTsInheritedExplicitAttributesFunction
												invokeFromValues:
													(OrderedCollection new
														add: handled3586;
														yourself))) ] ] ]
		from:
			(PltLOINDEXFunction
				invokeFromValues:
					(OrderedCollection new
						add: self unionAttributes;
						yourself))
		to:
			(PltHIINDEXFunction
				invokeFromValues:
					(OrderedCollection new
						add: self unionAttributes;
						yourself)).
	^ self return: self found

! !

!ExChdDiscriminatedTypeTailsAttributesFunction methodsFor: 'platypus-generated-accessing' stamp: ''!
typ
	^ typ

! !

!ExChdDiscriminatedTypeTailsAttributesFunction methodsFor: 'platypus-generated-accessing' stamp: ''!
typ: aExChdDiscriminatedType
	typ := aExChdDiscriminatedType

! !

!ExChdDiscriminatedTypeTailsAttributesFunction methodsFor: 'platypus-generated-accessing' stamp: ''!
unionAttr
	^ unionAttr

! !

!ExChdDiscriminatedTypeTailsAttributesFunction methodsFor: 'platypus-generated-accessing' stamp: ''!
unionAttr: aExChdAttribute
	unionAttr := aExChdAttribute

! !

!ExChdDiscriminatedTypeTailsAttributesFunction methodsFor: 'platypus-generated-accessing' stamp: ''!
unionAttributes
	^ unionAttributes

! !

!ExChdDiscriminatedTypeTailsAttributesFunction methodsFor: 'platypus-generated-accessing' stamp: ''!
unionAttributes: aListOfExChdAttribute
	unionAttributes := aListOfExChdAttribute
		ifNil: [ OrderedCollection new ]
		ifNotNil: [ aListOfExChdAttribute as: OrderedCollection ]

! !

!ExChdDiscriminatedTypeTailsAttributesFunction methodsFor: 'platypus-generated-accessing' stamp: ''!
unionType
	^ unionType

! !

!ExChdDiscriminatedTypeTailsAttributesFunction methodsFor: 'platypus-generated-accessing' stamp: ''!
unionType: aExChdDefinedType
	unionType := aExChdDefinedType

! !

PlatypusCoreAlgorithmDeclaration subclass: #ExChdDiscriminatedTypeUnionCaseCodeFunction
	instanceVariableNames: 'u code allAttributes'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Express2Cheddar-DiscriminatedTypeSchema'!

!ExChdDiscriminatedTypeUnionCaseCodeFunction commentStamp: 'platypus comment' prior: 0!
<ISO10303-11-EXPRESS>
FUNCTION discriminated_type_union_case_code ( u : discriminated_type_union_type ) : STRING;
	LOCAL 
		code : STRING := '';
		all_attributes : LIST OF attribute := inherited_explicit_attributes ( u );
	END_LOCAL;

	REPEAT no := LOINDEX ( all_attributes ) TO HIINDEX ( all_attributes );

		ALIAS attr FOR all_attributes [ no];
			ALIAS ada_domain FOR basic_ada_domain ( attr.domain ).handled;
				code := code + '\t\twhen ' + attr.name + ' => \n ' + ada_domain.union_ads_code;
			END_ALIAS;
		END_ALIAS;
		code := code + '\n';
	END_REPEAT;
	RETURN ( code );
END_FUNCTION;
</ISO10303-11-EXPRESS>!

!ExChdDiscriminatedTypeUnionCaseCodeFunction class methodsFor: 'platypus-generated-platypus-signature' stamp: ''!
iso10303P11Translater
	^ 'Platypus (c) LISYC EA3883, Universite de Bretagne occidentale. Brest.'

! !

!ExChdDiscriminatedTypeUnionCaseCodeFunction class methodsFor: 'platypus-generated-meta-data-accessing' stamp: ''!
schemaDefinition
	^ ExChdDiscriminatedTypeSchemaDefinition singleton

! !

!ExChdDiscriminatedTypeUnionCaseCodeFunction class methodsFor: 'platypus-generated-platypus-signature' stamp: ''!
translatedFromISO10303P11
	^ true

! !

!ExChdDiscriminatedTypeUnionCaseCodeFunction class methodsFor: 'platypus-generated-platypus-signature' stamp: ''!
vwNamespaceName
	^ #Express2Cheddar

! !

!ExChdDiscriminatedTypeUnionCaseCodeFunction methodsFor: 'platypus-generated-accessing' stamp: ''!
allAttributes
	^ allAttributes

! !

!ExChdDiscriminatedTypeUnionCaseCodeFunction methodsFor: 'platypus-generated-accessing' stamp: ''!
allAttributes: aListOfExChdAttribute
	allAttributes := aListOfExChdAttribute
		ifNil: [ OrderedCollection new ]
		ifNotNil: [ aListOfExChdAttribute as: OrderedCollection ]

! !

!ExChdDiscriminatedTypeUnionCaseCodeFunction methodsFor: 'platypus-generated-accessing' stamp: ''!
code
	^ code

! !

!ExChdDiscriminatedTypeUnionCaseCodeFunction methodsFor: 'platypus-generated-accessing' stamp: ''!
code: aString
	code := aString

! !

!ExChdDiscriminatedTypeUnionCaseCodeFunction methodsFor: 'platypus-generated-accessing' stamp: ''!
fromValues: values
	self u: (values at: 1)

! !

!ExChdDiscriminatedTypeUnionCaseCodeFunction methodsFor: 'platypus-generated-invoking' stamp: ''!
invoke
	" ---------- locals assignments ----------"

	self code: ''.
	self
		allAttributes:
			(PTsInheritedExplicitAttributesFunction
				invokeFromValues:
					(OrderedCollection new
						add: self u;
						yourself)).	" ---------- statements ----------"
	PlatypusCoreRepeatStatement
		repeat: [ :no62 | 
			PlatypusCoreAliasStatement
				alias: (self allAttributes pltAt: no62)
				statementsBlock: [ :attr1893 | 
					PlatypusCoreAliasStatement
						alias:
							((ExChdBasicAdaDomainFunction
								invokeFromValues:
									(OrderedCollection new
										add: (attr1893 domainUsingContext: self class context);
										yourself)) handledUsingContext: self class context)
						statementsBlock: [ :adaDomain1529 | 
							self
								code:
									((((self code pltPlus: '\t\twhen ') pltPlus: (attr1893 nameUsingContext: self class context)) pltPlus: ' => \n ')
										pltPlus: (adaDomain1529 unionAdsCodeUsingContext: self class context)) ] ].
			self code: (self code pltPlus: '\n') ]
		from:
			(PltLOINDEXFunction
				invokeFromValues:
					(OrderedCollection new
						add: self allAttributes;
						yourself))
		to:
			(PltHIINDEXFunction
				invokeFromValues:
					(OrderedCollection new
						add: self allAttributes;
						yourself)).
	^ self return: self code

! !

!ExChdDiscriminatedTypeUnionCaseCodeFunction methodsFor: 'platypus-generated-accessing' stamp: ''!
u
	^ u

! !

!ExChdDiscriminatedTypeUnionCaseCodeFunction methodsFor: 'platypus-generated-accessing' stamp: ''!
u: aExChdDiscriminatedTypeUnionType
	u := aExChdDiscriminatedTypeUnionType

! !

PlatypusCoreAlgorithmDeclaration subclass: #ExChdDiscriminatedTypeUnionElementCaseCodeFunction
	instanceVariableNames: 'u code allAttributes domain'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Express2Cheddar-DiscriminatedTypeSchema'!

!ExChdDiscriminatedTypeUnionElementCaseCodeFunction commentStamp: 'platypus comment' prior: 0!
<ISO10303-11-EXPRESS>
FUNCTION discriminated_type_union_element_case_code ( u : discriminated_type_union_element_type ) : STRING;
	LOCAL 
		code : STRING := '';
		all_attributes : LIST OF attribute := inherited_explicit_attributes ( u );
		domain : entity_instance;
	END_LOCAL;

	REPEAT no := LOINDEX ( all_attributes ) TO HIINDEX ( all_attributes );

		ALIAS attr FOR all_attributes [ no];
			domain := basic_ada_domain ( attr.domain );
			IF ( 'RECORD_AND_CLASS.ADA_CLASS' IN TYPEOF ( domain.handled ) ) THEN
				code := code + '\t\t\t' + attr.name + ' : ' + domain.handled.ptr_type + ';\n';
			ELSE
				code := code + '\t\t\t' + attr.name + ' : ' + domain.ada_ref_ident + ';\n';
			END_IF;
		END_ALIAS;
	END_REPEAT;
	RETURN ( code );
END_FUNCTION;
</ISO10303-11-EXPRESS>!

!ExChdDiscriminatedTypeUnionElementCaseCodeFunction class methodsFor: 'platypus-generated-platypus-signature' stamp: ''!
iso10303P11Translater
	^ 'Platypus (c) LISYC EA3883, Universite de Bretagne occidentale. Brest.'

! !

!ExChdDiscriminatedTypeUnionElementCaseCodeFunction class methodsFor: 'platypus-generated-meta-data-accessing' stamp: ''!
schemaDefinition
	^ ExChdDiscriminatedTypeSchemaDefinition singleton

! !

!ExChdDiscriminatedTypeUnionElementCaseCodeFunction class methodsFor: 'platypus-generated-platypus-signature' stamp: ''!
translatedFromISO10303P11
	^ true

! !

!ExChdDiscriminatedTypeUnionElementCaseCodeFunction class methodsFor: 'platypus-generated-platypus-signature' stamp: ''!
vwNamespaceName
	^ #Express2Cheddar

! !

!ExChdDiscriminatedTypeUnionElementCaseCodeFunction methodsFor: 'platypus-generated-accessing' stamp: ''!
allAttributes
	^ allAttributes

! !

!ExChdDiscriminatedTypeUnionElementCaseCodeFunction methodsFor: 'platypus-generated-accessing' stamp: ''!
allAttributes: aListOfExChdAttribute
	allAttributes := aListOfExChdAttribute
		ifNil: [ OrderedCollection new ]
		ifNotNil: [ aListOfExChdAttribute as: OrderedCollection ]

! !

!ExChdDiscriminatedTypeUnionElementCaseCodeFunction methodsFor: 'platypus-generated-accessing' stamp: ''!
code
	^ code

! !

!ExChdDiscriminatedTypeUnionElementCaseCodeFunction methodsFor: 'platypus-generated-accessing' stamp: ''!
code: aString
	code := aString

! !

!ExChdDiscriminatedTypeUnionElementCaseCodeFunction methodsFor: 'platypus-generated-accessing' stamp: ''!
domain
	^ domain

! !

!ExChdDiscriminatedTypeUnionElementCaseCodeFunction methodsFor: 'platypus-generated-accessing' stamp: ''!
domain: aExChdEntityInstance
	domain := aExChdEntityInstance

! !

!ExChdDiscriminatedTypeUnionElementCaseCodeFunction methodsFor: 'platypus-generated-accessing' stamp: ''!
fromValues: values
	self u: (values at: 1)

! !

!ExChdDiscriminatedTypeUnionElementCaseCodeFunction methodsFor: 'platypus-generated-invoking' stamp: ''!
invoke
	" ---------- locals assignments ----------"

	self code: ''.
	self
		allAttributes:
			(PTsInheritedExplicitAttributesFunction
				invokeFromValues:
					(OrderedCollection new
						add: self u;
						yourself)).	" ---------- statements ----------"
	PlatypusCoreRepeatStatement
		repeat: [ :no1543 | 
			PlatypusCoreAliasStatement
				alias: (self allAttributes pltAt: no1543)
				statementsBlock: [ :attr3374 | 
					self
						domain:
							(ExChdBasicAdaDomainFunction
								invokeFromValues:
									(OrderedCollection new
										add: (attr3374 domainUsingContext: self class context);
										yourself)).
					((PltTYPEOFFunction
						invokeFromValues:
							(OrderedCollection new
								add: (self domain handledUsingContext: self class context);
								yourself)) includes: 'RECORD_AND_CLASS.ADA_CLASS')
						ifTrue: [ 
							self
								code:
									(((((self code pltPlus: '\t\t\t') pltPlus: (attr3374 nameUsingContext: self class context)) pltPlus: ' : ')
										pltPlus: ((self domain handledUsingContext: self class context) ptrTypeUsingContext: self class context))
										pltPlus: ';\n') ]
						ifFalse: [ 
							self
								code:
									(((((self code pltPlus: '\t\t\t') pltPlus: (attr3374 nameUsingContext: self class context)) pltPlus: ' : ')
										pltPlus: (self domain adaRefIdentUsingContext: self class context)) pltPlus: ';\n') ] ] ]
		from:
			(PltLOINDEXFunction
				invokeFromValues:
					(OrderedCollection new
						add: self allAttributes;
						yourself))
		to:
			(PltHIINDEXFunction
				invokeFromValues:
					(OrderedCollection new
						add: self allAttributes;
						yourself)).
	^ self return: self code

! !

!ExChdDiscriminatedTypeUnionElementCaseCodeFunction methodsFor: 'platypus-generated-accessing' stamp: ''!
u
	^ u

! !

!ExChdDiscriminatedTypeUnionElementCaseCodeFunction methodsFor: 'platypus-generated-accessing' stamp: ''!
u: aExChdDiscriminatedTypeUnionElementType
	u := aExChdDiscriminatedTypeUnionElementType

! !

PlatypusCoreAlgorithmDeclaration subclass: #ExChdDiscriminatedTypeUnionTypeInterfacesListFunction
	instanceVariableNames: 'd isAds l'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Express2Cheddar-DiscriminatedTypeSchema'!

!ExChdDiscriminatedTypeUnionTypeInterfacesListFunction commentStamp: 'platypus comment' prior: 0!
<ISO10303-11-EXPRESS>
FUNCTION discriminated_type_union_type_interfaces_list ( d : discriminated_type_union_type; isAds : BOOLEAN ) : LIST OF ada_interface;
	LOCAL 
		l : LIST OF ada_interface := [ ];
	END_LOCAL;

	REPEAT no := LOINDEX ( d.attributes ) TO HIINDEX ( d.attributes );

		ALIAS curr FOR d.attributes [ no];
			l := l + entity_definition_interfaces_list ( curr.domain.handled, isAds );
		END_ALIAS;
	END_REPEAT;
	RETURN ( l );
END_FUNCTION;
</ISO10303-11-EXPRESS>!

!ExChdDiscriminatedTypeUnionTypeInterfacesListFunction class methodsFor: 'platypus-generated-platypus-signature' stamp: ''!
iso10303P11Translater
	^ 'Platypus (c) LISYC EA3883, Universite de Bretagne occidentale. Brest.'

! !

!ExChdDiscriminatedTypeUnionTypeInterfacesListFunction class methodsFor: 'platypus-generated-meta-data-accessing' stamp: ''!
schemaDefinition
	^ ExChdDiscriminatedTypeSchemaDefinition singleton

! !

!ExChdDiscriminatedTypeUnionTypeInterfacesListFunction class methodsFor: 'platypus-generated-platypus-signature' stamp: ''!
translatedFromISO10303P11
	^ true

! !

!ExChdDiscriminatedTypeUnionTypeInterfacesListFunction class methodsFor: 'platypus-generated-platypus-signature' stamp: ''!
vwNamespaceName
	^ #Express2Cheddar

! !

!ExChdDiscriminatedTypeUnionTypeInterfacesListFunction methodsFor: 'platypus-generated-accessing' stamp: ''!
d
	^ d

! !

!ExChdDiscriminatedTypeUnionTypeInterfacesListFunction methodsFor: 'platypus-generated-accessing' stamp: ''!
d: aExChdDiscriminatedTypeUnionType
	d := aExChdDiscriminatedTypeUnionType

! !

!ExChdDiscriminatedTypeUnionTypeInterfacesListFunction methodsFor: 'platypus-generated-accessing' stamp: ''!
d: aExChdDiscriminatedTypeUnionType isAds: aBoolean
	self d: aExChdDiscriminatedTypeUnionType.
	self isAds: aBoolean

! !

!ExChdDiscriminatedTypeUnionTypeInterfacesListFunction methodsFor: 'platypus-generated-accessing' stamp: ''!
fromValues: values
	self d: (values at: 1).
	self isAds: (values at: 2)

! !

!ExChdDiscriminatedTypeUnionTypeInterfacesListFunction methodsFor: 'platypus-generated-invoking' stamp: ''!
invoke
	" ---------- locals assignments ----------"

	self l: Array new.	" ---------- statements ----------"
	PlatypusCoreRepeatStatement
		repeat: [ :no1879 | 
			PlatypusCoreAliasStatement
				alias: ((self d attributesUsingContext: self class context) pltAt: no1879)
				statementsBlock: [ :curr285 | 
					self
						l:
							(self l
								pltPlus:
									(ExChdEntityDefinitionInterfacesListFunction
										invokeFromValues:
											(OrderedCollection new
												add: ((curr285 domainUsingContext: self class context) handledUsingContext: self class context);
												add: self isAds;
												yourself))) ] ]
		from:
			(PltLOINDEXFunction
				invokeFromValues:
					(OrderedCollection new
						add: (self d attributesUsingContext: self class context);
						yourself))
		to:
			(PltHIINDEXFunction
				invokeFromValues:
					(OrderedCollection new
						add: (self d attributesUsingContext: self class context);
						yourself)).
	^ self return: self l

! !

!ExChdDiscriminatedTypeUnionTypeInterfacesListFunction methodsFor: 'platypus-generated-accessing' stamp: ''!
isAds
	^ isAds

! !

!ExChdDiscriminatedTypeUnionTypeInterfacesListFunction methodsFor: 'platypus-generated-accessing' stamp: ''!
isAds: aBoolean
	isAds := aBoolean

! !

!ExChdDiscriminatedTypeUnionTypeInterfacesListFunction methodsFor: 'platypus-generated-accessing' stamp: ''!
l
	^ l

! !

!ExChdDiscriminatedTypeUnionTypeInterfacesListFunction methodsFor: 'platypus-generated-accessing' stamp: ''!
l: aListOfExChdAdaInterface
	l := aListOfExChdAdaInterface
		ifNil: [ OrderedCollection new ]
		ifNotNil: [ aListOfExChdAdaInterface as: OrderedCollection ]

! !

PlatypusCoreAlgorithmDeclaration subclass: #ExChdDiscriminatedTypeXmlEndElementCodeFunction
	instanceVariableNames: 'typ'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Express2Cheddar-DiscriminatedTypeSchema'!

!ExChdDiscriminatedTypeXmlEndElementCodeFunction commentStamp: 'platypus comment' prior: 0!
<ISO10303-11-EXPRESS>
FUNCTION discriminated_type_xml_end_element_code ( typ : discriminated_type ) : STRING;
	RETURN ( '\nprocedure End_Element(\n' 
		+ '\tHandler : in out Xml_generic_parser;\n' 
		+ '\tobj : in out ' + typ.name + '_io;\n' 
		+ '\tNamespace_Uri : Unicode.CES.Byte_Sequence := "";\n' 
		+ '\tLocal_Name    : Unicode.CES.Byte_Sequence := "";\n' 
		+ '\tQname : Unicode.CES.Byte_Sequence := "") is \nbegin\n' 
		+ discriminated_type_attributes_xml_end_element_code ( typ ) + '\nend End_Element;\n' );
END_FUNCTION;
</ISO10303-11-EXPRESS>!

!ExChdDiscriminatedTypeXmlEndElementCodeFunction class methodsFor: 'platypus-generated-platypus-signature' stamp: ''!
iso10303P11Translater
	^ 'Platypus (c) LISYC EA3883, Universite de Bretagne occidentale. Brest.'

! !

!ExChdDiscriminatedTypeXmlEndElementCodeFunction class methodsFor: 'platypus-generated-meta-data-accessing' stamp: ''!
schemaDefinition
	^ ExChdDiscriminatedTypeSchemaDefinition singleton

! !

!ExChdDiscriminatedTypeXmlEndElementCodeFunction class methodsFor: 'platypus-generated-platypus-signature' stamp: ''!
translatedFromISO10303P11
	^ true

! !

!ExChdDiscriminatedTypeXmlEndElementCodeFunction class methodsFor: 'platypus-generated-platypus-signature' stamp: ''!
vwNamespaceName
	^ #Express2Cheddar

! !

!ExChdDiscriminatedTypeXmlEndElementCodeFunction methodsFor: 'platypus-generated-accessing' stamp: ''!
fromValues: values
	self typ: (values at: 1)

! !

!ExChdDiscriminatedTypeXmlEndElementCodeFunction methodsFor: 'platypus-generated-invoking' stamp: ''!
invoke
	" ---------- locals assignments ----------"

	" ---------- statements ----------"

	^ self
		return:
			((((((((('\nprocedure End_Element(\n' pltPlus: '\tHandler : in out Xml_generic_parser;\n') pltPlus: '\tobj : in out ')
				pltPlus: (self typ nameUsingContext: self class context)) pltPlus: '_io;\n')
				pltPlus: '\tNamespace_Uri : Unicode.CES.Byte_Sequence := "";\n')
				pltPlus: '\tLocal_Name    : Unicode.CES.Byte_Sequence := "";\n')
				pltPlus: '\tQname : Unicode.CES.Byte_Sequence := "") is \nbegin\n')
				pltPlus:
					(ExChdDiscriminatedTypeAttributesXmlEndElementCodeFunction
						invokeFromValues:
							(OrderedCollection new
								add: self typ;
								yourself))) pltPlus: '\nend End_Element;\n')

! !

!ExChdDiscriminatedTypeXmlEndElementCodeFunction methodsFor: 'platypus-generated-accessing' stamp: ''!
typ
	^ typ

! !

!ExChdDiscriminatedTypeXmlEndElementCodeFunction methodsFor: 'platypus-generated-accessing' stamp: ''!
typ: aExChdDiscriminatedType
	typ := aExChdDiscriminatedType

! !

PlatypusCoreAlgorithmDeclaration subclass: #ExChdDiscriminatedTypeXmlIoRecordCodeFunction
	instanceVariableNames: 'typ code discrimAttr discrimType unionAttr unionType unionAttributes tailsAttrs translAttrs'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Express2Cheddar-DiscriminatedTypeSchema'!

!ExChdDiscriminatedTypeXmlIoRecordCodeFunction commentStamp: 'platypus comment' prior: 0!
<ISO10303-11-EXPRESS>
FUNCTION discriminated_type_xml_io_record_code ( typ : discriminated_type ) : STRING;
	LOCAL 
		code : STRING := '';
		discrim_attr : attribute := typ.discriminant;
		discrim_type : entity_instance := discrim_attr.domain.handled;
		union_attr : attribute := typ.union_attr;
		union_type : defined_type := union_attr.domain.handled;
		union_attributes : LIST OF attribute := inherited_explicit_attributes ( union_type );
		tails_attrs : LIST OF attribute := typ.tail_attributes;
		transl_attrs : LIST OF attribute := typ.translated_attributes;
	END_LOCAL;
	code := '\ntype ' + typ.name + '_io is record' + '\n\t' + discrim_attr.name + ' : ' + discrim_type.name + ';';

	REPEAT no := LOINDEX ( transl_attrs ) TO HIINDEX ( transl_attrs );

		ALIAS attr FOR transl_attrs [ no];
			code := code + explicit_attribute_xml_io_record_code ( attr );
		END_ALIAS;
	END_REPEAT;

	REPEAT no := LOINDEX ( tails_attrs ) TO HIINDEX ( tails_attrs );

		ALIAS attr FOR tails_attrs [ no];
			code := code + explicit_attribute_xml_io_record_code ( attr );
		END_ALIAS;
	END_REPEAT;
	code := code + '\nend record;\n';
	RETURN ( code );
END_FUNCTION;
</ISO10303-11-EXPRESS>!

!ExChdDiscriminatedTypeXmlIoRecordCodeFunction class methodsFor: 'platypus-generated-platypus-signature' stamp: ''!
iso10303P11Translater
	^ 'Platypus (c) LISYC EA3883, Universite de Bretagne occidentale. Brest.'

! !

!ExChdDiscriminatedTypeXmlIoRecordCodeFunction class methodsFor: 'platypus-generated-meta-data-accessing' stamp: ''!
schemaDefinition
	^ ExChdDiscriminatedTypeSchemaDefinition singleton

! !

!ExChdDiscriminatedTypeXmlIoRecordCodeFunction class methodsFor: 'platypus-generated-platypus-signature' stamp: ''!
translatedFromISO10303P11
	^ true

! !

!ExChdDiscriminatedTypeXmlIoRecordCodeFunction class methodsFor: 'platypus-generated-platypus-signature' stamp: ''!
vwNamespaceName
	^ #Express2Cheddar

! !

!ExChdDiscriminatedTypeXmlIoRecordCodeFunction methodsFor: 'platypus-generated-accessing' stamp: ''!
code
	^ code

! !

!ExChdDiscriminatedTypeXmlIoRecordCodeFunction methodsFor: 'platypus-generated-accessing' stamp: ''!
code: aString
	code := aString

! !

!ExChdDiscriminatedTypeXmlIoRecordCodeFunction methodsFor: 'platypus-generated-accessing' stamp: ''!
discrimAttr
	^ discrimAttr

! !

!ExChdDiscriminatedTypeXmlIoRecordCodeFunction methodsFor: 'platypus-generated-accessing' stamp: ''!
discrimAttr: aExChdAttribute
	discrimAttr := aExChdAttribute

! !

!ExChdDiscriminatedTypeXmlIoRecordCodeFunction methodsFor: 'platypus-generated-accessing' stamp: ''!
discrimType
	^ discrimType

! !

!ExChdDiscriminatedTypeXmlIoRecordCodeFunction methodsFor: 'platypus-generated-accessing' stamp: ''!
discrimType: aExChdEntityInstance
	discrimType := aExChdEntityInstance

! !

!ExChdDiscriminatedTypeXmlIoRecordCodeFunction methodsFor: 'platypus-generated-accessing' stamp: ''!
fromValues: values
	self typ: (values at: 1)

! !

!ExChdDiscriminatedTypeXmlIoRecordCodeFunction methodsFor: 'platypus-generated-invoking' stamp: ''!
invoke
	" ---------- locals assignments ----------"

	self code: ''.
	self discrimAttr: (self typ discriminantUsingContext: self class context).
	self discrimType: ((self discrimAttr domainUsingContext: self class context) handledUsingContext: self class context).
	self unionAttr: (self typ unionAttrUsingContext: self class context).
	self unionType: ((self unionAttr domainUsingContext: self class context) handledUsingContext: self class context).
	self
		unionAttributes:
			(PTsInheritedExplicitAttributesFunction
				invokeFromValues:
					(OrderedCollection new
						add: self unionType;
						yourself)).
	self tailsAttrs: (self typ tailAttributesUsingContext: self class context).
	self translAttrs: (self typ translatedAttributesUsingContext: self class context).	" ---------- statements ----------"
	self
		code:
			((((((('\ntype ' pltPlus: (self typ nameUsingContext: self class context)) pltPlus: '_io is record') pltPlus: '\n\t')
				pltPlus: (self discrimAttr nameUsingContext: self class context)) pltPlus: ' : ')
				pltPlus: (self discrimType nameUsingContext: self class context)) pltPlus: ';').
	PlatypusCoreRepeatStatement
		repeat: [ :no3824 | 
			PlatypusCoreAliasStatement
				alias: (self translAttrs pltAt: no3824)
				statementsBlock: [ :attr1555 | 
					self
						code:
							(self code
								pltPlus:
									(ExChdExplicitAttributeXmlIoRecordCodeFunction
										invokeFromValues:
											(OrderedCollection new
												add: attr1555;
												yourself))) ] ]
		from:
			(PltLOINDEXFunction
				invokeFromValues:
					(OrderedCollection new
						add: self translAttrs;
						yourself))
		to:
			(PltHIINDEXFunction
				invokeFromValues:
					(OrderedCollection new
						add: self translAttrs;
						yourself)).
	PlatypusCoreRepeatStatement
		repeat: [ :no1406 | 
			PlatypusCoreAliasStatement
				alias: (self tailsAttrs pltAt: no1406)
				statementsBlock: [ :attr3233 | 
					self
						code:
							(self code
								pltPlus:
									(ExChdExplicitAttributeXmlIoRecordCodeFunction
										invokeFromValues:
											(OrderedCollection new
												add: attr3233;
												yourself))) ] ]
		from:
			(PltLOINDEXFunction
				invokeFromValues:
					(OrderedCollection new
						add: self tailsAttrs;
						yourself))
		to:
			(PltHIINDEXFunction
				invokeFromValues:
					(OrderedCollection new
						add: self tailsAttrs;
						yourself)).
	self code: (self code pltPlus: '\nend record;\n').
	^ self return: self code

! !

!ExChdDiscriminatedTypeXmlIoRecordCodeFunction methodsFor: 'platypus-generated-accessing' stamp: ''!
tailsAttrs
	^ tailsAttrs

! !

!ExChdDiscriminatedTypeXmlIoRecordCodeFunction methodsFor: 'platypus-generated-accessing' stamp: ''!
tailsAttrs: aListOfExChdAttribute1
	tailsAttrs := aListOfExChdAttribute1
		ifNil: [ OrderedCollection new ]
		ifNotNil: [ aListOfExChdAttribute1 as: OrderedCollection ]

! !

!ExChdDiscriminatedTypeXmlIoRecordCodeFunction methodsFor: 'platypus-generated-accessing' stamp: ''!
translAttrs
	^ translAttrs

! !

!ExChdDiscriminatedTypeXmlIoRecordCodeFunction methodsFor: 'platypus-generated-accessing' stamp: ''!
translAttrs: aListOfExChdAttribute2
	translAttrs := aListOfExChdAttribute2
		ifNil: [ OrderedCollection new ]
		ifNotNil: [ aListOfExChdAttribute2 as: OrderedCollection ]

! !

!ExChdDiscriminatedTypeXmlIoRecordCodeFunction methodsFor: 'platypus-generated-accessing' stamp: ''!
typ
	^ typ

! !

!ExChdDiscriminatedTypeXmlIoRecordCodeFunction methodsFor: 'platypus-generated-accessing' stamp: ''!
typ: aExChdDiscriminatedType
	typ := aExChdDiscriminatedType

! !

!ExChdDiscriminatedTypeXmlIoRecordCodeFunction methodsFor: 'platypus-generated-accessing' stamp: ''!
unionAttr
	^ unionAttr

! !

!ExChdDiscriminatedTypeXmlIoRecordCodeFunction methodsFor: 'platypus-generated-accessing' stamp: ''!
unionAttr: aExChdAttribute1
	unionAttr := aExChdAttribute1

! !

!ExChdDiscriminatedTypeXmlIoRecordCodeFunction methodsFor: 'platypus-generated-accessing' stamp: ''!
unionAttributes
	^ unionAttributes

! !

!ExChdDiscriminatedTypeXmlIoRecordCodeFunction methodsFor: 'platypus-generated-accessing' stamp: ''!
unionAttributes: aListOfExChdAttribute
	unionAttributes := aListOfExChdAttribute
		ifNil: [ OrderedCollection new ]
		ifNotNil: [ aListOfExChdAttribute as: OrderedCollection ]

! !

!ExChdDiscriminatedTypeXmlIoRecordCodeFunction methodsFor: 'platypus-generated-accessing' stamp: ''!
unionType
	^ unionType

! !

!ExChdDiscriminatedTypeXmlIoRecordCodeFunction methodsFor: 'platypus-generated-accessing' stamp: ''!
unionType: aExChdDefinedType
	unionType := aExChdDefinedType

! !

PlatypusCoreAlgorithmDeclaration subclass: #ExChdDiscriminatedTypeXmlIoRecordInitializeCodeFunction
	instanceVariableNames: 'typ'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Express2Cheddar-DiscriminatedTypeSchema'!

!ExChdDiscriminatedTypeXmlIoRecordInitializeCodeFunction commentStamp: 'platypus comment' prior: 0!
<ISO10303-11-EXPRESS>
FUNCTION discriminated_type_xml_io_record_initialize_code ( typ : discriminated_type ) : STRING;
	RETURN ( '\nprocedure Initialize(obj : out ' + typ.name + '_io) is \nbegin ' + discriminated_type_attributes_xml_io_record_initialize_code ( typ ) + '\nend Initialize;\n' );
END_FUNCTION;
</ISO10303-11-EXPRESS>!

!ExChdDiscriminatedTypeXmlIoRecordInitializeCodeFunction class methodsFor: 'platypus-generated-platypus-signature' stamp: ''!
iso10303P11Translater
	^ 'Platypus (c) LISYC EA3883, Universite de Bretagne occidentale. Brest.'

! !

!ExChdDiscriminatedTypeXmlIoRecordInitializeCodeFunction class methodsFor: 'platypus-generated-meta-data-accessing' stamp: ''!
schemaDefinition
	^ ExChdDiscriminatedTypeSchemaDefinition singleton

! !

!ExChdDiscriminatedTypeXmlIoRecordInitializeCodeFunction class methodsFor: 'platypus-generated-platypus-signature' stamp: ''!
translatedFromISO10303P11
	^ true

! !

!ExChdDiscriminatedTypeXmlIoRecordInitializeCodeFunction class methodsFor: 'platypus-generated-platypus-signature' stamp: ''!
vwNamespaceName
	^ #Express2Cheddar

! !

!ExChdDiscriminatedTypeXmlIoRecordInitializeCodeFunction methodsFor: 'platypus-generated-accessing' stamp: ''!
fromValues: values
	self typ: (values at: 1)

! !

!ExChdDiscriminatedTypeXmlIoRecordInitializeCodeFunction methodsFor: 'platypus-generated-invoking' stamp: ''!
invoke
	" ---------- locals assignments ----------"

	" ---------- statements ----------"

	^ self
		return:
			(((('\nprocedure Initialize(obj : out ' pltPlus: (self typ nameUsingContext: self class context))
				pltPlus: '_io) is \nbegin ')
				pltPlus:
					(ExChdDiscriminatedTypeAttributesXmlIoRecordInitializeCodeFunction
						invokeFromValues:
							(OrderedCollection new
								add: self typ;
								yourself))) pltPlus: '\nend Initialize;\n')

! !

!ExChdDiscriminatedTypeXmlIoRecordInitializeCodeFunction methodsFor: 'platypus-generated-accessing' stamp: ''!
typ
	^ typ

! !

!ExChdDiscriminatedTypeXmlIoRecordInitializeCodeFunction methodsFor: 'platypus-generated-accessing' stamp: ''!
typ: aExChdDiscriminatedType
	typ := aExChdDiscriminatedType

! !

PlatypusCoreAlgorithmDeclaration subclass: #ExChdDiscriminatedTypeXmlStartElementCodeFunction
	instanceVariableNames: 'typ code'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Express2Cheddar-DiscriminatedTypeSchema'!

!ExChdDiscriminatedTypeXmlStartElementCodeFunction commentStamp: 'platypus comment' prior: 0!
<ISO10303-11-EXPRESS>
FUNCTION discriminated_type_xml_start_element_code ( typ : discriminated_type ) : STRING;
	LOCAL 
		code : STRING := discriminated_type_attributes_xml_start_element_code ( typ );
	END_LOCAL;

	IF ( code > '' ) THEN
		code := '\nprocedure Start_Element(\n' 
		+ '\tHandler: in out Xml_Generic_Parser;\n' 
		+ '\tobj : in out ' + typ.name + '_io;\n' 
		+ '\tNamespace_Uri : Unicode.CES.Byte_Sequence := "";\n' 
		+ '\tLocal_Name : Unicode.CES.Byte_Sequence := "";\n' 
		+ '\tQname : Unicode.CES.Byte_Sequence := "";\n' 
		+ '\tAtts : Sax.Attributes.Attributes''Class) is \nbegin\n' 
		+ '\tif Get_Length (Atts) > 0 then' + code + '\n' 
		+ '\tend if;\n' 
		+ 'end Start_Element;\n';
	END_IF;
	RETURN ( code );
END_FUNCTION;
</ISO10303-11-EXPRESS>!

!ExChdDiscriminatedTypeXmlStartElementCodeFunction class methodsFor: 'platypus-generated-platypus-signature' stamp: ''!
iso10303P11Translater
	^ 'Platypus (c) LISYC EA3883, Universite de Bretagne occidentale. Brest.'

! !

!ExChdDiscriminatedTypeXmlStartElementCodeFunction class methodsFor: 'platypus-generated-meta-data-accessing' stamp: ''!
schemaDefinition
	^ ExChdDiscriminatedTypeSchemaDefinition singleton

! !

!ExChdDiscriminatedTypeXmlStartElementCodeFunction class methodsFor: 'platypus-generated-platypus-signature' stamp: ''!
translatedFromISO10303P11
	^ true

! !

!ExChdDiscriminatedTypeXmlStartElementCodeFunction class methodsFor: 'platypus-generated-platypus-signature' stamp: ''!
vwNamespaceName
	^ #Express2Cheddar

! !

!ExChdDiscriminatedTypeXmlStartElementCodeFunction methodsFor: 'platypus-generated-accessing' stamp: ''!
code
	^ code

! !

!ExChdDiscriminatedTypeXmlStartElementCodeFunction methodsFor: 'platypus-generated-accessing' stamp: ''!
code: aString
	code := aString

! !

!ExChdDiscriminatedTypeXmlStartElementCodeFunction methodsFor: 'platypus-generated-accessing' stamp: ''!
fromValues: values
	self typ: (values at: 1)

! !

!ExChdDiscriminatedTypeXmlStartElementCodeFunction methodsFor: 'platypus-generated-invoking' stamp: ''!
invoke
	" ---------- locals assignments ----------"

	self
		code:
			(ExChdDiscriminatedTypeAttributesXmlStartElementCodeFunction
				invokeFromValues:
					(OrderedCollection new
						add: self typ;
						yourself)).	" ---------- statements ----------"
	self code > ''
		ifTrue: [ 
			self
				code:
					((((((((((((('\nprocedure Start_Element(\n' pltPlus: '\tHandler: in out Xml_Generic_Parser;\n')
						pltPlus: '\tobj : in out ') pltPlus: (self typ nameUsingContext: self class context)) pltPlus: '_io;\n')
						pltPlus: '\tNamespace_Uri : Unicode.CES.Byte_Sequence := "";\n')
						pltPlus: '\tLocal_Name : Unicode.CES.Byte_Sequence := "";\n')
						pltPlus: '\tQname : Unicode.CES.Byte_Sequence := "";\n')
						pltPlus: '\tAtts : Sax.Attributes.Attributes''Class) is \nbegin\n') pltPlus: '\tif Get_Length (Atts) > 0 then')
						pltPlus: self code) pltPlus: '\n') pltPlus: '\tend if;\n') pltPlus: 'end Start_Element;\n') ].
	^ self return: self code

! !

!ExChdDiscriminatedTypeXmlStartElementCodeFunction methodsFor: 'platypus-generated-accessing' stamp: ''!
typ
	^ typ

! !

!ExChdDiscriminatedTypeXmlStartElementCodeFunction methodsFor: 'platypus-generated-accessing' stamp: ''!
typ: aExChdDiscriminatedType
	typ := aExChdDiscriminatedType

! !

PlatypusCoreAlgorithmDeclaration subclass: #ExChdDoCommentsWithFunction
	instanceVariableNames: 'src'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Express2Cheddar-CheddarConstantsSchema'!

!ExChdDoCommentsWithFunction commentStamp: 'platypus comment' prior: 0!
<ISO10303-11-EXPRESS>
FUNCTION do_comments_with ( src : STRING ) : STRING;
	(*#  " comments " 
		| r s |
		r := ''.
		s :=  self src val.
		s linesDo: [:l | r := r , '--', l, String cr]. 
		self return: (PltStringLiteral val: r)
     		 #*) (*# <pharo> " comments " 
		| r s |
		r := ''.
		s :=  self src.
		s linesDo: [:l | r := r , '--', l, String cr]. 
		^ self return: r  #*) END_FUNCTION;
</ISO10303-11-EXPRESS>!

!ExChdDoCommentsWithFunction class methodsFor: 'platypus-generated-platypus-signature' stamp: ''!
iso10303P11Translater
	^ 'Platypus (c) LISYC EA3883, Universite de Bretagne occidentale. Brest.'

! !

!ExChdDoCommentsWithFunction class methodsFor: 'platypus-generated-meta-data-accessing' stamp: ''!
schemaDefinition
	^ ExChdCheddarConstantsSchemaDefinition singleton

! !

!ExChdDoCommentsWithFunction class methodsFor: 'platypus-generated-platypus-signature' stamp: ''!
translatedFromISO10303P11
	^ true

! !

!ExChdDoCommentsWithFunction class methodsFor: 'platypus-generated-platypus-signature' stamp: ''!
vwNamespaceName
	^ #Express2Cheddar

! !

!ExChdDoCommentsWithFunction methodsFor: 'platypus-generated-accessing' stamp: ''!
fromValues: values
	self src: (values at: 1)

! !

!ExChdDoCommentsWithFunction methodsFor: 'platypus-generated-invoking' stamp: ''!
invoke
	" ---------- locals assignments ----------"

	" ---------- statements ----------"

	"---------- native statement ---------- "

	" comments "

	| r s |
	r := ''.
	s := self src.
	s linesDo: [ :l | r := r , '--' , l , String cr ].
	^ self return: r

! !

!ExChdDoCommentsWithFunction methodsFor: 'platypus-generated-accessing' stamp: ''!
src
	^ src

! !

!ExChdDoCommentsWithFunction methodsFor: 'platypus-generated-accessing' stamp: ''!
src: aString
	src := aString

! !

PlatypusCoreAlgorithmDeclaration subclass: #ExChdDomainInterfacesListFunction
	instanceVariableNames: 'adaDomain ads pkg result'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Express2Cheddar-CheddarDomainsSchema'!

!ExChdDomainInterfacesListFunction commentStamp: 'platypus comment' prior: 0!
<ISO10303-11-EXPRESS>
FUNCTION domain_interfaces_list ( ada_domain : entity_instance; ads : BOOLEAN; pkg : schema_definition ) : LIST OF ada_interface;
	LOCAL 
		result : LIST OF ada_interface := [ ];
	END_LOCAL;

	ALIAS h FOR ada_domain.handled;

		IF ads THEN
			result := result + ada_domain.ads_interfaces_list;
		ELSE
			result := result + ada_domain.adb_interfaces_list;
			IF ( 'CHEDDAR_DOMAINS.ADA_ENUMERATION' IN TYPEOF ( h ) ) THEN
				IF ( h.owner.name <> pkg.name ) THEN
					result := result + ada_interface ( h.owner.name, ?, true, false );
					result := result + ada_interface ( h.full_io_type_name, ?, false, true );
				END_IF;
			END_IF;
		END_IF;

		IF ( 'CHEDDAR_DOMAINS.ADA_PRIMITIVE_TYPE' IN TYPEOF ( h ) ) OR ( 'DISCRIMINATED_TYPE.DISCRIMINATED_TYPE' IN TYPEOF ( h ) ) THEN
			IF ads THEN
				result := result + h.ads_interfaces_list;
			ELSE
				result := result + h.adb_interfaces_list;
			END_IF;
		END_IF;
	END_ALIAS;
	RETURN ( result );
END_FUNCTION;
</ISO10303-11-EXPRESS>!

!ExChdDomainInterfacesListFunction class methodsFor: 'platypus-generated-platypus-signature' stamp: ''!
iso10303P11Translater
	^ 'Platypus (c) LISYC EA3883, Universite de Bretagne occidentale. Brest.'

! !

!ExChdDomainInterfacesListFunction class methodsFor: 'platypus-generated-meta-data-accessing' stamp: ''!
schemaDefinition
	^ ExChdCheddarDomainsSchemaDefinition singleton

! !

!ExChdDomainInterfacesListFunction class methodsFor: 'platypus-generated-platypus-signature' stamp: ''!
translatedFromISO10303P11
	^ true

! !

!ExChdDomainInterfacesListFunction class methodsFor: 'platypus-generated-platypus-signature' stamp: ''!
vwNamespaceName
	^ #Express2Cheddar

! !

!ExChdDomainInterfacesListFunction methodsFor: 'platypus-generated-accessing' stamp: ''!
adaDomain
	^ adaDomain

! !

!ExChdDomainInterfacesListFunction methodsFor: 'platypus-generated-accessing' stamp: ''!
adaDomain: aExChdEntityInstance
	adaDomain := aExChdEntityInstance

! !

!ExChdDomainInterfacesListFunction methodsFor: 'platypus-generated-accessing' stamp: ''!
adaDomain: aExChdEntityInstance ads: aBoolean pkg: aExChdSchemaDefinition
	self adaDomain: aExChdEntityInstance.
	self ads: aBoolean.
	self pkg: aExChdSchemaDefinition

! !

!ExChdDomainInterfacesListFunction methodsFor: 'platypus-generated-accessing' stamp: ''!
ads
	^ ads

! !

!ExChdDomainInterfacesListFunction methodsFor: 'platypus-generated-accessing' stamp: ''!
ads: aBoolean
	ads := aBoolean

! !

!ExChdDomainInterfacesListFunction methodsFor: 'platypus-generated-accessing' stamp: ''!
fromValues: values
	self adaDomain: (values at: 1).
	self ads: (values at: 2).
	self pkg: (values at: 3)

! !

!ExChdDomainInterfacesListFunction methodsFor: 'platypus-generated-invoking' stamp: ''!
invoke
	" ---------- locals assignments ----------"

	self result: Array new.	" ---------- statements ----------"
	PlatypusCoreAliasStatement
		alias: (self adaDomain handledUsingContext: self class context)
		statementsBlock: [ :h2956 | 
			self ads
				ifTrue: [ self result: (self result pltPlus: (self adaDomain adsInterfacesListUsingContext: self class context)) ]
				ifFalse: [ 
					self result: (self result pltPlus: (self adaDomain adbInterfacesListUsingContext: self class context)).
					((PltTYPEOFFunction
						invokeFromValues:
							(OrderedCollection new
								add: h2956;
								yourself)) includes: 'CHEDDAR_DOMAINS.ADA_ENUMERATION')
						ifTrue: [ 
							((h2956 ownerUsingContext: self class context) nameUsingContext: self class context)
								~= (self pkg nameUsingContext: self class context)
								ifTrue: [ 
									self
										result:
											(self result
												pltPlus:
													(ExChdAdaInterface new
														adaInterfaceFromValues:
																(OrderedCollection new
																		add: ((h2956 ownerUsingContext: self class context) nameUsingContext: self class context);
																		add: nil;
																		add: true;
																		add: false;
																		yourself);
														yourself)).
									self
										result:
											(self result
												pltPlus:
													(ExChdAdaInterface new
														adaInterfaceFromValues:
																(OrderedCollection new
																		add: (h2956 fullIoTypeNameUsingContext: self class context);
																		add: nil;
																		add: false;
																		add: true;
																		yourself);
														yourself)) ] ] ].
			(((PltTYPEOFFunction
				invokeFromValues:
					(OrderedCollection new
						add: h2956;
						yourself)) includes: 'CHEDDAR_DOMAINS.ADA_PRIMITIVE_TYPE')
				or: [ 
					(PltTYPEOFFunction
						invokeFromValues:
							(OrderedCollection new
								add: h2956;
								yourself)) includes: 'DISCRIMINATED_TYPE.DISCRIMINATED_TYPE' ])
				ifTrue: [ 
					self ads
						ifTrue: [ self result: (self result pltPlus: (h2956 adsInterfacesListUsingContext: self class context)) ]
						ifFalse: [ self result: (self result pltPlus: (h2956 adbInterfacesListUsingContext: self class context)) ] ] ].
	^ self return: self result

! !

!ExChdDomainInterfacesListFunction methodsFor: 'platypus-generated-accessing' stamp: ''!
pkg
	^ pkg

! !

!ExChdDomainInterfacesListFunction methodsFor: 'platypus-generated-accessing' stamp: ''!
pkg: aExChdSchemaDefinition
	pkg := aExChdSchemaDefinition

! !

!ExChdDomainInterfacesListFunction methodsFor: 'platypus-generated-accessing' stamp: ''!
result
	^ result

! !

!ExChdDomainInterfacesListFunction methodsFor: 'platypus-generated-accessing' stamp: ''!
result: aListOfExChdAdaInterface
	result := aListOfExChdAdaInterface
		ifNil: [ OrderedCollection new ]
		ifNotNil: [ aListOfExChdAdaInterface as: OrderedCollection ]

! !

PlatypusCoreAlgorithmDeclaration subclass: #ExChdDtdsIntoProcedure
	instanceVariableNames: 'dir roots path'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Express2Cheddar-Express2cheddarFacadeSchema'!

!ExChdDtdsIntoProcedure commentStamp: 'platypus comment' prior: 0!
<ISO10303-11-EXPRESS>
PROCEDURE dtds_Into ( dir : STRING );
	LOCAL 
		roots : LIST OF root_dtd_element := root_dtds ( );
		path : STRING;
	END_LOCAL;
	(*#  MultiByteFileStream defaultToLF  #*) prepare_root_ada_classes;

	IF EXISTS ( dir ) THEN
		path := dir;
	ELSE
		path := '.';
	END_IF;

	REPEAT no := LOINDEX ( roots ) TO HIINDEX ( roots );

		ALIAS curr FOR roots [ no];
			WriteFile ( path + '/' + curr.tag + '.dtd', curr.dtd_code );
		END_ALIAS;
	END_REPEAT;
END_PROCEDURE;
</ISO10303-11-EXPRESS>!

!ExChdDtdsIntoProcedure class methodsFor: 'platypus-generated-platypus-signature' stamp: ''!
iso10303P11Translater
	^ 'Platypus (c) LISYC EA3883, Universite de Bretagne occidentale. Brest.'

! !

!ExChdDtdsIntoProcedure class methodsFor: 'platypus-generated-meta-data-accessing' stamp: ''!
schemaDefinition
	^ ExChdExpress2cheddarFacadeSchemaDefinition singleton

! !

!ExChdDtdsIntoProcedure class methodsFor: 'platypus-generated-platypus-signature' stamp: ''!
translatedFromISO10303P11
	^ true

! !

!ExChdDtdsIntoProcedure class methodsFor: 'platypus-generated-platypus-signature' stamp: ''!
vwNamespaceName
	^ #Express2Cheddar

! !

!ExChdDtdsIntoProcedure methodsFor: 'platypus-generated-accessing' stamp: ''!
dir
	^ dir

! !

!ExChdDtdsIntoProcedure methodsFor: 'platypus-generated-accessing' stamp: ''!
dir: aString
	dir := aString

! !

!ExChdDtdsIntoProcedure methodsFor: 'platypus-generated-accessing' stamp: ''!
fromValues: values
	self dir: (values at: 1)

! !

!ExChdDtdsIntoProcedure methodsFor: 'platypus-generated-invoking' stamp: ''!
invoke
	" ---------- locals assignments ----------"

	self roots: ExChdRootDtdsFunction invoke.	" ---------- statements ----------"	"---------- native statement ---------- "
	MultiByteFileStream defaultToLF.
	ExChdPrepareRootAdaClassesProcedure invoke.
	(PltEXISTSFunction
		invokeFromValues:
			(OrderedCollection new
				add: self dir;
				yourself))
		ifTrue: [ self path: self dir ]
		ifFalse: [ self path: '.' ].
	PlatypusCoreRepeatStatement
		repeat: [ :no2662 | 
			PlatypusCoreAliasStatement
				alias: (self roots pltAt: no2662)
				statementsBlock: [ :curr389 | 
					PTsWriteFileProcedure
						invokeFromValues:
							(OrderedCollection new
								add: (((self path pltPlus: '/') pltPlus: (curr389 tagUsingContext: self class context)) pltPlus: '.dtd');
								add: (curr389 dtdCodeUsingContext: self class context);
								yourself) ] ]
		from:
			(PltLOINDEXFunction
				invokeFromValues:
					(OrderedCollection new
						add: self roots;
						yourself))
		to:
			(PltHIINDEXFunction
				invokeFromValues:
					(OrderedCollection new
						add: self roots;
						yourself))

! !

!ExChdDtdsIntoProcedure methodsFor: 'platypus-generated-accessing' stamp: ''!
path
	^ path

! !

!ExChdDtdsIntoProcedure methodsFor: 'platypus-generated-accessing' stamp: ''!
path: aString
	path := aString

! !

!ExChdDtdsIntoProcedure methodsFor: 'platypus-generated-accessing' stamp: ''!
roots
	^ roots

! !

!ExChdDtdsIntoProcedure methodsFor: 'platypus-generated-accessing' stamp: ''!
roots: aListOfExChdRootDtdElement
	roots := aListOfExChdRootDtdElement
		ifNil: [ OrderedCollection new ]
		ifNotNil: [ aListOfExChdRootDtdElement as: OrderedCollection ]

! !

PlatypusCoreAlgorithmDeclaration subclass: #ExChdEntityDefinitionInterfacesListFunction
	instanceVariableNames: 'r ads result adaDomain'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Express2Cheddar-RecordAndClassSchema'!

!ExChdEntityDefinitionInterfacesListFunction commentStamp: 'platypus comment' prior: 0!
<ISO10303-11-EXPRESS>
FUNCTION entity_definition_interfaces_list ( r : entity_definition; ads : BOOLEAN ) : LIST OF ada_interface;
	LOCAL 
		result : LIST OF ada_interface := [ ];
		ada_domain : entity_instance;
	END_LOCAL;

	REPEAT no := LOINDEX ( r.explicit_attributes ) TO HIINDEX ( r.explicit_attributes );

		ALIAS curr FOR r.explicit_attributes [ no];
			ada_domain := basic_ada_domain ( curr.domain );
			result := result + domain_interfaces_list ( ada_domain, ads, r.owner );
		END_ALIAS;
	END_REPEAT;
	RETURN ( result );
END_FUNCTION;
</ISO10303-11-EXPRESS>!

!ExChdEntityDefinitionInterfacesListFunction class methodsFor: 'platypus-generated-platypus-signature' stamp: ''!
iso10303P11Translater
	^ 'Platypus (c) LISYC EA3883, Universite de Bretagne occidentale. Brest.'

! !

!ExChdEntityDefinitionInterfacesListFunction class methodsFor: 'platypus-generated-meta-data-accessing' stamp: ''!
schemaDefinition
	^ ExChdRecordAndClassSchemaDefinition singleton

! !

!ExChdEntityDefinitionInterfacesListFunction class methodsFor: 'platypus-generated-platypus-signature' stamp: ''!
translatedFromISO10303P11
	^ true

! !

!ExChdEntityDefinitionInterfacesListFunction class methodsFor: 'platypus-generated-platypus-signature' stamp: ''!
vwNamespaceName
	^ #Express2Cheddar

! !

!ExChdEntityDefinitionInterfacesListFunction methodsFor: 'platypus-generated-accessing' stamp: ''!
adaDomain
	^ adaDomain

! !

!ExChdEntityDefinitionInterfacesListFunction methodsFor: 'platypus-generated-accessing' stamp: ''!
adaDomain: aExChdEntityInstance
	adaDomain := aExChdEntityInstance

! !

!ExChdEntityDefinitionInterfacesListFunction methodsFor: 'platypus-generated-accessing' stamp: ''!
ads
	^ ads

! !

!ExChdEntityDefinitionInterfacesListFunction methodsFor: 'platypus-generated-accessing' stamp: ''!
ads: aBoolean
	ads := aBoolean

! !

!ExChdEntityDefinitionInterfacesListFunction methodsFor: 'platypus-generated-accessing' stamp: ''!
fromValues: values
	self r: (values at: 1).
	self ads: (values at: 2)

! !

!ExChdEntityDefinitionInterfacesListFunction methodsFor: 'platypus-generated-invoking' stamp: ''!
invoke
	" ---------- locals assignments ----------"

	self result: Array new.	" ---------- statements ----------"
	PlatypusCoreRepeatStatement
		repeat: [ :no267 | 
			PlatypusCoreAliasStatement
				alias: ((self r explicitAttributesUsingContext: self class context) pltAt: no267)
				statementsBlock: [ :curr2775 | 
					self
						adaDomain:
							(ExChdBasicAdaDomainFunction
								invokeFromValues:
									(OrderedCollection new
										add: (curr2775 domainUsingContext: self class context);
										yourself)).
					self
						result:
							(self result
								pltPlus:
									(ExChdDomainInterfacesListFunction
										invokeFromValues:
											(OrderedCollection new
												add: self adaDomain;
												add: self ads;
												add: (self r ownerUsingContext: self class context);
												yourself))) ] ]
		from:
			(PltLOINDEXFunction
				invokeFromValues:
					(OrderedCollection new
						add: (self r explicitAttributesUsingContext: self class context);
						yourself))
		to:
			(PltHIINDEXFunction
				invokeFromValues:
					(OrderedCollection new
						add: (self r explicitAttributesUsingContext: self class context);
						yourself)).
	^ self return: self result

! !

!ExChdEntityDefinitionInterfacesListFunction methodsFor: 'platypus-generated-accessing' stamp: ''!
r
	^ r

! !

!ExChdEntityDefinitionInterfacesListFunction methodsFor: 'platypus-generated-accessing' stamp: ''!
r: aExChdEntityDefinition
	r := aExChdEntityDefinition

! !

!ExChdEntityDefinitionInterfacesListFunction methodsFor: 'platypus-generated-accessing' stamp: ''!
r: aExChdEntityDefinition ads: aBoolean
	self r: aExChdEntityDefinition.
	self ads: aBoolean

! !

!ExChdEntityDefinitionInterfacesListFunction methodsFor: 'platypus-generated-accessing' stamp: ''!
result
	^ result

! !

!ExChdEntityDefinitionInterfacesListFunction methodsFor: 'platypus-generated-accessing' stamp: ''!
result: aListOfExChdAdaInterface
	result := aListOfExChdAdaInterface
		ifNil: [ OrderedCollection new ]
		ifNotNil: [ aListOfExChdAdaInterface as: OrderedCollection ]

! !

PlatypusCoreAlgorithmDeclaration subclass: #ExChdEnumerationAdbCodeFunction
	instanceVariableNames: 'e code'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Express2Cheddar-CheddarDomainsSchema'!

!ExChdEnumerationAdbCodeFunction commentStamp: 'platypus comment' prior: 0!
<ISO10303-11-EXPRESS>
FUNCTION enumeration_adb_code ( e : ada_enumeration ) : STRING;
	LOCAL 
		code : STRING;
	END_LOCAL;
	code := 'function XML_String(obj : in ' + e.name + ') return Unbounded_String is\n' 
	+ 'begin\n' 
	+ '	return to_unbounded_string(' + e.name + '''image (obj) );\n' 
	+ 'end XML_String;\n\n' 

	+ 'function XML_Ref_String (obj : in ' + e.name + ') return Unbounded_String is\n' 
	+ 'begin\n' 
	+ '\traise xml_ref_string_error;\n' 
	+ '\treturn to_unbounded_string("");\n' 
	+ 'end XML_Ref_String;\n\n';
	RETURN ( code );
END_FUNCTION;
</ISO10303-11-EXPRESS>!

!ExChdEnumerationAdbCodeFunction class methodsFor: 'platypus-generated-platypus-signature' stamp: ''!
iso10303P11Translater
	^ 'Platypus (c) LISYC EA3883, Universite de Bretagne occidentale. Brest.'

! !

!ExChdEnumerationAdbCodeFunction class methodsFor: 'platypus-generated-meta-data-accessing' stamp: ''!
schemaDefinition
	^ ExChdCheddarDomainsSchemaDefinition singleton

! !

!ExChdEnumerationAdbCodeFunction class methodsFor: 'platypus-generated-platypus-signature' stamp: ''!
translatedFromISO10303P11
	^ true

! !

!ExChdEnumerationAdbCodeFunction class methodsFor: 'platypus-generated-platypus-signature' stamp: ''!
vwNamespaceName
	^ #Express2Cheddar

! !

!ExChdEnumerationAdbCodeFunction methodsFor: 'platypus-generated-accessing' stamp: ''!
code
	^ code

! !

!ExChdEnumerationAdbCodeFunction methodsFor: 'platypus-generated-accessing' stamp: ''!
code: aString
	code := aString

! !

!ExChdEnumerationAdbCodeFunction methodsFor: 'platypus-generated-accessing' stamp: ''!
e
	^ e

! !

!ExChdEnumerationAdbCodeFunction methodsFor: 'platypus-generated-accessing' stamp: ''!
e: aExChdAdaEnumeration
	e := aExChdAdaEnumeration

! !

!ExChdEnumerationAdbCodeFunction methodsFor: 'platypus-generated-accessing' stamp: ''!
fromValues: values
	self e: (values at: 1)

! !

!ExChdEnumerationAdbCodeFunction methodsFor: 'platypus-generated-invoking' stamp: ''!
invoke
	" ---------- locals assignments ----------"

	" ---------- statements ----------"

	self
		code:
			(((((((((((((('function XML_String(obj : in ' pltPlus: (self e nameUsingContext: self class context))
				pltPlus: ') return Unbounded_String is\n') pltPlus: 'begin\n') pltPlus: '	return to_unbounded_string(')
				pltPlus: (self e nameUsingContext: self class context)) pltPlus: '''image (obj) );\n')
				pltPlus: 'end XML_String;\n\n') pltPlus: 'function XML_Ref_String (obj : in ')
				pltPlus: (self e nameUsingContext: self class context)) pltPlus: ') return Unbounded_String is\n')
				pltPlus: 'begin\n') pltPlus: '\traise xml_ref_string_error;\n') pltPlus: '\treturn to_unbounded_string("");\n')
				pltPlus: 'end XML_Ref_String;\n\n').
	^ self return: self code

! !

PlatypusCoreAlgorithmDeclaration subclass: #ExChdEnumerationAdsCodeFunction
	instanceVariableNames: 'e code convertType'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Express2Cheddar-CheddarDomainsSchema'!

!ExChdEnumerationAdsCodeFunction commentStamp: 'platypus comment' prior: 0!
<ISO10303-11-EXPRESS>
FUNCTION enumeration_ads_code ( e : ada_enumeration ) : STRING;
	LOCAL 
		code : STRING;
		convert_type : STRING := NVL ( e.convertion, e.domain.elements [ LOINDEX ( e.domain.elements ) ] );
	END_LOCAL;
	code := 'type ' + e.name + ' is (\n\t' + StringAggregateConcatSeparatedBy ( e.domain.elements, ',\n\t' ) + ');\n';

	IF ( 'CHEDDAR_DOMAINS.PRAGMA_CONVENTION' IN TYPEOF ( e ) ) THEN
		code := code + 'pragma convention (' + e.convention + ', ' + e.name + ');\n';
	END_IF;
	code := code + '\n' 
	+ 'procedure To_' + e.name + ' is\n' 
	+ 'new Convert_Strings(' + e.name + ', ' + convert_type + ');\n' 
	+ 'procedure To_' + e.name + ' is\n' 
	+ 'new Convert_Unbounded_Strings(' + e.name + ', ' + convert_type + ');\n' 
	+ 'function XML_String (obj : in ' + e.name + ') return Unbounded_String;\n' 
	+ 'function XML_Ref_String (obj : in ' + e.name + ') return Unbounded_String;\n' 
	+ 'package ' + e.name + '_io is new text_io.enumeration_io(' + e.name + ');\n' 
	+ 'use ' + e.name + '_io;\n\n';
	RETURN ( code );
END_FUNCTION;
</ISO10303-11-EXPRESS>!

!ExChdEnumerationAdsCodeFunction class methodsFor: 'platypus-generated-platypus-signature' stamp: ''!
iso10303P11Translater
	^ 'Platypus (c) LISYC EA3883, Universite de Bretagne occidentale. Brest.'

! !

!ExChdEnumerationAdsCodeFunction class methodsFor: 'platypus-generated-meta-data-accessing' stamp: ''!
schemaDefinition
	^ ExChdCheddarDomainsSchemaDefinition singleton

! !

!ExChdEnumerationAdsCodeFunction class methodsFor: 'platypus-generated-platypus-signature' stamp: ''!
translatedFromISO10303P11
	^ true

! !

!ExChdEnumerationAdsCodeFunction class methodsFor: 'platypus-generated-platypus-signature' stamp: ''!
vwNamespaceName
	^ #Express2Cheddar

! !

!ExChdEnumerationAdsCodeFunction methodsFor: 'platypus-generated-accessing' stamp: ''!
code
	^ code

! !

!ExChdEnumerationAdsCodeFunction methodsFor: 'platypus-generated-accessing' stamp: ''!
code: aString
	code := aString

! !

!ExChdEnumerationAdsCodeFunction methodsFor: 'platypus-generated-accessing' stamp: ''!
convertType
	^ convertType

! !

!ExChdEnumerationAdsCodeFunction methodsFor: 'platypus-generated-accessing' stamp: ''!
convertType: aString1
	convertType := aString1

! !

!ExChdEnumerationAdsCodeFunction methodsFor: 'platypus-generated-accessing' stamp: ''!
e
	^ e

! !

!ExChdEnumerationAdsCodeFunction methodsFor: 'platypus-generated-accessing' stamp: ''!
e: aExChdAdaEnumeration
	e := aExChdAdaEnumeration

! !

!ExChdEnumerationAdsCodeFunction methodsFor: 'platypus-generated-accessing' stamp: ''!
fromValues: values
	self e: (values at: 1)

! !

!ExChdEnumerationAdsCodeFunction methodsFor: 'platypus-generated-invoking' stamp: ''!
invoke
	" ---------- locals assignments ----------"

	self
		convertType:
			(PltNVLFunction
				invokeFromValues:
					(OrderedCollection new
						add: (self e convertionUsingContext: self class context);
						add:
								(((self e domainUsingContext: self class context) elementsUsingContext: self class context)
										pltAt:
											(PltLOINDEXFunction
												invokeFromValues:
													(OrderedCollection new
														add: ((self e domainUsingContext: self class context) elementsUsingContext: self class context);
														yourself)));
						yourself)).	" ---------- statements ----------"
	self
		code:
			(((('type ' pltPlus: (self e nameUsingContext: self class context)) pltPlus: ' is (\n\t')
				pltPlus:
					(PTsStringAggregateConcatSeparatedByFunction
						invokeFromValues:
							(OrderedCollection new
								add: ((self e domainUsingContext: self class context) elementsUsingContext: self class context);
								add: ',\n\t';
								yourself))) pltPlus: ');\n').
	((PltTYPEOFFunction
		invokeFromValues:
			(OrderedCollection new
				add: self e;
				yourself)) includes: 'CHEDDAR_DOMAINS.PRAGMA_CONVENTION')
		ifTrue: [ 
			self
				code:
					(((((self code pltPlus: 'pragma convention (') pltPlus: (self e conventionUsingContext: self class context))
						pltPlus: ', ') pltPlus: (self e nameUsingContext: self class context)) pltPlus: ');\n') ].
	self
		code:
			(((((((((((((((((((((((((((((((self code pltPlus: '\n') pltPlus: 'procedure To_')
				pltPlus: (self e nameUsingContext: self class context)) pltPlus: ' is\n') pltPlus: 'new Convert_Strings(')
				pltPlus: (self e nameUsingContext: self class context)) pltPlus: ', ') pltPlus: self convertType) pltPlus: ');\n')
				pltPlus: 'procedure To_') pltPlus: (self e nameUsingContext: self class context)) pltPlus: ' is\n')
				pltPlus: 'new Convert_Unbounded_Strings(') pltPlus: (self e nameUsingContext: self class context)) pltPlus: ', ')
				pltPlus: self convertType) pltPlus: ');\n') pltPlus: 'function XML_String (obj : in ')
				pltPlus: (self e nameUsingContext: self class context)) pltPlus: ') return Unbounded_String;\n')
				pltPlus: 'function XML_Ref_String (obj : in ') pltPlus: (self e nameUsingContext: self class context))
				pltPlus: ') return Unbounded_String;\n') pltPlus: 'package ') pltPlus: (self e nameUsingContext: self class context))
				pltPlus: '_io is new text_io.enumeration_io(') pltPlus: (self e nameUsingContext: self class context))
				pltPlus: ');\n') pltPlus: 'use ') pltPlus: (self e nameUsingContext: self class context)) pltPlus: '_io;\n\n').
	^ self return: self code

! !

PlatypusCoreAlgorithmDeclaration subclass: #ExChdExplicitAttributeInitializeFunction
	instanceVariableNames: 'attr domain init'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Express2Cheddar-RecordAndClassSchema'!

!ExChdExplicitAttributeInitializeFunction commentStamp: 'platypus comment' prior: 0!
<ISO10303-11-EXPRESS>
FUNCTION explicit_attribute_initialize ( attr : explicit_attribute ) : STRING;
	LOCAL 
		domain : dictionary_instance := basic_ada_domain ( attr.domain );
		init : STRING := domain.init_value;
	END_LOCAL;

	IF ( attr.name = xml_id_name ) THEN
		RETURN ( 'generate_id( framework_id, obj.' + attr.name + ' );' );
	END_IF;

	IF ( 'CHEDDAR_DOMAINS.IN_SCOPE_ATTRIBUTE' IN TYPEOF ( attr ) ) THEN
		RETURN ( attr.init_code );
	END_IF;

	IF ( 'CHEDDAR_DOMAINS.CHEDDAR_PRIMITIVE_TYPE' IN TYPEOF ( domain.handled ) ) THEN
		init := domain.handled.init_value;
	END_IF;

	IF NOT EXISTS ( init ) THEN
		RETURN ( ? );
	ELSE

		IF init <> 'initialize' THEN
			RETURN ( 'obj.' + attr.name + ' := ' + init + ';' );
		ELSE
			IF domain.handled.refed_by_pointer THEN
				RETURN ( 'initialize( obj.' + attr.name + '.all);' );
			ELSE
				RETURN ( 'initialize( obj.' + attr.name + ');' );
			END_IF;
		END_IF;
	END_IF;
END_FUNCTION;
</ISO10303-11-EXPRESS>!

!ExChdExplicitAttributeInitializeFunction class methodsFor: 'platypus-generated-platypus-signature' stamp: ''!
iso10303P11Translater
	^ 'Platypus (c) LISYC EA3883, Universite de Bretagne occidentale. Brest.'

! !

!ExChdExplicitAttributeInitializeFunction class methodsFor: 'platypus-generated-meta-data-accessing' stamp: ''!
schemaDefinition
	^ ExChdRecordAndClassSchemaDefinition singleton

! !

!ExChdExplicitAttributeInitializeFunction class methodsFor: 'platypus-generated-platypus-signature' stamp: ''!
translatedFromISO10303P11
	^ true

! !

!ExChdExplicitAttributeInitializeFunction class methodsFor: 'platypus-generated-platypus-signature' stamp: ''!
vwNamespaceName
	^ #Express2Cheddar

! !

!ExChdExplicitAttributeInitializeFunction methodsFor: 'platypus-generated-accessing' stamp: ''!
attr
	^ attr

! !

!ExChdExplicitAttributeInitializeFunction methodsFor: 'platypus-generated-accessing' stamp: ''!
attr: aExChdExplicitAttribute
	attr := aExChdExplicitAttribute

! !

!ExChdExplicitAttributeInitializeFunction methodsFor: 'platypus-generated-accessing' stamp: ''!
domain
	^ domain

! !

!ExChdExplicitAttributeInitializeFunction methodsFor: 'platypus-generated-accessing' stamp: ''!
domain: aExChdDictionaryInstance
	domain := aExChdDictionaryInstance

! !

!ExChdExplicitAttributeInitializeFunction methodsFor: 'platypus-generated-accessing' stamp: ''!
fromValues: values
	self attr: (values at: 1)

! !

!ExChdExplicitAttributeInitializeFunction methodsFor: 'platypus-generated-accessing' stamp: ''!
init
	^ init

! !

!ExChdExplicitAttributeInitializeFunction methodsFor: 'platypus-generated-accessing' stamp: ''!
init: aString
	init := aString

! !

!ExChdExplicitAttributeInitializeFunction methodsFor: 'platypus-generated-invoking' stamp: ''!
invoke
	" ---------- locals assignments ----------"

	self
		domain:
			(ExChdBasicAdaDomainFunction
				invokeFromValues:
					(OrderedCollection new
						add: (self attr domainUsingContext: self class context);
						yourself)).
	self init: (self domain initValueUsingContext: self class context).	" ---------- statements ----------"
	(self attr nameUsingContext: self class context) = 'cheddar_private_id'
		ifTrue: [ 
			^ self
				return:
					(('generate_id( framework_id, obj.' pltPlus: (self attr nameUsingContext: self class context)) pltPlus: ' );') ].
	((PltTYPEOFFunction
		invokeFromValues:
			(OrderedCollection new
				add: self attr;
				yourself)) includes: 'CHEDDAR_DOMAINS.IN_SCOPE_ATTRIBUTE')
		ifTrue: [ ^ self return: (self attr initCodeUsingContext: self class context) ].
	((PltTYPEOFFunction
		invokeFromValues:
			(OrderedCollection new
				add: (self domain handledUsingContext: self class context);
				yourself)) includes: 'CHEDDAR_DOMAINS.CHEDDAR_PRIMITIVE_TYPE')
		ifTrue: [ self init: ((self domain handledUsingContext: self class context) initValueUsingContext: self class context) ].
	(PltEXISTSFunction
		invokeFromValues:
			(OrderedCollection new
				add: self init;
				yourself)) not
		ifTrue: [ ^ self return: nil ]
		ifFalse: [ 
			self init ~= 'initialize'
				ifTrue: [ 
					^ self
						return:
							(((('obj.' pltPlus: (self attr nameUsingContext: self class context)) pltPlus: ' := ') pltPlus: self init) pltPlus: ';') ]
				ifFalse: [ 
					((self domain handledUsingContext: self class context) refedByPointerUsingContext: self class context)
						ifTrue: [ ^ self return: (('initialize( obj.' pltPlus: (self attr nameUsingContext: self class context)) pltPlus: '.all);') ]
						ifFalse: [ ^ self return: (('initialize( obj.' pltPlus: (self attr nameUsingContext: self class context)) pltPlus: ');') ] ] ]

! !

PlatypusCoreAlgorithmDeclaration subclass: #ExChdExplicitAttributePutFunction
	instanceVariableNames: 'attr code prfx domain'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Express2Cheddar-RecordAndClassSchema'!

!ExChdExplicitAttributePutFunction commentStamp: 'platypus comment' prior: 0!
<ISO10303-11-EXPRESS>
FUNCTION explicit_attribute_put ( attr : explicit_attribute ) : STRING;
	LOCAL 
		code : STRING;
		prfx : STRING := '';
		domain : entity_instance := basic_ada_domain ( attr.domain );
	END_LOCAL;
	code := 'put("' + attr.name + ': "); ';

	IF ( 'RECORD_AND_CLASS.CHEDDAR_FUNCTION_PTR' IN TYPEOF ( domain.handled ) ) THEN
		RETURN ( '' );
	END_IF;

	IF ( 'CHEDDAR_DOMAINS.ADA_PRIMITIVE_TYPE' IN TYPEOF ( domain.handled ) ) THEN
		prfx := domain.handled.put_prefix;
	END_IF;

	IF domain.handled.refed_by_pointer THEN
		code := code + 'if obj.' + attr.name + ' /= null then ' + prfx + 'put(obj.' + attr.name + '.all' + '); else put("null"); end if;';
	ELSE
		code := code + prfx + 'put(obj.' + attr.name + '); ';
	END_IF;
	code := code + 'put ( "; " );';
	RETURN ( code );
END_FUNCTION;
</ISO10303-11-EXPRESS>!

!ExChdExplicitAttributePutFunction class methodsFor: 'platypus-generated-platypus-signature' stamp: ''!
iso10303P11Translater
	^ 'Platypus (c) LISYC EA3883, Universite de Bretagne occidentale. Brest.'

! !

!ExChdExplicitAttributePutFunction class methodsFor: 'platypus-generated-meta-data-accessing' stamp: ''!
schemaDefinition
	^ ExChdRecordAndClassSchemaDefinition singleton

! !

!ExChdExplicitAttributePutFunction class methodsFor: 'platypus-generated-platypus-signature' stamp: ''!
translatedFromISO10303P11
	^ true

! !

!ExChdExplicitAttributePutFunction class methodsFor: 'platypus-generated-platypus-signature' stamp: ''!
vwNamespaceName
	^ #Express2Cheddar

! !

!ExChdExplicitAttributePutFunction methodsFor: 'platypus-generated-accessing' stamp: ''!
attr
	^ attr

! !

!ExChdExplicitAttributePutFunction methodsFor: 'platypus-generated-accessing' stamp: ''!
attr: aExChdExplicitAttribute
	attr := aExChdExplicitAttribute

! !

!ExChdExplicitAttributePutFunction methodsFor: 'platypus-generated-accessing' stamp: ''!
code
	^ code

! !

!ExChdExplicitAttributePutFunction methodsFor: 'platypus-generated-accessing' stamp: ''!
code: aString
	code := aString

! !

!ExChdExplicitAttributePutFunction methodsFor: 'platypus-generated-accessing' stamp: ''!
domain
	^ domain

! !

!ExChdExplicitAttributePutFunction methodsFor: 'platypus-generated-accessing' stamp: ''!
domain: aExChdEntityInstance
	domain := aExChdEntityInstance

! !

!ExChdExplicitAttributePutFunction methodsFor: 'platypus-generated-accessing' stamp: ''!
fromValues: values
	self attr: (values at: 1)

! !

!ExChdExplicitAttributePutFunction methodsFor: 'platypus-generated-invoking' stamp: ''!
invoke
	" ---------- locals assignments ----------"

	self prfx: ''.
	self
		domain:
			(ExChdBasicAdaDomainFunction
				invokeFromValues:
					(OrderedCollection new
						add: (self attr domainUsingContext: self class context);
						yourself)).	" ---------- statements ----------"
	self code: (('put("' pltPlus: (self attr nameUsingContext: self class context)) pltPlus: ': "); ').
	((PltTYPEOFFunction
		invokeFromValues:
			(OrderedCollection new
				add: (self domain handledUsingContext: self class context);
				yourself)) includes: 'RECORD_AND_CLASS.CHEDDAR_FUNCTION_PTR')
		ifTrue: [ ^ self return: '' ].
	((PltTYPEOFFunction
		invokeFromValues:
			(OrderedCollection new
				add: (self domain handledUsingContext: self class context);
				yourself)) includes: 'CHEDDAR_DOMAINS.ADA_PRIMITIVE_TYPE')
		ifTrue: [ self prfx: ((self domain handledUsingContext: self class context) putPrefixUsingContext: self class context) ].
	((self domain handledUsingContext: self class context) refedByPointerUsingContext: self class context)
		ifTrue: [ 
			self
				code:
					((((((((self code pltPlus: 'if obj.') pltPlus: (self attr nameUsingContext: self class context))
						pltPlus: ' /= null then ') pltPlus: self prfx) pltPlus: 'put(obj.')
						pltPlus: (self attr nameUsingContext: self class context)) pltPlus: '.all')
						pltPlus: '); else put("null"); end if;') ]
		ifFalse: [ 
			self
				code:
					((((self code pltPlus: self prfx) pltPlus: 'put(obj.') pltPlus: (self attr nameUsingContext: self class context))
						pltPlus: '); ') ].
	self code: (self code pltPlus: 'put ( "; " );').
	^ self return: self code

! !

!ExChdExplicitAttributePutFunction methodsFor: 'platypus-generated-accessing' stamp: ''!
prfx
	^ prfx

! !

!ExChdExplicitAttributePutFunction methodsFor: 'platypus-generated-accessing' stamp: ''!
prfx: aString1
	prfx := aString1

! !

PlatypusCoreAlgorithmDeclaration subclass: #ExChdExplicitAttributeXmlEndElementCodeFunction
	instanceVariableNames: 'attr code domain init ioDomain'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Express2Cheddar-RecordAndClassSchema'!

!ExChdExplicitAttributeXmlEndElementCodeFunction commentStamp: 'platypus comment' prior: 0!
<ISO10303-11-EXPRESS>
FUNCTION explicit_attribute_xml_end_element_code ( attr : explicit_attribute ) : STRING;
	LOCAL 
		code : STRING := '';
		domain : entity_instance := basic_ada_domain ( attr.domain );
		init : STRING := domain.init_value;
		io_domain : STRING;
	END_LOCAL;

	IF NOT is_generic_object ( domain.handled ) THEN

		IF ( 'CHEDDAR_DOMAINS.ADA_ENUMERATION' IN TYPEOF ( domain.handled ) ) OR EXISTS ( init ) THEN
			IF ( 'CHEDDAR_DOMAINS.ADA_ENUMERATION' IN TYPEOF ( domain.handled ) ) THEN
				io_domain := domain.ada_ident;
			ELSE
				IF ( init = 'empty_string' ) THEN
					io_domain := 'String';
				ELSE
					IF ( lowerize ( init ) = 'false' ) THEN
						io_domain := 'Boolean';
					ELSE
						IF ( init = '0' ) THEN
							io_domain := 'Integer';
						ELSE
							io_domain := 'Double';
						END_IF;
					END_IF;
				END_IF;
			END_IF;
			IF init = 'empty_string' THEN
				code := '\n\tif To_String (To_Lower (Qname)) = "' + lowerize ( attr.name ) + '" then\n' 
				+ '\t\tobj.' + attr.name + ' := handler.Parameter_List (1);\n' 
				+ '\tend if;';
			ELSE
				code := '\n\tif To_String (To_Lower (Qname)) = "' + lowerize ( attr.name ) + '" then\n' 
				+ '\t\tTo_' + io_domain + ' (handler.Parameter_List (1), obj.' + attr.name + ', Handler.Ok);\n' 
				+ '\t\tif not Handler.Ok then\n' 
				+ '\t\t\tPut_Line ("Warning : Error on data type From " & To_String (Handler.Locator));\n' 
				+ '\t\tend if;\n' 
				+ '\tend if;';
			END_IF;
		END_IF;
	END_IF;
	RETURN ( code );
END_FUNCTION;
</ISO10303-11-EXPRESS>!

!ExChdExplicitAttributeXmlEndElementCodeFunction class methodsFor: 'platypus-generated-platypus-signature' stamp: ''!
iso10303P11Translater
	^ 'Platypus (c) LISYC EA3883, Universite de Bretagne occidentale. Brest.'

! !

!ExChdExplicitAttributeXmlEndElementCodeFunction class methodsFor: 'platypus-generated-meta-data-accessing' stamp: ''!
schemaDefinition
	^ ExChdRecordAndClassSchemaDefinition singleton

! !

!ExChdExplicitAttributeXmlEndElementCodeFunction class methodsFor: 'platypus-generated-platypus-signature' stamp: ''!
translatedFromISO10303P11
	^ true

! !

!ExChdExplicitAttributeXmlEndElementCodeFunction class methodsFor: 'platypus-generated-platypus-signature' stamp: ''!
vwNamespaceName
	^ #Express2Cheddar

! !

!ExChdExplicitAttributeXmlEndElementCodeFunction methodsFor: 'platypus-generated-accessing' stamp: ''!
attr
	^ attr

! !

!ExChdExplicitAttributeXmlEndElementCodeFunction methodsFor: 'platypus-generated-accessing' stamp: ''!
attr: aExChdExplicitAttribute
	attr := aExChdExplicitAttribute

! !

!ExChdExplicitAttributeXmlEndElementCodeFunction methodsFor: 'platypus-generated-accessing' stamp: ''!
code
	^ code

! !

!ExChdExplicitAttributeXmlEndElementCodeFunction methodsFor: 'platypus-generated-accessing' stamp: ''!
code: aString
	code := aString

! !

!ExChdExplicitAttributeXmlEndElementCodeFunction methodsFor: 'platypus-generated-accessing' stamp: ''!
domain
	^ domain

! !

!ExChdExplicitAttributeXmlEndElementCodeFunction methodsFor: 'platypus-generated-accessing' stamp: ''!
domain: aExChdEntityInstance
	domain := aExChdEntityInstance

! !

!ExChdExplicitAttributeXmlEndElementCodeFunction methodsFor: 'platypus-generated-accessing' stamp: ''!
fromValues: values
	self attr: (values at: 1)

! !

!ExChdExplicitAttributeXmlEndElementCodeFunction methodsFor: 'platypus-generated-accessing' stamp: ''!
init
	^ init

! !

!ExChdExplicitAttributeXmlEndElementCodeFunction methodsFor: 'platypus-generated-accessing' stamp: ''!
init: aString1
	init := aString1

! !

!ExChdExplicitAttributeXmlEndElementCodeFunction methodsFor: 'platypus-generated-invoking' stamp: ''!
invoke
	" ---------- locals assignments ----------"

	self code: ''.
	self
		domain:
			(ExChdBasicAdaDomainFunction
				invokeFromValues:
					(OrderedCollection new
						add: (self attr domainUsingContext: self class context);
						yourself)).
	self init: (self domain initValueUsingContext: self class context).	" ---------- statements ----------"
	(ExChdIsGenericObjectFunction
		invokeFromValues:
			(OrderedCollection new
				add: (self domain handledUsingContext: self class context);
				yourself)) not
		ifTrue: [ 
			(((PltTYPEOFFunction
				invokeFromValues:
					(OrderedCollection new
						add: (self domain handledUsingContext: self class context);
						yourself)) includes: 'CHEDDAR_DOMAINS.ADA_ENUMERATION')
				or: [ 
					PltEXISTSFunction
						invokeFromValues:
							(OrderedCollection new
								add: self init;
								yourself) ])
				ifTrue: [ 
					((PltTYPEOFFunction
						invokeFromValues:
							(OrderedCollection new
								add: (self domain handledUsingContext: self class context);
								yourself)) includes: 'CHEDDAR_DOMAINS.ADA_ENUMERATION')
						ifTrue: [ self ioDomain: (self domain adaIdentUsingContext: self class context) ]
						ifFalse: [ 
							self init = 'empty_string'
								ifTrue: [ self ioDomain: 'String' ]
								ifFalse: [ 
									(PTsLowerizeFunction
										invokeFromValues:
											(OrderedCollection new
												add: self init;
												yourself)) = 'false'
										ifTrue: [ self ioDomain: 'Boolean' ]
										ifFalse: [ 
											self init = '0'
												ifTrue: [ self ioDomain: 'Integer' ]
												ifFalse: [ self ioDomain: 'Double' ] ] ] ].
					self init = 'empty_string'
						ifTrue: [ 
							self
								code:
									(((((('\n\tif To_String (To_Lower (Qname)) = "'
										pltPlus:
											(PTsLowerizeFunction
												invokeFromValues:
													(OrderedCollection new
														add: (self attr nameUsingContext: self class context);
														yourself))) pltPlus: '" then\n') pltPlus: '\t\tobj.')
										pltPlus: (self attr nameUsingContext: self class context)) pltPlus: ' := handler.Parameter_List (1);\n')
										pltPlus: '\tend if;') ]
						ifFalse: [ 
							self
								code:
									((((((((((('\n\tif To_String (To_Lower (Qname)) = "'
										pltPlus:
											(PTsLowerizeFunction
												invokeFromValues:
													(OrderedCollection new
														add: (self attr nameUsingContext: self class context);
														yourself))) pltPlus: '" then\n') pltPlus: '\t\tTo_') pltPlus: self ioDomain)
										pltPlus: ' (handler.Parameter_List (1), obj.') pltPlus: (self attr nameUsingContext: self class context))
										pltPlus: ', Handler.Ok);\n') pltPlus: '\t\tif not Handler.Ok then\n')
										pltPlus: '\t\t\tPut_Line ("Warning : Error on data type From " & To_String (Handler.Locator));\n')
										pltPlus: '\t\tend if;\n') pltPlus: '\tend if;') ] ] ].
	^ self return: self code

! !

!ExChdExplicitAttributeXmlEndElementCodeFunction methodsFor: 'platypus-generated-accessing' stamp: ''!
ioDomain
	^ ioDomain

! !

!ExChdExplicitAttributeXmlEndElementCodeFunction methodsFor: 'platypus-generated-accessing' stamp: ''!
ioDomain: aString2
	ioDomain := aString2

! !

PlatypusCoreAlgorithmDeclaration subclass: #ExChdExplicitAttributeXmlIoRecordCodeFunction
	instanceVariableNames: 'attr code domain init'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Express2Cheddar-RecordAndClassSchema'!

!ExChdExplicitAttributeXmlIoRecordCodeFunction commentStamp: 'platypus comment' prior: 0!
<ISO10303-11-EXPRESS>
FUNCTION explicit_attribute_xml_io_record_code ( attr : explicit_attribute ) : STRING;
	LOCAL 
		code : STRING := '';
		domain : entity_instance := basic_ada_domain ( attr.domain );
		init : STRING := domain.init_value;
	END_LOCAL;

	IF ( 'RECORD_AND_CLASS.RECORD' IN TYPEOF ( domain.handled ) ) THEN
		RETURN ( ada_entity_attributes_xml_io_record_code ( domain.handled ) );
	END_IF;

	IF NOT is_generic_object ( domain.handled ) THEN

		IF ( 'CHEDDAR_DOMAINS.ADA_ENUMERATION' IN TYPEOF ( domain.handled ) ) OR EXISTS ( init ) THEN
			IF ( 'CHEDDAR_DOMAINS.ADA_ENUMERATION' IN TYPEOF ( domain.handled ) ) THEN
				code := '\t' + attr.name + ' : ' + domain.ada_ref_ident + ';';
			ELSE
				IF ( init = 'empty_string' ) THEN
					code := '\t' + attr.name + ' : Unbounded_String;';
				ELSE
					IF ( lowerize ( init ) = 'false' ) THEN
						code := '\t' + attr.name + ' : Boolean;';
					ELSE
						IF ( init = '0' ) THEN
							code := '\t' + attr.name + ' : Integer;';
						ELSE
							code := '\t' + attr.name + ' : Double;';
						END_IF;
					END_IF;
				END_IF;
			END_IF;
		END_IF;
	ELSE
		code := '\t' + attr.name + ' : Unbounded_String;';
	END_IF;

	IF ( code > '' ) THEN
		code := '\n' 
		+ code;
	END_IF;
	RETURN ( code );
END_FUNCTION;
</ISO10303-11-EXPRESS>!

!ExChdExplicitAttributeXmlIoRecordCodeFunction class methodsFor: 'platypus-generated-platypus-signature' stamp: ''!
iso10303P11Translater
	^ 'Platypus (c) LISYC EA3883, Universite de Bretagne occidentale. Brest.'

! !

!ExChdExplicitAttributeXmlIoRecordCodeFunction class methodsFor: 'platypus-generated-meta-data-accessing' stamp: ''!
schemaDefinition
	^ ExChdRecordAndClassSchemaDefinition singleton

! !

!ExChdExplicitAttributeXmlIoRecordCodeFunction class methodsFor: 'platypus-generated-platypus-signature' stamp: ''!
translatedFromISO10303P11
	^ true

! !

!ExChdExplicitAttributeXmlIoRecordCodeFunction class methodsFor: 'platypus-generated-platypus-signature' stamp: ''!
vwNamespaceName
	^ #Express2Cheddar

! !

!ExChdExplicitAttributeXmlIoRecordCodeFunction methodsFor: 'platypus-generated-accessing' stamp: ''!
attr
	^ attr

! !

!ExChdExplicitAttributeXmlIoRecordCodeFunction methodsFor: 'platypus-generated-accessing' stamp: ''!
attr: aExChdExplicitAttribute
	attr := aExChdExplicitAttribute

! !

!ExChdExplicitAttributeXmlIoRecordCodeFunction methodsFor: 'platypus-generated-accessing' stamp: ''!
code
	^ code

! !

!ExChdExplicitAttributeXmlIoRecordCodeFunction methodsFor: 'platypus-generated-accessing' stamp: ''!
code: aString
	code := aString

! !

!ExChdExplicitAttributeXmlIoRecordCodeFunction methodsFor: 'platypus-generated-accessing' stamp: ''!
domain
	^ domain

! !

!ExChdExplicitAttributeXmlIoRecordCodeFunction methodsFor: 'platypus-generated-accessing' stamp: ''!
domain: aExChdEntityInstance
	domain := aExChdEntityInstance

! !

!ExChdExplicitAttributeXmlIoRecordCodeFunction methodsFor: 'platypus-generated-accessing' stamp: ''!
fromValues: values
	self attr: (values at: 1)

! !

!ExChdExplicitAttributeXmlIoRecordCodeFunction methodsFor: 'platypus-generated-accessing' stamp: ''!
init
	^ init

! !

!ExChdExplicitAttributeXmlIoRecordCodeFunction methodsFor: 'platypus-generated-accessing' stamp: ''!
init: aString1
	init := aString1

! !

!ExChdExplicitAttributeXmlIoRecordCodeFunction methodsFor: 'platypus-generated-invoking' stamp: ''!
invoke
	" ---------- locals assignments ----------"

	self code: ''.
	self
		domain:
			(ExChdBasicAdaDomainFunction
				invokeFromValues:
					(OrderedCollection new
						add: (self attr domainUsingContext: self class context);
						yourself)).
	self init: (self domain initValueUsingContext: self class context).	" ---------- statements ----------"
	((PltTYPEOFFunction
		invokeFromValues:
			(OrderedCollection new
				add: (self domain handledUsingContext: self class context);
				yourself)) includes: 'RECORD_AND_CLASS.RECORD')
		ifTrue: [ 
			^ self
				return:
					(ExChdAdaEntityAttributesXmlIoRecordCodeFunction
						invokeFromValues:
							(OrderedCollection new
								add: (self domain handledUsingContext: self class context);
								yourself)) ].
	(ExChdIsGenericObjectFunction
		invokeFromValues:
			(OrderedCollection new
				add: (self domain handledUsingContext: self class context);
				yourself)) not
		ifTrue: [ 
			(((PltTYPEOFFunction
				invokeFromValues:
					(OrderedCollection new
						add: (self domain handledUsingContext: self class context);
						yourself)) includes: 'CHEDDAR_DOMAINS.ADA_ENUMERATION')
				or: [ 
					PltEXISTSFunction
						invokeFromValues:
							(OrderedCollection new
								add: self init;
								yourself) ])
				ifTrue: [ 
					((PltTYPEOFFunction
						invokeFromValues:
							(OrderedCollection new
								add: (self domain handledUsingContext: self class context);
								yourself)) includes: 'CHEDDAR_DOMAINS.ADA_ENUMERATION')
						ifTrue: [ 
							self
								code:
									(((('\t' pltPlus: (self attr nameUsingContext: self class context)) pltPlus: ' : ')
										pltPlus: (self domain adaRefIdentUsingContext: self class context)) pltPlus: ';') ]
						ifFalse: [ 
							self init = 'empty_string'
								ifTrue: [ self code: (('\t' pltPlus: (self attr nameUsingContext: self class context)) pltPlus: ' : Unbounded_String;') ]
								ifFalse: [ 
									(PTsLowerizeFunction
										invokeFromValues:
											(OrderedCollection new
												add: self init;
												yourself)) = 'false'
										ifTrue: [ self code: (('\t' pltPlus: (self attr nameUsingContext: self class context)) pltPlus: ' : Boolean;') ]
										ifFalse: [ 
											self init = '0'
												ifTrue: [ self code: (('\t' pltPlus: (self attr nameUsingContext: self class context)) pltPlus: ' : Integer;') ]
												ifFalse: [ self code: (('\t' pltPlus: (self attr nameUsingContext: self class context)) pltPlus: ' : Double;') ] ] ] ] ] ]
		ifFalse: [ self code: (('\t' pltPlus: (self attr nameUsingContext: self class context)) pltPlus: ' : Unbounded_String;') ].
	self code > ''
		ifTrue: [ self code: ('\n' pltPlus: self code) ].
	^ self return: self code

! !

PlatypusCoreAlgorithmDeclaration subclass: #ExChdExplicitAttributeXmlIoRecordInitializeCodeFunction
	instanceVariableNames: 'attr code domain init'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Express2Cheddar-RecordAndClassSchema'!

!ExChdExplicitAttributeXmlIoRecordInitializeCodeFunction commentStamp: 'platypus comment' prior: 0!
<ISO10303-11-EXPRESS>
FUNCTION explicit_attribute_xml_io_record_initialize_code ( attr : explicit_attribute ) : STRING;
	LOCAL 
		code : STRING := '';
		domain : entity_instance := basic_ada_domain ( attr.domain );
		init : STRING := domain.init_value;
	END_LOCAL;

	IF NOT is_generic_object ( domain.handled ) THEN

		IF ( 'CHEDDAR_DOMAINS.ADA_ENUMERATION' IN TYPEOF ( domain.handled ) ) THEN
			code := '\tobj.' + attr.name + ' := ' + domain.ada_ref_ident + '''first;';
		ELSE
			IF EXISTS ( init ) THEN
				code := '\tobj.' + attr.name + ' := ' + init + ';';
			END_IF;
		END_IF;
	ELSE
		code := '\tobj.' + attr.name + ' := empty_string;';
	END_IF;
	RETURN ( code );
END_FUNCTION;
</ISO10303-11-EXPRESS>!

!ExChdExplicitAttributeXmlIoRecordInitializeCodeFunction class methodsFor: 'platypus-generated-platypus-signature' stamp: ''!
iso10303P11Translater
	^ 'Platypus (c) LISYC EA3883, Universite de Bretagne occidentale. Brest.'

! !

!ExChdExplicitAttributeXmlIoRecordInitializeCodeFunction class methodsFor: 'platypus-generated-meta-data-accessing' stamp: ''!
schemaDefinition
	^ ExChdRecordAndClassSchemaDefinition singleton

! !

!ExChdExplicitAttributeXmlIoRecordInitializeCodeFunction class methodsFor: 'platypus-generated-platypus-signature' stamp: ''!
translatedFromISO10303P11
	^ true

! !

!ExChdExplicitAttributeXmlIoRecordInitializeCodeFunction class methodsFor: 'platypus-generated-platypus-signature' stamp: ''!
vwNamespaceName
	^ #Express2Cheddar

! !

!ExChdExplicitAttributeXmlIoRecordInitializeCodeFunction methodsFor: 'platypus-generated-accessing' stamp: ''!
attr
	^ attr

! !

!ExChdExplicitAttributeXmlIoRecordInitializeCodeFunction methodsFor: 'platypus-generated-accessing' stamp: ''!
attr: aExChdExplicitAttribute
	attr := aExChdExplicitAttribute

! !

!ExChdExplicitAttributeXmlIoRecordInitializeCodeFunction methodsFor: 'platypus-generated-accessing' stamp: ''!
code
	^ code

! !

!ExChdExplicitAttributeXmlIoRecordInitializeCodeFunction methodsFor: 'platypus-generated-accessing' stamp: ''!
code: aString
	code := aString

! !

!ExChdExplicitAttributeXmlIoRecordInitializeCodeFunction methodsFor: 'platypus-generated-accessing' stamp: ''!
domain
	^ domain

! !

!ExChdExplicitAttributeXmlIoRecordInitializeCodeFunction methodsFor: 'platypus-generated-accessing' stamp: ''!
domain: aExChdEntityInstance
	domain := aExChdEntityInstance

! !

!ExChdExplicitAttributeXmlIoRecordInitializeCodeFunction methodsFor: 'platypus-generated-accessing' stamp: ''!
fromValues: values
	self attr: (values at: 1)

! !

!ExChdExplicitAttributeXmlIoRecordInitializeCodeFunction methodsFor: 'platypus-generated-accessing' stamp: ''!
init
	^ init

! !

!ExChdExplicitAttributeXmlIoRecordInitializeCodeFunction methodsFor: 'platypus-generated-accessing' stamp: ''!
init: aString1
	init := aString1

! !

!ExChdExplicitAttributeXmlIoRecordInitializeCodeFunction methodsFor: 'platypus-generated-invoking' stamp: ''!
invoke
	" ---------- locals assignments ----------"

	self code: ''.
	self
		domain:
			(ExChdBasicAdaDomainFunction
				invokeFromValues:
					(OrderedCollection new
						add: (self attr domainUsingContext: self class context);
						yourself)).
	self init: (self domain initValueUsingContext: self class context).	" ---------- statements ----------"
	(ExChdIsGenericObjectFunction
		invokeFromValues:
			(OrderedCollection new
				add: (self domain handledUsingContext: self class context);
				yourself)) not
		ifTrue: [ 
			((PltTYPEOFFunction
				invokeFromValues:
					(OrderedCollection new
						add: (self domain handledUsingContext: self class context);
						yourself)) includes: 'CHEDDAR_DOMAINS.ADA_ENUMERATION')
				ifTrue: [ 
					self
						code:
							(((('\tobj.' pltPlus: (self attr nameUsingContext: self class context)) pltPlus: ' := ')
								pltPlus: (self domain adaRefIdentUsingContext: self class context)) pltPlus: '''first;') ]
				ifFalse: [ 
					(PltEXISTSFunction
						invokeFromValues:
							(OrderedCollection new
								add: self init;
								yourself))
						ifTrue: [ 
							self
								code:
									(((('\tobj.' pltPlus: (self attr nameUsingContext: self class context)) pltPlus: ' := ') pltPlus: self init)
										pltPlus: ';') ] ] ]
		ifFalse: [ self code: (('\tobj.' pltPlus: (self attr nameUsingContext: self class context)) pltPlus: ' := empty_string;') ].
	^ self return: self code

! !

PlatypusCoreAlgorithmDeclaration subclass: #ExChdExplicitAttributeXmlStartElementCodeFunction
	instanceVariableNames: 'attr code domain subDomain elementDomain'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Express2Cheddar-RecordAndClassSchema'!

!ExChdExplicitAttributeXmlStartElementCodeFunction commentStamp: 'platypus comment' prior: 0!
<ISO10303-11-EXPRESS>
FUNCTION explicit_attribute_xml_start_element_code ( attr : explicit_attribute ) : STRING;
	LOCAL 
		code : STRING := '';
		domain : entity_instance := basic_ada_domain ( attr.domain );
		sub_domain : entity_instance;
		element_domain : entity_instance;
	END_LOCAL;

	IF is_generic_object ( domain.handled ) THEN
		code := '\n\t\tif To_String (To_Lower (Qname)) = "' + lowerize ( attr.name ) + '" then\n' 
		+ '\t\t\tfor J in 0 .. Get_Length (Atts) - 1 loop\n' 
		+ '\t\t\t\tif To_String (To_Lower (Get_Qname (Atts, J))) = "ref" then\n' 
		+ '\t\t\t\t\tobj.' + attr.name + ' := To_Unbounded_String (Get_Value (Atts, J));\n' 
		+ '\t\t\t\tend if;\n' 
		+ '\t\t\tend loop;\n' 
		+ '\t\tend if;';
	END_IF;
	RETURN ( code );
END_FUNCTION;
</ISO10303-11-EXPRESS>!

!ExChdExplicitAttributeXmlStartElementCodeFunction class methodsFor: 'platypus-generated-platypus-signature' stamp: ''!
iso10303P11Translater
	^ 'Platypus (c) LISYC EA3883, Universite de Bretagne occidentale. Brest.'

! !

!ExChdExplicitAttributeXmlStartElementCodeFunction class methodsFor: 'platypus-generated-meta-data-accessing' stamp: ''!
schemaDefinition
	^ ExChdRecordAndClassSchemaDefinition singleton

! !

!ExChdExplicitAttributeXmlStartElementCodeFunction class methodsFor: 'platypus-generated-platypus-signature' stamp: ''!
translatedFromISO10303P11
	^ true

! !

!ExChdExplicitAttributeXmlStartElementCodeFunction class methodsFor: 'platypus-generated-platypus-signature' stamp: ''!
vwNamespaceName
	^ #Express2Cheddar

! !

!ExChdExplicitAttributeXmlStartElementCodeFunction methodsFor: 'platypus-generated-accessing' stamp: ''!
attr
	^ attr

! !

!ExChdExplicitAttributeXmlStartElementCodeFunction methodsFor: 'platypus-generated-accessing' stamp: ''!
attr: aExChdExplicitAttribute
	attr := aExChdExplicitAttribute

! !

!ExChdExplicitAttributeXmlStartElementCodeFunction methodsFor: 'platypus-generated-accessing' stamp: ''!
code
	^ code

! !

!ExChdExplicitAttributeXmlStartElementCodeFunction methodsFor: 'platypus-generated-accessing' stamp: ''!
code: aString
	code := aString

! !

!ExChdExplicitAttributeXmlStartElementCodeFunction methodsFor: 'platypus-generated-accessing' stamp: ''!
domain
	^ domain

! !

!ExChdExplicitAttributeXmlStartElementCodeFunction methodsFor: 'platypus-generated-accessing' stamp: ''!
domain: aExChdEntityInstance
	domain := aExChdEntityInstance

! !

!ExChdExplicitAttributeXmlStartElementCodeFunction methodsFor: 'platypus-generated-accessing' stamp: ''!
elementDomain
	^ elementDomain

! !

!ExChdExplicitAttributeXmlStartElementCodeFunction methodsFor: 'platypus-generated-accessing' stamp: ''!
elementDomain: aExChdEntityInstance2
	elementDomain := aExChdEntityInstance2

! !

!ExChdExplicitAttributeXmlStartElementCodeFunction methodsFor: 'platypus-generated-accessing' stamp: ''!
fromValues: values
	self attr: (values at: 1)

! !

!ExChdExplicitAttributeXmlStartElementCodeFunction methodsFor: 'platypus-generated-invoking' stamp: ''!
invoke
	" ---------- locals assignments ----------"

	self code: ''.
	self
		domain:
			(ExChdBasicAdaDomainFunction
				invokeFromValues:
					(OrderedCollection new
						add: (self attr domainUsingContext: self class context);
						yourself)).	" ---------- statements ----------"
	(ExChdIsGenericObjectFunction
		invokeFromValues:
			(OrderedCollection new
				add: (self domain handledUsingContext: self class context);
				yourself))
		ifTrue: [ 
			self
				code:
					(((((((((('\n\t\tif To_String (To_Lower (Qname)) = "'
						pltPlus:
							(PTsLowerizeFunction
								invokeFromValues:
									(OrderedCollection new
										add: (self attr nameUsingContext: self class context);
										yourself))) pltPlus: '" then\n') pltPlus: '\t\t\tfor J in 0 .. Get_Length (Atts) - 1 loop\n')
						pltPlus: '\t\t\t\tif To_String (To_Lower (Get_Qname (Atts, J))) = "ref" then\n') pltPlus: '\t\t\t\t\tobj.')
						pltPlus: (self attr nameUsingContext: self class context))
						pltPlus: ' := To_Unbounded_String (Get_Value (Atts, J));\n') pltPlus: '\t\t\t\tend if;\n')
						pltPlus: '\t\t\tend loop;\n') pltPlus: '\t\tend if;') ]
		ifFalse: [  ].
	^ self return: self code

! !

!ExChdExplicitAttributeXmlStartElementCodeFunction methodsFor: 'platypus-generated-accessing' stamp: ''!
subDomain
	^ subDomain

! !

!ExChdExplicitAttributeXmlStartElementCodeFunction methodsFor: 'platypus-generated-accessing' stamp: ''!
subDomain: aExChdEntityInstance1
	subDomain := aExChdEntityInstance1

! !

PlatypusCoreAlgorithmDeclaration subclass: #ExChdExplicitAttributeXmlWriterCodeFunction
	instanceVariableNames: 'prefix attr code domain tag'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Express2Cheddar-RecordAndClassSchema'!

!ExChdExplicitAttributeXmlWriterCodeFunction commentStamp: 'platypus comment' prior: 0!
<ISO10303-11-EXPRESS>
FUNCTION explicit_attribute_xml_writer_code ( prefix : STRING; attr : explicit_attribute ) : STRING;
	LOCAL 
		code : STRING;
		domain : entity_instance := basic_ada_domain ( attr.domain );
		tag : STRING := Lowerize ( attr.name );
	END_LOCAL;

	IF ( 'RECORD_AND_CLASS.CHEDDAR_FUNCTION_PTR' IN TYPEOF ( domain.handled ) ) THEN
		RETURN ( '' );
	END_IF;

	IF ( attr.name = xml_id_name ) THEN
		RETURN ( '' );
	END_IF;

	IF is_generic_object ( domain.handled ) THEN
		code := '\tresult := result & to_unbounded_string("<' + attr.name + ' ref=""") & ' + prefix + '.' + attr.name + '.' + xml_id_name + ' & to_unbounded_string(""" />");';
	ELSE
		code := '\tif (XML_String(' + prefix + '.' + attr.name + ') /= Empty_String) then\n' 
		+ '\t\tresult := result & to_unbounded_string("<' + tag + '>") & XML_String(' + prefix + '.' + attr.name + ') & to_unbounded_string("</' + tag + '>");\n\tend if;';
	END_IF;
	RETURN ( code );
END_FUNCTION;
</ISO10303-11-EXPRESS>!

!ExChdExplicitAttributeXmlWriterCodeFunction class methodsFor: 'platypus-generated-platypus-signature' stamp: ''!
iso10303P11Translater
	^ 'Platypus (c) LISYC EA3883, Universite de Bretagne occidentale. Brest.'

! !

!ExChdExplicitAttributeXmlWriterCodeFunction class methodsFor: 'platypus-generated-meta-data-accessing' stamp: ''!
schemaDefinition
	^ ExChdRecordAndClassSchemaDefinition singleton

! !

!ExChdExplicitAttributeXmlWriterCodeFunction class methodsFor: 'platypus-generated-platypus-signature' stamp: ''!
translatedFromISO10303P11
	^ true

! !

!ExChdExplicitAttributeXmlWriterCodeFunction class methodsFor: 'platypus-generated-platypus-signature' stamp: ''!
vwNamespaceName
	^ #Express2Cheddar

! !

!ExChdExplicitAttributeXmlWriterCodeFunction methodsFor: 'platypus-generated-accessing' stamp: ''!
attr
	^ attr

! !

!ExChdExplicitAttributeXmlWriterCodeFunction methodsFor: 'platypus-generated-accessing' stamp: ''!
attr: aExChdExplicitAttribute
	attr := aExChdExplicitAttribute

! !

!ExChdExplicitAttributeXmlWriterCodeFunction methodsFor: 'platypus-generated-accessing' stamp: ''!
code
	^ code

! !

!ExChdExplicitAttributeXmlWriterCodeFunction methodsFor: 'platypus-generated-accessing' stamp: ''!
code: aString
	code := aString

! !

!ExChdExplicitAttributeXmlWriterCodeFunction methodsFor: 'platypus-generated-accessing' stamp: ''!
domain
	^ domain

! !

!ExChdExplicitAttributeXmlWriterCodeFunction methodsFor: 'platypus-generated-accessing' stamp: ''!
domain: aExChdEntityInstance
	domain := aExChdEntityInstance

! !

!ExChdExplicitAttributeXmlWriterCodeFunction methodsFor: 'platypus-generated-accessing' stamp: ''!
fromValues: values
	self prefix: (values at: 1).
	self attr: (values at: 2)

! !

!ExChdExplicitAttributeXmlWriterCodeFunction methodsFor: 'platypus-generated-invoking' stamp: ''!
invoke
	" ---------- locals assignments ----------"

	self
		domain:
			(ExChdBasicAdaDomainFunction
				invokeFromValues:
					(OrderedCollection new
						add: (self attr domainUsingContext: self class context);
						yourself)).
	self
		tag:
			(PTsLowerizeFunction
				invokeFromValues:
					(OrderedCollection new
						add: (self attr nameUsingContext: self class context);
						yourself)).	" ---------- statements ----------"
	((PltTYPEOFFunction
		invokeFromValues:
			(OrderedCollection new
				add: (self domain handledUsingContext: self class context);
				yourself)) includes: 'RECORD_AND_CLASS.CHEDDAR_FUNCTION_PTR')
		ifTrue: [ ^ self return: '' ].
	(self attr nameUsingContext: self class context) = 'cheddar_private_id'
		ifTrue: [ ^ self return: '' ].
	(ExChdIsGenericObjectFunction
		invokeFromValues:
			(OrderedCollection new
				add: (self domain handledUsingContext: self class context);
				yourself))
		ifTrue: [ 
			self
				code:
					(((((((('\tresult := result & to_unbounded_string("<' pltPlus: (self attr nameUsingContext: self class context))
						pltPlus: ' ref=""") & ') pltPlus: self prefix) pltPlus: '.')
						pltPlus: (self attr nameUsingContext: self class context)) pltPlus: '.') pltPlus: 'cheddar_private_id')
						pltPlus: ' & to_unbounded_string(""" />");') ]
		ifFalse: [ 
			self
				code:
					((((((((((((('\tif (XML_String(' pltPlus: self prefix) pltPlus: '.')
						pltPlus: (self attr nameUsingContext: self class context)) pltPlus: ') /= Empty_String) then\n')
						pltPlus: '\t\tresult := result & to_unbounded_string("<') pltPlus: self tag) pltPlus: '>") & XML_String(')
						pltPlus: self prefix) pltPlus: '.') pltPlus: (self attr nameUsingContext: self class context))
						pltPlus: ') & to_unbounded_string("</') pltPlus: self tag) pltPlus: '>");\n\tend if;') ].
	^ self return: self code

! !

!ExChdExplicitAttributeXmlWriterCodeFunction methodsFor: 'platypus-generated-accessing' stamp: ''!
prefix
	^ prefix

! !

!ExChdExplicitAttributeXmlWriterCodeFunction methodsFor: 'platypus-generated-accessing' stamp: ''!
prefix: aString
	prefix := aString

! !

!ExChdExplicitAttributeXmlWriterCodeFunction methodsFor: 'platypus-generated-accessing' stamp: ''!
prefix: aString attr: aExChdExplicitAttribute
	self prefix: aString.
	self attr: aExChdExplicitAttribute

! !

!ExChdExplicitAttributeXmlWriterCodeFunction methodsFor: 'platypus-generated-accessing' stamp: ''!
tag
	^ tag

! !

!ExChdExplicitAttributeXmlWriterCodeFunction methodsFor: 'platypus-generated-accessing' stamp: ''!
tag: aString1
	tag := aString1

! !

PlatypusCoreAlgorithmDeclaration subclass: #ExChdGenerateAllIntoProcedure
	instanceVariableNames: 'dir'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Express2Cheddar-Express2cheddarFacadeSchema'!

!ExChdGenerateAllIntoProcedure commentStamp: 'platypus comment' prior: 0!
<ISO10303-11-EXPRESS>
PROCEDURE generate_all_into ( dir : STRING );
	(*#  MultiByteFileStream defaultToLF  #*) prepare_root_ada_classes;
	all_packages_code_into ( true, dir, 'Platypus2Cheddar' );
	all_packages_code_into ( false, dir, 'Platypus2Cheddar' );
	dtds_into ( dir );
END_PROCEDURE;
</ISO10303-11-EXPRESS>!

!ExChdGenerateAllIntoProcedure class methodsFor: 'platypus-generated-platypus-signature' stamp: ''!
iso10303P11Translater
	^ 'Platypus (c) LISYC EA3883, Universite de Bretagne occidentale. Brest.'

! !

!ExChdGenerateAllIntoProcedure class methodsFor: 'platypus-generated-meta-data-accessing' stamp: ''!
schemaDefinition
	^ ExChdExpress2cheddarFacadeSchemaDefinition singleton

! !

!ExChdGenerateAllIntoProcedure class methodsFor: 'platypus-generated-platypus-signature' stamp: ''!
translatedFromISO10303P11
	^ true

! !

!ExChdGenerateAllIntoProcedure class methodsFor: 'platypus-generated-platypus-signature' stamp: ''!
vwNamespaceName
	^ #Express2Cheddar

! !

!ExChdGenerateAllIntoProcedure methodsFor: 'platypus-generated-accessing' stamp: ''!
dir
	^ dir

! !

!ExChdGenerateAllIntoProcedure methodsFor: 'platypus-generated-accessing' stamp: ''!
dir: aString
	dir := aString

! !

!ExChdGenerateAllIntoProcedure methodsFor: 'platypus-generated-accessing' stamp: ''!
fromValues: values
	self dir: (values at: 1)

! !

!ExChdGenerateAllIntoProcedure methodsFor: 'platypus-generated-invoking' stamp: ''!
invoke
	" ---------- locals assignments ----------"

	" ---------- statements ----------"

	"---------- native statement ---------- "

	MultiByteFileStream defaultToLF.
	ExChdPrepareRootAdaClassesProcedure invoke.
	ExChdAllPackagesCodeIntoFunction
		invokeFromValues:
			(OrderedCollection new
				add: true;
				add: self dir;
				add: 'Platypus2Cheddar';
				yourself).
	ExChdAllPackagesCodeIntoFunction
		invokeFromValues:
			(OrderedCollection new
				add: false;
				add: self dir;
				add: 'Platypus2Cheddar';
				yourself).
	ExChdDtdsIntoProcedure
		invokeFromValues:
			(OrderedCollection new
				add: self dir;
				yourself)

! !

PlatypusCoreAlgorithmDeclaration subclass: #ExChdGenericPackageAliasesFunction
	instanceVariableNames: 'e aliases attrname'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Express2Cheddar-PackageSchema'!

!ExChdGenericPackageAliasesFunction commentStamp: 'platypus comment' prior: 0!
<ISO10303-11-EXPRESS>
FUNCTION generic_package_aliases ( e : generic_package_instanciation ) : LIST OF cheddar_defined_type;
	LOCAL 
		aliases : LIST OF entity_instance := [ ];
		attrname : STRING;
	END_LOCAL;

	REPEAT no := LOINDEX ( e.attributes ) TO HIINDEX ( e.attributes );

		ALIAS attr FOR e.attributes [ no];
			ALIAS an FOR attr.name;
				IF ( an [ LENGTH ( an ) ] = '_' ) THEN
					attrname := an [ 1 : LENGTH ( an ) - 1 ];
				ELSE
					attrname := an;
				END_IF;
			END_ALIAS;
			aliases := aliases + ( ada_type ( ) || attr.domain || package_alias ( e.name, attrname ) );
		END_ALIAS;
	END_REPEAT;
	RETURN ( aliases );
END_FUNCTION;
</ISO10303-11-EXPRESS>!

!ExChdGenericPackageAliasesFunction class methodsFor: 'platypus-generated-platypus-signature' stamp: ''!
iso10303P11Translater
	^ 'Platypus (c) LISYC EA3883, Universite de Bretagne occidentale. Brest.'

! !

!ExChdGenericPackageAliasesFunction class methodsFor: 'platypus-generated-meta-data-accessing' stamp: ''!
schemaDefinition
	^ ExChdPackageSchemaDefinition singleton

! !

!ExChdGenericPackageAliasesFunction class methodsFor: 'platypus-generated-platypus-signature' stamp: ''!
translatedFromISO10303P11
	^ true

! !

!ExChdGenericPackageAliasesFunction class methodsFor: 'platypus-generated-platypus-signature' stamp: ''!
vwNamespaceName
	^ #Express2Cheddar

! !

!ExChdGenericPackageAliasesFunction methodsFor: 'platypus-generated-accessing' stamp: ''!
aliases
	^ aliases

! !

!ExChdGenericPackageAliasesFunction methodsFor: 'platypus-generated-accessing' stamp: ''!
aliases: aListOfExChdEntityInstance
	aliases := aListOfExChdEntityInstance
		ifNil: [ OrderedCollection new ]
		ifNotNil: [ aListOfExChdEntityInstance as: OrderedCollection ]

! !

!ExChdGenericPackageAliasesFunction methodsFor: 'platypus-generated-accessing' stamp: ''!
attrname
	^ attrname

! !

!ExChdGenericPackageAliasesFunction methodsFor: 'platypus-generated-accessing' stamp: ''!
attrname: aString
	attrname := aString

! !

!ExChdGenericPackageAliasesFunction methodsFor: 'platypus-generated-accessing' stamp: ''!
e
	^ e

! !

!ExChdGenericPackageAliasesFunction methodsFor: 'platypus-generated-accessing' stamp: ''!
e: aExChdGenericPackageInstanciation
	e := aExChdGenericPackageInstanciation

! !

!ExChdGenericPackageAliasesFunction methodsFor: 'platypus-generated-accessing' stamp: ''!
fromValues: values
	self e: (values at: 1)

! !

!ExChdGenericPackageAliasesFunction methodsFor: 'platypus-generated-invoking' stamp: ''!
invoke
	" ---------- locals assignments ----------"

	self aliases: Array new.	" ---------- statements ----------"
	PlatypusCoreRepeatStatement
		repeat: [ :no3019 | 
			PlatypusCoreAliasStatement
				alias: ((self e attributesUsingContext: self class context) pltAt: no3019)
				statementsBlock: [ :attr1425 | 
					PlatypusCoreAliasStatement
						alias: (attr1425 nameUsingContext: self class context)
						statementsBlock: [ :an2192 | 
							(an2192
								pltAt:
									(PltLENGTHFunction
										invokeFromValues:
											(OrderedCollection new
												add: an2192;
												yourself))) = '_'
								ifTrue: [ 
									self
										attrname:
											(an2192
												pltCopyFrom: 1
												to:
													((PltLENGTHFunction
														invokeFromValues:
															(OrderedCollection new
																add: an2192;
																yourself)) pltMinus: 1)) ]
								ifFalse: [ self attrname: an2192 ] ].
					self
						aliases:
							(self aliases
								pltPlus:
									(PlatypusComplexInstance
										fromRecords:
											(OrderedCollection new
												add:
														(PlatypusComplexInstance
																fromRecords:
																	(OrderedCollection new
																		add: ExChdAdaType new;
																		add: (attr1425 domainUsingContext: self class context);
																		yourself)) pltAsObject;
												add:
														(ExChdPackageAlias new
																packageAliasFromValues:
																		(OrderedCollection new
																				add: (self e nameUsingContext: self class context);
																				add: self attrname;
																				yourself);
																yourself);
												yourself)) pltAsObject) ] ]
		from:
			(PltLOINDEXFunction
				invokeFromValues:
					(OrderedCollection new
						add: (self e attributesUsingContext: self class context);
						yourself))
		to:
			(PltHIINDEXFunction
				invokeFromValues:
					(OrderedCollection new
						add: (self e attributesUsingContext: self class context);
						yourself)).
	^ self return: self aliases

! !

PlatypusCoreAlgorithmDeclaration subclass: #ExChdGenericPackageInstanciationAttributesAdsCodeFunction
	instanceVariableNames: 'e result aliases'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Express2Cheddar-PackageSchema'!

!ExChdGenericPackageInstanciationAttributesAdsCodeFunction commentStamp: 'platypus comment' prior: 0!
<ISO10303-11-EXPRESS>
FUNCTION generic_package_instanciation_attributes_ads_code ( e : generic_package_instanciation ) : STRING;
	LOCAL 
		result : STRING := '';
		aliases : LIST OF cheddar_defined_type := e.aliases;
	END_LOCAL;

	REPEAT no := LOINDEX ( aliases ) TO HIINDEX ( aliases );

		ALIAS attr FOR e.aliases [ no];
			result := result + attr.ads_code;
		END_ALIAS;
	END_REPEAT;
	RETURN ( result );
END_FUNCTION;
</ISO10303-11-EXPRESS>!

!ExChdGenericPackageInstanciationAttributesAdsCodeFunction class methodsFor: 'platypus-generated-platypus-signature' stamp: ''!
iso10303P11Translater
	^ 'Platypus (c) LISYC EA3883, Universite de Bretagne occidentale. Brest.'

! !

!ExChdGenericPackageInstanciationAttributesAdsCodeFunction class methodsFor: 'platypus-generated-meta-data-accessing' stamp: ''!
schemaDefinition
	^ ExChdPackageSchemaDefinition singleton

! !

!ExChdGenericPackageInstanciationAttributesAdsCodeFunction class methodsFor: 'platypus-generated-platypus-signature' stamp: ''!
translatedFromISO10303P11
	^ true

! !

!ExChdGenericPackageInstanciationAttributesAdsCodeFunction class methodsFor: 'platypus-generated-platypus-signature' stamp: ''!
vwNamespaceName
	^ #Express2Cheddar

! !

!ExChdGenericPackageInstanciationAttributesAdsCodeFunction methodsFor: 'platypus-generated-accessing' stamp: ''!
aliases
	^ aliases

! !

!ExChdGenericPackageInstanciationAttributesAdsCodeFunction methodsFor: 'platypus-generated-accessing' stamp: ''!
aliases: aListOfExChdCheddarDefinedType
	aliases := aListOfExChdCheddarDefinedType
		ifNil: [ OrderedCollection new ]
		ifNotNil: [ aListOfExChdCheddarDefinedType as: OrderedCollection ]

! !

!ExChdGenericPackageInstanciationAttributesAdsCodeFunction methodsFor: 'platypus-generated-accessing' stamp: ''!
e
	^ e

! !

!ExChdGenericPackageInstanciationAttributesAdsCodeFunction methodsFor: 'platypus-generated-accessing' stamp: ''!
e: aExChdGenericPackageInstanciation
	e := aExChdGenericPackageInstanciation

! !

!ExChdGenericPackageInstanciationAttributesAdsCodeFunction methodsFor: 'platypus-generated-accessing' stamp: ''!
fromValues: values
	self e: (values at: 1)

! !

!ExChdGenericPackageInstanciationAttributesAdsCodeFunction methodsFor: 'platypus-generated-invoking' stamp: ''!
invoke
	" ---------- locals assignments ----------"

	self result: ''.
	self aliases: (self e aliasesUsingContext: self class context).	" ---------- statements ----------"
	PlatypusCoreRepeatStatement
		repeat: [ :no1127 | 
			PlatypusCoreAliasStatement
				alias: ((self e aliasesUsingContext: self class context) pltAt: no1127)
				statementsBlock: [ :attr3626 | self result: (self result pltPlus: (attr3626 adsCodeUsingContext: self class context)) ] ]
		from:
			(PltLOINDEXFunction
				invokeFromValues:
					(OrderedCollection new
						add: self aliases;
						yourself))
		to:
			(PltHIINDEXFunction
				invokeFromValues:
					(OrderedCollection new
						add: self aliases;
						yourself)).
	^ self return: self result

! !

!ExChdGenericPackageInstanciationAttributesAdsCodeFunction methodsFor: 'platypus-generated-accessing' stamp: ''!
result
	^ result

! !

!ExChdGenericPackageInstanciationAttributesAdsCodeFunction methodsFor: 'platypus-generated-accessing' stamp: ''!
result: aString
	result := aString

! !

PlatypusCoreAlgorithmDeclaration subclass: #ExChdGetDeclaredEntityDomainsFunction
	instanceVariableNames: 'pkgs result'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Express2Cheddar-CheddarDtdSchema'!

!ExChdGetDeclaredEntityDomainsFunction commentStamp: 'platypus comment' prior: 0!
<ISO10303-11-EXPRESS>
FUNCTION get_declared_entity_domains ( pkgs : LIST OF package_dtd_element ) : LIST OF dtd_element;
	LOCAL 
		result : LIST OF dtd_element := [ ];
	END_LOCAL;

	REPEAT no := LOINDEX ( pkgs ) TO HIINDEX ( pkgs );
		result := result + pkgs [ no].subs;
	END_REPEAT;
	RETURN ( result );
END_FUNCTION;
</ISO10303-11-EXPRESS>!

!ExChdGetDeclaredEntityDomainsFunction class methodsFor: 'platypus-generated-platypus-signature' stamp: ''!
iso10303P11Translater
	^ 'Platypus (c) LISYC EA3883, Universite de Bretagne occidentale. Brest.'

! !

!ExChdGetDeclaredEntityDomainsFunction class methodsFor: 'platypus-generated-meta-data-accessing' stamp: ''!
schemaDefinition
	^ ExChdCheddarDtdSchemaDefinition singleton

! !

!ExChdGetDeclaredEntityDomainsFunction class methodsFor: 'platypus-generated-platypus-signature' stamp: ''!
translatedFromISO10303P11
	^ true

! !

!ExChdGetDeclaredEntityDomainsFunction class methodsFor: 'platypus-generated-platypus-signature' stamp: ''!
vwNamespaceName
	^ #Express2Cheddar

! !

!ExChdGetDeclaredEntityDomainsFunction methodsFor: 'platypus-generated-accessing' stamp: ''!
fromValues: values
	self pkgs: (values at: 1)

! !

!ExChdGetDeclaredEntityDomainsFunction methodsFor: 'platypus-generated-invoking' stamp: ''!
invoke
	" ---------- locals assignments ----------"

	self result: Array new.	" ---------- statements ----------"
	PlatypusCoreRepeatStatement
		repeat: [ :no1021 | self result: (self result pltPlus: ((self pkgs pltAt: no1021) subsUsingContext: self class context)) ]
		from:
			(PltLOINDEXFunction
				invokeFromValues:
					(OrderedCollection new
						add: self pkgs;
						yourself))
		to:
			(PltHIINDEXFunction
				invokeFromValues:
					(OrderedCollection new
						add: self pkgs;
						yourself)).
	^ self return: self result

! !

!ExChdGetDeclaredEntityDomainsFunction methodsFor: 'platypus-generated-accessing' stamp: ''!
pkgs
	^ pkgs

! !

!ExChdGetDeclaredEntityDomainsFunction methodsFor: 'platypus-generated-accessing' stamp: ''!
pkgs: aListOfExChdPackageDtdElement
	pkgs := aListOfExChdPackageDtdElement
		ifNil: [ OrderedCollection new ]
		ifNotNil: [ aListOfExChdPackageDtdElement as: OrderedCollection ]

! !

!ExChdGetDeclaredEntityDomainsFunction methodsFor: 'platypus-generated-accessing' stamp: ''!
result
	^ result

! !

!ExChdGetDeclaredEntityDomainsFunction methodsFor: 'platypus-generated-accessing' stamp: ''!
result: aListOfExChdDtdElement
	result := aListOfExChdDtdElement
		ifNil: [ OrderedCollection new ]
		ifNotNil: [ aListOfExChdDtdElement as: OrderedCollection ]

! !

PlatypusCoreAlgorithmDeclaration subclass: #ExChdGetReferencedEntityDomainsFunction
	instanceVariableNames: 'pkgs attributes domains names curr'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Express2Cheddar-CheddarDtdSchema'!

!ExChdGetReferencedEntityDomainsFunction commentStamp: 'platypus comment' prior: 0!
<ISO10303-11-EXPRESS>
FUNCTION get_referenced_entity_domains ( pkgs : LIST OF package_dtd_element ) : LIST OF entity_ref_dtd_element;
	LOCAL 
		attributes : LIST OF attribute_dtd_element := [ ];
		domains : LIST OF entity_ref_dtd_element := [ ];
		names : LIST OF STRING := [ ];
		curr : domain_dtd_element;
	END_LOCAL;

	REPEAT no := LOINDEX ( pkgs ) TO HIINDEX ( pkgs );
		attributes := attributes + compute_package_attribute_dtd_elements ( pkgs [ no] );
	END_REPEAT;

	REPEAT noi := LOINDEX ( attributes ) TO HIINDEX ( attributes );
		curr := ?;

		ALIAS dom FOR attributes [ noi].domain;
			IF ( 'CHEDDAR_DTD.ENTITY_REF_DTD_ELEMENT' IN TYPEOF ( dom ) ) THEN
				curr := dom;
			END_IF;
			IF ( ( 'CHEDDAR_DTD.COLLECTION_DTD_ELEMENT' IN TYPEOF ( dom ) ) AND ( 'CHEDDAR_DTD.ENTITY_REF_DTD_ELEMENT' IN TYPEOF ( dom.element_domain ) ) ) THEN
				curr := dom.element_domain;
			END_IF;
			IF EXISTS ( curr ) THEN
				IF NOT ( lowerize ( curr.domain.name ) IN names ) THEN
					domains := domains + curr;
					names := names + lowerize ( curr.domain.name );
				END_IF;
			END_IF;
		END_ALIAS;
	END_REPEAT;
	RETURN ( domains );
END_FUNCTION;
</ISO10303-11-EXPRESS>!

!ExChdGetReferencedEntityDomainsFunction class methodsFor: 'platypus-generated-platypus-signature' stamp: ''!
iso10303P11Translater
	^ 'Platypus (c) LISYC EA3883, Universite de Bretagne occidentale. Brest.'

! !

!ExChdGetReferencedEntityDomainsFunction class methodsFor: 'platypus-generated-meta-data-accessing' stamp: ''!
schemaDefinition
	^ ExChdCheddarDtdSchemaDefinition singleton

! !

!ExChdGetReferencedEntityDomainsFunction class methodsFor: 'platypus-generated-platypus-signature' stamp: ''!
translatedFromISO10303P11
	^ true

! !

!ExChdGetReferencedEntityDomainsFunction class methodsFor: 'platypus-generated-platypus-signature' stamp: ''!
vwNamespaceName
	^ #Express2Cheddar

! !

!ExChdGetReferencedEntityDomainsFunction methodsFor: 'platypus-generated-accessing' stamp: ''!
attributes
	^ attributes

! !

!ExChdGetReferencedEntityDomainsFunction methodsFor: 'platypus-generated-accessing' stamp: ''!
attributes: aListOfExChdAttributeDtdElement
	attributes := aListOfExChdAttributeDtdElement
		ifNil: [ OrderedCollection new ]
		ifNotNil: [ aListOfExChdAttributeDtdElement as: OrderedCollection ]

! !

!ExChdGetReferencedEntityDomainsFunction methodsFor: 'platypus-generated-accessing' stamp: ''!
curr
	^ curr

! !

!ExChdGetReferencedEntityDomainsFunction methodsFor: 'platypus-generated-accessing' stamp: ''!
curr: aExChdDomainDtdElement
	curr := aExChdDomainDtdElement

! !

!ExChdGetReferencedEntityDomainsFunction methodsFor: 'platypus-generated-accessing' stamp: ''!
domains
	^ domains

! !

!ExChdGetReferencedEntityDomainsFunction methodsFor: 'platypus-generated-accessing' stamp: ''!
domains: aListOfExChdEntityRefDtdElement
	domains := aListOfExChdEntityRefDtdElement
		ifNil: [ OrderedCollection new ]
		ifNotNil: [ aListOfExChdEntityRefDtdElement as: OrderedCollection ]

! !

!ExChdGetReferencedEntityDomainsFunction methodsFor: 'platypus-generated-accessing' stamp: ''!
fromValues: values
	self pkgs: (values at: 1)

! !

!ExChdGetReferencedEntityDomainsFunction methodsFor: 'platypus-generated-invoking' stamp: ''!
invoke
	" ---------- locals assignments ----------"

	self attributes: Array new.
	self domains: Array new.
	self names: Array new.	" ---------- statements ----------"
	PlatypusCoreRepeatStatement
		repeat: [ :no1130 | 
			self
				attributes:
					(self attributes
						pltPlus:
							(ExChdComputePackageAttributeDtdElementsFunction
								invokeFromValues:
									(OrderedCollection new
										add: (self pkgs pltAt: no1130);
										yourself))) ]
		from:
			(PltLOINDEXFunction
				invokeFromValues:
					(OrderedCollection new
						add: self pkgs;
						yourself))
		to:
			(PltHIINDEXFunction
				invokeFromValues:
					(OrderedCollection new
						add: self pkgs;
						yourself)).
	PlatypusCoreRepeatStatement
		repeat: [ :noi1194 | 
			self curr: nil.
			PlatypusCoreAliasStatement
				alias: ((self attributes pltAt: noi1194) domainUsingContext: self class context)
				statementsBlock: [ :dom2762 | 
					((PltTYPEOFFunction
						invokeFromValues:
							(OrderedCollection new
								add: dom2762;
								yourself)) includes: 'CHEDDAR_DTD.ENTITY_REF_DTD_ELEMENT')
						ifTrue: [ self curr: dom2762 ].
					(((PltTYPEOFFunction
						invokeFromValues:
							(OrderedCollection new
								add: dom2762;
								yourself)) includes: 'CHEDDAR_DTD.COLLECTION_DTD_ELEMENT')
						and: [ 
							(PltTYPEOFFunction
								invokeFromValues:
									(OrderedCollection new
										add: (dom2762 elementDomainUsingContext: self class context);
										yourself)) includes: 'CHEDDAR_DTD.ENTITY_REF_DTD_ELEMENT' ])
						ifTrue: [ self curr: (dom2762 elementDomainUsingContext: self class context) ].
					(PltEXISTSFunction
						invokeFromValues:
							(OrderedCollection new
								add: self curr;
								yourself))
						ifTrue: [ 
							(self names
								includes:
									(PTsLowerizeFunction
										invokeFromValues:
											(OrderedCollection new
												add: ((self curr domainUsingContext: self class context) nameUsingContext: self class context);
												yourself))) not
								ifTrue: [ 
									self domains: (self domains pltPlus: self curr).
									self
										names:
											(self names
												pltPlus:
													(PTsLowerizeFunction
														invokeFromValues:
															(OrderedCollection new
																add: ((self curr domainUsingContext: self class context) nameUsingContext: self class context);
																yourself))) ] ] ] ]
		from:
			(PltLOINDEXFunction
				invokeFromValues:
					(OrderedCollection new
						add: self attributes;
						yourself))
		to:
			(PltHIINDEXFunction
				invokeFromValues:
					(OrderedCollection new
						add: self attributes;
						yourself)).
	^ self return: self domains

! !

!ExChdGetReferencedEntityDomainsFunction methodsFor: 'platypus-generated-accessing' stamp: ''!
names
	^ names

! !

!ExChdGetReferencedEntityDomainsFunction methodsFor: 'platypus-generated-accessing' stamp: ''!
names: aListOfString
	names := aListOfString ifNil: [ OrderedCollection new ] ifNotNil: [ aListOfString as: OrderedCollection ]

! !

!ExChdGetReferencedEntityDomainsFunction methodsFor: 'platypus-generated-accessing' stamp: ''!
pkgs
	^ pkgs

! !

!ExChdGetReferencedEntityDomainsFunction methodsFor: 'platypus-generated-accessing' stamp: ''!
pkgs: aListOfExChdPackageDtdElement
	pkgs := aListOfExChdPackageDtdElement
		ifNil: [ OrderedCollection new ]
		ifNotNil: [ aListOfExChdPackageDtdElement as: OrderedCollection ]

! !

PlatypusCoreAlgorithmDeclaration subclass: #ExChdInScopeAttributeInitCodeFunction
	instanceVariableNames: 'a code'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Express2Cheddar-CheddarDomainsSchema'!

!ExChdInScopeAttributeInitCodeFunction commentStamp: 'platypus comment' prior: 0!
<ISO10303-11-EXPRESS>
FUNCTION in_scope_attribute_init_code ( a : in_scope_attribute ) : STRING;
	LOCAL 
		code : STRING := '';
	END_LOCAL;

	ALIAS domain FOR a.domain.handled;

		IF domain.refed_by_pointer THEN
			code := code + '\n\tif obj.' + a.name + ' /= null then\n' 
			+ '\t\tFree (obj.' + a.name + ' );\n' 
			+ '\tend if;\n' 
			+ '\tobj.' + a.name + ' := new ' + domain.name + ';\n' 
			+ '\tInitialize(obj.' + a.name + '.all);\n';
		END_IF;
	END_ALIAS;
	RETURN ( code );
END_FUNCTION;
</ISO10303-11-EXPRESS>!

!ExChdInScopeAttributeInitCodeFunction class methodsFor: 'platypus-generated-platypus-signature' stamp: ''!
iso10303P11Translater
	^ 'Platypus (c) LISYC EA3883, Universite de Bretagne occidentale. Brest.'

! !

!ExChdInScopeAttributeInitCodeFunction class methodsFor: 'platypus-generated-meta-data-accessing' stamp: ''!
schemaDefinition
	^ ExChdCheddarDomainsSchemaDefinition singleton

! !

!ExChdInScopeAttributeInitCodeFunction class methodsFor: 'platypus-generated-platypus-signature' stamp: ''!
translatedFromISO10303P11
	^ true

! !

!ExChdInScopeAttributeInitCodeFunction class methodsFor: 'platypus-generated-platypus-signature' stamp: ''!
vwNamespaceName
	^ #Express2Cheddar

! !

!ExChdInScopeAttributeInitCodeFunction methodsFor: 'platypus-generated-accessing' stamp: ''!
a
	^ a

! !

!ExChdInScopeAttributeInitCodeFunction methodsFor: 'platypus-generated-accessing' stamp: ''!
a: aExChdInScopeAttribute
	a := aExChdInScopeAttribute

! !

!ExChdInScopeAttributeInitCodeFunction methodsFor: 'platypus-generated-accessing' stamp: ''!
code
	^ code

! !

!ExChdInScopeAttributeInitCodeFunction methodsFor: 'platypus-generated-accessing' stamp: ''!
code: aString
	code := aString

! !

!ExChdInScopeAttributeInitCodeFunction methodsFor: 'platypus-generated-accessing' stamp: ''!
fromValues: values
	self a: (values at: 1)

! !

!ExChdInScopeAttributeInitCodeFunction methodsFor: 'platypus-generated-invoking' stamp: ''!
invoke
	" ---------- locals assignments ----------"

	self code: ''.	" ---------- statements ----------"
	PlatypusCoreAliasStatement
		alias: ((self a domainUsingContext: self class context) handledUsingContext: self class context)
		statementsBlock: [ :domain981 | 
			(domain981 refedByPointerUsingContext: self class context)
				ifTrue: [ 
					self
						code:
							(((((((((((((((self code pltPlus: '\n\tif obj.') pltPlus: (self a nameUsingContext: self class context))
								pltPlus: ' /= null then\n') pltPlus: '\t\tFree (obj.') pltPlus: (self a nameUsingContext: self class context))
								pltPlus: ' );\n') pltPlus: '\tend if;\n') pltPlus: '\tobj.')
								pltPlus: (self a nameUsingContext: self class context)) pltPlus: ' := new ')
								pltPlus: (domain981 nameUsingContext: self class context)) pltPlus: ';\n') pltPlus: '\tInitialize(obj.')
								pltPlus: (self a nameUsingContext: self class context)) pltPlus: '.all);\n') ] ].
	^ self return: self code

! !

PlatypusCoreAlgorithmDeclaration subclass: #ExChdIsGenericObjectFunction
	instanceVariableNames: 'e'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Express2Cheddar-RecordAndClassSchema'!

!ExChdIsGenericObjectFunction commentStamp: 'platypus comment' prior: 0!
<ISO10303-11-EXPRESS>
FUNCTION is_generic_object ( e : entity_instance ) : BOOLEAN;

	IF ( 'RECORD_AND_CLASS.ADA_CLASS' IN TYPEOF ( e ) ) THEN
		RETURN ( inherits_from_entity_named ( e, 'generic_object' ) );
	END_IF;
	RETURN ( false );
END_FUNCTION;
</ISO10303-11-EXPRESS>!

!ExChdIsGenericObjectFunction class methodsFor: 'platypus-generated-platypus-signature' stamp: ''!
iso10303P11Translater
	^ 'Platypus (c) LISYC EA3883, Universite de Bretagne occidentale. Brest.'

! !

!ExChdIsGenericObjectFunction class methodsFor: 'platypus-generated-meta-data-accessing' stamp: ''!
schemaDefinition
	^ ExChdRecordAndClassSchemaDefinition singleton

! !

!ExChdIsGenericObjectFunction class methodsFor: 'platypus-generated-platypus-signature' stamp: ''!
translatedFromISO10303P11
	^ true

! !

!ExChdIsGenericObjectFunction class methodsFor: 'platypus-generated-platypus-signature' stamp: ''!
vwNamespaceName
	^ #Express2Cheddar

! !

!ExChdIsGenericObjectFunction methodsFor: 'platypus-generated-accessing' stamp: ''!
e
	^ e

! !

!ExChdIsGenericObjectFunction methodsFor: 'platypus-generated-accessing' stamp: ''!
e: aExChdEntityInstance
	e := aExChdEntityInstance

! !

!ExChdIsGenericObjectFunction methodsFor: 'platypus-generated-accessing' stamp: ''!
fromValues: values
	self e: (values at: 1)

! !

!ExChdIsGenericObjectFunction methodsFor: 'platypus-generated-invoking' stamp: ''!
invoke
	" ---------- locals assignments ----------"

	" ---------- statements ----------"

	((PltTYPEOFFunction
		invokeFromValues:
			(OrderedCollection new
				add: self e;
				yourself)) includes: 'RECORD_AND_CLASS.ADA_CLASS')
		ifTrue: [ 
			^ self
				return:
					(PTsInheritsFromEntityNamedFunction
						invokeFromValues:
							(OrderedCollection new
								add: self e;
								add: 'generic_object';
								yourself)) ].
	^ self return: false

! !

PlatypusCoreAlgorithmDeclaration subclass: #ExChdIsNamedObjectFunction
	instanceVariableNames: 'e'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Express2Cheddar-RecordAndClassSchema'!

!ExChdIsNamedObjectFunction commentStamp: 'platypus comment' prior: 0!
<ISO10303-11-EXPRESS>
FUNCTION is_named_object ( e : entity_instance ) : BOOLEAN;

	IF ( 'RECORD_AND_CLASS.ADA_CLASS' IN TYPEOF ( e ) ) THEN
		RETURN ( inherits_from_entity_named ( e, 'named_object' ) );
	END_IF;
	RETURN ( false );
END_FUNCTION;
</ISO10303-11-EXPRESS>!

!ExChdIsNamedObjectFunction class methodsFor: 'platypus-generated-platypus-signature' stamp: ''!
iso10303P11Translater
	^ 'Platypus (c) LISYC EA3883, Universite de Bretagne occidentale. Brest.'

! !

!ExChdIsNamedObjectFunction class methodsFor: 'platypus-generated-meta-data-accessing' stamp: ''!
schemaDefinition
	^ ExChdRecordAndClassSchemaDefinition singleton

! !

!ExChdIsNamedObjectFunction class methodsFor: 'platypus-generated-platypus-signature' stamp: ''!
translatedFromISO10303P11
	^ true

! !

!ExChdIsNamedObjectFunction class methodsFor: 'platypus-generated-platypus-signature' stamp: ''!
vwNamespaceName
	^ #Express2Cheddar

! !

!ExChdIsNamedObjectFunction methodsFor: 'platypus-generated-accessing' stamp: ''!
e
	^ e

! !

!ExChdIsNamedObjectFunction methodsFor: 'platypus-generated-accessing' stamp: ''!
e: aExChdEntityInstance
	e := aExChdEntityInstance

! !

!ExChdIsNamedObjectFunction methodsFor: 'platypus-generated-accessing' stamp: ''!
fromValues: values
	self e: (values at: 1)

! !

!ExChdIsNamedObjectFunction methodsFor: 'platypus-generated-invoking' stamp: ''!
invoke
	" ---------- locals assignments ----------"

	" ---------- statements ----------"

	((PltTYPEOFFunction
		invokeFromValues:
			(OrderedCollection new
				add: self e;
				yourself)) includes: 'RECORD_AND_CLASS.ADA_CLASS')
		ifTrue: [ 
			^ self
				return:
					(PTsInheritsFromEntityNamedFunction
						invokeFromValues:
							(OrderedCollection new
								add: self e;
								add: 'named_object';
								yourself)) ].
	^ self return: false

! !

PlatypusCoreAlgorithmDeclaration subclass: #ExChdIsOfGeneratedConceptKindFunction
	instanceVariableNames: 'c'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Express2Cheddar-Express2cheddarFacadeSchema'!

!ExChdIsOfGeneratedConceptKindFunction commentStamp: 'platypus comment' prior: 0!
<ISO10303-11-EXPRESS>
FUNCTION is_of_generated_concept_kind ( c : dictionary_instance ) : BOOLEAN;
	RETURN ( ( 'CHEDDAR_DOMAINS.ADA_TYPE' IN TYPEOF ( c ) ) OR ( 'RECORD_AND_CLASS.ADA_ENTITY' IN TYPEOF ( c ) ) OR ( 'PACKAGE.PACKAGE_ALIAS' IN TYPEOF ( c ) ) OR ( 'RECORD_AND_CLASS.CHEDDAR_FUNCTION_PTR' IN TYPEOF ( c ) ) );
END_FUNCTION;
</ISO10303-11-EXPRESS>!

!ExChdIsOfGeneratedConceptKindFunction class methodsFor: 'platypus-generated-platypus-signature' stamp: ''!
iso10303P11Translater
	^ 'Platypus (c) LISYC EA3883, Universite de Bretagne occidentale. Brest.'

! !

!ExChdIsOfGeneratedConceptKindFunction class methodsFor: 'platypus-generated-meta-data-accessing' stamp: ''!
schemaDefinition
	^ ExChdExpress2cheddarFacadeSchemaDefinition singleton

! !

!ExChdIsOfGeneratedConceptKindFunction class methodsFor: 'platypus-generated-platypus-signature' stamp: ''!
translatedFromISO10303P11
	^ true

! !

!ExChdIsOfGeneratedConceptKindFunction class methodsFor: 'platypus-generated-platypus-signature' stamp: ''!
vwNamespaceName
	^ #Express2Cheddar

! !

!ExChdIsOfGeneratedConceptKindFunction methodsFor: 'platypus-generated-accessing' stamp: ''!
c
	^ c

! !

!ExChdIsOfGeneratedConceptKindFunction methodsFor: 'platypus-generated-accessing' stamp: ''!
c: aExChdDictionaryInstance
	c := aExChdDictionaryInstance

! !

!ExChdIsOfGeneratedConceptKindFunction methodsFor: 'platypus-generated-accessing' stamp: ''!
fromValues: values
	self c: (values at: 1)

! !

!ExChdIsOfGeneratedConceptKindFunction methodsFor: 'platypus-generated-invoking' stamp: ''!
invoke
	" ---------- locals assignments ----------"

	" ---------- statements ----------"

	^ self
		return:
			(((((PltTYPEOFFunction
				invokeFromValues:
					(OrderedCollection new
						add: self c;
						yourself)) includes: 'CHEDDAR_DOMAINS.ADA_TYPE')
				or: [ 
					(PltTYPEOFFunction
						invokeFromValues:
							(OrderedCollection new
								add: self c;
								yourself)) includes: 'RECORD_AND_CLASS.ADA_ENTITY' ])
				or: [ 
					(PltTYPEOFFunction
						invokeFromValues:
							(OrderedCollection new
								add: self c;
								yourself)) includes: 'PACKAGE.PACKAGE_ALIAS' ])
				or: [ 
					(PltTYPEOFFunction
						invokeFromValues:
							(OrderedCollection new
								add: self c;
								yourself)) includes: 'RECORD_AND_CLASS.CHEDDAR_FUNCTION_PTR' ])

! !

PlatypusCoreAlgorithmDeclaration subclass: #ExChdPackageAdaClassesFunction
	instanceVariableNames: 'pkg clsList'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Express2Cheddar-Express2cheddarFacadeSchema'!

!ExChdPackageAdaClassesFunction commentStamp: 'platypus comment' prior: 0!
<ISO10303-11-EXPRESS>
FUNCTION package_ada_classes ( pkg : ada_package ) : LIST OF ada_class;
	LOCAL 
		cls_list : LIST OF ada_class := [ ];
	END_LOCAL;

	ALIAS entities FOR pkg.entities;

		REPEAT noi := LOINDEX ( entities ) TO HIINDEX ( entities );
			IF ( 'RECORD_AND_CLASS.ADA_CLASS' IN TYPEOF ( entities [ noi] ) ) THEN
				cls_list := cls_list + entities [ noi];
			END_IF;
		END_REPEAT;
	END_ALIAS;
	RETURN ( cls_list );
END_FUNCTION;
</ISO10303-11-EXPRESS>!

!ExChdPackageAdaClassesFunction class methodsFor: 'platypus-generated-platypus-signature' stamp: ''!
iso10303P11Translater
	^ 'Platypus (c) LISYC EA3883, Universite de Bretagne occidentale. Brest.'

! !

!ExChdPackageAdaClassesFunction class methodsFor: 'platypus-generated-meta-data-accessing' stamp: ''!
schemaDefinition
	^ ExChdExpress2cheddarFacadeSchemaDefinition singleton

! !

!ExChdPackageAdaClassesFunction class methodsFor: 'platypus-generated-platypus-signature' stamp: ''!
translatedFromISO10303P11
	^ true

! !

!ExChdPackageAdaClassesFunction class methodsFor: 'platypus-generated-platypus-signature' stamp: ''!
vwNamespaceName
	^ #Express2Cheddar

! !

!ExChdPackageAdaClassesFunction methodsFor: 'platypus-generated-accessing' stamp: ''!
clsList
	^ clsList

! !

!ExChdPackageAdaClassesFunction methodsFor: 'platypus-generated-accessing' stamp: ''!
clsList: aListOfExChdAdaClass
	clsList := aListOfExChdAdaClass
		ifNil: [ OrderedCollection new ]
		ifNotNil: [ aListOfExChdAdaClass as: OrderedCollection ]

! !

!ExChdPackageAdaClassesFunction methodsFor: 'platypus-generated-accessing' stamp: ''!
fromValues: values
	self pkg: (values at: 1)

! !

!ExChdPackageAdaClassesFunction methodsFor: 'platypus-generated-invoking' stamp: ''!
invoke
	" ---------- locals assignments ----------"

	self clsList: Array new.	" ---------- statements ----------"
	PlatypusCoreAliasStatement
		alias: (self pkg entitiesUsingContext: self class context)
		statementsBlock: [ :entities3644 | 
			PlatypusCoreRepeatStatement
				repeat: [ :noi1401 | 
					((PltTYPEOFFunction
						invokeFromValues:
							(OrderedCollection new
								add: (entities3644 pltAt: noi1401);
								yourself)) includes: 'RECORD_AND_CLASS.ADA_CLASS')
						ifTrue: [ self clsList: (self clsList pltPlus: (entities3644 pltAt: noi1401)) ] ]
				from:
					(PltLOINDEXFunction
						invokeFromValues:
							(OrderedCollection new
								add: entities3644;
								yourself))
				to:
					(PltHIINDEXFunction
						invokeFromValues:
							(OrderedCollection new
								add: entities3644;
								yourself)) ].
	^ self return: self clsList

! !

!ExChdPackageAdaClassesFunction methodsFor: 'platypus-generated-accessing' stamp: ''!
pkg
	^ pkg

! !

!ExChdPackageAdaClassesFunction methodsFor: 'platypus-generated-accessing' stamp: ''!
pkg: aExChdAdaPackage
	pkg := aExChdAdaPackage

! !

PlatypusCoreAlgorithmDeclaration subclass: #ExChdPackageDiscriminatedTypesFunction
	instanceVariableNames: 'pkg dtList'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Express2Cheddar-Express2cheddarFacadeSchema'!

!ExChdPackageDiscriminatedTypesFunction commentStamp: 'platypus comment' prior: 0!
<ISO10303-11-EXPRESS>
FUNCTION package_discriminated_types ( pkg : ada_package ) : LIST OF discriminated_type;
	LOCAL 
		dt_list : LIST OF discriminated_type := [ ];
	END_LOCAL;

	ALIAS entities FOR pkg.entities;

		REPEAT noi := LOINDEX ( entities ) TO HIINDEX ( entities );
			IF ( 'DISCRIMINATED_TYPE.DISCRIMINATED_TYPE' IN TYPEOF ( entities [ noi] ) ) THEN
				dt_list := dt_list + entities [ noi];
			END_IF;
		END_REPEAT;
	END_ALIAS;
	RETURN ( dt_list );
END_FUNCTION;
</ISO10303-11-EXPRESS>!

!ExChdPackageDiscriminatedTypesFunction class methodsFor: 'platypus-generated-platypus-signature' stamp: ''!
iso10303P11Translater
	^ 'Platypus (c) LISYC EA3883, Universite de Bretagne occidentale. Brest.'

! !

!ExChdPackageDiscriminatedTypesFunction class methodsFor: 'platypus-generated-meta-data-accessing' stamp: ''!
schemaDefinition
	^ ExChdExpress2cheddarFacadeSchemaDefinition singleton

! !

!ExChdPackageDiscriminatedTypesFunction class methodsFor: 'platypus-generated-platypus-signature' stamp: ''!
translatedFromISO10303P11
	^ true

! !

!ExChdPackageDiscriminatedTypesFunction class methodsFor: 'platypus-generated-platypus-signature' stamp: ''!
vwNamespaceName
	^ #Express2Cheddar

! !

!ExChdPackageDiscriminatedTypesFunction methodsFor: 'platypus-generated-accessing' stamp: ''!
dtList
	^ dtList

! !

!ExChdPackageDiscriminatedTypesFunction methodsFor: 'platypus-generated-accessing' stamp: ''!
dtList: aListOfExChdDiscriminatedType
	dtList := aListOfExChdDiscriminatedType
		ifNil: [ OrderedCollection new ]
		ifNotNil: [ aListOfExChdDiscriminatedType as: OrderedCollection ]

! !

!ExChdPackageDiscriminatedTypesFunction methodsFor: 'platypus-generated-accessing' stamp: ''!
fromValues: values
	self pkg: (values at: 1)

! !

!ExChdPackageDiscriminatedTypesFunction methodsFor: 'platypus-generated-invoking' stamp: ''!
invoke
	" ---------- locals assignments ----------"

	self dtList: Array new.	" ---------- statements ----------"
	PlatypusCoreAliasStatement
		alias: (self pkg entitiesUsingContext: self class context)
		statementsBlock: [ :entities664 | 
			PlatypusCoreRepeatStatement
				repeat: [ :noi2356 | 
					((PltTYPEOFFunction
						invokeFromValues:
							(OrderedCollection new
								add: (entities664 pltAt: noi2356);
								yourself)) includes: 'DISCRIMINATED_TYPE.DISCRIMINATED_TYPE')
						ifTrue: [ self dtList: (self dtList pltPlus: (entities664 pltAt: noi2356)) ] ]
				from:
					(PltLOINDEXFunction
						invokeFromValues:
							(OrderedCollection new
								add: entities664;
								yourself))
				to:
					(PltHIINDEXFunction
						invokeFromValues:
							(OrderedCollection new
								add: entities664;
								yourself)) ].
	^ self return: self dtList

! !

!ExChdPackageDiscriminatedTypesFunction methodsFor: 'platypus-generated-accessing' stamp: ''!
pkg
	^ pkg

! !

!ExChdPackageDiscriminatedTypesFunction methodsFor: 'platypus-generated-accessing' stamp: ''!
pkg: aExChdAdaPackage
	pkg := aExChdAdaPackage

! !

PlatypusCoreAlgorithmDeclaration subclass: #ExChdPackageRecordsFunction
	instanceVariableNames: 'pkg recList'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Express2Cheddar-Express2cheddarFacadeSchema'!

!ExChdPackageRecordsFunction commentStamp: 'platypus comment' prior: 0!
<ISO10303-11-EXPRESS>
FUNCTION package_records ( pkg : ada_package ) : LIST OF record;
	LOCAL 
		rec_list : LIST OF record := [ ];
	END_LOCAL;

	ALIAS entities FOR pkg.entities;

		REPEAT noi := LOINDEX ( entities ) TO HIINDEX ( entities );
			IF ( 'RECORD_AND_CLASS.RECORD' IN TYPEOF ( entities [ noi] ) ) THEN
				rec_list := rec_list + entities [ noi];
			END_IF;
		END_REPEAT;
	END_ALIAS;
	RETURN ( rec_list );
END_FUNCTION;
</ISO10303-11-EXPRESS>!

!ExChdPackageRecordsFunction class methodsFor: 'platypus-generated-platypus-signature' stamp: ''!
iso10303P11Translater
	^ 'Platypus (c) LISYC EA3883, Universite de Bretagne occidentale. Brest.'

! !

!ExChdPackageRecordsFunction class methodsFor: 'platypus-generated-meta-data-accessing' stamp: ''!
schemaDefinition
	^ ExChdExpress2cheddarFacadeSchemaDefinition singleton

! !

!ExChdPackageRecordsFunction class methodsFor: 'platypus-generated-platypus-signature' stamp: ''!
translatedFromISO10303P11
	^ true

! !

!ExChdPackageRecordsFunction class methodsFor: 'platypus-generated-platypus-signature' stamp: ''!
vwNamespaceName
	^ #Express2Cheddar

! !

!ExChdPackageRecordsFunction methodsFor: 'platypus-generated-accessing' stamp: ''!
fromValues: values
	self pkg: (values at: 1)

! !

!ExChdPackageRecordsFunction methodsFor: 'platypus-generated-invoking' stamp: ''!
invoke
	" ---------- locals assignments ----------"

	self recList: Array new.	" ---------- statements ----------"
	PlatypusCoreAliasStatement
		alias: (self pkg entitiesUsingContext: self class context)
		statementsBlock: [ :entities3901 | 
			PlatypusCoreRepeatStatement
				repeat: [ :noi1494 | 
					((PltTYPEOFFunction
						invokeFromValues:
							(OrderedCollection new
								add: (entities3901 pltAt: noi1494);
								yourself)) includes: 'RECORD_AND_CLASS.RECORD')
						ifTrue: [ self recList: (self recList pltPlus: (entities3901 pltAt: noi1494)) ] ]
				from:
					(PltLOINDEXFunction
						invokeFromValues:
							(OrderedCollection new
								add: entities3901;
								yourself))
				to:
					(PltHIINDEXFunction
						invokeFromValues:
							(OrderedCollection new
								add: entities3901;
								yourself)) ].
	^ self return: self recList

! !

!ExChdPackageRecordsFunction methodsFor: 'platypus-generated-accessing' stamp: ''!
pkg
	^ pkg

! !

!ExChdPackageRecordsFunction methodsFor: 'platypus-generated-accessing' stamp: ''!
pkg: aExChdAdaPackage
	pkg := aExChdAdaPackage

! !

!ExChdPackageRecordsFunction methodsFor: 'platypus-generated-accessing' stamp: ''!
recList
	^ recList

! !

!ExChdPackageRecordsFunction methodsFor: 'platypus-generated-accessing' stamp: ''!
recList: aListOfExChdRecord
	recList := aListOfExChdRecord ifNil: [ OrderedCollection new ] ifNotNil: [ aListOfExChdRecord as: OrderedCollection ]

! !

PlatypusCoreAlgorithmDeclaration subclass: #ExChdPrepareRootAdaClassesProcedure
	instanceVariableNames: 'clslist'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Express2Cheddar-Express2cheddarFacadeSchema'!

!ExChdPrepareRootAdaClassesProcedure commentStamp: 'platypus comment' prior: 0!
<ISO10303-11-EXPRESS>
PROCEDURE prepare_root_ada_classes;
	LOCAL 
		clslist : LIST OF ada_class := all_ada_classes ( );
	END_LOCAL;

	REPEAT no := LOINDEX ( clslist ) TO HIINDEX ( clslist );

		ALIAS curr FOR clslist [ no];
			IF SIZEOF ( curr.supertypes ) = 0 THEN
				IF NOT has_attribute_named ( curr, xml_id_name ) THEN
					add_xml_id_to_ada_class ( curr );
				END_IF;
			END_IF;
		END_ALIAS;
	END_REPEAT;
END_PROCEDURE;
</ISO10303-11-EXPRESS>!

!ExChdPrepareRootAdaClassesProcedure class methodsFor: 'platypus-generated-platypus-signature' stamp: ''!
iso10303P11Translater
	^ 'Platypus (c) LISYC EA3883, Universite de Bretagne occidentale. Brest.'

! !

!ExChdPrepareRootAdaClassesProcedure class methodsFor: 'platypus-generated-meta-data-accessing' stamp: ''!
schemaDefinition
	^ ExChdExpress2cheddarFacadeSchemaDefinition singleton

! !

!ExChdPrepareRootAdaClassesProcedure class methodsFor: 'platypus-generated-platypus-signature' stamp: ''!
translatedFromISO10303P11
	^ true

! !

!ExChdPrepareRootAdaClassesProcedure class methodsFor: 'platypus-generated-platypus-signature' stamp: ''!
vwNamespaceName
	^ #Express2Cheddar

! !

!ExChdPrepareRootAdaClassesProcedure methodsFor: 'platypus-generated-accessing' stamp: ''!
clslist
	^ clslist

! !

!ExChdPrepareRootAdaClassesProcedure methodsFor: 'platypus-generated-accessing' stamp: ''!
clslist: aListOfExChdAdaClass
	clslist := aListOfExChdAdaClass
		ifNil: [ OrderedCollection new ]
		ifNotNil: [ aListOfExChdAdaClass as: OrderedCollection ]

! !

!ExChdPrepareRootAdaClassesProcedure methodsFor: 'platypus-generated-invoking' stamp: ''!
invoke
	" ---------- locals assignments ----------"

	self clslist: ExChdAllAdaClassesFunction invoke.	" ---------- statements ----------"
	PlatypusCoreRepeatStatement
		repeat: [ :no1180 | 
			PlatypusCoreAliasStatement
				alias: (self clslist pltAt: no1180)
				statementsBlock: [ :curr3003 | 
					(PltSIZEOFFunction
						invokeFromValues:
							(OrderedCollection new
								add: (curr3003 supertypesUsingContext: self class context);
								yourself)) = 0
						ifTrue: [ 
							(PTsHasAttributeNamedFunction
								invokeFromValues:
									(OrderedCollection new
										add: curr3003;
										add: 'cheddar_private_id';
										yourself)) not
								ifTrue: [ 
									ExChdAddXmlIdToAdaClassProcedure
										invokeFromValues:
											(OrderedCollection new
												add: curr3003;
												yourself) ] ] ] ]
		from:
			(PltLOINDEXFunction
				invokeFromValues:
					(OrderedCollection new
						add: self clslist;
						yourself))
		to:
			(PltHIINDEXFunction
				invokeFromValues:
					(OrderedCollection new
						add: self clslist;
						yourself))

! !

PlatypusCoreAlgorithmDeclaration subclass: #ExChdRangeTypeAdsCodeFunction
	instanceVariableNames: 'rt r'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Express2Cheddar-CheddarDomainsSchema'!

!ExChdRangeTypeAdsCodeFunction commentStamp: 'platypus comment' prior: 0!
<ISO10303-11-EXPRESS>
FUNCTION range_type_ads_code ( rt : range_type ) : STRING;
	LOCAL 
		r : STRING := 'type ' + rt.ada_ident + ' is Range ' + rt.lower + ' .. ' + rt.upper + ';\n';
	END_LOCAL;

	IF EXISTS ( rt.lower_constant ) THEN
		r := r + rt.lower_constant + ' : constant ' + rt.ada_ident + ' := ' + rt.ada_ident + '''First;\n';
	END_IF;

	IF EXISTS ( rt.upper_constant ) THEN
		r := r + rt.upper_constant + ' : constant ' + rt.ada_ident + ' := ' + rt.ada_ident + '''Last;\n';
	END_IF;
	RETURN ( r );
END_FUNCTION;
</ISO10303-11-EXPRESS>!

!ExChdRangeTypeAdsCodeFunction class methodsFor: 'platypus-generated-platypus-signature' stamp: ''!
iso10303P11Translater
	^ 'Platypus (c) LISYC EA3883, Universite de Bretagne occidentale. Brest.'

! !

!ExChdRangeTypeAdsCodeFunction class methodsFor: 'platypus-generated-meta-data-accessing' stamp: ''!
schemaDefinition
	^ ExChdCheddarDomainsSchemaDefinition singleton

! !

!ExChdRangeTypeAdsCodeFunction class methodsFor: 'platypus-generated-platypus-signature' stamp: ''!
translatedFromISO10303P11
	^ true

! !

!ExChdRangeTypeAdsCodeFunction class methodsFor: 'platypus-generated-platypus-signature' stamp: ''!
vwNamespaceName
	^ #Express2Cheddar

! !

!ExChdRangeTypeAdsCodeFunction methodsFor: 'platypus-generated-accessing' stamp: ''!
fromValues: values
	self rt: (values at: 1)

! !

!ExChdRangeTypeAdsCodeFunction methodsFor: 'platypus-generated-invoking' stamp: ''!
invoke
	" ---------- locals assignments ----------"

	self
		r:
			(((((('type ' pltPlus: (self rt adaIdentUsingContext: self class context)) pltPlus: ' is Range ')
				pltPlus: (self rt lowerUsingContext: self class context)) pltPlus: ' .. ')
				pltPlus: (self rt upperUsingContext: self class context)) pltPlus: ';\n').	" ---------- statements ----------"
	(PltEXISTSFunction
		invokeFromValues:
			(OrderedCollection new
				add: (self rt lowerConstantUsingContext: self class context);
				yourself))
		ifTrue: [ 
			self
				r:
					((((((self r pltPlus: (self rt lowerConstantUsingContext: self class context)) pltPlus: ' : constant ')
						pltPlus: (self rt adaIdentUsingContext: self class context)) pltPlus: ' := ')
						pltPlus: (self rt adaIdentUsingContext: self class context)) pltPlus: '''First;\n') ].
	(PltEXISTSFunction
		invokeFromValues:
			(OrderedCollection new
				add: (self rt upperConstantUsingContext: self class context);
				yourself))
		ifTrue: [ 
			self
				r:
					((((((self r pltPlus: (self rt upperConstantUsingContext: self class context)) pltPlus: ' : constant ')
						pltPlus: (self rt adaIdentUsingContext: self class context)) pltPlus: ' := ')
						pltPlus: (self rt adaIdentUsingContext: self class context)) pltPlus: '''Last;\n') ].
	^ self return: self r

! !

!ExChdRangeTypeAdsCodeFunction methodsFor: 'platypus-generated-accessing' stamp: ''!
r
	^ r

! !

!ExChdRangeTypeAdsCodeFunction methodsFor: 'platypus-generated-accessing' stamp: ''!
r: aString
	r := aString

! !

!ExChdRangeTypeAdsCodeFunction methodsFor: 'platypus-generated-accessing' stamp: ''!
rt
	^ rt

! !

!ExChdRangeTypeAdsCodeFunction methodsFor: 'platypus-generated-accessing' stamp: ''!
rt: aExChdRangeType
	rt := aExChdRangeType

! !

PlatypusCoreAlgorithmDeclaration subclass: #ExChdRecordAdbCodeFunction
	instanceVariableNames: 'rec code'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Express2Cheddar-RecordAndClassSchema'!

!ExChdRecordAdbCodeFunction commentStamp: 'platypus comment' prior: 0!
<ISO10303-11-EXPRESS>
FUNCTION record_adb_code ( rec : record ) : STRING;
	LOCAL 
		code : STRING;
	END_LOCAL;
	code := '\n' 
	+ '-- --------= ' + rec.name + ' =--------\n' 
	+ record_initialize_code ( rec ) + '\n' 
	+ record_put_code ( rec ) + '\n' 
	+ record_xml_writer_code ( rec ) + '\n' 
	+ record_copy_code ( rec ) + '\n';
	RETURN ( code );
END_FUNCTION;
</ISO10303-11-EXPRESS>!

!ExChdRecordAdbCodeFunction class methodsFor: 'platypus-generated-platypus-signature' stamp: ''!
iso10303P11Translater
	^ 'Platypus (c) LISYC EA3883, Universite de Bretagne occidentale. Brest.'

! !

!ExChdRecordAdbCodeFunction class methodsFor: 'platypus-generated-meta-data-accessing' stamp: ''!
schemaDefinition
	^ ExChdRecordAndClassSchemaDefinition singleton

! !

!ExChdRecordAdbCodeFunction class methodsFor: 'platypus-generated-platypus-signature' stamp: ''!
translatedFromISO10303P11
	^ true

! !

!ExChdRecordAdbCodeFunction class methodsFor: 'platypus-generated-platypus-signature' stamp: ''!
vwNamespaceName
	^ #Express2Cheddar

! !

!ExChdRecordAdbCodeFunction methodsFor: 'platypus-generated-accessing' stamp: ''!
code
	^ code

! !

!ExChdRecordAdbCodeFunction methodsFor: 'platypus-generated-accessing' stamp: ''!
code: aString
	code := aString

! !

!ExChdRecordAdbCodeFunction methodsFor: 'platypus-generated-accessing' stamp: ''!
fromValues: values
	self rec: (values at: 1)

! !

!ExChdRecordAdbCodeFunction methodsFor: 'platypus-generated-invoking' stamp: ''!
invoke
	" ---------- locals assignments ----------"

	" ---------- statements ----------"

	self
		code:
			((((((((((('\n' pltPlus: '-- --------= ') pltPlus: (self rec nameUsingContext: self class context))
				pltPlus: ' =--------\n')
				pltPlus:
					(ExChdRecordInitializeCodeFunction
						invokeFromValues:
							(OrderedCollection new
								add: self rec;
								yourself))) pltPlus: '\n')
				pltPlus:
					(ExChdRecordPutCodeFunction
						invokeFromValues:
							(OrderedCollection new
								add: self rec;
								yourself))) pltPlus: '\n')
				pltPlus:
					(ExChdRecordXmlWriterCodeFunction
						invokeFromValues:
							(OrderedCollection new
								add: self rec;
								yourself))) pltPlus: '\n')
				pltPlus:
					(ExChdRecordCopyCodeFunction
						invokeFromValues:
							(OrderedCollection new
								add: self rec;
								yourself))) pltPlus: '\n').
	^ self return: self code

! !

!ExChdRecordAdbCodeFunction methodsFor: 'platypus-generated-accessing' stamp: ''!
rec
	^ rec

! !

!ExChdRecordAdbCodeFunction methodsFor: 'platypus-generated-accessing' stamp: ''!
rec: aExChdRecord
	rec := aExChdRecord

! !

PlatypusCoreAlgorithmDeclaration subclass: #ExChdRecordAdsCodeFunction
	instanceVariableNames: 'rec result domain'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Express2Cheddar-RecordAndClassSchema'!

!ExChdRecordAdsCodeFunction commentStamp: 'platypus comment' prior: 0!
<ISO10303-11-EXPRESS>
FUNCTION record_ads_code ( rec : record ) : STRING;
	LOCAL 
		result : STRING;
		domain : entity_instance;
	END_LOCAL;
	result := '\n' 
	+ '-- --------= ' + rec.name + ' =--------\n \n' 
	+ 'type ' + rec.name + ' is\nrecord\n';

	REPEAT no := LOINDEX ( rec.attributes ) TO HIINDEX ( rec.attributes );
		result := result + ' ' + rec.attributes [ no].name + ' : ';
		domain := basic_ada_domain ( rec.attributes [ no].domain );

		IF domain.handled.refed_by_pointer THEN
			result := result + domain.handled.ptr_type + ';\n';
		ELSE
			result := result + domain.ada_ref_ident + ';\n';
		END_IF;
	END_REPEAT;
	result := result + 'end record;\n\n' 

	+ 'type ' + rec.ptr_type + ' is access all ' + rec.name + ';\n\n' 

	+ 'procedure Initialize(obj : out ' + rec.name + ');\n' 
	+ 'procedure Put(obj : in ' + rec.name + ');\n' 
	+ 'procedure Put(obj : in ' + rec.ptr_type + ');\n' 
	+ 'function Copy(obj : in ' + rec.ptr_type + ') return ' + rec.ptr_type + ';\n' 
	+ 'function Copy(obj : in ' + rec.name + ') return ' + rec.ptr_type + ';\n' 
	+ 'procedure Build_Attributes_XML_String(obj : in ' + rec.name + '; result : in out Unbounded_String);\n' 
	+ 'function XML_String(obj : in ' + rec.name + ') return Unbounded_String;\n' 
	+ 'function XML_String(obj : in ' + rec.ptr_type + ') return Unbounded_String;\n' 
	+ 'function XML_Ref_String(obj : in ' + rec.name + ') return Unbounded_String;\n' 
	+ 'procedure Free  is new Unchecked_Deallocation (' + rec.name + ', ' + rec.ptr_type + ');\n';
	RETURN ( result );
END_FUNCTION;
</ISO10303-11-EXPRESS>!

!ExChdRecordAdsCodeFunction class methodsFor: 'platypus-generated-platypus-signature' stamp: ''!
iso10303P11Translater
	^ 'Platypus (c) LISYC EA3883, Universite de Bretagne occidentale. Brest.'

! !

!ExChdRecordAdsCodeFunction class methodsFor: 'platypus-generated-meta-data-accessing' stamp: ''!
schemaDefinition
	^ ExChdRecordAndClassSchemaDefinition singleton

! !

!ExChdRecordAdsCodeFunction class methodsFor: 'platypus-generated-platypus-signature' stamp: ''!
translatedFromISO10303P11
	^ true

! !

!ExChdRecordAdsCodeFunction class methodsFor: 'platypus-generated-platypus-signature' stamp: ''!
vwNamespaceName
	^ #Express2Cheddar

! !

!ExChdRecordAdsCodeFunction methodsFor: 'platypus-generated-accessing' stamp: ''!
domain
	^ domain

! !

!ExChdRecordAdsCodeFunction methodsFor: 'platypus-generated-accessing' stamp: ''!
domain: aExChdEntityInstance
	domain := aExChdEntityInstance

! !

!ExChdRecordAdsCodeFunction methodsFor: 'platypus-generated-accessing' stamp: ''!
fromValues: values
	self rec: (values at: 1)

! !

!ExChdRecordAdsCodeFunction methodsFor: 'platypus-generated-invoking' stamp: ''!
invoke
	" ---------- locals assignments ----------"

	" ---------- statements ----------"

	self
		result:
			(((((('\n' pltPlus: '-- --------= ') pltPlus: (self rec nameUsingContext: self class context))
				pltPlus: ' =--------\n \n') pltPlus: 'type ') pltPlus: (self rec nameUsingContext: self class context))
				pltPlus: ' is\nrecord\n').
	PlatypusCoreRepeatStatement
		repeat: [ :no1130 | 
			self
				result:
					(((self result pltPlus: ' ')
						pltPlus:
							(((self rec attributesUsingContext: self class context) pltAt: no1130) nameUsingContext: self class context))
						pltPlus: ' : ').
			self
				domain:
					(ExChdBasicAdaDomainFunction
						invokeFromValues:
							(OrderedCollection new
								add:
										(((self rec attributesUsingContext: self class context) pltAt: no1130) domainUsingContext: self class context);
								yourself)).
			((self domain handledUsingContext: self class context) refedByPointerUsingContext: self class context)
				ifTrue: [ 
					self
						result:
							((self result pltPlus: ((self domain handledUsingContext: self class context) ptrTypeUsingContext: self class context))
								pltPlus: ';\n') ]
				ifFalse: [ self result: ((self result pltPlus: (self domain adaRefIdentUsingContext: self class context)) pltPlus: ';\n') ] ]
		from:
			(PltLOINDEXFunction
				invokeFromValues:
					(OrderedCollection new
						add: (self rec attributesUsingContext: self class context);
						yourself))
		to:
			(PltHIINDEXFunction
				invokeFromValues:
					(OrderedCollection new
						add: (self rec attributesUsingContext: self class context);
						yourself)).
	self
		result:
			((((((((((((((((((((((((((((((((((((((((((self result pltPlus: 'end record;\n\n') pltPlus: 'type ')
				pltPlus: (self rec ptrTypeUsingContext: self class context)) pltPlus: ' is access all ')
				pltPlus: (self rec nameUsingContext: self class context)) pltPlus: ';\n\n')
				pltPlus: 'procedure Initialize(obj : out ') pltPlus: (self rec nameUsingContext: self class context))
				pltPlus: ');\n') pltPlus: 'procedure Put(obj : in ') pltPlus: (self rec nameUsingContext: self class context))
				pltPlus: ');\n') pltPlus: 'procedure Put(obj : in ') pltPlus: (self rec ptrTypeUsingContext: self class context))
				pltPlus: ');\n') pltPlus: 'function Copy(obj : in ') pltPlus: (self rec ptrTypeUsingContext: self class context))
				pltPlus: ') return ') pltPlus: (self rec ptrTypeUsingContext: self class context)) pltPlus: ';\n')
				pltPlus: 'function Copy(obj : in ') pltPlus: (self rec nameUsingContext: self class context)) pltPlus: ') return ')
				pltPlus: (self rec ptrTypeUsingContext: self class context)) pltPlus: ';\n')
				pltPlus: 'procedure Build_Attributes_XML_String(obj : in ') pltPlus: (self rec nameUsingContext: self class context))
				pltPlus: '; result : in out Unbounded_String);\n') pltPlus: 'function XML_String(obj : in ')
				pltPlus: (self rec nameUsingContext: self class context)) pltPlus: ') return Unbounded_String;\n')
				pltPlus: 'function XML_String(obj : in ') pltPlus: (self rec ptrTypeUsingContext: self class context))
				pltPlus: ') return Unbounded_String;\n') pltPlus: 'function XML_Ref_String(obj : in ')
				pltPlus: (self rec nameUsingContext: self class context)) pltPlus: ') return Unbounded_String;\n')
				pltPlus: 'procedure Free  is new Unchecked_Deallocation (') pltPlus: (self rec nameUsingContext: self class context))
				pltPlus: ', ') pltPlus: (self rec ptrTypeUsingContext: self class context)) pltPlus: ');\n').
	^ self return: self result

! !

!ExChdRecordAdsCodeFunction methodsFor: 'platypus-generated-accessing' stamp: ''!
rec
	^ rec

! !

!ExChdRecordAdsCodeFunction methodsFor: 'platypus-generated-accessing' stamp: ''!
rec: aExChdRecord
	rec := aExChdRecord

! !

!ExChdRecordAdsCodeFunction methodsFor: 'platypus-generated-accessing' stamp: ''!
result
	^ result

! !

!ExChdRecordAdsCodeFunction methodsFor: 'platypus-generated-accessing' stamp: ''!
result: aString
	result := aString

! !

PlatypusCoreAlgorithmDeclaration subclass: #ExChdRecordCopyCodeFunction
	instanceVariableNames: 'cip code v'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Express2Cheddar-RecordAndClassSchema'!

!ExChdRecordCopyCodeFunction commentStamp: 'platypus comment' prior: 0!
<ISO10303-11-EXPRESS>
FUNCTION record_copy_code ( cip : record ) : STRING;
	LOCAL 
		code : STRING;
		v : STRING := 'New_' + cip.name;
	END_LOCAL;
	code := 'function Copy ( obj : in ' + cip.name + ' ) return ' + cip.ptr_type + ' is\n' 
	+ '\t' + v + ' : ' + cip.ptr_type + ';\n' 
	+ 'begin\n' 
	+ '\t' + v + ' := new ' + cip.name + '''(obj);\n';
	code := code + '\treturn (' + v + ');\n';
	code := code + 'end Copy;\n\n' 

	+ 'function Copy ( obj : in ' + cip.ptr_type + ' ) return ' + cip.ptr_type + ' is\n' 
	+ 'begin\n' 
	+ '\treturn copy(obj.all);\n' 
	+ 'end Copy;\n';
	RETURN ( code );
END_FUNCTION;
</ISO10303-11-EXPRESS>!

!ExChdRecordCopyCodeFunction class methodsFor: 'platypus-generated-platypus-signature' stamp: ''!
iso10303P11Translater
	^ 'Platypus (c) LISYC EA3883, Universite de Bretagne occidentale. Brest.'

! !

!ExChdRecordCopyCodeFunction class methodsFor: 'platypus-generated-meta-data-accessing' stamp: ''!
schemaDefinition
	^ ExChdRecordAndClassSchemaDefinition singleton

! !

!ExChdRecordCopyCodeFunction class methodsFor: 'platypus-generated-platypus-signature' stamp: ''!
translatedFromISO10303P11
	^ true

! !

!ExChdRecordCopyCodeFunction class methodsFor: 'platypus-generated-platypus-signature' stamp: ''!
vwNamespaceName
	^ #Express2Cheddar

! !

!ExChdRecordCopyCodeFunction methodsFor: 'platypus-generated-accessing' stamp: ''!
cip
	^ cip

! !

!ExChdRecordCopyCodeFunction methodsFor: 'platypus-generated-accessing' stamp: ''!
cip: aExChdRecord
	cip := aExChdRecord

! !

!ExChdRecordCopyCodeFunction methodsFor: 'platypus-generated-accessing' stamp: ''!
code
	^ code

! !

!ExChdRecordCopyCodeFunction methodsFor: 'platypus-generated-accessing' stamp: ''!
code: aString
	code := aString

! !

!ExChdRecordCopyCodeFunction methodsFor: 'platypus-generated-accessing' stamp: ''!
fromValues: values
	self cip: (values at: 1)

! !

!ExChdRecordCopyCodeFunction methodsFor: 'platypus-generated-invoking' stamp: ''!
invoke
	" ---------- locals assignments ----------"

	self v: ('New_' pltPlus: (self cip nameUsingContext: self class context)).	" ---------- statements ----------"
	self
		code:
			((((((((((((((('function Copy ( obj : in ' pltPlus: (self cip nameUsingContext: self class context))
				pltPlus: ' ) return ') pltPlus: (self cip ptrTypeUsingContext: self class context)) pltPlus: ' is\n') pltPlus: '\t')
				pltPlus: self v) pltPlus: ' : ') pltPlus: (self cip ptrTypeUsingContext: self class context)) pltPlus: ';\n')
				pltPlus: 'begin\n') pltPlus: '\t') pltPlus: self v) pltPlus: ' := new ')
				pltPlus: (self cip nameUsingContext: self class context)) pltPlus: '''(obj);\n').
	self code: (((self code pltPlus: '\treturn (') pltPlus: self v) pltPlus: ');\n').
	self
		code:
			(((((((((self code pltPlus: 'end Copy;\n\n') pltPlus: 'function Copy ( obj : in ')
				pltPlus: (self cip ptrTypeUsingContext: self class context)) pltPlus: ' ) return ')
				pltPlus: (self cip ptrTypeUsingContext: self class context)) pltPlus: ' is\n') pltPlus: 'begin\n')
				pltPlus: '\treturn copy(obj.all);\n') pltPlus: 'end Copy;\n').
	^ self return: self code

! !

!ExChdRecordCopyCodeFunction methodsFor: 'platypus-generated-accessing' stamp: ''!
v
	^ v

! !

!ExChdRecordCopyCodeFunction methodsFor: 'platypus-generated-accessing' stamp: ''!
v: aString1
	v := aString1

! !

PlatypusCoreAlgorithmDeclaration subclass: #ExChdRecordInitializeCodeFunction
	instanceVariableNames: 'rec code innerCode attrs init'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Express2Cheddar-RecordAndClassSchema'!

!ExChdRecordInitializeCodeFunction commentStamp: 'platypus comment' prior: 0!
<ISO10303-11-EXPRESS>
FUNCTION record_initialize_code ( rec : record ) : STRING;
	LOCAL 
		code : STRING;
		innerCode : STRING := '';
		attrs : LIST OF attribute;
		init : STRING;
	END_LOCAL;
	code := '\nprocedure Initialize(obj : out ' + rec.name + ') is \nbegin\n';

	REPEAT no := LOINDEX ( rec.explicit_attributes ) TO HIINDEX ( rec.explicit_attributes );

		ALIAS attr FOR rec.explicit_attributes [ no];
			init := explicit_attribute_initialize ( attr );
			IF ( EXISTS ( init ) AND ( init > '' ) ) THEN
				innerCode := innerCode + '\t' + init + '\n';
			END_IF;
		END_ALIAS;
	END_REPEAT;

	IF innerCode = '' THEN
		innerCode := '\tnull;\n';
	END_IF;
	code := code + innerCode + 'end Initialize;\n';
	RETURN ( code );
END_FUNCTION;
</ISO10303-11-EXPRESS>!

!ExChdRecordInitializeCodeFunction class methodsFor: 'platypus-generated-platypus-signature' stamp: ''!
iso10303P11Translater
	^ 'Platypus (c) LISYC EA3883, Universite de Bretagne occidentale. Brest.'

! !

!ExChdRecordInitializeCodeFunction class methodsFor: 'platypus-generated-meta-data-accessing' stamp: ''!
schemaDefinition
	^ ExChdRecordAndClassSchemaDefinition singleton

! !

!ExChdRecordInitializeCodeFunction class methodsFor: 'platypus-generated-platypus-signature' stamp: ''!
translatedFromISO10303P11
	^ true

! !

!ExChdRecordInitializeCodeFunction class methodsFor: 'platypus-generated-platypus-signature' stamp: ''!
vwNamespaceName
	^ #Express2Cheddar

! !

!ExChdRecordInitializeCodeFunction methodsFor: 'platypus-generated-accessing' stamp: ''!
attrs
	^ attrs

! !

!ExChdRecordInitializeCodeFunction methodsFor: 'platypus-generated-accessing' stamp: ''!
attrs: aListOfExChdAttribute
	attrs := aListOfExChdAttribute
		ifNil: [ OrderedCollection new ]
		ifNotNil: [ aListOfExChdAttribute as: OrderedCollection ]

! !

!ExChdRecordInitializeCodeFunction methodsFor: 'platypus-generated-accessing' stamp: ''!
code
	^ code

! !

!ExChdRecordInitializeCodeFunction methodsFor: 'platypus-generated-accessing' stamp: ''!
code: aString
	code := aString

! !

!ExChdRecordInitializeCodeFunction methodsFor: 'platypus-generated-accessing' stamp: ''!
fromValues: values
	self rec: (values at: 1)

! !

!ExChdRecordInitializeCodeFunction methodsFor: 'platypus-generated-accessing' stamp: ''!
init
	^ init

! !

!ExChdRecordInitializeCodeFunction methodsFor: 'platypus-generated-accessing' stamp: ''!
init: aString2
	init := aString2

! !

!ExChdRecordInitializeCodeFunction methodsFor: 'platypus-generated-accessing' stamp: ''!
innerCode
	^ innerCode

! !

!ExChdRecordInitializeCodeFunction methodsFor: 'platypus-generated-accessing' stamp: ''!
innerCode: aString1
	innerCode := aString1

! !

!ExChdRecordInitializeCodeFunction methodsFor: 'platypus-generated-invoking' stamp: ''!
invoke
	" ---------- locals assignments ----------"

	self innerCode: ''.	" ---------- statements ----------"
	self
		code:
			(('\nprocedure Initialize(obj : out ' pltPlus: (self rec nameUsingContext: self class context))
				pltPlus: ') is \nbegin\n').
	PlatypusCoreRepeatStatement
		repeat: [ :no1254 | 
			PlatypusCoreAliasStatement
				alias: ((self rec explicitAttributesUsingContext: self class context) pltAt: no1254)
				statementsBlock: [ :attr3831 | 
					self
						init:
							(ExChdExplicitAttributeInitializeFunction
								invokeFromValues:
									(OrderedCollection new
										add: attr3831;
										yourself)).
					((PltEXISTSFunction
						invokeFromValues:
							(OrderedCollection new
								add: self init;
								yourself)) and: [ self init > '' ])
						ifTrue: [ self innerCode: (((self innerCode pltPlus: '\t') pltPlus: self init) pltPlus: '\n') ] ] ]
		from:
			(PltLOINDEXFunction
				invokeFromValues:
					(OrderedCollection new
						add: (self rec explicitAttributesUsingContext: self class context);
						yourself))
		to:
			(PltHIINDEXFunction
				invokeFromValues:
					(OrderedCollection new
						add: (self rec explicitAttributesUsingContext: self class context);
						yourself)).
	self innerCode = ''
		ifTrue: [ self innerCode: '\tnull;\n' ].
	self code: ((self code pltPlus: self innerCode) pltPlus: 'end Initialize;\n').
	^ self return: self code

! !

!ExChdRecordInitializeCodeFunction methodsFor: 'platypus-generated-accessing' stamp: ''!
rec
	^ rec

! !

!ExChdRecordInitializeCodeFunction methodsFor: 'platypus-generated-accessing' stamp: ''!
rec: aExChdRecord
	rec := aExChdRecord

! !

PlatypusCoreAlgorithmDeclaration subclass: #ExChdRecordPutCodeFunction
	instanceVariableNames: 'rec code acode'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Express2Cheddar-RecordAndClassSchema'!

!ExChdRecordPutCodeFunction commentStamp: 'platypus comment' prior: 0!
<ISO10303-11-EXPRESS>
FUNCTION record_put_code ( rec : record ) : STRING;
	LOCAL 
		code : STRING;
		acode : STRING;
	END_LOCAL;
	code := 'procedure Put(obj : in ' + rec.name + ') is \nbegin\n';

	REPEAT no := LOINDEX ( rec.explicit_attributes ) TO HIINDEX ( rec.explicit_attributes );

		ALIAS attr FOR rec.explicit_attributes [ no];
			acode := explicit_attribute_put ( attr );
			IF ( acode > '' ) THEN
				code := code + '\t' + acode + '\n';
			END_IF;
		END_ALIAS;
	END_REPEAT;
	code := code + 'end Put;\n \n' 
	+ 'procedure Put(obj : in ' + rec.ptr_type + ') is\n' 
	+ 'begin\n' 
	+ '\tPut(Obj.All);\n' 
	+ 'end Put;\n';
	RETURN ( code );
END_FUNCTION;
</ISO10303-11-EXPRESS>!

!ExChdRecordPutCodeFunction class methodsFor: 'platypus-generated-platypus-signature' stamp: ''!
iso10303P11Translater
	^ 'Platypus (c) LISYC EA3883, Universite de Bretagne occidentale. Brest.'

! !

!ExChdRecordPutCodeFunction class methodsFor: 'platypus-generated-meta-data-accessing' stamp: ''!
schemaDefinition
	^ ExChdRecordAndClassSchemaDefinition singleton

! !

!ExChdRecordPutCodeFunction class methodsFor: 'platypus-generated-platypus-signature' stamp: ''!
translatedFromISO10303P11
	^ true

! !

!ExChdRecordPutCodeFunction class methodsFor: 'platypus-generated-platypus-signature' stamp: ''!
vwNamespaceName
	^ #Express2Cheddar

! !

!ExChdRecordPutCodeFunction methodsFor: 'platypus-generated-accessing' stamp: ''!
acode
	^ acode

! !

!ExChdRecordPutCodeFunction methodsFor: 'platypus-generated-accessing' stamp: ''!
acode: aString1
	acode := aString1

! !

!ExChdRecordPutCodeFunction methodsFor: 'platypus-generated-accessing' stamp: ''!
code
	^ code

! !

!ExChdRecordPutCodeFunction methodsFor: 'platypus-generated-accessing' stamp: ''!
code: aString
	code := aString

! !

!ExChdRecordPutCodeFunction methodsFor: 'platypus-generated-accessing' stamp: ''!
fromValues: values
	self rec: (values at: 1)

! !

!ExChdRecordPutCodeFunction methodsFor: 'platypus-generated-invoking' stamp: ''!
invoke
	" ---------- locals assignments ----------"

	" ---------- statements ----------"

	self
		code: (('procedure Put(obj : in ' pltPlus: (self rec nameUsingContext: self class context)) pltPlus: ') is \nbegin\n').
	PlatypusCoreRepeatStatement
		repeat: [ :no115 | 
			PlatypusCoreAliasStatement
				alias: ((self rec explicitAttributesUsingContext: self class context) pltAt: no115)
				statementsBlock: [ :attr2692 | 
					self
						acode:
							(ExChdExplicitAttributePutFunction
								invokeFromValues:
									(OrderedCollection new
										add: attr2692;
										yourself)).
					self acode > ''
						ifTrue: [ self code: (((self code pltPlus: '\t') pltPlus: self acode) pltPlus: '\n') ] ] ]
		from:
			(PltLOINDEXFunction
				invokeFromValues:
					(OrderedCollection new
						add: (self rec explicitAttributesUsingContext: self class context);
						yourself))
		to:
			(PltHIINDEXFunction
				invokeFromValues:
					(OrderedCollection new
						add: (self rec explicitAttributesUsingContext: self class context);
						yourself)).
	self
		code:
			(((((((self code pltPlus: 'end Put;\n \n') pltPlus: 'procedure Put(obj : in ')
				pltPlus: (self rec ptrTypeUsingContext: self class context)) pltPlus: ') is\n') pltPlus: 'begin\n')
				pltPlus: '\tPut(Obj.All);\n') pltPlus: 'end Put;\n').
	^ self return: self code

! !

!ExChdRecordPutCodeFunction methodsFor: 'platypus-generated-accessing' stamp: ''!
rec
	^ rec

! !

!ExChdRecordPutCodeFunction methodsFor: 'platypus-generated-accessing' stamp: ''!
rec: aExChdRecord
	rec := aExChdRecord

! !

PlatypusCoreAlgorithmDeclaration subclass: #ExChdRecordXmlIoRecordCodeFunction
	instanceVariableNames: 'rec'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Express2Cheddar-RecordAndClassSchema'!

!ExChdRecordXmlIoRecordCodeFunction commentStamp: 'platypus comment' prior: 0!
<ISO10303-11-EXPRESS>
FUNCTION record_xml_io_record_code ( rec : record ) : STRING;
	RETURN ( '\ntype ' + rec.name + '_io is record' + ada_entity_attributes_xml_io_record_code ( rec ) + '\nend record;\n' );
END_FUNCTION;
</ISO10303-11-EXPRESS>!

!ExChdRecordXmlIoRecordCodeFunction class methodsFor: 'platypus-generated-platypus-signature' stamp: ''!
iso10303P11Translater
	^ 'Platypus (c) LISYC EA3883, Universite de Bretagne occidentale. Brest.'

! !

!ExChdRecordXmlIoRecordCodeFunction class methodsFor: 'platypus-generated-meta-data-accessing' stamp: ''!
schemaDefinition
	^ ExChdRecordAndClassSchemaDefinition singleton

! !

!ExChdRecordXmlIoRecordCodeFunction class methodsFor: 'platypus-generated-platypus-signature' stamp: ''!
translatedFromISO10303P11
	^ true

! !

!ExChdRecordXmlIoRecordCodeFunction class methodsFor: 'platypus-generated-platypus-signature' stamp: ''!
vwNamespaceName
	^ #Express2Cheddar

! !

!ExChdRecordXmlIoRecordCodeFunction methodsFor: 'platypus-generated-accessing' stamp: ''!
fromValues: values
	self rec: (values at: 1)

! !

!ExChdRecordXmlIoRecordCodeFunction methodsFor: 'platypus-generated-invoking' stamp: ''!
invoke
	" ---------- locals assignments ----------"

	" ---------- statements ----------"

	^ self
		return:
			(((('\ntype ' pltPlus: (self rec nameUsingContext: self class context)) pltPlus: '_io is record')
				pltPlus:
					(ExChdAdaEntityAttributesXmlIoRecordCodeFunction
						invokeFromValues:
							(OrderedCollection new
								add: self rec;
								yourself))) pltPlus: '\nend record;\n')

! !

!ExChdRecordXmlIoRecordCodeFunction methodsFor: 'platypus-generated-accessing' stamp: ''!
rec
	^ rec

! !

!ExChdRecordXmlIoRecordCodeFunction methodsFor: 'platypus-generated-accessing' stamp: ''!
rec: aExChdRecord
	rec := aExChdRecord

! !

PlatypusCoreAlgorithmDeclaration subclass: #ExChdRecordXmlWriterCodeFunction
	instanceVariableNames: 'cip code acode'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Express2Cheddar-RecordAndClassSchema'!

!ExChdRecordXmlWriterCodeFunction commentStamp: 'platypus comment' prior: 0!
<ISO10303-11-EXPRESS>
FUNCTION record_xml_writer_code ( cip : record ) : STRING;
	LOCAL 
		code : STRING;
		acode : STRING;
	END_LOCAL;
	code := '\nprocedure Build_Attributes_XML_String(obj : in ' + cip.name + '; result : in out Unbounded_String) is \nbegin\n';

	REPEAT no := LOINDEX ( cip.explicit_attributes ) TO HIINDEX ( cip.explicit_attributes );

		ALIAS attr FOR cip.explicit_attributes [ no];
			acode := explicit_attribute_xml_writer_code ( 'obj', attr );
			IF ( acode > '' ) THEN
				code := code + acode + '\n';
			END_IF;
		END_ALIAS;
	END_REPEAT;
	code := code + 'end Build_Attributes_XML_String;\n\n' 

	+ 'function XML_String(obj : in ' + cip.name + ') return Unbounded_String is\n' 
	+ '\tresult : Unbounded_String;\n' 
	+ 'begin\n' 
	+ '\tresult := to_unbounded_string("<' + cip.html_tag + '>");\n' 
	+ '\tBuild_Attributes_XML_String(obj, result);\n' 
	+ '\tresult := result & to_unbounded_string("</' + cip.html_tag + '>");\n' 
	+ '\treturn (result);\n' 
	+ 'end XML_String;\n\n' 

	+ 'function XML_String(obj : in ' + cip.ptr_type + ') return Unbounded_String is\n' 
	+ 'begin\n' 
	+ '	if obj /= null then\n' 
	+ '		return XML_String(obj.all);\n' 
	+ '	else\n' 
	+ '		return Empty_String;\n' 
	+ '	end if;\n' 
	+ 'end XML_String;\n\n' 

	+ 'function XML_Ref_String(obj : in ' + cip.name + ') return Unbounded_String is\n' 
	+ '\tresult : Unbounded_String;\n' 
	+ 'begin\n' 
	+ '	raise xml_ref_string_error;\n' 
	+ '	return to_unbounded_string("");\n' 
	+ 'end XML_Ref_String;\n';
	RETURN ( code );
END_FUNCTION;
</ISO10303-11-EXPRESS>!

!ExChdRecordXmlWriterCodeFunction class methodsFor: 'platypus-generated-platypus-signature' stamp: ''!
iso10303P11Translater
	^ 'Platypus (c) LISYC EA3883, Universite de Bretagne occidentale. Brest.'

! !

!ExChdRecordXmlWriterCodeFunction class methodsFor: 'platypus-generated-meta-data-accessing' stamp: ''!
schemaDefinition
	^ ExChdRecordAndClassSchemaDefinition singleton

! !

!ExChdRecordXmlWriterCodeFunction class methodsFor: 'platypus-generated-platypus-signature' stamp: ''!
translatedFromISO10303P11
	^ true

! !

!ExChdRecordXmlWriterCodeFunction class methodsFor: 'platypus-generated-platypus-signature' stamp: ''!
vwNamespaceName
	^ #Express2Cheddar

! !

!ExChdRecordXmlWriterCodeFunction methodsFor: 'platypus-generated-accessing' stamp: ''!
acode
	^ acode

! !

!ExChdRecordXmlWriterCodeFunction methodsFor: 'platypus-generated-accessing' stamp: ''!
acode: aString1
	acode := aString1

! !

!ExChdRecordXmlWriterCodeFunction methodsFor: 'platypus-generated-accessing' stamp: ''!
cip
	^ cip

! !

!ExChdRecordXmlWriterCodeFunction methodsFor: 'platypus-generated-accessing' stamp: ''!
cip: aExChdRecord
	cip := aExChdRecord

! !

!ExChdRecordXmlWriterCodeFunction methodsFor: 'platypus-generated-accessing' stamp: ''!
code
	^ code

! !

!ExChdRecordXmlWriterCodeFunction methodsFor: 'platypus-generated-accessing' stamp: ''!
code: aString
	code := aString

! !

!ExChdRecordXmlWriterCodeFunction methodsFor: 'platypus-generated-accessing' stamp: ''!
fromValues: values
	self cip: (values at: 1)

! !

!ExChdRecordXmlWriterCodeFunction methodsFor: 'platypus-generated-invoking' stamp: ''!
invoke
	" ---------- locals assignments ----------"

	" ---------- statements ----------"

	self
		code:
			(('\nprocedure Build_Attributes_XML_String(obj : in ' pltPlus: (self cip nameUsingContext: self class context))
				pltPlus: '; result : in out Unbounded_String) is \nbegin\n').
	PlatypusCoreRepeatStatement
		repeat: [ :no1203 | 
			PlatypusCoreAliasStatement
				alias: ((self cip explicitAttributesUsingContext: self class context) pltAt: no1203)
				statementsBlock: [ :attr3780 | 
					self
						acode:
							(ExChdExplicitAttributeXmlWriterCodeFunction
								invokeFromValues:
									(OrderedCollection new
										add: 'obj';
										add: attr3780;
										yourself)).
					self acode > ''
						ifTrue: [ self code: ((self code pltPlus: self acode) pltPlus: '\n') ] ] ]
		from:
			(PltLOINDEXFunction
				invokeFromValues:
					(OrderedCollection new
						add: (self cip explicitAttributesUsingContext: self class context);
						yourself))
		to:
			(PltHIINDEXFunction
				invokeFromValues:
					(OrderedCollection new
						add: (self cip explicitAttributesUsingContext: self class context);
						yourself)).
	self
		code:
			(((((((((((((((((((((((((((((((((self code pltPlus: 'end Build_Attributes_XML_String;\n\n')
				pltPlus: 'function XML_String(obj : in ') pltPlus: (self cip nameUsingContext: self class context))
				pltPlus: ') return Unbounded_String is\n') pltPlus: '\tresult : Unbounded_String;\n') pltPlus: 'begin\n')
				pltPlus: '\tresult := to_unbounded_string("<') pltPlus: (self cip htmlTagUsingContext: self class context))
				pltPlus: '>");\n') pltPlus: '\tBuild_Attributes_XML_String(obj, result);\n')
				pltPlus: '\tresult := result & to_unbounded_string("</') pltPlus: (self cip htmlTagUsingContext: self class context))
				pltPlus: '>");\n') pltPlus: '\treturn (result);\n') pltPlus: 'end XML_String;\n\n')
				pltPlus: 'function XML_String(obj : in ') pltPlus: (self cip ptrTypeUsingContext: self class context))
				pltPlus: ') return Unbounded_String is\n') pltPlus: 'begin\n') pltPlus: '	if obj /= null then\n')
				pltPlus: '		return XML_String(obj.all);\n') pltPlus: '	else\n') pltPlus: '		return Empty_String;\n')
				pltPlus: '	end if;\n') pltPlus: 'end XML_String;\n\n') pltPlus: 'function XML_Ref_String(obj : in ')
				pltPlus: (self cip nameUsingContext: self class context)) pltPlus: ') return Unbounded_String is\n')
				pltPlus: '\tresult : Unbounded_String;\n') pltPlus: 'begin\n') pltPlus: '	raise xml_ref_string_error;\n')
				pltPlus: '	return to_unbounded_string("");\n') pltPlus: 'end XML_Ref_String;\n').
	^ self return: self code

! !

PlatypusCoreAlgorithmDeclaration subclass: #ExChdRootDtdsFunction
	instanceVariableNames: 'xmlPkgs rootNames result'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Express2Cheddar-CheddarDtdSchema'!

!ExChdRootDtdsFunction commentStamp: 'platypus comment' prior: 0!
<ISO10303-11-EXPRESS>
FUNCTION root_dtds : LIST OF root_dtd_element;
	LOCAL 
		xml_pkgs : LIST OF ada_package := xml_packages ( );
		root_names : LIST OF STRING := [ ];
		result : LIST OF root_dtd_element := [ ];
	END_LOCAL;

	REPEAT no := LOINDEX ( xml_pkgs ) TO HIINDEX ( xml_pkgs );

		ALIAS curr_pkg FOR xml_pkgs [ no];
			root_names := root_names + curr_pkg.xml_root_tags;
		END_ALIAS;
	END_REPEAT;
	root_names := SetToList ( ListToSet ( root_names ) );

	REPEAT no := LOINDEX ( root_names ) TO HIINDEX ( root_names );
		result := result + composite_dtd_element ( ) || root_dtd_element ( ) || dtd_element ( ?, root_names [ no] );
	END_REPEAT;
	RETURN ( result );
END_FUNCTION;
</ISO10303-11-EXPRESS>!

!ExChdRootDtdsFunction class methodsFor: 'platypus-generated-platypus-signature' stamp: ''!
iso10303P11Translater
	^ 'Platypus (c) LISYC EA3883, Universite de Bretagne occidentale. Brest.'

! !

!ExChdRootDtdsFunction class methodsFor: 'platypus-generated-meta-data-accessing' stamp: ''!
schemaDefinition
	^ ExChdCheddarDtdSchemaDefinition singleton

! !

!ExChdRootDtdsFunction class methodsFor: 'platypus-generated-platypus-signature' stamp: ''!
translatedFromISO10303P11
	^ true

! !

!ExChdRootDtdsFunction class methodsFor: 'platypus-generated-platypus-signature' stamp: ''!
vwNamespaceName
	^ #Express2Cheddar

! !

!ExChdRootDtdsFunction methodsFor: 'platypus-generated-invoking' stamp: ''!
invoke
	" ---------- locals assignments ----------"

	self xmlPkgs: ExChdXmlPackagesFunction invoke.
	self rootNames: Array new.
	self result: Array new.	" ---------- statements ----------"
	PlatypusCoreRepeatStatement
		repeat: [ :no2412 | 
			PlatypusCoreAliasStatement
				alias: (self xmlPkgs pltAt: no2412)
				statementsBlock: [ :currPkg146 | self rootNames: (self rootNames pltPlus: (currPkg146 xmlRootTagsUsingContext: self class context)) ] ]
		from:
			(PltLOINDEXFunction
				invokeFromValues:
					(OrderedCollection new
						add: self xmlPkgs;
						yourself))
		to:
			(PltHIINDEXFunction
				invokeFromValues:
					(OrderedCollection new
						add: self xmlPkgs;
						yourself)).
	self
		rootNames:
			(PTsSetToListFunction
				invokeFromValues:
					(OrderedCollection new
						add:
								(PTsListToSetFunction
										invokeFromValues:
											(OrderedCollection new
												add: self rootNames;
												yourself));
						yourself)).
	PlatypusCoreRepeatStatement
		repeat: [ :no2151 | 
			self
				result:
					(self result
						pltPlus:
							(PlatypusComplexInstance
								fromRecords:
									(OrderedCollection new
										add:
												(PlatypusComplexInstance
														fromRecords:
															(OrderedCollection new
																add: ExChdCompositeDtdElement new;
																add: ExChdRootDtdElement new;
																yourself)) pltAsObject;
										add:
												(ExChdDtdElement new
														dtdElementFromValues:
																(OrderedCollection new
																		add: nil;
																		add: (self rootNames pltAt: no2151);
																		yourself);
														yourself);
										yourself)) pltAsObject) ]
		from:
			(PltLOINDEXFunction
				invokeFromValues:
					(OrderedCollection new
						add: self rootNames;
						yourself))
		to:
			(PltHIINDEXFunction
				invokeFromValues:
					(OrderedCollection new
						add: self rootNames;
						yourself)).
	^ self return: self result

! !

!ExChdRootDtdsFunction methodsFor: 'platypus-generated-accessing' stamp: ''!
result
	^ result

! !

!ExChdRootDtdsFunction methodsFor: 'platypus-generated-accessing' stamp: ''!
result: aListOfExChdRootDtdElement
	result := aListOfExChdRootDtdElement
		ifNil: [ OrderedCollection new ]
		ifNotNil: [ aListOfExChdRootDtdElement as: OrderedCollection ]

! !

!ExChdRootDtdsFunction methodsFor: 'platypus-generated-accessing' stamp: ''!
rootNames
	^ rootNames

! !

!ExChdRootDtdsFunction methodsFor: 'platypus-generated-accessing' stamp: ''!
rootNames: aListOfString
	rootNames := aListOfString ifNil: [ OrderedCollection new ] ifNotNil: [ aListOfString as: OrderedCollection ]

! !

!ExChdRootDtdsFunction methodsFor: 'platypus-generated-accessing' stamp: ''!
xmlPkgs
	^ xmlPkgs

! !

!ExChdRootDtdsFunction methodsFor: 'platypus-generated-accessing' stamp: ''!
xmlPkgs: aListOfExChdAdaPackage
	xmlPkgs := aListOfExChdAdaPackage
		ifNil: [ OrderedCollection new ]
		ifNotNil: [ aListOfExChdAdaPackage as: OrderedCollection ]

! !

PlatypusCoreAlgorithmDeclaration subclass: #ExChdXmlArchitectureIoAdbPackageCodeFunction
	instanceVariableNames: 'code allcls allrecs allents strtab alldts'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Express2Cheddar-XmlIoSchema'!

!ExChdXmlArchitectureIoAdbPackageCodeFunction commentStamp: 'platypus comment' prior: 0!
<ISO10303-11-EXPRESS>
FUNCTION xml_architecture_io_adb_package_code : STRING;
	LOCAL 
		code : STRING := '';
		allcls : LIST OF ada_class := all_ada_classes ( );
		allrecs : LIST OF record := all_ada_records ( );
		allents : LIST OF ada_entity := allcls + allrecs;
		strtab : LIST OF STRING := [ ];
		alldts : LIST OF discriminated_type := all_ada_discriminated_types ( );
	END_LOCAL;
	code := source_licence + '\n';
	code := code + 'package body xml_architecture_io is\n\n';
	code := code + '\n';
	code := code + '\nprocedure Start_Element(' + '\n	Handler: in out Xml_Generic_Parser;' + '\n	ref : in out unbounded_string;' + '\n	id : in out unbounded_string;' + '\n	Namespace_Uri : Unicode.CES.Byte_Sequence := "";' + '\n	Local_Name : Unicode.CES.Byte_Sequence := "";' + '\n	Qname : Unicode.CES.Byte_Sequence := "";' + '\n	Atts : Sax.Attributes.Attributes''Class) is' + '\nbegin' + '\n	if Get_Length (Atts) > 0 then' + '\n		if (To_String (To_Lower (Qname)) = "' + Lowerize ( allents [ LOINDEX ( allents ) ].name ) + '")';

	REPEAT no := LOINDEX ( allents ) + 1 TO HIINDEX ( allents );
		code := code + '\n\t\t\t OR (To_String (To_Lower (Qname)) = "' + Lowerize ( allents [ no].name ) + '")';
	END_REPEAT;
	code := code + ' then' + '\n			for J in 0 .. Get_Length (Atts) - 1 loop' + '\n				if To_String (To_Lower (Get_Qname (Atts, J))) = "id" then' + '\n					id := To_Unbounded_String (Get_Value (Atts, J));' + '\n				end if;' + '\n				if To_String (To_Lower (Get_Qname (Atts, J))) = "ref" then' + '\n					ref := To_Unbounded_String (Get_Value (Atts, J));' + '\n				end if;' + '\n			end loop;' + '\n		end if;' + '\n	end if;' + '\nend Start_Element;\n\n';

	REPEAT no := LOINDEX ( alldts ) TO HIINDEX ( alldts );
		code := code + discriminated_type_xml_io_record_initialize_code ( alldts [ no] );
		code := code + discriminated_type_xml_start_element_code ( alldts [ no] );
		code := code + discriminated_type_xml_end_element_code ( alldts [ no] );
	END_REPEAT;

	REPEAT no := LOINDEX ( allrecs ) TO HIINDEX ( allrecs );
		code := code + ada_entity_xml_io_record_initialize_code ( allrecs [ no] );
		code := code + ada_entity_xml_start_element_code ( allrecs [ no] );
		code := code + ada_entity_xml_end_element_code ( allrecs [ no] );
	END_REPEAT;

	REPEAT no := LOINDEX ( allcls ) TO HIINDEX ( allcls );
		code := code + ada_entity_xml_io_record_initialize_code ( allcls [ no] );
		code := code + ada_entity_xml_start_element_code ( allcls [ no] );
		code := code + ada_entity_xml_end_element_code ( allcls [ no] );
	END_REPEAT;
	code := code + 'end xml_architecture_io;\n';
	RETURN ( code );
END_FUNCTION;
</ISO10303-11-EXPRESS>!

!ExChdXmlArchitectureIoAdbPackageCodeFunction class methodsFor: 'platypus-generated-platypus-signature' stamp: ''!
iso10303P11Translater
	^ 'Platypus (c) LISYC EA3883, Universite de Bretagne occidentale. Brest.'

! !

!ExChdXmlArchitectureIoAdbPackageCodeFunction class methodsFor: 'platypus-generated-meta-data-accessing' stamp: ''!
schemaDefinition
	^ ExChdXmlIoSchemaDefinition singleton

! !

!ExChdXmlArchitectureIoAdbPackageCodeFunction class methodsFor: 'platypus-generated-platypus-signature' stamp: ''!
translatedFromISO10303P11
	^ true

! !

!ExChdXmlArchitectureIoAdbPackageCodeFunction class methodsFor: 'platypus-generated-platypus-signature' stamp: ''!
vwNamespaceName
	^ #Express2Cheddar

! !

!ExChdXmlArchitectureIoAdbPackageCodeFunction methodsFor: 'platypus-generated-accessing' stamp: ''!
allcls
	^ allcls

! !

!ExChdXmlArchitectureIoAdbPackageCodeFunction methodsFor: 'platypus-generated-accessing' stamp: ''!
allcls: aListOfExChdAdaClass
	allcls := aListOfExChdAdaClass
		ifNil: [ OrderedCollection new ]
		ifNotNil: [ aListOfExChdAdaClass as: OrderedCollection ]

! !

!ExChdXmlArchitectureIoAdbPackageCodeFunction methodsFor: 'platypus-generated-accessing' stamp: ''!
alldts
	^ alldts

! !

!ExChdXmlArchitectureIoAdbPackageCodeFunction methodsFor: 'platypus-generated-accessing' stamp: ''!
alldts: aListOfExChdDiscriminatedType
	alldts := aListOfExChdDiscriminatedType
		ifNil: [ OrderedCollection new ]
		ifNotNil: [ aListOfExChdDiscriminatedType as: OrderedCollection ]

! !

!ExChdXmlArchitectureIoAdbPackageCodeFunction methodsFor: 'platypus-generated-accessing' stamp: ''!
allents
	^ allents

! !

!ExChdXmlArchitectureIoAdbPackageCodeFunction methodsFor: 'platypus-generated-accessing' stamp: ''!
allents: aListOfExChdAdaEntity
	allents := aListOfExChdAdaEntity
		ifNil: [ OrderedCollection new ]
		ifNotNil: [ aListOfExChdAdaEntity as: OrderedCollection ]

! !

!ExChdXmlArchitectureIoAdbPackageCodeFunction methodsFor: 'platypus-generated-accessing' stamp: ''!
allrecs
	^ allrecs

! !

!ExChdXmlArchitectureIoAdbPackageCodeFunction methodsFor: 'platypus-generated-accessing' stamp: ''!
allrecs: aListOfExChdRecord
	allrecs := aListOfExChdRecord ifNil: [ OrderedCollection new ] ifNotNil: [ aListOfExChdRecord as: OrderedCollection ]

! !

!ExChdXmlArchitectureIoAdbPackageCodeFunction methodsFor: 'platypus-generated-accessing' stamp: ''!
code
	^ code

! !

!ExChdXmlArchitectureIoAdbPackageCodeFunction methodsFor: 'platypus-generated-accessing' stamp: ''!
code: aString
	code := aString

! !

!ExChdXmlArchitectureIoAdbPackageCodeFunction methodsFor: 'platypus-generated-invoking' stamp: ''!
invoke
	" ---------- locals assignments ----------"

	self code: ''.
	self allcls: ExChdAllAdaClassesFunction invoke.
	self allrecs: ExChdAllAdaRecordsFunction invoke.
	self allents: (self allcls pltPlus: self allrecs).
	self strtab: Array new.
	self alldts: ExChdAllAdaDiscriminatedTypesFunction invoke.	" ---------- statements ----------"
	self
		code:
			(((((((((((((((((((((((((((((((((((((((''
				pltPlus: '------------------------------------------------------------------------------\n')
				pltPlus: '------------------------------------------------------------------------------\n')
				pltPlus: '--  This source file was automatically generated by Platypus\n')
				pltPlus: '--  see http://dossen.univ-brest.fr/apl\n') pltPlus: '-- \n')
				pltPlus: '--  Any modification of this file will be lost. \n')
				pltPlus: '--  Please see the "platypus" directory instead : it contains the Cheddar''s\n')
				pltPlus: '--  model and its meta-model. \n')
				pltPlus: '------------------------------------------------------------------------------\n \n')
				pltPlus: '------------------------------------------------------------------------------\n')
				pltPlus: '-- Cheddar is a free real time scheduling tool.\n')
				pltPlus: '-- This program provides services to automatically check temporal constraints\n')
				pltPlus: '-- of real time tasks.\n') pltPlus: '--\n') pltPlus: '-- Copyright (C) 2002-2014   Frank Singhoff\n')
				pltPlus: '-- Cheddar is developed by the LAB-STICC Team, University of Brest\n') pltPlus: '--\n')
				pltPlus: '-- This program is free software; you can redistribute it and/or modify\n')
				pltPlus: '-- it under the terms of the GNU General Public License as published by\n')
				pltPlus: '-- the Free Software Foundation; either version 2 of the License, or\n')
				pltPlus: '-- (at your option) any later version.\n') pltPlus: '--\n')
				pltPlus: '-- This program is distributed in the hope that it will be useful,\n')
				pltPlus: '-- but WITHOUT ANY WARRANTY; without even the implied warranty of\n')
				pltPlus: '-- MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the\n')
				pltPlus: '-- GNU General Public License for more details.\n') pltPlus: '--\n')
				pltPlus: '-- You should have received a copy of the GNU General Public License\n')
				pltPlus: '-- along with this program; if not, write to the Free Software\n')
				pltPlus: '-- Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA\n') pltPlus: '--\n')
				pltPlus: '--\n') pltPlus: '-- Contact : cheddar@listes.univ-brest.fr\n')
				pltPlus: '-- 	To post to this mailing list, you must be subscribed\n')
				pltPlus: '-- 	(see http//beru.univ-brest.fr/~singhoff/cheddar for details)\n') pltPlus: '--\n')
				pltPlus: '------------------------------------------------------------------------------\n')
				pltPlus: '------------------------------------------------------------------------------\n') pltPlus: '\n').
	self code: (self code pltPlus: 'package body xml_architecture_io is\n\n').
	self code: (self code pltPlus: '\n').
	self
		code:
			(((((((((((((self code pltPlus: '\nprocedure Start_Element(') pltPlus: '\n	Handler: in out Xml_Generic_Parser;')
				pltPlus: '\n	ref : in out unbounded_string;') pltPlus: '\n	id : in out unbounded_string;')
				pltPlus: '\n	Namespace_Uri : Unicode.CES.Byte_Sequence := "";')
				pltPlus: '\n	Local_Name : Unicode.CES.Byte_Sequence := "";') pltPlus: '\n	Qname : Unicode.CES.Byte_Sequence := "";')
				pltPlus: '\n	Atts : Sax.Attributes.Attributes''Class) is') pltPlus: '\nbegin')
				pltPlus: '\n	if Get_Length (Atts) > 0 then') pltPlus: '\n		if (To_String (To_Lower (Qname)) = "')
				pltPlus:
					(PTsLowerizeFunction
						invokeFromValues:
							(OrderedCollection new
								add:
										((self allents
												pltAt:
													(PltLOINDEXFunction
														invokeFromValues:
															(OrderedCollection new
																add: self allents;
																yourself))) nameUsingContext: self class context);
								yourself))) pltPlus: '")').
	PlatypusCoreRepeatStatement
		repeat: [ :no1583 | 
			self
				code:
					(((self code pltPlus: '\n\t\t\t OR (To_String (To_Lower (Qname)) = "')
						pltPlus:
							(PTsLowerizeFunction
								invokeFromValues:
									(OrderedCollection new
										add: ((self allents pltAt: no1583) nameUsingContext: self class context);
										yourself))) pltPlus: '")') ]
		from:
			((PltLOINDEXFunction
				invokeFromValues:
					(OrderedCollection new
						add: self allents;
						yourself)) pltPlus: 1)
		to:
			(PltHIINDEXFunction
				invokeFromValues:
					(OrderedCollection new
						add: self allents;
						yourself)).
	self
		code:
			((((((((((((self code pltPlus: ' then') pltPlus: '\n			for J in 0 .. Get_Length (Atts) - 1 loop')
				pltPlus: '\n				if To_String (To_Lower (Get_Qname (Atts, J))) = "id" then')
				pltPlus: '\n					id := To_Unbounded_String (Get_Value (Atts, J));') pltPlus: '\n				end if;')
				pltPlus: '\n				if To_String (To_Lower (Get_Qname (Atts, J))) = "ref" then')
				pltPlus: '\n					ref := To_Unbounded_String (Get_Value (Atts, J));') pltPlus: '\n				end if;')
				pltPlus: '\n			end loop;') pltPlus: '\n		end if;') pltPlus: '\n	end if;') pltPlus: '\nend Start_Element;\n\n').
	PlatypusCoreRepeatStatement
		repeat: [ :no1620 | 
			self
				code:
					(self code
						pltPlus:
							(ExChdDiscriminatedTypeXmlIoRecordInitializeCodeFunction
								invokeFromValues:
									(OrderedCollection new
										add: (self alldts pltAt: no1620);
										yourself))).
			self
				code:
					(self code
						pltPlus:
							(ExChdDiscriminatedTypeXmlStartElementCodeFunction
								invokeFromValues:
									(OrderedCollection new
										add: (self alldts pltAt: no1620);
										yourself))).
			self
				code:
					(self code
						pltPlus:
							(ExChdDiscriminatedTypeXmlEndElementCodeFunction
								invokeFromValues:
									(OrderedCollection new
										add: (self alldts pltAt: no1620);
										yourself))) ]
		from:
			(PltLOINDEXFunction
				invokeFromValues:
					(OrderedCollection new
						add: self alldts;
						yourself))
		to:
			(PltHIINDEXFunction
				invokeFromValues:
					(OrderedCollection new
						add: self alldts;
						yourself)).
	PlatypusCoreRepeatStatement
		repeat: [ :no3202 | 
			self
				code:
					(self code
						pltPlus:
							(ExChdAdaEntityXmlIoRecordInitializeCodeFunction
								invokeFromValues:
									(OrderedCollection new
										add: (self allrecs pltAt: no3202);
										yourself))).
			self
				code:
					(self code
						pltPlus:
							(ExChdAdaEntityXmlStartElementCodeFunction
								invokeFromValues:
									(OrderedCollection new
										add: (self allrecs pltAt: no3202);
										yourself))).
			self
				code:
					(self code
						pltPlus:
							(ExChdAdaEntityXmlEndElementCodeFunction
								invokeFromValues:
									(OrderedCollection new
										add: (self allrecs pltAt: no3202);
										yourself))) ]
		from:
			(PltLOINDEXFunction
				invokeFromValues:
					(OrderedCollection new
						add: self allrecs;
						yourself))
		to:
			(PltHIINDEXFunction
				invokeFromValues:
					(OrderedCollection new
						add: self allrecs;
						yourself)).
	PlatypusCoreRepeatStatement
		repeat: [ :no664 | 
			self
				code:
					(self code
						pltPlus:
							(ExChdAdaEntityXmlIoRecordInitializeCodeFunction
								invokeFromValues:
									(OrderedCollection new
										add: (self allcls pltAt: no664);
										yourself))).
			self
				code:
					(self code
						pltPlus:
							(ExChdAdaEntityXmlStartElementCodeFunction
								invokeFromValues:
									(OrderedCollection new
										add: (self allcls pltAt: no664);
										yourself))).
			self
				code:
					(self code
						pltPlus:
							(ExChdAdaEntityXmlEndElementCodeFunction
								invokeFromValues:
									(OrderedCollection new
										add: (self allcls pltAt: no664);
										yourself))) ]
		from:
			(PltLOINDEXFunction
				invokeFromValues:
					(OrderedCollection new
						add: self allcls;
						yourself))
		to:
			(PltHIINDEXFunction
				invokeFromValues:
					(OrderedCollection new
						add: self allcls;
						yourself)).
	self code: (self code pltPlus: 'end xml_architecture_io;\n').
	^ self return: self code

! !

!ExChdXmlArchitectureIoAdbPackageCodeFunction methodsFor: 'platypus-generated-accessing' stamp: ''!
strtab
	^ strtab

! !

!ExChdXmlArchitectureIoAdbPackageCodeFunction methodsFor: 'platypus-generated-accessing' stamp: ''!
strtab: aListOfString
	strtab := aListOfString ifNil: [ OrderedCollection new ] ifNotNil: [ aListOfString as: OrderedCollection ]

! !

PlatypusCoreAlgorithmDeclaration subclass: #ExChdXmlArchitectureIoAdsPackageCodeFunction
	instanceVariableNames: 'test code pkgs allcls allrecs alldts interfaces'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Express2Cheddar-XmlIoSchema'!

!ExChdXmlArchitectureIoAdsPackageCodeFunction commentStamp: 'platypus comment' prior: 0!
<ISO10303-11-EXPRESS>
FUNCTION xml_architecture_io_ads_package_code : STRING;
	LOCAL 
		test : STRING := '';
		code : STRING := '';
		pkgs : LIST OF ada_package := SetToList ( all_ada_packages ( ) );
		allcls : LIST OF ada_class := all_ada_classes ( );
		allrecs : LIST OF ada_class := all_ada_records ( );
		alldts : LIST OF discriminated_type := all_ada_discriminated_types ( );
		interfaces : LIST OF ada_interface := [ ada_interface ( 'Sax', 'Readers', true, true ), ada_interface ( 'Networks', ?, true, true ), ada_interface ( 'Sax', 'Exceptions', true, true ), ada_interface ( 'Sax', 'Locators', true, true ), ada_interface ( 'Sax', 'Attributes', true, true ), ada_interface ( 'Unicode', 'CES', true, true ), ada_interface ( 'Unicode', ?, true, true ), ada_interface ( 'xml_generic_parsers', ?, true, true ), ada_interface ( 'Ada', 'Text_IO', true, true ), ada_interface ( 'Ada', 'Strings.Unbounded', true, true ), ada_interface ( 'Strings', ?, true, true ), ada_interface ( 'Unbounded_Strings', ?, true, true ), ada_interface ( 'Ada', 'Numerics.Aux', true, true ), ada_interface ( 'call_framework_interface', ?, true, true ), ada_interface ( 'Debug', ?, true, true ) ];
	END_LOCAL;
	code := source_licence + '\n';

	REPEAT no := LOINDEX ( pkgs ) TO HIINDEX ( pkgs );
		interfaces := interfaces + ada_interface ( pkgs [ no].name, ?, true, true );
		interfaces := interfaces + ada_package_interface ( pkgs [ no], true );
	END_REPEAT;
	code := source_licence + ada_interfaces_code ( ?, interfaces );
	code := code + 'package xml_architecture_io is\n\n' 

	+ '-- Attributes of the discriminated types\n\n';

	REPEAT no := LOINDEX ( alldts ) TO HIINDEX ( alldts );
		code := code + alldts [ no].xml_io_record_code + '\n';
	END_REPEAT;
	code := code + '\nprocedure Start_Element(' + '\n	Handler: in out Xml_Generic_Parser;' + '\n	ref : in out unbounded_string;' + '\n	id : in out unbounded_string;' + '\n	Namespace_Uri : Unicode.CES.Byte_Sequence := "";' + '\n	Local_Name : Unicode.CES.Byte_Sequence := "";' + '\n	Qname : Unicode.CES.Byte_Sequence := "";' + '\n	Atts : Sax.Attributes.Attributes''Class);\n';

	REPEAT no := LOINDEX ( alldts ) TO HIINDEX ( alldts );
		test := discriminated_type_xml_start_element_code ( alldts [ no] );

		IF ( test > '' ) THEN
			code := code + '\nprocedure Start_Element(\n' 
			+ '\tHandler : in out Xml_generic_parser;\n' 
			+ '\tobj : in out ' + alldts [ no].name + '_io;\n' 
			+ '\tNamespace_Uri : Unicode.CES.Byte_Sequence := "";\n' 
			+ '\tLocal_Name : Unicode.CES.Byte_Sequence := "";\n' 
			+ '\tQname : Unicode.CES.Byte_Sequence := "";\n' 
			+ '\tAtts : Sax.Attributes.Attributes''Class);\n';
		END_IF;
		code := code + '\nprocedure End_Element(\n' 
		+ '\tHandler : in out Xml_generic_parser;\n' 
		+ '\tobj : in out ' + alldts [ no].name + '_io;\n' 
		+ '\tNamespace_Uri : Unicode.CES.Byte_Sequence := "";\n' 
		+ '\tLocal_Name : Unicode.CES.Byte_Sequence := "";\n' 
		+ '\tQname : Unicode.CES.Byte_Sequence := "");\n';
	END_REPEAT;

	REPEAT no := LOINDEX ( alldts ) TO HIINDEX ( alldts );
		code := code + '\nprocedure Initialize(obj : out ' + alldts [ no].name + '_io);';
	END_REPEAT;
	code := code + '\n\n' 

	+ '-- Attributes of the parsed entities\n\n';

	REPEAT no := LOINDEX ( allrecs ) TO HIINDEX ( allrecs );
		code := code + allrecs [ no].xml_io_record_code + '\n';
	END_REPEAT;
	code := code + '\n';

	REPEAT no := LOINDEX ( allrecs ) TO HIINDEX ( allrecs );
		code := code + '\nprocedure Initialize(obj : out ' + allrecs [ no].name + '_io);';
	END_REPEAT;
	code := code + '\n';

	REPEAT no := LOINDEX ( allrecs ) TO HIINDEX ( allrecs );
		test := ada_entity_xml_start_element_code ( allrecs [ no] );

		IF ( test > '' ) THEN
			code := code + '\nprocedure Start_Element(\n' 
			+ '\tHandler : in out Xml_generic_parser;\n' 
			+ '\tobj : in out ' + allrecs [ no].name + '_io;\n' 
			+ '\tNamespace_Uri : Unicode.CES.Byte_Sequence := "";\n' 
			+ '\tLocal_Name : Unicode.CES.Byte_Sequence := "";\n' 
			+ '\tQname : Unicode.CES.Byte_Sequence := "";\n' 
			+ '\tAtts : Sax.Attributes.Attributes''Class);\n';
		END_IF;
		code := code + '\nprocedure End_Element(\n' 
		+ '\tHandler : in out Xml_generic_parser;\n' 
		+ '\tobj : in out ' + allrecs [ no].name + '_io;\n' 
		+ '\tNamespace_Uri : Unicode.CES.Byte_Sequence := "";\n' 
		+ '\tLocal_Name : Unicode.CES.Byte_Sequence := "";\n' 
		+ '\tQname : Unicode.CES.Byte_Sequence := "");\n';
	END_REPEAT;

	REPEAT no := LOINDEX ( allcls ) TO HIINDEX ( allcls );
		code := code + allcls [ no].xml_io_record_code + '\n';
	END_REPEAT;
	code := code + '\n';

	REPEAT no := LOINDEX ( allcls ) TO HIINDEX ( allcls );
		code := code + '\nprocedure Initialize(obj : out ' + allcls [ no].name + '_io);';
	END_REPEAT;
	code := code + '\n';

	REPEAT no := LOINDEX ( allcls ) TO HIINDEX ( allcls );
		test := ada_entity_xml_start_element_code ( allcls [ no] );

		IF ( test > '' ) THEN
			code := code + '\nprocedure Start_Element(\n' 
			+ '\tHandler : in out Xml_generic_parser;\n' 
			+ '\tobj : in out ' + allcls [ no].name + '_io;\n' 
			+ '\tNamespace_Uri : Unicode.CES.Byte_Sequence := "";\n' 
			+ '\tLocal_Name : Unicode.CES.Byte_Sequence := "";\n' 
			+ '\tQname : Unicode.CES.Byte_Sequence := "";\n' 
			+ '\tAtts : Sax.Attributes.Attributes''Class);\n';
		END_IF;
		code := code + '\nprocedure End_Element(\n' 
		+ '\tHandler : in out Xml_generic_parser;\n' 
		+ '\tobj : in out ' + allcls [ no].name + '_io;\n' 
		+ '\tNamespace_Uri : Unicode.CES.Byte_Sequence := "";\n' 
		+ '\tLocal_Name : Unicode.CES.Byte_Sequence := "";\n' 
		+ '\tQname : Unicode.CES.Byte_Sequence := "");\n';
	END_REPEAT;
	code := code + '\n\nend xml_architecture_io;\n';
	RETURN ( code );
END_FUNCTION;
</ISO10303-11-EXPRESS>!

!ExChdXmlArchitectureIoAdsPackageCodeFunction class methodsFor: 'platypus-generated-platypus-signature' stamp: ''!
iso10303P11Translater
	^ 'Platypus (c) LISYC EA3883, Universite de Bretagne occidentale. Brest.'

! !

!ExChdXmlArchitectureIoAdsPackageCodeFunction class methodsFor: 'platypus-generated-meta-data-accessing' stamp: ''!
schemaDefinition
	^ ExChdXmlIoSchemaDefinition singleton

! !

!ExChdXmlArchitectureIoAdsPackageCodeFunction class methodsFor: 'platypus-generated-platypus-signature' stamp: ''!
translatedFromISO10303P11
	^ true

! !

!ExChdXmlArchitectureIoAdsPackageCodeFunction class methodsFor: 'platypus-generated-platypus-signature' stamp: ''!
vwNamespaceName
	^ #Express2Cheddar

! !

!ExChdXmlArchitectureIoAdsPackageCodeFunction methodsFor: 'platypus-generated-accessing' stamp: ''!
allcls
	^ allcls

! !

!ExChdXmlArchitectureIoAdsPackageCodeFunction methodsFor: 'platypus-generated-accessing' stamp: ''!
allcls: aListOfExChdAdaClass
	allcls := aListOfExChdAdaClass
		ifNil: [ OrderedCollection new ]
		ifNotNil: [ aListOfExChdAdaClass as: OrderedCollection ]

! !

!ExChdXmlArchitectureIoAdsPackageCodeFunction methodsFor: 'platypus-generated-accessing' stamp: ''!
alldts
	^ alldts

! !

!ExChdXmlArchitectureIoAdsPackageCodeFunction methodsFor: 'platypus-generated-accessing' stamp: ''!
alldts: aListOfExChdDiscriminatedType
	alldts := aListOfExChdDiscriminatedType
		ifNil: [ OrderedCollection new ]
		ifNotNil: [ aListOfExChdDiscriminatedType as: OrderedCollection ]

! !

!ExChdXmlArchitectureIoAdsPackageCodeFunction methodsFor: 'platypus-generated-accessing' stamp: ''!
allrecs
	^ allrecs

! !

!ExChdXmlArchitectureIoAdsPackageCodeFunction methodsFor: 'platypus-generated-accessing' stamp: ''!
allrecs: aListOfExChdAdaClass1
	allrecs := aListOfExChdAdaClass1
		ifNil: [ OrderedCollection new ]
		ifNotNil: [ aListOfExChdAdaClass1 as: OrderedCollection ]

! !

!ExChdXmlArchitectureIoAdsPackageCodeFunction methodsFor: 'platypus-generated-accessing' stamp: ''!
code
	^ code

! !

!ExChdXmlArchitectureIoAdsPackageCodeFunction methodsFor: 'platypus-generated-accessing' stamp: ''!
code: aString1
	code := aString1

! !

!ExChdXmlArchitectureIoAdsPackageCodeFunction methodsFor: 'platypus-generated-accessing' stamp: ''!
interfaces
	^ interfaces

! !

!ExChdXmlArchitectureIoAdsPackageCodeFunction methodsFor: 'platypus-generated-accessing' stamp: ''!
interfaces: aListOfExChdAdaInterface
	interfaces := aListOfExChdAdaInterface
		ifNil: [ OrderedCollection new ]
		ifNotNil: [ aListOfExChdAdaInterface as: OrderedCollection ]

! !

!ExChdXmlArchitectureIoAdsPackageCodeFunction methodsFor: 'platypus-generated-invoking' stamp: ''!
invoke
	" ---------- locals assignments ----------"

	self test: ''.
	self code: ''.
	self
		pkgs:
			(PTsSetToListFunction
				invokeFromValues:
					(OrderedCollection new
						add: ExChdAllAdaPackagesFunction invoke;
						yourself)).
	self allcls: ExChdAllAdaClassesFunction invoke.
	self allrecs: ExChdAllAdaRecordsFunction invoke.
	self alldts: ExChdAllAdaDiscriminatedTypesFunction invoke.
	self
		interfaces:
			(PlatypusCoreAggregateInitializer
				collectionFrom:
					(OrderedCollection new
						add:
								(ExChdAdaInterface new
										adaInterfaceFromValues:
												(OrderedCollection new
														add: 'Sax';
														add: 'Readers';
														add: true;
														add: true;
														yourself);
										yourself);
						add:
								(ExChdAdaInterface new
										adaInterfaceFromValues:
												(OrderedCollection new
														add: 'Networks';
														add: nil;
														add: true;
														add: true;
														yourself);
										yourself);
						add:
								(ExChdAdaInterface new
										adaInterfaceFromValues:
												(OrderedCollection new
														add: 'Sax';
														add: 'Exceptions';
														add: true;
														add: true;
														yourself);
										yourself);
						add:
								(ExChdAdaInterface new
										adaInterfaceFromValues:
												(OrderedCollection new
														add: 'Sax';
														add: 'Locators';
														add: true;
														add: true;
														yourself);
										yourself);
						add:
								(ExChdAdaInterface new
										adaInterfaceFromValues:
												(OrderedCollection new
														add: 'Sax';
														add: 'Attributes';
														add: true;
														add: true;
														yourself);
										yourself);
						add:
								(ExChdAdaInterface new
										adaInterfaceFromValues:
												(OrderedCollection new
														add: 'Unicode';
														add: 'CES';
														add: true;
														add: true;
														yourself);
										yourself);
						add:
								(ExChdAdaInterface new
										adaInterfaceFromValues:
												(OrderedCollection new
														add: 'Unicode';
														add: nil;
														add: true;
														add: true;
														yourself);
										yourself);
						add:
								(ExChdAdaInterface new
										adaInterfaceFromValues:
												(OrderedCollection new
														add: 'xml_generic_parsers';
														add: nil;
														add: true;
														add: true;
														yourself);
										yourself);
						add:
								(ExChdAdaInterface new
										adaInterfaceFromValues:
												(OrderedCollection new
														add: 'Ada';
														add: 'Text_IO';
														add: true;
														add: true;
														yourself);
										yourself);
						add:
								(ExChdAdaInterface new
										adaInterfaceFromValues:
												(OrderedCollection new
														add: 'Ada';
														add: 'Strings.Unbounded';
														add: true;
														add: true;
														yourself);
										yourself);
						add:
								(ExChdAdaInterface new
										adaInterfaceFromValues:
												(OrderedCollection new
														add: 'Strings';
														add: nil;
														add: true;
														add: true;
														yourself);
										yourself);
						add:
								(ExChdAdaInterface new
										adaInterfaceFromValues:
												(OrderedCollection new
														add: 'Unbounded_Strings';
														add: nil;
														add: true;
														add: true;
														yourself);
										yourself);
						add:
								(ExChdAdaInterface new
										adaInterfaceFromValues:
												(OrderedCollection new
														add: 'Ada';
														add: 'Numerics.Aux';
														add: true;
														add: true;
														yourself);
										yourself);
						add:
								(ExChdAdaInterface new
										adaInterfaceFromValues:
												(OrderedCollection new
														add: 'call_framework_interface';
														add: nil;
														add: true;
														add: true;
														yourself);
										yourself);
						add:
								(ExChdAdaInterface new
										adaInterfaceFromValues:
												(OrderedCollection new
														add: 'Debug';
														add: nil;
														add: true;
														add: true;
														yourself);
										yourself);
						yourself)).	" ---------- statements ----------"
	self
		code:
			(((((((((((((((((((((((((((((((((((((((''
				pltPlus: '------------------------------------------------------------------------------\n')
				pltPlus: '------------------------------------------------------------------------------\n')
				pltPlus: '--  This source file was automatically generated by Platypus\n')
				pltPlus: '--  see http://dossen.univ-brest.fr/apl\n') pltPlus: '-- \n')
				pltPlus: '--  Any modification of this file will be lost. \n')
				pltPlus: '--  Please see the "platypus" directory instead : it contains the Cheddar''s\n')
				pltPlus: '--  model and its meta-model. \n')
				pltPlus: '------------------------------------------------------------------------------\n \n')
				pltPlus: '------------------------------------------------------------------------------\n')
				pltPlus: '-- Cheddar is a free real time scheduling tool.\n')
				pltPlus: '-- This program provides services to automatically check temporal constraints\n')
				pltPlus: '-- of real time tasks.\n') pltPlus: '--\n') pltPlus: '-- Copyright (C) 2002-2014   Frank Singhoff\n')
				pltPlus: '-- Cheddar is developed by the LAB-STICC Team, University of Brest\n') pltPlus: '--\n')
				pltPlus: '-- This program is free software; you can redistribute it and/or modify\n')
				pltPlus: '-- it under the terms of the GNU General Public License as published by\n')
				pltPlus: '-- the Free Software Foundation; either version 2 of the License, or\n')
				pltPlus: '-- (at your option) any later version.\n') pltPlus: '--\n')
				pltPlus: '-- This program is distributed in the hope that it will be useful,\n')
				pltPlus: '-- but WITHOUT ANY WARRANTY; without even the implied warranty of\n')
				pltPlus: '-- MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the\n')
				pltPlus: '-- GNU General Public License for more details.\n') pltPlus: '--\n')
				pltPlus: '-- You should have received a copy of the GNU General Public License\n')
				pltPlus: '-- along with this program; if not, write to the Free Software\n')
				pltPlus: '-- Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA\n') pltPlus: '--\n')
				pltPlus: '--\n') pltPlus: '-- Contact : cheddar@listes.univ-brest.fr\n')
				pltPlus: '-- 	To post to this mailing list, you must be subscribed\n')
				pltPlus: '-- 	(see http//beru.univ-brest.fr/~singhoff/cheddar for details)\n') pltPlus: '--\n')
				pltPlus: '------------------------------------------------------------------------------\n')
				pltPlus: '------------------------------------------------------------------------------\n') pltPlus: '\n').
	PlatypusCoreRepeatStatement
		repeat: [ :no411 | 
			self
				interfaces:
					(self interfaces
						pltPlus:
							(ExChdAdaInterface new
								adaInterfaceFromValues:
										(OrderedCollection new
												add: ((self pkgs pltAt: no411) nameUsingContext: self class context);
												add: nil;
												add: true;
												add: true;
												yourself);
								yourself)).
			self
				interfaces:
					(self interfaces
						pltPlus:
							(ExChdAdaPackageInterfaceFunction
								invokeFromValues:
									(OrderedCollection new
										add: (self pkgs pltAt: no411);
										add: true;
										yourself))) ]
		from:
			(PltLOINDEXFunction
				invokeFromValues:
					(OrderedCollection new
						add: self pkgs;
						yourself))
		to:
			(PltHIINDEXFunction
				invokeFromValues:
					(OrderedCollection new
						add: self pkgs;
						yourself)).
	self
		code:
			(((((((((((((((((((((((((((((((((((((((''
				pltPlus: '------------------------------------------------------------------------------\n')
				pltPlus: '------------------------------------------------------------------------------\n')
				pltPlus: '--  This source file was automatically generated by Platypus\n')
				pltPlus: '--  see http://dossen.univ-brest.fr/apl\n') pltPlus: '-- \n')
				pltPlus: '--  Any modification of this file will be lost. \n')
				pltPlus: '--  Please see the "platypus" directory instead : it contains the Cheddar''s\n')
				pltPlus: '--  model and its meta-model. \n')
				pltPlus: '------------------------------------------------------------------------------\n \n')
				pltPlus: '------------------------------------------------------------------------------\n')
				pltPlus: '-- Cheddar is a free real time scheduling tool.\n')
				pltPlus: '-- This program provides services to automatically check temporal constraints\n')
				pltPlus: '-- of real time tasks.\n') pltPlus: '--\n') pltPlus: '-- Copyright (C) 2002-2014   Frank Singhoff\n')
				pltPlus: '-- Cheddar is developed by the LAB-STICC Team, University of Brest\n') pltPlus: '--\n')
				pltPlus: '-- This program is free software; you can redistribute it and/or modify\n')
				pltPlus: '-- it under the terms of the GNU General Public License as published by\n')
				pltPlus: '-- the Free Software Foundation; either version 2 of the License, or\n')
				pltPlus: '-- (at your option) any later version.\n') pltPlus: '--\n')
				pltPlus: '-- This program is distributed in the hope that it will be useful,\n')
				pltPlus: '-- but WITHOUT ANY WARRANTY; without even the implied warranty of\n')
				pltPlus: '-- MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the\n')
				pltPlus: '-- GNU General Public License for more details.\n') pltPlus: '--\n')
				pltPlus: '-- You should have received a copy of the GNU General Public License\n')
				pltPlus: '-- along with this program; if not, write to the Free Software\n')
				pltPlus: '-- Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA\n') pltPlus: '--\n')
				pltPlus: '--\n') pltPlus: '-- Contact : cheddar@listes.univ-brest.fr\n')
				pltPlus: '-- 	To post to this mailing list, you must be subscribed\n')
				pltPlus: '-- 	(see http//beru.univ-brest.fr/~singhoff/cheddar for details)\n') pltPlus: '--\n')
				pltPlus: '------------------------------------------------------------------------------\n')
				pltPlus: '------------------------------------------------------------------------------\n')
				pltPlus:
					(ExChdAdaInterfacesCodeFunction
						invokeFromValues:
							(OrderedCollection new
								add: nil;
								add: self interfaces;
								yourself))).
	self
		code:
			((self code pltPlus: 'package xml_architecture_io is\n\n') pltPlus: '-- Attributes of the discriminated types\n\n').
	PlatypusCoreRepeatStatement
		repeat: [ :no346 | 
			self
				code:
					((self code pltPlus: ((self alldts pltAt: no346) xmlIoRecordCodeUsingContext: self class context)) pltPlus: '\n') ]
		from:
			(PltLOINDEXFunction
				invokeFromValues:
					(OrderedCollection new
						add: self alldts;
						yourself))
		to:
			(PltHIINDEXFunction
				invokeFromValues:
					(OrderedCollection new
						add: self alldts;
						yourself)).
	self
		code:
			((((((((self code pltPlus: '\nprocedure Start_Element(') pltPlus: '\n	Handler: in out Xml_Generic_Parser;')
				pltPlus: '\n	ref : in out unbounded_string;') pltPlus: '\n	id : in out unbounded_string;')
				pltPlus: '\n	Namespace_Uri : Unicode.CES.Byte_Sequence := "";')
				pltPlus: '\n	Local_Name : Unicode.CES.Byte_Sequence := "";') pltPlus: '\n	Qname : Unicode.CES.Byte_Sequence := "";')
				pltPlus: '\n	Atts : Sax.Attributes.Attributes''Class);\n').
	PlatypusCoreRepeatStatement
		repeat: [ :no3525 | 
			self
				test:
					(ExChdDiscriminatedTypeXmlStartElementCodeFunction
						invokeFromValues:
							(OrderedCollection new
								add: (self alldts pltAt: no3525);
								yourself)).
			self test > ''
				ifTrue: [ 
					self
						code:
							(((((((((self code pltPlus: '\nprocedure Start_Element(\n') pltPlus: '\tHandler : in out Xml_generic_parser;\n')
								pltPlus: '\tobj : in out ') pltPlus: ((self alldts pltAt: no3525) nameUsingContext: self class context))
								pltPlus: '_io;\n') pltPlus: '\tNamespace_Uri : Unicode.CES.Byte_Sequence := "";\n')
								pltPlus: '\tLocal_Name : Unicode.CES.Byte_Sequence := "";\n')
								pltPlus: '\tQname : Unicode.CES.Byte_Sequence := "";\n')
								pltPlus: '\tAtts : Sax.Attributes.Attributes''Class);\n') ].
			self
				code:
					((((((((self code pltPlus: '\nprocedure End_Element(\n') pltPlus: '\tHandler : in out Xml_generic_parser;\n')
						pltPlus: '\tobj : in out ') pltPlus: ((self alldts pltAt: no3525) nameUsingContext: self class context))
						pltPlus: '_io;\n') pltPlus: '\tNamespace_Uri : Unicode.CES.Byte_Sequence := "";\n')
						pltPlus: '\tLocal_Name : Unicode.CES.Byte_Sequence := "";\n')
						pltPlus: '\tQname : Unicode.CES.Byte_Sequence := "");\n') ]
		from:
			(PltLOINDEXFunction
				invokeFromValues:
					(OrderedCollection new
						add: self alldts;
						yourself))
		to:
			(PltHIINDEXFunction
				invokeFromValues:
					(OrderedCollection new
						add: self alldts;
						yourself)).
	PlatypusCoreRepeatStatement
		repeat: [ :no2213 | 
			self
				code:
					(((self code pltPlus: '\nprocedure Initialize(obj : out ')
						pltPlus: ((self alldts pltAt: no2213) nameUsingContext: self class context)) pltPlus: '_io);') ]
		from:
			(PltLOINDEXFunction
				invokeFromValues:
					(OrderedCollection new
						add: self alldts;
						yourself))
		to:
			(PltHIINDEXFunction
				invokeFromValues:
					(OrderedCollection new
						add: self alldts;
						yourself)).
	self code: ((self code pltPlus: '\n\n') pltPlus: '-- Attributes of the parsed entities\n\n').
	PlatypusCoreRepeatStatement
		repeat: [ :no862 | 
			self
				code:
					((self code pltPlus: ((self allrecs pltAt: no862) xmlIoRecordCodeUsingContext: self class context)) pltPlus: '\n') ]
		from:
			(PltLOINDEXFunction
				invokeFromValues:
					(OrderedCollection new
						add: self allrecs;
						yourself))
		to:
			(PltHIINDEXFunction
				invokeFromValues:
					(OrderedCollection new
						add: self allrecs;
						yourself)).
	self code: (self code pltPlus: '\n').
	PlatypusCoreRepeatStatement
		repeat: [ :no882 | 
			self
				code:
					(((self code pltPlus: '\nprocedure Initialize(obj : out ')
						pltPlus: ((self allrecs pltAt: no882) nameUsingContext: self class context)) pltPlus: '_io);') ]
		from:
			(PltLOINDEXFunction
				invokeFromValues:
					(OrderedCollection new
						add: self allrecs;
						yourself))
		to:
			(PltHIINDEXFunction
				invokeFromValues:
					(OrderedCollection new
						add: self allrecs;
						yourself)).
	self code: (self code pltPlus: '\n').
	PlatypusCoreRepeatStatement
		repeat: [ :no1992 | 
			self
				test:
					(ExChdAdaEntityXmlStartElementCodeFunction
						invokeFromValues:
							(OrderedCollection new
								add: (self allrecs pltAt: no1992);
								yourself)).
			self test > ''
				ifTrue: [ 
					self
						code:
							(((((((((self code pltPlus: '\nprocedure Start_Element(\n') pltPlus: '\tHandler : in out Xml_generic_parser;\n')
								pltPlus: '\tobj : in out ') pltPlus: ((self allrecs pltAt: no1992) nameUsingContext: self class context))
								pltPlus: '_io;\n') pltPlus: '\tNamespace_Uri : Unicode.CES.Byte_Sequence := "";\n')
								pltPlus: '\tLocal_Name : Unicode.CES.Byte_Sequence := "";\n')
								pltPlus: '\tQname : Unicode.CES.Byte_Sequence := "";\n')
								pltPlus: '\tAtts : Sax.Attributes.Attributes''Class);\n') ].
			self
				code:
					((((((((self code pltPlus: '\nprocedure End_Element(\n') pltPlus: '\tHandler : in out Xml_generic_parser;\n')
						pltPlus: '\tobj : in out ') pltPlus: ((self allrecs pltAt: no1992) nameUsingContext: self class context))
						pltPlus: '_io;\n') pltPlus: '\tNamespace_Uri : Unicode.CES.Byte_Sequence := "";\n')
						pltPlus: '\tLocal_Name : Unicode.CES.Byte_Sequence := "";\n')
						pltPlus: '\tQname : Unicode.CES.Byte_Sequence := "");\n') ]
		from:
			(PltLOINDEXFunction
				invokeFromValues:
					(OrderedCollection new
						add: self allrecs;
						yourself))
		to:
			(PltHIINDEXFunction
				invokeFromValues:
					(OrderedCollection new
						add: self allrecs;
						yourself)).
	PlatypusCoreRepeatStatement
		repeat: [ :no672 | 
			self
				code:
					((self code pltPlus: ((self allcls pltAt: no672) xmlIoRecordCodeUsingContext: self class context)) pltPlus: '\n') ]
		from:
			(PltLOINDEXFunction
				invokeFromValues:
					(OrderedCollection new
						add: self allcls;
						yourself))
		to:
			(PltHIINDEXFunction
				invokeFromValues:
					(OrderedCollection new
						add: self allcls;
						yourself)).
	self code: (self code pltPlus: '\n').
	PlatypusCoreRepeatStatement
		repeat: [ :no671 | 
			self
				code:
					(((self code pltPlus: '\nprocedure Initialize(obj : out ')
						pltPlus: ((self allcls pltAt: no671) nameUsingContext: self class context)) pltPlus: '_io);') ]
		from:
			(PltLOINDEXFunction
				invokeFromValues:
					(OrderedCollection new
						add: self allcls;
						yourself))
		to:
			(PltHIINDEXFunction
				invokeFromValues:
					(OrderedCollection new
						add: self allcls;
						yourself)).
	self code: (self code pltPlus: '\n').
	PlatypusCoreRepeatStatement
		repeat: [ :no1781 | 
			self
				test:
					(ExChdAdaEntityXmlStartElementCodeFunction
						invokeFromValues:
							(OrderedCollection new
								add: (self allcls pltAt: no1781);
								yourself)).
			self test > ''
				ifTrue: [ 
					self
						code:
							(((((((((self code pltPlus: '\nprocedure Start_Element(\n') pltPlus: '\tHandler : in out Xml_generic_parser;\n')
								pltPlus: '\tobj : in out ') pltPlus: ((self allcls pltAt: no1781) nameUsingContext: self class context))
								pltPlus: '_io;\n') pltPlus: '\tNamespace_Uri : Unicode.CES.Byte_Sequence := "";\n')
								pltPlus: '\tLocal_Name : Unicode.CES.Byte_Sequence := "";\n')
								pltPlus: '\tQname : Unicode.CES.Byte_Sequence := "";\n')
								pltPlus: '\tAtts : Sax.Attributes.Attributes''Class);\n') ].
			self
				code:
					((((((((self code pltPlus: '\nprocedure End_Element(\n') pltPlus: '\tHandler : in out Xml_generic_parser;\n')
						pltPlus: '\tobj : in out ') pltPlus: ((self allcls pltAt: no1781) nameUsingContext: self class context))
						pltPlus: '_io;\n') pltPlus: '\tNamespace_Uri : Unicode.CES.Byte_Sequence := "";\n')
						pltPlus: '\tLocal_Name : Unicode.CES.Byte_Sequence := "";\n')
						pltPlus: '\tQname : Unicode.CES.Byte_Sequence := "");\n') ]
		from:
			(PltLOINDEXFunction
				invokeFromValues:
					(OrderedCollection new
						add: self allcls;
						yourself))
		to:
			(PltHIINDEXFunction
				invokeFromValues:
					(OrderedCollection new
						add: self allcls;
						yourself)).
	self code: (self code pltPlus: '\n\nend xml_architecture_io;\n').
	^ self return: self code

! !

!ExChdXmlArchitectureIoAdsPackageCodeFunction methodsFor: 'platypus-generated-accessing' stamp: ''!
pkgs
	^ pkgs

! !

!ExChdXmlArchitectureIoAdsPackageCodeFunction methodsFor: 'platypus-generated-accessing' stamp: ''!
pkgs: aListOfExChdAdaPackage
	pkgs := aListOfExChdAdaPackage
		ifNil: [ OrderedCollection new ]
		ifNotNil: [ aListOfExChdAdaPackage as: OrderedCollection ]

! !

!ExChdXmlArchitectureIoAdsPackageCodeFunction methodsFor: 'platypus-generated-accessing' stamp: ''!
test
	^ test

! !

!ExChdXmlArchitectureIoAdsPackageCodeFunction methodsFor: 'platypus-generated-accessing' stamp: ''!
test: aString
	test := aString

! !

PlatypusCoreAlgorithmDeclaration subclass: #ExChdXmlPackagesFunction
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Express2Cheddar-CheddarDtdSchema'!

!ExChdXmlPackagesFunction commentStamp: 'platypus comment' prior: 0!
<ISO10303-11-EXPRESS>
FUNCTION xml_packages : LIST OF ada_package;
	RETURN ( QUERY ( p <* SetToList ( all_ada_packages ( ) ) | SIZEOF ( p.xml_root_tags ) > 0 ) );
END_FUNCTION;
</ISO10303-11-EXPRESS>!

!ExChdXmlPackagesFunction class methodsFor: 'platypus-generated-platypus-signature' stamp: ''!
iso10303P11Translater
	^ 'Platypus (c) LISYC EA3883, Universite de Bretagne occidentale. Brest.'

! !

!ExChdXmlPackagesFunction class methodsFor: 'platypus-generated-meta-data-accessing' stamp: ''!
schemaDefinition
	^ ExChdCheddarDtdSchemaDefinition singleton

! !

!ExChdXmlPackagesFunction class methodsFor: 'platypus-generated-platypus-signature' stamp: ''!
translatedFromISO10303P11
	^ true

! !

!ExChdXmlPackagesFunction class methodsFor: 'platypus-generated-platypus-signature' stamp: ''!
vwNamespaceName
	^ #Express2Cheddar

! !

!ExChdXmlPackagesFunction methodsFor: 'platypus-generated-invoking' stamp: ''!
invoke
	" ---------- locals assignments ----------"

	" ---------- statements ----------"

	^ self
		return:
			((PTsSetToListFunction
				invokeFromValues:
					(OrderedCollection new
						add: ExChdAllAdaPackagesFunction invoke;
						yourself))
				select: [ :p3477 | 
					(PltSIZEOFFunction
						invokeFromValues:
							(OrderedCollection new
								add: (p3477 xmlRootTagsUsingContext: self class context);
								yourself)) > 0 ])

! !

PlatypusCoreAlgorithmDeclaration subclass: #ExChdXmlPackagesWithTagFunction
	instanceVariableNames: 'tag'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Express2Cheddar-CheddarDtdSchema'!

!ExChdXmlPackagesWithTagFunction commentStamp: 'platypus comment' prior: 0!
<ISO10303-11-EXPRESS>
FUNCTION xml_packages_with_tag ( tag : STRING ) : LIST OF ada_package;
	RETURN ( QUERY ( p <* xml_packages ( ) | tag IN p.xml_root_tags ) );
END_FUNCTION;
</ISO10303-11-EXPRESS>!

!ExChdXmlPackagesWithTagFunction class methodsFor: 'platypus-generated-platypus-signature' stamp: ''!
iso10303P11Translater
	^ 'Platypus (c) LISYC EA3883, Universite de Bretagne occidentale. Brest.'

! !

!ExChdXmlPackagesWithTagFunction class methodsFor: 'platypus-generated-meta-data-accessing' stamp: ''!
schemaDefinition
	^ ExChdCheddarDtdSchemaDefinition singleton

! !

!ExChdXmlPackagesWithTagFunction class methodsFor: 'platypus-generated-platypus-signature' stamp: ''!
translatedFromISO10303P11
	^ true

! !

!ExChdXmlPackagesWithTagFunction class methodsFor: 'platypus-generated-platypus-signature' stamp: ''!
vwNamespaceName
	^ #Express2Cheddar

! !

!ExChdXmlPackagesWithTagFunction methodsFor: 'platypus-generated-accessing' stamp: ''!
fromValues: values
	self tag: (values at: 1)

! !

!ExChdXmlPackagesWithTagFunction methodsFor: 'platypus-generated-invoking' stamp: ''!
invoke
	" ---------- locals assignments ----------"

	" ---------- statements ----------"

	^ self
		return:
			(ExChdXmlPackagesFunction invoke
				select: [ :p1855 | (p1855 xmlRootTagsUsingContext: self class context) includes: self tag ])

! !

!ExChdXmlPackagesWithTagFunction methodsFor: 'platypus-generated-accessing' stamp: ''!
tag
	^ tag

! !

!ExChdXmlPackagesWithTagFunction methodsFor: 'platypus-generated-accessing' stamp: ''!
tag: aString
	tag := aString

! !

PltDefinedType subclass: #ExChdAdaType
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Express2Cheddar-CheddarDomainsSchema'!

!ExChdAdaType commentStamp: 'platypus comment' prior: 0!
<ISO10303-11-EXPRESS>
ENTITY ada_type 
	SUBTYPE OF ( defined_type );
DERIVE
	ada_ident : STRING := name;
	ada_ref_ident : STRING := name;
	init_value : STRING := ?;
	dependencies : LIST OF dictionary_instance := dependencies_of ( SELF.owner, SELF.domain.handled );
	refed_by_pointer : BOOLEAN := false;
END_ENTITY;
</ISO10303-11-EXPRESS>!

ExChdAdaType subclass: #ExChdAdaEnumeration
	instanceVariableNames: 'convertion'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Express2Cheddar-CheddarDomainsSchema'!

!ExChdAdaEnumeration commentStamp: 'platypus comment' prior: 0!
<ISO10303-11-EXPRESS>
ENTITY ada_enumeration 
	SUBTYPE OF ( ada_type );
	convertion : OPTIONAL STRING;
DERIVE
	ads_interfaces_list : LIST OF ada_interface := [ ada_interface ( 'Convert_Strings', ?, true, false ), ada_interface ( 'Convert_Unbounded_Strings', ?, true, false ), ada_interface ( 'text_io', ?, true, true ), ada_interface ( 'ada.strings', 'unbounded', true, true ) ];
	adb_interfaces_list : LIST OF ada_interface := [ ada_interface ( 'primitive_xml_strings', ?, true, true ) ];
	ads_code : STRING := enumeration_ads_code ( SELF );
	adb_code : STRING := enumeration_adb_code ( SELF );
	SELF\ada_type.ada_ident : STRING := name;
	SELF\ada_type.ada_ref_ident : STRING := SELF.ada_ident;
	SELF\ada_type.init_value : STRING := NVL ( convertion, domain.elements [ 1 ] );
	io_type_name : STRING := SELF.ada_ident + '_io';
	full_io_type_name : STRING := SELF.owner.name + '.' + SELF.io_type_name;
	SELF\defined_type.accepted : entity_instance := SELF.accept_ada_enumeration;
END_ENTITY;
</ISO10303-11-EXPRESS>!

!ExChdAdaEnumeration class methodsFor: 'platypus-generated-platypus-signature' stamp: ''!
iso10303P11Translater
	^ 'Platypus (c) LISYC EA3883, Universite de Bretagne occidentale. Brest.'

! !

!ExChdAdaEnumeration class methodsFor: 'platypus-generated-meta-data-accessing' stamp: ''!
schemaDefinition
	^ ExChdCheddarDomainsSchemaDefinition singleton

! !

!ExChdAdaEnumeration class methodsFor: 'platypus-generated-meta-data-accessing' stamp: ''!
schemaInstance
	^ ExChdExpress2cheddarSchemaInstance singleton

! !

!ExChdAdaEnumeration class methodsFor: 'platypus-generated-platypus-signature' stamp: ''!
translatedFromISO10303P11
	^ true

! !

!ExChdAdaEnumeration class methodsFor: 'platypus-generated-platypus-signature' stamp: ''!
vwNamespaceName
	^ #Express2Cheddar

! !

!ExChdAdaEnumeration methodsFor: 'platypus-generated-visiting' stamp: ''!
accept: aVisitor
	^ aVisitor acceptAdaEnumeration: self

! !

!ExChdAdaEnumeration methodsFor: 'platypus-generated-deriving' stamp: ''!
accepted
	^ self acceptedUsingContext: self class context

! !

!ExChdAdaEnumeration methodsFor: 'platypus-generated-deriving' stamp: ''!
acceptedUsingContext: aContext
	^ self acceptedUsingContext: aContext receiver: self

! !

!ExChdAdaEnumeration methodsFor: 'platypus-generated-deriving' stamp: ''!
acceptedUsingContext: aContext receiver: aReceiver
	^ aReceiver acceptAdaEnumerationUsingContext: aContext

! !

!ExChdAdaEnumeration methodsFor: 'platypus-generated-copying' stamp: ''!
adaEnumerationCopyTo: another
	another fastSetConvertion: self convertion

! !

!ExChdAdaEnumeration methodsFor: 'platypus-generated-group-accessing' stamp: ''!
adaEnumerationFromValues: values
	| valuesloc |
	valuesloc := values asOrderedCollection.
	self setConvertion: valuesloc removeFirst.
	^ valuesloc

! !

!ExChdAdaEnumeration methodsFor: 'platypus-generated-group-accessing' stamp: ''!
adaEnumerationToValues: values
	values add: self convertion.
	^ values

! !

!ExChdAdaEnumeration methodsFor: 'platypus-generated-deriving' stamp: ''!
adaIdent
	^ self adaIdentUsingContext: self class context

! !

!ExChdAdaEnumeration methodsFor: 'platypus-generated-deriving' stamp: ''!
adaIdentUsingContext: aContext
	^ self adaIdentUsingContext: aContext receiver: self

! !

!ExChdAdaEnumeration methodsFor: 'platypus-generated-deriving' stamp: ''!
adaIdentUsingContext: aContext receiver: aReceiver
	^ aReceiver name

! !

!ExChdAdaEnumeration methodsFor: 'platypus-generated-deriving' stamp: ''!
adaRefIdent
	^ self adaRefIdentUsingContext: self class context

! !

!ExChdAdaEnumeration methodsFor: 'platypus-generated-deriving' stamp: ''!
adaRefIdentUsingContext: aContext
	^ self adaRefIdentUsingContext: aContext receiver: self

! !

!ExChdAdaEnumeration methodsFor: 'platypus-generated-deriving' stamp: ''!
adaRefIdentUsingContext: aContext receiver: aReceiver
	^ aReceiver adaIdentUsingContext: aContext

! !

!ExChdAdaEnumeration methodsFor: 'platypus-generated-deriving' stamp: ''!
adbCode
	^ self adbCodeUsingContext: self class context

! !

!ExChdAdaEnumeration methodsFor: 'platypus-generated-deriving' stamp: ''!
adbCodeUsingContext: aContext
	^ self adbCodeUsingContext: aContext receiver: self

! !

!ExChdAdaEnumeration methodsFor: 'platypus-generated-deriving' stamp: ''!
adbCodeUsingContext: aContext receiver: aReceiver
	^ ExChdEnumerationAdbCodeFunction
		invokeFromValues:
			(OrderedCollection new
				add: aReceiver;
				yourself)

! !

!ExChdAdaEnumeration methodsFor: 'platypus-generated-deriving' stamp: ''!
adbInterfacesList
	^ self adbInterfacesListUsingContext: self class context

! !

!ExChdAdaEnumeration methodsFor: 'platypus-generated-deriving' stamp: ''!
adbInterfacesListUsingContext: aContext
	^ self adbInterfacesListUsingContext: aContext receiver: self

! !

!ExChdAdaEnumeration methodsFor: 'platypus-generated-deriving' stamp: ''!
adbInterfacesListUsingContext: aContext receiver: aReceiver
	^ PlatypusCoreAggregateInitializer
		collectionFrom:
			(OrderedCollection new
				add:
						(ExChdAdaInterface new
								adaInterfaceFromValues:
										(OrderedCollection new
												add: 'primitive_xml_strings';
												add: nil;
												add: true;
												add: true;
												yourself);
								yourself);
				yourself)

! !

!ExChdAdaEnumeration methodsFor: 'platypus-generated-deriving' stamp: ''!
adsCode
	^ self adsCodeUsingContext: self class context

! !

!ExChdAdaEnumeration methodsFor: 'platypus-generated-deriving' stamp: ''!
adsCodeUsingContext: aContext
	^ self adsCodeUsingContext: aContext receiver: self

! !

!ExChdAdaEnumeration methodsFor: 'platypus-generated-deriving' stamp: ''!
adsCodeUsingContext: aContext receiver: aReceiver
	^ ExChdEnumerationAdsCodeFunction
		invokeFromValues:
			(OrderedCollection new
				add: aReceiver;
				yourself)

! !

!ExChdAdaEnumeration methodsFor: 'platypus-generated-deriving' stamp: ''!
adsInterfacesList
	^ self adsInterfacesListUsingContext: self class context

! !

!ExChdAdaEnumeration methodsFor: 'platypus-generated-deriving' stamp: ''!
adsInterfacesListUsingContext: aContext
	^ self adsInterfacesListUsingContext: aContext receiver: self

! !

!ExChdAdaEnumeration methodsFor: 'platypus-generated-deriving' stamp: ''!
adsInterfacesListUsingContext: aContext receiver: aReceiver
	^ PlatypusCoreAggregateInitializer
		collectionFrom:
			(OrderedCollection new
				add:
						(ExChdAdaInterface new
								adaInterfaceFromValues:
										(OrderedCollection new
												add: 'Convert_Strings';
												add: nil;
												add: true;
												add: false;
												yourself);
								yourself);
				add:
						(ExChdAdaInterface new
								adaInterfaceFromValues:
										(OrderedCollection new
												add: 'Convert_Unbounded_Strings';
												add: nil;
												add: true;
												add: false;
												yourself);
								yourself);
				add:
						(ExChdAdaInterface new
								adaInterfaceFromValues:
										(OrderedCollection new
												add: 'text_io';
												add: nil;
												add: true;
												add: true;
												yourself);
								yourself);
				add:
						(ExChdAdaInterface new
								adaInterfaceFromValues:
										(OrderedCollection new
												add: 'ada.strings';
												add: 'unbounded';
												add: true;
												add: true;
												yourself);
								yourself);
				yourself)

! !

!ExChdAdaEnumeration methodsFor: 'platypus-generated-accessing' stamp: ''!
convertion
	^ convertion

! !

!ExChdAdaEnumeration methodsFor: 'platypus-generated-accessing' stamp: ''!
convertion: aString
	convertion := aString

! !

!ExChdAdaEnumeration methodsFor: 'platypus-generated-with-context-accessing' stamp: ''!
convertionUsingContext: aContext
	^ self convertion

! !

!ExChdAdaEnumeration methodsFor: 'platypus-generated-fast-set-accessing' stamp: ''!
fastSetConvertion: aString
	convertion := aString

! !

!ExChdAdaEnumeration methodsFor: 'platypus-generated-group-accessing' stamp: ''!
fromValues: values
	^ self adaEnumerationFromValues: (super fromValues: values)

! !

!ExChdAdaEnumeration methodsFor: 'platypus-generated-deriving' stamp: ''!
fullIoTypeName
	^ self fullIoTypeNameUsingContext: self class context

! !

!ExChdAdaEnumeration methodsFor: 'platypus-generated-deriving' stamp: ''!
fullIoTypeNameUsingContext: aContext
	^ self fullIoTypeNameUsingContext: aContext receiver: self

! !

!ExChdAdaEnumeration methodsFor: 'platypus-generated-deriving' stamp: ''!
fullIoTypeNameUsingContext: aContext receiver: aReceiver
	^ (((aReceiver ownerUsingContext: aContext) nameUsingContext: aContext) pltPlus: '.')
		pltPlus: (aReceiver ioTypeNameUsingContext: aContext)

! !

!ExChdAdaEnumeration methodsFor: 'platypus-generated-deriving' stamp: ''!
initValue
	^ self initValueUsingContext: self class context

! !

!ExChdAdaEnumeration methodsFor: 'platypus-generated-deriving' stamp: ''!
initValueUsingContext: aContext
	^ self initValueUsingContext: aContext receiver: self

! !

!ExChdAdaEnumeration methodsFor: 'platypus-generated-deriving' stamp: ''!
initValueUsingContext: aContext receiver: aReceiver
	^ PltNVLFunction
		invokeFromValues:
			(OrderedCollection new
				add: aReceiver convertion;
				add: ((aReceiver domain elementsUsingContext: self class context) pltAt: 1);
				yourself)

! !

!ExChdAdaEnumeration methodsFor: 'platypus-generated-deriving' stamp: ''!
ioTypeName
	^ self ioTypeNameUsingContext: self class context

! !

!ExChdAdaEnumeration methodsFor: 'platypus-generated-deriving' stamp: ''!
ioTypeNameUsingContext: aContext
	^ self ioTypeNameUsingContext: aContext receiver: self

! !

!ExChdAdaEnumeration methodsFor: 'platypus-generated-deriving' stamp: ''!
ioTypeNameUsingContext: aContext receiver: aReceiver
	^ (aReceiver adaIdentUsingContext: aContext) pltPlus: '_io'

! !

!ExChdAdaEnumeration methodsFor: 'platypus-generated-classifying' stamp: ''!
isExChdAdaEnumeration
	^ true

! !

!ExChdAdaEnumeration methodsFor: 'platypus-generated-group-accessing' stamp: ''!
localFromValues: values
	^ self adaEnumerationFromValues: values

! !

!ExChdAdaEnumeration methodsFor: 'platypus-generated-group-accessing' stamp: ''!
localToValues: values
	^ self adaEnumerationToValues: values

! !

!ExChdAdaEnumeration methodsFor: 'platypus-generated-copying' stamp: ''!
pltCopyGroup: aClassSymbol to: anObject
	self class name == aClassSymbol
		ifTrue: [ self pltCopyTo: anObject ]
		ifFalse: [ super pltCopyGroup: aClassSymbol to: anObject ]

! !

!ExChdAdaEnumeration methodsFor: 'platypus-generated-copying' stamp: ''!
pltCopyTo: another
	super pltCopyTo: another.
	self adaEnumerationCopyTo: another

! !

!ExChdAdaEnumeration methodsFor: 'platypus-generated-copying' stamp: ''!
pltLocalCopyTo: another
	self adaEnumerationCopyTo: another

! !

!ExChdAdaEnumeration methodsFor: 'platypus-generated-set-accessing' stamp: ''!
setConvertion: aString
	self convertion: aString

! !

!ExChdAdaEnumeration methodsFor: 'platypus-generated-initializing' stamp: ''!
stepInitialize
	super stepInitialize.
	convertion := nil

! !

!ExChdAdaEnumeration methodsFor: 'platypus-generated-group-accessing' stamp: ''!
toValues: values
	^ self adaEnumerationToValues: (super toValues: values)

! !

!ExChdAdaType class methodsFor: 'platypus-generated-platypus-signature' stamp: ''!
iso10303P11Translater
	^ 'Platypus (c) LISYC EA3883, Universite de Bretagne occidentale. Brest.'

! !

!ExChdAdaType class methodsFor: 'platypus-generated-meta-data-accessing' stamp: ''!
schemaDefinition
	^ ExChdCheddarDomainsSchemaDefinition singleton

! !

!ExChdAdaType class methodsFor: 'platypus-generated-meta-data-accessing' stamp: ''!
schemaInstance
	^ ExChdExpress2cheddarSchemaInstance singleton

! !

!ExChdAdaType class methodsFor: 'platypus-generated-platypus-signature' stamp: ''!
translatedFromISO10303P11
	^ true

! !

!ExChdAdaType class methodsFor: 'platypus-generated-platypus-signature' stamp: ''!
vwNamespaceName
	^ #Express2Cheddar

! !

!ExChdAdaType methodsFor: 'platypus-generated-visiting' stamp: ''!
accept: aVisitor
	^ aVisitor acceptAdaType: self

! !

!ExChdAdaType methodsFor: 'platypus-generated-deriving' stamp: ''!
adaIdent
	^ self adaIdentUsingContext: self class context

! !

!ExChdAdaType methodsFor: 'platypus-generated-deriving' stamp: ''!
adaIdentUsingContext: aContext
	^ self adaIdentUsingContext: aContext receiver: self

! !

!ExChdAdaType methodsFor: 'platypus-generated-deriving' stamp: ''!
adaIdentUsingContext: aContext receiver: aReceiver
	^ aReceiver name

! !

!ExChdAdaType methodsFor: 'platypus-generated-deriving' stamp: ''!
adaRefIdent
	^ self adaRefIdentUsingContext: self class context

! !

!ExChdAdaType methodsFor: 'platypus-generated-deriving' stamp: ''!
adaRefIdentUsingContext: aContext
	^ self adaRefIdentUsingContext: aContext receiver: self

! !

!ExChdAdaType methodsFor: 'platypus-generated-deriving' stamp: ''!
adaRefIdentUsingContext: aContext receiver: aReceiver
	^ aReceiver name

! !

!ExChdAdaType methodsFor: 'platypus-generated-copying' stamp: ''!
adaTypeCopyTo: another
	

! !

!ExChdAdaType methodsFor: 'platypus-generated-group-accessing' stamp: ''!
adaTypeFromValues: values
	| valuesloc |
	valuesloc := values asOrderedCollection.
	^ valuesloc

! !

!ExChdAdaType methodsFor: 'platypus-generated-group-accessing' stamp: ''!
adaTypeToValues: values
	^ values

! !

!ExChdAdaType methodsFor: 'platypus-generated-deriving' stamp: ''!
dependencies
	^ self dependenciesUsingContext: self class context

! !

!ExChdAdaType methodsFor: 'platypus-generated-deriving' stamp: ''!
dependenciesUsingContext: aContext
	^ self dependenciesUsingContext: aContext receiver: self

! !

!ExChdAdaType methodsFor: 'platypus-generated-deriving' stamp: ''!
dependenciesUsingContext: aContext receiver: aReceiver
	^ ExChdDependenciesOfFunction
		invokeFromValues:
			(OrderedCollection new
				add: (aReceiver ownerUsingContext: self class context);
				add: ((aReceiver domainUsingContext: self class context) handledUsingContext: self class context);
				yourself)

! !

!ExChdAdaType methodsFor: 'platypus-generated-group-accessing' stamp: ''!
fromValues: values
	^ self adaTypeFromValues: (super fromValues: values)

! !

!ExChdAdaType methodsFor: 'platypus-generated-deriving' stamp: ''!
initValue
	^ self initValueUsingContext: self class context

! !

!ExChdAdaType methodsFor: 'platypus-generated-deriving' stamp: ''!
initValueUsingContext: aContext
	^ self initValueUsingContext: aContext receiver: self

! !

!ExChdAdaType methodsFor: 'platypus-generated-deriving' stamp: ''!
initValueUsingContext: aContext receiver: aReceiver
	^ nil

! !

!ExChdAdaType methodsFor: 'platypus-generated-classifying' stamp: ''!
isExChdAdaType
	^ true

! !

!ExChdAdaType methodsFor: 'platypus-generated-group-accessing' stamp: ''!
localFromValues: values
	^ self adaTypeFromValues: values

! !

!ExChdAdaType methodsFor: 'platypus-generated-group-accessing' stamp: ''!
localToValues: values
	^ self adaTypeToValues: values

! !

!ExChdAdaType methodsFor: 'platypus-generated-copying' stamp: ''!
pltCopyGroup: aClassSymbol to: anObject
	self class name == aClassSymbol
		ifTrue: [ self pltCopyTo: anObject ]
		ifFalse: [ super pltCopyGroup: aClassSymbol to: anObject ]

! !

!ExChdAdaType methodsFor: 'platypus-generated-copying' stamp: ''!
pltCopyTo: another
	super pltCopyTo: another.
	self adaTypeCopyTo: another

! !

!ExChdAdaType methodsFor: 'platypus-generated-copying' stamp: ''!
pltLocalCopyTo: another
	self adaTypeCopyTo: another

! !

!ExChdAdaType methodsFor: 'platypus-generated-deriving' stamp: ''!
refedByPointer
	^ self refedByPointerUsingContext: self class context

! !

!ExChdAdaType methodsFor: 'platypus-generated-deriving' stamp: ''!
refedByPointerUsingContext: aContext
	^ self refedByPointerUsingContext: aContext receiver: self

! !

!ExChdAdaType methodsFor: 'platypus-generated-deriving' stamp: ''!
refedByPointerUsingContext: aContext receiver: aReceiver
	^ false

! !

!ExChdAdaType methodsFor: 'platypus-generated-initializing' stamp: ''!
stepInitialize
	super stepInitialize

! !

!ExChdAdaType methodsFor: 'platypus-generated-group-accessing' stamp: ''!
toValues: values
	^ self adaTypeToValues: (super toValues: values)

! !

ExChdAdaType subclass: #ExChdCheddarDefinedType
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Express2Cheddar-CheddarDomainsSchema'!

!ExChdCheddarDefinedType commentStamp: 'platypus comment' prior: 0!
<ISO10303-11-EXPRESS>
ENTITY cheddar_defined_type 
	SUBTYPE OF ( ada_type );
DERIVE
	ads_interface_list : LIST OF ada_interface := cheddar_defined_type_interfaces_list ( SELF, true );
	adb_interface_list : LIST OF ada_interface := cheddar_defined_type_interfaces_list ( SELF, false );
	SELF\defined_type.accepted : entity_instance := SELF.accept_cheddar_defined_type;
END_ENTITY;
</ISO10303-11-EXPRESS>!

!ExChdCheddarDefinedType class methodsFor: 'platypus-generated-platypus-signature' stamp: ''!
iso10303P11Translater
	^ 'Platypus (c) LISYC EA3883, Universite de Bretagne occidentale. Brest.'

! !

!ExChdCheddarDefinedType class methodsFor: 'platypus-generated-meta-data-accessing' stamp: ''!
schemaDefinition
	^ ExChdCheddarDomainsSchemaDefinition singleton

! !

!ExChdCheddarDefinedType class methodsFor: 'platypus-generated-meta-data-accessing' stamp: ''!
schemaInstance
	^ ExChdExpress2cheddarSchemaInstance singleton

! !

!ExChdCheddarDefinedType class methodsFor: 'platypus-generated-platypus-signature' stamp: ''!
translatedFromISO10303P11
	^ true

! !

!ExChdCheddarDefinedType class methodsFor: 'platypus-generated-platypus-signature' stamp: ''!
vwNamespaceName
	^ #Express2Cheddar

! !

!ExChdCheddarDefinedType methodsFor: 'platypus-generated-visiting' stamp: ''!
accept: aVisitor
	^ aVisitor acceptCheddarDefinedType: self

! !

!ExChdCheddarDefinedType methodsFor: 'platypus-generated-deriving' stamp: ''!
accepted
	^ self acceptedUsingContext: self class context

! !

!ExChdCheddarDefinedType methodsFor: 'platypus-generated-deriving' stamp: ''!
acceptedUsingContext: aContext
	^ self acceptedUsingContext: aContext receiver: self

! !

!ExChdCheddarDefinedType methodsFor: 'platypus-generated-deriving' stamp: ''!
acceptedUsingContext: aContext receiver: aReceiver
	^ aReceiver acceptCheddarDefinedTypeUsingContext: aContext

! !

!ExChdCheddarDefinedType methodsFor: 'platypus-generated-deriving' stamp: ''!
adbInterfaceList
	^ self adbInterfaceListUsingContext: self class context

! !

!ExChdCheddarDefinedType methodsFor: 'platypus-generated-deriving' stamp: ''!
adbInterfaceListUsingContext: aContext
	^ self adbInterfaceListUsingContext: aContext receiver: self

! !

!ExChdCheddarDefinedType methodsFor: 'platypus-generated-deriving' stamp: ''!
adbInterfaceListUsingContext: aContext receiver: aReceiver
	^ ExChdCheddarDefinedTypeInterfacesListFunction
		invokeFromValues:
			(OrderedCollection new
				add: aReceiver;
				add: false;
				yourself)

! !

!ExChdCheddarDefinedType methodsFor: 'platypus-generated-deriving' stamp: ''!
adsInterfaceList
	^ self adsInterfaceListUsingContext: self class context

! !

!ExChdCheddarDefinedType methodsFor: 'platypus-generated-deriving' stamp: ''!
adsInterfaceListUsingContext: aContext
	^ self adsInterfaceListUsingContext: aContext receiver: self

! !

!ExChdCheddarDefinedType methodsFor: 'platypus-generated-deriving' stamp: ''!
adsInterfaceListUsingContext: aContext receiver: aReceiver
	^ ExChdCheddarDefinedTypeInterfacesListFunction
		invokeFromValues:
			(OrderedCollection new
				add: aReceiver;
				add: true;
				yourself)

! !

!ExChdCheddarDefinedType methodsFor: 'platypus-generated-copying' stamp: ''!
cheddarDefinedTypeCopyTo: another
	

! !

!ExChdCheddarDefinedType methodsFor: 'platypus-generated-group-accessing' stamp: ''!
cheddarDefinedTypeFromValues: values
	| valuesloc |
	valuesloc := values asOrderedCollection.
	^ valuesloc

! !

!ExChdCheddarDefinedType methodsFor: 'platypus-generated-group-accessing' stamp: ''!
cheddarDefinedTypeToValues: values
	^ values

! !

!ExChdCheddarDefinedType methodsFor: 'platypus-generated-group-accessing' stamp: ''!
fromValues: values
	^ self cheddarDefinedTypeFromValues: (super fromValues: values)

! !

!ExChdCheddarDefinedType methodsFor: 'platypus-generated-classifying' stamp: ''!
isExChdCheddarDefinedType
	^ true

! !

!ExChdCheddarDefinedType methodsFor: 'platypus-generated-group-accessing' stamp: ''!
localFromValues: values
	^ self cheddarDefinedTypeFromValues: values

! !

!ExChdCheddarDefinedType methodsFor: 'platypus-generated-group-accessing' stamp: ''!
localToValues: values
	^ self cheddarDefinedTypeToValues: values

! !

!ExChdCheddarDefinedType methodsFor: 'platypus-generated-copying' stamp: ''!
pltCopyGroup: aClassSymbol to: anObject
	self class name == aClassSymbol
		ifTrue: [ self pltCopyTo: anObject ]
		ifFalse: [ super pltCopyGroup: aClassSymbol to: anObject ]

! !

!ExChdCheddarDefinedType methodsFor: 'platypus-generated-copying' stamp: ''!
pltCopyTo: another
	super pltCopyTo: another.
	self cheddarDefinedTypeCopyTo: another

! !

!ExChdCheddarDefinedType methodsFor: 'platypus-generated-copying' stamp: ''!
pltLocalCopyTo: another
	self cheddarDefinedTypeCopyTo: another

! !

!ExChdCheddarDefinedType methodsFor: 'platypus-generated-initializing' stamp: ''!
stepInitialize
	super stepInitialize

! !

!ExChdCheddarDefinedType methodsFor: 'platypus-generated-group-accessing' stamp: ''!
toValues: values
	^ self cheddarDefinedTypeToValues: (super toValues: values)

! !

ExChdCheddarDefinedType subclass: #ExChdCheddarPriorityRange
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Express2Cheddar-CheddarDomainsSchema'!

!ExChdCheddarPriorityRange commentStamp: 'platypus comment' prior: 0!
<ISO10303-11-EXPRESS>
ENTITY cheddar_priority_range 
	SUBTYPE OF ( cheddar_defined_type );
DERIVE
	ads_code : STRING := '
-- Definition of priority range. We choose the most current value :
-- 256 priority levels (from 0 to 255)
-- Zero is the lowest priority level
Type Priority_Range is new Natural range 0 .. 255;
package Priority_Io is new Text_IO.Integer_IO (Priority_Range);
use Priority_Io;
';
	adb_code : STRING := '';
	ads_interfaces_list : LIST OF ada_interface := [ ada_interface ( 'Framework_Config', ?, true, true ), ada_interface ( 'Framework_Config', 'Priority_Io', false, true ) ];
	adb_interfaces_list : LIST OF ada_interface := [ ];
	SELF\ada_type.ada_ident : STRING := 'Priority_Range';
	SELF\ada_type.ada_ref_ident : STRING := SELF.ada_ident;
	SELF\ada_type.init_value : STRING := '0';
END_ENTITY;
</ISO10303-11-EXPRESS>!

!ExChdCheddarPriorityRange class methodsFor: 'platypus-generated-platypus-signature' stamp: ''!
iso10303P11Translater
	^ 'Platypus (c) LISYC EA3883, Universite de Bretagne occidentale. Brest.'

! !

!ExChdCheddarPriorityRange class methodsFor: 'platypus-generated-meta-data-accessing' stamp: ''!
schemaDefinition
	^ ExChdCheddarDomainsSchemaDefinition singleton

! !

!ExChdCheddarPriorityRange class methodsFor: 'platypus-generated-meta-data-accessing' stamp: ''!
schemaInstance
	^ ExChdExpress2cheddarSchemaInstance singleton

! !

!ExChdCheddarPriorityRange class methodsFor: 'platypus-generated-platypus-signature' stamp: ''!
translatedFromISO10303P11
	^ true

! !

!ExChdCheddarPriorityRange class methodsFor: 'platypus-generated-platypus-signature' stamp: ''!
vwNamespaceName
	^ #Express2Cheddar

! !

!ExChdCheddarPriorityRange methodsFor: 'platypus-generated-visiting' stamp: ''!
accept: aVisitor
	^ aVisitor acceptCheddarPriorityRange: self

! !

!ExChdCheddarPriorityRange methodsFor: 'platypus-generated-deriving' stamp: ''!
adaIdent
	^ self adaIdentUsingContext: self class context

! !

!ExChdCheddarPriorityRange methodsFor: 'platypus-generated-deriving' stamp: ''!
adaIdentUsingContext: aContext
	^ self adaIdentUsingContext: aContext receiver: self

! !

!ExChdCheddarPriorityRange methodsFor: 'platypus-generated-deriving' stamp: ''!
adaIdentUsingContext: aContext receiver: aReceiver
	^ 'Priority_Range'

! !

!ExChdCheddarPriorityRange methodsFor: 'platypus-generated-deriving' stamp: ''!
adaRefIdent
	^ self adaRefIdentUsingContext: self class context

! !

!ExChdCheddarPriorityRange methodsFor: 'platypus-generated-deriving' stamp: ''!
adaRefIdentUsingContext: aContext
	^ self adaRefIdentUsingContext: aContext receiver: self

! !

!ExChdCheddarPriorityRange methodsFor: 'platypus-generated-deriving' stamp: ''!
adaRefIdentUsingContext: aContext receiver: aReceiver
	^ aReceiver adaIdentUsingContext: aContext

! !

!ExChdCheddarPriorityRange methodsFor: 'platypus-generated-deriving' stamp: ''!
adbCode
	^ self adbCodeUsingContext: self class context

! !

!ExChdCheddarPriorityRange methodsFor: 'platypus-generated-deriving' stamp: ''!
adbCodeUsingContext: aContext
	^ self adbCodeUsingContext: aContext receiver: self

! !

!ExChdCheddarPriorityRange methodsFor: 'platypus-generated-deriving' stamp: ''!
adbCodeUsingContext: aContext receiver: aReceiver
	^ ''

! !

!ExChdCheddarPriorityRange methodsFor: 'platypus-generated-deriving' stamp: ''!
adbInterfacesList
	^ self adbInterfacesListUsingContext: self class context

! !

!ExChdCheddarPriorityRange methodsFor: 'platypus-generated-deriving' stamp: ''!
adbInterfacesListUsingContext: aContext
	^ self adbInterfacesListUsingContext: aContext receiver: self

! !

!ExChdCheddarPriorityRange methodsFor: 'platypus-generated-deriving' stamp: ''!
adbInterfacesListUsingContext: aContext receiver: aReceiver
	^ Array new

! !

!ExChdCheddarPriorityRange methodsFor: 'platypus-generated-deriving' stamp: ''!
adsCode
	^ self adsCodeUsingContext: self class context

! !

!ExChdCheddarPriorityRange methodsFor: 'platypus-generated-deriving' stamp: ''!
adsCodeUsingContext: aContext
	^ self adsCodeUsingContext: aContext receiver: self

! !

!ExChdCheddarPriorityRange methodsFor: 'platypus-generated-deriving' stamp: ''!
adsCodeUsingContext: aContext receiver: aReceiver
	^ '
-- Definition of priority range. We choose the most current value :
-- 256 priority levels (from 0 to 255)
-- Zero is the lowest priority level
Type Priority_Range is new Natural range 0 .. 255;
package Priority_Io is new Text_IO.Integer_IO (Priority_Range);
use Priority_Io;
'

! !

!ExChdCheddarPriorityRange methodsFor: 'platypus-generated-deriving' stamp: ''!
adsInterfacesList
	^ self adsInterfacesListUsingContext: self class context

! !

!ExChdCheddarPriorityRange methodsFor: 'platypus-generated-deriving' stamp: ''!
adsInterfacesListUsingContext: aContext
	^ self adsInterfacesListUsingContext: aContext receiver: self

! !

!ExChdCheddarPriorityRange methodsFor: 'platypus-generated-deriving' stamp: ''!
adsInterfacesListUsingContext: aContext receiver: aReceiver
	^ PlatypusCoreAggregateInitializer
		collectionFrom:
			(OrderedCollection new
				add:
						(ExChdAdaInterface new
								adaInterfaceFromValues:
										(OrderedCollection new
												add: 'Framework_Config';
												add: nil;
												add: true;
												add: true;
												yourself);
								yourself);
				add:
						(ExChdAdaInterface new
								adaInterfaceFromValues:
										(OrderedCollection new
												add: 'Framework_Config';
												add: 'Priority_Io';
												add: false;
												add: true;
												yourself);
								yourself);
				yourself)

! !

!ExChdCheddarPriorityRange methodsFor: 'platypus-generated-copying' stamp: ''!
cheddarPriorityRangeCopyTo: another
	

! !

!ExChdCheddarPriorityRange methodsFor: 'platypus-generated-group-accessing' stamp: ''!
cheddarPriorityRangeFromValues: values
	| valuesloc |
	valuesloc := values asOrderedCollection.
	^ valuesloc

! !

!ExChdCheddarPriorityRange methodsFor: 'platypus-generated-group-accessing' stamp: ''!
cheddarPriorityRangeToValues: values
	^ values

! !

!ExChdCheddarPriorityRange methodsFor: 'platypus-generated-group-accessing' stamp: ''!
fromValues: values
	^ self cheddarPriorityRangeFromValues: (super fromValues: values)

! !

!ExChdCheddarPriorityRange methodsFor: 'platypus-generated-deriving' stamp: ''!
initValue
	^ self initValueUsingContext: self class context

! !

!ExChdCheddarPriorityRange methodsFor: 'platypus-generated-deriving' stamp: ''!
initValueUsingContext: aContext
	^ self initValueUsingContext: aContext receiver: self

! !

!ExChdCheddarPriorityRange methodsFor: 'platypus-generated-deriving' stamp: ''!
initValueUsingContext: aContext receiver: aReceiver
	^ '0'

! !

!ExChdCheddarPriorityRange methodsFor: 'platypus-generated-classifying' stamp: ''!
isExChdCheddarPriorityRange
	^ true

! !

!ExChdCheddarPriorityRange methodsFor: 'platypus-generated-group-accessing' stamp: ''!
localFromValues: values
	^ self cheddarPriorityRangeFromValues: values

! !

!ExChdCheddarPriorityRange methodsFor: 'platypus-generated-group-accessing' stamp: ''!
localToValues: values
	^ self cheddarPriorityRangeToValues: values

! !

!ExChdCheddarPriorityRange methodsFor: 'platypus-generated-copying' stamp: ''!
pltCopyGroup: aClassSymbol to: anObject
	self class name == aClassSymbol
		ifTrue: [ self pltCopyTo: anObject ]
		ifFalse: [ super pltCopyGroup: aClassSymbol to: anObject ]

! !

!ExChdCheddarPriorityRange methodsFor: 'platypus-generated-copying' stamp: ''!
pltCopyTo: another
	super pltCopyTo: another.
	self cheddarPriorityRangeCopyTo: another

! !

!ExChdCheddarPriorityRange methodsFor: 'platypus-generated-copying' stamp: ''!
pltLocalCopyTo: another
	self cheddarPriorityRangeCopyTo: another

! !

!ExChdCheddarPriorityRange methodsFor: 'platypus-generated-initializing' stamp: ''!
stepInitialize
	super stepInitialize

! !

!ExChdCheddarPriorityRange methodsFor: 'platypus-generated-group-accessing' stamp: ''!
toValues: values
	^ self cheddarPriorityRangeToValues: (super toValues: values)

! !

ExChdCheddarDefinedType subclass: #ExChdConstrainedArrayType
	instanceVariableNames: 'maxIdx interfaces minIdx'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Express2Cheddar-CheddarDomainsSchema'!

!ExChdConstrainedArrayType commentStamp: 'platypus comment' prior: 0!
<ISO10303-11-EXPRESS>
ENTITY constrained_array_type 
	SUBTYPE OF ( cheddar_defined_type );
	min_idx : STRING;
	max_idx : OPTIONAL STRING;
	interfaces : LIST OF ada_interface;
DERIVE
	adb_interfaces_list : LIST OF ada_interface := [ ];
	ads_interfaces_list : LIST OF ada_interface := interfaces;
	adb_code : STRING := '';
	ads_code : STRING := constrained_array_type_ads_code ( SELF );
END_ENTITY;
</ISO10303-11-EXPRESS>!

!ExChdConstrainedArrayType class methodsFor: 'platypus-generated-platypus-signature' stamp: ''!
iso10303P11Translater
	^ 'Platypus (c) LISYC EA3883, Universite de Bretagne occidentale. Brest.'

! !

!ExChdConstrainedArrayType class methodsFor: 'platypus-generated-meta-data-accessing' stamp: ''!
schemaDefinition
	^ ExChdCheddarDomainsSchemaDefinition singleton

! !

!ExChdConstrainedArrayType class methodsFor: 'platypus-generated-meta-data-accessing' stamp: ''!
schemaInstance
	^ ExChdExpress2cheddarSchemaInstance singleton

! !

!ExChdConstrainedArrayType class methodsFor: 'platypus-generated-platypus-signature' stamp: ''!
translatedFromISO10303P11
	^ true

! !

!ExChdConstrainedArrayType class methodsFor: 'platypus-generated-platypus-signature' stamp: ''!
vwNamespaceName
	^ #Express2Cheddar

! !

!ExChdConstrainedArrayType methodsFor: 'platypus-generated-visiting' stamp: ''!
accept: aVisitor
	^ aVisitor acceptConstrainedArrayType: self

! !

!ExChdConstrainedArrayType methodsFor: 'platypus-generated-deriving' stamp: ''!
adbCode
	^ self adbCodeUsingContext: self class context

! !

!ExChdConstrainedArrayType methodsFor: 'platypus-generated-deriving' stamp: ''!
adbCodeUsingContext: aContext
	^ self adbCodeUsingContext: aContext receiver: self

! !

!ExChdConstrainedArrayType methodsFor: 'platypus-generated-deriving' stamp: ''!
adbCodeUsingContext: aContext receiver: aReceiver
	^ ''

! !

!ExChdConstrainedArrayType methodsFor: 'platypus-generated-deriving' stamp: ''!
adbInterfacesList
	^ self adbInterfacesListUsingContext: self class context

! !

!ExChdConstrainedArrayType methodsFor: 'platypus-generated-deriving' stamp: ''!
adbInterfacesListUsingContext: aContext
	^ self adbInterfacesListUsingContext: aContext receiver: self

! !

!ExChdConstrainedArrayType methodsFor: 'platypus-generated-deriving' stamp: ''!
adbInterfacesListUsingContext: aContext receiver: aReceiver
	^ Array new

! !

!ExChdConstrainedArrayType methodsFor: 'platypus-generated-deriving' stamp: ''!
adsCode
	^ self adsCodeUsingContext: self class context

! !

!ExChdConstrainedArrayType methodsFor: 'platypus-generated-deriving' stamp: ''!
adsCodeUsingContext: aContext
	^ self adsCodeUsingContext: aContext receiver: self

! !

!ExChdConstrainedArrayType methodsFor: 'platypus-generated-deriving' stamp: ''!
adsCodeUsingContext: aContext receiver: aReceiver
	^ ExChdConstrainedArrayTypeAdsCodeFunction
		invokeFromValues:
			(OrderedCollection new
				add: aReceiver;
				yourself)

! !

!ExChdConstrainedArrayType methodsFor: 'platypus-generated-deriving' stamp: ''!
adsInterfacesList
	^ self adsInterfacesListUsingContext: self class context

! !

!ExChdConstrainedArrayType methodsFor: 'platypus-generated-deriving' stamp: ''!
adsInterfacesListUsingContext: aContext
	^ self adsInterfacesListUsingContext: aContext receiver: self

! !

!ExChdConstrainedArrayType methodsFor: 'platypus-generated-deriving' stamp: ''!
adsInterfacesListUsingContext: aContext receiver: aReceiver
	^ aReceiver interfaces

! !

!ExChdConstrainedArrayType methodsFor: 'platypus-generated-copying' stamp: ''!
constrainedArrayTypeCopyTo: another
	another fastSetMinIdx: self minIdx.
	another fastSetMaxIdx: self maxIdx.
	another fastSetInterfaces: self interfaces

! !

!ExChdConstrainedArrayType methodsFor: 'platypus-generated-group-accessing' stamp: ''!
constrainedArrayTypeFromValues: values
	| valuesloc |
	valuesloc := values asOrderedCollection.
	self setMinIdx: valuesloc removeFirst.
	self setMaxIdx: valuesloc removeFirst.
	self setInterfaces: valuesloc removeFirst.
	^ valuesloc

! !

!ExChdConstrainedArrayType methodsFor: 'platypus-generated-group-accessing' stamp: ''!
constrainedArrayTypeToValues: values
	values add: self minIdx.
	values add: self maxIdx.
	values add: self interfaces.
	^ values

! !

!ExChdConstrainedArrayType methodsFor: 'platypus-generated-fast-set-accessing' stamp: ''!
fastSetInterfaces: aListOfExChdAdaInterface
	interfaces := aListOfExChdAdaInterface

! !

!ExChdConstrainedArrayType methodsFor: 'platypus-generated-fast-set-accessing' stamp: ''!
fastSetMaxIdx: aString
	maxIdx := aString

! !

!ExChdConstrainedArrayType methodsFor: 'platypus-generated-fast-set-accessing' stamp: ''!
fastSetMinIdx: aString
	minIdx := aString

! !

!ExChdConstrainedArrayType methodsFor: 'platypus-generated-group-accessing' stamp: ''!
fromValues: values
	^ self constrainedArrayTypeFromValues: (super fromValues: values)

! !

!ExChdConstrainedArrayType methodsFor: 'platypus-generated-accessing' stamp: ''!
interfaces
	^ interfaces

! !

!ExChdConstrainedArrayType methodsFor: 'platypus-generated-accessing' stamp: ''!
interfaces: aListOfExChdAdaInterface
	interfaces := aListOfExChdAdaInterface
		ifNil: [ OrderedCollection new ]
		ifNotNil: [ aListOfExChdAdaInterface as: OrderedCollection ]

! !

!ExChdConstrainedArrayType methodsFor: 'platypus-generated-with-context-accessing' stamp: ''!
interfacesUsingContext: aContext
	^ self interfaces

! !

!ExChdConstrainedArrayType methodsFor: 'platypus-generated-classifying' stamp: ''!
isExChdConstrainedArrayType
	^ true

! !

!ExChdConstrainedArrayType methodsFor: 'platypus-generated-group-accessing' stamp: ''!
localFromValues: values
	^ self constrainedArrayTypeFromValues: values

! !

!ExChdConstrainedArrayType methodsFor: 'platypus-generated-group-accessing' stamp: ''!
localToValues: values
	^ self constrainedArrayTypeToValues: values

! !

!ExChdConstrainedArrayType methodsFor: 'platypus-generated-accessing' stamp: ''!
maxIdx
	^ maxIdx

! !

!ExChdConstrainedArrayType methodsFor: 'platypus-generated-accessing' stamp: ''!
maxIdx: aString
	maxIdx := aString

! !

!ExChdConstrainedArrayType methodsFor: 'platypus-generated-with-context-accessing' stamp: ''!
maxIdxUsingContext: aContext
	^ self maxIdx

! !

!ExChdConstrainedArrayType methodsFor: 'platypus-generated-accessing' stamp: ''!
minIdx
	^ minIdx

! !

!ExChdConstrainedArrayType methodsFor: 'platypus-generated-accessing' stamp: ''!
minIdx: aString
	minIdx := aString

! !

!ExChdConstrainedArrayType methodsFor: 'platypus-generated-with-context-accessing' stamp: ''!
minIdxUsingContext: aContext
	^ self minIdx

! !

!ExChdConstrainedArrayType methodsFor: 'platypus-generated-copying' stamp: ''!
pltCopyGroup: aClassSymbol to: anObject
	self class name == aClassSymbol
		ifTrue: [ self pltCopyTo: anObject ]
		ifFalse: [ super pltCopyGroup: aClassSymbol to: anObject ]

! !

!ExChdConstrainedArrayType methodsFor: 'platypus-generated-copying' stamp: ''!
pltCopyTo: another
	super pltCopyTo: another.
	self constrainedArrayTypeCopyTo: another

! !

!ExChdConstrainedArrayType methodsFor: 'platypus-generated-copying' stamp: ''!
pltLocalCopyTo: another
	self constrainedArrayTypeCopyTo: another

! !

!ExChdConstrainedArrayType methodsFor: 'platypus-generated-set-accessing' stamp: ''!
setInterfaces: aListOfExChdAdaInterface
	self interfaces: aListOfExChdAdaInterface

! !

!ExChdConstrainedArrayType methodsFor: 'platypus-generated-set-accessing' stamp: ''!
setMaxIdx: aString
	self maxIdx: aString

! !

!ExChdConstrainedArrayType methodsFor: 'platypus-generated-set-accessing' stamp: ''!
setMinIdx: aString
	self minIdx: aString

! !

!ExChdConstrainedArrayType methodsFor: 'platypus-generated-initializing' stamp: ''!
stepInitialize
	super stepInitialize.
	minIdx := ''.
	maxIdx := nil.
	interfaces := OrderedCollection new

! !

!ExChdConstrainedArrayType methodsFor: 'platypus-generated-group-accessing' stamp: ''!
toValues: values
	^ self constrainedArrayTypeToValues: (super toValues: values)

! !

PltDefinedType subclass: #ExChdExplicitTypeReference
	instanceVariableNames: 'interfaces usedName'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Express2Cheddar-CheddarDomainsSchema'!

!ExChdExplicitTypeReference commentStamp: 'platypus comment' prior: 0!
<ISO10303-11-EXPRESS>
ENTITY explicit_type_reference 
	SUBTYPE OF ( defined_type );
	used_name : OPTIONAL STRING;
	interfaces : LIST OF ada_interface;
DERIVE
	SELF\defined_type.accepted : entity_instance := SELF.accept_explicit_type_reference;
	ads_interfaces_list : LIST OF ada_interface := SELF.interfaces;
	adb_interfaces_list : LIST OF ada_interface := [ ada_interface ( SELF.owner.name, ?, true, true ) ] + interfaces;
	ada_ident : STRING := SELF.name;
	ptr_type : STRING := SELF.ada_ident + '_Ptr';
	ada_ref_ident : STRING := NVL ( SELF.used_name, SELF.name );
	init_value : STRING := ?;
	ads_code : STRING := '';
	adb_code : STRING := '';
	refed_by_pointer : BOOLEAN := string_ends_with ( SELF.ada_ref_ident, '_Ptr' );
END_ENTITY;
</ISO10303-11-EXPRESS>!

!ExChdExplicitTypeReference class methodsFor: 'platypus-generated-platypus-signature' stamp: ''!
iso10303P11Translater
	^ 'Platypus (c) LISYC EA3883, Universite de Bretagne occidentale. Brest.'

! !

!ExChdExplicitTypeReference class methodsFor: 'platypus-generated-meta-data-accessing' stamp: ''!
schemaDefinition
	^ ExChdCheddarDomainsSchemaDefinition singleton

! !

!ExChdExplicitTypeReference class methodsFor: 'platypus-generated-meta-data-accessing' stamp: ''!
schemaInstance
	^ ExChdExpress2cheddarSchemaInstance singleton

! !

!ExChdExplicitTypeReference class methodsFor: 'platypus-generated-platypus-signature' stamp: ''!
translatedFromISO10303P11
	^ true

! !

!ExChdExplicitTypeReference class methodsFor: 'platypus-generated-platypus-signature' stamp: ''!
vwNamespaceName
	^ #Express2Cheddar

! !

!ExChdExplicitTypeReference methodsFor: 'platypus-generated-visiting' stamp: ''!
accept: aVisitor
	^ aVisitor acceptExplicitTypeReference: self

! !

!ExChdExplicitTypeReference methodsFor: 'platypus-generated-deriving' stamp: ''!
accepted
	^ self acceptedUsingContext: self class context

! !

!ExChdExplicitTypeReference methodsFor: 'platypus-generated-deriving' stamp: ''!
acceptedUsingContext: aContext
	^ self acceptedUsingContext: aContext receiver: self

! !

!ExChdExplicitTypeReference methodsFor: 'platypus-generated-deriving' stamp: ''!
acceptedUsingContext: aContext receiver: aReceiver
	^ aReceiver acceptExplicitTypeReferenceUsingContext: aContext

! !

!ExChdExplicitTypeReference methodsFor: 'platypus-generated-deriving' stamp: ''!
adaIdent
	^ self adaIdentUsingContext: self class context

! !

!ExChdExplicitTypeReference methodsFor: 'platypus-generated-deriving' stamp: ''!
adaIdentUsingContext: aContext
	^ self adaIdentUsingContext: aContext receiver: self

! !

!ExChdExplicitTypeReference methodsFor: 'platypus-generated-deriving' stamp: ''!
adaIdentUsingContext: aContext receiver: aReceiver
	^ aReceiver nameUsingContext: aContext

! !

!ExChdExplicitTypeReference methodsFor: 'platypus-generated-deriving' stamp: ''!
adaRefIdent
	^ self adaRefIdentUsingContext: self class context

! !

!ExChdExplicitTypeReference methodsFor: 'platypus-generated-deriving' stamp: ''!
adaRefIdentUsingContext: aContext
	^ self adaRefIdentUsingContext: aContext receiver: self

! !

!ExChdExplicitTypeReference methodsFor: 'platypus-generated-deriving' stamp: ''!
adaRefIdentUsingContext: aContext receiver: aReceiver
	^ PltNVLFunction
		invokeFromValues:
			(OrderedCollection new
				add: (aReceiver usedNameUsingContext: self class context);
				add: (aReceiver nameUsingContext: self class context);
				yourself)

! !

!ExChdExplicitTypeReference methodsFor: 'platypus-generated-deriving' stamp: ''!
adbCode
	^ self adbCodeUsingContext: self class context

! !

!ExChdExplicitTypeReference methodsFor: 'platypus-generated-deriving' stamp: ''!
adbCodeUsingContext: aContext
	^ self adbCodeUsingContext: aContext receiver: self

! !

!ExChdExplicitTypeReference methodsFor: 'platypus-generated-deriving' stamp: ''!
adbCodeUsingContext: aContext receiver: aReceiver
	^ ''

! !

!ExChdExplicitTypeReference methodsFor: 'platypus-generated-deriving' stamp: ''!
adbInterfacesList
	^ self adbInterfacesListUsingContext: self class context

! !

!ExChdExplicitTypeReference methodsFor: 'platypus-generated-deriving' stamp: ''!
adbInterfacesListUsingContext: aContext
	^ self adbInterfacesListUsingContext: aContext receiver: self

! !

!ExChdExplicitTypeReference methodsFor: 'platypus-generated-deriving' stamp: ''!
adbInterfacesListUsingContext: aContext receiver: aReceiver
	^ (PlatypusCoreAggregateInitializer
		collectionFrom:
			(OrderedCollection new
				add:
						(ExChdAdaInterface new
								adaInterfaceFromValues:
										(OrderedCollection new
												add: ((aReceiver ownerUsingContext: self class context) nameUsingContext: self class context);
												add: nil;
												add: true;
												add: true;
												yourself);
								yourself);
				yourself)) pltPlus: aReceiver interfaces

! !

!ExChdExplicitTypeReference methodsFor: 'platypus-generated-deriving' stamp: ''!
adsCode
	^ self adsCodeUsingContext: self class context

! !

!ExChdExplicitTypeReference methodsFor: 'platypus-generated-deriving' stamp: ''!
adsCodeUsingContext: aContext
	^ self adsCodeUsingContext: aContext receiver: self

! !

!ExChdExplicitTypeReference methodsFor: 'platypus-generated-deriving' stamp: ''!
adsCodeUsingContext: aContext receiver: aReceiver
	^ ''

! !

!ExChdExplicitTypeReference methodsFor: 'platypus-generated-deriving' stamp: ''!
adsInterfacesList
	^ self adsInterfacesListUsingContext: self class context

! !

!ExChdExplicitTypeReference methodsFor: 'platypus-generated-deriving' stamp: ''!
adsInterfacesListUsingContext: aContext
	^ self adsInterfacesListUsingContext: aContext receiver: self

! !

!ExChdExplicitTypeReference methodsFor: 'platypus-generated-deriving' stamp: ''!
adsInterfacesListUsingContext: aContext receiver: aReceiver
	^ aReceiver interfacesUsingContext: aContext

! !

!ExChdExplicitTypeReference methodsFor: 'platypus-generated-copying' stamp: ''!
explicitTypeReferenceCopyTo: another
	another fastSetUsedName: self usedName.
	another fastSetInterfaces: self interfaces

! !

!ExChdExplicitTypeReference methodsFor: 'platypus-generated-group-accessing' stamp: ''!
explicitTypeReferenceFromValues: values
	| valuesloc |
	valuesloc := values asOrderedCollection.
	self setUsedName: valuesloc removeFirst.
	self setInterfaces: valuesloc removeFirst.
	^ valuesloc

! !

!ExChdExplicitTypeReference methodsFor: 'platypus-generated-group-accessing' stamp: ''!
explicitTypeReferenceToValues: values
	values add: self usedName.
	values add: self interfaces.
	^ values

! !

!ExChdExplicitTypeReference methodsFor: 'platypus-generated-fast-set-accessing' stamp: ''!
fastSetInterfaces: aListOfExChdAdaInterface
	interfaces := aListOfExChdAdaInterface

! !

!ExChdExplicitTypeReference methodsFor: 'platypus-generated-fast-set-accessing' stamp: ''!
fastSetUsedName: aString
	usedName := aString

! !

!ExChdExplicitTypeReference methodsFor: 'platypus-generated-group-accessing' stamp: ''!
fromValues: values
	^ self explicitTypeReferenceFromValues: (super fromValues: values)

! !

!ExChdExplicitTypeReference methodsFor: 'platypus-generated-deriving' stamp: ''!
initValue
	^ self initValueUsingContext: self class context

! !

!ExChdExplicitTypeReference methodsFor: 'platypus-generated-deriving' stamp: ''!
initValueUsingContext: aContext
	^ self initValueUsingContext: aContext receiver: self

! !

!ExChdExplicitTypeReference methodsFor: 'platypus-generated-deriving' stamp: ''!
initValueUsingContext: aContext receiver: aReceiver
	^ nil

! !

!ExChdExplicitTypeReference methodsFor: 'platypus-generated-accessing' stamp: ''!
interfaces
	^ interfaces

! !

!ExChdExplicitTypeReference methodsFor: 'platypus-generated-accessing' stamp: ''!
interfaces: aListOfExChdAdaInterface
	interfaces := aListOfExChdAdaInterface
		ifNil: [ OrderedCollection new ]
		ifNotNil: [ aListOfExChdAdaInterface as: OrderedCollection ]

! !

!ExChdExplicitTypeReference methodsFor: 'platypus-generated-with-context-accessing' stamp: ''!
interfacesUsingContext: aContext
	^ self interfaces

! !

!ExChdExplicitTypeReference methodsFor: 'platypus-generated-classifying' stamp: ''!
isExChdExplicitTypeReference
	^ true

! !

!ExChdExplicitTypeReference methodsFor: 'platypus-generated-group-accessing' stamp: ''!
localFromValues: values
	^ self explicitTypeReferenceFromValues: values

! !

!ExChdExplicitTypeReference methodsFor: 'platypus-generated-group-accessing' stamp: ''!
localToValues: values
	^ self explicitTypeReferenceToValues: values

! !

!ExChdExplicitTypeReference methodsFor: 'platypus-generated-copying' stamp: ''!
pltCopyGroup: aClassSymbol to: anObject
	self class name == aClassSymbol
		ifTrue: [ self pltCopyTo: anObject ]
		ifFalse: [ super pltCopyGroup: aClassSymbol to: anObject ]

! !

!ExChdExplicitTypeReference methodsFor: 'platypus-generated-copying' stamp: ''!
pltCopyTo: another
	super pltCopyTo: another.
	self explicitTypeReferenceCopyTo: another

! !

!ExChdExplicitTypeReference methodsFor: 'platypus-generated-copying' stamp: ''!
pltLocalCopyTo: another
	self explicitTypeReferenceCopyTo: another

! !

!ExChdExplicitTypeReference methodsFor: 'platypus-generated-deriving' stamp: ''!
ptrType
	^ self ptrTypeUsingContext: self class context

! !

!ExChdExplicitTypeReference methodsFor: 'platypus-generated-deriving' stamp: ''!
ptrTypeUsingContext: aContext
	^ self ptrTypeUsingContext: aContext receiver: self

! !

!ExChdExplicitTypeReference methodsFor: 'platypus-generated-deriving' stamp: ''!
ptrTypeUsingContext: aContext receiver: aReceiver
	^ (aReceiver adaIdentUsingContext: aContext) pltPlus: '_Ptr'

! !

!ExChdExplicitTypeReference methodsFor: 'platypus-generated-deriving' stamp: ''!
refedByPointer
	^ self refedByPointerUsingContext: self class context

! !

!ExChdExplicitTypeReference methodsFor: 'platypus-generated-deriving' stamp: ''!
refedByPointerUsingContext: aContext
	^ self refedByPointerUsingContext: aContext receiver: self

! !

!ExChdExplicitTypeReference methodsFor: 'platypus-generated-deriving' stamp: ''!
refedByPointerUsingContext: aContext receiver: aReceiver
	^ PTsStringEndsWithFunction
		invokeFromValues:
			(OrderedCollection new
				add: (aReceiver adaRefIdentUsingContext: self class context);
				add: '_Ptr';
				yourself)

! !

!ExChdExplicitTypeReference methodsFor: 'platypus-generated-set-accessing' stamp: ''!
setInterfaces: aListOfExChdAdaInterface
	self interfaces: aListOfExChdAdaInterface

! !

!ExChdExplicitTypeReference methodsFor: 'platypus-generated-set-accessing' stamp: ''!
setUsedName: aString
	self usedName: aString

! !

!ExChdExplicitTypeReference methodsFor: 'platypus-generated-initializing' stamp: ''!
stepInitialize
	super stepInitialize.
	usedName := nil.
	interfaces := OrderedCollection new

! !

!ExChdExplicitTypeReference methodsFor: 'platypus-generated-group-accessing' stamp: ''!
toValues: values
	^ self explicitTypeReferenceToValues: (super toValues: values)

! !

!ExChdExplicitTypeReference methodsFor: 'platypus-generated-accessing' stamp: ''!
usedName
	^ usedName

! !

!ExChdExplicitTypeReference methodsFor: 'platypus-generated-accessing' stamp: ''!
usedName: aString
	usedName := aString

! !

!ExChdExplicitTypeReference methodsFor: 'platypus-generated-with-context-accessing' stamp: ''!
usedNameUsingContext: aContext
	^ self usedName

! !

PltDefinedType subclass: #ExChdRangeType
	instanceVariableNames: 'lower lowerConstant upper upperConstant'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Express2Cheddar-CheddarDomainsSchema'!

!ExChdRangeType commentStamp: 'platypus comment' prior: 0!
<ISO10303-11-EXPRESS>
ENTITY range_type 
	SUBTYPE OF ( defined_type );
	lower : STRING;
	upper : STRING;
	lower_constant : OPTIONAL STRING;
	upper_constant : OPTIONAL STRING;
DERIVE
	ads_interfaces_list : LIST OF ada_interface := [ ];
	adb_interfaces_list : LIST OF ada_interface := [ ];
	ada_ident : STRING := name;
	ada_ref_ident : STRING := SELF.ada_ident;
	ads_code : STRING := range_type_ads_code ( SELF );
	adb_code : STRING := '';
END_ENTITY;
</ISO10303-11-EXPRESS>!

!ExChdRangeType class methodsFor: 'platypus-generated-platypus-signature' stamp: ''!
iso10303P11Translater
	^ 'Platypus (c) LISYC EA3883, Universite de Bretagne occidentale. Brest.'

! !

!ExChdRangeType class methodsFor: 'platypus-generated-meta-data-accessing' stamp: ''!
schemaDefinition
	^ ExChdCheddarDomainsSchemaDefinition singleton

! !

!ExChdRangeType class methodsFor: 'platypus-generated-meta-data-accessing' stamp: ''!
schemaInstance
	^ ExChdExpress2cheddarSchemaInstance singleton

! !

!ExChdRangeType class methodsFor: 'platypus-generated-platypus-signature' stamp: ''!
translatedFromISO10303P11
	^ true

! !

!ExChdRangeType class methodsFor: 'platypus-generated-platypus-signature' stamp: ''!
vwNamespaceName
	^ #Express2Cheddar

! !

!ExChdRangeType methodsFor: 'platypus-generated-visiting' stamp: ''!
accept: aVisitor
	^ aVisitor acceptRangeType: self

! !

!ExChdRangeType methodsFor: 'platypus-generated-deriving' stamp: ''!
adaIdent
	^ self adaIdentUsingContext: self class context

! !

!ExChdRangeType methodsFor: 'platypus-generated-deriving' stamp: ''!
adaIdentUsingContext: aContext
	^ self adaIdentUsingContext: aContext receiver: self

! !

!ExChdRangeType methodsFor: 'platypus-generated-deriving' stamp: ''!
adaIdentUsingContext: aContext receiver: aReceiver
	^ aReceiver name

! !

!ExChdRangeType methodsFor: 'platypus-generated-deriving' stamp: ''!
adaRefIdent
	^ self adaRefIdentUsingContext: self class context

! !

!ExChdRangeType methodsFor: 'platypus-generated-deriving' stamp: ''!
adaRefIdentUsingContext: aContext
	^ self adaRefIdentUsingContext: aContext receiver: self

! !

!ExChdRangeType methodsFor: 'platypus-generated-deriving' stamp: ''!
adaRefIdentUsingContext: aContext receiver: aReceiver
	^ aReceiver adaIdentUsingContext: aContext

! !

!ExChdRangeType methodsFor: 'platypus-generated-deriving' stamp: ''!
adbCode
	^ self adbCodeUsingContext: self class context

! !

!ExChdRangeType methodsFor: 'platypus-generated-deriving' stamp: ''!
adbCodeUsingContext: aContext
	^ self adbCodeUsingContext: aContext receiver: self

! !

!ExChdRangeType methodsFor: 'platypus-generated-deriving' stamp: ''!
adbCodeUsingContext: aContext receiver: aReceiver
	^ ''

! !

!ExChdRangeType methodsFor: 'platypus-generated-deriving' stamp: ''!
adbInterfacesList
	^ self adbInterfacesListUsingContext: self class context

! !

!ExChdRangeType methodsFor: 'platypus-generated-deriving' stamp: ''!
adbInterfacesListUsingContext: aContext
	^ self adbInterfacesListUsingContext: aContext receiver: self

! !

!ExChdRangeType methodsFor: 'platypus-generated-deriving' stamp: ''!
adbInterfacesListUsingContext: aContext receiver: aReceiver
	^ Array new

! !

!ExChdRangeType methodsFor: 'platypus-generated-deriving' stamp: ''!
adsCode
	^ self adsCodeUsingContext: self class context

! !

!ExChdRangeType methodsFor: 'platypus-generated-deriving' stamp: ''!
adsCodeUsingContext: aContext
	^ self adsCodeUsingContext: aContext receiver: self

! !

!ExChdRangeType methodsFor: 'platypus-generated-deriving' stamp: ''!
adsCodeUsingContext: aContext receiver: aReceiver
	^ ExChdRangeTypeAdsCodeFunction
		invokeFromValues:
			(OrderedCollection new
				add: aReceiver;
				yourself)

! !

!ExChdRangeType methodsFor: 'platypus-generated-deriving' stamp: ''!
adsInterfacesList
	^ self adsInterfacesListUsingContext: self class context

! !

!ExChdRangeType methodsFor: 'platypus-generated-deriving' stamp: ''!
adsInterfacesListUsingContext: aContext
	^ self adsInterfacesListUsingContext: aContext receiver: self

! !

!ExChdRangeType methodsFor: 'platypus-generated-deriving' stamp: ''!
adsInterfacesListUsingContext: aContext receiver: aReceiver
	^ Array new

! !

!ExChdRangeType methodsFor: 'platypus-generated-fast-set-accessing' stamp: ''!
fastSetLower: aString
	lower := aString

! !

!ExChdRangeType methodsFor: 'platypus-generated-fast-set-accessing' stamp: ''!
fastSetLowerConstant: aString
	lowerConstant := aString

! !

!ExChdRangeType methodsFor: 'platypus-generated-fast-set-accessing' stamp: ''!
fastSetUpper: aString
	upper := aString

! !

!ExChdRangeType methodsFor: 'platypus-generated-fast-set-accessing' stamp: ''!
fastSetUpperConstant: aString
	upperConstant := aString

! !

!ExChdRangeType methodsFor: 'platypus-generated-group-accessing' stamp: ''!
fromValues: values
	^ self rangeTypeFromValues: (super fromValues: values)

! !

!ExChdRangeType methodsFor: 'platypus-generated-classifying' stamp: ''!
isExChdRangeType
	^ true

! !

!ExChdRangeType methodsFor: 'platypus-generated-group-accessing' stamp: ''!
localFromValues: values
	^ self rangeTypeFromValues: values

! !

!ExChdRangeType methodsFor: 'platypus-generated-group-accessing' stamp: ''!
localToValues: values
	^ self rangeTypeToValues: values

! !

!ExChdRangeType methodsFor: 'platypus-generated-accessing' stamp: ''!
lower
	^ lower

! !

!ExChdRangeType methodsFor: 'platypus-generated-accessing' stamp: ''!
lower: aString
	lower := aString

! !

!ExChdRangeType methodsFor: 'platypus-generated-accessing' stamp: ''!
lowerConstant
	^ lowerConstant

! !

!ExChdRangeType methodsFor: 'platypus-generated-accessing' stamp: ''!
lowerConstant: aString
	lowerConstant := aString

! !

!ExChdRangeType methodsFor: 'platypus-generated-with-context-accessing' stamp: ''!
lowerConstantUsingContext: aContext
	^ self lowerConstant

! !

!ExChdRangeType methodsFor: 'platypus-generated-with-context-accessing' stamp: ''!
lowerUsingContext: aContext
	^ self lower

! !

!ExChdRangeType methodsFor: 'platypus-generated-copying' stamp: ''!
pltCopyGroup: aClassSymbol to: anObject
	self class name == aClassSymbol
		ifTrue: [ self pltCopyTo: anObject ]
		ifFalse: [ super pltCopyGroup: aClassSymbol to: anObject ]

! !

!ExChdRangeType methodsFor: 'platypus-generated-copying' stamp: ''!
pltCopyTo: another
	super pltCopyTo: another.
	self rangeTypeCopyTo: another

! !

!ExChdRangeType methodsFor: 'platypus-generated-copying' stamp: ''!
pltLocalCopyTo: another
	self rangeTypeCopyTo: another

! !

!ExChdRangeType methodsFor: 'platypus-generated-copying' stamp: ''!
rangeTypeCopyTo: another
	another fastSetLower: self lower.
	another fastSetUpper: self upper.
	another fastSetLowerConstant: self lowerConstant.
	another fastSetUpperConstant: self upperConstant

! !

!ExChdRangeType methodsFor: 'platypus-generated-group-accessing' stamp: ''!
rangeTypeFromValues: values
	| valuesloc |
	valuesloc := values asOrderedCollection.
	self setLower: valuesloc removeFirst.
	self setUpper: valuesloc removeFirst.
	self setLowerConstant: valuesloc removeFirst.
	self setUpperConstant: valuesloc removeFirst.
	^ valuesloc

! !

!ExChdRangeType methodsFor: 'platypus-generated-group-accessing' stamp: ''!
rangeTypeToValues: values
	values add: self lower.
	values add: self upper.
	values add: self lowerConstant.
	values add: self upperConstant.
	^ values

! !

!ExChdRangeType methodsFor: 'platypus-generated-set-accessing' stamp: ''!
setLower: aString
	self lower: aString

! !

!ExChdRangeType methodsFor: 'platypus-generated-set-accessing' stamp: ''!
setLowerConstant: aString
	self lowerConstant: aString

! !

!ExChdRangeType methodsFor: 'platypus-generated-set-accessing' stamp: ''!
setUpper: aString
	self upper: aString

! !

!ExChdRangeType methodsFor: 'platypus-generated-set-accessing' stamp: ''!
setUpperConstant: aString
	self upperConstant: aString

! !

!ExChdRangeType methodsFor: 'platypus-generated-initializing' stamp: ''!
stepInitialize
	super stepInitialize.
	lower := ''.
	upper := ''.
	lowerConstant := nil.
	upperConstant := nil

! !

!ExChdRangeType methodsFor: 'platypus-generated-group-accessing' stamp: ''!
toValues: values
	^ self rangeTypeToValues: (super toValues: values)

! !

!ExChdRangeType methodsFor: 'platypus-generated-accessing' stamp: ''!
upper
	^ upper

! !

!ExChdRangeType methodsFor: 'platypus-generated-accessing' stamp: ''!
upper: aString
	upper := aString

! !

!ExChdRangeType methodsFor: 'platypus-generated-accessing' stamp: ''!
upperConstant
	^ upperConstant

! !

!ExChdRangeType methodsFor: 'platypus-generated-accessing' stamp: ''!
upperConstant: aString
	upperConstant := aString

! !

!ExChdRangeType methodsFor: 'platypus-generated-with-context-accessing' stamp: ''!
upperConstantUsingContext: aContext
	^ self upperConstant

! !

!ExChdRangeType methodsFor: 'platypus-generated-with-context-accessing' stamp: ''!
upperUsingContext: aContext
	^ self upper

! !

PltEntityDefinition subclass: #ExChdAdaEntity
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Express2Cheddar-RecordAndClassSchema'!

!ExChdAdaEntity commentStamp: 'platypus comment' prior: 0!
<ISO10303-11-EXPRESS>
ENTITY ada_entity 
	ABSTRACT SUPERTYPE 
	SUBTYPE OF ( entity_definition );
DERIVE
	refed_by_pointer : BOOLEAN := false;
	ada_ident : STRING := name;
	ada_ref_ident : STRING := SELF.ada_ident;
	ptr_type : STRING := name + '_Ptr';
	explicit_attributes : LIST OF explicit_attribute := QUERY ( a <* attributes | 'PLATYPUS_DICTIONARY_SCHEMA.EXPLICIT_ATTRIBUTE' IN TYPEOF ( a ) );
	derived_attributes : LIST OF explicit_attribute := QUERY ( a <* attributes | 'PLATYPUS_DICTIONARY_SCHEMA.DERIVED_ATTRIBUTE' IN TYPEOF ( a ) );
	put_prefix : STRING := '';
	dependencies : LIST OF dictionary_instance := dependencies_of_ada_entity ( SELF.owner, SELF );
	xml_writer_code : STRING := ?;
	xml_io_record_code : STRING := ?;
	html_tag : STRING := Lowerize ( SELF.name );
END_ENTITY;
</ISO10303-11-EXPRESS>!

ExChdAdaEntity subclass: #ExChdAdaClass
	instanceVariableNames: 'isPrivate'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Express2Cheddar-RecordAndClassSchema'!

!ExChdAdaClass commentStamp: 'platypus comment' prior: 0!
<ISO10303-11-EXPRESS>
ENTITY ada_class 
	SUBTYPE OF ( ada_entity );
	is_private : BOOLEAN;
DERIVE
	SELF\ada_entity.refed_by_pointer : BOOLEAN := true;
	ads_code : STRING := ada_class_ads_code ( SELF, is_private );
	adb_code : STRING := ada_class_adb_code ( SELF );
	init_value : STRING := ?;
	ads_interfaces_list : LIST OF ada_interface := ada_entity_interfaces_list ( SELF, true );
	adb_interfaces_list : LIST OF ada_interface := ada_entity_interfaces_list ( SELF, false );
	SELF\ada_entity.ada_ref_ident : STRING := SELF.ptr_type;
	SELF\ada_entity.xml_writer_code : STRING := ada_class_xml_writer_code ( SELF );
	SELF\ada_entity.xml_io_record_code : STRING := ada_class_xml_io_record_code ( SELF );
END_ENTITY;
</ISO10303-11-EXPRESS>!

!ExChdAdaClass class methodsFor: 'platypus-generated-platypus-signature' stamp: ''!
iso10303P11Translater
	^ 'Platypus (c) LISYC EA3883, Universite de Bretagne occidentale. Brest.'

! !

!ExChdAdaClass class methodsFor: 'platypus-generated-meta-data-accessing' stamp: ''!
schemaDefinition
	^ ExChdRecordAndClassSchemaDefinition singleton

! !

!ExChdAdaClass class methodsFor: 'platypus-generated-meta-data-accessing' stamp: ''!
schemaInstance
	^ ExChdExpress2cheddarSchemaInstance singleton

! !

!ExChdAdaClass class methodsFor: 'platypus-generated-platypus-signature' stamp: ''!
translatedFromISO10303P11
	^ true

! !

!ExChdAdaClass class methodsFor: 'platypus-generated-platypus-signature' stamp: ''!
vwNamespaceName
	^ #Express2Cheddar

! !

!ExChdAdaClass methodsFor: 'platypus-generated-visiting' stamp: ''!
accept: aVisitor
	^ aVisitor acceptAdaClass: self

! !

!ExChdAdaClass methodsFor: 'platypus-generated-copying' stamp: ''!
adaClassCopyTo: another
	another fastSetIsPrivate: self isPrivate

! !

!ExChdAdaClass methodsFor: 'platypus-generated-group-accessing' stamp: ''!
adaClassFromValues: values
	| valuesloc |
	valuesloc := values asOrderedCollection.
	self setIsPrivate: valuesloc removeFirst.
	^ valuesloc

! !

!ExChdAdaClass methodsFor: 'platypus-generated-group-accessing' stamp: ''!
adaClassToValues: values
	values add: self isPrivate.
	^ values

! !

!ExChdAdaClass methodsFor: 'platypus-generated-deriving' stamp: ''!
adaRefIdent
	^ self adaRefIdentUsingContext: self class context

! !

!ExChdAdaClass methodsFor: 'platypus-generated-deriving' stamp: ''!
adaRefIdentUsingContext: aContext
	^ self adaRefIdentUsingContext: aContext receiver: self

! !

!ExChdAdaClass methodsFor: 'platypus-generated-deriving' stamp: ''!
adaRefIdentUsingContext: aContext receiver: aReceiver
	^ aReceiver ptrTypeUsingContext: aContext

! !

!ExChdAdaClass methodsFor: 'platypus-generated-deriving' stamp: ''!
adbCode
	^ self adbCodeUsingContext: self class context

! !

!ExChdAdaClass methodsFor: 'platypus-generated-deriving' stamp: ''!
adbCodeUsingContext: aContext
	^ self adbCodeUsingContext: aContext receiver: self

! !

!ExChdAdaClass methodsFor: 'platypus-generated-deriving' stamp: ''!
adbCodeUsingContext: aContext receiver: aReceiver
	^ ExChdAdaClassAdbCodeFunction
		invokeFromValues:
			(OrderedCollection new
				add: aReceiver;
				yourself)

! !

!ExChdAdaClass methodsFor: 'platypus-generated-deriving' stamp: ''!
adbInterfacesList
	^ self adbInterfacesListUsingContext: self class context

! !

!ExChdAdaClass methodsFor: 'platypus-generated-deriving' stamp: ''!
adbInterfacesListUsingContext: aContext
	^ self adbInterfacesListUsingContext: aContext receiver: self

! !

!ExChdAdaClass methodsFor: 'platypus-generated-deriving' stamp: ''!
adbInterfacesListUsingContext: aContext receiver: aReceiver
	^ ExChdAdaEntityInterfacesListFunction
		invokeFromValues:
			(OrderedCollection new
				add: aReceiver;
				add: false;
				yourself)

! !

!ExChdAdaClass methodsFor: 'platypus-generated-deriving' stamp: ''!
adsCode
	^ self adsCodeUsingContext: self class context

! !

!ExChdAdaClass methodsFor: 'platypus-generated-deriving' stamp: ''!
adsCodeUsingContext: aContext
	^ self adsCodeUsingContext: aContext receiver: self

! !

!ExChdAdaClass methodsFor: 'platypus-generated-deriving' stamp: ''!
adsCodeUsingContext: aContext receiver: aReceiver
	^ ExChdAdaClassAdsCodeFunction
		invokeFromValues:
			(OrderedCollection new
				add: aReceiver;
				add: aReceiver isPrivate;
				yourself)

! !

!ExChdAdaClass methodsFor: 'platypus-generated-deriving' stamp: ''!
adsInterfacesList
	^ self adsInterfacesListUsingContext: self class context

! !

!ExChdAdaClass methodsFor: 'platypus-generated-deriving' stamp: ''!
adsInterfacesListUsingContext: aContext
	^ self adsInterfacesListUsingContext: aContext receiver: self

! !

!ExChdAdaClass methodsFor: 'platypus-generated-deriving' stamp: ''!
adsInterfacesListUsingContext: aContext receiver: aReceiver
	^ ExChdAdaEntityInterfacesListFunction
		invokeFromValues:
			(OrderedCollection new
				add: aReceiver;
				add: true;
				yourself)

! !

!ExChdAdaClass methodsFor: 'platypus-generated-fast-set-accessing' stamp: ''!
fastSetIsPrivate: aBoolean
	isPrivate := aBoolean

! !

!ExChdAdaClass methodsFor: 'platypus-generated-group-accessing' stamp: ''!
fromValues: values
	^ self adaClassFromValues: (super fromValues: values)

! !

!ExChdAdaClass methodsFor: 'platypus-generated-deriving' stamp: ''!
initValue
	^ self initValueUsingContext: self class context

! !

!ExChdAdaClass methodsFor: 'platypus-generated-deriving' stamp: ''!
initValueUsingContext: aContext
	^ self initValueUsingContext: aContext receiver: self

! !

!ExChdAdaClass methodsFor: 'platypus-generated-deriving' stamp: ''!
initValueUsingContext: aContext receiver: aReceiver
	^ nil

! !

!ExChdAdaClass methodsFor: 'platypus-generated-classifying' stamp: ''!
isExChdAdaClass
	^ true

! !

!ExChdAdaClass methodsFor: 'platypus-generated-accessing' stamp: ''!
isPrivate
	^ isPrivate

! !

!ExChdAdaClass methodsFor: 'platypus-generated-accessing' stamp: ''!
isPrivate: aBoolean
	isPrivate := aBoolean

! !

!ExChdAdaClass methodsFor: 'platypus-generated-with-context-accessing' stamp: ''!
isPrivateUsingContext: aContext
	^ self isPrivate

! !

!ExChdAdaClass methodsFor: 'platypus-generated-group-accessing' stamp: ''!
localFromValues: values
	^ self adaClassFromValues: values

! !

!ExChdAdaClass methodsFor: 'platypus-generated-group-accessing' stamp: ''!
localToValues: values
	^ self adaClassToValues: values

! !

!ExChdAdaClass methodsFor: 'platypus-generated-copying' stamp: ''!
pltCopyGroup: aClassSymbol to: anObject
	self class name == aClassSymbol
		ifTrue: [ self pltCopyTo: anObject ]
		ifFalse: [ super pltCopyGroup: aClassSymbol to: anObject ]

! !

!ExChdAdaClass methodsFor: 'platypus-generated-copying' stamp: ''!
pltCopyTo: another
	super pltCopyTo: another.
	self adaClassCopyTo: another

! !

!ExChdAdaClass methodsFor: 'platypus-generated-copying' stamp: ''!
pltLocalCopyTo: another
	self adaClassCopyTo: another

! !

!ExChdAdaClass methodsFor: 'platypus-generated-deriving' stamp: ''!
refedByPointer
	^ self refedByPointerUsingContext: self class context

! !

!ExChdAdaClass methodsFor: 'platypus-generated-deriving' stamp: ''!
refedByPointerUsingContext: aContext
	^ self refedByPointerUsingContext: aContext receiver: self

! !

!ExChdAdaClass methodsFor: 'platypus-generated-deriving' stamp: ''!
refedByPointerUsingContext: aContext receiver: aReceiver
	^ true

! !

!ExChdAdaClass methodsFor: 'platypus-generated-set-accessing' stamp: ''!
setIsPrivate: aBoolean
	self isPrivate: aBoolean

! !

!ExChdAdaClass methodsFor: 'platypus-generated-initializing' stamp: ''!
stepInitialize
	super stepInitialize.
	isPrivate := false

! !

!ExChdAdaClass methodsFor: 'platypus-generated-group-accessing' stamp: ''!
toValues: values
	^ self adaClassToValues: (super toValues: values)

! !

!ExChdAdaClass methodsFor: 'platypus-generated-deriving' stamp: ''!
xmlIoRecordCode
	^ self xmlIoRecordCodeUsingContext: self class context

! !

!ExChdAdaClass methodsFor: 'platypus-generated-deriving' stamp: ''!
xmlIoRecordCodeUsingContext: aContext
	^ self xmlIoRecordCodeUsingContext: aContext receiver: self

! !

!ExChdAdaClass methodsFor: 'platypus-generated-deriving' stamp: ''!
xmlIoRecordCodeUsingContext: aContext receiver: aReceiver
	^ ExChdAdaClassXmlIoRecordCodeFunction
		invokeFromValues:
			(OrderedCollection new
				add: aReceiver;
				yourself)

! !

!ExChdAdaClass methodsFor: 'platypus-generated-deriving' stamp: ''!
xmlWriterCode
	^ self xmlWriterCodeUsingContext: self class context

! !

!ExChdAdaClass methodsFor: 'platypus-generated-deriving' stamp: ''!
xmlWriterCodeUsingContext: aContext
	^ self xmlWriterCodeUsingContext: aContext receiver: self

! !

!ExChdAdaClass methodsFor: 'platypus-generated-deriving' stamp: ''!
xmlWriterCodeUsingContext: aContext receiver: aReceiver
	^ ExChdAdaClassXmlWriterCodeFunction
		invokeFromValues:
			(OrderedCollection new
				add: aReceiver;
				yourself)

! !

!ExChdAdaEntity class methodsFor: 'platypus-generated-platypus-signature' stamp: ''!
iso10303P11Translater
	^ 'Platypus (c) LISYC EA3883, Universite de Bretagne occidentale. Brest.'

! !

!ExChdAdaEntity class methodsFor: 'platypus-generated-meta-data-accessing' stamp: ''!
schemaDefinition
	^ ExChdRecordAndClassSchemaDefinition singleton

! !

!ExChdAdaEntity class methodsFor: 'platypus-generated-meta-data-accessing' stamp: ''!
schemaInstance
	^ ExChdExpress2cheddarSchemaInstance singleton

! !

!ExChdAdaEntity class methodsFor: 'platypus-generated-platypus-signature' stamp: ''!
translatedFromISO10303P11
	^ true

! !

!ExChdAdaEntity class methodsFor: 'platypus-generated-platypus-signature' stamp: ''!
vwNamespaceName
	^ #Express2Cheddar

! !

!ExChdAdaEntity methodsFor: 'platypus-generated-visiting' stamp: ''!
accept: aVisitor
	^ aVisitor acceptAdaEntity: self

! !

!ExChdAdaEntity methodsFor: 'platypus-generated-copying' stamp: ''!
adaEntityCopyTo: another
	

! !

!ExChdAdaEntity methodsFor: 'platypus-generated-group-accessing' stamp: ''!
adaEntityFromValues: values
	| valuesloc |
	valuesloc := values asOrderedCollection.
	^ valuesloc

! !

!ExChdAdaEntity methodsFor: 'platypus-generated-group-accessing' stamp: ''!
adaEntityToValues: values
	^ values

! !

!ExChdAdaEntity methodsFor: 'platypus-generated-deriving' stamp: ''!
adaIdent
	^ self adaIdentUsingContext: self class context

! !

!ExChdAdaEntity methodsFor: 'platypus-generated-deriving' stamp: ''!
adaIdentUsingContext: aContext
	^ self adaIdentUsingContext: aContext receiver: self

! !

!ExChdAdaEntity methodsFor: 'platypus-generated-deriving' stamp: ''!
adaIdentUsingContext: aContext receiver: aReceiver
	^ aReceiver name

! !

!ExChdAdaEntity methodsFor: 'platypus-generated-deriving' stamp: ''!
adaRefIdent
	^ self adaRefIdentUsingContext: self class context

! !

!ExChdAdaEntity methodsFor: 'platypus-generated-deriving' stamp: ''!
adaRefIdentUsingContext: aContext
	^ self adaRefIdentUsingContext: aContext receiver: self

! !

!ExChdAdaEntity methodsFor: 'platypus-generated-deriving' stamp: ''!
adaRefIdentUsingContext: aContext receiver: aReceiver
	^ aReceiver adaIdentUsingContext: aContext

! !

!ExChdAdaEntity methodsFor: 'platypus-generated-deriving' stamp: ''!
dependencies
	^ self dependenciesUsingContext: self class context

! !

!ExChdAdaEntity methodsFor: 'platypus-generated-deriving' stamp: ''!
dependenciesUsingContext: aContext
	^ self dependenciesUsingContext: aContext receiver: self

! !

!ExChdAdaEntity methodsFor: 'platypus-generated-deriving' stamp: ''!
dependenciesUsingContext: aContext receiver: aReceiver
	^ ExChdDependenciesOfAdaEntityFunction
		invokeFromValues:
			(OrderedCollection new
				add: (aReceiver ownerUsingContext: self class context);
				add: aReceiver;
				yourself)

! !

!ExChdAdaEntity methodsFor: 'platypus-generated-deriving' stamp: ''!
derivedAttributes
	^ self derivedAttributesUsingContext: self class context

! !

!ExChdAdaEntity methodsFor: 'platypus-generated-deriving' stamp: ''!
derivedAttributesUsingContext: aContext
	^ self derivedAttributesUsingContext: aContext receiver: self

! !

!ExChdAdaEntity methodsFor: 'platypus-generated-deriving' stamp: ''!
derivedAttributesUsingContext: aContext receiver: aReceiver
	^ aReceiver attributes
		select: [ :a176 | 
			(PltTYPEOFFunction
				invokeFromValues:
					(OrderedCollection new
						add: a176;
						yourself)) includes: 'PLATYPUS_DICTIONARY_SCHEMA.DERIVED_ATTRIBUTE' ]

! !

!ExChdAdaEntity methodsFor: 'platypus-generated-deriving' stamp: ''!
explicitAttributes
	^ self explicitAttributesUsingContext: self class context

! !

!ExChdAdaEntity methodsFor: 'platypus-generated-deriving' stamp: ''!
explicitAttributesUsingContext: aContext
	^ self explicitAttributesUsingContext: aContext receiver: self

! !

!ExChdAdaEntity methodsFor: 'platypus-generated-deriving' stamp: ''!
explicitAttributesUsingContext: aContext receiver: aReceiver
	^ aReceiver attributes
		select: [ :a2503 | 
			(PltTYPEOFFunction
				invokeFromValues:
					(OrderedCollection new
						add: a2503;
						yourself)) includes: 'PLATYPUS_DICTIONARY_SCHEMA.EXPLICIT_ATTRIBUTE' ]

! !

!ExChdAdaEntity methodsFor: 'platypus-generated-group-accessing' stamp: ''!
fromValues: values
	^ self adaEntityFromValues: (super fromValues: values)

! !

!ExChdAdaEntity methodsFor: 'platypus-generated-deriving' stamp: ''!
htmlTag
	^ self htmlTagUsingContext: self class context

! !

!ExChdAdaEntity methodsFor: 'platypus-generated-deriving' stamp: ''!
htmlTagUsingContext: aContext
	^ self htmlTagUsingContext: aContext receiver: self

! !

!ExChdAdaEntity methodsFor: 'platypus-generated-deriving' stamp: ''!
htmlTagUsingContext: aContext receiver: aReceiver
	^ PTsLowerizeFunction
		invokeFromValues:
			(OrderedCollection new
				add: (aReceiver nameUsingContext: self class context);
				yourself)

! !

!ExChdAdaEntity methodsFor: 'platypus-generated-classifying' stamp: ''!
isExChdAdaEntity
	^ true

! !

!ExChdAdaEntity methodsFor: 'platypus-generated-group-accessing' stamp: ''!
localFromValues: values
	^ self adaEntityFromValues: values

! !

!ExChdAdaEntity methodsFor: 'platypus-generated-group-accessing' stamp: ''!
localToValues: values
	^ self adaEntityToValues: values

! !

!ExChdAdaEntity methodsFor: 'platypus-generated-copying' stamp: ''!
pltCopyGroup: aClassSymbol to: anObject
	self class name == aClassSymbol
		ifTrue: [ self pltCopyTo: anObject ]
		ifFalse: [ super pltCopyGroup: aClassSymbol to: anObject ]

! !

!ExChdAdaEntity methodsFor: 'platypus-generated-copying' stamp: ''!
pltCopyTo: another
	super pltCopyTo: another.
	self adaEntityCopyTo: another

! !

!ExChdAdaEntity methodsFor: 'platypus-generated-copying' stamp: ''!
pltLocalCopyTo: another
	self adaEntityCopyTo: another

! !

!ExChdAdaEntity methodsFor: 'platypus-generated-deriving' stamp: ''!
ptrType
	^ self ptrTypeUsingContext: self class context

! !

!ExChdAdaEntity methodsFor: 'platypus-generated-deriving' stamp: ''!
ptrTypeUsingContext: aContext
	^ self ptrTypeUsingContext: aContext receiver: self

! !

!ExChdAdaEntity methodsFor: 'platypus-generated-deriving' stamp: ''!
ptrTypeUsingContext: aContext receiver: aReceiver
	^ aReceiver name pltPlus: '_Ptr'

! !

!ExChdAdaEntity methodsFor: 'platypus-generated-deriving' stamp: ''!
putPrefix
	^ self putPrefixUsingContext: self class context

! !

!ExChdAdaEntity methodsFor: 'platypus-generated-deriving' stamp: ''!
putPrefixUsingContext: aContext
	^ self putPrefixUsingContext: aContext receiver: self

! !

!ExChdAdaEntity methodsFor: 'platypus-generated-deriving' stamp: ''!
putPrefixUsingContext: aContext receiver: aReceiver
	^ ''

! !

!ExChdAdaEntity methodsFor: 'platypus-generated-deriving' stamp: ''!
refedByPointer
	^ self refedByPointerUsingContext: self class context

! !

!ExChdAdaEntity methodsFor: 'platypus-generated-deriving' stamp: ''!
refedByPointerUsingContext: aContext
	^ self refedByPointerUsingContext: aContext receiver: self

! !

!ExChdAdaEntity methodsFor: 'platypus-generated-deriving' stamp: ''!
refedByPointerUsingContext: aContext receiver: aReceiver
	^ false

! !

!ExChdAdaEntity methodsFor: 'platypus-generated-initializing' stamp: ''!
stepInitialize
	super stepInitialize

! !

!ExChdAdaEntity methodsFor: 'platypus-generated-group-accessing' stamp: ''!
toValues: values
	^ self adaEntityToValues: (super toValues: values)

! !

!ExChdAdaEntity methodsFor: 'platypus-generated-deriving' stamp: ''!
xmlIoRecordCode
	^ self xmlIoRecordCodeUsingContext: self class context

! !

!ExChdAdaEntity methodsFor: 'platypus-generated-deriving' stamp: ''!
xmlIoRecordCodeUsingContext: aContext
	^ self xmlIoRecordCodeUsingContext: aContext receiver: self

! !

!ExChdAdaEntity methodsFor: 'platypus-generated-deriving' stamp: ''!
xmlIoRecordCodeUsingContext: aContext receiver: aReceiver
	^ nil

! !

!ExChdAdaEntity methodsFor: 'platypus-generated-deriving' stamp: ''!
xmlWriterCode
	^ self xmlWriterCodeUsingContext: self class context

! !

!ExChdAdaEntity methodsFor: 'platypus-generated-deriving' stamp: ''!
xmlWriterCodeUsingContext: aContext
	^ self xmlWriterCodeUsingContext: aContext receiver: self

! !

!ExChdAdaEntity methodsFor: 'platypus-generated-deriving' stamp: ''!
xmlWriterCodeUsingContext: aContext receiver: aReceiver
	^ nil

! !

ExChdAdaEntity subclass: #ExChdDiscriminatedType
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Express2Cheddar-DiscriminatedTypeSchema'!

!ExChdDiscriminatedType commentStamp: 'platypus comment' prior: 0!
<ISO10303-11-EXPRESS>
ENTITY discriminated_type 
	SUBTYPE OF ( ada_entity );
DERIVE
	SELF\ada_entity.refed_by_pointer : BOOLEAN := false;
	discriminant : attribute := QUERY ( attr <* attributes | 'DISCRIMINATED_TYPE.DISCRIMINATED_TYPE_DISCRIMINANT' IN TYPEOF ( attr ) ) [ 1 ];
	union_attr : attribute := QUERY ( attr <* attributes | 'DISCRIMINATED_TYPE.DISCRIMINATED_TYPE_UNION' IN TYPEOF ( attr ) ) [ 1 ];
	ads_interfaces_list : LIST OF ada_interface := discriminated_Type_interfaces_list ( SELF, true );
	adb_interfaces_list : LIST OF ada_interface := discriminated_Type_interfaces_list ( SELF, false );
	translated_attributes : LIST OF explicit_attribute := explicit_attributes - discriminant - union_attr;
	SELF\ada_entity.ada_ident : STRING := name;
	SELF\ada_entity.ada_ref_ident : STRING := SELF.ada_ident + '_Ptr';
	SELF\ada_entity.xml_io_record_code : STRING := discriminated_type_xml_io_record_code ( SELF );
	tail_attributes : LIST OF attribute := discriminated_type_tails_attributes ( SELF );
	ads_code : STRING := discriminated_type_ads_code ( SELF );
	adb_code : STRING := discriminated_type_adb_code ( SELF );
END_ENTITY;
</ISO10303-11-EXPRESS>!

!ExChdDiscriminatedType class methodsFor: 'platypus-generated-platypus-signature' stamp: ''!
iso10303P11Translater
	^ 'Platypus (c) LISYC EA3883, Universite de Bretagne occidentale. Brest.'

! !

!ExChdDiscriminatedType class methodsFor: 'platypus-generated-meta-data-accessing' stamp: ''!
schemaDefinition
	^ ExChdDiscriminatedTypeSchemaDefinition singleton

! !

!ExChdDiscriminatedType class methodsFor: 'platypus-generated-meta-data-accessing' stamp: ''!
schemaInstance
	^ ExChdExpress2cheddarSchemaInstance singleton

! !

!ExChdDiscriminatedType class methodsFor: 'platypus-generated-platypus-signature' stamp: ''!
translatedFromISO10303P11
	^ true

! !

!ExChdDiscriminatedType class methodsFor: 'platypus-generated-platypus-signature' stamp: ''!
vwNamespaceName
	^ #Express2Cheddar

! !

!ExChdDiscriminatedType methodsFor: 'platypus-generated-visiting' stamp: ''!
accept: aVisitor
	^ aVisitor acceptDiscriminatedType: self

! !

!ExChdDiscriminatedType methodsFor: 'platypus-generated-deriving' stamp: ''!
adaIdent
	^ self adaIdentUsingContext: self class context

! !

!ExChdDiscriminatedType methodsFor: 'platypus-generated-deriving' stamp: ''!
adaIdentUsingContext: aContext
	^ self adaIdentUsingContext: aContext receiver: self

! !

!ExChdDiscriminatedType methodsFor: 'platypus-generated-deriving' stamp: ''!
adaIdentUsingContext: aContext receiver: aReceiver
	^ aReceiver name

! !

!ExChdDiscriminatedType methodsFor: 'platypus-generated-deriving' stamp: ''!
adaRefIdent
	^ self adaRefIdentUsingContext: self class context

! !

!ExChdDiscriminatedType methodsFor: 'platypus-generated-deriving' stamp: ''!
adaRefIdentUsingContext: aContext
	^ self adaRefIdentUsingContext: aContext receiver: self

! !

!ExChdDiscriminatedType methodsFor: 'platypus-generated-deriving' stamp: ''!
adaRefIdentUsingContext: aContext receiver: aReceiver
	^ (aReceiver adaIdentUsingContext: aContext) pltPlus: '_Ptr'

! !

!ExChdDiscriminatedType methodsFor: 'platypus-generated-deriving' stamp: ''!
adbCode
	^ self adbCodeUsingContext: self class context

! !

!ExChdDiscriminatedType methodsFor: 'platypus-generated-deriving' stamp: ''!
adbCodeUsingContext: aContext
	^ self adbCodeUsingContext: aContext receiver: self

! !

!ExChdDiscriminatedType methodsFor: 'platypus-generated-deriving' stamp: ''!
adbCodeUsingContext: aContext receiver: aReceiver
	^ ExChdDiscriminatedTypeAdbCodeFunction
		invokeFromValues:
			(OrderedCollection new
				add: aReceiver;
				yourself)

! !

!ExChdDiscriminatedType methodsFor: 'platypus-generated-deriving' stamp: ''!
adbInterfacesList
	^ self adbInterfacesListUsingContext: self class context

! !

!ExChdDiscriminatedType methodsFor: 'platypus-generated-deriving' stamp: ''!
adbInterfacesListUsingContext: aContext
	^ self adbInterfacesListUsingContext: aContext receiver: self

! !

!ExChdDiscriminatedType methodsFor: 'platypus-generated-deriving' stamp: ''!
adbInterfacesListUsingContext: aContext receiver: aReceiver
	^ ExChdDiscriminatedTypeInterfacesListFunction
		invokeFromValues:
			(OrderedCollection new
				add: aReceiver;
				add: false;
				yourself)

! !

!ExChdDiscriminatedType methodsFor: 'platypus-generated-deriving' stamp: ''!
adsCode
	^ self adsCodeUsingContext: self class context

! !

!ExChdDiscriminatedType methodsFor: 'platypus-generated-deriving' stamp: ''!
adsCodeUsingContext: aContext
	^ self adsCodeUsingContext: aContext receiver: self

! !

!ExChdDiscriminatedType methodsFor: 'platypus-generated-deriving' stamp: ''!
adsCodeUsingContext: aContext receiver: aReceiver
	^ ExChdDiscriminatedTypeAdsCodeFunction
		invokeFromValues:
			(OrderedCollection new
				add: aReceiver;
				yourself)

! !

!ExChdDiscriminatedType methodsFor: 'platypus-generated-deriving' stamp: ''!
adsInterfacesList
	^ self adsInterfacesListUsingContext: self class context

! !

!ExChdDiscriminatedType methodsFor: 'platypus-generated-deriving' stamp: ''!
adsInterfacesListUsingContext: aContext
	^ self adsInterfacesListUsingContext: aContext receiver: self

! !

!ExChdDiscriminatedType methodsFor: 'platypus-generated-deriving' stamp: ''!
adsInterfacesListUsingContext: aContext receiver: aReceiver
	^ ExChdDiscriminatedTypeInterfacesListFunction
		invokeFromValues:
			(OrderedCollection new
				add: aReceiver;
				add: true;
				yourself)

! !

!ExChdDiscriminatedType methodsFor: 'platypus-generated-deriving' stamp: ''!
discriminant
	^ self discriminantUsingContext: self class context

! !

!ExChdDiscriminatedType methodsFor: 'platypus-generated-deriving' stamp: ''!
discriminantUsingContext: aContext
	^ self discriminantUsingContext: aContext receiver: self

! !

!ExChdDiscriminatedType methodsFor: 'platypus-generated-deriving' stamp: ''!
discriminantUsingContext: aContext receiver: aReceiver
	^ (aReceiver attributes
		select: [ :attr1379 | 
			(PltTYPEOFFunction
				invokeFromValues:
					(OrderedCollection new
						add: attr1379;
						yourself)) includes: 'DISCRIMINATED_TYPE.DISCRIMINATED_TYPE_DISCRIMINANT' ]) pltAt: 1

! !

!ExChdDiscriminatedType methodsFor: 'platypus-generated-copying' stamp: ''!
discriminatedTypeCopyTo: another
	

! !

!ExChdDiscriminatedType methodsFor: 'platypus-generated-group-accessing' stamp: ''!
discriminatedTypeFromValues: values
	| valuesloc |
	valuesloc := values asOrderedCollection.
	^ valuesloc

! !

!ExChdDiscriminatedType methodsFor: 'platypus-generated-group-accessing' stamp: ''!
discriminatedTypeToValues: values
	^ values

! !

!ExChdDiscriminatedType methodsFor: 'platypus-generated-group-accessing' stamp: ''!
fromValues: values
	^ self discriminatedTypeFromValues: (super fromValues: values)

! !

!ExChdDiscriminatedType methodsFor: 'platypus-generated-classifying' stamp: ''!
isExChdDiscriminatedType
	^ true

! !

!ExChdDiscriminatedType methodsFor: 'platypus-generated-group-accessing' stamp: ''!
localFromValues: values
	^ self discriminatedTypeFromValues: values

! !

!ExChdDiscriminatedType methodsFor: 'platypus-generated-group-accessing' stamp: ''!
localToValues: values
	^ self discriminatedTypeToValues: values

! !

!ExChdDiscriminatedType methodsFor: 'platypus-generated-copying' stamp: ''!
pltCopyGroup: aClassSymbol to: anObject
	self class name == aClassSymbol
		ifTrue: [ self pltCopyTo: anObject ]
		ifFalse: [ super pltCopyGroup: aClassSymbol to: anObject ]

! !

!ExChdDiscriminatedType methodsFor: 'platypus-generated-copying' stamp: ''!
pltCopyTo: another
	super pltCopyTo: another.
	self discriminatedTypeCopyTo: another

! !

!ExChdDiscriminatedType methodsFor: 'platypus-generated-copying' stamp: ''!
pltLocalCopyTo: another
	self discriminatedTypeCopyTo: another

! !

!ExChdDiscriminatedType methodsFor: 'platypus-generated-deriving' stamp: ''!
refedByPointer
	^ self refedByPointerUsingContext: self class context

! !

!ExChdDiscriminatedType methodsFor: 'platypus-generated-deriving' stamp: ''!
refedByPointerUsingContext: aContext
	^ self refedByPointerUsingContext: aContext receiver: self

! !

!ExChdDiscriminatedType methodsFor: 'platypus-generated-deriving' stamp: ''!
refedByPointerUsingContext: aContext receiver: aReceiver
	^ false

! !

!ExChdDiscriminatedType methodsFor: 'platypus-generated-initializing' stamp: ''!
stepInitialize
	super stepInitialize

! !

!ExChdDiscriminatedType methodsFor: 'platypus-generated-deriving' stamp: ''!
tailAttributes
	^ self tailAttributesUsingContext: self class context

! !

!ExChdDiscriminatedType methodsFor: 'platypus-generated-deriving' stamp: ''!
tailAttributesUsingContext: aContext
	^ self tailAttributesUsingContext: aContext receiver: self

! !

!ExChdDiscriminatedType methodsFor: 'platypus-generated-deriving' stamp: ''!
tailAttributesUsingContext: aContext receiver: aReceiver
	^ ExChdDiscriminatedTypeTailsAttributesFunction
		invokeFromValues:
			(OrderedCollection new
				add: aReceiver;
				yourself)

! !

!ExChdDiscriminatedType methodsFor: 'platypus-generated-group-accessing' stamp: ''!
toValues: values
	^ self discriminatedTypeToValues: (super toValues: values)

! !

!ExChdDiscriminatedType methodsFor: 'platypus-generated-deriving' stamp: ''!
translatedAttributes
	^ self translatedAttributesUsingContext: self class context

! !

!ExChdDiscriminatedType methodsFor: 'platypus-generated-deriving' stamp: ''!
translatedAttributesUsingContext: aContext
	^ self translatedAttributesUsingContext: aContext receiver: self

! !

!ExChdDiscriminatedType methodsFor: 'platypus-generated-deriving' stamp: ''!
translatedAttributesUsingContext: aContext receiver: aReceiver
	^ ((aReceiver explicitAttributesUsingContext: aContext) pltMinus: (aReceiver discriminantUsingContext: aContext))
		pltMinus: (aReceiver unionAttrUsingContext: aContext)

! !

!ExChdDiscriminatedType methodsFor: 'platypus-generated-deriving' stamp: ''!
unionAttr
	^ self unionAttrUsingContext: self class context

! !

!ExChdDiscriminatedType methodsFor: 'platypus-generated-deriving' stamp: ''!
unionAttrUsingContext: aContext
	^ self unionAttrUsingContext: aContext receiver: self

! !

!ExChdDiscriminatedType methodsFor: 'platypus-generated-deriving' stamp: ''!
unionAttrUsingContext: aContext receiver: aReceiver
	^ (aReceiver attributes
		select: [ :attr593 | 
			(PltTYPEOFFunction
				invokeFromValues:
					(OrderedCollection new
						add: attr593;
						yourself)) includes: 'DISCRIMINATED_TYPE.DISCRIMINATED_TYPE_UNION' ]) pltAt: 1

! !

!ExChdDiscriminatedType methodsFor: 'platypus-generated-deriving' stamp: ''!
xmlIoRecordCode
	^ self xmlIoRecordCodeUsingContext: self class context

! !

!ExChdDiscriminatedType methodsFor: 'platypus-generated-deriving' stamp: ''!
xmlIoRecordCodeUsingContext: aContext
	^ self xmlIoRecordCodeUsingContext: aContext receiver: self

! !

!ExChdDiscriminatedType methodsFor: 'platypus-generated-deriving' stamp: ''!
xmlIoRecordCodeUsingContext: aContext receiver: aReceiver
	^ ExChdDiscriminatedTypeXmlIoRecordCodeFunction
		invokeFromValues:
			(OrderedCollection new
				add: aReceiver;
				yourself)

! !

ExChdAdaEntity subclass: #ExChdDiscriminatedTypeUnionElementType
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Express2Cheddar-DiscriminatedTypeSchema'!

!ExChdDiscriminatedTypeUnionElementType commentStamp: 'platypus comment' prior: 0!
<ISO10303-11-EXPRESS>
ENTITY discriminated_type_union_element_type 
	SUBTYPE OF ( ada_entity );
DERIVE
	ads_interfaces_list : LIST OF ada_interface := [ ];
	adb_interfaces_list : LIST OF ada_interface := [ ];
	ads_code : STRING := '';
	adb_code : STRING := '';
	union_ads_code : STRING := discriminated_type_union_element_case_code ( SELF );
END_ENTITY;
</ISO10303-11-EXPRESS>!

!ExChdDiscriminatedTypeUnionElementType class methodsFor: 'platypus-generated-platypus-signature' stamp: ''!
iso10303P11Translater
	^ 'Platypus (c) LISYC EA3883, Universite de Bretagne occidentale. Brest.'

! !

!ExChdDiscriminatedTypeUnionElementType class methodsFor: 'platypus-generated-meta-data-accessing' stamp: ''!
schemaDefinition
	^ ExChdDiscriminatedTypeSchemaDefinition singleton

! !

!ExChdDiscriminatedTypeUnionElementType class methodsFor: 'platypus-generated-meta-data-accessing' stamp: ''!
schemaInstance
	^ ExChdExpress2cheddarSchemaInstance singleton

! !

!ExChdDiscriminatedTypeUnionElementType class methodsFor: 'platypus-generated-platypus-signature' stamp: ''!
translatedFromISO10303P11
	^ true

! !

!ExChdDiscriminatedTypeUnionElementType class methodsFor: 'platypus-generated-platypus-signature' stamp: ''!
vwNamespaceName
	^ #Express2Cheddar

! !

!ExChdDiscriminatedTypeUnionElementType methodsFor: 'platypus-generated-visiting' stamp: ''!
accept: aVisitor
	^ aVisitor acceptDiscriminatedTypeUnionElementType: self

! !

!ExChdDiscriminatedTypeUnionElementType methodsFor: 'platypus-generated-deriving' stamp: ''!
adbCode
	^ self adbCodeUsingContext: self class context

! !

!ExChdDiscriminatedTypeUnionElementType methodsFor: 'platypus-generated-deriving' stamp: ''!
adbCodeUsingContext: aContext
	^ self adbCodeUsingContext: aContext receiver: self

! !

!ExChdDiscriminatedTypeUnionElementType methodsFor: 'platypus-generated-deriving' stamp: ''!
adbCodeUsingContext: aContext receiver: aReceiver
	^ ''

! !

!ExChdDiscriminatedTypeUnionElementType methodsFor: 'platypus-generated-deriving' stamp: ''!
adbInterfacesList
	^ self adbInterfacesListUsingContext: self class context

! !

!ExChdDiscriminatedTypeUnionElementType methodsFor: 'platypus-generated-deriving' stamp: ''!
adbInterfacesListUsingContext: aContext
	^ self adbInterfacesListUsingContext: aContext receiver: self

! !

!ExChdDiscriminatedTypeUnionElementType methodsFor: 'platypus-generated-deriving' stamp: ''!
adbInterfacesListUsingContext: aContext receiver: aReceiver
	^ Array new

! !

!ExChdDiscriminatedTypeUnionElementType methodsFor: 'platypus-generated-deriving' stamp: ''!
adsCode
	^ self adsCodeUsingContext: self class context

! !

!ExChdDiscriminatedTypeUnionElementType methodsFor: 'platypus-generated-deriving' stamp: ''!
adsCodeUsingContext: aContext
	^ self adsCodeUsingContext: aContext receiver: self

! !

!ExChdDiscriminatedTypeUnionElementType methodsFor: 'platypus-generated-deriving' stamp: ''!
adsCodeUsingContext: aContext receiver: aReceiver
	^ ''

! !

!ExChdDiscriminatedTypeUnionElementType methodsFor: 'platypus-generated-deriving' stamp: ''!
adsInterfacesList
	^ self adsInterfacesListUsingContext: self class context

! !

!ExChdDiscriminatedTypeUnionElementType methodsFor: 'platypus-generated-deriving' stamp: ''!
adsInterfacesListUsingContext: aContext
	^ self adsInterfacesListUsingContext: aContext receiver: self

! !

!ExChdDiscriminatedTypeUnionElementType methodsFor: 'platypus-generated-deriving' stamp: ''!
adsInterfacesListUsingContext: aContext receiver: aReceiver
	^ Array new

! !

!ExChdDiscriminatedTypeUnionElementType methodsFor: 'platypus-generated-copying' stamp: ''!
discriminatedTypeUnionElementTypeCopyTo: another
	

! !

!ExChdDiscriminatedTypeUnionElementType methodsFor: 'platypus-generated-group-accessing' stamp: ''!
discriminatedTypeUnionElementTypeFromValues: values
	| valuesloc |
	valuesloc := values asOrderedCollection.
	^ valuesloc

! !

!ExChdDiscriminatedTypeUnionElementType methodsFor: 'platypus-generated-group-accessing' stamp: ''!
discriminatedTypeUnionElementTypeToValues: values
	^ values

! !

!ExChdDiscriminatedTypeUnionElementType methodsFor: 'platypus-generated-group-accessing' stamp: ''!
fromValues: values
	^ self discriminatedTypeUnionElementTypeFromValues: (super fromValues: values)

! !

!ExChdDiscriminatedTypeUnionElementType methodsFor: 'platypus-generated-classifying' stamp: ''!
isExChdDiscriminatedTypeUnionElementType
	^ true

! !

!ExChdDiscriminatedTypeUnionElementType methodsFor: 'platypus-generated-group-accessing' stamp: ''!
localFromValues: values
	^ self discriminatedTypeUnionElementTypeFromValues: values

! !

!ExChdDiscriminatedTypeUnionElementType methodsFor: 'platypus-generated-group-accessing' stamp: ''!
localToValues: values
	^ self discriminatedTypeUnionElementTypeToValues: values

! !

!ExChdDiscriminatedTypeUnionElementType methodsFor: 'platypus-generated-copying' stamp: ''!
pltCopyGroup: aClassSymbol to: anObject
	self class name == aClassSymbol
		ifTrue: [ self pltCopyTo: anObject ]
		ifFalse: [ super pltCopyGroup: aClassSymbol to: anObject ]

! !

!ExChdDiscriminatedTypeUnionElementType methodsFor: 'platypus-generated-copying' stamp: ''!
pltCopyTo: another
	super pltCopyTo: another.
	self discriminatedTypeUnionElementTypeCopyTo: another

! !

!ExChdDiscriminatedTypeUnionElementType methodsFor: 'platypus-generated-copying' stamp: ''!
pltLocalCopyTo: another
	self discriminatedTypeUnionElementTypeCopyTo: another

! !

!ExChdDiscriminatedTypeUnionElementType methodsFor: 'platypus-generated-initializing' stamp: ''!
stepInitialize
	super stepInitialize

! !

!ExChdDiscriminatedTypeUnionElementType methodsFor: 'platypus-generated-group-accessing' stamp: ''!
toValues: values
	^ self discriminatedTypeUnionElementTypeToValues: (super toValues: values)

! !

!ExChdDiscriminatedTypeUnionElementType methodsFor: 'platypus-generated-deriving' stamp: ''!
unionAdsCode
	^ self unionAdsCodeUsingContext: self class context

! !

!ExChdDiscriminatedTypeUnionElementType methodsFor: 'platypus-generated-deriving' stamp: ''!
unionAdsCodeUsingContext: aContext
	^ self unionAdsCodeUsingContext: aContext receiver: self

! !

!ExChdDiscriminatedTypeUnionElementType methodsFor: 'platypus-generated-deriving' stamp: ''!
unionAdsCodeUsingContext: aContext receiver: aReceiver
	^ ExChdDiscriminatedTypeUnionElementCaseCodeFunction
		invokeFromValues:
			(OrderedCollection new
				add: aReceiver;
				yourself)

! !

ExChdAdaEntity subclass: #ExChdDiscriminatedTypeUnionType
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Express2Cheddar-DiscriminatedTypeSchema'!

!ExChdDiscriminatedTypeUnionType commentStamp: 'platypus comment' prior: 0!
<ISO10303-11-EXPRESS>
ENTITY discriminated_type_union_type 
	SUBTYPE OF ( ada_entity );
DERIVE
	ads_interfaces_list : LIST OF ada_interface := discriminated_type_union_type_interfaces_list ( SELF, true );
	adb_interfaces_list : LIST OF ada_interface := discriminated_type_union_type_interfaces_list ( SELF, false );
	ads_code : STRING := '';
	adb_code : STRING := '';
	union_ads_code : STRING := discriminated_type_union_case_code ( SELF );
	all_attributes : LIST OF attribute := inherited_explicit_attributes ( SELF );
END_ENTITY;
</ISO10303-11-EXPRESS>!

!ExChdDiscriminatedTypeUnionType class methodsFor: 'platypus-generated-platypus-signature' stamp: ''!
iso10303P11Translater
	^ 'Platypus (c) LISYC EA3883, Universite de Bretagne occidentale. Brest.'

! !

!ExChdDiscriminatedTypeUnionType class methodsFor: 'platypus-generated-meta-data-accessing' stamp: ''!
schemaDefinition
	^ ExChdDiscriminatedTypeSchemaDefinition singleton

! !

!ExChdDiscriminatedTypeUnionType class methodsFor: 'platypus-generated-meta-data-accessing' stamp: ''!
schemaInstance
	^ ExChdExpress2cheddarSchemaInstance singleton

! !

!ExChdDiscriminatedTypeUnionType class methodsFor: 'platypus-generated-platypus-signature' stamp: ''!
translatedFromISO10303P11
	^ true

! !

!ExChdDiscriminatedTypeUnionType class methodsFor: 'platypus-generated-platypus-signature' stamp: ''!
vwNamespaceName
	^ #Express2Cheddar

! !

!ExChdDiscriminatedTypeUnionType methodsFor: 'platypus-generated-visiting' stamp: ''!
accept: aVisitor
	^ aVisitor acceptDiscriminatedTypeUnionType: self

! !

!ExChdDiscriminatedTypeUnionType methodsFor: 'platypus-generated-deriving' stamp: ''!
adbCode
	^ self adbCodeUsingContext: self class context

! !

!ExChdDiscriminatedTypeUnionType methodsFor: 'platypus-generated-deriving' stamp: ''!
adbCodeUsingContext: aContext
	^ self adbCodeUsingContext: aContext receiver: self

! !

!ExChdDiscriminatedTypeUnionType methodsFor: 'platypus-generated-deriving' stamp: ''!
adbCodeUsingContext: aContext receiver: aReceiver
	^ ''

! !

!ExChdDiscriminatedTypeUnionType methodsFor: 'platypus-generated-deriving' stamp: ''!
adbInterfacesList
	^ self adbInterfacesListUsingContext: self class context

! !

!ExChdDiscriminatedTypeUnionType methodsFor: 'platypus-generated-deriving' stamp: ''!
adbInterfacesListUsingContext: aContext
	^ self adbInterfacesListUsingContext: aContext receiver: self

! !

!ExChdDiscriminatedTypeUnionType methodsFor: 'platypus-generated-deriving' stamp: ''!
adbInterfacesListUsingContext: aContext receiver: aReceiver
	^ ExChdDiscriminatedTypeUnionTypeInterfacesListFunction
		invokeFromValues:
			(OrderedCollection new
				add: aReceiver;
				add: false;
				yourself)

! !

!ExChdDiscriminatedTypeUnionType methodsFor: 'platypus-generated-deriving' stamp: ''!
adsCode
	^ self adsCodeUsingContext: self class context

! !

!ExChdDiscriminatedTypeUnionType methodsFor: 'platypus-generated-deriving' stamp: ''!
adsCodeUsingContext: aContext
	^ self adsCodeUsingContext: aContext receiver: self

! !

!ExChdDiscriminatedTypeUnionType methodsFor: 'platypus-generated-deriving' stamp: ''!
adsCodeUsingContext: aContext receiver: aReceiver
	^ ''

! !

!ExChdDiscriminatedTypeUnionType methodsFor: 'platypus-generated-deriving' stamp: ''!
adsInterfacesList
	^ self adsInterfacesListUsingContext: self class context

! !

!ExChdDiscriminatedTypeUnionType methodsFor: 'platypus-generated-deriving' stamp: ''!
adsInterfacesListUsingContext: aContext
	^ self adsInterfacesListUsingContext: aContext receiver: self

! !

!ExChdDiscriminatedTypeUnionType methodsFor: 'platypus-generated-deriving' stamp: ''!
adsInterfacesListUsingContext: aContext receiver: aReceiver
	^ ExChdDiscriminatedTypeUnionTypeInterfacesListFunction
		invokeFromValues:
			(OrderedCollection new
				add: aReceiver;
				add: true;
				yourself)

! !

!ExChdDiscriminatedTypeUnionType methodsFor: 'platypus-generated-deriving' stamp: ''!
allAttributes
	^ self allAttributesUsingContext: self class context

! !

!ExChdDiscriminatedTypeUnionType methodsFor: 'platypus-generated-deriving' stamp: ''!
allAttributesUsingContext: aContext
	^ self allAttributesUsingContext: aContext receiver: self

! !

!ExChdDiscriminatedTypeUnionType methodsFor: 'platypus-generated-deriving' stamp: ''!
allAttributesUsingContext: aContext receiver: aReceiver
	^ PTsInheritedExplicitAttributesFunction
		invokeFromValues:
			(OrderedCollection new
				add: aReceiver;
				yourself)

! !

!ExChdDiscriminatedTypeUnionType methodsFor: 'platypus-generated-copying' stamp: ''!
discriminatedTypeUnionTypeCopyTo: another
	

! !

!ExChdDiscriminatedTypeUnionType methodsFor: 'platypus-generated-group-accessing' stamp: ''!
discriminatedTypeUnionTypeFromValues: values
	| valuesloc |
	valuesloc := values asOrderedCollection.
	^ valuesloc

! !

!ExChdDiscriminatedTypeUnionType methodsFor: 'platypus-generated-group-accessing' stamp: ''!
discriminatedTypeUnionTypeToValues: values
	^ values

! !

!ExChdDiscriminatedTypeUnionType methodsFor: 'platypus-generated-group-accessing' stamp: ''!
fromValues: values
	^ self discriminatedTypeUnionTypeFromValues: (super fromValues: values)

! !

!ExChdDiscriminatedTypeUnionType methodsFor: 'platypus-generated-classifying' stamp: ''!
isExChdDiscriminatedTypeUnionType
	^ true

! !

!ExChdDiscriminatedTypeUnionType methodsFor: 'platypus-generated-group-accessing' stamp: ''!
localFromValues: values
	^ self discriminatedTypeUnionTypeFromValues: values

! !

!ExChdDiscriminatedTypeUnionType methodsFor: 'platypus-generated-group-accessing' stamp: ''!
localToValues: values
	^ self discriminatedTypeUnionTypeToValues: values

! !

!ExChdDiscriminatedTypeUnionType methodsFor: 'platypus-generated-copying' stamp: ''!
pltCopyGroup: aClassSymbol to: anObject
	self class name == aClassSymbol
		ifTrue: [ self pltCopyTo: anObject ]
		ifFalse: [ super pltCopyGroup: aClassSymbol to: anObject ]

! !

!ExChdDiscriminatedTypeUnionType methodsFor: 'platypus-generated-copying' stamp: ''!
pltCopyTo: another
	super pltCopyTo: another.
	self discriminatedTypeUnionTypeCopyTo: another

! !

!ExChdDiscriminatedTypeUnionType methodsFor: 'platypus-generated-copying' stamp: ''!
pltLocalCopyTo: another
	self discriminatedTypeUnionTypeCopyTo: another

! !

!ExChdDiscriminatedTypeUnionType methodsFor: 'platypus-generated-initializing' stamp: ''!
stepInitialize
	super stepInitialize

! !

!ExChdDiscriminatedTypeUnionType methodsFor: 'platypus-generated-group-accessing' stamp: ''!
toValues: values
	^ self discriminatedTypeUnionTypeToValues: (super toValues: values)

! !

!ExChdDiscriminatedTypeUnionType methodsFor: 'platypus-generated-deriving' stamp: ''!
unionAdsCode
	^ self unionAdsCodeUsingContext: self class context

! !

!ExChdDiscriminatedTypeUnionType methodsFor: 'platypus-generated-deriving' stamp: ''!
unionAdsCodeUsingContext: aContext
	^ self unionAdsCodeUsingContext: aContext receiver: self

! !

!ExChdDiscriminatedTypeUnionType methodsFor: 'platypus-generated-deriving' stamp: ''!
unionAdsCodeUsingContext: aContext receiver: aReceiver
	^ ExChdDiscriminatedTypeUnionCaseCodeFunction
		invokeFromValues:
			(OrderedCollection new
				add: aReceiver;
				yourself)

! !

ExChdAdaEntity subclass: #ExChdGenericPackageInstanciation
	instanceVariableNames: 'genericPackageName parameters interfaces'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Express2Cheddar-PackageSchema'!

!ExChdGenericPackageInstanciation commentStamp: 'platypus comment' prior: 0!
<ISO10303-11-EXPRESS>
ENTITY generic_package_instanciation 
	SUBTYPE OF ( ada_entity );
	generic_package_name : STRING;
	parameters : LIST OF STRING;
	interfaces : LIST OF ada_interface;
DERIVE
	aliases : LIST OF cheddar_defined_type := generic_package_aliases ( SELF );
	ads_interfaces_list : LIST OF ada_interface := [ ada_interface ( SELF.generic_package_name, ?, true, false ), ada_interface ( SELF.owner.name, SELF.name, false, true ), ada_interface ( 'Unchecked_Deallocation', ?, true, false ) ] + interfaces;
	adb_interfaces_list : LIST OF ada_interface := [ ];
	ads_code : STRING := 'package ' + ada_ident + ' is new ' + generic_package_name + '(' + StringAggregateConcatSeparatedBy ( parameters, ', ' ) + ');\n' 
	+ 'use ' + ada_ident + ';\n' 
	+ generic_package_instanciation_attributes_ads_code ( SELF );
	adb_code : STRING := '';
END_ENTITY;
</ISO10303-11-EXPRESS>!

!ExChdGenericPackageInstanciation class methodsFor: 'platypus-generated-platypus-signature' stamp: ''!
iso10303P11Translater
	^ 'Platypus (c) LISYC EA3883, Universite de Bretagne occidentale. Brest.'

! !

!ExChdGenericPackageInstanciation class methodsFor: 'platypus-generated-meta-data-accessing' stamp: ''!
schemaDefinition
	^ ExChdPackageSchemaDefinition singleton

! !

!ExChdGenericPackageInstanciation class methodsFor: 'platypus-generated-meta-data-accessing' stamp: ''!
schemaInstance
	^ ExChdExpress2cheddarSchemaInstance singleton

! !

!ExChdGenericPackageInstanciation class methodsFor: 'platypus-generated-platypus-signature' stamp: ''!
translatedFromISO10303P11
	^ true

! !

!ExChdGenericPackageInstanciation class methodsFor: 'platypus-generated-platypus-signature' stamp: ''!
vwNamespaceName
	^ #Express2Cheddar

! !

!ExChdGenericPackageInstanciation methodsFor: 'platypus-generated-visiting' stamp: ''!
accept: aVisitor
	^ aVisitor acceptGenericPackageInstanciation: self

! !

!ExChdGenericPackageInstanciation methodsFor: 'platypus-generated-deriving' stamp: ''!
adbCode
	^ self adbCodeUsingContext: self class context

! !

!ExChdGenericPackageInstanciation methodsFor: 'platypus-generated-deriving' stamp: ''!
adbCodeUsingContext: aContext
	^ self adbCodeUsingContext: aContext receiver: self

! !

!ExChdGenericPackageInstanciation methodsFor: 'platypus-generated-deriving' stamp: ''!
adbCodeUsingContext: aContext receiver: aReceiver
	^ ''

! !

!ExChdGenericPackageInstanciation methodsFor: 'platypus-generated-deriving' stamp: ''!
adbInterfacesList
	^ self adbInterfacesListUsingContext: self class context

! !

!ExChdGenericPackageInstanciation methodsFor: 'platypus-generated-deriving' stamp: ''!
adbInterfacesListUsingContext: aContext
	^ self adbInterfacesListUsingContext: aContext receiver: self

! !

!ExChdGenericPackageInstanciation methodsFor: 'platypus-generated-deriving' stamp: ''!
adbInterfacesListUsingContext: aContext receiver: aReceiver
	^ Array new

! !

!ExChdGenericPackageInstanciation methodsFor: 'platypus-generated-deriving' stamp: ''!
adsCode
	^ self adsCodeUsingContext: self class context

! !

!ExChdGenericPackageInstanciation methodsFor: 'platypus-generated-deriving' stamp: ''!
adsCodeUsingContext: aContext
	^ self adsCodeUsingContext: aContext receiver: self

! !

!ExChdGenericPackageInstanciation methodsFor: 'platypus-generated-deriving' stamp: ''!
adsCodeUsingContext: aContext receiver: aReceiver
	^ ((((((((('package ' pltPlus: (aReceiver adaIdentUsingContext: aContext)) pltPlus: ' is new ')
		pltPlus: aReceiver genericPackageName) pltPlus: '(')
		pltPlus:
			(PTsStringAggregateConcatSeparatedByFunction
				invokeFromValues:
					(OrderedCollection new
						add: aReceiver parameters;
						add: ', ';
						yourself))) pltPlus: ');\n') pltPlus: 'use ') pltPlus: (aReceiver adaIdentUsingContext: aContext)) pltPlus: ';\n')
		pltPlus:
			(ExChdGenericPackageInstanciationAttributesAdsCodeFunction
				invokeFromValues:
					(OrderedCollection new
						add: aReceiver;
						yourself))

! !

!ExChdGenericPackageInstanciation methodsFor: 'platypus-generated-deriving' stamp: ''!
adsInterfacesList
	^ self adsInterfacesListUsingContext: self class context

! !

!ExChdGenericPackageInstanciation methodsFor: 'platypus-generated-deriving' stamp: ''!
adsInterfacesListUsingContext: aContext
	^ self adsInterfacesListUsingContext: aContext receiver: self

! !

!ExChdGenericPackageInstanciation methodsFor: 'platypus-generated-deriving' stamp: ''!
adsInterfacesListUsingContext: aContext receiver: aReceiver
	^ (PlatypusCoreAggregateInitializer
		collectionFrom:
			(OrderedCollection new
				add:
						(ExChdAdaInterface new
								adaInterfaceFromValues:
										(OrderedCollection new
												add: (aReceiver genericPackageNameUsingContext: self class context);
												add: nil;
												add: true;
												add: false;
												yourself);
								yourself);
				add:
						(ExChdAdaInterface new
								adaInterfaceFromValues:
										(OrderedCollection new
												add: ((aReceiver ownerUsingContext: self class context) nameUsingContext: self class context);
												add: (aReceiver nameUsingContext: self class context);
												add: false;
												add: true;
												yourself);
								yourself);
				add:
						(ExChdAdaInterface new
								adaInterfaceFromValues:
										(OrderedCollection new
												add: 'Unchecked_Deallocation';
												add: nil;
												add: true;
												add: false;
												yourself);
								yourself);
				yourself)) pltPlus: aReceiver interfaces

! !

!ExChdGenericPackageInstanciation methodsFor: 'platypus-generated-deriving' stamp: ''!
aliases
	^ self aliasesUsingContext: self class context

! !

!ExChdGenericPackageInstanciation methodsFor: 'platypus-generated-deriving' stamp: ''!
aliasesUsingContext: aContext
	^ self aliasesUsingContext: aContext receiver: self

! !

!ExChdGenericPackageInstanciation methodsFor: 'platypus-generated-deriving' stamp: ''!
aliasesUsingContext: aContext receiver: aReceiver
	^ ExChdGenericPackageAliasesFunction
		invokeFromValues:
			(OrderedCollection new
				add: aReceiver;
				yourself)

! !

!ExChdGenericPackageInstanciation methodsFor: 'platypus-generated-fast-set-accessing' stamp: ''!
fastSetGenericPackageName: aString
	genericPackageName := aString

! !

!ExChdGenericPackageInstanciation methodsFor: 'platypus-generated-fast-set-accessing' stamp: ''!
fastSetInterfaces: aListOfExChdAdaInterface
	interfaces := aListOfExChdAdaInterface

! !

!ExChdGenericPackageInstanciation methodsFor: 'platypus-generated-fast-set-accessing' stamp: ''!
fastSetParameters: aListOfString
	parameters := aListOfString

! !

!ExChdGenericPackageInstanciation methodsFor: 'platypus-generated-group-accessing' stamp: ''!
fromValues: values
	^ self genericPackageInstanciationFromValues: (super fromValues: values)

! !

!ExChdGenericPackageInstanciation methodsFor: 'platypus-generated-copying' stamp: ''!
genericPackageInstanciationCopyTo: another
	another fastSetGenericPackageName: self genericPackageName.
	another fastSetParameters: self parameters.
	another fastSetInterfaces: self interfaces

! !

!ExChdGenericPackageInstanciation methodsFor: 'platypus-generated-group-accessing' stamp: ''!
genericPackageInstanciationFromValues: values
	| valuesloc |
	valuesloc := values asOrderedCollection.
	self setGenericPackageName: valuesloc removeFirst.
	self setParameters: valuesloc removeFirst.
	self setInterfaces: valuesloc removeFirst.
	^ valuesloc

! !

!ExChdGenericPackageInstanciation methodsFor: 'platypus-generated-group-accessing' stamp: ''!
genericPackageInstanciationToValues: values
	values add: self genericPackageName.
	values add: self parameters.
	values add: self interfaces.
	^ values

! !

!ExChdGenericPackageInstanciation methodsFor: 'platypus-generated-accessing' stamp: ''!
genericPackageName
	^ genericPackageName

! !

!ExChdGenericPackageInstanciation methodsFor: 'platypus-generated-accessing' stamp: ''!
genericPackageName: aString
	genericPackageName := aString

! !

!ExChdGenericPackageInstanciation methodsFor: 'platypus-generated-with-context-accessing' stamp: ''!
genericPackageNameUsingContext: aContext
	^ self genericPackageName

! !

!ExChdGenericPackageInstanciation methodsFor: 'platypus-generated-accessing' stamp: ''!
interfaces
	^ interfaces

! !

!ExChdGenericPackageInstanciation methodsFor: 'platypus-generated-accessing' stamp: ''!
interfaces: aListOfExChdAdaInterface
	interfaces := aListOfExChdAdaInterface
		ifNil: [ OrderedCollection new ]
		ifNotNil: [ aListOfExChdAdaInterface as: OrderedCollection ]

! !

!ExChdGenericPackageInstanciation methodsFor: 'platypus-generated-with-context-accessing' stamp: ''!
interfacesUsingContext: aContext
	^ self interfaces

! !

!ExChdGenericPackageInstanciation methodsFor: 'platypus-generated-classifying' stamp: ''!
isExChdGenericPackageInstanciation
	^ true

! !

!ExChdGenericPackageInstanciation methodsFor: 'platypus-generated-group-accessing' stamp: ''!
localFromValues: values
	^ self genericPackageInstanciationFromValues: values

! !

!ExChdGenericPackageInstanciation methodsFor: 'platypus-generated-group-accessing' stamp: ''!
localToValues: values
	^ self genericPackageInstanciationToValues: values

! !

!ExChdGenericPackageInstanciation methodsFor: 'platypus-generated-accessing' stamp: ''!
parameters
	^ parameters

! !

!ExChdGenericPackageInstanciation methodsFor: 'platypus-generated-accessing' stamp: ''!
parameters: aListOfString
	parameters := aListOfString ifNil: [ OrderedCollection new ] ifNotNil: [ aListOfString as: OrderedCollection ]

! !

!ExChdGenericPackageInstanciation methodsFor: 'platypus-generated-with-context-accessing' stamp: ''!
parametersUsingContext: aContext
	^ self parameters

! !

!ExChdGenericPackageInstanciation methodsFor: 'platypus-generated-copying' stamp: ''!
pltCopyGroup: aClassSymbol to: anObject
	self class name == aClassSymbol
		ifTrue: [ self pltCopyTo: anObject ]
		ifFalse: [ super pltCopyGroup: aClassSymbol to: anObject ]

! !

!ExChdGenericPackageInstanciation methodsFor: 'platypus-generated-copying' stamp: ''!
pltCopyTo: another
	super pltCopyTo: another.
	self genericPackageInstanciationCopyTo: another

! !

!ExChdGenericPackageInstanciation methodsFor: 'platypus-generated-copying' stamp: ''!
pltLocalCopyTo: another
	self genericPackageInstanciationCopyTo: another

! !

!ExChdGenericPackageInstanciation methodsFor: 'platypus-generated-set-accessing' stamp: ''!
setGenericPackageName: aString
	self genericPackageName: aString

! !

!ExChdGenericPackageInstanciation methodsFor: 'platypus-generated-set-accessing' stamp: ''!
setInterfaces: aListOfExChdAdaInterface
	self interfaces: aListOfExChdAdaInterface

! !

!ExChdGenericPackageInstanciation methodsFor: 'platypus-generated-set-accessing' stamp: ''!
setParameters: aListOfString
	self parameters: aListOfString

! !

!ExChdGenericPackageInstanciation methodsFor: 'platypus-generated-initializing' stamp: ''!
stepInitialize
	super stepInitialize.
	genericPackageName := ''.
	parameters := OrderedCollection new.
	interfaces := OrderedCollection new

! !

!ExChdGenericPackageInstanciation methodsFor: 'platypus-generated-group-accessing' stamp: ''!
toValues: values
	^ self genericPackageInstanciationToValues: (super toValues: values)

! !

ExChdAdaEntity subclass: #ExChdRecord
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Express2Cheddar-RecordAndClassSchema'!

!ExChdRecord commentStamp: 'platypus comment' prior: 0!
<ISO10303-11-EXPRESS>
ENTITY record 
	SUBTYPE OF ( ada_entity );
DERIVE
	ads_code : STRING := record_ads_code ( SELF );
	adb_code : STRING := record_adb_code ( SELF );
	ads_interfaces_list : LIST OF ada_interface := ada_entity_interfaces_list ( SELF, true );
	adb_interfaces_list : LIST OF ada_interface := ada_entity_interfaces_list ( SELF, false );
	SELF\ada_entity.xml_writer_code : STRING := record_xml_writer_code ( SELF );
	SELF\ada_entity.xml_io_record_code : STRING := record_xml_io_record_code ( SELF );
END_ENTITY;
</ISO10303-11-EXPRESS>!

!ExChdRecord class methodsFor: 'platypus-generated-platypus-signature' stamp: ''!
iso10303P11Translater
	^ 'Platypus (c) LISYC EA3883, Universite de Bretagne occidentale. Brest.'

! !

!ExChdRecord class methodsFor: 'platypus-generated-meta-data-accessing' stamp: ''!
schemaDefinition
	^ ExChdRecordAndClassSchemaDefinition singleton

! !

!ExChdRecord class methodsFor: 'platypus-generated-meta-data-accessing' stamp: ''!
schemaInstance
	^ ExChdExpress2cheddarSchemaInstance singleton

! !

!ExChdRecord class methodsFor: 'platypus-generated-platypus-signature' stamp: ''!
translatedFromISO10303P11
	^ true

! !

!ExChdRecord class methodsFor: 'platypus-generated-platypus-signature' stamp: ''!
vwNamespaceName
	^ #Express2Cheddar

! !

!ExChdRecord methodsFor: 'platypus-generated-visiting' stamp: ''!
accept: aVisitor
	^ aVisitor acceptRecord: self

! !

!ExChdRecord methodsFor: 'platypus-generated-deriving' stamp: ''!
adbCode
	^ self adbCodeUsingContext: self class context

! !

!ExChdRecord methodsFor: 'platypus-generated-deriving' stamp: ''!
adbCodeUsingContext: aContext
	^ self adbCodeUsingContext: aContext receiver: self

! !

!ExChdRecord methodsFor: 'platypus-generated-deriving' stamp: ''!
adbCodeUsingContext: aContext receiver: aReceiver
	^ ExChdRecordAdbCodeFunction
		invokeFromValues:
			(OrderedCollection new
				add: aReceiver;
				yourself)

! !

!ExChdRecord methodsFor: 'platypus-generated-deriving' stamp: ''!
adbInterfacesList
	^ self adbInterfacesListUsingContext: self class context

! !

!ExChdRecord methodsFor: 'platypus-generated-deriving' stamp: ''!
adbInterfacesListUsingContext: aContext
	^ self adbInterfacesListUsingContext: aContext receiver: self

! !

!ExChdRecord methodsFor: 'platypus-generated-deriving' stamp: ''!
adbInterfacesListUsingContext: aContext receiver: aReceiver
	^ ExChdAdaEntityInterfacesListFunction
		invokeFromValues:
			(OrderedCollection new
				add: aReceiver;
				add: false;
				yourself)

! !

!ExChdRecord methodsFor: 'platypus-generated-deriving' stamp: ''!
adsCode
	^ self adsCodeUsingContext: self class context

! !

!ExChdRecord methodsFor: 'platypus-generated-deriving' stamp: ''!
adsCodeUsingContext: aContext
	^ self adsCodeUsingContext: aContext receiver: self

! !

!ExChdRecord methodsFor: 'platypus-generated-deriving' stamp: ''!
adsCodeUsingContext: aContext receiver: aReceiver
	^ ExChdRecordAdsCodeFunction
		invokeFromValues:
			(OrderedCollection new
				add: aReceiver;
				yourself)

! !

!ExChdRecord methodsFor: 'platypus-generated-deriving' stamp: ''!
adsInterfacesList
	^ self adsInterfacesListUsingContext: self class context

! !

!ExChdRecord methodsFor: 'platypus-generated-deriving' stamp: ''!
adsInterfacesListUsingContext: aContext
	^ self adsInterfacesListUsingContext: aContext receiver: self

! !

!ExChdRecord methodsFor: 'platypus-generated-deriving' stamp: ''!
adsInterfacesListUsingContext: aContext receiver: aReceiver
	^ ExChdAdaEntityInterfacesListFunction
		invokeFromValues:
			(OrderedCollection new
				add: aReceiver;
				add: true;
				yourself)

! !

!ExChdRecord methodsFor: 'platypus-generated-group-accessing' stamp: ''!
fromValues: values
	^ self recordFromValues: (super fromValues: values)

! !

!ExChdRecord methodsFor: 'platypus-generated-classifying' stamp: ''!
isExChdRecord
	^ true

! !

!ExChdRecord methodsFor: 'platypus-generated-group-accessing' stamp: ''!
localFromValues: values
	^ self recordFromValues: values

! !

!ExChdRecord methodsFor: 'platypus-generated-group-accessing' stamp: ''!
localToValues: values
	^ self recordToValues: values

! !

!ExChdRecord methodsFor: 'platypus-generated-copying' stamp: ''!
pltCopyGroup: aClassSymbol to: anObject
	self class name == aClassSymbol
		ifTrue: [ self pltCopyTo: anObject ]
		ifFalse: [ super pltCopyGroup: aClassSymbol to: anObject ]

! !

!ExChdRecord methodsFor: 'platypus-generated-copying' stamp: ''!
pltCopyTo: another
	super pltCopyTo: another.
	self recordCopyTo: another

! !

!ExChdRecord methodsFor: 'platypus-generated-copying' stamp: ''!
pltLocalCopyTo: another
	self recordCopyTo: another

! !

!ExChdRecord methodsFor: 'platypus-generated-copying' stamp: ''!
recordCopyTo: another
	

! !

!ExChdRecord methodsFor: 'platypus-generated-group-accessing' stamp: ''!
recordFromValues: values
	| valuesloc |
	valuesloc := values asOrderedCollection.
	^ valuesloc

! !

!ExChdRecord methodsFor: 'platypus-generated-group-accessing' stamp: ''!
recordToValues: values
	^ values

! !

!ExChdRecord methodsFor: 'platypus-generated-initializing' stamp: ''!
stepInitialize
	super stepInitialize

! !

!ExChdRecord methodsFor: 'platypus-generated-group-accessing' stamp: ''!
toValues: values
	^ self recordToValues: (super toValues: values)

! !

!ExChdRecord methodsFor: 'platypus-generated-deriving' stamp: ''!
xmlIoRecordCode
	^ self xmlIoRecordCodeUsingContext: self class context

! !

!ExChdRecord methodsFor: 'platypus-generated-deriving' stamp: ''!
xmlIoRecordCodeUsingContext: aContext
	^ self xmlIoRecordCodeUsingContext: aContext receiver: self

! !

!ExChdRecord methodsFor: 'platypus-generated-deriving' stamp: ''!
xmlIoRecordCodeUsingContext: aContext receiver: aReceiver
	^ ExChdRecordXmlIoRecordCodeFunction
		invokeFromValues:
			(OrderedCollection new
				add: aReceiver;
				yourself)

! !

!ExChdRecord methodsFor: 'platypus-generated-deriving' stamp: ''!
xmlWriterCode
	^ self xmlWriterCodeUsingContext: self class context

! !

!ExChdRecord methodsFor: 'platypus-generated-deriving' stamp: ''!
xmlWriterCodeUsingContext: aContext
	^ self xmlWriterCodeUsingContext: aContext receiver: self

! !

!ExChdRecord methodsFor: 'platypus-generated-deriving' stamp: ''!
xmlWriterCodeUsingContext: aContext receiver: aReceiver
	^ ExChdRecordXmlWriterCodeFunction
		invokeFromValues:
			(OrderedCollection new
				add: aReceiver;
				yourself)

! !

PltEntityDefinition subclass: #ExChdAdaPrimitiveType
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Express2Cheddar-CheddarDomainsSchema'!

!ExChdAdaPrimitiveType commentStamp: 'platypus comment' prior: 0!
<ISO10303-11-EXPRESS>
ENTITY ada_primitive_type 
	SUBTYPE OF ( entity_definition );
DERIVE
	ads_interfaces_list : LIST OF ada_interface := [ ];
	adb_interfaces_list : LIST OF ada_interface := [ ];
	ads_code : STRING := '';
	adb_code : STRING := '';
	put_prefix : STRING := '';
	refed_by_pointer : BOOLEAN := false;
END_ENTITY;
</ISO10303-11-EXPRESS>!

ExChdAdaPrimitiveType subclass: #ExChdAdaBooleanType
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Express2Cheddar-CheddarDomainsSchema'!

!ExChdAdaBooleanType commentStamp: 'platypus comment' prior: 0!
<ISO10303-11-EXPRESS>
ENTITY ada_boolean_type 
	SUBTYPE OF ( ada_primitive_type );
DERIVE
	SELF\ada_primitive_type.ads_interfaces_list : LIST OF ada_interface := std_io_interfaces + [ ada_interface ( 'standards_io', 'boolean_io', false, true ) ];
	SELF\ada_primitive_type.adb_interfaces_list : LIST OF ada_interface := [ ada_interface ( 'primitive_xml_strings', ?, true, true ) ];
	ada_ident : STRING := 'Boolean';
	ada_ref_ident : STRING := SELF.ada_ident;
	init_value : STRING := 'false';
	SELF\ada_primitive_type.put_prefix : STRING := 'standards_io.boolean_io.';
END_ENTITY;
</ISO10303-11-EXPRESS>!

!ExChdAdaBooleanType class methodsFor: 'platypus-generated-platypus-signature' stamp: ''!
iso10303P11Translater
	^ 'Platypus (c) LISYC EA3883, Universite de Bretagne occidentale. Brest.'

! !

!ExChdAdaBooleanType class methodsFor: 'platypus-generated-meta-data-accessing' stamp: ''!
schemaDefinition
	^ ExChdCheddarDomainsSchemaDefinition singleton

! !

!ExChdAdaBooleanType class methodsFor: 'platypus-generated-meta-data-accessing' stamp: ''!
schemaInstance
	^ ExChdExpress2cheddarSchemaInstance singleton

! !

!ExChdAdaBooleanType class methodsFor: 'platypus-generated-platypus-signature' stamp: ''!
translatedFromISO10303P11
	^ true

! !

!ExChdAdaBooleanType class methodsFor: 'platypus-generated-platypus-signature' stamp: ''!
vwNamespaceName
	^ #Express2Cheddar

! !

!ExChdAdaBooleanType methodsFor: 'platypus-generated-visiting' stamp: ''!
accept: aVisitor
	^ aVisitor acceptAdaBooleanType: self

! !

!ExChdAdaBooleanType methodsFor: 'platypus-generated-copying' stamp: ''!
adaBooleanTypeCopyTo: another
	

! !

!ExChdAdaBooleanType methodsFor: 'platypus-generated-group-accessing' stamp: ''!
adaBooleanTypeFromValues: values
	| valuesloc |
	valuesloc := values asOrderedCollection.
	^ valuesloc

! !

!ExChdAdaBooleanType methodsFor: 'platypus-generated-group-accessing' stamp: ''!
adaBooleanTypeToValues: values
	^ values

! !

!ExChdAdaBooleanType methodsFor: 'platypus-generated-deriving' stamp: ''!
adaIdent
	^ self adaIdentUsingContext: self class context

! !

!ExChdAdaBooleanType methodsFor: 'platypus-generated-deriving' stamp: ''!
adaIdentUsingContext: aContext
	^ self adaIdentUsingContext: aContext receiver: self

! !

!ExChdAdaBooleanType methodsFor: 'platypus-generated-deriving' stamp: ''!
adaIdentUsingContext: aContext receiver: aReceiver
	^ 'Boolean'

! !

!ExChdAdaBooleanType methodsFor: 'platypus-generated-deriving' stamp: ''!
adaRefIdent
	^ self adaRefIdentUsingContext: self class context

! !

!ExChdAdaBooleanType methodsFor: 'platypus-generated-deriving' stamp: ''!
adaRefIdentUsingContext: aContext
	^ self adaRefIdentUsingContext: aContext receiver: self

! !

!ExChdAdaBooleanType methodsFor: 'platypus-generated-deriving' stamp: ''!
adaRefIdentUsingContext: aContext receiver: aReceiver
	^ aReceiver adaIdentUsingContext: aContext

! !

!ExChdAdaBooleanType methodsFor: 'platypus-generated-deriving' stamp: ''!
adbInterfacesList
	^ self adbInterfacesListUsingContext: self class context

! !

!ExChdAdaBooleanType methodsFor: 'platypus-generated-deriving' stamp: ''!
adbInterfacesListUsingContext: aContext
	^ self adbInterfacesListUsingContext: aContext receiver: self

! !

!ExChdAdaBooleanType methodsFor: 'platypus-generated-deriving' stamp: ''!
adbInterfacesListUsingContext: aContext receiver: aReceiver
	^ PlatypusCoreAggregateInitializer
		collectionFrom:
			(OrderedCollection new
				add:
						(ExChdAdaInterface new
								adaInterfaceFromValues:
										(OrderedCollection new
												add: 'primitive_xml_strings';
												add: nil;
												add: true;
												add: true;
												yourself);
								yourself);
				yourself)

! !

!ExChdAdaBooleanType methodsFor: 'platypus-generated-deriving' stamp: ''!
adsInterfacesList
	^ self adsInterfacesListUsingContext: self class context

! !

!ExChdAdaBooleanType methodsFor: 'platypus-generated-deriving' stamp: ''!
adsInterfacesListUsingContext: aContext
	^ self adsInterfacesListUsingContext: aContext receiver: self

! !

!ExChdAdaBooleanType methodsFor: 'platypus-generated-deriving' stamp: ''!
adsInterfacesListUsingContext: aContext receiver: aReceiver
	^ (PlatypusCoreAggregateInitializer
		collectionFrom:
			(OrderedCollection new
				add:
						(ExChdAdaInterface new
								adaInterfaceFromValues:
										(OrderedCollection new
												add: 'standards_io';
												add: nil;
												add: true;
												add: true;
												yourself);
								yourself);
				yourself))
		pltPlus:
			(PlatypusCoreAggregateInitializer
				collectionFrom:
					(OrderedCollection new
						add:
								(ExChdAdaInterface new
										adaInterfaceFromValues:
												(OrderedCollection new
														add: 'standards_io';
														add: 'boolean_io';
														add: false;
														add: true;
														yourself);
										yourself);
						yourself))

! !

!ExChdAdaBooleanType methodsFor: 'platypus-generated-group-accessing' stamp: ''!
fromValues: values
	^ self adaBooleanTypeFromValues: (super fromValues: values)

! !

!ExChdAdaBooleanType methodsFor: 'platypus-generated-deriving' stamp: ''!
initValue
	^ self initValueUsingContext: self class context

! !

!ExChdAdaBooleanType methodsFor: 'platypus-generated-deriving' stamp: ''!
initValueUsingContext: aContext
	^ self initValueUsingContext: aContext receiver: self

! !

!ExChdAdaBooleanType methodsFor: 'platypus-generated-deriving' stamp: ''!
initValueUsingContext: aContext receiver: aReceiver
	^ 'false'

! !

!ExChdAdaBooleanType methodsFor: 'platypus-generated-classifying' stamp: ''!
isExChdAdaBooleanType
	^ true

! !

!ExChdAdaBooleanType methodsFor: 'platypus-generated-group-accessing' stamp: ''!
localFromValues: values
	^ self adaBooleanTypeFromValues: values

! !

!ExChdAdaBooleanType methodsFor: 'platypus-generated-group-accessing' stamp: ''!
localToValues: values
	^ self adaBooleanTypeToValues: values

! !

!ExChdAdaBooleanType methodsFor: 'platypus-generated-copying' stamp: ''!
pltCopyGroup: aClassSymbol to: anObject
	self class name == aClassSymbol
		ifTrue: [ self pltCopyTo: anObject ]
		ifFalse: [ super pltCopyGroup: aClassSymbol to: anObject ]

! !

!ExChdAdaBooleanType methodsFor: 'platypus-generated-copying' stamp: ''!
pltCopyTo: another
	super pltCopyTo: another.
	self adaBooleanTypeCopyTo: another

! !

!ExChdAdaBooleanType methodsFor: 'platypus-generated-copying' stamp: ''!
pltLocalCopyTo: another
	self adaBooleanTypeCopyTo: another

! !

!ExChdAdaBooleanType methodsFor: 'platypus-generated-deriving' stamp: ''!
putPrefix
	^ self putPrefixUsingContext: self class context

! !

!ExChdAdaBooleanType methodsFor: 'platypus-generated-deriving' stamp: ''!
putPrefixUsingContext: aContext
	^ self putPrefixUsingContext: aContext receiver: self

! !

!ExChdAdaBooleanType methodsFor: 'platypus-generated-deriving' stamp: ''!
putPrefixUsingContext: aContext receiver: aReceiver
	^ 'standards_io.boolean_io.'

! !

!ExChdAdaBooleanType methodsFor: 'platypus-generated-initializing' stamp: ''!
stepInitialize
	super stepInitialize

! !

!ExChdAdaBooleanType methodsFor: 'platypus-generated-group-accessing' stamp: ''!
toValues: values
	^ self adaBooleanTypeToValues: (super toValues: values)

! !

ExChdAdaPrimitiveType subclass: #ExChdAdaDoubleType
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Express2Cheddar-CheddarDomainsSchema'!

!ExChdAdaDoubleType commentStamp: 'platypus comment' prior: 0!
<ISO10303-11-EXPRESS>
ENTITY ada_double_type 
	SUBTYPE OF ( ada_primitive_type );
DERIVE
	SELF\ada_primitive_type.ads_interfaces_list : LIST OF ada_interface := std_io_interfaces + [ ada_interface ( 'Ada', 'Numerics.Aux', true, true ), ada_interface ( 'standards_io', 'double_io', false, true ) ];
	SELF\ada_primitive_type.adb_interfaces_list : LIST OF ada_interface := [ ada_interface ( 'primitive_xml_strings', ?, true, true ) ];
	ada_ident : STRING := 'Double';
	ada_ref_ident : STRING := SELF.ada_ident;
	init_value : STRING := '0.0';
	SELF\ada_primitive_type.put_prefix : STRING := 'standards_io.double_io.';
END_ENTITY;
</ISO10303-11-EXPRESS>!

!ExChdAdaDoubleType class methodsFor: 'platypus-generated-platypus-signature' stamp: ''!
iso10303P11Translater
	^ 'Platypus (c) LISYC EA3883, Universite de Bretagne occidentale. Brest.'

! !

!ExChdAdaDoubleType class methodsFor: 'platypus-generated-meta-data-accessing' stamp: ''!
schemaDefinition
	^ ExChdCheddarDomainsSchemaDefinition singleton

! !

!ExChdAdaDoubleType class methodsFor: 'platypus-generated-meta-data-accessing' stamp: ''!
schemaInstance
	^ ExChdExpress2cheddarSchemaInstance singleton

! !

!ExChdAdaDoubleType class methodsFor: 'platypus-generated-platypus-signature' stamp: ''!
translatedFromISO10303P11
	^ true

! !

!ExChdAdaDoubleType class methodsFor: 'platypus-generated-platypus-signature' stamp: ''!
vwNamespaceName
	^ #Express2Cheddar

! !

!ExChdAdaDoubleType methodsFor: 'platypus-generated-visiting' stamp: ''!
accept: aVisitor
	^ aVisitor acceptAdaDoubleType: self

! !

!ExChdAdaDoubleType methodsFor: 'platypus-generated-copying' stamp: ''!
adaDoubleTypeCopyTo: another
	

! !

!ExChdAdaDoubleType methodsFor: 'platypus-generated-group-accessing' stamp: ''!
adaDoubleTypeFromValues: values
	| valuesloc |
	valuesloc := values asOrderedCollection.
	^ valuesloc

! !

!ExChdAdaDoubleType methodsFor: 'platypus-generated-group-accessing' stamp: ''!
adaDoubleTypeToValues: values
	^ values

! !

!ExChdAdaDoubleType methodsFor: 'platypus-generated-deriving' stamp: ''!
adaIdent
	^ self adaIdentUsingContext: self class context

! !

!ExChdAdaDoubleType methodsFor: 'platypus-generated-deriving' stamp: ''!
adaIdentUsingContext: aContext
	^ self adaIdentUsingContext: aContext receiver: self

! !

!ExChdAdaDoubleType methodsFor: 'platypus-generated-deriving' stamp: ''!
adaIdentUsingContext: aContext receiver: aReceiver
	^ 'Double'

! !

!ExChdAdaDoubleType methodsFor: 'platypus-generated-deriving' stamp: ''!
adaRefIdent
	^ self adaRefIdentUsingContext: self class context

! !

!ExChdAdaDoubleType methodsFor: 'platypus-generated-deriving' stamp: ''!
adaRefIdentUsingContext: aContext
	^ self adaRefIdentUsingContext: aContext receiver: self

! !

!ExChdAdaDoubleType methodsFor: 'platypus-generated-deriving' stamp: ''!
adaRefIdentUsingContext: aContext receiver: aReceiver
	^ aReceiver adaIdentUsingContext: aContext

! !

!ExChdAdaDoubleType methodsFor: 'platypus-generated-deriving' stamp: ''!
adbInterfacesList
	^ self adbInterfacesListUsingContext: self class context

! !

!ExChdAdaDoubleType methodsFor: 'platypus-generated-deriving' stamp: ''!
adbInterfacesListUsingContext: aContext
	^ self adbInterfacesListUsingContext: aContext receiver: self

! !

!ExChdAdaDoubleType methodsFor: 'platypus-generated-deriving' stamp: ''!
adbInterfacesListUsingContext: aContext receiver: aReceiver
	^ PlatypusCoreAggregateInitializer
		collectionFrom:
			(OrderedCollection new
				add:
						(ExChdAdaInterface new
								adaInterfaceFromValues:
										(OrderedCollection new
												add: 'primitive_xml_strings';
												add: nil;
												add: true;
												add: true;
												yourself);
								yourself);
				yourself)

! !

!ExChdAdaDoubleType methodsFor: 'platypus-generated-deriving' stamp: ''!
adsInterfacesList
	^ self adsInterfacesListUsingContext: self class context

! !

!ExChdAdaDoubleType methodsFor: 'platypus-generated-deriving' stamp: ''!
adsInterfacesListUsingContext: aContext
	^ self adsInterfacesListUsingContext: aContext receiver: self

! !

!ExChdAdaDoubleType methodsFor: 'platypus-generated-deriving' stamp: ''!
adsInterfacesListUsingContext: aContext receiver: aReceiver
	^ (PlatypusCoreAggregateInitializer
		collectionFrom:
			(OrderedCollection new
				add:
						(ExChdAdaInterface new
								adaInterfaceFromValues:
										(OrderedCollection new
												add: 'standards_io';
												add: nil;
												add: true;
												add: true;
												yourself);
								yourself);
				yourself))
		pltPlus:
			(PlatypusCoreAggregateInitializer
				collectionFrom:
					(OrderedCollection new
						add:
								(ExChdAdaInterface new
										adaInterfaceFromValues:
												(OrderedCollection new
														add: 'Ada';
														add: 'Numerics.Aux';
														add: true;
														add: true;
														yourself);
										yourself);
						add:
								(ExChdAdaInterface new
										adaInterfaceFromValues:
												(OrderedCollection new
														add: 'standards_io';
														add: 'double_io';
														add: false;
														add: true;
														yourself);
										yourself);
						yourself))

! !

!ExChdAdaDoubleType methodsFor: 'platypus-generated-group-accessing' stamp: ''!
fromValues: values
	^ self adaDoubleTypeFromValues: (super fromValues: values)

! !

!ExChdAdaDoubleType methodsFor: 'platypus-generated-deriving' stamp: ''!
initValue
	^ self initValueUsingContext: self class context

! !

!ExChdAdaDoubleType methodsFor: 'platypus-generated-deriving' stamp: ''!
initValueUsingContext: aContext
	^ self initValueUsingContext: aContext receiver: self

! !

!ExChdAdaDoubleType methodsFor: 'platypus-generated-deriving' stamp: ''!
initValueUsingContext: aContext receiver: aReceiver
	^ '0.0'

! !

!ExChdAdaDoubleType methodsFor: 'platypus-generated-classifying' stamp: ''!
isExChdAdaDoubleType
	^ true

! !

!ExChdAdaDoubleType methodsFor: 'platypus-generated-group-accessing' stamp: ''!
localFromValues: values
	^ self adaDoubleTypeFromValues: values

! !

!ExChdAdaDoubleType methodsFor: 'platypus-generated-group-accessing' stamp: ''!
localToValues: values
	^ self adaDoubleTypeToValues: values

! !

!ExChdAdaDoubleType methodsFor: 'platypus-generated-copying' stamp: ''!
pltCopyGroup: aClassSymbol to: anObject
	self class name == aClassSymbol
		ifTrue: [ self pltCopyTo: anObject ]
		ifFalse: [ super pltCopyGroup: aClassSymbol to: anObject ]

! !

!ExChdAdaDoubleType methodsFor: 'platypus-generated-copying' stamp: ''!
pltCopyTo: another
	super pltCopyTo: another.
	self adaDoubleTypeCopyTo: another

! !

!ExChdAdaDoubleType methodsFor: 'platypus-generated-copying' stamp: ''!
pltLocalCopyTo: another
	self adaDoubleTypeCopyTo: another

! !

!ExChdAdaDoubleType methodsFor: 'platypus-generated-deriving' stamp: ''!
putPrefix
	^ self putPrefixUsingContext: self class context

! !

!ExChdAdaDoubleType methodsFor: 'platypus-generated-deriving' stamp: ''!
putPrefixUsingContext: aContext
	^ self putPrefixUsingContext: aContext receiver: self

! !

!ExChdAdaDoubleType methodsFor: 'platypus-generated-deriving' stamp: ''!
putPrefixUsingContext: aContext receiver: aReceiver
	^ 'standards_io.double_io.'

! !

!ExChdAdaDoubleType methodsFor: 'platypus-generated-initializing' stamp: ''!
stepInitialize
	super stepInitialize

! !

!ExChdAdaDoubleType methodsFor: 'platypus-generated-group-accessing' stamp: ''!
toValues: values
	^ self adaDoubleTypeToValues: (super toValues: values)

! !

ExChdAdaPrimitiveType subclass: #ExChdAdaIntegerType
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Express2Cheddar-CheddarDomainsSchema'!

!ExChdAdaIntegerType commentStamp: 'platypus comment' prior: 0!
<ISO10303-11-EXPRESS>
ENTITY ada_integer_type 
	SUBTYPE OF ( ada_primitive_type );
DERIVE
	SELF\ada_primitive_type.ads_interfaces_list : LIST OF ada_interface := std_io_interfaces + [ ada_interface ( 'standards_io', 'integer_io', false, true ) ];
	SELF\ada_primitive_type.adb_interfaces_list : LIST OF ada_interface := [ ada_interface ( 'primitive_xml_strings', ?, true, true ) ];
	ada_ident : STRING := 'Integer';
	ada_ref_ident : STRING := SELF.ada_ident;
	init_value : STRING := '0';
	SELF\ada_primitive_type.put_prefix : STRING := 'standards_io.integer_io.';
END_ENTITY;
</ISO10303-11-EXPRESS>!

!ExChdAdaIntegerType class methodsFor: 'platypus-generated-platypus-signature' stamp: ''!
iso10303P11Translater
	^ 'Platypus (c) LISYC EA3883, Universite de Bretagne occidentale. Brest.'

! !

!ExChdAdaIntegerType class methodsFor: 'platypus-generated-meta-data-accessing' stamp: ''!
schemaDefinition
	^ ExChdCheddarDomainsSchemaDefinition singleton

! !

!ExChdAdaIntegerType class methodsFor: 'platypus-generated-meta-data-accessing' stamp: ''!
schemaInstance
	^ ExChdExpress2cheddarSchemaInstance singleton

! !

!ExChdAdaIntegerType class methodsFor: 'platypus-generated-platypus-signature' stamp: ''!
translatedFromISO10303P11
	^ true

! !

!ExChdAdaIntegerType class methodsFor: 'platypus-generated-platypus-signature' stamp: ''!
vwNamespaceName
	^ #Express2Cheddar

! !

!ExChdAdaIntegerType methodsFor: 'platypus-generated-visiting' stamp: ''!
accept: aVisitor
	^ aVisitor acceptAdaIntegerType: self

! !

!ExChdAdaIntegerType methodsFor: 'platypus-generated-deriving' stamp: ''!
adaIdent
	^ self adaIdentUsingContext: self class context

! !

!ExChdAdaIntegerType methodsFor: 'platypus-generated-deriving' stamp: ''!
adaIdentUsingContext: aContext
	^ self adaIdentUsingContext: aContext receiver: self

! !

!ExChdAdaIntegerType methodsFor: 'platypus-generated-deriving' stamp: ''!
adaIdentUsingContext: aContext receiver: aReceiver
	^ 'Integer'

! !

!ExChdAdaIntegerType methodsFor: 'platypus-generated-copying' stamp: ''!
adaIntegerTypeCopyTo: another
	

! !

!ExChdAdaIntegerType methodsFor: 'platypus-generated-group-accessing' stamp: ''!
adaIntegerTypeFromValues: values
	| valuesloc |
	valuesloc := values asOrderedCollection.
	^ valuesloc

! !

!ExChdAdaIntegerType methodsFor: 'platypus-generated-group-accessing' stamp: ''!
adaIntegerTypeToValues: values
	^ values

! !

!ExChdAdaIntegerType methodsFor: 'platypus-generated-deriving' stamp: ''!
adaRefIdent
	^ self adaRefIdentUsingContext: self class context

! !

!ExChdAdaIntegerType methodsFor: 'platypus-generated-deriving' stamp: ''!
adaRefIdentUsingContext: aContext
	^ self adaRefIdentUsingContext: aContext receiver: self

! !

!ExChdAdaIntegerType methodsFor: 'platypus-generated-deriving' stamp: ''!
adaRefIdentUsingContext: aContext receiver: aReceiver
	^ aReceiver adaIdentUsingContext: aContext

! !

!ExChdAdaIntegerType methodsFor: 'platypus-generated-deriving' stamp: ''!
adbInterfacesList
	^ self adbInterfacesListUsingContext: self class context

! !

!ExChdAdaIntegerType methodsFor: 'platypus-generated-deriving' stamp: ''!
adbInterfacesListUsingContext: aContext
	^ self adbInterfacesListUsingContext: aContext receiver: self

! !

!ExChdAdaIntegerType methodsFor: 'platypus-generated-deriving' stamp: ''!
adbInterfacesListUsingContext: aContext receiver: aReceiver
	^ PlatypusCoreAggregateInitializer
		collectionFrom:
			(OrderedCollection new
				add:
						(ExChdAdaInterface new
								adaInterfaceFromValues:
										(OrderedCollection new
												add: 'primitive_xml_strings';
												add: nil;
												add: true;
												add: true;
												yourself);
								yourself);
				yourself)

! !

!ExChdAdaIntegerType methodsFor: 'platypus-generated-deriving' stamp: ''!
adsInterfacesList
	^ self adsInterfacesListUsingContext: self class context

! !

!ExChdAdaIntegerType methodsFor: 'platypus-generated-deriving' stamp: ''!
adsInterfacesListUsingContext: aContext
	^ self adsInterfacesListUsingContext: aContext receiver: self

! !

!ExChdAdaIntegerType methodsFor: 'platypus-generated-deriving' stamp: ''!
adsInterfacesListUsingContext: aContext receiver: aReceiver
	^ (PlatypusCoreAggregateInitializer
		collectionFrom:
			(OrderedCollection new
				add:
						(ExChdAdaInterface new
								adaInterfaceFromValues:
										(OrderedCollection new
												add: 'standards_io';
												add: nil;
												add: true;
												add: true;
												yourself);
								yourself);
				yourself))
		pltPlus:
			(PlatypusCoreAggregateInitializer
				collectionFrom:
					(OrderedCollection new
						add:
								(ExChdAdaInterface new
										adaInterfaceFromValues:
												(OrderedCollection new
														add: 'standards_io';
														add: 'integer_io';
														add: false;
														add: true;
														yourself);
										yourself);
						yourself))

! !

!ExChdAdaIntegerType methodsFor: 'platypus-generated-group-accessing' stamp: ''!
fromValues: values
	^ self adaIntegerTypeFromValues: (super fromValues: values)

! !

!ExChdAdaIntegerType methodsFor: 'platypus-generated-deriving' stamp: ''!
initValue
	^ self initValueUsingContext: self class context

! !

!ExChdAdaIntegerType methodsFor: 'platypus-generated-deriving' stamp: ''!
initValueUsingContext: aContext
	^ self initValueUsingContext: aContext receiver: self

! !

!ExChdAdaIntegerType methodsFor: 'platypus-generated-deriving' stamp: ''!
initValueUsingContext: aContext receiver: aReceiver
	^ '0'

! !

!ExChdAdaIntegerType methodsFor: 'platypus-generated-classifying' stamp: ''!
isExChdAdaIntegerType
	^ true

! !

!ExChdAdaIntegerType methodsFor: 'platypus-generated-group-accessing' stamp: ''!
localFromValues: values
	^ self adaIntegerTypeFromValues: values

! !

!ExChdAdaIntegerType methodsFor: 'platypus-generated-group-accessing' stamp: ''!
localToValues: values
	^ self adaIntegerTypeToValues: values

! !

!ExChdAdaIntegerType methodsFor: 'platypus-generated-copying' stamp: ''!
pltCopyGroup: aClassSymbol to: anObject
	self class name == aClassSymbol
		ifTrue: [ self pltCopyTo: anObject ]
		ifFalse: [ super pltCopyGroup: aClassSymbol to: anObject ]

! !

!ExChdAdaIntegerType methodsFor: 'platypus-generated-copying' stamp: ''!
pltCopyTo: another
	super pltCopyTo: another.
	self adaIntegerTypeCopyTo: another

! !

!ExChdAdaIntegerType methodsFor: 'platypus-generated-copying' stamp: ''!
pltLocalCopyTo: another
	self adaIntegerTypeCopyTo: another

! !

!ExChdAdaIntegerType methodsFor: 'platypus-generated-deriving' stamp: ''!
putPrefix
	^ self putPrefixUsingContext: self class context

! !

!ExChdAdaIntegerType methodsFor: 'platypus-generated-deriving' stamp: ''!
putPrefixUsingContext: aContext
	^ self putPrefixUsingContext: aContext receiver: self

! !

!ExChdAdaIntegerType methodsFor: 'platypus-generated-deriving' stamp: ''!
putPrefixUsingContext: aContext receiver: aReceiver
	^ 'standards_io.integer_io.'

! !

!ExChdAdaIntegerType methodsFor: 'platypus-generated-initializing' stamp: ''!
stepInitialize
	super stepInitialize

! !

!ExChdAdaIntegerType methodsFor: 'platypus-generated-group-accessing' stamp: ''!
toValues: values
	^ self adaIntegerTypeToValues: (super toValues: values)

! !

ExChdAdaPrimitiveType subclass: #ExChdAdaNaturalType
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Express2Cheddar-CheddarDomainsSchema'!

!ExChdAdaNaturalType commentStamp: 'platypus comment' prior: 0!
<ISO10303-11-EXPRESS>
ENTITY ada_natural_type 
	SUBTYPE OF ( ada_primitive_type );
DERIVE
	SELF\ada_primitive_type.ads_interfaces_list : LIST OF ada_interface := std_io_interfaces + [ ada_interface ( 'standards_io', 'natural_io', false, true ) ];
	SELF\ada_primitive_type.adb_interfaces_list : LIST OF ada_interface := [ ada_interface ( 'primitive_xml_strings', ?, true, true ) ];
	ada_ident : STRING := 'Natural';
	ada_ref_ident : STRING := SELF.ada_ident;
	init_value : STRING := '0';
	SELF\ada_primitive_type.put_prefix : STRING := 'standards_io.natural_io.';
END_ENTITY;
</ISO10303-11-EXPRESS>!

!ExChdAdaNaturalType class methodsFor: 'platypus-generated-platypus-signature' stamp: ''!
iso10303P11Translater
	^ 'Platypus (c) LISYC EA3883, Universite de Bretagne occidentale. Brest.'

! !

!ExChdAdaNaturalType class methodsFor: 'platypus-generated-meta-data-accessing' stamp: ''!
schemaDefinition
	^ ExChdCheddarDomainsSchemaDefinition singleton

! !

!ExChdAdaNaturalType class methodsFor: 'platypus-generated-meta-data-accessing' stamp: ''!
schemaInstance
	^ ExChdExpress2cheddarSchemaInstance singleton

! !

!ExChdAdaNaturalType class methodsFor: 'platypus-generated-platypus-signature' stamp: ''!
translatedFromISO10303P11
	^ true

! !

!ExChdAdaNaturalType class methodsFor: 'platypus-generated-platypus-signature' stamp: ''!
vwNamespaceName
	^ #Express2Cheddar

! !

!ExChdAdaNaturalType methodsFor: 'platypus-generated-visiting' stamp: ''!
accept: aVisitor
	^ aVisitor acceptAdaNaturalType: self

! !

!ExChdAdaNaturalType methodsFor: 'platypus-generated-deriving' stamp: ''!
adaIdent
	^ self adaIdentUsingContext: self class context

! !

!ExChdAdaNaturalType methodsFor: 'platypus-generated-deriving' stamp: ''!
adaIdentUsingContext: aContext
	^ self adaIdentUsingContext: aContext receiver: self

! !

!ExChdAdaNaturalType methodsFor: 'platypus-generated-deriving' stamp: ''!
adaIdentUsingContext: aContext receiver: aReceiver
	^ 'Natural'

! !

!ExChdAdaNaturalType methodsFor: 'platypus-generated-copying' stamp: ''!
adaNaturalTypeCopyTo: another
	

! !

!ExChdAdaNaturalType methodsFor: 'platypus-generated-group-accessing' stamp: ''!
adaNaturalTypeFromValues: values
	| valuesloc |
	valuesloc := values asOrderedCollection.
	^ valuesloc

! !

!ExChdAdaNaturalType methodsFor: 'platypus-generated-group-accessing' stamp: ''!
adaNaturalTypeToValues: values
	^ values

! !

!ExChdAdaNaturalType methodsFor: 'platypus-generated-deriving' stamp: ''!
adaRefIdent
	^ self adaRefIdentUsingContext: self class context

! !

!ExChdAdaNaturalType methodsFor: 'platypus-generated-deriving' stamp: ''!
adaRefIdentUsingContext: aContext
	^ self adaRefIdentUsingContext: aContext receiver: self

! !

!ExChdAdaNaturalType methodsFor: 'platypus-generated-deriving' stamp: ''!
adaRefIdentUsingContext: aContext receiver: aReceiver
	^ aReceiver adaIdentUsingContext: aContext

! !

!ExChdAdaNaturalType methodsFor: 'platypus-generated-deriving' stamp: ''!
adbInterfacesList
	^ self adbInterfacesListUsingContext: self class context

! !

!ExChdAdaNaturalType methodsFor: 'platypus-generated-deriving' stamp: ''!
adbInterfacesListUsingContext: aContext
	^ self adbInterfacesListUsingContext: aContext receiver: self

! !

!ExChdAdaNaturalType methodsFor: 'platypus-generated-deriving' stamp: ''!
adbInterfacesListUsingContext: aContext receiver: aReceiver
	^ PlatypusCoreAggregateInitializer
		collectionFrom:
			(OrderedCollection new
				add:
						(ExChdAdaInterface new
								adaInterfaceFromValues:
										(OrderedCollection new
												add: 'primitive_xml_strings';
												add: nil;
												add: true;
												add: true;
												yourself);
								yourself);
				yourself)

! !

!ExChdAdaNaturalType methodsFor: 'platypus-generated-deriving' stamp: ''!
adsInterfacesList
	^ self adsInterfacesListUsingContext: self class context

! !

!ExChdAdaNaturalType methodsFor: 'platypus-generated-deriving' stamp: ''!
adsInterfacesListUsingContext: aContext
	^ self adsInterfacesListUsingContext: aContext receiver: self

! !

!ExChdAdaNaturalType methodsFor: 'platypus-generated-deriving' stamp: ''!
adsInterfacesListUsingContext: aContext receiver: aReceiver
	^ (PlatypusCoreAggregateInitializer
		collectionFrom:
			(OrderedCollection new
				add:
						(ExChdAdaInterface new
								adaInterfaceFromValues:
										(OrderedCollection new
												add: 'standards_io';
												add: nil;
												add: true;
												add: true;
												yourself);
								yourself);
				yourself))
		pltPlus:
			(PlatypusCoreAggregateInitializer
				collectionFrom:
					(OrderedCollection new
						add:
								(ExChdAdaInterface new
										adaInterfaceFromValues:
												(OrderedCollection new
														add: 'standards_io';
														add: 'natural_io';
														add: false;
														add: true;
														yourself);
										yourself);
						yourself))

! !

!ExChdAdaNaturalType methodsFor: 'platypus-generated-group-accessing' stamp: ''!
fromValues: values
	^ self adaNaturalTypeFromValues: (super fromValues: values)

! !

!ExChdAdaNaturalType methodsFor: 'platypus-generated-deriving' stamp: ''!
initValue
	^ self initValueUsingContext: self class context

! !

!ExChdAdaNaturalType methodsFor: 'platypus-generated-deriving' stamp: ''!
initValueUsingContext: aContext
	^ self initValueUsingContext: aContext receiver: self

! !

!ExChdAdaNaturalType methodsFor: 'platypus-generated-deriving' stamp: ''!
initValueUsingContext: aContext receiver: aReceiver
	^ '0'

! !

!ExChdAdaNaturalType methodsFor: 'platypus-generated-classifying' stamp: ''!
isExChdAdaNaturalType
	^ true

! !

!ExChdAdaNaturalType methodsFor: 'platypus-generated-group-accessing' stamp: ''!
localFromValues: values
	^ self adaNaturalTypeFromValues: values

! !

!ExChdAdaNaturalType methodsFor: 'platypus-generated-group-accessing' stamp: ''!
localToValues: values
	^ self adaNaturalTypeToValues: values

! !

!ExChdAdaNaturalType methodsFor: 'platypus-generated-copying' stamp: ''!
pltCopyGroup: aClassSymbol to: anObject
	self class name == aClassSymbol
		ifTrue: [ self pltCopyTo: anObject ]
		ifFalse: [ super pltCopyGroup: aClassSymbol to: anObject ]

! !

!ExChdAdaNaturalType methodsFor: 'platypus-generated-copying' stamp: ''!
pltCopyTo: another
	super pltCopyTo: another.
	self adaNaturalTypeCopyTo: another

! !

!ExChdAdaNaturalType methodsFor: 'platypus-generated-copying' stamp: ''!
pltLocalCopyTo: another
	self adaNaturalTypeCopyTo: another

! !

!ExChdAdaNaturalType methodsFor: 'platypus-generated-deriving' stamp: ''!
putPrefix
	^ self putPrefixUsingContext: self class context

! !

!ExChdAdaNaturalType methodsFor: 'platypus-generated-deriving' stamp: ''!
putPrefixUsingContext: aContext
	^ self putPrefixUsingContext: aContext receiver: self

! !

!ExChdAdaNaturalType methodsFor: 'platypus-generated-deriving' stamp: ''!
putPrefixUsingContext: aContext receiver: aReceiver
	^ 'standards_io.natural_io.'

! !

!ExChdAdaNaturalType methodsFor: 'platypus-generated-initializing' stamp: ''!
stepInitialize
	super stepInitialize

! !

!ExChdAdaNaturalType methodsFor: 'platypus-generated-group-accessing' stamp: ''!
toValues: values
	^ self adaNaturalTypeToValues: (super toValues: values)

! !

!ExChdAdaPrimitiveType class methodsFor: 'platypus-generated-platypus-signature' stamp: ''!
iso10303P11Translater
	^ 'Platypus (c) LISYC EA3883, Universite de Bretagne occidentale. Brest.'

! !

!ExChdAdaPrimitiveType class methodsFor: 'platypus-generated-meta-data-accessing' stamp: ''!
schemaDefinition
	^ ExChdCheddarDomainsSchemaDefinition singleton

! !

!ExChdAdaPrimitiveType class methodsFor: 'platypus-generated-meta-data-accessing' stamp: ''!
schemaInstance
	^ ExChdExpress2cheddarSchemaInstance singleton

! !

!ExChdAdaPrimitiveType class methodsFor: 'platypus-generated-platypus-signature' stamp: ''!
translatedFromISO10303P11
	^ true

! !

!ExChdAdaPrimitiveType class methodsFor: 'platypus-generated-platypus-signature' stamp: ''!
vwNamespaceName
	^ #Express2Cheddar

! !

!ExChdAdaPrimitiveType methodsFor: 'platypus-generated-visiting' stamp: ''!
accept: aVisitor
	^ aVisitor acceptAdaPrimitiveType: self

! !

!ExChdAdaPrimitiveType methodsFor: 'platypus-generated-copying' stamp: ''!
adaPrimitiveTypeCopyTo: another
	

! !

!ExChdAdaPrimitiveType methodsFor: 'platypus-generated-group-accessing' stamp: ''!
adaPrimitiveTypeFromValues: values
	| valuesloc |
	valuesloc := values asOrderedCollection.
	^ valuesloc

! !

!ExChdAdaPrimitiveType methodsFor: 'platypus-generated-group-accessing' stamp: ''!
adaPrimitiveTypeToValues: values
	^ values

! !

!ExChdAdaPrimitiveType methodsFor: 'platypus-generated-deriving' stamp: ''!
adbCode
	^ self adbCodeUsingContext: self class context

! !

!ExChdAdaPrimitiveType methodsFor: 'platypus-generated-deriving' stamp: ''!
adbCodeUsingContext: aContext
	^ self adbCodeUsingContext: aContext receiver: self

! !

!ExChdAdaPrimitiveType methodsFor: 'platypus-generated-deriving' stamp: ''!
adbCodeUsingContext: aContext receiver: aReceiver
	^ ''

! !

!ExChdAdaPrimitiveType methodsFor: 'platypus-generated-deriving' stamp: ''!
adbInterfacesList
	^ self adbInterfacesListUsingContext: self class context

! !

!ExChdAdaPrimitiveType methodsFor: 'platypus-generated-deriving' stamp: ''!
adbInterfacesListUsingContext: aContext
	^ self adbInterfacesListUsingContext: aContext receiver: self

! !

!ExChdAdaPrimitiveType methodsFor: 'platypus-generated-deriving' stamp: ''!
adbInterfacesListUsingContext: aContext receiver: aReceiver
	^ Array new

! !

!ExChdAdaPrimitiveType methodsFor: 'platypus-generated-deriving' stamp: ''!
adsCode
	^ self adsCodeUsingContext: self class context

! !

!ExChdAdaPrimitiveType methodsFor: 'platypus-generated-deriving' stamp: ''!
adsCodeUsingContext: aContext
	^ self adsCodeUsingContext: aContext receiver: self

! !

!ExChdAdaPrimitiveType methodsFor: 'platypus-generated-deriving' stamp: ''!
adsCodeUsingContext: aContext receiver: aReceiver
	^ ''

! !

!ExChdAdaPrimitiveType methodsFor: 'platypus-generated-deriving' stamp: ''!
adsInterfacesList
	^ self adsInterfacesListUsingContext: self class context

! !

!ExChdAdaPrimitiveType methodsFor: 'platypus-generated-deriving' stamp: ''!
adsInterfacesListUsingContext: aContext
	^ self adsInterfacesListUsingContext: aContext receiver: self

! !

!ExChdAdaPrimitiveType methodsFor: 'platypus-generated-deriving' stamp: ''!
adsInterfacesListUsingContext: aContext receiver: aReceiver
	^ Array new

! !

!ExChdAdaPrimitiveType methodsFor: 'platypus-generated-group-accessing' stamp: ''!
fromValues: values
	^ self adaPrimitiveTypeFromValues: (super fromValues: values)

! !

!ExChdAdaPrimitiveType methodsFor: 'platypus-generated-classifying' stamp: ''!
isExChdAdaPrimitiveType
	^ true

! !

!ExChdAdaPrimitiveType methodsFor: 'platypus-generated-group-accessing' stamp: ''!
localFromValues: values
	^ self adaPrimitiveTypeFromValues: values

! !

!ExChdAdaPrimitiveType methodsFor: 'platypus-generated-group-accessing' stamp: ''!
localToValues: values
	^ self adaPrimitiveTypeToValues: values

! !

!ExChdAdaPrimitiveType methodsFor: 'platypus-generated-copying' stamp: ''!
pltCopyGroup: aClassSymbol to: anObject
	self class name == aClassSymbol
		ifTrue: [ self pltCopyTo: anObject ]
		ifFalse: [ super pltCopyGroup: aClassSymbol to: anObject ]

! !

!ExChdAdaPrimitiveType methodsFor: 'platypus-generated-copying' stamp: ''!
pltCopyTo: another
	super pltCopyTo: another.
	self adaPrimitiveTypeCopyTo: another

! !

!ExChdAdaPrimitiveType methodsFor: 'platypus-generated-copying' stamp: ''!
pltLocalCopyTo: another
	self adaPrimitiveTypeCopyTo: another

! !

!ExChdAdaPrimitiveType methodsFor: 'platypus-generated-deriving' stamp: ''!
putPrefix
	^ self putPrefixUsingContext: self class context

! !

!ExChdAdaPrimitiveType methodsFor: 'platypus-generated-deriving' stamp: ''!
putPrefixUsingContext: aContext
	^ self putPrefixUsingContext: aContext receiver: self

! !

!ExChdAdaPrimitiveType methodsFor: 'platypus-generated-deriving' stamp: ''!
putPrefixUsingContext: aContext receiver: aReceiver
	^ ''

! !

!ExChdAdaPrimitiveType methodsFor: 'platypus-generated-deriving' stamp: ''!
refedByPointer
	^ self refedByPointerUsingContext: self class context

! !

!ExChdAdaPrimitiveType methodsFor: 'platypus-generated-deriving' stamp: ''!
refedByPointerUsingContext: aContext
	^ self refedByPointerUsingContext: aContext receiver: self

! !

!ExChdAdaPrimitiveType methodsFor: 'platypus-generated-deriving' stamp: ''!
refedByPointerUsingContext: aContext receiver: aReceiver
	^ false

! !

!ExChdAdaPrimitiveType methodsFor: 'platypus-generated-initializing' stamp: ''!
stepInitialize
	super stepInitialize

! !

!ExChdAdaPrimitiveType methodsFor: 'platypus-generated-group-accessing' stamp: ''!
toValues: values
	^ self adaPrimitiveTypeToValues: (super toValues: values)

! !

ExChdAdaPrimitiveType subclass: #ExChdAdaRealType
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Express2Cheddar-CheddarDomainsSchema'!

!ExChdAdaRealType commentStamp: 'platypus comment' prior: 0!
<ISO10303-11-EXPRESS>
ENTITY ada_real_type 
	SUBTYPE OF ( ada_primitive_type );
DERIVE
	SELF\ada_primitive_type.ads_interfaces_list : LIST OF ada_interface := std_io_interfaces + [ ada_interface ( 'Ada', 'Numerics.Aux', true, true ), ada_interface ( 'standards_io', 'float_io', false, true ) ];
	SELF\ada_primitive_type.adb_interfaces_list : LIST OF ada_interface := [ ada_interface ( 'primitive_xml_strings', ?, true, true ) ];
	ada_ident : STRING := 'Float';
	ada_ref_ident : STRING := SELF.ada_ident;
	init_value : STRING := '0.0';
	SELF\ada_primitive_type.put_prefix : STRING := 'standards_io.float_io.';
END_ENTITY;
</ISO10303-11-EXPRESS>!

!ExChdAdaRealType class methodsFor: 'platypus-generated-platypus-signature' stamp: ''!
iso10303P11Translater
	^ 'Platypus (c) LISYC EA3883, Universite de Bretagne occidentale. Brest.'

! !

!ExChdAdaRealType class methodsFor: 'platypus-generated-meta-data-accessing' stamp: ''!
schemaDefinition
	^ ExChdCheddarDomainsSchemaDefinition singleton

! !

!ExChdAdaRealType class methodsFor: 'platypus-generated-meta-data-accessing' stamp: ''!
schemaInstance
	^ ExChdExpress2cheddarSchemaInstance singleton

! !

!ExChdAdaRealType class methodsFor: 'platypus-generated-platypus-signature' stamp: ''!
translatedFromISO10303P11
	^ true

! !

!ExChdAdaRealType class methodsFor: 'platypus-generated-platypus-signature' stamp: ''!
vwNamespaceName
	^ #Express2Cheddar

! !

!ExChdAdaRealType methodsFor: 'platypus-generated-visiting' stamp: ''!
accept: aVisitor
	^ aVisitor acceptAdaRealType: self

! !

!ExChdAdaRealType methodsFor: 'platypus-generated-deriving' stamp: ''!
adaIdent
	^ self adaIdentUsingContext: self class context

! !

!ExChdAdaRealType methodsFor: 'platypus-generated-deriving' stamp: ''!
adaIdentUsingContext: aContext
	^ self adaIdentUsingContext: aContext receiver: self

! !

!ExChdAdaRealType methodsFor: 'platypus-generated-deriving' stamp: ''!
adaIdentUsingContext: aContext receiver: aReceiver
	^ 'Float'

! !

!ExChdAdaRealType methodsFor: 'platypus-generated-copying' stamp: ''!
adaRealTypeCopyTo: another
	

! !

!ExChdAdaRealType methodsFor: 'platypus-generated-group-accessing' stamp: ''!
adaRealTypeFromValues: values
	| valuesloc |
	valuesloc := values asOrderedCollection.
	^ valuesloc

! !

!ExChdAdaRealType methodsFor: 'platypus-generated-group-accessing' stamp: ''!
adaRealTypeToValues: values
	^ values

! !

!ExChdAdaRealType methodsFor: 'platypus-generated-deriving' stamp: ''!
adaRefIdent
	^ self adaRefIdentUsingContext: self class context

! !

!ExChdAdaRealType methodsFor: 'platypus-generated-deriving' stamp: ''!
adaRefIdentUsingContext: aContext
	^ self adaRefIdentUsingContext: aContext receiver: self

! !

!ExChdAdaRealType methodsFor: 'platypus-generated-deriving' stamp: ''!
adaRefIdentUsingContext: aContext receiver: aReceiver
	^ aReceiver adaIdentUsingContext: aContext

! !

!ExChdAdaRealType methodsFor: 'platypus-generated-deriving' stamp: ''!
adbInterfacesList
	^ self adbInterfacesListUsingContext: self class context

! !

!ExChdAdaRealType methodsFor: 'platypus-generated-deriving' stamp: ''!
adbInterfacesListUsingContext: aContext
	^ self adbInterfacesListUsingContext: aContext receiver: self

! !

!ExChdAdaRealType methodsFor: 'platypus-generated-deriving' stamp: ''!
adbInterfacesListUsingContext: aContext receiver: aReceiver
	^ PlatypusCoreAggregateInitializer
		collectionFrom:
			(OrderedCollection new
				add:
						(ExChdAdaInterface new
								adaInterfaceFromValues:
										(OrderedCollection new
												add: 'primitive_xml_strings';
												add: nil;
												add: true;
												add: true;
												yourself);
								yourself);
				yourself)

! !

!ExChdAdaRealType methodsFor: 'platypus-generated-deriving' stamp: ''!
adsInterfacesList
	^ self adsInterfacesListUsingContext: self class context

! !

!ExChdAdaRealType methodsFor: 'platypus-generated-deriving' stamp: ''!
adsInterfacesListUsingContext: aContext
	^ self adsInterfacesListUsingContext: aContext receiver: self

! !

!ExChdAdaRealType methodsFor: 'platypus-generated-deriving' stamp: ''!
adsInterfacesListUsingContext: aContext receiver: aReceiver
	^ (PlatypusCoreAggregateInitializer
		collectionFrom:
			(OrderedCollection new
				add:
						(ExChdAdaInterface new
								adaInterfaceFromValues:
										(OrderedCollection new
												add: 'standards_io';
												add: nil;
												add: true;
												add: true;
												yourself);
								yourself);
				yourself))
		pltPlus:
			(PlatypusCoreAggregateInitializer
				collectionFrom:
					(OrderedCollection new
						add:
								(ExChdAdaInterface new
										adaInterfaceFromValues:
												(OrderedCollection new
														add: 'Ada';
														add: 'Numerics.Aux';
														add: true;
														add: true;
														yourself);
										yourself);
						add:
								(ExChdAdaInterface new
										adaInterfaceFromValues:
												(OrderedCollection new
														add: 'standards_io';
														add: 'float_io';
														add: false;
														add: true;
														yourself);
										yourself);
						yourself))

! !

!ExChdAdaRealType methodsFor: 'platypus-generated-group-accessing' stamp: ''!
fromValues: values
	^ self adaRealTypeFromValues: (super fromValues: values)

! !

!ExChdAdaRealType methodsFor: 'platypus-generated-deriving' stamp: ''!
initValue
	^ self initValueUsingContext: self class context

! !

!ExChdAdaRealType methodsFor: 'platypus-generated-deriving' stamp: ''!
initValueUsingContext: aContext
	^ self initValueUsingContext: aContext receiver: self

! !

!ExChdAdaRealType methodsFor: 'platypus-generated-deriving' stamp: ''!
initValueUsingContext: aContext receiver: aReceiver
	^ '0.0'

! !

!ExChdAdaRealType methodsFor: 'platypus-generated-classifying' stamp: ''!
isExChdAdaRealType
	^ true

! !

!ExChdAdaRealType methodsFor: 'platypus-generated-group-accessing' stamp: ''!
localFromValues: values
	^ self adaRealTypeFromValues: values

! !

!ExChdAdaRealType methodsFor: 'platypus-generated-group-accessing' stamp: ''!
localToValues: values
	^ self adaRealTypeToValues: values

! !

!ExChdAdaRealType methodsFor: 'platypus-generated-copying' stamp: ''!
pltCopyGroup: aClassSymbol to: anObject
	self class name == aClassSymbol
		ifTrue: [ self pltCopyTo: anObject ]
		ifFalse: [ super pltCopyGroup: aClassSymbol to: anObject ]

! !

!ExChdAdaRealType methodsFor: 'platypus-generated-copying' stamp: ''!
pltCopyTo: another
	super pltCopyTo: another.
	self adaRealTypeCopyTo: another

! !

!ExChdAdaRealType methodsFor: 'platypus-generated-copying' stamp: ''!
pltLocalCopyTo: another
	self adaRealTypeCopyTo: another

! !

!ExChdAdaRealType methodsFor: 'platypus-generated-deriving' stamp: ''!
putPrefix
	^ self putPrefixUsingContext: self class context

! !

!ExChdAdaRealType methodsFor: 'platypus-generated-deriving' stamp: ''!
putPrefixUsingContext: aContext
	^ self putPrefixUsingContext: aContext receiver: self

! !

!ExChdAdaRealType methodsFor: 'platypus-generated-deriving' stamp: ''!
putPrefixUsingContext: aContext receiver: aReceiver
	^ 'standards_io.float_io.'

! !

!ExChdAdaRealType methodsFor: 'platypus-generated-initializing' stamp: ''!
stepInitialize
	super stepInitialize

! !

!ExChdAdaRealType methodsFor: 'platypus-generated-group-accessing' stamp: ''!
toValues: values
	^ self adaRealTypeToValues: (super toValues: values)

! !

ExChdAdaPrimitiveType subclass: #ExChdAdaUnboundedStringType
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Express2Cheddar-CheddarDomainsSchema'!

!ExChdAdaUnboundedStringType commentStamp: 'platypus comment' prior: 0!
<ISO10303-11-EXPRESS>
ENTITY ada_unbounded_string_type 
	SUBTYPE OF ( ada_primitive_type );
DERIVE
	SELF\ada_primitive_type.ads_interfaces_list : LIST OF ada_interface := [ ada_interface ( 'ada.strings', 'unbounded.text_io', true, true ), ada_interface ( 'Text_io', ?, true, true ), ada_interface ( 'Unbounded_Strings', ?, true, true ), ada_interface ( 'Convert_Strings', ?, true, false ), ada_interface ( 'Convert_Unbounded_Strings', ?, true, false ) ];
	SELF\ada_primitive_type.adb_interfaces_list : LIST OF ada_interface := [ ada_interface ( 'Text_io', ?, true, true ), ada_interface ( 'primitive_xml_strings', ?, true, true ) ];
	ada_ident : STRING := 'Unbounded_String';
	ada_ref_ident : STRING := SELF.ada_ident;
	init_value : STRING := 'empty_string';
END_ENTITY;
</ISO10303-11-EXPRESS>!

!ExChdAdaUnboundedStringType class methodsFor: 'platypus-generated-platypus-signature' stamp: ''!
iso10303P11Translater
	^ 'Platypus (c) LISYC EA3883, Universite de Bretagne occidentale. Brest.'

! !

!ExChdAdaUnboundedStringType class methodsFor: 'platypus-generated-meta-data-accessing' stamp: ''!
schemaDefinition
	^ ExChdCheddarDomainsSchemaDefinition singleton

! !

!ExChdAdaUnboundedStringType class methodsFor: 'platypus-generated-meta-data-accessing' stamp: ''!
schemaInstance
	^ ExChdExpress2cheddarSchemaInstance singleton

! !

!ExChdAdaUnboundedStringType class methodsFor: 'platypus-generated-platypus-signature' stamp: ''!
translatedFromISO10303P11
	^ true

! !

!ExChdAdaUnboundedStringType class methodsFor: 'platypus-generated-platypus-signature' stamp: ''!
vwNamespaceName
	^ #Express2Cheddar

! !

!ExChdAdaUnboundedStringType methodsFor: 'platypus-generated-visiting' stamp: ''!
accept: aVisitor
	^ aVisitor acceptAdaUnboundedStringType: self

! !

!ExChdAdaUnboundedStringType methodsFor: 'platypus-generated-deriving' stamp: ''!
adaIdent
	^ self adaIdentUsingContext: self class context

! !

!ExChdAdaUnboundedStringType methodsFor: 'platypus-generated-deriving' stamp: ''!
adaIdentUsingContext: aContext
	^ self adaIdentUsingContext: aContext receiver: self

! !

!ExChdAdaUnboundedStringType methodsFor: 'platypus-generated-deriving' stamp: ''!
adaIdentUsingContext: aContext receiver: aReceiver
	^ 'Unbounded_String'

! !

!ExChdAdaUnboundedStringType methodsFor: 'platypus-generated-deriving' stamp: ''!
adaRefIdent
	^ self adaRefIdentUsingContext: self class context

! !

!ExChdAdaUnboundedStringType methodsFor: 'platypus-generated-deriving' stamp: ''!
adaRefIdentUsingContext: aContext
	^ self adaRefIdentUsingContext: aContext receiver: self

! !

!ExChdAdaUnboundedStringType methodsFor: 'platypus-generated-deriving' stamp: ''!
adaRefIdentUsingContext: aContext receiver: aReceiver
	^ aReceiver adaIdentUsingContext: aContext

! !

!ExChdAdaUnboundedStringType methodsFor: 'platypus-generated-copying' stamp: ''!
adaUnboundedStringTypeCopyTo: another
	

! !

!ExChdAdaUnboundedStringType methodsFor: 'platypus-generated-group-accessing' stamp: ''!
adaUnboundedStringTypeFromValues: values
	| valuesloc |
	valuesloc := values asOrderedCollection.
	^ valuesloc

! !

!ExChdAdaUnboundedStringType methodsFor: 'platypus-generated-group-accessing' stamp: ''!
adaUnboundedStringTypeToValues: values
	^ values

! !

!ExChdAdaUnboundedStringType methodsFor: 'platypus-generated-deriving' stamp: ''!
adbInterfacesList
	^ self adbInterfacesListUsingContext: self class context

! !

!ExChdAdaUnboundedStringType methodsFor: 'platypus-generated-deriving' stamp: ''!
adbInterfacesListUsingContext: aContext
	^ self adbInterfacesListUsingContext: aContext receiver: self

! !

!ExChdAdaUnboundedStringType methodsFor: 'platypus-generated-deriving' stamp: ''!
adbInterfacesListUsingContext: aContext receiver: aReceiver
	^ PlatypusCoreAggregateInitializer
		collectionFrom:
			(OrderedCollection new
				add:
						(ExChdAdaInterface new
								adaInterfaceFromValues:
										(OrderedCollection new
												add: 'Text_io';
												add: nil;
												add: true;
												add: true;
												yourself);
								yourself);
				add:
						(ExChdAdaInterface new
								adaInterfaceFromValues:
										(OrderedCollection new
												add: 'primitive_xml_strings';
												add: nil;
												add: true;
												add: true;
												yourself);
								yourself);
				yourself)

! !

!ExChdAdaUnboundedStringType methodsFor: 'platypus-generated-deriving' stamp: ''!
adsInterfacesList
	^ self adsInterfacesListUsingContext: self class context

! !

!ExChdAdaUnboundedStringType methodsFor: 'platypus-generated-deriving' stamp: ''!
adsInterfacesListUsingContext: aContext
	^ self adsInterfacesListUsingContext: aContext receiver: self

! !

!ExChdAdaUnboundedStringType methodsFor: 'platypus-generated-deriving' stamp: ''!
adsInterfacesListUsingContext: aContext receiver: aReceiver
	^ PlatypusCoreAggregateInitializer
		collectionFrom:
			(OrderedCollection new
				add:
						(ExChdAdaInterface new
								adaInterfaceFromValues:
										(OrderedCollection new
												add: 'ada.strings';
												add: 'unbounded.text_io';
												add: true;
												add: true;
												yourself);
								yourself);
				add:
						(ExChdAdaInterface new
								adaInterfaceFromValues:
										(OrderedCollection new
												add: 'Text_io';
												add: nil;
												add: true;
												add: true;
												yourself);
								yourself);
				add:
						(ExChdAdaInterface new
								adaInterfaceFromValues:
										(OrderedCollection new
												add: 'Unbounded_Strings';
												add: nil;
												add: true;
												add: true;
												yourself);
								yourself);
				add:
						(ExChdAdaInterface new
								adaInterfaceFromValues:
										(OrderedCollection new
												add: 'Convert_Strings';
												add: nil;
												add: true;
												add: false;
												yourself);
								yourself);
				add:
						(ExChdAdaInterface new
								adaInterfaceFromValues:
										(OrderedCollection new
												add: 'Convert_Unbounded_Strings';
												add: nil;
												add: true;
												add: false;
												yourself);
								yourself);
				yourself)

! !

!ExChdAdaUnboundedStringType methodsFor: 'platypus-generated-group-accessing' stamp: ''!
fromValues: values
	^ self adaUnboundedStringTypeFromValues: (super fromValues: values)

! !

!ExChdAdaUnboundedStringType methodsFor: 'platypus-generated-deriving' stamp: ''!
initValue
	^ self initValueUsingContext: self class context

! !

!ExChdAdaUnboundedStringType methodsFor: 'platypus-generated-deriving' stamp: ''!
initValueUsingContext: aContext
	^ self initValueUsingContext: aContext receiver: self

! !

!ExChdAdaUnboundedStringType methodsFor: 'platypus-generated-deriving' stamp: ''!
initValueUsingContext: aContext receiver: aReceiver
	^ 'empty_string'

! !

!ExChdAdaUnboundedStringType methodsFor: 'platypus-generated-classifying' stamp: ''!
isExChdAdaUnboundedStringType
	^ true

! !

!ExChdAdaUnboundedStringType methodsFor: 'platypus-generated-group-accessing' stamp: ''!
localFromValues: values
	^ self adaUnboundedStringTypeFromValues: values

! !

!ExChdAdaUnboundedStringType methodsFor: 'platypus-generated-group-accessing' stamp: ''!
localToValues: values
	^ self adaUnboundedStringTypeToValues: values

! !

!ExChdAdaUnboundedStringType methodsFor: 'platypus-generated-copying' stamp: ''!
pltCopyGroup: aClassSymbol to: anObject
	self class name == aClassSymbol
		ifTrue: [ self pltCopyTo: anObject ]
		ifFalse: [ super pltCopyGroup: aClassSymbol to: anObject ]

! !

!ExChdAdaUnboundedStringType methodsFor: 'platypus-generated-copying' stamp: ''!
pltCopyTo: another
	super pltCopyTo: another.
	self adaUnboundedStringTypeCopyTo: another

! !

!ExChdAdaUnboundedStringType methodsFor: 'platypus-generated-copying' stamp: ''!
pltLocalCopyTo: another
	self adaUnboundedStringTypeCopyTo: another

! !

!ExChdAdaUnboundedStringType methodsFor: 'platypus-generated-initializing' stamp: ''!
stepInitialize
	super stepInitialize

! !

!ExChdAdaUnboundedStringType methodsFor: 'platypus-generated-group-accessing' stamp: ''!
toValues: values
	^ self adaUnboundedStringTypeToValues: (super toValues: values)

! !

ExChdAdaPrimitiveType subclass: #ExChdCheddarPrimitiveType
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Express2Cheddar-CheddarDomainsSchema'!

!ExChdCheddarPrimitiveType commentStamp: 'platypus comment' prior: 0!
<ISO10303-11-EXPRESS>
ENTITY cheddar_primitive_type 
	SUBTYPE OF ( ada_primitive_type );
END_ENTITY;
</ISO10303-11-EXPRESS>!

ExChdCheddarPrimitiveType subclass: #ExChdCheddarLawType
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Express2Cheddar-CheddarDomainsSchema'!

!ExChdCheddarLawType commentStamp: 'platypus comment' prior: 0!
<ISO10303-11-EXPRESS>
ENTITY cheddar_law_type 
	SUBTYPE OF ( cheddar_primitive_type );
DERIVE
	SELF\ada_primitive_type.ads_interfaces_list : LIST OF ada_interface := [ ada_interface ( 'Expression', ?, true, true ), ada_interface ( 'Expression', ?, false, true ) ];
	SELF\ada_primitive_type.adb_interfaces_list : LIST OF ada_interface := [ ];
	ada_ident : STRING := 'law_type';
	ada_ref_ident : STRING := SELF.ada_ident;
	init_value : STRING := ?;
END_ENTITY;
</ISO10303-11-EXPRESS>!

!ExChdCheddarLawType class methodsFor: 'platypus-generated-platypus-signature' stamp: ''!
iso10303P11Translater
	^ 'Platypus (c) LISYC EA3883, Universite de Bretagne occidentale. Brest.'

! !

!ExChdCheddarLawType class methodsFor: 'platypus-generated-meta-data-accessing' stamp: ''!
schemaDefinition
	^ ExChdCheddarDomainsSchemaDefinition singleton

! !

!ExChdCheddarLawType class methodsFor: 'platypus-generated-meta-data-accessing' stamp: ''!
schemaInstance
	^ ExChdExpress2cheddarSchemaInstance singleton

! !

!ExChdCheddarLawType class methodsFor: 'platypus-generated-platypus-signature' stamp: ''!
translatedFromISO10303P11
	^ true

! !

!ExChdCheddarLawType class methodsFor: 'platypus-generated-platypus-signature' stamp: ''!
vwNamespaceName
	^ #Express2Cheddar

! !

!ExChdCheddarLawType methodsFor: 'platypus-generated-visiting' stamp: ''!
accept: aVisitor
	^ aVisitor acceptCheddarLawType: self

! !

!ExChdCheddarLawType methodsFor: 'platypus-generated-deriving' stamp: ''!
adaIdent
	^ self adaIdentUsingContext: self class context

! !

!ExChdCheddarLawType methodsFor: 'platypus-generated-deriving' stamp: ''!
adaIdentUsingContext: aContext
	^ self adaIdentUsingContext: aContext receiver: self

! !

!ExChdCheddarLawType methodsFor: 'platypus-generated-deriving' stamp: ''!
adaIdentUsingContext: aContext receiver: aReceiver
	^ 'law_type'

! !

!ExChdCheddarLawType methodsFor: 'platypus-generated-deriving' stamp: ''!
adaRefIdent
	^ self adaRefIdentUsingContext: self class context

! !

!ExChdCheddarLawType methodsFor: 'platypus-generated-deriving' stamp: ''!
adaRefIdentUsingContext: aContext
	^ self adaRefIdentUsingContext: aContext receiver: self

! !

!ExChdCheddarLawType methodsFor: 'platypus-generated-deriving' stamp: ''!
adaRefIdentUsingContext: aContext receiver: aReceiver
	^ aReceiver adaIdentUsingContext: aContext

! !

!ExChdCheddarLawType methodsFor: 'platypus-generated-deriving' stamp: ''!
adbInterfacesList
	^ self adbInterfacesListUsingContext: self class context

! !

!ExChdCheddarLawType methodsFor: 'platypus-generated-deriving' stamp: ''!
adbInterfacesListUsingContext: aContext
	^ self adbInterfacesListUsingContext: aContext receiver: self

! !

!ExChdCheddarLawType methodsFor: 'platypus-generated-deriving' stamp: ''!
adbInterfacesListUsingContext: aContext receiver: aReceiver
	^ Array new

! !

!ExChdCheddarLawType methodsFor: 'platypus-generated-deriving' stamp: ''!
adsInterfacesList
	^ self adsInterfacesListUsingContext: self class context

! !

!ExChdCheddarLawType methodsFor: 'platypus-generated-deriving' stamp: ''!
adsInterfacesListUsingContext: aContext
	^ self adsInterfacesListUsingContext: aContext receiver: self

! !

!ExChdCheddarLawType methodsFor: 'platypus-generated-deriving' stamp: ''!
adsInterfacesListUsingContext: aContext receiver: aReceiver
	^ PlatypusCoreAggregateInitializer
		collectionFrom:
			(OrderedCollection new
				add:
						(ExChdAdaInterface new
								adaInterfaceFromValues:
										(OrderedCollection new
												add: 'Expression';
												add: nil;
												add: true;
												add: true;
												yourself);
								yourself);
				add:
						(ExChdAdaInterface new
								adaInterfaceFromValues:
										(OrderedCollection new
												add: 'Expression';
												add: nil;
												add: false;
												add: true;
												yourself);
								yourself);
				yourself)

! !

!ExChdCheddarLawType methodsFor: 'platypus-generated-copying' stamp: ''!
cheddarLawTypeCopyTo: another
	

! !

!ExChdCheddarLawType methodsFor: 'platypus-generated-group-accessing' stamp: ''!
cheddarLawTypeFromValues: values
	| valuesloc |
	valuesloc := values asOrderedCollection.
	^ valuesloc

! !

!ExChdCheddarLawType methodsFor: 'platypus-generated-group-accessing' stamp: ''!
cheddarLawTypeToValues: values
	^ values

! !

!ExChdCheddarLawType methodsFor: 'platypus-generated-group-accessing' stamp: ''!
fromValues: values
	^ self cheddarLawTypeFromValues: (super fromValues: values)

! !

!ExChdCheddarLawType methodsFor: 'platypus-generated-deriving' stamp: ''!
initValue
	^ self initValueUsingContext: self class context

! !

!ExChdCheddarLawType methodsFor: 'platypus-generated-deriving' stamp: ''!
initValueUsingContext: aContext
	^ self initValueUsingContext: aContext receiver: self

! !

!ExChdCheddarLawType methodsFor: 'platypus-generated-deriving' stamp: ''!
initValueUsingContext: aContext receiver: aReceiver
	^ nil

! !

!ExChdCheddarLawType methodsFor: 'platypus-generated-classifying' stamp: ''!
isExChdCheddarLawType
	^ true

! !

!ExChdCheddarLawType methodsFor: 'platypus-generated-group-accessing' stamp: ''!
localFromValues: values
	^ self cheddarLawTypeFromValues: values

! !

!ExChdCheddarLawType methodsFor: 'platypus-generated-group-accessing' stamp: ''!
localToValues: values
	^ self cheddarLawTypeToValues: values

! !

!ExChdCheddarLawType methodsFor: 'platypus-generated-copying' stamp: ''!
pltCopyGroup: aClassSymbol to: anObject
	self class name == aClassSymbol
		ifTrue: [ self pltCopyTo: anObject ]
		ifFalse: [ super pltCopyGroup: aClassSymbol to: anObject ]

! !

!ExChdCheddarLawType methodsFor: 'platypus-generated-copying' stamp: ''!
pltCopyTo: another
	super pltCopyTo: another.
	self cheddarLawTypeCopyTo: another

! !

!ExChdCheddarLawType methodsFor: 'platypus-generated-copying' stamp: ''!
pltLocalCopyTo: another
	self cheddarLawTypeCopyTo: another

! !

!ExChdCheddarLawType methodsFor: 'platypus-generated-initializing' stamp: ''!
stepInitialize
	super stepInitialize

! !

!ExChdCheddarLawType methodsFor: 'platypus-generated-group-accessing' stamp: ''!
toValues: values
	^ self cheddarLawTypeToValues: (super toValues: values)

! !

!ExChdCheddarPrimitiveType class methodsFor: 'platypus-generated-platypus-signature' stamp: ''!
iso10303P11Translater
	^ 'Platypus (c) LISYC EA3883, Universite de Bretagne occidentale. Brest.'

! !

!ExChdCheddarPrimitiveType class methodsFor: 'platypus-generated-meta-data-accessing' stamp: ''!
schemaDefinition
	^ ExChdCheddarDomainsSchemaDefinition singleton

! !

!ExChdCheddarPrimitiveType class methodsFor: 'platypus-generated-meta-data-accessing' stamp: ''!
schemaInstance
	^ ExChdExpress2cheddarSchemaInstance singleton

! !

!ExChdCheddarPrimitiveType class methodsFor: 'platypus-generated-platypus-signature' stamp: ''!
translatedFromISO10303P11
	^ true

! !

!ExChdCheddarPrimitiveType class methodsFor: 'platypus-generated-platypus-signature' stamp: ''!
vwNamespaceName
	^ #Express2Cheddar

! !

!ExChdCheddarPrimitiveType methodsFor: 'platypus-generated-visiting' stamp: ''!
accept: aVisitor
	^ aVisitor acceptCheddarPrimitiveType: self

! !

!ExChdCheddarPrimitiveType methodsFor: 'platypus-generated-copying' stamp: ''!
cheddarPrimitiveTypeCopyTo: another
	

! !

!ExChdCheddarPrimitiveType methodsFor: 'platypus-generated-group-accessing' stamp: ''!
cheddarPrimitiveTypeFromValues: values
	| valuesloc |
	valuesloc := values asOrderedCollection.
	^ valuesloc

! !

!ExChdCheddarPrimitiveType methodsFor: 'platypus-generated-group-accessing' stamp: ''!
cheddarPrimitiveTypeToValues: values
	^ values

! !

!ExChdCheddarPrimitiveType methodsFor: 'platypus-generated-group-accessing' stamp: ''!
fromValues: values
	^ self cheddarPrimitiveTypeFromValues: (super fromValues: values)

! !

!ExChdCheddarPrimitiveType methodsFor: 'platypus-generated-classifying' stamp: ''!
isExChdCheddarPrimitiveType
	^ true

! !

!ExChdCheddarPrimitiveType methodsFor: 'platypus-generated-group-accessing' stamp: ''!
localFromValues: values
	^ self cheddarPrimitiveTypeFromValues: values

! !

!ExChdCheddarPrimitiveType methodsFor: 'platypus-generated-group-accessing' stamp: ''!
localToValues: values
	^ self cheddarPrimitiveTypeToValues: values

! !

!ExChdCheddarPrimitiveType methodsFor: 'platypus-generated-copying' stamp: ''!
pltCopyGroup: aClassSymbol to: anObject
	self class name == aClassSymbol
		ifTrue: [ self pltCopyTo: anObject ]
		ifFalse: [ super pltCopyGroup: aClassSymbol to: anObject ]

! !

!ExChdCheddarPrimitiveType methodsFor: 'platypus-generated-copying' stamp: ''!
pltCopyTo: another
	super pltCopyTo: another.
	self cheddarPrimitiveTypeCopyTo: another

! !

!ExChdCheddarPrimitiveType methodsFor: 'platypus-generated-copying' stamp: ''!
pltLocalCopyTo: another
	self cheddarPrimitiveTypeCopyTo: another

! !

!ExChdCheddarPrimitiveType methodsFor: 'platypus-generated-initializing' stamp: ''!
stepInitialize
	super stepInitialize

! !

!ExChdCheddarPrimitiveType methodsFor: 'platypus-generated-group-accessing' stamp: ''!
toValues: values
	^ self cheddarPrimitiveTypeToValues: (super toValues: values)

! !

PltEntityDefinition subclass: #ExChdCheddarEntityDefinition
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Express2Cheddar-CheddarDomainsSchema'!

!ExChdCheddarEntityDefinition commentStamp: 'platypus comment' prior: 0!
<ISO10303-11-EXPRESS>
ENTITY cheddar_entity_definition 
	SUBTYPE OF ( entity_definition );
DERIVE
	ads_interfaces_list : LIST OF ada_interface := [ ];
	adb_interfaces_list : LIST OF ada_interface := [ ];
	ada_ident : STRING := SELF.name;
	ada_ref_ident : STRING := SELF.name;
	init_value : STRING := ?;
	ads_code : STRING := '';
	adb_code : STRING := '';
END_ENTITY;
</ISO10303-11-EXPRESS>!

!ExChdCheddarEntityDefinition class methodsFor: 'platypus-generated-platypus-signature' stamp: ''!
iso10303P11Translater
	^ 'Platypus (c) LISYC EA3883, Universite de Bretagne occidentale. Brest.'

! !

!ExChdCheddarEntityDefinition class methodsFor: 'platypus-generated-meta-data-accessing' stamp: ''!
schemaDefinition
	^ ExChdCheddarDomainsSchemaDefinition singleton

! !

!ExChdCheddarEntityDefinition class methodsFor: 'platypus-generated-meta-data-accessing' stamp: ''!
schemaInstance
	^ ExChdExpress2cheddarSchemaInstance singleton

! !

!ExChdCheddarEntityDefinition class methodsFor: 'platypus-generated-platypus-signature' stamp: ''!
translatedFromISO10303P11
	^ true

! !

!ExChdCheddarEntityDefinition class methodsFor: 'platypus-generated-platypus-signature' stamp: ''!
vwNamespaceName
	^ #Express2Cheddar

! !

!ExChdCheddarEntityDefinition methodsFor: 'platypus-generated-visiting' stamp: ''!
accept: aVisitor
	^ aVisitor acceptCheddarEntityDefinition: self

! !

!ExChdCheddarEntityDefinition methodsFor: 'platypus-generated-deriving' stamp: ''!
adaIdent
	^ self adaIdentUsingContext: self class context

! !

!ExChdCheddarEntityDefinition methodsFor: 'platypus-generated-deriving' stamp: ''!
adaIdentUsingContext: aContext
	^ self adaIdentUsingContext: aContext receiver: self

! !

!ExChdCheddarEntityDefinition methodsFor: 'platypus-generated-deriving' stamp: ''!
adaIdentUsingContext: aContext receiver: aReceiver
	^ aReceiver nameUsingContext: aContext

! !

!ExChdCheddarEntityDefinition methodsFor: 'platypus-generated-deriving' stamp: ''!
adaRefIdent
	^ self adaRefIdentUsingContext: self class context

! !

!ExChdCheddarEntityDefinition methodsFor: 'platypus-generated-deriving' stamp: ''!
adaRefIdentUsingContext: aContext
	^ self adaRefIdentUsingContext: aContext receiver: self

! !

!ExChdCheddarEntityDefinition methodsFor: 'platypus-generated-deriving' stamp: ''!
adaRefIdentUsingContext: aContext receiver: aReceiver
	^ aReceiver nameUsingContext: aContext

! !

!ExChdCheddarEntityDefinition methodsFor: 'platypus-generated-deriving' stamp: ''!
adbCode
	^ self adbCodeUsingContext: self class context

! !

!ExChdCheddarEntityDefinition methodsFor: 'platypus-generated-deriving' stamp: ''!
adbCodeUsingContext: aContext
	^ self adbCodeUsingContext: aContext receiver: self

! !

!ExChdCheddarEntityDefinition methodsFor: 'platypus-generated-deriving' stamp: ''!
adbCodeUsingContext: aContext receiver: aReceiver
	^ ''

! !

!ExChdCheddarEntityDefinition methodsFor: 'platypus-generated-deriving' stamp: ''!
adbInterfacesList
	^ self adbInterfacesListUsingContext: self class context

! !

!ExChdCheddarEntityDefinition methodsFor: 'platypus-generated-deriving' stamp: ''!
adbInterfacesListUsingContext: aContext
	^ self adbInterfacesListUsingContext: aContext receiver: self

! !

!ExChdCheddarEntityDefinition methodsFor: 'platypus-generated-deriving' stamp: ''!
adbInterfacesListUsingContext: aContext receiver: aReceiver
	^ Array new

! !

!ExChdCheddarEntityDefinition methodsFor: 'platypus-generated-deriving' stamp: ''!
adsCode
	^ self adsCodeUsingContext: self class context

! !

!ExChdCheddarEntityDefinition methodsFor: 'platypus-generated-deriving' stamp: ''!
adsCodeUsingContext: aContext
	^ self adsCodeUsingContext: aContext receiver: self

! !

!ExChdCheddarEntityDefinition methodsFor: 'platypus-generated-deriving' stamp: ''!
adsCodeUsingContext: aContext receiver: aReceiver
	^ ''

! !

!ExChdCheddarEntityDefinition methodsFor: 'platypus-generated-deriving' stamp: ''!
adsInterfacesList
	^ self adsInterfacesListUsingContext: self class context

! !

!ExChdCheddarEntityDefinition methodsFor: 'platypus-generated-deriving' stamp: ''!
adsInterfacesListUsingContext: aContext
	^ self adsInterfacesListUsingContext: aContext receiver: self

! !

!ExChdCheddarEntityDefinition methodsFor: 'platypus-generated-deriving' stamp: ''!
adsInterfacesListUsingContext: aContext receiver: aReceiver
	^ Array new

! !

!ExChdCheddarEntityDefinition methodsFor: 'platypus-generated-copying' stamp: ''!
cheddarEntityDefinitionCopyTo: another
	

! !

!ExChdCheddarEntityDefinition methodsFor: 'platypus-generated-group-accessing' stamp: ''!
cheddarEntityDefinitionFromValues: values
	| valuesloc |
	valuesloc := values asOrderedCollection.
	^ valuesloc

! !

!ExChdCheddarEntityDefinition methodsFor: 'platypus-generated-group-accessing' stamp: ''!
cheddarEntityDefinitionToValues: values
	^ values

! !

!ExChdCheddarEntityDefinition methodsFor: 'platypus-generated-group-accessing' stamp: ''!
fromValues: values
	^ self cheddarEntityDefinitionFromValues: (super fromValues: values)

! !

!ExChdCheddarEntityDefinition methodsFor: 'platypus-generated-deriving' stamp: ''!
initValue
	^ self initValueUsingContext: self class context

! !

!ExChdCheddarEntityDefinition methodsFor: 'platypus-generated-deriving' stamp: ''!
initValueUsingContext: aContext
	^ self initValueUsingContext: aContext receiver: self

! !

!ExChdCheddarEntityDefinition methodsFor: 'platypus-generated-deriving' stamp: ''!
initValueUsingContext: aContext receiver: aReceiver
	^ nil

! !

!ExChdCheddarEntityDefinition methodsFor: 'platypus-generated-classifying' stamp: ''!
isExChdCheddarEntityDefinition
	^ true

! !

!ExChdCheddarEntityDefinition methodsFor: 'platypus-generated-group-accessing' stamp: ''!
localFromValues: values
	^ self cheddarEntityDefinitionFromValues: values

! !

!ExChdCheddarEntityDefinition methodsFor: 'platypus-generated-group-accessing' stamp: ''!
localToValues: values
	^ self cheddarEntityDefinitionToValues: values

! !

!ExChdCheddarEntityDefinition methodsFor: 'platypus-generated-copying' stamp: ''!
pltCopyGroup: aClassSymbol to: anObject
	self class name == aClassSymbol
		ifTrue: [ self pltCopyTo: anObject ]
		ifFalse: [ super pltCopyGroup: aClassSymbol to: anObject ]

! !

!ExChdCheddarEntityDefinition methodsFor: 'platypus-generated-copying' stamp: ''!
pltCopyTo: another
	super pltCopyTo: another.
	self cheddarEntityDefinitionCopyTo: another

! !

!ExChdCheddarEntityDefinition methodsFor: 'platypus-generated-copying' stamp: ''!
pltLocalCopyTo: another
	self cheddarEntityDefinitionCopyTo: another

! !

!ExChdCheddarEntityDefinition methodsFor: 'platypus-generated-initializing' stamp: ''!
stepInitialize
	super stepInitialize

! !

!ExChdCheddarEntityDefinition methodsFor: 'platypus-generated-group-accessing' stamp: ''!
toValues: values
	^ self cheddarEntityDefinitionToValues: (super toValues: values)

! !

PltEntityDefinition subclass: #ExChdCheddarFunctionPtr
	instanceVariableNames: 'arguments returns'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Express2Cheddar-RecordAndClassSchema'!

!ExChdCheddarFunctionPtr commentStamp: 'platypus comment' prior: 0!
<ISO10303-11-EXPRESS>
ENTITY cheddar_function_ptr 
	SUBTYPE OF ( entity_definition );
	arguments : STRING;
	returns : STRING;
DERIVE
	ads_interface_list : LIST OF ada_interface := [ ];
	adb_interface_list : LIST OF ada_interface := [ ];
	ads_code : STRING := 'Type ' + SELF.name + ' is access function (' + SELF.arguments + ') return ' + SELF.returns + ';';
	adb_code : STRING := '';
	dependencies : LIST OF dictionary_instance := [ SELF ];
	refed_by_pointer : BOOLEAN := false;
END_ENTITY;
</ISO10303-11-EXPRESS>!

!ExChdCheddarFunctionPtr class methodsFor: 'platypus-generated-platypus-signature' stamp: ''!
iso10303P11Translater
	^ 'Platypus (c) LISYC EA3883, Universite de Bretagne occidentale. Brest.'

! !

!ExChdCheddarFunctionPtr class methodsFor: 'platypus-generated-meta-data-accessing' stamp: ''!
schemaDefinition
	^ ExChdRecordAndClassSchemaDefinition singleton

! !

!ExChdCheddarFunctionPtr class methodsFor: 'platypus-generated-meta-data-accessing' stamp: ''!
schemaInstance
	^ ExChdExpress2cheddarSchemaInstance singleton

! !

!ExChdCheddarFunctionPtr class methodsFor: 'platypus-generated-platypus-signature' stamp: ''!
translatedFromISO10303P11
	^ true

! !

!ExChdCheddarFunctionPtr class methodsFor: 'platypus-generated-platypus-signature' stamp: ''!
vwNamespaceName
	^ #Express2Cheddar

! !

!ExChdCheddarFunctionPtr methodsFor: 'platypus-generated-visiting' stamp: ''!
accept: aVisitor
	^ aVisitor acceptCheddarFunctionPtr: self

! !

!ExChdCheddarFunctionPtr methodsFor: 'platypus-generated-deriving' stamp: ''!
adbCode
	^ self adbCodeUsingContext: self class context

! !

!ExChdCheddarFunctionPtr methodsFor: 'platypus-generated-deriving' stamp: ''!
adbCodeUsingContext: aContext
	^ self adbCodeUsingContext: aContext receiver: self

! !

!ExChdCheddarFunctionPtr methodsFor: 'platypus-generated-deriving' stamp: ''!
adbCodeUsingContext: aContext receiver: aReceiver
	^ ''

! !

!ExChdCheddarFunctionPtr methodsFor: 'platypus-generated-deriving' stamp: ''!
adbInterfaceList
	^ self adbInterfaceListUsingContext: self class context

! !

!ExChdCheddarFunctionPtr methodsFor: 'platypus-generated-deriving' stamp: ''!
adbInterfaceListUsingContext: aContext
	^ self adbInterfaceListUsingContext: aContext receiver: self

! !

!ExChdCheddarFunctionPtr methodsFor: 'platypus-generated-deriving' stamp: ''!
adbInterfaceListUsingContext: aContext receiver: aReceiver
	^ Array new

! !

!ExChdCheddarFunctionPtr methodsFor: 'platypus-generated-deriving' stamp: ''!
adsCode
	^ self adsCodeUsingContext: self class context

! !

!ExChdCheddarFunctionPtr methodsFor: 'platypus-generated-deriving' stamp: ''!
adsCodeUsingContext: aContext
	^ self adsCodeUsingContext: aContext receiver: self

! !

!ExChdCheddarFunctionPtr methodsFor: 'platypus-generated-deriving' stamp: ''!
adsCodeUsingContext: aContext receiver: aReceiver
	^ ((((('Type ' pltPlus: (aReceiver nameUsingContext: aContext)) pltPlus: ' is access function (')
		pltPlus: (aReceiver argumentsUsingContext: aContext)) pltPlus: ') return ')
		pltPlus: (aReceiver returnsUsingContext: aContext)) pltPlus: ';'

! !

!ExChdCheddarFunctionPtr methodsFor: 'platypus-generated-deriving' stamp: ''!
adsInterfaceList
	^ self adsInterfaceListUsingContext: self class context

! !

!ExChdCheddarFunctionPtr methodsFor: 'platypus-generated-deriving' stamp: ''!
adsInterfaceListUsingContext: aContext
	^ self adsInterfaceListUsingContext: aContext receiver: self

! !

!ExChdCheddarFunctionPtr methodsFor: 'platypus-generated-deriving' stamp: ''!
adsInterfaceListUsingContext: aContext receiver: aReceiver
	^ Array new

! !

!ExChdCheddarFunctionPtr methodsFor: 'platypus-generated-accessing' stamp: ''!
arguments
	^ arguments

! !

!ExChdCheddarFunctionPtr methodsFor: 'platypus-generated-accessing' stamp: ''!
arguments: aString
	arguments := aString

! !

!ExChdCheddarFunctionPtr methodsFor: 'platypus-generated-with-context-accessing' stamp: ''!
argumentsUsingContext: aContext
	^ self arguments

! !

!ExChdCheddarFunctionPtr methodsFor: 'platypus-generated-copying' stamp: ''!
cheddarFunctionPtrCopyTo: another
	another fastSetArguments: self arguments.
	another fastSetReturns: self returns

! !

!ExChdCheddarFunctionPtr methodsFor: 'platypus-generated-group-accessing' stamp: ''!
cheddarFunctionPtrFromValues: values
	| valuesloc |
	valuesloc := values asOrderedCollection.
	self setArguments: valuesloc removeFirst.
	self setReturns: valuesloc removeFirst.
	^ valuesloc

! !

!ExChdCheddarFunctionPtr methodsFor: 'platypus-generated-group-accessing' stamp: ''!
cheddarFunctionPtrToValues: values
	values add: self arguments.
	values add: self returns.
	^ values

! !

!ExChdCheddarFunctionPtr methodsFor: 'platypus-generated-deriving' stamp: ''!
dependencies
	^ self dependenciesUsingContext: self class context

! !

!ExChdCheddarFunctionPtr methodsFor: 'platypus-generated-deriving' stamp: ''!
dependenciesUsingContext: aContext
	^ self dependenciesUsingContext: aContext receiver: self

! !

!ExChdCheddarFunctionPtr methodsFor: 'platypus-generated-deriving' stamp: ''!
dependenciesUsingContext: aContext receiver: aReceiver
	^ PlatypusCoreAggregateInitializer
		collectionFrom:
			(OrderedCollection new
				add: aReceiver;
				yourself)

! !

!ExChdCheddarFunctionPtr methodsFor: 'platypus-generated-fast-set-accessing' stamp: ''!
fastSetArguments: aString
	arguments := aString

! !

!ExChdCheddarFunctionPtr methodsFor: 'platypus-generated-fast-set-accessing' stamp: ''!
fastSetReturns: aString
	returns := aString

! !

!ExChdCheddarFunctionPtr methodsFor: 'platypus-generated-group-accessing' stamp: ''!
fromValues: values
	^ self cheddarFunctionPtrFromValues: (super fromValues: values)

! !

!ExChdCheddarFunctionPtr methodsFor: 'platypus-generated-classifying' stamp: ''!
isExChdCheddarFunctionPtr
	^ true

! !

!ExChdCheddarFunctionPtr methodsFor: 'platypus-generated-group-accessing' stamp: ''!
localFromValues: values
	^ self cheddarFunctionPtrFromValues: values

! !

!ExChdCheddarFunctionPtr methodsFor: 'platypus-generated-group-accessing' stamp: ''!
localToValues: values
	^ self cheddarFunctionPtrToValues: values

! !

!ExChdCheddarFunctionPtr methodsFor: 'platypus-generated-copying' stamp: ''!
pltCopyGroup: aClassSymbol to: anObject
	self class name == aClassSymbol
		ifTrue: [ self pltCopyTo: anObject ]
		ifFalse: [ super pltCopyGroup: aClassSymbol to: anObject ]

! !

!ExChdCheddarFunctionPtr methodsFor: 'platypus-generated-copying' stamp: ''!
pltCopyTo: another
	super pltCopyTo: another.
	self cheddarFunctionPtrCopyTo: another

! !

!ExChdCheddarFunctionPtr methodsFor: 'platypus-generated-copying' stamp: ''!
pltLocalCopyTo: another
	self cheddarFunctionPtrCopyTo: another

! !

!ExChdCheddarFunctionPtr methodsFor: 'platypus-generated-deriving' stamp: ''!
refedByPointer
	^ self refedByPointerUsingContext: self class context

! !

!ExChdCheddarFunctionPtr methodsFor: 'platypus-generated-deriving' stamp: ''!
refedByPointerUsingContext: aContext
	^ self refedByPointerUsingContext: aContext receiver: self

! !

!ExChdCheddarFunctionPtr methodsFor: 'platypus-generated-deriving' stamp: ''!
refedByPointerUsingContext: aContext receiver: aReceiver
	^ false

! !

!ExChdCheddarFunctionPtr methodsFor: 'platypus-generated-accessing' stamp: ''!
returns
	^ returns

! !

!ExChdCheddarFunctionPtr methodsFor: 'platypus-generated-accessing' stamp: ''!
returns: aString
	returns := aString

! !

!ExChdCheddarFunctionPtr methodsFor: 'platypus-generated-with-context-accessing' stamp: ''!
returnsUsingContext: aContext
	^ self returns

! !

!ExChdCheddarFunctionPtr methodsFor: 'platypus-generated-set-accessing' stamp: ''!
setArguments: aString
	self arguments: aString

! !

!ExChdCheddarFunctionPtr methodsFor: 'platypus-generated-set-accessing' stamp: ''!
setReturns: aString
	self returns: aString

! !

!ExChdCheddarFunctionPtr methodsFor: 'platypus-generated-initializing' stamp: ''!
stepInitialize
	super stepInitialize.
	arguments := ''.
	returns := ''

! !

!ExChdCheddarFunctionPtr methodsFor: 'platypus-generated-group-accessing' stamp: ''!
toValues: values
	^ self cheddarFunctionPtrToValues: (super toValues: values)

! !

PlatypusCoreSchemaInstance subclass: #ExChdExpress2cheddarSchemaInstance
	instanceVariableNames: 'context'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Express2Cheddar-Express2cheddarSchemaInstance'!

!ExChdExpress2cheddarSchemaInstance commentStamp: 'platypus comment' prior: 0!
<ISO10303-11-EXPRESS>
SCHEMA express2cheddar_facade;
	USE FROM Package;
	USE FROM record_and_class;
	USE FROM discriminated_type;
	USE FROM platypus_dictionary_schema;
	USE FROM express_toolsbox_functions;
	USE FROM express_dictionary_queries;
	USE FROM cheddar_domains;
	USE FROM cheddar_dtd;

	CONSTANT 
		source_licence : STRING := '' + '------------------------------------------------------------------------------\n' 
		+ '------------------------------------------------------------------------------\n' 
		+ '--  This source file was automatically generated by Platypus\n' 
		+ '--  see http://dossen.univ-brest.fr/apl\n' 
		+ '-- \n' 
		+ '--  Any modification of this file will be lost. \n' 
		+ '--  Please see the "platypus" directory instead : it contains the Cheddar''s\n' 
		+ '--  model and its meta-model. \n' 
		+ '------------------------------------------------------------------------------\n \n' 
		+ '------------------------------------------------------------------------------\n' 
		+ '-- Cheddar is a free real time scheduling tool.\n' 
		+ '-- This program provides services to automatically check temporal constraints\n' 
		+ '-- of real time tasks.\n' 
		+ '--\n' 
		+ '-- Copyright (C) 2002-2014   Frank Singhoff\n' 
		+ '-- Cheddar is developed by the LAB-STICC Team, University of Brest\n' 
		+ '--\n' 
		+ '-- This program is free software; you can redistribute it and/or modify\n' 
		+ '-- it under the terms of the GNU General Public License as published by\n' 
		+ '-- the Free Software Foundation; either version 2 of the License, or\n' 
		+ '-- (at your option) any later version.\n' 
		+ '--\n' 
		+ '-- This program is distributed in the hope that it will be useful,\n' 
		+ '-- but WITHOUT ANY WARRANTY; without even the implied warranty of\n' 
		+ '-- MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the\n' 
		+ '-- GNU General Public License for more details.\n' 
		+ '--\n' 
		+ '-- You should have received a copy of the GNU General Public License\n' 
		+ '-- along with this program; if not, write to the Free Software\n' 
		+ '-- Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA\n' 
		+ '--\n' 
		+ '--\n' 
		+ '-- Contact : cheddar@listes.univ-brest.fr\n' 
		+ '-- 	To post to this mailing list, you must be subscribed\n' 
		+ '-- 	(see http//beru.univ-brest.fr/~singhoff/cheddar for details)\n' 
		+ '--\n' 
		+ '------------------------------------------------------------------------------\n' 
		+ '------------------------------------------------------------------------------\n';
		xml_id_name : STRING := 'cheddar_private_id';
	END_CONSTANT;

	FUNCTION is_of_generated_concept_kind ( c : dictionary_instance ) : BOOLEAN;
		RETURN ( ( 'CHEDDAR_DOMAINS.ADA_TYPE' IN TYPEOF ( c ) ) OR ( 'RECORD_AND_CLASS.ADA_ENTITY' IN TYPEOF ( c ) ) OR ( 'PACKAGE.PACKAGE_ALIAS' IN TYPEOF ( c ) ) OR ( 'RECORD_AND_CLASS.CHEDDAR_FUNCTION_PTR' IN TYPEOF ( c ) ) );
	END_FUNCTION;

	FUNCTION all_ada_packages : SET OF ada_package;
		LOCAL 
			insts : SET OF GENERIC := allModelInstances ( );
		END_LOCAL;
		RETURN ( QUERY ( i <* insts | 'PACKAGE.ADA_PACKAGE' IN TYPEOF ( i ) ) );
	END_FUNCTION;

	FUNCTION ada_package_named ( name : STRING ) : ada_package;
		LOCAL 
			packages : SET OF ada_package := all_ada_packages ( );
			key : STRING := Lowerize ( name );
		END_LOCAL;

		REPEAT no := LOINDEX ( packages ) TO HIINDEX ( packages );
			ALIAS curr FOR packages [ no];
				IF ( Lowerize ( curr.name ) = key ) THEN
					RETURN ( curr );
				END_IF;
			END_ALIAS;
		END_REPEAT;
		RETURN ( ? );
	END_FUNCTION;

	FUNCTION package_ada_classes ( pkg : ada_package ) : LIST OF ada_class;
		LOCAL 
			cls_list : LIST OF ada_class := [ ];
		END_LOCAL;

		ALIAS entities FOR pkg.entities;
			REPEAT noi := LOINDEX ( entities ) TO HIINDEX ( entities );
				IF ( 'RECORD_AND_CLASS.ADA_CLASS' IN TYPEOF ( entities [ noi] ) ) THEN
					cls_list := cls_list + entities [ noi];
				END_IF;
			END_REPEAT;
		END_ALIAS;
		RETURN ( cls_list );
	END_FUNCTION;

	FUNCTION all_ada_classes : LIST OF ada_entity;
		LOCAL 
			cls_list : LIST OF ada_class := [ ];
			all_pkgs : LIST OF ada_package := SetToList ( all_ada_packages ( ) );
		END_LOCAL;

		REPEAT no := LOINDEX ( all_pkgs ) TO HIINDEX ( all_pkgs );
			cls_list := cls_list + package_ada_classes ( all_pkgs [ no] );
		END_REPEAT;
		RETURN ( cls_list );
	END_FUNCTION;

	PROCEDURE prepare_root_ada_classes;
		LOCAL 
			clslist : LIST OF ada_class := all_ada_classes ( );
		END_LOCAL;

		REPEAT no := LOINDEX ( clslist ) TO HIINDEX ( clslist );
			ALIAS curr FOR clslist [ no];
				IF SIZEOF ( curr.supertypes ) = 0 THEN
					IF NOT has_attribute_named ( curr, xml_id_name ) THEN
						add_xml_id_to_ada_class ( curr );
					END_IF;
				END_IF;
			END_ALIAS;
		END_REPEAT;
	END_PROCEDURE;

	FUNCTION all_ada_records : LIST OF ada_entity;
		LOCAL 
			cls_list : LIST OF ada_class := [ ];
			all_pkgs : LIST OF ada_package := SetToList ( all_ada_packages ( ) );
		END_LOCAL;

		REPEAT no := LOINDEX ( all_pkgs ) TO HIINDEX ( all_pkgs );
			ALIAS entities FOR all_pkgs [ no].entities;
				REPEAT noi := LOINDEX ( entities ) TO HIINDEX ( entities );
					IF ( 'RECORD_AND_CLASS.RECORD' IN TYPEOF ( entities [ noi] ) ) THEN
						cls_list := cls_list + entities [ noi];
					END_IF;
				END_REPEAT;
			END_ALIAS;
		END_REPEAT;
		RETURN ( cls_list );
	END_FUNCTION;

	FUNCTION all_ada_discriminated_types : LIST OF ada_entity;
		LOCAL 
			dt_list : LIST OF discriminated_type := [ ];
			all_pkgs : LIST OF ada_package := SetToList ( all_ada_packages ( ) );
		END_LOCAL;

		REPEAT no := LOINDEX ( all_pkgs ) TO HIINDEX ( all_pkgs );
			ALIAS entities FOR all_pkgs [ no].entities;
				REPEAT noi := LOINDEX ( entities ) TO HIINDEX ( entities );
					IF ( 'DISCRIMINATED_TYPE.DISCRIMINATED_TYPE' IN TYPEOF ( entities [ noi] ) ) THEN
						dt_list := dt_list + entities [ noi];
					END_IF;
				END_REPEAT;
			END_ALIAS;
		END_REPEAT;
		RETURN ( dt_list );
	END_FUNCTION;

	PROCEDURE add_xml_id_to_ada_class ( VAR cls : ada_class );
		LOCAL 
			idtype : cheddar_xml_id_type := entity_instance ( ? ) || sdai_instance ( ) || dictionary_instance ( ) || simple_type ( ) || string_type ( ?, false ) || cheddar_xml_id_type ( );
			idattr : explicit_attribute := entity_instance ( cls ) || sdai_instance ( ) || dictionary_instance ( ) || attribute ( xml_id_name, cls, idtype, ? ) || explicit_attribute ( false );
		END_LOCAL;
		idtype.owner := idattr;
		INSERT ( cls.attributes, idattr, 0 );
	END_PROCEDURE;

	FUNCTION package_records ( pkg : ada_package ) : LIST OF record;
		LOCAL 
			rec_list : LIST OF record := [ ];
		END_LOCAL;

		ALIAS entities FOR pkg.entities;
			REPEAT noi := LOINDEX ( entities ) TO HIINDEX ( entities );
				IF ( 'RECORD_AND_CLASS.RECORD' IN TYPEOF ( entities [ noi] ) ) THEN
					rec_list := rec_list + entities [ noi];
				END_IF;
			END_REPEAT;
		END_ALIAS;
		RETURN ( rec_list );
	END_FUNCTION;

	FUNCTION package_discriminated_types ( pkg : ada_package ) : LIST OF discriminated_type;
		LOCAL 
			dt_list : LIST OF discriminated_type := [ ];
		END_LOCAL;

		ALIAS entities FOR pkg.entities;
			REPEAT noi := LOINDEX ( entities ) TO HIINDEX ( entities );
				IF ( 'DISCRIMINATED_TYPE.DISCRIMINATED_TYPE' IN TYPEOF ( entities [ noi] ) ) THEN
					dt_list := dt_list + entities [ noi];
				END_IF;
			END_REPEAT;
		END_ALIAS;
		RETURN ( dt_list );
	END_FUNCTION;

	FUNCTION ada_entity_named ( name : STRING ) : ada_entity;
		LOCAL 
			entities : LIST OF ada_entity := all_ada_entities ( );
			key : STRING := Lowerize ( name );
		END_LOCAL;

		REPEAT no := LOINDEX ( entities ) TO HIINDEX ( entities );
			ALIAS curr FOR entities [ no];
				IF ( Lowerize ( curr.name ) = key ) THEN
					RETURN ( curr );
				END_IF;
			END_ALIAS;
		END_REPEAT;
		RETURN ( ? );
	END_FUNCTION;

	FUNCTION all_ada_entities : LIST OF ada_entity;
		LOCAL 
			ent_list : LIST OF ada_entity := [ ];
			all_pkgs : LIST OF ada_package := SetToList ( all_ada_packages ( ) );
		END_LOCAL;

		REPEAT no := LOINDEX ( all_pkgs ) TO HIINDEX ( all_pkgs );
			ALIAS entities FOR all_pkgs [ no].entities;
				REPEAT noi := LOINDEX ( entities ) TO HIINDEX ( entities );
					IF ( 'RECORD_AND_CLASS.RECORD' IN TYPEOF ( entities [ noi] ) ) THEN
						ent_list := ent_list + entities [ noi];
					END_IF;
					IF ( 'RECORD_AND_CLASS.ADA_CLASS' IN TYPEOF ( entities [ noi] ) ) THEN
						ent_list := ent_list + entities [ noi];
					END_IF;
					IF ( 'DISCRIMINATED_TYPE.DISCRIMINATED_TYPE' IN TYPEOF ( entities [ noi] ) ) THEN
						ent_list := ent_list + entities [ noi];
					END_IF;
				END_REPEAT;
			END_ALIAS;
		END_REPEAT;
		RETURN ( ent_list );
	END_FUNCTION;

	PROCEDURE dtds_Into ( dir : STRING );
		LOCAL 
			roots : LIST OF root_dtd_element := root_dtds ( );
			path : STRING;
		END_LOCAL;
		(*#  MultiByteFileStream defaultToLF  #*) prepare_root_ada_classes;

		IF EXISTS ( dir ) THEN
			path := dir;
		ELSE
			path := '.';
		END_IF;

		REPEAT no := LOINDEX ( roots ) TO HIINDEX ( roots );
			ALIAS curr FOR roots [ no];
				WriteFile ( path + '/' + curr.tag + '.dtd', curr.dtd_code );
			END_ALIAS;
		END_REPEAT;
	END_PROCEDURE;

	PROCEDURE generate_all_into ( dir : STRING );
		(*#  MultiByteFileStream defaultToLF  #*) prepare_root_ada_classes;
		all_packages_code_into ( true, dir, 'Platypus2Cheddar' );
		all_packages_code_into ( false, dir, 'Platypus2Cheddar' );
		dtds_into ( dir );
	END_PROCEDURE;
END_SCHEMA;


SCHEMA cheddar_dtd;
	USE FROM express2cheddar_facade;
	USE FROM platypus_dictionary_schema;
	USE FROM express_toolsbox_functions;
	USE FROM express_dictionary_queries;
	USE FROM record_and_class;
	USE FROM cheddar_domains;
	USE FROM package;
	USE FROM discriminated_type;

	ENTITY dtd_element 
		ABSTRACT SUPERTYPE;
		owner : OPTIONAL dtd_element;
		tag : STRING;
	DERIVE
		dtd_code : STRING := '';
	END_ENTITY;

	ENTITY composite_dtd_element 
		ABSTRACT SUPERTYPE 
		SUBTYPE OF ( dtd_element );
	DERIVE
		subs : LIST OF dtd_element := [ ];
	END_ENTITY;

	ENTITY root_dtd_element 
		SUBTYPE OF ( composite_dtd_element );
	DERIVE
		packages : LIST OF ada_package := xml_packages_with_tag ( SELF.tag );
		SELF\composite_dtd_element.subs : LIST OF package_dtd_element := compute_root_sub_elements ( SELF );
		SELF\dtd_element.dtd_code : STRING := compute_root_dtd_code ( SELF );
		declared_domains : LIST OF dtd_element := get_declared_entity_domains ( subs );
		referenced_entities : LIST OF dtd_element := get_referenced_entity_domains ( subs );
		implicit_domains : LIST OF entity_ref_dtd_element := compute_implicit_domains ( SELF );
	END_ENTITY;

	ENTITY package_dtd_element 
		SUBTYPE OF ( composite_dtd_element );
		package : ada_package;
	DERIVE
		SELF\dtd_element.tag : STRING := lowerize ( package.name );
		SELF\composite_dtd_element.subs : LIST OF dtd_element := compute_package_sub_elements ( SELF );
		SELF\dtd_element.dtd_code : STRING := compute_package_dtd_code ( SELF );
		attributes : LIST OF attribute_dtd_element := compute_package_attribute_dtd_elements ( SELF );
	END_ENTITY;

	ENTITY entity_dtd_element 
		SUBTYPE OF ( composite_dtd_element );
		domain : ada_entity;
	DERIVE
		SELF\dtd_element.tag : STRING := lowerize ( domain.name );
		SELF\composite_dtd_element.subs : LIST OF dtd_element := compute_entity_sub_elements ( SELF );
		SELF\dtd_element.dtd_code : STRING := compute_entity_dtd_code ( SELF );
	END_ENTITY;

	ENTITY ada_class_dtd_element 
		SUBTYPE OF ( entity_dtd_element );
	END_ENTITY;

	ENTITY record_dtd_element 
		SUBTYPE OF ( entity_dtd_element );
	END_ENTITY;

	ENTITY discriminated_type_dtd_element 
		SUBTYPE OF ( entity_dtd_element );
	DERIVE
		SELF\entity_dtd_element.subs : LIST OF dtd_element := compute_discriminated_type_sub_elements ( SELF );
		SELF\entity_dtd_element.dtd_code : STRING := compute_discriminated_type_code ( SELF );
	END_ENTITY;

	ENTITY attribute_dtd_element 
		SUBTYPE OF ( dtd_element );
		attribute : attribute;
		domain : domain_dtd_element;
	DERIVE
		SELF\dtd_element.tag : STRING := lowerize ( attribute.name );
		SELF\dtd_element.dtd_code : STRING := domain.dtd_code;
	END_ENTITY;

	ENTITY domain_dtd_element 
		SUBTYPE OF ( dtd_element );
		domain : entity_instance;
	DERIVE
		as_collection_element_dtd_code_tail : STRING := '';
	END_ENTITY;

	ENTITY simple_domain_dtd_element 
		SUBTYPE OF ( domain_dtd_element );
	DERIVE
		SELF\dtd_element.dtd_code : STRING := '<!!ELEMENT ' + SELF.owner.tag + ' (#PCDATA)>\n';
		SELF\domain_dtd_element.as_collection_element_dtd_code_tail : STRING := '(#PCDATA)>\n';
	END_ENTITY;

	ENTITY collection_dtd_element 
		SUBTYPE OF ( domain_dtd_element );
		element_domain : domain_dtd_element;
	DERIVE
		SELF\dtd_element.dtd_code : STRING := '<!!ELEMENT ' + owner.tag + ' ' + element_domain.as_collection_element_dtd_code_tail;
	END_ENTITY;

	ENTITY entity_ref_dtd_element 
		SUBTYPE OF ( domain_dtd_element );
	DERIVE
		infered_element : entity_dtd_element := ?;
		SELF\dtd_element.dtd_code : STRING := '<!!ELEMENT ' + owner.tag + ' (' + lowerize ( domain.name ) + ')>\n';
	END_ENTITY;

	ENTITY record_ref_dtd_element 
		SUBTYPE OF ( entity_ref_dtd_element );
	DERIVE
		SELF\entity_ref_dtd_element.infered_element : entity_dtd_element := dtd_element ( ?, ? ) || composite_dtd_element ( ) || entity_dtd_element ( domain ) || record_dtd_element ( );
		SELF\domain_dtd_element.as_collection_element_dtd_code_tail : STRING := '(' + lowerize ( domain.handled.name ) + ')*>\n';
	END_ENTITY;

	ENTITY ada_class_ref_dtd_element 
		SUBTYPE OF ( entity_ref_dtd_element );
	DERIVE
		SELF\entity_ref_dtd_element.infered_element : entity_dtd_element := dtd_element ( ?, ? ) || composite_dtd_element ( ) || entity_dtd_element ( domain ) || ada_class_dtd_element ( );
		SELF\entity_ref_dtd_element.dtd_code : STRING := '<!!ELEMENT ' + owner.tag + ' EMPTY>\n' 
		+ '<!!ATTLIST ' + owner.tag + ' ref IDREF #REQUIRED>\n';
		SELF\entity_ref_dtd_element.as_collection_element_dtd_code_tail : STRING := ' EMPTY>\n' 
		+ '<!!ATTLIST ' + owner.owner.tag + ' refs IDREFS #REQUIRED>\n';
	END_ENTITY;

	ENTITY discriminated_type_ref_dtd_element 
		SUBTYPE OF ( entity_ref_dtd_element );
	DERIVE
		SELF\entity_ref_dtd_element.infered_element : entity_dtd_element := dtd_element ( ?, ? ) || composite_dtd_element ( ) || entity_dtd_element ( domain ) || discriminated_type_dtd_element ( );
		SELF\domain_dtd_element.as_collection_element_dtd_code_tail : STRING := '(' + lowerize ( domain.handled.name ) + ')*>\n';
	END_ENTITY;

	ENTITY unknown_domain_dtd_element 
		SUBTYPE OF ( domain_dtd_element );
	DERIVE
		SELF\dtd_element.dtd_code : STRING := '<!!ELEMENT ' + SELF.owner.tag + ' ANY>\n';
		SELF\domain_dtd_element.as_collection_element_dtd_code_tail : STRING := 'ANY>\n';
	END_ENTITY;

	FUNCTION compute_root_dtd_code ( r : root_dtd_element ) : STRING;
		LOCAL 
			s : STRING := '';
			code : STRING;
			lines : LIST OF STRING := [ ];
			licence : STRING := string_replace ( source_licence, '--', '  ' );
			pkgs : LIST OF package_dtd_element := r.subs;
			attributes : LIST OF attribute_dtd_element := [ ];
			acode : STRING;
			previous : LIST OF STRING := [ ];
			implicits : LIST OF dtd_element := r.implicit_domains;
			infered : LIST OF entity_dtd_element := [ ];
			el : entity_dtd_element;
			infered_attributes : LIST OF attribute_dtd_element := [ ];
		END_LOCAL;

		REPEAT no := LOINDEX ( implicits ) TO HIINDEX ( implicits );
			el := implicits [ no].infered_element;
			infered := infered + el;
			infered_attributes := infered_attributes + el.subs;
		END_REPEAT;
		s := s + '<!!--' + licence + '-->\n\n' 

		+ '<!!ELEMENT ' + r.tag + ' (';

		REPEAT no := LOINDEX ( pkgs ) TO HIINDEX ( pkgs );
			s := s + pkgs [ no].tag + '?';
			IF ( no < HIINDEX ( pkgs ) ) THEN
				s := s + ' | ';
			END_IF;
		END_REPEAT;
		s := s + ')*>\n\n';

		REPEAT no := LOINDEX ( pkgs ) TO HIINDEX ( pkgs );
			code := pkgs [ no].dtd_code;
			previous := previous + LinesFromString ( code );
			s := s + code;
		END_REPEAT;
		s := s + '\n';

		REPEAT no := LOINDEX ( infered ) TO HIINDEX ( infered );
			acode := infered [ no].dtd_code;
			IF NOT ( acode IN previous ) THEN
				s := s + acode;
				previous := previous + acode;
			END_IF;
		END_REPEAT;

		REPEAT no := LOINDEX ( pkgs ) TO HIINDEX ( pkgs );
			attributes := attributes + compute_package_attribute_dtd_elements ( pkgs [ no] );
		END_REPEAT;

		REPEAT no := LOINDEX ( attributes ) TO HIINDEX ( attributes );
			acode := attributes [ no].dtd_code;
			IF NOT ( acode IN previous ) THEN
				s := s + attributes [ no].dtd_code;
				previous := previous + acode;
			END_IF;
		END_REPEAT;

		REPEAT no := LOINDEX ( infered_attributes ) TO HIINDEX ( infered_attributes );
			acode := infered_attributes [ no].dtd_code;
			IF NOT ( acode IN previous ) THEN
				s := s + acode;
				previous := previous + acode;
			END_IF;
		END_REPEAT;
		RETURN ( s );
	END_FUNCTION;

	FUNCTION root_dtds : LIST OF root_dtd_element;
		LOCAL 
			xml_pkgs : LIST OF ada_package := xml_packages ( );
			root_names : LIST OF STRING := [ ];
			result : LIST OF root_dtd_element := [ ];
		END_LOCAL;

		REPEAT no := LOINDEX ( xml_pkgs ) TO HIINDEX ( xml_pkgs );
			ALIAS curr_pkg FOR xml_pkgs [ no];
				root_names := root_names + curr_pkg.xml_root_tags;
			END_ALIAS;
		END_REPEAT;
		root_names := SetToList ( ListToSet ( root_names ) );

		REPEAT no := LOINDEX ( root_names ) TO HIINDEX ( root_names );
			result := result + composite_dtd_element ( ) || root_dtd_element ( ) || dtd_element ( ?, root_names [ no] );
		END_REPEAT;
		RETURN ( result );
	END_FUNCTION;

	FUNCTION compute_root_sub_elements ( e : root_dtd_element ) : LIST OF package_dtd_element;
		LOCAL 
			result : LIST OF package_dtd_element := [ ];
		END_LOCAL;

		ALIAS packages FOR e.packages;
			REPEAT no := LOINDEX ( packages ) TO HIINDEX ( packages );
				result := result + ( dtd_element ( e, ? ) || composite_dtd_element ( ) || package_dtd_element ( packages [ no] ) );
			END_REPEAT;
		END_ALIAS;
		RETURN ( result );
	END_FUNCTION;

	FUNCTION compute_package_attribute_dtd_elements ( p : package_dtd_element ) : LIST OF attribute_dtd_element;
		LOCAL 
			subs : LIST OF dtd_element := p.subs;
			r : LIST OF attribute_dtd_element := [ ];
		END_LOCAL;

		REPEAT no := LOINDEX ( subs ) TO HIINDEX ( subs );
			r := r + subs [ no].subs;
		END_REPEAT;
		RETURN ( r );
	END_FUNCTION;

	FUNCTION compute_package_dtd_code ( p : package_dtd_element ) : STRING;
		LOCAL 
			subs : LIST OF dtd_element := p.subs;
			s : STRING := '';
		END_LOCAL;

		IF ( SIZEOF ( subs ) > 0 ) THEN
			s := s + '<!!ELEMENT ' + p.tag + ' (';
			REPEAT no := LOINDEX ( subs ) TO HIINDEX ( subs );
				s := s + subs [ no].tag;
				IF ( no < HIINDEX ( subs ) ) THEN
					s := s + ' | ';
				END_IF;
			END_REPEAT;
			s := s + ')+>\n';
			REPEAT no := LOINDEX ( subs ) TO HIINDEX ( subs );
				s := s + subs [ no].dtd_code;
			END_REPEAT;
			s := s + '\n';
		END_IF;
		RETURN ( s );
	END_FUNCTION;

	FUNCTION compute_package_sub_elements ( e : package_dtd_element ) : LIST OF dtd_element;
		LOCAL 
			result : LIST OF dtd_element := [ ];
			classes : LIST OF ada_entity := package_ada_classes ( e.package );
			records : LIST OF ada_entity := package_records ( e.package );
			discrims : LIST OF discriminated_type := package_discriminated_types ( e.package );
		END_LOCAL;

		REPEAT no := LOINDEX ( classes ) TO HIINDEX ( classes );
			ALIAS curr FOR classes [ no];
				result := result + ( dtd_element ( e, ? ) || composite_dtd_element ( ) || entity_dtd_element ( curr ) || ada_class_dtd_element ( ) );
			END_ALIAS;
		END_REPEAT;

		REPEAT no := LOINDEX ( records ) TO HIINDEX ( records );
			ALIAS curr FOR records [ no];
				result := result + ( dtd_element ( e, ? ) || composite_dtd_element ( ) || entity_dtd_element ( curr ) || record_dtd_element ( ) );
			END_ALIAS;
		END_REPEAT;

		REPEAT no := LOINDEX ( discrims ) TO HIINDEX ( discrims );
			ALIAS curr FOR discrims [ no];
				result := result + ( dtd_element ( e, ? ) || composite_dtd_element ( ) || entity_dtd_element ( curr ) || discriminated_type_dtd_element ( ) );
			END_ALIAS;
		END_REPEAT;
		RETURN ( result );
	END_FUNCTION;

	FUNCTION compute_entity_dtd_code ( ent : entity_dtd_element ) : STRING;
		LOCAL 
			s : STRING := '';
			l : LIST OF STRING := [ ];
			subs : LIST OF dtd_element := ent.subs;
		END_LOCAL;

		REPEAT no := LOINDEX ( subs ) TO HIINDEX ( subs );
			ALIAS curr FOR subs [ no];
				l := l + curr.tag;
			END_ALIAS;
		END_REPEAT;
		s := '<!!ELEMENT ' + ent.tag + ' (' + StringAggregateConcatSeparatedBy ( l, ' | ' ) + ')*>\n';

		IF ( 'RECORD_AND_CLASS.ADA_CLASS' IN TYPEOF ( ent.domain ) ) THEN
			s := s + '<!!ATTLIST ' + ent.tag + ' id ID #REQUIRED>\n';
		END_IF;
		RETURN ( s );
	END_FUNCTION;

	FUNCTION compute_attribute_dtd_list_from_attribute_list ( owner : dtd_element; attrs : LIST OF explicit_attribute ) : LIST OF dtd_element;
		LOCAL 
			result : LIST OF dtd_element := [ ];
		END_LOCAL;

		REPEAT no := LOINDEX ( attrs ) TO HIINDEX ( attrs );
			ALIAS curr FOR attrs [ no];
				IF ( lowerize ( curr.name ) <> lowerize ( xml_id_name ) ) THEN
					result := result + compute_attribute_dtd_element ( owner, curr );
				END_IF;
			END_ALIAS;
		END_REPEAT;
		RETURN ( result );
	END_FUNCTION;

	FUNCTION compute_entity_sub_elements ( e : entity_dtd_element ) : LIST OF dtd_element;
		LOCAL 
			attrs : LIST OF explicit_attribute := inherited_explicit_attributes ( e.domain );
			result : LIST OF dtd_element := compute_attribute_dtd_list_from_attribute_list ( e, attrs );
		END_LOCAL;
		RETURN ( result );
	END_FUNCTION;

	FUNCTION compute_discriminated_type_code ( ent : discriminated_type_dtd_element ) : STRING;
		LOCAL 
			s : STRING := '';
			l : LIST OF STRING := [ ];
			subs : LIST OF dtd_element := ent.subs;
		END_LOCAL;

		REPEAT no := LOINDEX ( subs ) TO HIINDEX ( subs );
			ALIAS curr FOR subs [ no];
				l := l + curr.tag;
			END_ALIAS;
		END_REPEAT;
		s := '<!!ELEMENT ' + ent.tag + ' (' + StringAggregateConcatSeparatedBy ( l, ' | ' ) + ')*>\n';
		RETURN ( s );
	END_FUNCTION;

	FUNCTION compute_discriminated_type_sub_elements ( e : discriminated_type_dtd_element ) : LIST OF dtd_element;
		LOCAL 
			attrs : LIST OF explicit_attribute := discriminated_type_attributes ( e.domain );
			result : LIST OF dtd_element := compute_attribute_dtd_list_from_attribute_list ( e, attrs );
		END_LOCAL;
		RETURN ( result );
	END_FUNCTION;

	FUNCTION compute_attribute_dtd_element ( owner : dtd_element; a : attribute ) : attribute_dtd_element;
		LOCAL 
			domain : entity_instance := basic_ada_domain ( a.domain ).handled;
			result : attribute_dtd_element;
		END_LOCAL;
		result := ( dtd_element ( owner, ? ) || attribute_dtd_element ( a, ? ) );
		result.domain := compute_domain_dtd_element ( result, domain );
		RETURN ( result );
	END_FUNCTION;

	FUNCTION compute_domain_dtd_element ( owner : dtd_element; domain : entity_instance ) : domain_dtd_element;
		LOCAL 
			sub_domain : entity_instance;
			element_domain : entity_instance;
			result : domain_dtd_element;
		END_LOCAL;

		IF ( 'PLATYPUS_DICTIONARY_SCHEMA.DICTIONARY_INSTANCE_REFERENCE' IN TYPEOF ( domain ) ) THEN
			RETURN ( compute_domain_dtd_element ( owner, domain.ref ) );
		ELSE
			IF ( 'CHEDDAR_DOMAINS.ADA_PRIMITIVE_TYPE' IN TYPEOF ( domain ) ) THEN
				RETURN ( simple_domain_dtd_element ( ) || dtd_element ( owner, ? ) || domain_dtd_element ( domain ) );
			ELSE
				IF ( 'CHEDDAR_DOMAINS.ADA_ENUMERATION' IN TYPEOF ( domain ) ) THEN
					RETURN ( simple_domain_dtd_element ( ) || dtd_element ( owner, ? ) || domain_dtd_element ( domain ) );
				ELSE
					IF ( 'CHEDDAR_DOMAINS.CHEDDAR_PRIORITY_RANGE' IN TYPEOF ( domain ) ) THEN
						RETURN ( simple_domain_dtd_element ( ) || dtd_element ( owner, ? ) || domain_dtd_element ( domain ) );
					ELSE
						IF ( 'RECORD_AND_CLASS.RECORD' IN TYPEOF ( domain ) ) THEN
							RETURN ( record_ref_dtd_element ( ) || entity_ref_dtd_element ( ) || dtd_element ( owner, ? ) || domain_dtd_element ( domain ) );
						ELSE
							IF ( 'DISCRIMINATED_TYPE.DISCRIMINATED_TYPE' IN TYPEOF ( domain ) ) THEN
								RETURN ( discriminated_type_ref_dtd_element ( ) || entity_ref_dtd_element ( ) || dtd_element ( owner, ? ) || domain_dtd_element ( domain ) );
							ELSE
								IF ( 'RECORD_AND_CLASS.ADA_CLASS' IN TYPEOF ( domain ) ) THEN
									RETURN ( ada_class_ref_dtd_element ( ) || entity_ref_dtd_element ( ) || dtd_element ( owner, ? ) || domain_dtd_element ( domain ) );
								ELSE
									IF ( 'PLATYPUS_DICTIONARY_SCHEMA.DEFINED_TYPE' IN TYPEOF ( domain ) ) THEN
										sub_domain := basic_ada_domain ( domain.domain );
										IF ( 'PLATYPUS_DICTIONARY_SCHEMA.AGGREGATION_TYPE' IN TYPEOF ( sub_domain ) ) THEN
											element_domain := basic_ada_domain ( sub_domain.element_type );
											result := collection_dtd_element ( ? ) || dtd_element ( owner, ? ) || domain_dtd_element ( domain );
											result.element_domain := compute_domain_dtd_element ( result, element_domain );
											RETURN ( result );
										END_IF;
									END_IF;
								END_IF;
							END_IF;
						END_IF;
					END_IF;
				END_IF;
			END_IF;
		END_IF;
		println ( domain );
		RETURN ( unknown_domain_dtd_element ( ) || dtd_element ( owner, ? ) || domain_dtd_element ( domain ) );
	END_FUNCTION;

	FUNCTION xml_packages : LIST OF ada_package;
		RETURN ( QUERY ( p <* SetToList ( all_ada_packages ( ) ) | SIZEOF ( p.xml_root_tags ) > 0 ) );
	END_FUNCTION;

	FUNCTION get_referenced_entity_domains ( pkgs : LIST OF package_dtd_element ) : LIST OF entity_ref_dtd_element;
		LOCAL 
			attributes : LIST OF attribute_dtd_element := [ ];
			domains : LIST OF entity_ref_dtd_element := [ ];
			names : LIST OF STRING := [ ];
			curr : domain_dtd_element;
		END_LOCAL;

		REPEAT no := LOINDEX ( pkgs ) TO HIINDEX ( pkgs );
			attributes := attributes + compute_package_attribute_dtd_elements ( pkgs [ no] );
		END_REPEAT;

		REPEAT noi := LOINDEX ( attributes ) TO HIINDEX ( attributes );
			curr := ?;
			ALIAS dom FOR attributes [ noi].domain;
				IF ( 'CHEDDAR_DTD.ENTITY_REF_DTD_ELEMENT' IN TYPEOF ( dom ) ) THEN
					curr := dom;
				END_IF;
				IF ( ( 'CHEDDAR_DTD.COLLECTION_DTD_ELEMENT' IN TYPEOF ( dom ) ) AND ( 'CHEDDAR_DTD.ENTITY_REF_DTD_ELEMENT' IN TYPEOF ( dom.element_domain ) ) ) THEN
					curr := dom.element_domain;
				END_IF;
				IF EXISTS ( curr ) THEN
					IF NOT ( lowerize ( curr.domain.name ) IN names ) THEN
						domains := domains + curr;
						names := names + lowerize ( curr.domain.name );
					END_IF;
				END_IF;
			END_ALIAS;
		END_REPEAT;
		RETURN ( domains );
	END_FUNCTION;

	FUNCTION get_declared_entity_domains ( pkgs : LIST OF package_dtd_element ) : LIST OF dtd_element;
		LOCAL 
			result : LIST OF dtd_element := [ ];
		END_LOCAL;

		REPEAT no := LOINDEX ( pkgs ) TO HIINDEX ( pkgs );
			result := result + pkgs [ no].subs;
		END_REPEAT;
		RETURN ( result );
	END_FUNCTION;

	FUNCTION compute_implicit_domains ( r : root_dtd_element ) : LIST OF entity_ref_dtd_element;
		LOCAL 
			refed : LIST OF entity_ref_dtd_element := r.referenced_entities;
			decl : LIST OF dtd_element := r.declared_domains;
			decl_domain : LIST OF entity_instance := [ ];
			not_declared : LIST OF entity_ref_dtd_element := [ ];
		END_LOCAL;

		REPEAT no := LOINDEX ( decl ) TO HIINDEX ( decl );
			ALIAS curr FOR decl [ no];
				decl_domain := decl_domain + curr.domain;
			END_ALIAS;
		END_REPEAT;

		REPEAT no := LOINDEX ( refed ) TO HIINDEX ( refed );
			ALIAS curr FOR refed [ no];
				IF NOT ( curr.domain IN decl_domain ) AND NOT ( curr IN not_declared ) THEN
					not_declared := not_declared + curr;
				END_IF;
			END_ALIAS;
		END_REPEAT;
		RETURN ( not_declared );
	END_FUNCTION;

	FUNCTION xml_packages_with_tag ( tag : STRING ) : LIST OF ada_package;
		RETURN ( QUERY ( p <* xml_packages ( ) | tag IN p.xml_root_tags ) );
	END_FUNCTION;
END_SCHEMA;


SCHEMA ada_interface;
	USE FROM platypus_dictionary_schema;
	USE FROM express_toolsbox_functions;
	USE FROM package;

	ENTITY ada_interface;
		prefix : STRING;
		suffix : OPTIONAL STRING;
		with_it : BOOLEAN;
		use_it : BOOLEAN;
	DERIVE
		full_name : STRING := ada_interface_path ( SELF );
		declaration : STRING := ada_interface_declaration ( SELF );
	END_ENTITY;

	FUNCTION ada_interface_path ( i : ada_interface ) : STRING;
		LOCAL 
			name : STRING := i.prefix;
		END_LOCAL;

		IF EXISTS ( i.suffix ) THEN
			name := name + '.' + i.suffix;
		END_IF;
		RETURN ( name );
	END_FUNCTION;

	FUNCTION ada_interface_declaration ( int : ada_interface ) : STRING;
		LOCAL 
			s : STRING := '';
			name : STRING := ada_interface_path ( int );
		END_LOCAL;

		IF int.with_it THEN
			s := s + 'with ' + name + ';\n';
		END_IF;

		IF int.use_it THEN
			s := s + 'use ' + name + ';\n';
		END_IF;
		RETURN ( s );
	END_FUNCTION;

	FUNCTION ada_interfaces_code ( from_pkg : ada_package; l : LIST OF ada_interface ) : STRING;
		LOCAL 
			found : SET OF STRING := [ ];
			with_suffix : LIST OF ada_interface := [ ];
			with_prefix_only : LIST OF ada_interface := [ ];
			cleaned : LIST OF ada_interface := [ ];
			inserted : BOOLEAN;
			s : STRING := '';
		END_LOCAL;

		REPEAT no := LOINDEX ( l ) TO HIINDEX ( l );
			ALIAS curr FOR l [ no];
				IF NOT EXISTS ( from_pkg ) OR ( upperize ( from_pkg.name ) <> upperize ( curr.prefix ) ) THEN
					IF NOT ( upperize ( curr.full_name ) IN found ) THEN
						found := found + upperize ( curr.full_name );
						cleaned := cleaned + curr;
					END_IF;
				END_IF;
			END_ALIAS;
		END_REPEAT;

		REPEAT no := LOINDEX ( cleaned ) TO HIINDEX ( cleaned );
			ALIAS curr FOR cleaned [ no];
				IF EXISTS ( curr.suffix ) THEN
					with_suffix := with_suffix + curr;
				ELSE
					with_prefix_only := with_prefix_only + curr;
				END_IF;
			END_ALIAS;
		END_REPEAT;
		cleaned := [ ];

		REPEAT no := LOINDEX ( with_prefix_only ) TO HIINDEX ( with_prefix_only );
			cleaned := cleaned + with_prefix_only [ no];
		END_REPEAT;

		REPEAT no := LOINDEX ( with_suffix ) TO HIINDEX ( with_suffix );
			ALIAS curr FOR with_suffix [ no];
				inserted := false;
				REPEAT noi := LOINDEX ( cleaned ) TO HIINDEX ( cleaned );
					ALIAS curri FOR cleaned [ noi];
						IF ( upperize ( curr.prefix ) = upperize ( curri.prefix ) ) THEN
							INSERT ( cleaned, curr, noi );
							inserted := true;
							ESCAPE;
						END_IF;
					END_ALIAS;
				END_REPEAT;
				IF ( inserted = false ) THEN
					cleaned := cleaned + curr;
				END_IF;
			END_ALIAS;
		END_REPEAT;

		REPEAT no := LOINDEX ( cleaned ) TO HIINDEX ( cleaned );
			ALIAS curr FOR cleaned [ no];
				s := s + curr.declaration + '\n';
			END_ALIAS;
		END_REPEAT;
		RETURN ( s );
	END_FUNCTION;
END_SCHEMA;


SCHEMA xml_io;
	USE FROM platypus_dictionary_schema;
	USE FROM express_toolsbox_functions;
	USE FROM express2cheddar_facade;
	USE FROM record_and_class;
	USE FROM discriminated_type;
	USE FROM ada_interface;
	USE FROM package;

	FUNCTION xml_architecture_io_ads_package_code : STRING;
		LOCAL 
			test : STRING := '';
			code : STRING := '';
			pkgs : LIST OF ada_package := SetToList ( all_ada_packages ( ) );
			allcls : LIST OF ada_class := all_ada_classes ( );
			allrecs : LIST OF ada_class := all_ada_records ( );
			alldts : LIST OF discriminated_type := all_ada_discriminated_types ( );
			interfaces : LIST OF ada_interface := [ ada_interface ( 'Sax', 'Readers', true, true ), ada_interface ( 'Networks', ?, true, true ), ada_interface ( 'Sax', 'Exceptions', true, true ), ada_interface ( 'Sax', 'Locators', true, true ), ada_interface ( 'Sax', 'Attributes', true, true ), ada_interface ( 'Unicode', 'CES', true, true ), ada_interface ( 'Unicode', ?, true, true ), ada_interface ( 'xml_generic_parsers', ?, true, true ), ada_interface ( 'Ada', 'Text_IO', true, true ), ada_interface ( 'Ada', 'Strings.Unbounded', true, true ), ada_interface ( 'Strings', ?, true, true ), ada_interface ( 'Unbounded_Strings', ?, true, true ), ada_interface ( 'Ada', 'Numerics.Aux', true, true ), ada_interface ( 'call_framework_interface', ?, true, true ), ada_interface ( 'Debug', ?, true, true ) ];
		END_LOCAL;
		code := source_licence + '\n';

		REPEAT no := LOINDEX ( pkgs ) TO HIINDEX ( pkgs );
			interfaces := interfaces + ada_interface ( pkgs [ no].name, ?, true, true );
			interfaces := interfaces + ada_package_interface ( pkgs [ no], true );
		END_REPEAT;
		code := source_licence + ada_interfaces_code ( ?, interfaces );
		code := code + 'package xml_architecture_io is\n\n' 

		+ '-- Attributes of the discriminated types\n\n';

		REPEAT no := LOINDEX ( alldts ) TO HIINDEX ( alldts );
			code := code + alldts [ no].xml_io_record_code + '\n';
		END_REPEAT;
		code := code + '\nprocedure Start_Element(' + '\n	Handler: in out Xml_Generic_Parser;' + '\n	ref : in out unbounded_string;' + '\n	id : in out unbounded_string;' + '\n	Namespace_Uri : Unicode.CES.Byte_Sequence := "";' + '\n	Local_Name : Unicode.CES.Byte_Sequence := "";' + '\n	Qname : Unicode.CES.Byte_Sequence := "";' + '\n	Atts : Sax.Attributes.Attributes''Class);\n';

		REPEAT no := LOINDEX ( alldts ) TO HIINDEX ( alldts );
			test := discriminated_type_xml_start_element_code ( alldts [ no] );
			IF ( test > '' ) THEN
				code := code + '\nprocedure Start_Element(\n' 
				+ '\tHandler : in out Xml_generic_parser;\n' 
				+ '\tobj : in out ' + alldts [ no].name + '_io;\n' 
				+ '\tNamespace_Uri : Unicode.CES.Byte_Sequence := "";\n' 
				+ '\tLocal_Name : Unicode.CES.Byte_Sequence := "";\n' 
				+ '\tQname : Unicode.CES.Byte_Sequence := "";\n' 
				+ '\tAtts : Sax.Attributes.Attributes''Class);\n';
			END_IF;
			code := code + '\nprocedure End_Element(\n' 
			+ '\tHandler : in out Xml_generic_parser;\n' 
			+ '\tobj : in out ' + alldts [ no].name + '_io;\n' 
			+ '\tNamespace_Uri : Unicode.CES.Byte_Sequence := "";\n' 
			+ '\tLocal_Name : Unicode.CES.Byte_Sequence := "";\n' 
			+ '\tQname : Unicode.CES.Byte_Sequence := "");\n';
		END_REPEAT;

		REPEAT no := LOINDEX ( alldts ) TO HIINDEX ( alldts );
			code := code + '\nprocedure Initialize(obj : out ' + alldts [ no].name + '_io);';
		END_REPEAT;
		code := code + '\n\n' 

		+ '-- Attributes of the parsed entities\n\n';

		REPEAT no := LOINDEX ( allrecs ) TO HIINDEX ( allrecs );
			code := code + allrecs [ no].xml_io_record_code + '\n';
		END_REPEAT;
		code := code + '\n';

		REPEAT no := LOINDEX ( allrecs ) TO HIINDEX ( allrecs );
			code := code + '\nprocedure Initialize(obj : out ' + allrecs [ no].name + '_io);';
		END_REPEAT;
		code := code + '\n';

		REPEAT no := LOINDEX ( allrecs ) TO HIINDEX ( allrecs );
			test := ada_entity_xml_start_element_code ( allrecs [ no] );
			IF ( test > '' ) THEN
				code := code + '\nprocedure Start_Element(\n' 
				+ '\tHandler : in out Xml_generic_parser;\n' 
				+ '\tobj : in out ' + allrecs [ no].name + '_io;\n' 
				+ '\tNamespace_Uri : Unicode.CES.Byte_Sequence := "";\n' 
				+ '\tLocal_Name : Unicode.CES.Byte_Sequence := "";\n' 
				+ '\tQname : Unicode.CES.Byte_Sequence := "";\n' 
				+ '\tAtts : Sax.Attributes.Attributes''Class);\n';
			END_IF;
			code := code + '\nprocedure End_Element(\n' 
			+ '\tHandler : in out Xml_generic_parser;\n' 
			+ '\tobj : in out ' + allrecs [ no].name + '_io;\n' 
			+ '\tNamespace_Uri : Unicode.CES.Byte_Sequence := "";\n' 
			+ '\tLocal_Name : Unicode.CES.Byte_Sequence := "";\n' 
			+ '\tQname : Unicode.CES.Byte_Sequence := "");\n';
		END_REPEAT;

		REPEAT no := LOINDEX ( allcls ) TO HIINDEX ( allcls );
			code := code + allcls [ no].xml_io_record_code + '\n';
		END_REPEAT;
		code := code + '\n';

		REPEAT no := LOINDEX ( allcls ) TO HIINDEX ( allcls );
			code := code + '\nprocedure Initialize(obj : out ' + allcls [ no].name + '_io);';
		END_REPEAT;
		code := code + '\n';

		REPEAT no := LOINDEX ( allcls ) TO HIINDEX ( allcls );
			test := ada_entity_xml_start_element_code ( allcls [ no] );
			IF ( test > '' ) THEN
				code := code + '\nprocedure Start_Element(\n' 
				+ '\tHandler : in out Xml_generic_parser;\n' 
				+ '\tobj : in out ' + allcls [ no].name + '_io;\n' 
				+ '\tNamespace_Uri : Unicode.CES.Byte_Sequence := "";\n' 
				+ '\tLocal_Name : Unicode.CES.Byte_Sequence := "";\n' 
				+ '\tQname : Unicode.CES.Byte_Sequence := "";\n' 
				+ '\tAtts : Sax.Attributes.Attributes''Class);\n';
			END_IF;
			code := code + '\nprocedure End_Element(\n' 
			+ '\tHandler : in out Xml_generic_parser;\n' 
			+ '\tobj : in out ' + allcls [ no].name + '_io;\n' 
			+ '\tNamespace_Uri : Unicode.CES.Byte_Sequence := "";\n' 
			+ '\tLocal_Name : Unicode.CES.Byte_Sequence := "";\n' 
			+ '\tQname : Unicode.CES.Byte_Sequence := "");\n';
		END_REPEAT;
		code := code + '\n\nend xml_architecture_io;\n';
		RETURN ( code );
	END_FUNCTION;

	FUNCTION xml_architecture_io_adb_package_code : STRING;
		LOCAL 
			code : STRING := '';
			allcls : LIST OF ada_class := all_ada_classes ( );
			allrecs : LIST OF record := all_ada_records ( );
			allents : LIST OF ada_entity := allcls + allrecs;
			strtab : LIST OF STRING := [ ];
			alldts : LIST OF discriminated_type := all_ada_discriminated_types ( );
		END_LOCAL;
		code := source_licence + '\n';
		code := code + 'package body xml_architecture_io is\n\n';
		code := code + '\n';
		code := code + '\nprocedure Start_Element(' + '\n	Handler: in out Xml_Generic_Parser;' + '\n	ref : in out unbounded_string;' + '\n	id : in out unbounded_string;' + '\n	Namespace_Uri : Unicode.CES.Byte_Sequence := "";' + '\n	Local_Name : Unicode.CES.Byte_Sequence := "";' + '\n	Qname : Unicode.CES.Byte_Sequence := "";' + '\n	Atts : Sax.Attributes.Attributes''Class) is' + '\nbegin' + '\n	if Get_Length (Atts) > 0 then' + '\n		if (To_String (To_Lower (Qname)) = "' + Lowerize ( allents [ LOINDEX ( allents ) ].name ) + '")';

		REPEAT no := LOINDEX ( allents ) + 1 TO HIINDEX ( allents );
			code := code + '\n\t\t\t OR (To_String (To_Lower (Qname)) = "' + Lowerize ( allents [ no].name ) + '")';
		END_REPEAT;
		code := code + ' then' + '\n			for J in 0 .. Get_Length (Atts) - 1 loop' + '\n				if To_String (To_Lower (Get_Qname (Atts, J))) = "id" then' + '\n					id := To_Unbounded_String (Get_Value (Atts, J));' + '\n				end if;' + '\n				if To_String (To_Lower (Get_Qname (Atts, J))) = "ref" then' + '\n					ref := To_Unbounded_String (Get_Value (Atts, J));' + '\n				end if;' + '\n			end loop;' + '\n		end if;' + '\n	end if;' + '\nend Start_Element;\n\n';

		REPEAT no := LOINDEX ( alldts ) TO HIINDEX ( alldts );
			code := code + discriminated_type_xml_io_record_initialize_code ( alldts [ no] );
			code := code + discriminated_type_xml_start_element_code ( alldts [ no] );
			code := code + discriminated_type_xml_end_element_code ( alldts [ no] );
		END_REPEAT;

		REPEAT no := LOINDEX ( allrecs ) TO HIINDEX ( allrecs );
			code := code + ada_entity_xml_io_record_initialize_code ( allrecs [ no] );
			code := code + ada_entity_xml_start_element_code ( allrecs [ no] );
			code := code + ada_entity_xml_end_element_code ( allrecs [ no] );
		END_REPEAT;

		REPEAT no := LOINDEX ( allcls ) TO HIINDEX ( allcls );
			code := code + ada_entity_xml_io_record_initialize_code ( allcls [ no] );
			code := code + ada_entity_xml_start_element_code ( allcls [ no] );
			code := code + ada_entity_xml_end_element_code ( allcls [ no] );
		END_REPEAT;
		code := code + 'end xml_architecture_io;\n';
		RETURN ( code );
	END_FUNCTION;
END_SCHEMA;


SCHEMA cheddar_domains;
	USE FROM express2cheddar_facade;
	USE FROM ada_interface;
	USE FROM platypus_dictionary_schema;
	USE FROM platypus_expressions_schema;
	USE FROM express_toolsbox_functions;
	USE FROM express_dictionary_queries;

	CONSTANT 
		std_io_interfaces : LIST OF ada_interface := [ ada_interface ( 'standards_io', ?, true, true ) ];
	END_CONSTANT;

	ENTITY pragma_convention;
		convention : STRING;
	END_ENTITY;

	ENTITY ada_type 
		SUBTYPE OF ( defined_type );
	DERIVE
		ada_ident : STRING := name;
		ada_ref_ident : STRING := name;
		init_value : STRING := ?;
		dependencies : LIST OF dictionary_instance := dependencies_of ( SELF.owner, SELF.domain.handled );
		refed_by_pointer : BOOLEAN := false;
	END_ENTITY;

	ENTITY cheddar_defined_type 
		SUBTYPE OF ( ada_type );
	DERIVE
		ads_interface_list : LIST OF ada_interface := cheddar_defined_type_interfaces_list ( SELF, true );
		adb_interface_list : LIST OF ada_interface := cheddar_defined_type_interfaces_list ( SELF, false );
		SELF\defined_type.accepted : entity_instance := SELF.accept_cheddar_defined_type;
	END_ENTITY;

	ENTITY constrained_array_type 
		SUBTYPE OF ( cheddar_defined_type );
		min_idx : STRING;
		max_idx : OPTIONAL STRING;
		interfaces : LIST OF ada_interface;
	DERIVE
		adb_interfaces_list : LIST OF ada_interface := [ ];
		ads_interfaces_list : LIST OF ada_interface := interfaces;
		adb_code : STRING := '';
		ads_code : STRING := constrained_array_type_ads_code ( SELF );
	END_ENTITY;

	ENTITY cheddar_entity_definition 
		SUBTYPE OF ( entity_definition );
	DERIVE
		ads_interfaces_list : LIST OF ada_interface := [ ];
		adb_interfaces_list : LIST OF ada_interface := [ ];
		ada_ident : STRING := SELF.name;
		ada_ref_ident : STRING := SELF.name;
		init_value : STRING := ?;
		ads_code : STRING := '';
		adb_code : STRING := '';
	END_ENTITY;

	ENTITY unmapped_type_reference;
		ref : entity_instance;
	DERIVE
		ads_interfaces_list : LIST OF ada_interface := basic_ada_domain ( SELF.ref ).ads_interfaces_list;
		adb_interfaces_list : LIST OF ada_interface := basic_ada_domain ( SELF.ref ).adb_interfaces_list;
		ada_ident : STRING := SELF.name;
		ada_ref_ident : STRING := SELF.name;
		init_value : STRING := basic_ada_domain ( SELF.ref ).init_value;
		ads_code : STRING := '';
		adb_code : STRING := '';
		refed_by_pointer : BOOLEAN := false;
	END_ENTITY;

	ENTITY unmapped_entity_definition;
	DERIVE
		ads_interfaces_list : LIST OF ada_interface := [ ];
		adb_interfaces_list : LIST OF ada_interface := [ ];
		ada_ident : STRING := SELF.name;
		ada_ref_ident : STRING := SELF.name;
		init_value : STRING := ?;
		ads_code : STRING := '';
		adb_code : STRING := '';
	END_ENTITY;

	ENTITY basic_ada_type_getter;
	DERIVE
		accept_string_type : dictionary_instance := ( ada_unbounded_string_type ( ) || ada_primitive_type ( ) || dictionary_instance ( ) );
		accept_integer_type : dictionary_instance := ( ada_natural_type ( ) || ada_primitive_type ( ) || dictionary_instance ( ) );
		accept_real_type : dictionary_instance := ( ada_double_type ( ) || ada_primitive_type ( ) || dictionary_instance ( ) );
		accept_boolean_type : dictionary_instance := ( ada_boolean_type ( ) || ada_primitive_type ( ) || dictionary_instance ( ) );
		accept_enumeration_type : dictionary_instance := SELF\enumeration_type;
		accept_ada_enumeration : dictionary_instance := SELF;
		accept_attribute_reference : dictionary_instance := ( ada_attribute_reference ( ) || ada_named_type_reference ( ) || SELF\attribute_reference );
		accept_defined_type_reference : dictionary_instance := basic_ada_domain ( SELF\defined_type_reference.ref );
		accept_defined_type : dictionary_instance := unmapped_type_reference ( SELF.domain ) || SELF;
		accept_ada_range : dictionary_instance := SELF;
		accept_ada_class_reference : dictionary_instance := SELF;
		accept_ada_record_reference : dictionary_instance := SELF;
		accept_entity_definition_reference : dictionary_instance := ( unmapped_type_reference ( SELF.ref ) || SELF\entity_definition_reference );
		accept_entity_definition : dictionary_instance := ( unmapped_entity_definition ( ) || SELF\entity_definition );
		accept_cheddar_defined_type : dictionary_instance := SELF;
		accept_list_type : dictionary_instance := ( ada_list_type ( ) || SELF\list_type );
		accept_array_type : dictionary_instance := ( ada_array_type ( ) || SELF\array_type );
		accept_set_type : dictionary_instance := ( ada_set_type ( ) || SELF\set_type );
		accept_bag_type : dictionary_instance := ( ada_bag_type ( ) || SELF\bag_type );
		accept_explicit_type_reference : dictionary_instance := SELF;
	END_ENTITY;

	ENTITY ada_primitive_type 
		SUBTYPE OF ( entity_definition );
	DERIVE
		ads_interfaces_list : LIST OF ada_interface := [ ];
		adb_interfaces_list : LIST OF ada_interface := [ ];
		ads_code : STRING := '';
		adb_code : STRING := '';
		put_prefix : STRING := '';
		refed_by_pointer : BOOLEAN := false;
	END_ENTITY;

	ENTITY cheddar_primitive_type 
		SUBTYPE OF ( ada_primitive_type );
	END_ENTITY;

	ENTITY cheddar_law_type 
		SUBTYPE OF ( cheddar_primitive_type );
	DERIVE
		SELF\ada_primitive_type.ads_interfaces_list : LIST OF ada_interface := [ ada_interface ( 'Expression', ?, true, true ), ada_interface ( 'Expression', ?, false, true ) ];
		SELF\ada_primitive_type.adb_interfaces_list : LIST OF ada_interface := [ ];
		ada_ident : STRING := 'law_type';
		ada_ref_ident : STRING := SELF.ada_ident;
		init_value : STRING := ?;
	END_ENTITY;

	ENTITY cheddar_priority_range 
		SUBTYPE OF ( cheddar_defined_type );
	DERIVE
		ads_code : STRING := '
-- Definition of priority range. We choose the most current value :
-- 256 priority levels (from 0 to 255)
-- Zero is the lowest priority level
Type Priority_Range is new Natural range 0 .. 255;
package Priority_Io is new Text_IO.Integer_IO (Priority_Range);
use Priority_Io;
';
		adb_code : STRING := '';
		ads_interfaces_list : LIST OF ada_interface := [ ada_interface ( 'Framework_Config', ?, true, true ), ada_interface ( 'Framework_Config', 'Priority_Io', false, true ) ];
		adb_interfaces_list : LIST OF ada_interface := [ ];
		SELF\ada_type.ada_ident : STRING := 'Priority_Range';
		SELF\ada_type.ada_ref_ident : STRING := SELF.ada_ident;
		SELF\ada_type.init_value : STRING := '0';
	END_ENTITY;

	ENTITY ada_natural_type 
		SUBTYPE OF ( ada_primitive_type );
	DERIVE
		SELF\ada_primitive_type.ads_interfaces_list : LIST OF ada_interface := std_io_interfaces + [ ada_interface ( 'standards_io', 'natural_io', false, true ) ];
		SELF\ada_primitive_type.adb_interfaces_list : LIST OF ada_interface := [ ada_interface ( 'primitive_xml_strings', ?, true, true ) ];
		ada_ident : STRING := 'Natural';
		ada_ref_ident : STRING := SELF.ada_ident;
		init_value : STRING := '0';
		SELF\ada_primitive_type.put_prefix : STRING := 'standards_io.natural_io.';
	END_ENTITY;

	ENTITY ada_unbounded_string_type 
		SUBTYPE OF ( ada_primitive_type );
	DERIVE
		SELF\ada_primitive_type.ads_interfaces_list : LIST OF ada_interface := [ ada_interface ( 'ada.strings', 'unbounded.text_io', true, true ), ada_interface ( 'Text_io', ?, true, true ), ada_interface ( 'Unbounded_Strings', ?, true, true ), ada_interface ( 'Convert_Strings', ?, true, false ), ada_interface ( 'Convert_Unbounded_Strings', ?, true, false ) ];
		SELF\ada_primitive_type.adb_interfaces_list : LIST OF ada_interface := [ ada_interface ( 'Text_io', ?, true, true ), ada_interface ( 'primitive_xml_strings', ?, true, true ) ];
		ada_ident : STRING := 'Unbounded_String';
		ada_ref_ident : STRING := SELF.ada_ident;
		init_value : STRING := 'empty_string';
	END_ENTITY;

	ENTITY cheddar_xml_id_type 
		SUBTYPE OF ( string_type );
	DERIVE
		SELF\ada_unbounded_string_type.ads_interfaces_list : LIST OF ada_interface := [ ada_interface ( 'ada.strings', 'unbounded.text_io', true, true ), ada_interface ( 'Text_io', ?, true, true ), ada_interface ( 'Unbounded_Strings', ?, true, true ), ada_interface ( 'Convert_Strings', ?, true, false ), ada_interface ( 'Convert_Unbounded_Strings', ?, true, false ), ada_interface ( 'id_generators', ?, true, true ) ];
		adb_interfaces_list : LIST OF ada_interface := [ ada_interface ( 'call_framework', ?, true, true ), ada_interface ( 'id_generators', ?, true, true ) ];
		ads_code : STRING := '';
		adb_code : STRING := '';
		put_prefix : STRING := '';
		refed_by_pointer : BOOLEAN := false;
		SELF\ada_unbounded_string_type.init_value : STRING := 'generate_id';
	END_ENTITY;

	ENTITY ada_boolean_type 
		SUBTYPE OF ( ada_primitive_type );
	DERIVE
		SELF\ada_primitive_type.ads_interfaces_list : LIST OF ada_interface := std_io_interfaces + [ ada_interface ( 'standards_io', 'boolean_io', false, true ) ];
		SELF\ada_primitive_type.adb_interfaces_list : LIST OF ada_interface := [ ada_interface ( 'primitive_xml_strings', ?, true, true ) ];
		ada_ident : STRING := 'Boolean';
		ada_ref_ident : STRING := SELF.ada_ident;
		init_value : STRING := 'false';
		SELF\ada_primitive_type.put_prefix : STRING := 'standards_io.boolean_io.';
	END_ENTITY;

	ENTITY ada_real_type 
		SUBTYPE OF ( ada_primitive_type );
	DERIVE
		SELF\ada_primitive_type.ads_interfaces_list : LIST OF ada_interface := std_io_interfaces + [ ada_interface ( 'Ada', 'Numerics.Aux', true, true ), ada_interface ( 'standards_io', 'float_io', false, true ) ];
		SELF\ada_primitive_type.adb_interfaces_list : LIST OF ada_interface := [ ada_interface ( 'primitive_xml_strings', ?, true, true ) ];
		ada_ident : STRING := 'Float';
		ada_ref_ident : STRING := SELF.ada_ident;
		init_value : STRING := '0.0';
		SELF\ada_primitive_type.put_prefix : STRING := 'standards_io.float_io.';
	END_ENTITY;

	ENTITY ada_double_type 
		SUBTYPE OF ( ada_primitive_type );
	DERIVE
		SELF\ada_primitive_type.ads_interfaces_list : LIST OF ada_interface := std_io_interfaces + [ ada_interface ( 'Ada', 'Numerics.Aux', true, true ), ada_interface ( 'standards_io', 'double_io', false, true ) ];
		SELF\ada_primitive_type.adb_interfaces_list : LIST OF ada_interface := [ ada_interface ( 'primitive_xml_strings', ?, true, true ) ];
		ada_ident : STRING := 'Double';
		ada_ref_ident : STRING := SELF.ada_ident;
		init_value : STRING := '0.0';
		SELF\ada_primitive_type.put_prefix : STRING := 'standards_io.double_io.';
	END_ENTITY;

	ENTITY ada_integer_type 
		SUBTYPE OF ( ada_primitive_type );
	DERIVE
		SELF\ada_primitive_type.ads_interfaces_list : LIST OF ada_interface := std_io_interfaces + [ ada_interface ( 'standards_io', 'integer_io', false, true ) ];
		SELF\ada_primitive_type.adb_interfaces_list : LIST OF ada_interface := [ ada_interface ( 'primitive_xml_strings', ?, true, true ) ];
		ada_ident : STRING := 'Integer';
		ada_ref_ident : STRING := SELF.ada_ident;
		init_value : STRING := '0';
		SELF\ada_primitive_type.put_prefix : STRING := 'standards_io.integer_io.';
	END_ENTITY;

	ENTITY ada_named_type_reference 
		SUBTYPE OF ( entity_instance );
	DERIVE
		ads_interfaces_list : LIST OF ada_interface := [ ];
		adb_interfaces_list : LIST OF ada_interface := [ ];
		ada_ident : STRING := SELF.ref.name;
		ada_ref_ident : STRING := SELF.ada_ident;
	END_ENTITY;

	ENTITY ada_record_reference 
		SUBTYPE OF ( ada_named_type_reference );
	DERIVE
		SELF\entity_definition_reference.accepted : entity_instance := SELF.accept_ada_record_reference;
	END_ENTITY;

	ENTITY ada_class_reference 
		SUBTYPE OF ( ada_named_type_reference );
	DERIVE
		SELF\entity_definition_reference.accepted : entity_instance := SELF.accept_ada_class_reference;
		SELF\ada_named_type_reference.ads_interfaces_list : LIST OF ada_interface := [ ada_interface ( SELF.ref.owner.name, ?, true, true ) ];
		SELF\ada_named_type_reference.ada_ident : STRING := SELF.ref.name + '_Ptr';
		init_value : STRING := 'initialize';
	END_ENTITY;

	ENTITY ada_primitive_class_reference 
		SUBTYPE OF ( ada_class_reference );
		pointed_type_name : STRING;
		package_name : STRING;
	DERIVE
		SELF\ada_class_reference.ads_interfaces_list : LIST OF ada_interface := [ ada_interface ( package_name, ?, true, true ) ];
		SELF\ada_class_reference.ada_ident : STRING := pointed_type_name + '_Ptr';
	END_ENTITY;

	ENTITY ada_attribute_reference 
		SUBTYPE OF ( ada_named_type_reference );
	END_ENTITY;

	ENTITY ada_array_type 
		SUBTYPE OF ( array_type );
	DERIVE
		ads_interfaces_list : LIST OF ada_interface := std_io_interfaces;
		adb_interfaces_list : LIST OF ada_interface := [ ];
		ada_ident : STRING := ?;
		ada_ref_ident : STRING := SELF.ada_ident;
		init_value : STRING := ?;
	END_ENTITY;

	ENTITY ada_list_type 
		SUBTYPE OF ( list_type );
	DERIVE
		ads_interfaces_list : LIST OF ada_interface := std_io_interfaces;
		adb_interfaces_list : LIST OF ada_interface := [ ];
		ada_ident : STRING := 'list';
		ada_ref_ident : STRING := SELF.ada_ident;
		init_value : STRING := ?;
	END_ENTITY;

	ENTITY ada_set_type 
		SUBTYPE OF ( set_type );
	DERIVE
		ads_interfaces_list : LIST OF ada_interface := std_io_interfaces;
		adb_interfaces_list : LIST OF ada_interface := [ ];
		ada_ident : STRING := 'set';
		ada_ref_ident : STRING := SELF.ada_ident;
	END_ENTITY;

	ENTITY ada_bag_type 
		SUBTYPE OF ( bag_type );
	DERIVE
		ads_interfaces_list : LIST OF ada_interface := std_io_interfaces;
		adb_interfaces_list : LIST OF ada_interface := [ ];
		ada_ident : STRING := 'bag';
		ada_ref_ident : STRING := SELF.ada_ident;
	END_ENTITY;

	ENTITY ada_enumeration 
		SUBTYPE OF ( ada_type );
		convertion : OPTIONAL STRING;
	DERIVE
		ads_interfaces_list : LIST OF ada_interface := [ ada_interface ( 'Convert_Strings', ?, true, false ), ada_interface ( 'Convert_Unbounded_Strings', ?, true, false ), ada_interface ( 'text_io', ?, true, true ), ada_interface ( 'ada.strings', 'unbounded', true, true ) ];
		adb_interfaces_list : LIST OF ada_interface := [ ada_interface ( 'primitive_xml_strings', ?, true, true ) ];
		ads_code : STRING := enumeration_ads_code ( SELF );
		adb_code : STRING := enumeration_adb_code ( SELF );
		SELF\ada_type.ada_ident : STRING := name;
		SELF\ada_type.ada_ref_ident : STRING := SELF.ada_ident;
		SELF\ada_type.init_value : STRING := NVL ( convertion, domain.elements [ 1 ] );
		io_type_name : STRING := SELF.ada_ident + '_io';
		full_io_type_name : STRING := SELF.owner.name + '.' + SELF.io_type_name;
		SELF\defined_type.accepted : entity_instance := SELF.accept_ada_enumeration;
	END_ENTITY;

	ENTITY basic_ada_type_value_format 
		SUBTYPE OF ( dictionary_instance );
		val : expression;
		basic_ada_type : OPTIONAL dictionary_instance;
	DERIVE
		formated : STRING := basic_ada_expression_value_string ( SELF.val );
	END_ENTITY;

	ENTITY range_type 
		SUBTYPE OF ( defined_type );
		lower : STRING;
		upper : STRING;
		lower_constant : OPTIONAL STRING;
		upper_constant : OPTIONAL STRING;
	DERIVE
		ads_interfaces_list : LIST OF ada_interface := [ ];
		adb_interfaces_list : LIST OF ada_interface := [ ];
		ada_ident : STRING := name;
		ada_ref_ident : STRING := SELF.ada_ident;
		ads_code : STRING := range_type_ads_code ( SELF );
		adb_code : STRING := '';
	END_ENTITY;

	ENTITY explicit_type_reference 
		SUBTYPE OF ( defined_type );
		used_name : OPTIONAL STRING;
		interfaces : LIST OF ada_interface;
	DERIVE
		SELF\defined_type.accepted : entity_instance := SELF.accept_explicit_type_reference;
		ads_interfaces_list : LIST OF ada_interface := SELF.interfaces;
		adb_interfaces_list : LIST OF ada_interface := [ ada_interface ( SELF.owner.name, ?, true, true ) ] + interfaces;
		ada_ident : STRING := SELF.name;
		ptr_type : STRING := SELF.ada_ident + '_Ptr';
		ada_ref_ident : STRING := NVL ( SELF.used_name, SELF.name );
		init_value : STRING := ?;
		ads_code : STRING := '';
		adb_code : STRING := '';
		refed_by_pointer : BOOLEAN := string_ends_with ( SELF.ada_ref_ident, '_Ptr' );
	END_ENTITY;

	ENTITY in_scope_attribute;
	DERIVE
		init_code : STRING := in_scope_attribute_init_code ( SELF );
	END_ENTITY;

	FUNCTION dependencies_of ( o : context_definition; t : dictionary_instance ) : LIST OF dictionary_instance;
		LOCAL 
			r : LIST OF dictionary_instance := [ ];
		END_LOCAL;

		IF ( 'PLATYPUS_DICTIONARY_SCHEMA.AGGREGATION_TYPE' IN TYPEOF ( t ) ) THEN
			r := r + dependencies_of ( o, t.element_type.handled );
		ELSE
			IF is_of_generated_concept_kind ( t ) THEN
				IF ( t.owner = o ) THEN
					r := r + t.dependencies + t;
				END_IF;
			END_IF;
		END_IF;
		RETURN ( r );
	END_FUNCTION;

	FUNCTION constrained_array_type_ads_code ( a : constrained_array_type ) : STRING;
		LOCAL 
			code : STRING := '';
		END_LOCAL;
		code := 'type ' + a.ada_ident + ' is Array ( ';

		IF EXISTS ( a.max_idx ) THEN
			code := code + a.min_idx + ' .. ' + a.max_idx;
		ELSE
			code := code + a.min_idx;
		END_IF;

		ALIAS etype FOR a.domain.element_type.handled;
			IF ( 'RECORD_AND_CLASS.ADA_CLASS' IN TYPEOF ( etype ) ) THEN
				code := code + ' ) of ' + etype.ptr_type + ';\n';
			ELSE
				code := code + ' ) of ' + etype.ada_ident + ';\n';
			END_IF;
		END_ALIAS;
		RETURN ( code );
	END_FUNCTION;

	FUNCTION cheddar_defined_type_interfaces_list ( r : cheddar_defined_type; ads : BOOLEAN ) : LIST OF ada_interface;
		LOCAL 
			result : LIST OF ada_interface := [ ];
		END_LOCAL;

		IF ads THEN
			result := result + ada_interface ( r.owner.name, ?, true, true );
		END_IF;
		RETURN ( result );
	END_FUNCTION;

	FUNCTION basic_ada_domain ( d : dictionary_instance ) : entity_instance;
		RETURN ( ( d || basic_ada_type_getter ( ) ).accepted );
	END_FUNCTION;

	FUNCTION enumeration_ads_code ( e : ada_enumeration ) : STRING;
		LOCAL 
			code : STRING;
			convert_type : STRING := NVL ( e.convertion, e.domain.elements [ LOINDEX ( e.domain.elements ) ] );
		END_LOCAL;
		code := 'type ' + e.name + ' is (\n\t' + StringAggregateConcatSeparatedBy ( e.domain.elements, ',\n\t' ) + ');\n';

		IF ( 'CHEDDAR_DOMAINS.PRAGMA_CONVENTION' IN TYPEOF ( e ) ) THEN
			code := code + 'pragma convention (' + e.convention + ', ' + e.name + ');\n';
		END_IF;
		code := code + '\n' 
		+ 'procedure To_' + e.name + ' is\n' 
		+ 'new Convert_Strings(' + e.name + ', ' + convert_type + ');\n' 
		+ 'procedure To_' + e.name + ' is\n' 
		+ 'new Convert_Unbounded_Strings(' + e.name + ', ' + convert_type + ');\n' 
		+ 'function XML_String (obj : in ' + e.name + ') return Unbounded_String;\n' 
		+ 'function XML_Ref_String (obj : in ' + e.name + ') return Unbounded_String;\n' 
		+ 'package ' + e.name + '_io is new text_io.enumeration_io(' + e.name + ');\n' 
		+ 'use ' + e.name + '_io;\n\n';
		RETURN ( code );
	END_FUNCTION;

	FUNCTION basic_ada_expression_value_string ( e : expression ) : STRING;
		LOCAL 
			code : STRING := '';
		END_LOCAL;

		IF ( 'PLATYPUS_EXPRESSIONS_SCHEMA.IDENTIFIER' IN TYPEOF ( e ) ) THEN
			RETURN ( e.name );
		END_IF;

		IF ( 'PLATYPUS_EXPRESSIONS_SCHEMA.INTEGER_LITERAL' IN TYPEOF ( e ) ) THEN
			RETURN ( FORMAT ( e.val, 'I' ) );
		END_IF;

		IF ( 'PLATYPUS_EXPRESSIONS_SCHEMA.TRUE_CONSTANT' IN TYPEOF ( e ) ) THEN
			RETURN ( 'True' );
		END_IF;

		IF ( 'PLATYPUS_EXPRESSIONS_SCHEMA.FALSE_CONSTANT' IN TYPEOF ( e ) ) THEN
			RETURN ( 'False' );
		END_IF;

		IF ( 'PLATYPUS_EXPRESSIONS_SCHEMA.BINARY_EXPRESSION' IN TYPEOF ( e ) ) THEN
			RETURN ( '(' + basic_ada_expression_value_string ( e.left_expr ) + ' ' + e.op_string + ' ' + basic_ada_expression_value_string ( e.right_expr ) + ')' );
		END_IF;
		RETURN ( 'null' );
	END_FUNCTION;

	FUNCTION enumeration_adb_code ( e : ada_enumeration ) : STRING;
		LOCAL 
			code : STRING;
		END_LOCAL;
		code := 'function XML_String(obj : in ' + e.name + ') return Unbounded_String is\n' 
		+ 'begin\n' 
		+ '	return to_unbounded_string(' + e.name + '''image (obj) );\n' 
		+ 'end XML_String;\n\n' 

		+ 'function XML_Ref_String (obj : in ' + e.name + ') return Unbounded_String is\n' 
		+ 'begin\n' 
		+ '\traise xml_ref_string_error;\n' 
		+ '\treturn to_unbounded_string("");\n' 
		+ 'end XML_Ref_String;\n\n';
		RETURN ( code );
	END_FUNCTION;

	FUNCTION range_type_ads_code ( rt : range_type ) : STRING;
		LOCAL 
			r : STRING := 'type ' + rt.ada_ident + ' is Range ' + rt.lower + ' .. ' + rt.upper + ';\n';
		END_LOCAL;

		IF EXISTS ( rt.lower_constant ) THEN
			r := r + rt.lower_constant + ' : constant ' + rt.ada_ident + ' := ' + rt.ada_ident + '''First;\n';
		END_IF;

		IF EXISTS ( rt.upper_constant ) THEN
			r := r + rt.upper_constant + ' : constant ' + rt.ada_ident + ' := ' + rt.ada_ident + '''Last;\n';
		END_IF;
		RETURN ( r );
	END_FUNCTION;

	FUNCTION in_scope_attribute_init_code ( a : in_scope_attribute ) : STRING;
		LOCAL 
			code : STRING := '';
		END_LOCAL;

		ALIAS domain FOR a.domain.handled;
			IF domain.refed_by_pointer THEN
				code := code + '\n\tif obj.' + a.name + ' /= null then\n' 
				+ '\t\tFree (obj.' + a.name + ' );\n' 
				+ '\tend if;\n' 
				+ '\tobj.' + a.name + ' := new ' + domain.name + ';\n' 
				+ '\tInitialize(obj.' + a.name + '.all);\n';
			END_IF;
		END_ALIAS;
		RETURN ( code );
	END_FUNCTION;

	FUNCTION domain_interfaces_list ( ada_domain : entity_instance; ads : BOOLEAN; pkg : schema_definition ) : LIST OF ada_interface;
		LOCAL 
			result : LIST OF ada_interface := [ ];
		END_LOCAL;

		ALIAS h FOR ada_domain.handled;
			IF ads THEN
				result := result + ada_domain.ads_interfaces_list;
			ELSE
				result := result + ada_domain.adb_interfaces_list;
				IF ( 'CHEDDAR_DOMAINS.ADA_ENUMERATION' IN TYPEOF ( h ) ) THEN
					IF ( h.owner.name <> pkg.name ) THEN
						result := result + ada_interface ( h.owner.name, ?, true, false );
						result := result + ada_interface ( h.full_io_type_name, ?, false, true );
					END_IF;
				END_IF;
			END_IF;
			IF ( 'CHEDDAR_DOMAINS.ADA_PRIMITIVE_TYPE' IN TYPEOF ( h ) ) OR ( 'DISCRIMINATED_TYPE.DISCRIMINATED_TYPE' IN TYPEOF ( h ) ) THEN
				IF ads THEN
					result := result + h.ads_interfaces_list;
				ELSE
					result := result + h.adb_interfaces_list;
				END_IF;
			END_IF;
		END_ALIAS;
		RETURN ( result );
	END_FUNCTION;
END_SCHEMA;


SCHEMA cheddar_constants;
	USE FROM express2cheddar_facade;
	USE FROM platypus_dictionary_schema;
	USE FROM cheddar_domains;
	USE FROM ada_interface;
	USE FROM express_dictionary_queries;
	USE FROM express_toolsbox_functions;

	ENTITY ada_constant 
		SUBTYPE OF ( constant_definition );
		final : BOOLEAN;
		other_initializer : OPTIONAL STRING;
	DERIVE
		ads_code : STRING := ada_constant_ads_code ( SELF );
		adb_code : STRING := '';
		ads_interfaces_list : LIST OF ada_interface := ada_constant_interfaces_list ( SELF, true );
		adb_interfaces_list : LIST OF ada_interface := [ ];
	END_ENTITY;

	FUNCTION do_comments_with ( src : STRING ) : STRING;
		(*#  " comments " 
		| r s |
		r := ''.
		s :=  self src val.
		s linesDo: [:l | r := r , '--', l, String cr]. 
		self return: (PltStringLiteral val: r)
     		 #*) (*# <pharo> " comments " 
		| r s |
		r := ''.
		s :=  self src.
		s linesDo: [:l | r := r , '--', l, String cr]. 
		^ self return: r  #*) END_FUNCTION;

	FUNCTION ada_constant_ads_code ( c : ada_constant ) : STRING;
		LOCAL 
			code : STRING := '';
			remarks : LIST OF remark := remarks_for ( c );
			rem : STRING;
			domain : dictionary_instance := basic_ada_domain ( c.domain );
		END_LOCAL;

		IF ( SIZEOF ( remarks ) > 0 ) THEN
			REPEAT no := LOINDEX ( remarks ) TO HIINDEX ( remarks );
				rem := clean_remark_text_of ( remarks [ no] );
				rem := do_comments_with ( rem );
				code := code + rem;
			END_REPEAT;
		END_IF;
		code := code + c.name + ' : ';

		IF c.final THEN
			code := code + 'constant ';
		END_IF;
		code := code + domain.ada_ref_ident;

		IF NOT EXISTS ( c.other_initializer ) THEN
			code := code + ' := ' + basic_ada_type_value_format ( c.initializer, ? ).formated + ';';
		ELSE
			IF c.other_initializer > '' THEN
				code := code + ' := ' + c.other_initializer;
			END_IF;
			code := code + ';';
		END_IF;
		code := code + '\n';
		RETURN ( code );
	END_FUNCTION;

	FUNCTION ada_constant_interfaces_list ( r : ada_constant; ads : BOOLEAN ) : LIST OF ada_interface;
		LOCAL 
			result : LIST OF ada_interface := [ ];
			ada_domain : entity_instance;
		END_LOCAL;
		ada_domain := basic_ada_domain ( r.domain );
		result := domain_interfaces_list ( ada_domain, ads, r.owner );
		RETURN ( result );
	END_FUNCTION;
END_SCHEMA;


SCHEMA record_and_class;
	USE FROM platypus_dictionary_schema;
	USE FROM platypus_environment_schema;
	USE FROM platypus_expressions_schema;
	USE FROM express_toolsbox_functions;
	USE FROM express_dictionary_queries;
	USE FROM express2cheddar_facade;
	USE FROM cheddar_domains;
	USE FROM discriminated_type;
	USE FROM ada_interface;

	ENTITY ada_entity 
		ABSTRACT SUPERTYPE 
		SUBTYPE OF ( entity_definition );
	DERIVE
		refed_by_pointer : BOOLEAN := false;
		ada_ident : STRING := name;
		ada_ref_ident : STRING := SELF.ada_ident;
		ptr_type : STRING := name + '_Ptr';
		explicit_attributes : LIST OF explicit_attribute := QUERY ( a <* attributes | 'PLATYPUS_DICTIONARY_SCHEMA.EXPLICIT_ATTRIBUTE' IN TYPEOF ( a ) );
		derived_attributes : LIST OF explicit_attribute := QUERY ( a <* attributes | 'PLATYPUS_DICTIONARY_SCHEMA.DERIVED_ATTRIBUTE' IN TYPEOF ( a ) );
		put_prefix : STRING := '';
		dependencies : LIST OF dictionary_instance := dependencies_of_ada_entity ( SELF.owner, SELF );
		xml_writer_code : STRING := ?;
		xml_io_record_code : STRING := ?;
		html_tag : STRING := Lowerize ( SELF.name );
	END_ENTITY;

	ENTITY ada_class 
		SUBTYPE OF ( ada_entity );
		is_private : BOOLEAN;
	DERIVE
		SELF\ada_entity.refed_by_pointer : BOOLEAN := true;
		ads_code : STRING := ada_class_ads_code ( SELF, is_private );
		adb_code : STRING := ada_class_adb_code ( SELF );
		init_value : STRING := ?;
		ads_interfaces_list : LIST OF ada_interface := ada_entity_interfaces_list ( SELF, true );
		adb_interfaces_list : LIST OF ada_interface := ada_entity_interfaces_list ( SELF, false );
		SELF\ada_entity.ada_ref_ident : STRING := SELF.ptr_type;
		SELF\ada_entity.xml_writer_code : STRING := ada_class_xml_writer_code ( SELF );
		SELF\ada_entity.xml_io_record_code : STRING := ada_class_xml_io_record_code ( SELF );
	END_ENTITY;

	ENTITY record 
		SUBTYPE OF ( ada_entity );
	DERIVE
		ads_code : STRING := record_ads_code ( SELF );
		adb_code : STRING := record_adb_code ( SELF );
		ads_interfaces_list : LIST OF ada_interface := ada_entity_interfaces_list ( SELF, true );
		adb_interfaces_list : LIST OF ada_interface := ada_entity_interfaces_list ( SELF, false );
		SELF\ada_entity.xml_writer_code : STRING := record_xml_writer_code ( SELF );
		SELF\ada_entity.xml_io_record_code : STRING := record_xml_io_record_code ( SELF );
	END_ENTITY;

	ENTITY cheddar_function_ptr 
		SUBTYPE OF ( entity_definition );
		arguments : STRING;
		returns : STRING;
	DERIVE
		ads_interface_list : LIST OF ada_interface := [ ];
		adb_interface_list : LIST OF ada_interface := [ ];
		ads_code : STRING := 'Type ' + SELF.name + ' is access function (' + SELF.arguments + ') return ' + SELF.returns + ';';
		adb_code : STRING := '';
		dependencies : LIST OF dictionary_instance := [ SELF ];
		refed_by_pointer : BOOLEAN := false;
	END_ENTITY;

	FUNCTION is_generic_object ( e : entity_instance ) : BOOLEAN;

		IF ( 'RECORD_AND_CLASS.ADA_CLASS' IN TYPEOF ( e ) ) THEN
			RETURN ( inherits_from_entity_named ( e, 'generic_object' ) );
		END_IF;
		RETURN ( false );
	END_FUNCTION;

	FUNCTION is_named_object ( e : entity_instance ) : BOOLEAN;

		IF ( 'RECORD_AND_CLASS.ADA_CLASS' IN TYPEOF ( e ) ) THEN
			RETURN ( inherits_from_entity_named ( e, 'named_object' ) );
		END_IF;
		RETURN ( false );
	END_FUNCTION;

	FUNCTION dependencies_of_ada_entity ( o : context_definition; t : ada_entity ) : LIST OF dictionary_instance;
		LOCAL 
			r : LIST OF dictionary_instance := [ ];
			attrs : LIST OF attribute := inherited_explicit_attributes ( t );
		END_LOCAL;

		REPEAT no := LOINDEX ( attrs ) TO HIINDEX ( attrs );
			r := r + dependencies_of ( o, attrs [ no].domain.handled );
		END_REPEAT;
		r := r + t;
		RETURN ( r );
	END_FUNCTION;

	FUNCTION ada_class_ads_code ( cip : ada_class; with_private : BOOLEAN ) : STRING;
		LOCAL 
			result : STRING;
			abstr : STRING := '';
			local_sup : entity_definition := local_root_supertype_of ( cip );
		END_LOCAL;
		result := '\n' 
		+ '-- --------= ' + cip.name + ' =--------\n\n' 

		+ 'type ' + cip.name + ';' + '\ntype ' + cip.ptr_type + ' is access all ' + cip.name + '''Class;\n';

		IF SIZEOF ( cip.supertypes ) > 0 THEN
			ALIAS supref FOR cip.supertypes [ 1 ].ref;
				result := result + 'type ' + cip.name + ' is ' + abstr + 'new ' + supref.ada_ident + ' with ';
			END_ALIAS;
		ELSE
			result := result + 'type ' + cip.name + ' is ' + abstr + 'new Ada.Finalization.Controlled with ';
		END_IF;

		IF with_private THEN
			result := result + 'private;\n';
		ELSE
			result := result + ada_class_attributes_ads_code ( cip );
		END_IF;
		result := result + '\nprocedure Initialize(obj : in out ' + cip.name + ');\n' 
		+ 'procedure Put(obj : in ' + cip.name + ');\n' 
		+ 'procedure Put(obj : in ' + cip.ptr_type + ');\n';
		result := result + 'procedure Put_Name(obj : in ' + cip.ptr_type + ');\n';
		result := result + 'procedure Build_Attributes_XML_String(obj : in ' + cip.name + '; result : in out Unbounded_String);\n' 
		+ 'function XML_String(obj : in ' + cip.name + ') return Unbounded_String;\n' 
		+ 'function XML_String(obj : in ' + cip.ptr_type + ') return Unbounded_String;\n' 
		+ 'function XML_Ref_String(obj : in ' + cip.name + ') return Unbounded_String;\n' 
		+ 'function XML_Ref_String(obj : in ' + cip.ptr_type + ') return Unbounded_String;\n';

		IF is_named_object ( cip ) THEN
			result := result + 'function Get_Name (obj : in ' + cip.name + ') return Unbounded_String;\n' 
			+ 'function Get_Name (obj : in ' + cip.ptr_type + ') return Unbounded_String;\n';
		END_IF;
		result := result + 'function Copy(obj : in ' + cip.ptr_type + ') return ' + local_sup.ptr_type + ';\n' 
		+ 'function Copy(obj : in ' + cip.name + ') return ' + local_sup.ptr_type + ';\n' 
		+ 'function type_of(obj : in ' + cip.name + ') return unbounded_string_list;\n' 
		+ 'function type_of(obj : in ' + cip.ptr_type + ') return unbounded_string_list;\n' 
		+ 'procedure Free  is new Unchecked_Deallocation (' + cip.name + '''Class, ' + cip.ptr_type + ');\n';
		RETURN ( result );
	END_FUNCTION;

	FUNCTION ada_class_adb_code ( cip : ada_class ) : STRING;
		LOCAL 
			code : STRING;
		END_LOCAL;
		code := '\n' 
		+ '-- --------= ' + cip.name + ' =--------\n' 
		+ ada_class_initialize_code ( cip ) + '\n' 
		+ ada_class_copy_code ( cip ) + '\n' 
		+ ada_class_put_code ( cip ) + '\n';

		IF is_named_object ( cip ) THEN
			code := code + ada_class_get_name_code ( cip ) + '\n';
		END_IF;
		code := code + ada_class_typeof_code ( cip ) + '\n' 
		+ ada_class_xml_writer_code ( cip ) + '\n';
		RETURN ( code );
	END_FUNCTION;

	FUNCTION ada_class_xml_writer_code ( cip : ada_class ) : STRING;
		LOCAL 
			code : STRING;
			contents : STRING := '';
			sub : STRING;
		END_LOCAL;
		code := '\nprocedure Build_Attributes_XML_String(obj : in ' + cip.name + '; result : in out Unbounded_String) is \nbegin\n';

		IF SIZEOF ( cip.supertypes ) > 0 THEN
			ALIAS sup FOR cip.supertypes [ LOINDEX ( cip.supertypes ) ].handled;
				contents := contents + '\tBuild_Attributes_XML_String(' + sup.name + '(obj), result);\n';
			END_ALIAS;
		END_IF;

		REPEAT no := LOINDEX ( cip.explicit_attributes ) TO HIINDEX ( cip.explicit_attributes );
			ALIAS attr FOR cip.explicit_attributes [ no];
				sub := explicit_attribute_xml_writer_code ( 'obj', attr );
				IF sub > '' THEN
					contents := contents + sub + '\n';
				END_IF;
			END_ALIAS;
		END_REPEAT;

		IF contents = '' THEN
			contents := '\tnull;\n';
		END_IF;
		code := code + contents + 'end Build_Attributes_XML_String;\n\n' 

		+ 'function XML_String(obj : in ' + cip.name + ') return Unbounded_String is\n' 
		+ '\tresult : Unbounded_String;\n' 
		+ 'begin\n' 
		+ '\tresult := to_unbounded_string("<' + cip.html_tag + ' id=""") & obj.' + xml_id_name + ' & to_unbounded_string(""" >");\n' 
		+ '\tBuild_Attributes_XML_String(obj, result);\n' 
		+ '\tresult := result & to_unbounded_string("</' + cip.html_tag + '>");\n' 
		+ '\treturn (result);\n' 
		+ 'end XML_String;\n\n' 

		+ 'function XML_String(obj : in ' + cip.ptr_type + ') return Unbounded_String is\n' 
		+ 'begin\n' 
		+ '	if obj /= null then\n' 
		+ '		return XML_String(obj.all);\n' 
		+ '	else\n' 
		+ '		return Empty_String;\n' 
		+ '	end if;\n' 
		+ 'end XML_String;\n\n' 

		+ 'function XML_Ref_String(obj : in ' + cip.name + ') return Unbounded_String is\n' 
		+ '\tresult : Unbounded_String;\n' 
		+ 'begin\n' 
		+ '\tresult := to_unbounded_string("<' + cip.html_tag + ' ref=""") & obj.' + xml_id_name + ' & to_unbounded_string(""" />");\n' 
		+ '\treturn (result);\n' 
		+ 'end XML_Ref_String;\n\n' 

		+ 'function XML_Ref_String(obj : in ' + cip.ptr_type + ') return Unbounded_String is\n' 
		+ 'begin\n' 
		+ '\treturn XML_Ref_String(obj.all);\n' 
		+ 'end XML_Ref_String;\n\n';
		RETURN ( code );
	END_FUNCTION;

	FUNCTION record_xml_writer_code ( cip : record ) : STRING;
		LOCAL 
			code : STRING;
			acode : STRING;
		END_LOCAL;
		code := '\nprocedure Build_Attributes_XML_String(obj : in ' + cip.name + '; result : in out Unbounded_String) is \nbegin\n';

		REPEAT no := LOINDEX ( cip.explicit_attributes ) TO HIINDEX ( cip.explicit_attributes );
			ALIAS attr FOR cip.explicit_attributes [ no];
				acode := explicit_attribute_xml_writer_code ( 'obj', attr );
				IF ( acode > '' ) THEN
					code := code + acode + '\n';
				END_IF;
			END_ALIAS;
		END_REPEAT;
		code := code + 'end Build_Attributes_XML_String;\n\n' 

		+ 'function XML_String(obj : in ' + cip.name + ') return Unbounded_String is\n' 
		+ '\tresult : Unbounded_String;\n' 
		+ 'begin\n' 
		+ '\tresult := to_unbounded_string("<' + cip.html_tag + '>");\n' 
		+ '\tBuild_Attributes_XML_String(obj, result);\n' 
		+ '\tresult := result & to_unbounded_string("</' + cip.html_tag + '>");\n' 
		+ '\treturn (result);\n' 
		+ 'end XML_String;\n\n' 

		+ 'function XML_String(obj : in ' + cip.ptr_type + ') return Unbounded_String is\n' 
		+ 'begin\n' 
		+ '	if obj /= null then\n' 
		+ '		return XML_String(obj.all);\n' 
		+ '	else\n' 
		+ '		return Empty_String;\n' 
		+ '	end if;\n' 
		+ 'end XML_String;\n\n' 

		+ 'function XML_Ref_String(obj : in ' + cip.name + ') return Unbounded_String is\n' 
		+ '\tresult : Unbounded_String;\n' 
		+ 'begin\n' 
		+ '	raise xml_ref_string_error;\n' 
		+ '	return to_unbounded_string("");\n' 
		+ 'end XML_Ref_String;\n';
		RETURN ( code );
	END_FUNCTION;

	FUNCTION ada_class_initialize_code ( cip : ada_class ) : STRING;
		LOCAL 
			code : STRING;
			innerCode : STRING := '';
			attrs : LIST OF attribute;
			init : STRING;
		END_LOCAL;
		code := '\nprocedure Initialize(obj : in out ' + cip.name + ') is \nbegin\n';

		IF SIZEOF ( cip.supertypes ) > 0 THEN
			ALIAS sup FOR cip.supertypes [ LOINDEX ( cip.supertypes ) ].handled;
				innerCode := innerCode + '\tinitialize(' + sup.name + '(obj));\n';
			END_ALIAS;
		END_IF;

		REPEAT no := LOINDEX ( cip.explicit_attributes ) TO HIINDEX ( cip.explicit_attributes );
			ALIAS attr FOR cip.explicit_attributes [ no];
				init := explicit_attribute_initialize ( attr );
				IF ( EXISTS ( init ) AND ( init > '' ) ) THEN
					innerCode := innerCode + '\t' + init + '\n';
				END_IF;
			END_ALIAS;
		END_REPEAT;

		REPEAT no := LOINDEX ( cip.derived_attributes ) TO HIINDEX ( cip.derived_attributes );
			ALIAS attr FOR cip.derived_attributes [ no];
				init := derived_attribute_initialize ( attr );
				IF ( EXISTS ( init ) AND ( init > '' ) ) THEN
					innerCode := innerCode + '\t' + init + '\n';
				END_IF;
			END_ALIAS;
		END_REPEAT;

		IF innerCode = '' THEN
			innerCode := '\tnull;\n';
		END_IF;
		code := code + innerCode + 'end Initialize;\n';
		RETURN ( code );
	END_FUNCTION;

	FUNCTION explicit_attribute_initialize ( attr : explicit_attribute ) : STRING;
		LOCAL 
			domain : dictionary_instance := basic_ada_domain ( attr.domain );
			init : STRING := domain.init_value;
		END_LOCAL;

		IF ( attr.name = xml_id_name ) THEN
			RETURN ( 'generate_id( framework_id, obj.' + attr.name + ' );' );
		END_IF;

		IF ( 'CHEDDAR_DOMAINS.IN_SCOPE_ATTRIBUTE' IN TYPEOF ( attr ) ) THEN
			RETURN ( attr.init_code );
		END_IF;

		IF ( 'CHEDDAR_DOMAINS.CHEDDAR_PRIMITIVE_TYPE' IN TYPEOF ( domain.handled ) ) THEN
			init := domain.handled.init_value;
		END_IF;

		IF NOT EXISTS ( init ) THEN
			RETURN ( ? );
		ELSE
			IF init <> 'initialize' THEN
				RETURN ( 'obj.' + attr.name + ' := ' + init + ';' );
			ELSE
				IF domain.handled.refed_by_pointer THEN
					RETURN ( 'initialize( obj.' + attr.name + '.all);' );
				ELSE
					RETURN ( 'initialize( obj.' + attr.name + ');' );
				END_IF;
			END_IF;
		END_IF;
	END_FUNCTION;

	FUNCTION derived_attribute_initialize ( attr : explicit_attribute ) : STRING;
		LOCAL 
			code : STRING;
			val : STRING;
			key : STRING := upperize ( attr.name );
		END_LOCAL;

		IF EXISTS ( attr.redeclaring ) THEN
			IF SIZEOF ( QUERY ( a <* inherited_explicit_attributes ( attr.owner ) | upperize ( a.name ) = key ) ) > 0 THEN
				val := basic_ada_type_value_format ( attr.assign, ? ).formated;
				code := 'obj.' + attr.name + ' := ' + val + ';';
			END_IF;
		END_IF;
		RETURN ( code );
	END_FUNCTION;

	FUNCTION ada_class_typeof_code ( cip : ada_class ) : STRING;
		LOCAL 
			code : STRING;
			sups : LIST OF entity_definition := all_supertypes_of ( cip );
		END_LOCAL;
		code := 'function type_of ( obj : in ' + cip.name + ' ) return unbounded_string_list is\n' 
		+ '\tlist : unbounded_string_list;\n' 
		+ '\ts : unbounded_string_ptr;\n' 
		+ 'begin\n' 
		+ '\t' + 'Initialize(list);\n' 
		+ '\n';

		REPEAT no := LOINDEX ( sups ) TO HIINDEX ( sups );
			ALIAS curr FOR sups [ no];
				code := code + '\t' + 's := new unbounded_string;\n' 
				+ '\t' + 's.all := to_unbounded_string("' + upperize ( curr.owner.name ) + '.' + upperize ( curr.name ) + '");\n' 
				+ '\t' + 'Add (list, s);\n' 
				+ '\n';
			END_ALIAS;
		END_REPEAT;
		code := code + '\treturn list;\nend type_of;\n\n' 

		+ 'function type_of ( obj : in ' + cip.ptr_type + ' ) return unbounded_string_list is\n' 
		+ 'begin\n' 
		+ '\treturn type_of(obj.all);\n' 
		+ 'end type_of;\n';
		RETURN ( code );
	END_FUNCTION;

	FUNCTION ada_class_copy_code ( cip : ada_class ) : STRING;
		LOCAL 
			code : STRING;
			v : STRING := 'New_' + cip.name;
			local_sup : entity_definition := local_root_supertype_of ( cip );
		END_LOCAL;
		code := 'function Copy ( obj : in ' + cip.name + ' ) return ' + local_sup.ptr_type + ' is\n' 
		+ '\t' + v + ' : ' + cip.ptr_type + ';\n' 
		+ 'begin\n' 
		+ '\t' + v + ' := new ' + cip.name + '''(obj);\n';

		IF local_sup.ptr_type <> cip.ptr_type THEN
			code := code + '\treturn ' + local_sup.ptr_type + '(' + v + ');\n';
		ELSE
			code := code + '\treturn (' + v + ');\n';
		END_IF;
		code := code + 'end Copy;\n\n' 

		+ 'function Copy ( obj : in ' + cip.ptr_type + ' ) return ' + local_sup.ptr_type + ' is\n' 
		+ 'begin\n' 
		+ '\treturn copy(obj.all);\n' 
		+ 'end Copy;\n';
		RETURN ( code );
	END_FUNCTION;

	FUNCTION ada_class_put_code ( cip : ada_class ) : STRING;
		LOCAL 
			code : STRING;
			acode : STRING;
		END_LOCAL;
		code := 'procedure Put(obj : in ' + cip.name + ') is \nbegin\n';

		IF SIZEOF ( cip.supertypes ) > 0 THEN
			ALIAS sup FOR cip.supertypes [ LOINDEX ( cip.supertypes ) ].handled;
				code := code + '\tput(' + sup.name + '(obj));\n';
			END_ALIAS;
		END_IF;

		REPEAT no := LOINDEX ( cip.explicit_attributes ) TO HIINDEX ( cip.explicit_attributes );
			ALIAS attr FOR cip.explicit_attributes [ no];
				acode := explicit_attribute_put ( attr );
				IF ( acode > '' ) THEN
					code := code + '\t' + acode + '\n';
				END_IF;
			END_ALIAS;
		END_REPEAT;
		code := code + 'end Put;\n \n' 
		+ 'procedure Put(obj : in ' + cip.ptr_type + ') is\n' 
		+ 'begin\n' 
		+ '\tPut(Obj.All);\n' 
		+ 'end Put;\n \n';
		code := code + 'procedure Put_Name ( obj : in ' + cip.ptr_type + ') is\n' 
		+ 'begin\n';

		IF has_inherited_attribute_named ( cip, 'name' ) THEN
			code := code + '\tPut ( To_String ( Obj.Name ) );\n';
		ELSE
			code := code + '\tPut ( To_String ( Obj.' + xml_id_name + ' ) );\n';
		END_IF;
		code := code + 'end Put_Name;\n';
		RETURN ( code );
	END_FUNCTION;

	FUNCTION ada_class_get_name_code ( cip : ada_class ) : STRING;
		LOCAL 
			code : STRING;
		END_LOCAL;
		code := 'function Get_Name (obj : in ' + cip.name + ') return Unbounded_String is\n' 
		+ 'begin\n';

		IF has_inherited_attribute_named ( cip, 'name' ) THEN
			code := code + '	return obj.name;\n';
		ELSE
			code := code + '	return obj.' + xml_id_name + ';\n';
		END_IF;
		code := code + 'end Get_Name;\n\n' 

		+ 'function Get_Name (obj : in ' + cip.name + '_ptr) return Unbounded_String is\n' 
		+ 'begin\n';

		IF has_inherited_attribute_named ( cip, 'name' ) THEN
			code := code + '	return obj.name;\n';
		ELSE
			code := code + '	return obj.' + xml_id_name + ';\n';
		END_IF;
		code := code + 'end Get_Name;\n';
		RETURN ( code );
	END_FUNCTION;

	FUNCTION ada_class_attributes_ads_code ( cip : ada_class ) : STRING;
		LOCAL 
			result : STRING;
			domain : entity_instance;
		END_LOCAL;

		IF SIZEOF ( cip.explicit_attributes ) = 0 THEN
			result := 'null record;\n';
		ELSE
			result := '\nrecord\n';
			REPEAT no := LOINDEX ( cip.explicit_attributes ) TO HIINDEX ( cip.explicit_attributes );
				ALIAS attr FOR cip.explicit_attributes [ no];
					domain := basic_ada_domain ( attr.domain );
					IF ( 'RECORD_AND_CLASS.ADA_CLASS' IN TYPEOF ( domain.handled ) ) OR ( 'DISCRIMINATED_TYPE.DISCRIMINATED_TYPE' IN TYPEOF ( domain.handled ) ) THEN
						result := result + ' ' + attr.name + ' : ' + domain.handled.ptr_type + ';\n';
					ELSE
						result := result + ' ' + attr.name + ' : ' + domain.ada_ref_ident + ';\n';
					END_IF;
				END_ALIAS;
			END_REPEAT;
			result := result + 'end record;\n';
		END_IF;
		RETURN ( result );
	END_FUNCTION;

	FUNCTION ada_entity_interfaces_list ( r : ada_entity; ads : BOOLEAN ) : LIST OF ada_interface;
		LOCAL 
			result : LIST OF ada_interface := entity_definition_interfaces_list ( r, ads );
		END_LOCAL;

		IF ads THEN
			IF 'PACKAGE.ADA_PACKAGE' IN TYPEOF ( r.owner ) THEN
				result := result + ada_interface ( r.owner.name, ?, true, true );
			END_IF;
			IF ( SIZEOF ( r.supertypes ) > 0 ) THEN
				ALIAS supref FOR r.supertypes [ 1 ].ref;
					IF 'PACKAGE.ADA_PACKAGE' IN TYPEOF ( supref.owner ) THEN
						result := result + ada_interface ( supref.owner.name, ?, true, true );
					END_IF;
				END_ALIAS;
			END_IF;
			result := result + ada_interface ( 'Ada.Finalization', ?, true, false );
			result := result + ada_interface ( 'unbounded_strings', ?, true, true );
			result := result + ada_interface ( 'ada.strings', 'unbounded', true, true );
			result := result + ada_interface ( 'unbounded_strings', 'Unbounded_String_List_Package', false, true );
			result := result + ada_interface ( 'Unchecked_Deallocation', ?, true, false );
			result := result + ada_interface ( 'Primitive_XML_Strings', ?, true, true );
		ELSE
			IF has_attribute_named ( r, xml_id_name ) THEN
				result := result + ada_interface ( 'framework', ?, true, true );
				result := result + ada_interface ( 'id_generators', ?, true, true );
			END_IF;
		END_IF;
		RETURN ( result );
	END_FUNCTION;

	FUNCTION entity_definition_interfaces_list ( r : entity_definition; ads : BOOLEAN ) : LIST OF ada_interface;
		LOCAL 
			result : LIST OF ada_interface := [ ];
			ada_domain : entity_instance;
		END_LOCAL;

		REPEAT no := LOINDEX ( r.explicit_attributes ) TO HIINDEX ( r.explicit_attributes );
			ALIAS curr FOR r.explicit_attributes [ no];
				ada_domain := basic_ada_domain ( curr.domain );
				result := result + domain_interfaces_list ( ada_domain, ads, r.owner );
			END_ALIAS;
		END_REPEAT;
		RETURN ( result );
	END_FUNCTION;

	FUNCTION record_ads_code ( rec : record ) : STRING;
		LOCAL 
			result : STRING;
			domain : entity_instance;
		END_LOCAL;
		result := '\n' 
		+ '-- --------= ' + rec.name + ' =--------\n \n' 
		+ 'type ' + rec.name + ' is\nrecord\n';

		REPEAT no := LOINDEX ( rec.attributes ) TO HIINDEX ( rec.attributes );
			result := result + ' ' + rec.attributes [ no].name + ' : ';
			domain := basic_ada_domain ( rec.attributes [ no].domain );
			IF domain.handled.refed_by_pointer THEN
				result := result + domain.handled.ptr_type + ';\n';
			ELSE
				result := result + domain.ada_ref_ident + ';\n';
			END_IF;
		END_REPEAT;
		result := result + 'end record;\n\n' 

		+ 'type ' + rec.ptr_type + ' is access all ' + rec.name + ';\n\n' 

		+ 'procedure Initialize(obj : out ' + rec.name + ');\n' 
		+ 'procedure Put(obj : in ' + rec.name + ');\n' 
		+ 'procedure Put(obj : in ' + rec.ptr_type + ');\n' 
		+ 'function Copy(obj : in ' + rec.ptr_type + ') return ' + rec.ptr_type + ';\n' 
		+ 'function Copy(obj : in ' + rec.name + ') return ' + rec.ptr_type + ';\n' 
		+ 'procedure Build_Attributes_XML_String(obj : in ' + rec.name + '; result : in out Unbounded_String);\n' 
		+ 'function XML_String(obj : in ' + rec.name + ') return Unbounded_String;\n' 
		+ 'function XML_String(obj : in ' + rec.ptr_type + ') return Unbounded_String;\n' 
		+ 'function XML_Ref_String(obj : in ' + rec.name + ') return Unbounded_String;\n' 
		+ 'procedure Free  is new Unchecked_Deallocation (' + rec.name + ', ' + rec.ptr_type + ');\n';
		RETURN ( result );
	END_FUNCTION;

	FUNCTION record_initialize_code ( rec : record ) : STRING;
		LOCAL 
			code : STRING;
			innerCode : STRING := '';
			attrs : LIST OF attribute;
			init : STRING;
		END_LOCAL;
		code := '\nprocedure Initialize(obj : out ' + rec.name + ') is \nbegin\n';

		REPEAT no := LOINDEX ( rec.explicit_attributes ) TO HIINDEX ( rec.explicit_attributes );
			ALIAS attr FOR rec.explicit_attributes [ no];
				init := explicit_attribute_initialize ( attr );
				IF ( EXISTS ( init ) AND ( init > '' ) ) THEN
					innerCode := innerCode + '\t' + init + '\n';
				END_IF;
			END_ALIAS;
		END_REPEAT;

		IF innerCode = '' THEN
			innerCode := '\tnull;\n';
		END_IF;
		code := code + innerCode + 'end Initialize;\n';
		RETURN ( code );
	END_FUNCTION;

	FUNCTION record_adb_code ( rec : record ) : STRING;
		LOCAL 
			code : STRING;
		END_LOCAL;
		code := '\n' 
		+ '-- --------= ' + rec.name + ' =--------\n' 
		+ record_initialize_code ( rec ) + '\n' 
		+ record_put_code ( rec ) + '\n' 
		+ record_xml_writer_code ( rec ) + '\n' 
		+ record_copy_code ( rec ) + '\n';
		RETURN ( code );
	END_FUNCTION;

	FUNCTION record_put_code ( rec : record ) : STRING;
		LOCAL 
			code : STRING;
			acode : STRING;
		END_LOCAL;
		code := 'procedure Put(obj : in ' + rec.name + ') is \nbegin\n';

		REPEAT no := LOINDEX ( rec.explicit_attributes ) TO HIINDEX ( rec.explicit_attributes );
			ALIAS attr FOR rec.explicit_attributes [ no];
				acode := explicit_attribute_put ( attr );
				IF ( acode > '' ) THEN
					code := code + '\t' + acode + '\n';
				END_IF;
			END_ALIAS;
		END_REPEAT;
		code := code + 'end Put;\n \n' 
		+ 'procedure Put(obj : in ' + rec.ptr_type + ') is\n' 
		+ 'begin\n' 
		+ '\tPut(Obj.All);\n' 
		+ 'end Put;\n';
		RETURN ( code );
	END_FUNCTION;

	FUNCTION explicit_attribute_put ( attr : explicit_attribute ) : STRING;
		LOCAL 
			code : STRING;
			prfx : STRING := '';
			domain : entity_instance := basic_ada_domain ( attr.domain );
		END_LOCAL;
		code := 'put("' + attr.name + ': "); ';

		IF ( 'RECORD_AND_CLASS.CHEDDAR_FUNCTION_PTR' IN TYPEOF ( domain.handled ) ) THEN
			RETURN ( '' );
		END_IF;

		IF ( 'CHEDDAR_DOMAINS.ADA_PRIMITIVE_TYPE' IN TYPEOF ( domain.handled ) ) THEN
			prfx := domain.handled.put_prefix;
		END_IF;

		IF domain.handled.refed_by_pointer THEN
			code := code + 'if obj.' + attr.name + ' /= null then ' + prfx + 'put(obj.' + attr.name + '.all' + '); else put("null"); end if;';
		ELSE
			code := code + prfx + 'put(obj.' + attr.name + '); ';
		END_IF;
		code := code + 'put ( "; " );';
		RETURN ( code );
	END_FUNCTION;

	FUNCTION explicit_attribute_xml_writer_code ( prefix : STRING; attr : explicit_attribute ) : STRING;
		LOCAL 
			code : STRING;
			domain : entity_instance := basic_ada_domain ( attr.domain );
			tag : STRING := Lowerize ( attr.name );
		END_LOCAL;

		IF ( 'RECORD_AND_CLASS.CHEDDAR_FUNCTION_PTR' IN TYPEOF ( domain.handled ) ) THEN
			RETURN ( '' );
		END_IF;

		IF ( attr.name = xml_id_name ) THEN
			RETURN ( '' );
		END_IF;

		IF is_generic_object ( domain.handled ) THEN
			code := '\tresult := result & to_unbounded_string("<' + attr.name + ' ref=""") & ' + prefix + '.' + attr.name + '.' + xml_id_name + ' & to_unbounded_string(""" />");';
		ELSE
			code := '\tif (XML_String(' + prefix + '.' + attr.name + ') /= Empty_String) then\n' 
			+ '\t\tresult := result & to_unbounded_string("<' + tag + '>") & XML_String(' + prefix + '.' + attr.name + ') & to_unbounded_string("</' + tag + '>");\n\tend if;';
		END_IF;
		RETURN ( code );
	END_FUNCTION;

	FUNCTION record_copy_code ( cip : record ) : STRING;
		LOCAL 
			code : STRING;
			v : STRING := 'New_' + cip.name;
		END_LOCAL;
		code := 'function Copy ( obj : in ' + cip.name + ' ) return ' + cip.ptr_type + ' is\n' 
		+ '\t' + v + ' : ' + cip.ptr_type + ';\n' 
		+ 'begin\n' 
		+ '\t' + v + ' := new ' + cip.name + '''(obj);\n';
		code := code + '\treturn (' + v + ');\n';
		code := code + 'end Copy;\n\n' 

		+ 'function Copy ( obj : in ' + cip.ptr_type + ' ) return ' + cip.ptr_type + ' is\n' 
		+ 'begin\n' 
		+ '\treturn copy(obj.all);\n' 
		+ 'end Copy;\n';
		RETURN ( code );
	END_FUNCTION;

	FUNCTION ada_class_xml_io_record_code ( cip : ada_class ) : STRING;
		RETURN ( '\ntype ' + cip.name + '_io is record' + ada_entity_attributes_xml_io_record_code ( cip ) + '\nend record;' );
	END_FUNCTION;

	FUNCTION ada_entity_attributes_xml_io_record_code ( cip : ada_class ) : STRING;
		LOCAL 
			code : STRING := '';
			attrcode : STRING;
		END_LOCAL;

		IF SIZEOF ( cip.supertypes ) > 0 THEN
			ALIAS sup FOR cip.supertypes [ LOINDEX ( cip.supertypes ) ].handled;
				code := code + ada_entity_attributes_xml_io_record_code ( sup );
			END_ALIAS;
		END_IF;

		REPEAT no := LOINDEX ( cip.explicit_attributes ) TO HIINDEX ( cip.explicit_attributes );
			ALIAS attr FOR cip.explicit_attributes [ no];
				attrcode := explicit_attribute_xml_io_record_code ( attr );
				code := code + attrcode;
			END_ALIAS;
		END_REPEAT;

		IF ( code = '' ) THEN
			code := '\tnull;';
		END_IF;
		RETURN ( code );
	END_FUNCTION;

	FUNCTION explicit_attribute_xml_io_record_code ( attr : explicit_attribute ) : STRING;
		LOCAL 
			code : STRING := '';
			domain : entity_instance := basic_ada_domain ( attr.domain );
			init : STRING := domain.init_value;
		END_LOCAL;

		IF ( 'RECORD_AND_CLASS.RECORD' IN TYPEOF ( domain.handled ) ) THEN
			RETURN ( ada_entity_attributes_xml_io_record_code ( domain.handled ) );
		END_IF;

		IF NOT is_generic_object ( domain.handled ) THEN
			IF ( 'CHEDDAR_DOMAINS.ADA_ENUMERATION' IN TYPEOF ( domain.handled ) ) OR EXISTS ( init ) THEN
				IF ( 'CHEDDAR_DOMAINS.ADA_ENUMERATION' IN TYPEOF ( domain.handled ) ) THEN
					code := '\t' + attr.name + ' : ' + domain.ada_ref_ident + ';';
				ELSE
					IF ( init = 'empty_string' ) THEN
						code := '\t' + attr.name + ' : Unbounded_String;';
					ELSE
						IF ( lowerize ( init ) = 'false' ) THEN
							code := '\t' + attr.name + ' : Boolean;';
						ELSE
							IF ( init = '0' ) THEN
								code := '\t' + attr.name + ' : Integer;';
							ELSE
								code := '\t' + attr.name + ' : Double;';
							END_IF;
						END_IF;
					END_IF;
				END_IF;
			END_IF;
		ELSE
			code := '\t' + attr.name + ' : Unbounded_String;';
		END_IF;

		IF ( code > '' ) THEN
			code := '\n' 
			+ code;
		END_IF;
		RETURN ( code );
	END_FUNCTION;

	FUNCTION record_xml_io_record_code ( rec : record ) : STRING;
		RETURN ( '\ntype ' + rec.name + '_io is record' + ada_entity_attributes_xml_io_record_code ( rec ) + '\nend record;\n' );
	END_FUNCTION;

	FUNCTION ada_entity_xml_io_record_initialize_code ( cip : ada_class ) : STRING;
		LOCAL 
			code : STRING := ada_entity_attributes_xml_io_record_initialize_code ( cip );
		END_LOCAL;

		IF ( code = '' ) THEN
			code := '\tnull;';
		END_IF;
		RETURN ( '\nprocedure Initialize(obj : out ' + cip.name + '_io) is \nbegin ' + code + '\nend Initialize;\n' );
	END_FUNCTION;

	FUNCTION ada_entity_attributes_xml_io_record_initialize_code ( cip : ada_class ) : STRING;
		LOCAL 
			code : STRING := '';
			s : STRING;
		END_LOCAL;

		IF SIZEOF ( cip.supertypes ) > 0 THEN
			ALIAS sup FOR cip.supertypes [ LOINDEX ( cip.supertypes ) ].handled;
				code := code + ada_entity_attributes_xml_io_record_initialize_code ( sup );
			END_ALIAS;
		END_IF;

		REPEAT no := LOINDEX ( cip.explicit_attributes ) TO HIINDEX ( cip.explicit_attributes );
			ALIAS attr FOR cip.explicit_attributes [ no];
				s := explicit_attribute_xml_io_record_initialize_code ( attr );
				IF ( s > '' ) THEN
					code := code + '\n' 
					+ s;
				END_IF;
			END_ALIAS;
		END_REPEAT;
		RETURN ( code );
	END_FUNCTION;

	FUNCTION explicit_attribute_xml_io_record_initialize_code ( attr : explicit_attribute ) : STRING;
		LOCAL 
			code : STRING := '';
			domain : entity_instance := basic_ada_domain ( attr.domain );
			init : STRING := domain.init_value;
		END_LOCAL;

		IF NOT is_generic_object ( domain.handled ) THEN
			IF ( 'CHEDDAR_DOMAINS.ADA_ENUMERATION' IN TYPEOF ( domain.handled ) ) THEN
				code := '\tobj.' + attr.name + ' := ' + domain.ada_ref_ident + '''first;';
			ELSE
				IF EXISTS ( init ) THEN
					code := '\tobj.' + attr.name + ' := ' + init + ';';
				END_IF;
			END_IF;
		ELSE
			code := '\tobj.' + attr.name + ' := empty_string;';
		END_IF;
		RETURN ( code );
	END_FUNCTION;

	FUNCTION ada_entity_xml_start_element_code ( cip : ada_entity ) : STRING;
		LOCAL 
			code : STRING;
		END_LOCAL;

		IF ( 'RECORD_AND_CLASS.RECORD' IN TYPEOF ( cip ) ) THEN
			code := '\nprocedure Start_Element(\n' 
			+ '\tHandler: in out Xml_Generic_Parser;\n' 
			+ '\tobj : in out ' + cip.name + '_io;\n' 
			+ '\tNamespace_Uri : Unicode.CES.Byte_Sequence := "";\n' 
			+ '\tLocal_Name : Unicode.CES.Byte_Sequence := "";\n' 
			+ '\tQname : Unicode.CES.Byte_Sequence := "";\n' 
			+ '\tAtts : Sax.Attributes.Attributes''Class) is\n' 
			+ 'begin\n' 
			+ '\tif To_String (To_Lower (Qname)) = "' + cip.html_tag + '" then\n' 
			+ '\t\tinitialize(obj);\n' 
			+ '\tend if;\n' 
			+ 'end Start_Element;\n';
		ELSE
			code := ada_entity_attributes_xml_start_element_code ( cip );
			IF ( code > '' ) THEN
				code := '\nprocedure Start_Element(\n' 
				+ '\tHandler: in out Xml_Generic_Parser;\n' 
				+ '\tobj : in out ' + cip.name + '_io;\n' 
				+ '\tNamespace_Uri : Unicode.CES.Byte_Sequence := "";\n' 
				+ '\tLocal_Name : Unicode.CES.Byte_Sequence := "";\n' 
				+ '\tQname : Unicode.CES.Byte_Sequence := "";\n' 
				+ '\tAtts : Sax.Attributes.Attributes''Class) is \nbegin\n' 
				+ '\tif Get_Length (Atts) > 0 then' + code + '\n' 
				+ '\tend if;\n' 
				+ 'end Start_Element;\n';
			END_IF;
		END_IF;
		RETURN ( code );
	END_FUNCTION;

	FUNCTION ada_entity_attributes_xml_start_element_code ( cip : ada_class ) : STRING;
		LOCAL 
			code : STRING := '';
			s : STRING;
		END_LOCAL;

		IF SIZEOF ( cip.supertypes ) > 0 THEN
			ALIAS sup FOR cip.supertypes [ LOINDEX ( cip.supertypes ) ].handled;
				code := code + ada_entity_attributes_xml_start_element_code ( sup );
			END_ALIAS;
		END_IF;

		REPEAT no := LOINDEX ( cip.explicit_attributes ) TO HIINDEX ( cip.explicit_attributes );
			ALIAS attr FOR cip.explicit_attributes [ no];
				s := explicit_attribute_xml_start_element_code ( attr );
				IF ( s > '' ) THEN
					code := code + s;
				END_IF;
			END_ALIAS;
		END_REPEAT;
		RETURN ( code );
	END_FUNCTION;

	FUNCTION explicit_attribute_xml_end_element_code ( attr : explicit_attribute ) : STRING;
		LOCAL 
			code : STRING := '';
			domain : entity_instance := basic_ada_domain ( attr.domain );
			init : STRING := domain.init_value;
			io_domain : STRING;
		END_LOCAL;

		IF NOT is_generic_object ( domain.handled ) THEN
			IF ( 'CHEDDAR_DOMAINS.ADA_ENUMERATION' IN TYPEOF ( domain.handled ) ) OR EXISTS ( init ) THEN
				IF ( 'CHEDDAR_DOMAINS.ADA_ENUMERATION' IN TYPEOF ( domain.handled ) ) THEN
					io_domain := domain.ada_ident;
				ELSE
					IF ( init = 'empty_string' ) THEN
						io_domain := 'String';
					ELSE
						IF ( lowerize ( init ) = 'false' ) THEN
							io_domain := 'Boolean';
						ELSE
							IF ( init = '0' ) THEN
								io_domain := 'Integer';
							ELSE
								io_domain := 'Double';
							END_IF;
						END_IF;
					END_IF;
				END_IF;
				IF init = 'empty_string' THEN
					code := '\n\tif To_String (To_Lower (Qname)) = "' + lowerize ( attr.name ) + '" then\n' 
					+ '\t\tobj.' + attr.name + ' := handler.Parameter_List (1);\n' 
					+ '\tend if;';
				ELSE
					code := '\n\tif To_String (To_Lower (Qname)) = "' + lowerize ( attr.name ) + '" then\n' 
					+ '\t\tTo_' + io_domain + ' (handler.Parameter_List (1), obj.' + attr.name + ', Handler.Ok);\n' 
					+ '\t\tif not Handler.Ok then\n' 
					+ '\t\t\tPut_Line ("Warning : Error on data type From " & To_String (Handler.Locator));\n' 
					+ '\t\tend if;\n' 
					+ '\tend if;';
				END_IF;
			END_IF;
		END_IF;
		RETURN ( code );
	END_FUNCTION;

	FUNCTION explicit_attribute_xml_start_element_code ( attr : explicit_attribute ) : STRING;
		LOCAL 
			code : STRING := '';
			domain : entity_instance := basic_ada_domain ( attr.domain );
			sub_domain : entity_instance;
			element_domain : entity_instance;
		END_LOCAL;

		IF is_generic_object ( domain.handled ) THEN
			code := '\n\t\tif To_String (To_Lower (Qname)) = "' + lowerize ( attr.name ) + '" then\n' 
			+ '\t\t\tfor J in 0 .. Get_Length (Atts) - 1 loop\n' 
			+ '\t\t\t\tif To_String (To_Lower (Get_Qname (Atts, J))) = "ref" then\n' 
			+ '\t\t\t\t\tobj.' + attr.name + ' := To_Unbounded_String (Get_Value (Atts, J));\n' 
			+ '\t\t\t\tend if;\n' 
			+ '\t\t\tend loop;\n' 
			+ '\t\tend if;';
		END_IF;
		RETURN ( code );
	END_FUNCTION;

	FUNCTION ada_entity_xml_end_element_code ( cip : ada_entity ) : STRING;
		RETURN ( '\nprocedure End_Element(\n' 
			+ '\tHandler : in out Xml_generic_parser;\n' 
			+ '\tobj : in out ' + cip.name + '_io;\n' 
			+ '\tNamespace_Uri : Unicode.CES.Byte_Sequence := "";\n' 
			+ '\tLocal_Name    : Unicode.CES.Byte_Sequence := "";\n' 
			+ '\tQname : Unicode.CES.Byte_Sequence := "") is \nbegin\n' 
			+ ada_entity_attributes_xml_end_element_code ( cip ) + '\nend End_Element;\n' );
	END_FUNCTION;

	FUNCTION ada_entity_attributes_xml_end_element_code ( cip : ada_class ) : STRING;
		LOCAL 
			code : STRING := '';
			s : STRING;
		END_LOCAL;

		IF SIZEOF ( cip.supertypes ) > 0 THEN
			ALIAS sup FOR cip.supertypes [ LOINDEX ( cip.supertypes ) ].handled;
				code := code + ada_entity_attributes_xml_end_element_code ( sup );
			END_ALIAS;
		END_IF;

		REPEAT no := LOINDEX ( cip.explicit_attributes ) TO HIINDEX ( cip.explicit_attributes );
			ALIAS attr FOR cip.explicit_attributes [ no];
				s := explicit_attribute_xml_end_element_code ( attr );
				IF ( s > '' ) THEN
					code := code + '\n' 
					+ s;
				END_IF;
			END_ALIAS;
		END_REPEAT;

		IF ( code = '' ) THEN
			code := '\tnull;\n';
		END_IF;
		RETURN ( code );
	END_FUNCTION;
END_SCHEMA;


SCHEMA package;
	USE FROM platypus_dictionary_schema;
	USE FROM express_toolsbox_functions;
	USE FROM express_dictionary_queries;
	USE FROM express2cheddar_facade;
	USE FROM record_and_class;
	USE FROM cheddar_domains;
	USE FROM ada_interface;
	USE FROM cheddar_constants;
	USE FROM xml_io;

	ENTITY ada_package 
		SUBTYPE OF ( schema_definition );
		ads_interface : LIST OF ada_interface;
		adb_interface : LIST OF ada_interface;
		xml_root_tags : LIST OF STRING;
	DERIVE
		infered_ads_interfaces : LIST OF ada_interface := ada_package_interface ( SELF, true );
		ads_head : STRING := source_licence + '\n' 
		+ ada_interfaces_code ( SELF, ada_package_interface ( SELF, true ) );
		adb_head : STRING := source_licence + '\n' 
		+ ada_interfaces_code ( SELF, ada_package_interface ( SELF, false ) );
		ads_code : STRING := ads_head + '\n\nPackage ' + name + ' is \n \n' 
		+ ada_package_ads_code ( SELF ) + '\nEnd ' + name + ';';
		adb_code : STRING := adb_head + '\n\nPackage Body ' + name + ' is \n \n' 
		+ ada_package_adb_code ( SELF ) + '\nEnd ' + name + ';';
	END_ENTITY;

	ENTITY package_alias;
		package_name : STRING;
		attribute_name : STRING;
	DERIVE
		ptr_type : STRING := SELF.name + '_Ptr';
		ads_interfaces_list : LIST OF ada_interface := [ ];
		adb_interfaces_list : LIST OF ada_interface := [ ada_interface ( SELF.owner.name, ?, true, true ) ];
		ads_code : STRING := 'subtype ' + SELF.name + ' is ' + package_name + '.' + attribute_name + ';\n' 
		+ 'subtype ' + SELF.ptr_type + ' is  ' + package_name + '.' + attribute_name + '_Ptr;\n';
		adb_code : STRING := '';
		init_value : STRING := ?;
		dependencies : LIST OF dictionary_instance := [ SELF ];
		ada_ref_ident : STRING := SELF.ptr_type;
		refed_by_pointer : BOOLEAN := true;
	END_ENTITY;

	ENTITY generic_package_instanciation 
		SUBTYPE OF ( ada_entity );
		generic_package_name : STRING;
		parameters : LIST OF STRING;
		interfaces : LIST OF ada_interface;
	DERIVE
		aliases : LIST OF cheddar_defined_type := generic_package_aliases ( SELF );
		ads_interfaces_list : LIST OF ada_interface := [ ada_interface ( SELF.generic_package_name, ?, true, false ), ada_interface ( SELF.owner.name, SELF.name, false, true ), ada_interface ( 'Unchecked_Deallocation', ?, true, false ) ] + interfaces;
		adb_interfaces_list : LIST OF ada_interface := [ ];
		ads_code : STRING := 'package ' + ada_ident + ' is new ' + generic_package_name + '(' + StringAggregateConcatSeparatedBy ( parameters, ', ' ) + ');\n' 
		+ 'use ' + ada_ident + ';\n' 
		+ generic_package_instanciation_attributes_ads_code ( SELF );
		adb_code : STRING := '';
	END_ENTITY;

	FUNCTION ada_package_adb_code ( pkg : ada_package ) : STRING;
		LOCAL 
			result : STRING;
		END_LOCAL;
		result := ada_package_concepts_list_code ( pkg, pkg.types, false ) + ada_package_concepts_list_code ( pkg, pkg.entities, false );
		RETURN ( result );
	END_FUNCTION;

	FUNCTION ada_package_ads_code ( pkg : ada_package ) : STRING;
		LOCAL 
			result : STRING;
			classes : LIST OF ada_class := QUERY ( e <* pkg.entities | 'RECORD_AND_CLASS.ADA_CLASS' IN TYPEOF ( e ) );
			const_list : LIST OF ada_constant := QUERY ( e <* pkg.constants | 'CHEDDAR_CONSTANTS.ADA_CONSTANT' IN TYPEOF ( e ) );
			private_classes : LIST OF ada_class := QUERY ( e <* classes | e.is_private );
			constrained_arrays : LIST OF defined_type;
		END_LOCAL;
		constrained_arrays := QUERY ( t <* pkg.types | 'CHEDDAR_DOMAINS.CONSTRAINED_ARRAY_TYPE' IN TYPEOF ( t ) );
		result := ada_package_concepts_list_code ( pkg, ( ( pkg.types - constrained_arrays ) + pkg.entities ) + constrained_arrays, true );

		REPEAT no := LOINDEX ( const_list ) TO HIINDEX ( const_list );
			result := result + const_list [ no].ads_code + '\n';
		END_REPEAT;

		IF SIZEOF ( private_classes ) > 0 THEN
			result := result + '\n\nprivate\n \n';
			REPEAT no := LOINDEX ( private_classes ) TO HIINDEX ( private_classes );
				ALIAS supref FOR private_classes [ no].supertypes [ 1 ].ref;
					result := result + '\ntype ' + private_classes [ no].name + ' is new ' + supref.ada_ident + ' with\n' 
					+ ada_class_attributes_ads_code ( private_classes [ no] );
				END_ALIAS;
			END_REPEAT;
		END_IF;
		RETURN ( result );
	END_FUNCTION;

	FUNCTION ada_package_interface ( pkg : ada_package; ads : BOOLEAN ) : LIST OF ada_interface;
		LOCAL 
			ads_list : LIST OF ada_interface := [ ada_interface ( 'Ada.Strings.Unbounded', ?, true, true ), ada_interface ( 'Framework_Config', ?, true, true ), ada_interface ( 'id_generators', ?, true, true ) ];
			adb_list : LIST OF ada_interface := [ ada_interface ( 'Text_io', ?, true, true ), ada_interface ( 'unbounded_strings', ?, true, true ) ];
			wul : LIST OF ada_interface;
			result : LIST OF ada_interface := [ ];
			defs : LIST OF dictionary_instance := pkg.entities + pkg.types + pkg.constants;
			pkgKey : STRING := upperize ( pkg.name );
		END_LOCAL;

		REPEAT no := LOINDEX ( pkg.interface ) TO HIINDEX ( pkg.interface );
			ALIAS curr FOR pkg.interface [ no];
				IF ( 'PACKAGE.ADA_PACKAGE' IN TYPEOF ( curr.native_schema ) ) THEN
					ads_list := ads_list + ADA_INTERFACE ( curr.native_schema.name, ?, true, true );
				END_IF;
			END_ALIAS;
		END_REPEAT;

		REPEAT no := LOINDEX ( defs ) TO HIINDEX ( defs );
			ALIAS e FOR defs [ no];
				IF ( 'CHEDDAR_DOMAINS.CHEDDAR_DEFINED_TYPE' IN TYPEOF ( e ) ) THEN
					ads_list := ads_list + e.ads_interfaces_list;
					adb_list := adb_list + e.adb_interfaces_list;
				END_IF;
				IF ( 'CHEDDAR_DOMAINS.EXPLICIT_TYPE_REFERENCE' IN TYPEOF ( e ) ) THEN
					ads_list := ads_list + e.ads_interfaces_list;
					adb_list := adb_list + e.adb_interfaces_list;
				END_IF;
				IF ( 'CHEDDAR_CONSTANTS.ADA_CONSTANT' IN TYPEOF ( e ) ) THEN
					ads_list := ads_list + e.ads_interfaces_list;
					adb_list := adb_list + e.adb_interfaces_list;
				END_IF;
				IF ( 'RECORD_AND_CLASS.ADA_ENTITY' IN TYPEOF ( e ) ) THEN
					ads_list := ads_list + e.ads_interfaces_list;
					adb_list := adb_list + e.adb_interfaces_list;
				END_IF;
				IF ( 'CHEDDAR_DOMAINS.ADA_ENUMERATION' IN TYPEOF ( e ) ) THEN
					ads_list := ads_list + e.ads_interfaces_list;
					adb_list := adb_list + e.adb_interfaces_list;
				END_IF;
				IF ( 'CHEDDAR_DOMAINS.CONSTRAINED_ARRAY_TYPE' IN TYPEOF ( e ) ) THEN
					ads_list := ads_list + e.ads_interfaces_list;
					adb_list := adb_list + e.adb_interfaces_list;
				END_IF;
				IF ( 'PACKAGE.GENERIC_PACKAGE_INSTANCIATION' IN TYPEOF ( e ) ) THEN
					ads_list := ads_list + e.ads_interfaces_list;
					adb_list := adb_list + e.adb_interfaces_list;
				END_IF;
			END_ALIAS;
		END_REPEAT;

		IF ads THEN
			wul := ads_list + pkg.ads_interface;
		ELSE
			wul := adb_list + pkg.adb_interface;
		END_IF;

		REPEAT no := LOINDEX ( wul ) TO HIINDEX ( wul );
			ALIAS curr FOR wul [ no];
				IF ( upperize ( curr.prefix ) <> pkgKey ) THEN
					result := result + curr;
				END_IF;
			END_ALIAS;
		END_REPEAT;
		RETURN ( result );
	END_FUNCTION;

	FUNCTION all_packages_code ( ads : BOOLEAN ) : STRING;
		RETURN ( all_packages_code_into ( ads, ?, ? ) );
	END_FUNCTION;

	FUNCTION concept_in_list ( c : dictionary_instance; l : LIST OF dictionary_instance ) : BOOLEAN;
		LOCAL 
			key : STRING := upperize ( c.name );
		END_LOCAL;

		REPEAT no := LOINDEX ( l ) TO HIINDEX ( l );
			IF ( upperize ( l [ no].name ) = key ) THEN
				RETURN ( true );
			END_IF;
		END_REPEAT;
		RETURN ( false );
	END_FUNCTION;

	FUNCTION concept_list_local_dependencies ( sch : schema_definition; l : LIST OF dictionary_instance ) : LIST OF dictionary_instance;
		LOCAL 
			wl : LIST OF dictionary_instance := [ ];
			r : LIST OF dictionary_instance := [ ];
		END_LOCAL;

		REPEAT no := LOINDEX ( l ) TO HIINDEX ( l );
			ALIAS c FOR l [ no];
				IF is_of_generated_concept_kind ( c ) THEN
					wl := c.dependencies;
					REPEAT noi := LOINDEX ( wl ) TO HIINDEX ( wl );
						IF NOT concept_in_list ( wl [ noi], r ) THEN
							r := r + wl [ noi];
						END_IF;
					END_REPEAT;
				END_IF;
			END_ALIAS;
		END_REPEAT;
		RETURN ( r );
	END_FUNCTION;

	FUNCTION ada_package_concepts_list_code ( p : ada_package; concepts : LIST OF dictionary_instance; ads : BOOLEAN ) : STRING;
		LOCAL 
			result : STRING := '';
			code : STRING := '';
			contents : LIST OF dictionary_instance := [ ];
		END_LOCAL;

		IF ads THEN
			contents := concepts;
		ELSE
			contents := concepts;
		END_IF;

		REPEAT no := LOINDEX ( contents ) TO HIINDEX ( contents );
			ALIAS c FOR contents [ no];
				IF is_of_generated_concept_kind ( c ) THEN
					IF ads THEN
						code := c.ads_code;
					ELSE
						code := c.adb_code;
					END_IF;
					result := result + code;
					IF ( code > '' ) THEN
						result := result + '\n';
					END_IF;
				END_IF;
			END_ALIAS;
		END_REPEAT;
		RETURN ( result );
	END_FUNCTION;

	FUNCTION ada_package_class_typeof_list ( pkg : ada_package ) : STRING;
		LOCAL 
			result : STRING := '';
			classes : LIST OF ada_class := QUERY ( e <* pkg.entities | 'RECORD_AND_CLASS.ADA_CLASS' IN TYPEOF ( e ) );
		END_LOCAL;

		REPEAT no := LOINDEX ( classes ) TO HIINDEX ( classes );
			ALIAS curr FOR classes [ no];
				result := result + curr.name + '(';
				result := result + StringAggregateConcatSeparatedBy ( TYPEOF ( curr ), ',' );
				result := result + ')\n';
			END_ALIAS;
		END_REPEAT;
		RETURN ( result );
	END_FUNCTION;

	FUNCTION generic_package_aliases ( e : generic_package_instanciation ) : LIST OF cheddar_defined_type;
		LOCAL 
			aliases : LIST OF entity_instance := [ ];
			attrname : STRING;
		END_LOCAL;

		REPEAT no := LOINDEX ( e.attributes ) TO HIINDEX ( e.attributes );
			ALIAS attr FOR e.attributes [ no];
				ALIAS an FOR attr.name;
					IF ( an [ LENGTH ( an ) ] = '_' ) THEN
						attrname := an [ 1 : LENGTH ( an ) - 1 ];
					ELSE
						attrname := an;
					END_IF;
				END_ALIAS;
				aliases := aliases + ( ada_type ( ) || attr.domain || package_alias ( e.name, attrname ) );
			END_ALIAS;
		END_REPEAT;
		RETURN ( aliases );
	END_FUNCTION;

	FUNCTION generic_package_instanciation_attributes_ads_code ( e : generic_package_instanciation ) : STRING;
		LOCAL 
			result : STRING := '';
			aliases : LIST OF cheddar_defined_type := e.aliases;
		END_LOCAL;

		REPEAT no := LOINDEX ( aliases ) TO HIINDEX ( aliases );
			ALIAS attr FOR e.aliases [ no];
				result := result + attr.ads_code;
			END_ALIAS;
		END_REPEAT;
		RETURN ( result );
	END_FUNCTION;

	FUNCTION all_packages_code_into ( ads : BOOLEAN; dir : STRING; targetName : STRING ) : STRING;
		LOCAL 
			code : STRING := '';
			body : STRING;
			pkgs : LIST OF ada_package := SetToList ( all_ada_packages ( ) );
			targetPath : STRING;
		END_LOCAL;

		REPEAT no := LOINDEX ( pkgs ) TO HIINDEX ( pkgs );
			IF ads THEN
				body := pkgs [ no].ads_code;
			ELSE
				body := pkgs [ no].adb_code;
			END_IF;
			IF ( body > '' ) THEN
				code := code + body + '\n\n';
			END_IF;
		END_REPEAT;

		IF ads THEN
			code := code + xml_architecture_io_ads_package_code ( );
		ELSE
			code := code + xml_architecture_io_adb_package_code ( );
		END_IF;

		IF EXISTS ( dir ) THEN
			targetPath := dir;
		ELSE
			targetPath := '.';
		END_IF;

		IF EXISTS ( targetName ) THEN
			targetPath := targetPath + '/' + targetName;
		ELSE
			targetPath := targetPath + '/' + 'Platypus2Cheddar';
		END_IF;

		IF ads THEN
			WriteFile ( targetPath + '.ads', code );
		ELSE
			WriteFile ( targetPath + '.adb', code );
		END_IF;
		RETURN ( code );
	END_FUNCTION;
END_SCHEMA;


SCHEMA discriminated_type;
	USE FROM platypus_dictionary_schema;
	USE FROM express_toolsbox_functions;
	USE FROM express_dictionary_queries;
	USE FROM express2cheddar_facade;
	USE FROM record_and_class;
	USE FROM cheddar_domains;
	USE FROM ada_interface;

	ENTITY discriminated_type 
		SUBTYPE OF ( ada_entity );
	DERIVE
		SELF\ada_entity.refed_by_pointer : BOOLEAN := false;
		discriminant : attribute := QUERY ( attr <* attributes | 'DISCRIMINATED_TYPE.DISCRIMINATED_TYPE_DISCRIMINANT' IN TYPEOF ( attr ) ) [ 1 ];
		union_attr : attribute := QUERY ( attr <* attributes | 'DISCRIMINATED_TYPE.DISCRIMINATED_TYPE_UNION' IN TYPEOF ( attr ) ) [ 1 ];
		ads_interfaces_list : LIST OF ada_interface := discriminated_Type_interfaces_list ( SELF, true );
		adb_interfaces_list : LIST OF ada_interface := discriminated_Type_interfaces_list ( SELF, false );
		translated_attributes : LIST OF explicit_attribute := explicit_attributes - discriminant - union_attr;
		SELF\ada_entity.ada_ident : STRING := name;
		SELF\ada_entity.ada_ref_ident : STRING := SELF.ada_ident + '_Ptr';
		SELF\ada_entity.xml_io_record_code : STRING := discriminated_type_xml_io_record_code ( SELF );
		tail_attributes : LIST OF attribute := discriminated_type_tails_attributes ( SELF );
		ads_code : STRING := discriminated_type_ads_code ( SELF );
		adb_code : STRING := discriminated_type_adb_code ( SELF );
	END_ENTITY;

	ENTITY discriminated_type_discriminant 
		SUBTYPE OF ( explicit_attribute );
	END_ENTITY;

	ENTITY discriminated_type_union 
		SUBTYPE OF ( explicit_attribute );
	END_ENTITY;

	ENTITY discriminated_type_union_element_type 
		SUBTYPE OF ( ada_entity );
	DERIVE
		ads_interfaces_list : LIST OF ada_interface := [ ];
		adb_interfaces_list : LIST OF ada_interface := [ ];
		ads_code : STRING := '';
		adb_code : STRING := '';
		union_ads_code : STRING := discriminated_type_union_element_case_code ( SELF );
	END_ENTITY;

	ENTITY discriminated_type_union_type 
		SUBTYPE OF ( ada_entity );
	DERIVE
		ads_interfaces_list : LIST OF ada_interface := discriminated_type_union_type_interfaces_list ( SELF, true );
		adb_interfaces_list : LIST OF ada_interface := discriminated_type_union_type_interfaces_list ( SELF, false );
		ads_code : STRING := '';
		adb_code : STRING := '';
		union_ads_code : STRING := discriminated_type_union_case_code ( SELF );
		all_attributes : LIST OF attribute := inherited_explicit_attributes ( SELF );
	END_ENTITY;

	FUNCTION discriminated_type_attributes ( d : discriminated_type ) : LIST OF attribute;
		LOCAL 
			other_attrs : LIST OF attribute := [ d.discriminant] + d.translated_attributes;
			tail_attrs : LIST OF explicit_attribute := discriminated_type_tails_attributes ( d );
			attrs : LIST OF attribute := other_attrs + tail_attrs;
		END_LOCAL;
		RETURN ( attrs );
	END_FUNCTION;

	FUNCTION discriminated_type_interfaces_list ( r : discriminated_type; ads : BOOLEAN ) : LIST OF ada_interface;
		RETURN ( ada_entity_interfaces_list ( r, ads ) );
	END_FUNCTION;

	FUNCTION discriminated_type_union_type_interfaces_list ( d : discriminated_type_union_type; isAds : BOOLEAN ) : LIST OF ada_interface;
		LOCAL 
			l : LIST OF ada_interface := [ ];
		END_LOCAL;

		REPEAT no := LOINDEX ( d.attributes ) TO HIINDEX ( d.attributes );
			ALIAS curr FOR d.attributes [ no];
				l := l + entity_definition_interfaces_list ( curr.domain.handled, isAds );
			END_ALIAS;
		END_REPEAT;
		RETURN ( l );
	END_FUNCTION;

	FUNCTION discriminated_type_adb_code ( typ : discriminated_type ) : STRING;
		LOCAL 
			code : STRING;
			acode : STRING;
			discrim_attr : attribute := typ.discriminant;
			union_attr : attribute := typ.union_attr;
			union_type : defined_type := union_attr.domain.handled;
			union_attributes : LIST OF attribute := inherited_explicit_attributes ( union_type );
			transl_attrs : LIST OF attribute := typ.translated_attributes;
			v : STRING := 'New_' + typ.name;
		END_LOCAL;
		code := 'procedure Initialize (obj : out ' + typ.name + '_Ptr) is\n' 
		+ 'begin\n' 
		+ '\tobj := NULL;\n' 
		+ 'end Initialize;\n \n' 
		+ 'procedure Put(obj : in ' + typ.name + '_Ptr) is\n' 
		+ 'begin\n' 
		+ '\tif (obj /= NULL) then\n';

		REPEAT no := LOINDEX ( transl_attrs ) TO HIINDEX ( transl_attrs );
			ALIAS attr FOR transl_attrs [ no];
				acode := explicit_attribute_put ( attr );
				IF ( acode > '' ) THEN
					code := code + '\t\t' + acode + '\n';
				END_IF;
			END_ALIAS;
		END_REPEAT;
		code := code + '\t\t' + explicit_attribute_put ( discrim_attr ) + '\n' 
		+ '\t\tput ( "value: " );\n' 
		+ '\t\tcase obj.' + discrim_attr.name + ' is \n';

		REPEAT no := LOINDEX ( union_attributes ) TO HIINDEX ( union_attributes );
			ALIAS union_attr FOR union_attributes [ no];
				ALIAS ada_domain FOR basic_ada_domain ( union_attr.domain ).handled;
					ALIAS element_attributes FOR inherited_explicit_attributes ( ada_domain );
						code := code + '\t\t\twhen ' + union_attr.name + ' => \n';
						REPEAT noi := LOINDEX ( element_attributes ) TO HIINDEX ( element_attributes );
							ALIAS element_attr FOR element_attributes [ noi];
								acode := explicit_attribute_put ( element_attr );
								IF ( acode > '' ) THEN
									code := code + '\t\t\t\t' + acode + '\n';
								END_IF;
							END_ALIAS;
						END_REPEAT;
					END_ALIAS;
				END_ALIAS;
			END_ALIAS;
			code := code + '\n';
		END_REPEAT;
		code := code + '\t\tend case;\n\tend if;\n\tNew_Line;\nend Put;\n\n' 

		+ 'function Copy ( obj : in ' + typ.name + ' ) return ' + typ.ptr_type + ' is\n' 
		+ '\t' + v + ' : ' + typ.ptr_type + ';\n' 
		+ 'begin\n' 
		+ '\t' + v + ' := new ' + typ.name + '''(obj);\n' 
		+ '\treturn (' + v + ');\n' 
		+ 'end Copy;\n\n' 

		+ 'function Copy ( obj : in ' + typ.ptr_type + ' ) return ' + typ.ptr_type + ' is\n' 
		+ 'begin\n' 
		+ '\treturn copy(obj.all);\n' 
		+ 'end Copy;\n\n' 

		+ 'function XML_String(obj : in ' + typ.name + ') return Unbounded_String is\n' 
		+ '\tresult : Unbounded_String;\n' 
		+ 'begin\n' 
		+ '	result := to_unbounded_string("<' + typ.html_tag + '>");\n';

		REPEAT no := LOINDEX ( transl_attrs ) TO HIINDEX ( transl_attrs );
			ALIAS attr FOR transl_attrs [ no];
				acode := explicit_attribute_xml_writer_code ( 'obj', attr );
				IF ( acode > '' ) THEN
					code := code + '\t\t' + acode + '\n';
				END_IF;
			END_ALIAS;
		END_REPEAT;
		code := code + explicit_attribute_xml_writer_code ( 'obj', discrim_attr ) + '\n\n' 

		+ '\tcase obj.' + discrim_attr.name + ' is \n';

		REPEAT no := LOINDEX ( union_attributes ) TO HIINDEX ( union_attributes );
			ALIAS union_attr FOR union_attributes [ no];
				ALIAS ada_domain FOR basic_ada_domain ( union_attr.domain ).handled;
					ALIAS element_attributes FOR inherited_explicit_attributes ( ada_domain );
						code := code + '\t\twhen ' + union_attr.name + ' => \n';
						REPEAT noi := LOINDEX ( element_attributes ) TO HIINDEX ( element_attributes );
							ALIAS element_attr FOR element_attributes [ noi];
								acode := explicit_attribute_xml_writer_code ( 'obj', element_attr );
								IF ( acode > '' ) THEN
									code := code + '\t\t' + acode + '\n';
								END_IF;
							END_ALIAS;
						END_REPEAT;
					END_ALIAS;
				END_ALIAS;
			END_ALIAS;
			code := code + '\n';
		END_REPEAT;
		code := code + '\tend case;\n' 
		+ '\tresult := result & to_unbounded_string("</' + typ.html_tag + '>");\n' 
		+ '\treturn (result);\n' 
		+ 'end XML_String;\n\n' 

		+ 'function XML_String(obj : in ' + typ.name + '_Ptr) return Unbounded_String is\n' 
		+ 'begin\n' 
		+ '	return XML_String(obj.all);\n' 
		+ 'end XML_String;\n\n' 

		+ 'function XML_Ref_String(obj : in ' + typ.name + ') return Unbounded_String is\n' 
		+ '\tresult : Unbounded_String;\n' 
		+ 'begin\n' 
		+ '	raise xml_ref_string_error;\n' 
		+ '	return to_unbounded_string("");\n' 
		+ 'end XML_Ref_String;\n' 
		+ 'function XML_Ref_String(obj : in ' + typ.name + '_Ptr) return Unbounded_String is\n' 
		+ 'begin\n' 
		+ '	return XML_Ref_String(obj.all);\n' 
		+ 'end XML_Ref_String;\n\n';
		RETURN ( code );
	END_FUNCTION;

	FUNCTION discriminated_type_ads_code ( typ : discriminated_type ) : STRING;
		LOCAL 
			result : STRING;
			discrim_attr : attribute := typ.discriminant;
			discrim_type : entity_instance := discrim_attr.domain.handled;
			union_attr : attribute := typ.union_attr;
			union_type : defined_type := union_attr.domain.handled;
			union_selections : LIST OF attribute := inherited_explicit_attributes ( union_type );
			domain : entity_instance;
			transl_attrs : LIST OF attribute := typ.translated_attributes;
		END_LOCAL;
		result := 'type ' + typ.name + ' (' + discrim_attr.name + ' : ' + discrim_type.name + ' ) is record\n';

		REPEAT no := LOINDEX ( transl_attrs ) TO HIINDEX ( transl_attrs );
			ALIAS attr FOR transl_attrs [ no];
				domain := basic_ada_domain ( attr.domain );
				IF ( 'RECORD_AND_CLASS.ADA_CLASS' IN TYPEOF ( domain.handled ) ) THEN
					result := result + '\t' + attr.name + ' : ' + domain.handled.ptr_type + ';\n';
				ELSE
					result := result + '\t' + attr.name + ' : ' + domain.ada_ref_ident + ';\n';
				END_IF;
			END_ALIAS;
		END_REPEAT;
		result := result + '\tcase ' + discrim_attr.name + ' is \n' 
		+ union_type.union_ads_code + '\tend case;\nend record;\n\n' 

		+ 'type ' + typ.ptr_type + ' is access all ' + typ.name + ';\n' 
		+ '\nprocedure Initialize(obj : out ' + typ.ptr_type + ');\n' 
		+ '\nprocedure Put(obj : in ' + typ.ptr_type + ');\n' 
		+ 'function Copy(obj : in ' + typ.ptr_type + ') return ' + typ.ptr_type + ';\n' 
		+ 'function Copy(obj : in ' + typ.name + ') return ' + typ.ptr_type + ';\n' 
		+ 'function XML_String(obj : in ' + typ.name + ') return Unbounded_String;\n' 
		+ '\nfunction XML_String(obj : in ' + typ.ptr_type + ') return Unbounded_String;\n' 
		+ 'procedure Free  is new Unchecked_Deallocation (' + typ.name + ', ' + typ.ptr_type + ');\n' 
		+ 'function XML_Ref_String(obj : in ' + typ.name + ') return Unbounded_String;\n' 
		+ '\nfunction XML_Ref_String(obj : in ' + typ.ptr_type + ') return Unbounded_String;\n';
		RETURN ( result );
	END_FUNCTION;

	FUNCTION discriminated_type_union_case_code ( u : discriminated_type_union_type ) : STRING;
		LOCAL 
			code : STRING := '';
			all_attributes : LIST OF attribute := inherited_explicit_attributes ( u );
		END_LOCAL;

		REPEAT no := LOINDEX ( all_attributes ) TO HIINDEX ( all_attributes );
			ALIAS attr FOR all_attributes [ no];
				ALIAS ada_domain FOR basic_ada_domain ( attr.domain ).handled;
					code := code + '\t\twhen ' + attr.name + ' => \n ' + ada_domain.union_ads_code;
				END_ALIAS;
			END_ALIAS;
			code := code + '\n';
		END_REPEAT;
		RETURN ( code );
	END_FUNCTION;

	FUNCTION discriminated_type_union_element_case_code ( u : discriminated_type_union_element_type ) : STRING;
		LOCAL 
			code : STRING := '';
			all_attributes : LIST OF attribute := inherited_explicit_attributes ( u );
			domain : entity_instance;
		END_LOCAL;

		REPEAT no := LOINDEX ( all_attributes ) TO HIINDEX ( all_attributes );
			ALIAS attr FOR all_attributes [ no];
				domain := basic_ada_domain ( attr.domain );
				IF ( 'RECORD_AND_CLASS.ADA_CLASS' IN TYPEOF ( domain.handled ) ) THEN
					code := code + '\t\t\t' + attr.name + ' : ' + domain.handled.ptr_type + ';\n';
				ELSE
					code := code + '\t\t\t' + attr.name + ' : ' + domain.ada_ref_ident + ';\n';
				END_IF;
			END_ALIAS;
		END_REPEAT;
		RETURN ( code );
	END_FUNCTION;

	FUNCTION discriminated_type_xml_io_record_code ( typ : discriminated_type ) : STRING;
		LOCAL 
			code : STRING := '';
			discrim_attr : attribute := typ.discriminant;
			discrim_type : entity_instance := discrim_attr.domain.handled;
			union_attr : attribute := typ.union_attr;
			union_type : defined_type := union_attr.domain.handled;
			union_attributes : LIST OF attribute := inherited_explicit_attributes ( union_type );
			tails_attrs : LIST OF attribute := typ.tail_attributes;
			transl_attrs : LIST OF attribute := typ.translated_attributes;
		END_LOCAL;
		code := '\ntype ' + typ.name + '_io is record' + '\n\t' + discrim_attr.name + ' : ' + discrim_type.name + ';';

		REPEAT no := LOINDEX ( transl_attrs ) TO HIINDEX ( transl_attrs );
			ALIAS attr FOR transl_attrs [ no];
				code := code + explicit_attribute_xml_io_record_code ( attr );
			END_ALIAS;
		END_REPEAT;

		REPEAT no := LOINDEX ( tails_attrs ) TO HIINDEX ( tails_attrs );
			ALIAS attr FOR tails_attrs [ no];
				code := code + explicit_attribute_xml_io_record_code ( attr );
			END_ALIAS;
		END_REPEAT;
		code := code + '\nend record;\n';
		RETURN ( code );
	END_FUNCTION;

	FUNCTION discriminated_type_tails_attributes ( typ : discriminated_type ) : LIST OF attribute;
		LOCAL 
			union_attr : attribute := typ.union_attr;
			union_type : defined_type := union_attr.domain.handled;
			union_attributes : LIST OF attribute := inherited_explicit_attributes ( union_type );
			found : LIST OF attribute := [ ];
		END_LOCAL;

		REPEAT no := LOINDEX ( union_attributes ) TO HIINDEX ( union_attributes );
			ALIAS curr FOR union_attributes [ no];
				ALIAS handled FOR curr.domain.handled;
					found := found + inherited_explicit_attributes ( handled );
				END_ALIAS;
			END_ALIAS;
		END_REPEAT;
		RETURN ( found );
	END_FUNCTION;

	FUNCTION discriminated_type_xml_end_element_code ( typ : discriminated_type ) : STRING;
		RETURN ( '\nprocedure End_Element(\n' 
			+ '\tHandler : in out Xml_generic_parser;\n' 
			+ '\tobj : in out ' + typ.name + '_io;\n' 
			+ '\tNamespace_Uri : Unicode.CES.Byte_Sequence := "";\n' 
			+ '\tLocal_Name    : Unicode.CES.Byte_Sequence := "";\n' 
			+ '\tQname : Unicode.CES.Byte_Sequence := "") is \nbegin\n' 
			+ discriminated_type_attributes_xml_end_element_code ( typ ) + '\nend End_Element;\n' );
	END_FUNCTION;

	FUNCTION discriminated_type_xml_start_element_code ( typ : discriminated_type ) : STRING;
		LOCAL 
			code : STRING := discriminated_type_attributes_xml_start_element_code ( typ );
		END_LOCAL;

		IF ( code > '' ) THEN
			code := '\nprocedure Start_Element(\n' 
			+ '\tHandler: in out Xml_Generic_Parser;\n' 
			+ '\tobj : in out ' + typ.name + '_io;\n' 
			+ '\tNamespace_Uri : Unicode.CES.Byte_Sequence := "";\n' 
			+ '\tLocal_Name : Unicode.CES.Byte_Sequence := "";\n' 
			+ '\tQname : Unicode.CES.Byte_Sequence := "";\n' 
			+ '\tAtts : Sax.Attributes.Attributes''Class) is \nbegin\n' 
			+ '\tif Get_Length (Atts) > 0 then' + code + '\n' 
			+ '\tend if;\n' 
			+ 'end Start_Element;\n';
		END_IF;
		RETURN ( code );
	END_FUNCTION;

	FUNCTION discriminated_type_attributes_xml_end_element_code ( typ : discriminated_type ) : STRING;
		LOCAL 
			code : STRING := '';
			s : STRING;
			discrim_attr : attribute := typ.discriminant;
			attrs : LIST OF attribute := typ.tail_attributes + typ.translated_attributes;
		END_LOCAL;
		code := code + explicit_attribute_xml_end_element_code ( discrim_attr ) + '\n';

		REPEAT no := LOINDEX ( attrs ) TO HIINDEX ( attrs );
			ALIAS attr FOR attrs [ no];
				s := explicit_attribute_xml_end_element_code ( attr );
				IF ( s > '' ) THEN
					code := code + '\n' 
					+ s;
				END_IF;
			END_ALIAS;
		END_REPEAT;

		IF ( code = '' ) THEN
			code := '\tnull;\n';
		END_IF;
		RETURN ( code );
	END_FUNCTION;

	FUNCTION discriminated_type_attributes_xml_start_element_code ( typ : discriminated_type ) : STRING;
		LOCAL 
			code : STRING := '';
			s : STRING;
			discrim_attr : attribute := typ.discriminant;
			attrs : LIST OF attribute := typ.tail_attributes + typ.translated_attributes;
		END_LOCAL;
		code := explicit_attribute_xml_start_element_code ( discrim_attr );

		REPEAT no := LOINDEX ( attrs ) TO HIINDEX ( attrs );
			ALIAS attr FOR attrs [ no];
				s := explicit_attribute_xml_start_element_code ( attr );
				IF ( s > '' ) THEN
					code := code + '\n' 
					+ s;
				END_IF;
			END_ALIAS;
		END_REPEAT;
		RETURN ( code );
	END_FUNCTION;

	FUNCTION discriminated_type_attributes_xml_io_record_initialize_code ( typ : discriminated_type ) : STRING;
		LOCAL 
			code : STRING := '';
			s : STRING;
			discrim_attr : attribute := typ.discriminant;
			attrs : LIST OF attribute := typ.tail_attributes + typ.translated_attributes;
		END_LOCAL;
		code := code + explicit_attribute_xml_io_record_initialize_code ( discrim_attr ) + '\n';

		REPEAT no := LOINDEX ( attrs ) TO HIINDEX ( attrs );
			ALIAS attr FOR attrs [ no];
				s := explicit_attribute_xml_io_record_initialize_code ( attr );
				IF ( s > '' ) THEN
					code := code + '\n' 
					+ s;
				END_IF;
			END_ALIAS;
		END_REPEAT;
		RETURN ( code );
	END_FUNCTION;

	FUNCTION discriminated_type_xml_io_record_initialize_code ( typ : discriminated_type ) : STRING;
		RETURN ( '\nprocedure Initialize(obj : out ' + typ.name + '_io) is \nbegin ' + discriminated_type_attributes_xml_io_record_initialize_code ( typ ) + '\nend Initialize;\n' );
	END_FUNCTION;
END_SCHEMA;


</ISO10303-11-EXPRESS>!

!ExChdExpress2cheddarSchemaInstance class methodsFor: 'platypus-generated-initializing' stamp: ''!
initialize
	self reinitializeSingleton.
	self singleton buildIndexes

! !

!ExChdExpress2cheddarSchemaInstance class methodsFor: 'platypus-generated-platypus-signature' stamp: ''!
iso10303P11Translater
	^ 'Platypus (c) LISYC EA3883, Universite de Bretagne occidentale. Brest.'

! !

!ExChdExpress2cheddarSchemaInstance class methodsFor: 'platypus-generated-platypus-signature' stamp: ''!
translatedFromISO10303P11
	^ true

! !

!ExChdExpress2cheddarSchemaInstance class methodsFor: 'platypus-generated-platypus-signature' stamp: ''!
vwNamespaceName
	^ #Express2Cheddar

! !

!ExChdExpress2cheddarSchemaInstance methodsFor: 'platypus-generated-context-accessing' stamp: ''!
context
	^ context

! !

!ExChdExpress2cheddarSchemaInstance methodsFor: 'platypus-generated-context-accessing' stamp: ''!
context: aContext
	context := aContext.
	super context: aContext

! !

!ExChdExpress2cheddarSchemaInstance methodsFor: 'platypus-generated-accessing' stamp: ''!
externalSchemaInstanceClassNames
	^ #(#PltPlatypusMetaSchemasSchemaInstance #PTsExpressToolsboxSchemaInstance)

! !

!ExChdExpress2cheddarSchemaInstance methodsFor: 'platypus-generated-accessing' stamp: ''!
namesBuilder
	| namesBuilder |
	namesBuilder := self namesBuilderClass new.
	namesBuilder classPrefix: 'ExChd'.
	namesBuilder systemCategoryPrefix: 'Express2Cheddar'.
	namesBuilder rootClassName: 'ExChdCoreEntity'.
	namesBuilder rootClassSystemCategory: 'Express2Cheddar'.
	^ namesBuilder

! !

!ExChdExpress2cheddarSchemaInstance methodsFor: 'platypus-generated-accessing' stamp: ''!
namesBuilderClassName
	^ #PlatypusNamesBuilder

! !

!ExChdExpress2cheddarSchemaInstance methodsFor: 'platypus-generated-accessing' stamp: ''!
repositoryClassName
	^ #ExChdExpress2cheddarRepository

! !

!ExChdExpress2cheddarSchemaInstance methodsFor: 'platypus-generated-schemata-accessing' stamp: ''!
schemaDefinition1
	^ #(#express2cheddar_facade #ExChdExpress2cheddarFacadeSchemaDefinition)

! !

!ExChdExpress2cheddarSchemaInstance methodsFor: 'platypus-generated-schemata-accessing' stamp: ''!
schemaDefinition2
	^ #(#cheddar_dtd #ExChdCheddarDtdSchemaDefinition)

! !

!ExChdExpress2cheddarSchemaInstance methodsFor: 'platypus-generated-schemata-accessing' stamp: ''!
schemaDefinition3
	^ #(#ada_interface #ExChdAdaInterfaceSchemaDefinition)

! !

!ExChdExpress2cheddarSchemaInstance methodsFor: 'platypus-generated-schemata-accessing' stamp: ''!
schemaDefinition4
	^ #(#xml_io #ExChdXmlIoSchemaDefinition)

! !

!ExChdExpress2cheddarSchemaInstance methodsFor: 'platypus-generated-schemata-accessing' stamp: ''!
schemaDefinition5
	^ #(#cheddar_domains #ExChdCheddarDomainsSchemaDefinition)

! !

!ExChdExpress2cheddarSchemaInstance methodsFor: 'platypus-generated-schemata-accessing' stamp: ''!
schemaDefinition6
	^ #(#cheddar_constants #ExChdCheddarConstantsSchemaDefinition)

! !

!ExChdExpress2cheddarSchemaInstance methodsFor: 'platypus-generated-schemata-accessing' stamp: ''!
schemaDefinition7
	^ #(#record_and_class #ExChdRecordAndClassSchemaDefinition)

! !

!ExChdExpress2cheddarSchemaInstance methodsFor: 'platypus-generated-schemata-accessing' stamp: ''!
schemaDefinition8
	^ #(#package #ExChdPackageSchemaDefinition)

! !

!ExChdExpress2cheddarSchemaInstance methodsFor: 'platypus-generated-schemata-accessing' stamp: ''!
schemaDefinition9
	^ #(#discriminated_type #ExChdDiscriminatedTypeSchemaDefinition)

! !

!ExChdExpress2cheddarSchemaInstance methodsFor: 'platypus-generated-schemata-accessing' stamp: ''!
schemaDefinitionCount
	^ 9

! !

PltDictionaryInstance subclass: #ExChdBasicAdaTypeValueFormat
	instanceVariableNames: 'basicAdaType val'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Express2Cheddar-CheddarDomainsSchema'!

!ExChdBasicAdaTypeValueFormat commentStamp: 'platypus comment' prior: 0!
<ISO10303-11-EXPRESS>
ENTITY basic_ada_type_value_format 
	SUBTYPE OF ( dictionary_instance );
	val : expression;
	basic_ada_type : OPTIONAL dictionary_instance;
DERIVE
	formated : STRING := basic_ada_expression_value_string ( SELF.val );
END_ENTITY;
</ISO10303-11-EXPRESS>!

!ExChdBasicAdaTypeValueFormat class methodsFor: 'platypus-generated-platypus-signature' stamp: ''!
iso10303P11Translater
	^ 'Platypus (c) LISYC EA3883, Universite de Bretagne occidentale. Brest.'

! !

!ExChdBasicAdaTypeValueFormat class methodsFor: 'platypus-generated-meta-data-accessing' stamp: ''!
schemaDefinition
	^ ExChdCheddarDomainsSchemaDefinition singleton

! !

!ExChdBasicAdaTypeValueFormat class methodsFor: 'platypus-generated-meta-data-accessing' stamp: ''!
schemaInstance
	^ ExChdExpress2cheddarSchemaInstance singleton

! !

!ExChdBasicAdaTypeValueFormat class methodsFor: 'platypus-generated-platypus-signature' stamp: ''!
translatedFromISO10303P11
	^ true

! !

!ExChdBasicAdaTypeValueFormat class methodsFor: 'platypus-generated-platypus-signature' stamp: ''!
vwNamespaceName
	^ #Express2Cheddar

! !

!ExChdBasicAdaTypeValueFormat methodsFor: 'platypus-generated-visiting' stamp: ''!
accept: aVisitor
	^ aVisitor acceptBasicAdaTypeValueFormat: self

! !

!ExChdBasicAdaTypeValueFormat methodsFor: 'platypus-generated-accessing' stamp: ''!
basicAdaType
	^ basicAdaType

! !

!ExChdBasicAdaTypeValueFormat methodsFor: 'platypus-generated-accessing' stamp: ''!
basicAdaType: aExChdDictionaryInstance
	basicAdaType := aExChdDictionaryInstance

! !

!ExChdBasicAdaTypeValueFormat methodsFor: 'platypus-generated-with-context-accessing' stamp: ''!
basicAdaTypeUsingContext: aContext
	^ self basicAdaType

! !

!ExChdBasicAdaTypeValueFormat methodsFor: 'platypus-generated-copying' stamp: ''!
basicAdaTypeValueFormatCopyTo: another
	another fastSetVal: self val.
	another fastSetBasicAdaType: self basicAdaType

! !

!ExChdBasicAdaTypeValueFormat methodsFor: 'platypus-generated-group-accessing' stamp: ''!
basicAdaTypeValueFormatFromValues: values
	| valuesloc |
	valuesloc := values asOrderedCollection.
	self setVal: valuesloc removeFirst.
	self setBasicAdaType: valuesloc removeFirst.
	^ valuesloc

! !

!ExChdBasicAdaTypeValueFormat methodsFor: 'platypus-generated-group-accessing' stamp: ''!
basicAdaTypeValueFormatToValues: values
	values add: self val.
	values add: self basicAdaType.
	^ values

! !

!ExChdBasicAdaTypeValueFormat methodsFor: 'platypus-generated-fast-set-accessing' stamp: ''!
fastSetBasicAdaType: aExChdDictionaryInstance
	basicAdaType := aExChdDictionaryInstance

! !

!ExChdBasicAdaTypeValueFormat methodsFor: 'platypus-generated-fast-set-accessing' stamp: ''!
fastSetVal: aExChdExpression
	val := aExChdExpression

! !

!ExChdBasicAdaTypeValueFormat methodsFor: 'platypus-generated-deriving' stamp: ''!
formated
	^ self formatedUsingContext: self class context

! !

!ExChdBasicAdaTypeValueFormat methodsFor: 'platypus-generated-deriving' stamp: ''!
formatedUsingContext: aContext
	^ self formatedUsingContext: aContext receiver: self

! !

!ExChdBasicAdaTypeValueFormat methodsFor: 'platypus-generated-deriving' stamp: ''!
formatedUsingContext: aContext receiver: aReceiver
	^ ExChdBasicAdaExpressionValueStringFunction
		invokeFromValues:
			(OrderedCollection new
				add: (aReceiver valUsingContext: self class context);
				yourself)

! !

!ExChdBasicAdaTypeValueFormat methodsFor: 'platypus-generated-group-accessing' stamp: ''!
fromValues: values
	^ self basicAdaTypeValueFormatFromValues: (super fromValues: values)

! !

!ExChdBasicAdaTypeValueFormat methodsFor: 'platypus-generated-classifying' stamp: ''!
isExChdBasicAdaTypeValueFormat
	^ true

! !

!ExChdBasicAdaTypeValueFormat methodsFor: 'platypus-generated-group-accessing' stamp: ''!
localFromValues: values
	^ self basicAdaTypeValueFormatFromValues: values

! !

!ExChdBasicAdaTypeValueFormat methodsFor: 'platypus-generated-group-accessing' stamp: ''!
localToValues: values
	^ self basicAdaTypeValueFormatToValues: values

! !

!ExChdBasicAdaTypeValueFormat methodsFor: 'platypus-generated-copying' stamp: ''!
pltCopyGroup: aClassSymbol to: anObject
	self class name == aClassSymbol
		ifTrue: [ self pltCopyTo: anObject ]
		ifFalse: [ super pltCopyGroup: aClassSymbol to: anObject ]

! !

!ExChdBasicAdaTypeValueFormat methodsFor: 'platypus-generated-copying' stamp: ''!
pltCopyTo: another
	super pltCopyTo: another.
	self basicAdaTypeValueFormatCopyTo: another

! !

!ExChdBasicAdaTypeValueFormat methodsFor: 'platypus-generated-copying' stamp: ''!
pltLocalCopyTo: another
	self basicAdaTypeValueFormatCopyTo: another

! !

!ExChdBasicAdaTypeValueFormat methodsFor: 'platypus-generated-set-accessing' stamp: ''!
setBasicAdaType: aExChdDictionaryInstance
	self basicAdaType: aExChdDictionaryInstance

! !

!ExChdBasicAdaTypeValueFormat methodsFor: 'platypus-generated-set-accessing' stamp: ''!
setVal: aExChdExpression
	self val: aExChdExpression

! !

!ExChdBasicAdaTypeValueFormat methodsFor: 'platypus-generated-initializing' stamp: ''!
stepInitialize
	super stepInitialize.
	val := nil.
	basicAdaType := nil

! !

!ExChdBasicAdaTypeValueFormat methodsFor: 'platypus-generated-group-accessing' stamp: ''!
toValues: values
	^ self basicAdaTypeValueFormatToValues: (super toValues: values)

! !

!ExChdBasicAdaTypeValueFormat methodsFor: 'platypus-generated-accessing' stamp: ''!
val
	^ val

! !

!ExChdBasicAdaTypeValueFormat methodsFor: 'platypus-generated-accessing' stamp: ''!
val: aExChdExpression
	val := aExChdExpression

! !

!ExChdBasicAdaTypeValueFormat methodsFor: 'platypus-generated-with-context-accessing' stamp: ''!
valUsingContext: aContext
	^ self val

! !

PltArrayType subclass: #ExChdAdaArrayType
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Express2Cheddar-CheddarDomainsSchema'!

!ExChdAdaArrayType commentStamp: 'platypus comment' prior: 0!
<ISO10303-11-EXPRESS>
ENTITY ada_array_type 
	SUBTYPE OF ( array_type );
DERIVE
	ads_interfaces_list : LIST OF ada_interface := std_io_interfaces;
	adb_interfaces_list : LIST OF ada_interface := [ ];
	ada_ident : STRING := ?;
	ada_ref_ident : STRING := SELF.ada_ident;
	init_value : STRING := ?;
END_ENTITY;
</ISO10303-11-EXPRESS>!

!ExChdAdaArrayType class methodsFor: 'platypus-generated-platypus-signature' stamp: ''!
iso10303P11Translater
	^ 'Platypus (c) LISYC EA3883, Universite de Bretagne occidentale. Brest.'

! !

!ExChdAdaArrayType class methodsFor: 'platypus-generated-meta-data-accessing' stamp: ''!
schemaDefinition
	^ ExChdCheddarDomainsSchemaDefinition singleton

! !

!ExChdAdaArrayType class methodsFor: 'platypus-generated-meta-data-accessing' stamp: ''!
schemaInstance
	^ ExChdExpress2cheddarSchemaInstance singleton

! !

!ExChdAdaArrayType class methodsFor: 'platypus-generated-platypus-signature' stamp: ''!
translatedFromISO10303P11
	^ true

! !

!ExChdAdaArrayType class methodsFor: 'platypus-generated-platypus-signature' stamp: ''!
vwNamespaceName
	^ #Express2Cheddar

! !

!ExChdAdaArrayType methodsFor: 'platypus-generated-visiting' stamp: ''!
accept: aVisitor
	^ aVisitor acceptAdaArrayType: self

! !

!ExChdAdaArrayType methodsFor: 'platypus-generated-copying' stamp: ''!
adaArrayTypeCopyTo: another
	

! !

!ExChdAdaArrayType methodsFor: 'platypus-generated-group-accessing' stamp: ''!
adaArrayTypeFromValues: values
	| valuesloc |
	valuesloc := values asOrderedCollection.
	^ valuesloc

! !

!ExChdAdaArrayType methodsFor: 'platypus-generated-group-accessing' stamp: ''!
adaArrayTypeToValues: values
	^ values

! !

!ExChdAdaArrayType methodsFor: 'platypus-generated-deriving' stamp: ''!
adaIdent
	^ self adaIdentUsingContext: self class context

! !

!ExChdAdaArrayType methodsFor: 'platypus-generated-deriving' stamp: ''!
adaIdentUsingContext: aContext
	^ self adaIdentUsingContext: aContext receiver: self

! !

!ExChdAdaArrayType methodsFor: 'platypus-generated-deriving' stamp: ''!
adaIdentUsingContext: aContext receiver: aReceiver
	^ nil

! !

!ExChdAdaArrayType methodsFor: 'platypus-generated-deriving' stamp: ''!
adaRefIdent
	^ self adaRefIdentUsingContext: self class context

! !

!ExChdAdaArrayType methodsFor: 'platypus-generated-deriving' stamp: ''!
adaRefIdentUsingContext: aContext
	^ self adaRefIdentUsingContext: aContext receiver: self

! !

!ExChdAdaArrayType methodsFor: 'platypus-generated-deriving' stamp: ''!
adaRefIdentUsingContext: aContext receiver: aReceiver
	^ aReceiver adaIdentUsingContext: aContext

! !

!ExChdAdaArrayType methodsFor: 'platypus-generated-deriving' stamp: ''!
adbInterfacesList
	^ self adbInterfacesListUsingContext: self class context

! !

!ExChdAdaArrayType methodsFor: 'platypus-generated-deriving' stamp: ''!
adbInterfacesListUsingContext: aContext
	^ self adbInterfacesListUsingContext: aContext receiver: self

! !

!ExChdAdaArrayType methodsFor: 'platypus-generated-deriving' stamp: ''!
adbInterfacesListUsingContext: aContext receiver: aReceiver
	^ Array new

! !

!ExChdAdaArrayType methodsFor: 'platypus-generated-deriving' stamp: ''!
adsInterfacesList
	^ self adsInterfacesListUsingContext: self class context

! !

!ExChdAdaArrayType methodsFor: 'platypus-generated-deriving' stamp: ''!
adsInterfacesListUsingContext: aContext
	^ self adsInterfacesListUsingContext: aContext receiver: self

! !

!ExChdAdaArrayType methodsFor: 'platypus-generated-deriving' stamp: ''!
adsInterfacesListUsingContext: aContext receiver: aReceiver
	^ PlatypusCoreAggregateInitializer
		collectionFrom:
			(OrderedCollection new
				add:
						(ExChdAdaInterface new
								adaInterfaceFromValues:
										(OrderedCollection new
												add: 'standards_io';
												add: nil;
												add: true;
												add: true;
												yourself);
								yourself);
				yourself)

! !

!ExChdAdaArrayType methodsFor: 'platypus-generated-group-accessing' stamp: ''!
fromValues: values
	^ self adaArrayTypeFromValues: (super fromValues: values)

! !

!ExChdAdaArrayType methodsFor: 'platypus-generated-deriving' stamp: ''!
initValue
	^ self initValueUsingContext: self class context

! !

!ExChdAdaArrayType methodsFor: 'platypus-generated-deriving' stamp: ''!
initValueUsingContext: aContext
	^ self initValueUsingContext: aContext receiver: self

! !

!ExChdAdaArrayType methodsFor: 'platypus-generated-deriving' stamp: ''!
initValueUsingContext: aContext receiver: aReceiver
	^ nil

! !

!ExChdAdaArrayType methodsFor: 'platypus-generated-classifying' stamp: ''!
isExChdAdaArrayType
	^ true

! !

!ExChdAdaArrayType methodsFor: 'platypus-generated-group-accessing' stamp: ''!
localFromValues: values
	^ self adaArrayTypeFromValues: values

! !

!ExChdAdaArrayType methodsFor: 'platypus-generated-group-accessing' stamp: ''!
localToValues: values
	^ self adaArrayTypeToValues: values

! !

!ExChdAdaArrayType methodsFor: 'platypus-generated-copying' stamp: ''!
pltCopyGroup: aClassSymbol to: anObject
	self class name == aClassSymbol
		ifTrue: [ self pltCopyTo: anObject ]
		ifFalse: [ super pltCopyGroup: aClassSymbol to: anObject ]

! !

!ExChdAdaArrayType methodsFor: 'platypus-generated-copying' stamp: ''!
pltCopyTo: another
	super pltCopyTo: another.
	self adaArrayTypeCopyTo: another

! !

!ExChdAdaArrayType methodsFor: 'platypus-generated-copying' stamp: ''!
pltLocalCopyTo: another
	self adaArrayTypeCopyTo: another

! !

!ExChdAdaArrayType methodsFor: 'platypus-generated-initializing' stamp: ''!
stepInitialize
	super stepInitialize

! !

!ExChdAdaArrayType methodsFor: 'platypus-generated-group-accessing' stamp: ''!
toValues: values
	^ self adaArrayTypeToValues: (super toValues: values)

! !

PltBagType subclass: #ExChdAdaBagType
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Express2Cheddar-CheddarDomainsSchema'!

!ExChdAdaBagType commentStamp: 'platypus comment' prior: 0!
<ISO10303-11-EXPRESS>
ENTITY ada_bag_type 
	SUBTYPE OF ( bag_type );
DERIVE
	ads_interfaces_list : LIST OF ada_interface := std_io_interfaces;
	adb_interfaces_list : LIST OF ada_interface := [ ];
	ada_ident : STRING := 'bag';
	ada_ref_ident : STRING := SELF.ada_ident;
END_ENTITY;
</ISO10303-11-EXPRESS>!

!ExChdAdaBagType class methodsFor: 'platypus-generated-platypus-signature' stamp: ''!
iso10303P11Translater
	^ 'Platypus (c) LISYC EA3883, Universite de Bretagne occidentale. Brest.'

! !

!ExChdAdaBagType class methodsFor: 'platypus-generated-meta-data-accessing' stamp: ''!
schemaDefinition
	^ ExChdCheddarDomainsSchemaDefinition singleton

! !

!ExChdAdaBagType class methodsFor: 'platypus-generated-meta-data-accessing' stamp: ''!
schemaInstance
	^ ExChdExpress2cheddarSchemaInstance singleton

! !

!ExChdAdaBagType class methodsFor: 'platypus-generated-platypus-signature' stamp: ''!
translatedFromISO10303P11
	^ true

! !

!ExChdAdaBagType class methodsFor: 'platypus-generated-platypus-signature' stamp: ''!
vwNamespaceName
	^ #Express2Cheddar

! !

!ExChdAdaBagType methodsFor: 'platypus-generated-visiting' stamp: ''!
accept: aVisitor
	^ aVisitor acceptAdaBagType: self

! !

!ExChdAdaBagType methodsFor: 'platypus-generated-copying' stamp: ''!
adaBagTypeCopyTo: another
	

! !

!ExChdAdaBagType methodsFor: 'platypus-generated-group-accessing' stamp: ''!
adaBagTypeFromValues: values
	| valuesloc |
	valuesloc := values asOrderedCollection.
	^ valuesloc

! !

!ExChdAdaBagType methodsFor: 'platypus-generated-group-accessing' stamp: ''!
adaBagTypeToValues: values
	^ values

! !

!ExChdAdaBagType methodsFor: 'platypus-generated-deriving' stamp: ''!
adaIdent
	^ self adaIdentUsingContext: self class context

! !

!ExChdAdaBagType methodsFor: 'platypus-generated-deriving' stamp: ''!
adaIdentUsingContext: aContext
	^ self adaIdentUsingContext: aContext receiver: self

! !

!ExChdAdaBagType methodsFor: 'platypus-generated-deriving' stamp: ''!
adaIdentUsingContext: aContext receiver: aReceiver
	^ 'bag'

! !

!ExChdAdaBagType methodsFor: 'platypus-generated-deriving' stamp: ''!
adaRefIdent
	^ self adaRefIdentUsingContext: self class context

! !

!ExChdAdaBagType methodsFor: 'platypus-generated-deriving' stamp: ''!
adaRefIdentUsingContext: aContext
	^ self adaRefIdentUsingContext: aContext receiver: self

! !

!ExChdAdaBagType methodsFor: 'platypus-generated-deriving' stamp: ''!
adaRefIdentUsingContext: aContext receiver: aReceiver
	^ aReceiver adaIdentUsingContext: aContext

! !

!ExChdAdaBagType methodsFor: 'platypus-generated-deriving' stamp: ''!
adbInterfacesList
	^ self adbInterfacesListUsingContext: self class context

! !

!ExChdAdaBagType methodsFor: 'platypus-generated-deriving' stamp: ''!
adbInterfacesListUsingContext: aContext
	^ self adbInterfacesListUsingContext: aContext receiver: self

! !

!ExChdAdaBagType methodsFor: 'platypus-generated-deriving' stamp: ''!
adbInterfacesListUsingContext: aContext receiver: aReceiver
	^ Array new

! !

!ExChdAdaBagType methodsFor: 'platypus-generated-deriving' stamp: ''!
adsInterfacesList
	^ self adsInterfacesListUsingContext: self class context

! !

!ExChdAdaBagType methodsFor: 'platypus-generated-deriving' stamp: ''!
adsInterfacesListUsingContext: aContext
	^ self adsInterfacesListUsingContext: aContext receiver: self

! !

!ExChdAdaBagType methodsFor: 'platypus-generated-deriving' stamp: ''!
adsInterfacesListUsingContext: aContext receiver: aReceiver
	^ PlatypusCoreAggregateInitializer
		collectionFrom:
			(OrderedCollection new
				add:
						(ExChdAdaInterface new
								adaInterfaceFromValues:
										(OrderedCollection new
												add: 'standards_io';
												add: nil;
												add: true;
												add: true;
												yourself);
								yourself);
				yourself)

! !

!ExChdAdaBagType methodsFor: 'platypus-generated-group-accessing' stamp: ''!
fromValues: values
	^ self adaBagTypeFromValues: (super fromValues: values)

! !

!ExChdAdaBagType methodsFor: 'platypus-generated-classifying' stamp: ''!
isExChdAdaBagType
	^ true

! !

!ExChdAdaBagType methodsFor: 'platypus-generated-group-accessing' stamp: ''!
localFromValues: values
	^ self adaBagTypeFromValues: values

! !

!ExChdAdaBagType methodsFor: 'platypus-generated-group-accessing' stamp: ''!
localToValues: values
	^ self adaBagTypeToValues: values

! !

!ExChdAdaBagType methodsFor: 'platypus-generated-copying' stamp: ''!
pltCopyGroup: aClassSymbol to: anObject
	self class name == aClassSymbol
		ifTrue: [ self pltCopyTo: anObject ]
		ifFalse: [ super pltCopyGroup: aClassSymbol to: anObject ]

! !

!ExChdAdaBagType methodsFor: 'platypus-generated-copying' stamp: ''!
pltCopyTo: another
	super pltCopyTo: another.
	self adaBagTypeCopyTo: another

! !

!ExChdAdaBagType methodsFor: 'platypus-generated-copying' stamp: ''!
pltLocalCopyTo: another
	self adaBagTypeCopyTo: another

! !

!ExChdAdaBagType methodsFor: 'platypus-generated-initializing' stamp: ''!
stepInitialize
	super stepInitialize

! !

!ExChdAdaBagType methodsFor: 'platypus-generated-group-accessing' stamp: ''!
toValues: values
	^ self adaBagTypeToValues: (super toValues: values)

! !

Object subclass: #CheddarGenerator
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Express2Cheddar-scripts'!

!CheddarGenerator class methodsFor: 'platypus2Cheddar' stamp: 'AlainPlantec 2/23/2015 11:00'!
generate
	self generateInto: 'generated-code'! !

!CheddarGenerator class methodsFor: 'platypus2Cheddar' stamp: 'AlainPlantec 2/24/2015 13:16'!
generateInto: aPathString
	Cursor wait
		showWhile: [ 
			| map exp2Chd |
			map := Platypus itemNamed: 'cheddar_mapping'.
			exp2Chd := Platypus itemNamed: 'express2cheddar'.
			exp2Chd removeAllModelContents.
			exp2Chd promote: map.
			Cursor wait
				showWhile: [ 
					ExChdGenerateAllIntoProcedure 
						invokeOnContextStream: exp2Chd masterModelAsStepStream 
						fromValues: {aPathString} ] ]! !

Object subclass: #CheddarUMLGen
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Express2Cheddar-scripts'!

!CheddarUMLGen class methodsFor: 'as yet unclassified' stamp: 'AlainPlantec 2/24/2015 13:17'!
all
	"self all"
	"self allFor: ChdModelGenericObject.
	self allFor: ChdLangGenericExpression.
	self allFor: ChdLangGenericStatement."

	! !

!CheddarUMLGen class methodsFor: 'as yet unclassified' stamp: 'AlainPlantec 4/13/2011 09:58'!
allFor: rootClass
	self byPackage: rootClass.
	self simple: rootClass.
	self withInstVars: rootClass! !

!CheddarUMLGen class methodsFor: 'as yet unclassified' stamp: 'AlainPlantec 4/13/2011 09:54'!
byPackage
	| d s f |
	d := Dictionary new.
	Morph
		allSubclassesDo: [:cls |  
			| pkgname |
			pkgname := (PackageOrganizer default mostSpecificPackageOfClass: cls) packageName.
			s := d at: pkgname ifAbsentPut: Set new.
			s add: cls].
	s := String
				streamContents: [:strm | 
					strm nextPutAll: '@startuml'.
					strm cr.
					d
						keysAndValuesDo: [:k :v | 
							strm nextPutAll: 'package "' , k , '"'.
							strm cr.
							v
								do: [:cls | 
									strm nextPutAll: String tab , cls superclass name.
									strm nextPutAll: ' <|-- '.
									strm nextPutAll: cls name.
									strm cr].
							strm nextPutAll: 'end package'.
							strm cr].
					strm nextPutAll: 'hide circle'.
					strm cr.
					strm nextPutAll: 'hide method'.
					strm cr.
					strm nextPutAll: '@enduml'.
					strm cr].
	f := StandardFileStream forceNewFileNamed: 'MorphHierarchyByPackage.txt'.
	f nextPutAll: s.
	f close! !

!CheddarUMLGen class methodsFor: 'as yet unclassified' stamp: 'AlainPlantec 4/13/2011 09:57'!
byPackage: rootClass
	| d s f |
	d := Dictionary new.
	rootClass
		allSubclassesDo: [:cls |  
			| pkgname |
			pkgname := (PackageOrganizer default mostSpecificPackageOfClass: cls) packageName.
			s := d at: pkgname ifAbsentPut: Set new.
			s add: cls].
	s := String
				streamContents: [:strm | 
					strm nextPutAll: '@startuml'.
					strm cr.
					d
						keysAndValuesDo: [:k :v | 
							strm nextPutAll: 'package "' , k , '"'.
							strm cr.
							v
								do: [:cls | 
									strm nextPutAll: String tab , cls superclass name.
									strm nextPutAll: ' <|-- '.
									strm nextPutAll: cls name.
									strm cr].
							strm nextPutAll: 'end package'.
							strm cr].
					strm nextPutAll: 'hide circle'.
					strm cr.
					strm nextPutAll: 'hide method'.
					strm cr.
					strm nextPutAll: '@enduml'.
					strm cr].
	f := StandardFileStream forceNewFileNamed: rootClass name, 'HierarchyByPackage.txt'.
	f nextPutAll: s.
	f close! !

!CheddarUMLGen class methodsFor: 'as yet unclassified' stamp: 'AlainPlantec 4/13/2011 09:56'!
simple: rootClass
	| s f |
	s := String
				streamContents: [:strm |  
					strm nextPutAll: '@startuml'.
					strm cr.
					rootClass
						allSubclassesDo: [:cls | 
							strm nextPutAll: cls superclass name.
							strm nextPutAll: ' <|-- '.
							strm nextPutAll: cls name.
							strm cr].
					strm cr.
					strm nextPutAll: 'hide circle'.
					strm cr.
					strm nextPutAll: 'hide method'.
					strm cr.
					strm nextPutAll: '@enduml'.
					strm cr].
	f := StandardFileStream forceNewFileNamed: rootClass name, 'Hierarchy.txt'.
	f nextPutAll: s.
	f close! !

!CheddarUMLGen class methodsFor: 'as yet unclassified' stamp: 'AlainPlantec 4/13/2011 09:56'!
withInstVars: rootClass
	| s f |
	s := String
				streamContents: [:strm | 
					strm nextPutAll: '@startuml'.
					strm cr. 
					rootClass
						allSubclassesDo: [:cls | 
							strm nextPutAll: cls superclass name.
							strm nextPutAll: ' <|-- '.
							strm nextPutAll: cls name.
							strm cr].
					strm cr.
					rootClass
						allSubclassesDo: [:cls | cls instVarNames notEmpty
								ifTrue: [cls instVarNames
										do: [:n | 
											strm nextPutAll: cls name.
											strm nextPutAll: ' : '.
											strm nextPutAll: n]
										separatedBy: [strm cr].
									strm cr]].
					strm nextPutAll: 'hide circle'.
					strm cr.
					strm nextPutAll: 'hide method'.
					strm cr.
					strm nextPutAll: '@enduml'.
					strm cr].
	f := StandardFileStream forceNewFileNamed: rootClass name, 'HierarchyWithInstVars.txt'.
	f nextPutAll: s.
	f close! !

Object subclass: #ExChdCoreEntity
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Express2Cheddar'!

ExChdCoreEntity subclass: #ExChdAdaInterface
	instanceVariableNames: 'withIt useIt suffix prefix'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Express2Cheddar-AdaInterfaceSchema'!

!ExChdAdaInterface commentStamp: 'platypus comment' prior: 0!
<ISO10303-11-EXPRESS>
ENTITY ada_interface;
	prefix : STRING;
	suffix : OPTIONAL STRING;
	with_it : BOOLEAN;
	use_it : BOOLEAN;
DERIVE
	full_name : STRING := ada_interface_path ( SELF );
	declaration : STRING := ada_interface_declaration ( SELF );
END_ENTITY;
</ISO10303-11-EXPRESS>!

!ExChdAdaInterface class methodsFor: 'platypus-generated-platypus-signature' stamp: ''!
iso10303P11Translater
	^ 'Platypus (c) LISYC EA3883, Universite de Bretagne occidentale. Brest.'

! !

!ExChdAdaInterface class methodsFor: 'platypus-generated-meta-data-accessing' stamp: ''!
schemaDefinition
	^ ExChdAdaInterfaceSchemaDefinition singleton

! !

!ExChdAdaInterface class methodsFor: 'platypus-generated-meta-data-accessing' stamp: ''!
schemaInstance
	^ ExChdExpress2cheddarSchemaInstance singleton

! !

!ExChdAdaInterface class methodsFor: 'platypus-generated-platypus-signature' stamp: ''!
translatedFromISO10303P11
	^ true

! !

!ExChdAdaInterface class methodsFor: 'platypus-generated-platypus-signature' stamp: ''!
vwNamespaceName
	^ #Express2Cheddar

! !

!ExChdAdaInterface methodsFor: 'platypus-generated-visiting' stamp: ''!
accept: aVisitor
	^ aVisitor acceptAdaInterface: self

! !

!ExChdAdaInterface methodsFor: 'platypus-generated-copying' stamp: ''!
adaInterfaceCopyTo: another
	another fastSetPrefix: self prefix.
	another fastSetSuffix: self suffix.
	another fastSetWithIt: self withIt.
	another fastSetUseIt: self useIt

! !

!ExChdAdaInterface methodsFor: 'platypus-generated-group-accessing' stamp: ''!
adaInterfaceFromValues: values
	| valuesloc |
	valuesloc := values asOrderedCollection.
	self setPrefix: valuesloc removeFirst.
	self setSuffix: valuesloc removeFirst.
	self setWithIt: valuesloc removeFirst.
	self setUseIt: valuesloc removeFirst.
	^ valuesloc

! !

!ExChdAdaInterface methodsFor: 'platypus-generated-group-accessing' stamp: ''!
adaInterfaceToValues: values
	values add: self prefix.
	values add: self suffix.
	values add: self withIt.
	values add: self useIt.
	^ values

! !

!ExChdAdaInterface methodsFor: 'platypus-generated-deriving' stamp: ''!
declaration
	^ self declarationUsingContext: self class context

! !

!ExChdAdaInterface methodsFor: 'platypus-generated-deriving' stamp: ''!
declarationUsingContext: aContext
	^ self declarationUsingContext: aContext receiver: self

! !

!ExChdAdaInterface methodsFor: 'platypus-generated-deriving' stamp: ''!
declarationUsingContext: aContext receiver: aReceiver
	^ ExChdAdaInterfaceDeclarationFunction
		invokeFromValues:
			(OrderedCollection new
				add: aReceiver;
				yourself)

! !

!ExChdAdaInterface methodsFor: 'platypus-generated-fast-set-accessing' stamp: ''!
fastSetPrefix: aString
	prefix := aString

! !

!ExChdAdaInterface methodsFor: 'platypus-generated-fast-set-accessing' stamp: ''!
fastSetSuffix: aString
	suffix := aString

! !

!ExChdAdaInterface methodsFor: 'platypus-generated-fast-set-accessing' stamp: ''!
fastSetUseIt: aBoolean
	useIt := aBoolean

! !

!ExChdAdaInterface methodsFor: 'platypus-generated-fast-set-accessing' stamp: ''!
fastSetWithIt: aBoolean
	withIt := aBoolean

! !

!ExChdAdaInterface methodsFor: 'platypus-generated-group-accessing' stamp: ''!
fromValues: values
	^ self adaInterfaceFromValues: (super fromValues: values)

! !

!ExChdAdaInterface methodsFor: 'platypus-generated-deriving' stamp: ''!
fullName
	^ self fullNameUsingContext: self class context

! !

!ExChdAdaInterface methodsFor: 'platypus-generated-deriving' stamp: ''!
fullNameUsingContext: aContext
	^ self fullNameUsingContext: aContext receiver: self

! !

!ExChdAdaInterface methodsFor: 'platypus-generated-deriving' stamp: ''!
fullNameUsingContext: aContext receiver: aReceiver
	^ ExChdAdaInterfacePathFunction
		invokeFromValues:
			(OrderedCollection new
				add: aReceiver;
				yourself)

! !

!ExChdAdaInterface methodsFor: 'platypus-generated-classifying' stamp: ''!
isExChdAdaInterface
	^ true

! !

!ExChdAdaInterface methodsFor: 'platypus-generated-group-accessing' stamp: ''!
localFromValues: values
	^ self adaInterfaceFromValues: values

! !

!ExChdAdaInterface methodsFor: 'platypus-generated-group-accessing' stamp: ''!
localToValues: values
	^ self adaInterfaceToValues: values

! !

!ExChdAdaInterface methodsFor: 'platypus-generated-copying' stamp: ''!
pltCopyGroup: aClassSymbol to: anObject
	self class name == aClassSymbol
		ifTrue: [ self pltCopyTo: anObject ]
		ifFalse: [ super pltCopyGroup: aClassSymbol to: anObject ]

! !

!ExChdAdaInterface methodsFor: 'platypus-generated-copying' stamp: ''!
pltCopyTo: another
	super pltCopyTo: another.
	self adaInterfaceCopyTo: another

! !

!ExChdAdaInterface methodsFor: 'platypus-generated-copying' stamp: ''!
pltLocalCopyTo: another
	self adaInterfaceCopyTo: another

! !

!ExChdAdaInterface methodsFor: 'platypus-generated-accessing' stamp: ''!
prefix
	^ prefix

! !

!ExChdAdaInterface methodsFor: 'platypus-generated-accessing' stamp: ''!
prefix: aString
	prefix := aString

! !

!ExChdAdaInterface methodsFor: 'platypus-generated-with-context-accessing' stamp: ''!
prefixUsingContext: aContext
	^ self prefix

! !

!ExChdAdaInterface methodsFor: 'platypus-generated-set-accessing' stamp: ''!
setPrefix: aString
	self prefix: aString

! !

!ExChdAdaInterface methodsFor: 'platypus-generated-set-accessing' stamp: ''!
setSuffix: aString
	self suffix: aString

! !

!ExChdAdaInterface methodsFor: 'platypus-generated-set-accessing' stamp: ''!
setUseIt: aBoolean
	self useIt: aBoolean

! !

!ExChdAdaInterface methodsFor: 'platypus-generated-set-accessing' stamp: ''!
setWithIt: aBoolean
	self withIt: aBoolean

! !

!ExChdAdaInterface methodsFor: 'platypus-generated-initializing' stamp: ''!
stepInitialize
	super stepInitialize.
	prefix := ''.
	suffix := nil.
	withIt := false.
	useIt := false

! !

!ExChdAdaInterface methodsFor: 'platypus-generated-accessing' stamp: ''!
suffix
	^ suffix

! !

!ExChdAdaInterface methodsFor: 'platypus-generated-accessing' stamp: ''!
suffix: aString
	suffix := aString

! !

!ExChdAdaInterface methodsFor: 'platypus-generated-with-context-accessing' stamp: ''!
suffixUsingContext: aContext
	^ self suffix

! !

!ExChdAdaInterface methodsFor: 'platypus-generated-group-accessing' stamp: ''!
toValues: values
	^ self adaInterfaceToValues: (super toValues: values)

! !

!ExChdAdaInterface methodsFor: 'platypus-generated-accessing' stamp: ''!
useIt
	^ useIt

! !

!ExChdAdaInterface methodsFor: 'platypus-generated-accessing' stamp: ''!
useIt: aBoolean
	useIt := aBoolean

! !

!ExChdAdaInterface methodsFor: 'platypus-generated-with-context-accessing' stamp: ''!
useItUsingContext: aContext
	^ self useIt

! !

!ExChdAdaInterface methodsFor: 'platypus-generated-accessing' stamp: ''!
withIt
	^ withIt

! !

!ExChdAdaInterface methodsFor: 'platypus-generated-accessing' stamp: ''!
withIt: aBoolean
	withIt := aBoolean

! !

!ExChdAdaInterface methodsFor: 'platypus-generated-with-context-accessing' stamp: ''!
withItUsingContext: aContext
	^ self withIt

! !

ExChdCoreEntity subclass: #ExChdBasicAdaTypeGetter
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Express2Cheddar-CheddarDomainsSchema'!

!ExChdBasicAdaTypeGetter commentStamp: 'platypus comment' prior: 0!
<ISO10303-11-EXPRESS>
ENTITY basic_ada_type_getter;
DERIVE
	accept_string_type : dictionary_instance := ( ada_unbounded_string_type ( ) || ada_primitive_type ( ) || dictionary_instance ( ) );
	accept_integer_type : dictionary_instance := ( ada_natural_type ( ) || ada_primitive_type ( ) || dictionary_instance ( ) );
	accept_real_type : dictionary_instance := ( ada_double_type ( ) || ada_primitive_type ( ) || dictionary_instance ( ) );
	accept_boolean_type : dictionary_instance := ( ada_boolean_type ( ) || ada_primitive_type ( ) || dictionary_instance ( ) );
	accept_enumeration_type : dictionary_instance := SELF\enumeration_type;
	accept_ada_enumeration : dictionary_instance := SELF;
	accept_attribute_reference : dictionary_instance := ( ada_attribute_reference ( ) || ada_named_type_reference ( ) || SELF\attribute_reference );
	accept_defined_type_reference : dictionary_instance := basic_ada_domain ( SELF\defined_type_reference.ref );
	accept_defined_type : dictionary_instance := unmapped_type_reference ( SELF.domain ) || SELF;
	accept_ada_range : dictionary_instance := SELF;
	accept_ada_class_reference : dictionary_instance := SELF;
	accept_ada_record_reference : dictionary_instance := SELF;
	accept_entity_definition_reference : dictionary_instance := ( unmapped_type_reference ( SELF.ref ) || SELF\entity_definition_reference );
	accept_entity_definition : dictionary_instance := ( unmapped_entity_definition ( ) || SELF\entity_definition );
	accept_cheddar_defined_type : dictionary_instance := SELF;
	accept_list_type : dictionary_instance := ( ada_list_type ( ) || SELF\list_type );
	accept_array_type : dictionary_instance := ( ada_array_type ( ) || SELF\array_type );
	accept_set_type : dictionary_instance := ( ada_set_type ( ) || SELF\set_type );
	accept_bag_type : dictionary_instance := ( ada_bag_type ( ) || SELF\bag_type );
	accept_explicit_type_reference : dictionary_instance := SELF;
END_ENTITY;
</ISO10303-11-EXPRESS>!

!ExChdBasicAdaTypeGetter class methodsFor: 'platypus-generated-platypus-signature' stamp: ''!
iso10303P11Translater
	^ 'Platypus (c) LISYC EA3883, Universite de Bretagne occidentale. Brest.'

! !

!ExChdBasicAdaTypeGetter class methodsFor: 'platypus-generated-meta-data-accessing' stamp: ''!
schemaDefinition
	^ ExChdCheddarDomainsSchemaDefinition singleton

! !

!ExChdBasicAdaTypeGetter class methodsFor: 'platypus-generated-meta-data-accessing' stamp: ''!
schemaInstance
	^ ExChdExpress2cheddarSchemaInstance singleton

! !

!ExChdBasicAdaTypeGetter class methodsFor: 'platypus-generated-platypus-signature' stamp: ''!
translatedFromISO10303P11
	^ true

! !

!ExChdBasicAdaTypeGetter class methodsFor: 'platypus-generated-platypus-signature' stamp: ''!
vwNamespaceName
	^ #Express2Cheddar

! !

!ExChdBasicAdaTypeGetter methodsFor: 'platypus-generated-visiting' stamp: ''!
accept: aVisitor
	^ aVisitor acceptBasicAdaTypeGetter: self

! !

!ExChdBasicAdaTypeGetter methodsFor: 'platypus-generated-deriving' stamp: ''!
acceptAdaClassReference
	^ self acceptAdaClassReferenceUsingContext: self class context

! !

!ExChdBasicAdaTypeGetter methodsFor: 'platypus-generated-deriving' stamp: ''!
acceptAdaClassReferenceUsingContext: aContext
	^ self acceptAdaClassReferenceUsingContext: aContext receiver: self

! !

!ExChdBasicAdaTypeGetter methodsFor: 'platypus-generated-deriving' stamp: ''!
acceptAdaClassReferenceUsingContext: aContext receiver: aReceiver
	^ aReceiver

! !

!ExChdBasicAdaTypeGetter methodsFor: 'platypus-generated-deriving' stamp: ''!
acceptAdaEnumeration
	^ self acceptAdaEnumerationUsingContext: self class context

! !

!ExChdBasicAdaTypeGetter methodsFor: 'platypus-generated-deriving' stamp: ''!
acceptAdaEnumerationUsingContext: aContext
	^ self acceptAdaEnumerationUsingContext: aContext receiver: self

! !

!ExChdBasicAdaTypeGetter methodsFor: 'platypus-generated-deriving' stamp: ''!
acceptAdaEnumerationUsingContext: aContext receiver: aReceiver
	^ aReceiver

! !

!ExChdBasicAdaTypeGetter methodsFor: 'platypus-generated-deriving' stamp: ''!
acceptAdaRange
	^ self acceptAdaRangeUsingContext: self class context

! !

!ExChdBasicAdaTypeGetter methodsFor: 'platypus-generated-deriving' stamp: ''!
acceptAdaRangeUsingContext: aContext
	^ self acceptAdaRangeUsingContext: aContext receiver: self

! !

!ExChdBasicAdaTypeGetter methodsFor: 'platypus-generated-deriving' stamp: ''!
acceptAdaRangeUsingContext: aContext receiver: aReceiver
	^ aReceiver

! !

!ExChdBasicAdaTypeGetter methodsFor: 'platypus-generated-deriving' stamp: ''!
acceptAdaRecordReference
	^ self acceptAdaRecordReferenceUsingContext: self class context

! !

!ExChdBasicAdaTypeGetter methodsFor: 'platypus-generated-deriving' stamp: ''!
acceptAdaRecordReferenceUsingContext: aContext
	^ self acceptAdaRecordReferenceUsingContext: aContext receiver: self

! !

!ExChdBasicAdaTypeGetter methodsFor: 'platypus-generated-deriving' stamp: ''!
acceptAdaRecordReferenceUsingContext: aContext receiver: aReceiver
	^ aReceiver

! !

!ExChdBasicAdaTypeGetter methodsFor: 'platypus-generated-deriving' stamp: ''!
acceptArrayType
	^ self acceptArrayTypeUsingContext: self class context

! !

!ExChdBasicAdaTypeGetter methodsFor: 'platypus-generated-deriving' stamp: ''!
acceptArrayTypeUsingContext: aContext
	^ self acceptArrayTypeUsingContext: aContext receiver: self

! !

!ExChdBasicAdaTypeGetter methodsFor: 'platypus-generated-deriving' stamp: ''!
acceptArrayTypeUsingContext: aContext receiver: aReceiver
	^ (PlatypusComplexInstance
		fromRecords:
			(OrderedCollection new
				add: ExChdAdaArrayType new;
				add: (aReceiver asPlatypusComplexInstance \ #PltArrayType) pltAsObject;
				yourself)) pltAsObject

! !

!ExChdBasicAdaTypeGetter methodsFor: 'platypus-generated-deriving' stamp: ''!
acceptAttributeReference
	^ self acceptAttributeReferenceUsingContext: self class context

! !

!ExChdBasicAdaTypeGetter methodsFor: 'platypus-generated-deriving' stamp: ''!
acceptAttributeReferenceUsingContext: aContext
	^ self acceptAttributeReferenceUsingContext: aContext receiver: self

! !

!ExChdBasicAdaTypeGetter methodsFor: 'platypus-generated-deriving' stamp: ''!
acceptAttributeReferenceUsingContext: aContext receiver: aReceiver
	^ (PlatypusComplexInstance
		fromRecords:
			(OrderedCollection new
				add:
						(PlatypusComplexInstance
								fromRecords:
									(OrderedCollection new
										add: ExChdAdaAttributeReference new;
										add: ExChdAdaNamedTypeReference new;
										yourself)) pltAsObject;
				add: (aReceiver asPlatypusComplexInstance \ #PltAttributeReference) pltAsObject;
				yourself)) pltAsObject

! !

!ExChdBasicAdaTypeGetter methodsFor: 'platypus-generated-deriving' stamp: ''!
acceptBagType
	^ self acceptBagTypeUsingContext: self class context

! !

!ExChdBasicAdaTypeGetter methodsFor: 'platypus-generated-deriving' stamp: ''!
acceptBagTypeUsingContext: aContext
	^ self acceptBagTypeUsingContext: aContext receiver: self

! !

!ExChdBasicAdaTypeGetter methodsFor: 'platypus-generated-deriving' stamp: ''!
acceptBagTypeUsingContext: aContext receiver: aReceiver
	^ (PlatypusComplexInstance
		fromRecords:
			(OrderedCollection new
				add: ExChdAdaBagType new;
				add: (aReceiver asPlatypusComplexInstance \ #PltBagType) pltAsObject;
				yourself)) pltAsObject

! !

!ExChdBasicAdaTypeGetter methodsFor: 'platypus-generated-deriving' stamp: ''!
acceptBooleanType
	^ self acceptBooleanTypeUsingContext: self class context

! !

!ExChdBasicAdaTypeGetter methodsFor: 'platypus-generated-deriving' stamp: ''!
acceptBooleanTypeUsingContext: aContext
	^ self acceptBooleanTypeUsingContext: aContext receiver: self

! !

!ExChdBasicAdaTypeGetter methodsFor: 'platypus-generated-deriving' stamp: ''!
acceptBooleanTypeUsingContext: aContext receiver: aReceiver
	^ (PlatypusComplexInstance
		fromRecords:
			(OrderedCollection new
				add:
						(PlatypusComplexInstance
								fromRecords:
									(OrderedCollection new
										add: ExChdAdaBooleanType new;
										add: ExChdAdaPrimitiveType new;
										yourself)) pltAsObject;
				add: PltDictionaryInstance new;
				yourself)) pltAsObject

! !

!ExChdBasicAdaTypeGetter methodsFor: 'platypus-generated-deriving' stamp: ''!
acceptCheddarDefinedType
	^ self acceptCheddarDefinedTypeUsingContext: self class context

! !

!ExChdBasicAdaTypeGetter methodsFor: 'platypus-generated-deriving' stamp: ''!
acceptCheddarDefinedTypeUsingContext: aContext
	^ self acceptCheddarDefinedTypeUsingContext: aContext receiver: self

! !

!ExChdBasicAdaTypeGetter methodsFor: 'platypus-generated-deriving' stamp: ''!
acceptCheddarDefinedTypeUsingContext: aContext receiver: aReceiver
	^ aReceiver

! !

!ExChdBasicAdaTypeGetter methodsFor: 'platypus-generated-deriving' stamp: ''!
acceptDefinedType
	^ self acceptDefinedTypeUsingContext: self class context

! !

!ExChdBasicAdaTypeGetter methodsFor: 'platypus-generated-deriving' stamp: ''!
acceptDefinedTypeReference
	^ self acceptDefinedTypeReferenceUsingContext: self class context

! !

!ExChdBasicAdaTypeGetter methodsFor: 'platypus-generated-deriving' stamp: ''!
acceptDefinedTypeReferenceUsingContext: aContext
	^ self acceptDefinedTypeReferenceUsingContext: aContext receiver: self

! !

!ExChdBasicAdaTypeGetter methodsFor: 'platypus-generated-deriving' stamp: ''!
acceptDefinedTypeReferenceUsingContext: aContext receiver: aReceiver
	^ ExChdBasicAdaDomainFunction
		invokeFromValues:
			(OrderedCollection new
				add:
						((aReceiver asPlatypusComplexInstance \ #PltDefinedTypeReference) pltAsObject refUsingContext: self class context);
				yourself)

! !

!ExChdBasicAdaTypeGetter methodsFor: 'platypus-generated-deriving' stamp: ''!
acceptDefinedTypeUsingContext: aContext
	^ self acceptDefinedTypeUsingContext: aContext receiver: self

! !

!ExChdBasicAdaTypeGetter methodsFor: 'platypus-generated-deriving' stamp: ''!
acceptDefinedTypeUsingContext: aContext receiver: aReceiver
	^ (PlatypusComplexInstance
		fromRecords:
			(OrderedCollection new
				add:
						(ExChdUnmappedTypeReference new
								unmappedTypeReferenceFromValues:
										(OrderedCollection new
												add: (aReceiver domainUsingContext: self class context);
												yourself);
								yourself);
				add: aReceiver;
				yourself)) pltAsObject

! !

!ExChdBasicAdaTypeGetter methodsFor: 'platypus-generated-deriving' stamp: ''!
acceptEntityDefinition
	^ self acceptEntityDefinitionUsingContext: self class context

! !

!ExChdBasicAdaTypeGetter methodsFor: 'platypus-generated-deriving' stamp: ''!
acceptEntityDefinitionReference
	^ self acceptEntityDefinitionReferenceUsingContext: self class context

! !

!ExChdBasicAdaTypeGetter methodsFor: 'platypus-generated-deriving' stamp: ''!
acceptEntityDefinitionReferenceUsingContext: aContext
	^ self acceptEntityDefinitionReferenceUsingContext: aContext receiver: self

! !

!ExChdBasicAdaTypeGetter methodsFor: 'platypus-generated-deriving' stamp: ''!
acceptEntityDefinitionReferenceUsingContext: aContext receiver: aReceiver
	^ (PlatypusComplexInstance
		fromRecords:
			(OrderedCollection new
				add:
						(ExChdUnmappedTypeReference new
								unmappedTypeReferenceFromValues:
										(OrderedCollection new
												add: (aReceiver refUsingContext: self class context);
												yourself);
								yourself);
				add: (aReceiver asPlatypusComplexInstance \ #PltEntityDefinitionReference) pltAsObject;
				yourself)) pltAsObject

! !

!ExChdBasicAdaTypeGetter methodsFor: 'platypus-generated-deriving' stamp: ''!
acceptEntityDefinitionUsingContext: aContext
	^ self acceptEntityDefinitionUsingContext: aContext receiver: self

! !

!ExChdBasicAdaTypeGetter methodsFor: 'platypus-generated-deriving' stamp: ''!
acceptEntityDefinitionUsingContext: aContext receiver: aReceiver
	^ (PlatypusComplexInstance
		fromRecords:
			(OrderedCollection new
				add: ExChdUnmappedEntityDefinition new;
				add: (aReceiver asPlatypusComplexInstance \ #PltEntityDefinition) pltAsObject;
				yourself)) pltAsObject

! !

!ExChdBasicAdaTypeGetter methodsFor: 'platypus-generated-deriving' stamp: ''!
acceptEnumerationType
	^ self acceptEnumerationTypeUsingContext: self class context

! !

!ExChdBasicAdaTypeGetter methodsFor: 'platypus-generated-deriving' stamp: ''!
acceptEnumerationTypeUsingContext: aContext
	^ self acceptEnumerationTypeUsingContext: aContext receiver: self

! !

!ExChdBasicAdaTypeGetter methodsFor: 'platypus-generated-deriving' stamp: ''!
acceptEnumerationTypeUsingContext: aContext receiver: aReceiver
	^ (aReceiver asPlatypusComplexInstance \ #PltEnumerationType) pltAsObject

! !

!ExChdBasicAdaTypeGetter methodsFor: 'platypus-generated-deriving' stamp: ''!
acceptExplicitTypeReference
	^ self acceptExplicitTypeReferenceUsingContext: self class context

! !

!ExChdBasicAdaTypeGetter methodsFor: 'platypus-generated-deriving' stamp: ''!
acceptExplicitTypeReferenceUsingContext: aContext
	^ self acceptExplicitTypeReferenceUsingContext: aContext receiver: self

! !

!ExChdBasicAdaTypeGetter methodsFor: 'platypus-generated-deriving' stamp: ''!
acceptExplicitTypeReferenceUsingContext: aContext receiver: aReceiver
	^ aReceiver

! !

!ExChdBasicAdaTypeGetter methodsFor: 'platypus-generated-deriving' stamp: ''!
acceptIntegerType
	^ self acceptIntegerTypeUsingContext: self class context

! !

!ExChdBasicAdaTypeGetter methodsFor: 'platypus-generated-deriving' stamp: ''!
acceptIntegerTypeUsingContext: aContext
	^ self acceptIntegerTypeUsingContext: aContext receiver: self

! !

!ExChdBasicAdaTypeGetter methodsFor: 'platypus-generated-deriving' stamp: ''!
acceptIntegerTypeUsingContext: aContext receiver: aReceiver
	^ (PlatypusComplexInstance
		fromRecords:
			(OrderedCollection new
				add:
						(PlatypusComplexInstance
								fromRecords:
									(OrderedCollection new
										add: ExChdAdaNaturalType new;
										add: ExChdAdaPrimitiveType new;
										yourself)) pltAsObject;
				add: PltDictionaryInstance new;
				yourself)) pltAsObject

! !

!ExChdBasicAdaTypeGetter methodsFor: 'platypus-generated-deriving' stamp: ''!
acceptListType
	^ self acceptListTypeUsingContext: self class context

! !

!ExChdBasicAdaTypeGetter methodsFor: 'platypus-generated-deriving' stamp: ''!
acceptListTypeUsingContext: aContext
	^ self acceptListTypeUsingContext: aContext receiver: self

! !

!ExChdBasicAdaTypeGetter methodsFor: 'platypus-generated-deriving' stamp: ''!
acceptListTypeUsingContext: aContext receiver: aReceiver
	^ (PlatypusComplexInstance
		fromRecords:
			(OrderedCollection new
				add: ExChdAdaListType new;
				add: (aReceiver asPlatypusComplexInstance \ #PltListType) pltAsObject;
				yourself)) pltAsObject

! !

!ExChdBasicAdaTypeGetter methodsFor: 'platypus-generated-deriving' stamp: ''!
acceptRealType
	^ self acceptRealTypeUsingContext: self class context

! !

!ExChdBasicAdaTypeGetter methodsFor: 'platypus-generated-deriving' stamp: ''!
acceptRealTypeUsingContext: aContext
	^ self acceptRealTypeUsingContext: aContext receiver: self

! !

!ExChdBasicAdaTypeGetter methodsFor: 'platypus-generated-deriving' stamp: ''!
acceptRealTypeUsingContext: aContext receiver: aReceiver
	^ (PlatypusComplexInstance
		fromRecords:
			(OrderedCollection new
				add:
						(PlatypusComplexInstance
								fromRecords:
									(OrderedCollection new
										add: ExChdAdaDoubleType new;
										add: ExChdAdaPrimitiveType new;
										yourself)) pltAsObject;
				add: PltDictionaryInstance new;
				yourself)) pltAsObject

! !

!ExChdBasicAdaTypeGetter methodsFor: 'platypus-generated-deriving' stamp: ''!
acceptSetType
	^ self acceptSetTypeUsingContext: self class context

! !

!ExChdBasicAdaTypeGetter methodsFor: 'platypus-generated-deriving' stamp: ''!
acceptSetTypeUsingContext: aContext
	^ self acceptSetTypeUsingContext: aContext receiver: self

! !

!ExChdBasicAdaTypeGetter methodsFor: 'platypus-generated-deriving' stamp: ''!
acceptSetTypeUsingContext: aContext receiver: aReceiver
	^ (PlatypusComplexInstance
		fromRecords:
			(OrderedCollection new
				add: ExChdAdaSetType new;
				add: (aReceiver asPlatypusComplexInstance \ #PltSetType) pltAsObject;
				yourself)) pltAsObject

! !

!ExChdBasicAdaTypeGetter methodsFor: 'platypus-generated-deriving' stamp: ''!
acceptStringType
	^ self acceptStringTypeUsingContext: self class context

! !

!ExChdBasicAdaTypeGetter methodsFor: 'platypus-generated-deriving' stamp: ''!
acceptStringTypeUsingContext: aContext
	^ self acceptStringTypeUsingContext: aContext receiver: self

! !

!ExChdBasicAdaTypeGetter methodsFor: 'platypus-generated-deriving' stamp: ''!
acceptStringTypeUsingContext: aContext receiver: aReceiver
	^ (PlatypusComplexInstance
		fromRecords:
			(OrderedCollection new
				add:
						(PlatypusComplexInstance
								fromRecords:
									(OrderedCollection new
										add: ExChdAdaUnboundedStringType new;
										add: ExChdAdaPrimitiveType new;
										yourself)) pltAsObject;
				add: PltDictionaryInstance new;
				yourself)) pltAsObject

! !

!ExChdBasicAdaTypeGetter methodsFor: 'platypus-generated-copying' stamp: ''!
basicAdaTypeGetterCopyTo: another
	

! !

!ExChdBasicAdaTypeGetter methodsFor: 'platypus-generated-group-accessing' stamp: ''!
basicAdaTypeGetterFromValues: values
	| valuesloc |
	valuesloc := values asOrderedCollection.
	^ valuesloc

! !

!ExChdBasicAdaTypeGetter methodsFor: 'platypus-generated-group-accessing' stamp: ''!
basicAdaTypeGetterToValues: values
	^ values

! !

!ExChdBasicAdaTypeGetter methodsFor: 'platypus-generated-group-accessing' stamp: ''!
fromValues: values
	^ self basicAdaTypeGetterFromValues: (super fromValues: values)

! !

!ExChdBasicAdaTypeGetter methodsFor: 'platypus-generated-classifying' stamp: ''!
isExChdBasicAdaTypeGetter
	^ true

! !

!ExChdBasicAdaTypeGetter methodsFor: 'platypus-generated-group-accessing' stamp: ''!
localFromValues: values
	^ self basicAdaTypeGetterFromValues: values

! !

!ExChdBasicAdaTypeGetter methodsFor: 'platypus-generated-group-accessing' stamp: ''!
localToValues: values
	^ self basicAdaTypeGetterToValues: values

! !

!ExChdBasicAdaTypeGetter methodsFor: 'platypus-generated-copying' stamp: ''!
pltCopyGroup: aClassSymbol to: anObject
	self class name == aClassSymbol
		ifTrue: [ self pltCopyTo: anObject ]
		ifFalse: [ super pltCopyGroup: aClassSymbol to: anObject ]

! !

!ExChdBasicAdaTypeGetter methodsFor: 'platypus-generated-copying' stamp: ''!
pltCopyTo: another
	super pltCopyTo: another.
	self basicAdaTypeGetterCopyTo: another

! !

!ExChdBasicAdaTypeGetter methodsFor: 'platypus-generated-copying' stamp: ''!
pltLocalCopyTo: another
	self basicAdaTypeGetterCopyTo: another

! !

!ExChdBasicAdaTypeGetter methodsFor: 'platypus-generated-initializing' stamp: ''!
stepInitialize
	super stepInitialize

! !

!ExChdBasicAdaTypeGetter methodsFor: 'platypus-generated-group-accessing' stamp: ''!
toValues: values
	^ self basicAdaTypeGetterToValues: (super toValues: values)

! !

!ExChdCoreEntity class methodsFor: 'platypus-generated-context-accessing' stamp: ''!
context
	^ self schemaDefinition context

! !

!ExChdCoreEntity class methodsFor: 'platypus-generated-platypus-signature' stamp: ''!
iso10303P11Translater
	^ 'Platypus (c) LISYC EA3883, Universite de Bretagne occidentale. Brest.'

! !

!ExChdCoreEntity class methodsFor: 'platypus-generated-meta-data-accessing' stamp: ''!
platypusMetaData
	^ self schemaDefinition metaDataFor: self name asSymbol

! !

!ExChdCoreEntity class methodsFor: 'platypus-generated-platypus-signature' stamp: ''!
translatedFromISO10303P11
	^ true

! !

!ExChdCoreEntity class methodsFor: 'platypus-generated-platypus-signature' stamp: ''!
vwNamespaceName
	^ #Express2Cheddar

! !

!ExChdCoreEntity methodsFor: '*Express2Cheddar-CheddarDomainsSchema-classifying' stamp: ''!
isExChdAdaArrayType
	^ false

! !

!ExChdCoreEntity methodsFor: '*Express2Cheddar-CheddarDomainsSchema-classifying' stamp: ''!
isExChdAdaAttributeReference
	^ false

! !

!ExChdCoreEntity methodsFor: '*Express2Cheddar-CheddarDomainsSchema-classifying' stamp: ''!
isExChdAdaBagType
	^ false

! !

!ExChdCoreEntity methodsFor: '*Express2Cheddar-CheddarDomainsSchema-classifying' stamp: ''!
isExChdAdaBooleanType
	^ false

! !

!ExChdCoreEntity methodsFor: '*Express2Cheddar-RecordAndClassSchema-classifying' stamp: ''!
isExChdAdaClass
	^ false

! !

!ExChdCoreEntity methodsFor: '*Express2Cheddar-CheddarDtdSchema-classifying' stamp: ''!
isExChdAdaClassDtdElement
	^ false

! !

!ExChdCoreEntity methodsFor: '*Express2Cheddar-CheddarDtdSchema-classifying' stamp: ''!
isExChdAdaClassRefDtdElement
	^ false

! !

!ExChdCoreEntity methodsFor: '*Express2Cheddar-CheddarDomainsSchema-classifying' stamp: ''!
isExChdAdaClassReference
	^ false

! !

!ExChdCoreEntity methodsFor: '*Express2Cheddar-CheddarConstantsSchema-classifying' stamp: ''!
isExChdAdaConstant
	^ false

! !

!ExChdCoreEntity methodsFor: '*Express2Cheddar-CheddarDomainsSchema-classifying' stamp: ''!
isExChdAdaDoubleType
	^ false

! !

!ExChdCoreEntity methodsFor: '*Express2Cheddar-RecordAndClassSchema-classifying' stamp: ''!
isExChdAdaEntity
	^ false

! !

!ExChdCoreEntity methodsFor: '*Express2Cheddar-CheddarDomainsSchema-classifying' stamp: ''!
isExChdAdaEnumeration
	^ false

! !

!ExChdCoreEntity methodsFor: '*Express2Cheddar-CheddarDomainsSchema-classifying' stamp: ''!
isExChdAdaIntegerType
	^ false

! !

!ExChdCoreEntity methodsFor: '*Express2Cheddar-AdaInterfaceSchema-classifying' stamp: ''!
isExChdAdaInterface
	^ false

! !

!ExChdCoreEntity methodsFor: '*Express2Cheddar-CheddarDomainsSchema-classifying' stamp: ''!
isExChdAdaListType
	^ false

! !

!ExChdCoreEntity methodsFor: '*Express2Cheddar-CheddarDomainsSchema-classifying' stamp: ''!
isExChdAdaNamedTypeReference
	^ false

! !

!ExChdCoreEntity methodsFor: '*Express2Cheddar-CheddarDomainsSchema-classifying' stamp: ''!
isExChdAdaNaturalType
	^ false

! !

!ExChdCoreEntity methodsFor: '*Express2Cheddar-PackageSchema-classifying' stamp: ''!
isExChdAdaPackage
	^ false

! !

!ExChdCoreEntity methodsFor: '*Express2Cheddar-CheddarDomainsSchema-classifying' stamp: ''!
isExChdAdaPrimitiveClassReference
	^ false

! !

!ExChdCoreEntity methodsFor: '*Express2Cheddar-CheddarDomainsSchema-classifying' stamp: ''!
isExChdAdaPrimitiveType
	^ false

! !

!ExChdCoreEntity methodsFor: '*Express2Cheddar-CheddarDomainsSchema-classifying' stamp: ''!
isExChdAdaRealType
	^ false

! !

!ExChdCoreEntity methodsFor: '*Express2Cheddar-CheddarDomainsSchema-classifying' stamp: ''!
isExChdAdaRecordReference
	^ false

! !

!ExChdCoreEntity methodsFor: '*Express2Cheddar-CheddarDomainsSchema-classifying' stamp: ''!
isExChdAdaSetType
	^ false

! !

!ExChdCoreEntity methodsFor: '*Express2Cheddar-CheddarDomainsSchema-classifying' stamp: ''!
isExChdAdaType
	^ false

! !

!ExChdCoreEntity methodsFor: '*Express2Cheddar-CheddarDomainsSchema-classifying' stamp: ''!
isExChdAdaUnboundedStringType
	^ false

! !

!ExChdCoreEntity methodsFor: '*Express2Cheddar-CheddarDtdSchema-classifying' stamp: ''!
isExChdAttributeDtdElement
	^ false

! !

!ExChdCoreEntity methodsFor: '*Express2Cheddar-CheddarDomainsSchema-classifying' stamp: ''!
isExChdBasicAdaTypeGetter
	^ false

! !

!ExChdCoreEntity methodsFor: '*Express2Cheddar-CheddarDomainsSchema-classifying' stamp: ''!
isExChdBasicAdaTypeValueFormat
	^ false

! !

!ExChdCoreEntity methodsFor: '*Express2Cheddar-CheddarDomainsSchema-classifying' stamp: ''!
isExChdCheddarDefinedType
	^ false

! !

!ExChdCoreEntity methodsFor: '*Express2Cheddar-CheddarDomainsSchema-classifying' stamp: ''!
isExChdCheddarEntityDefinition
	^ false

! !

!ExChdCoreEntity methodsFor: '*Express2Cheddar-RecordAndClassSchema-classifying' stamp: ''!
isExChdCheddarFunctionPtr
	^ false

! !

!ExChdCoreEntity methodsFor: '*Express2Cheddar-CheddarDomainsSchema-classifying' stamp: ''!
isExChdCheddarLawType
	^ false

! !

!ExChdCoreEntity methodsFor: '*Express2Cheddar-CheddarDomainsSchema-classifying' stamp: ''!
isExChdCheddarPrimitiveType
	^ false

! !

!ExChdCoreEntity methodsFor: '*Express2Cheddar-CheddarDomainsSchema-classifying' stamp: ''!
isExChdCheddarPriorityRange
	^ false

! !

!ExChdCoreEntity methodsFor: '*Express2Cheddar-CheddarDomainsSchema-classifying' stamp: ''!
isExChdCheddarXmlIdType
	^ false

! !

!ExChdCoreEntity methodsFor: '*Express2Cheddar-CheddarDtdSchema-classifying' stamp: ''!
isExChdCollectionDtdElement
	^ false

! !

!ExChdCoreEntity methodsFor: '*Express2Cheddar-CheddarDtdSchema-classifying' stamp: ''!
isExChdCompositeDtdElement
	^ false

! !

!ExChdCoreEntity methodsFor: '*Express2Cheddar-CheddarDomainsSchema-classifying' stamp: ''!
isExChdConstrainedArrayType
	^ false

! !

!ExChdCoreEntity methodsFor: '*Express2Cheddar-DiscriminatedTypeSchema-classifying' stamp: ''!
isExChdDiscriminatedType
	^ false

! !

!ExChdCoreEntity methodsFor: '*Express2Cheddar-DiscriminatedTypeSchema-classifying' stamp: ''!
isExChdDiscriminatedTypeDiscriminant
	^ false

! !

!ExChdCoreEntity methodsFor: '*Express2Cheddar-CheddarDtdSchema-classifying' stamp: ''!
isExChdDiscriminatedTypeDtdElement
	^ false

! !

!ExChdCoreEntity methodsFor: '*Express2Cheddar-CheddarDtdSchema-classifying' stamp: ''!
isExChdDiscriminatedTypeRefDtdElement
	^ false

! !

!ExChdCoreEntity methodsFor: '*Express2Cheddar-DiscriminatedTypeSchema-classifying' stamp: ''!
isExChdDiscriminatedTypeUnion
	^ false

! !

!ExChdCoreEntity methodsFor: '*Express2Cheddar-DiscriminatedTypeSchema-classifying' stamp: ''!
isExChdDiscriminatedTypeUnionElementType
	^ false

! !

!ExChdCoreEntity methodsFor: '*Express2Cheddar-DiscriminatedTypeSchema-classifying' stamp: ''!
isExChdDiscriminatedTypeUnionType
	^ false

! !

!ExChdCoreEntity methodsFor: '*Express2Cheddar-CheddarDtdSchema-classifying' stamp: ''!
isExChdDomainDtdElement
	^ false

! !

!ExChdCoreEntity methodsFor: '*Express2Cheddar-CheddarDtdSchema-classifying' stamp: ''!
isExChdDtdElement
	^ false

! !

!ExChdCoreEntity methodsFor: '*Express2Cheddar-CheddarDtdSchema-classifying' stamp: ''!
isExChdEntityDtdElement
	^ false

! !

!ExChdCoreEntity methodsFor: '*Express2Cheddar-CheddarDtdSchema-classifying' stamp: ''!
isExChdEntityRefDtdElement
	^ false

! !

!ExChdCoreEntity methodsFor: '*Express2Cheddar-CheddarDomainsSchema-classifying' stamp: ''!
isExChdExplicitTypeReference
	^ false

! !

!ExChdCoreEntity methodsFor: '*Express2Cheddar-PackageSchema-classifying' stamp: ''!
isExChdGenericPackageInstanciation
	^ false

! !

!ExChdCoreEntity methodsFor: '*Express2Cheddar-CheddarDomainsSchema-classifying' stamp: ''!
isExChdInScopeAttribute
	^ false

! !

!ExChdCoreEntity methodsFor: '*Express2Cheddar-PackageSchema-classifying' stamp: ''!
isExChdPackageAlias
	^ false

! !

!ExChdCoreEntity methodsFor: '*Express2Cheddar-CheddarDtdSchema-classifying' stamp: ''!
isExChdPackageDtdElement
	^ false

! !

!ExChdCoreEntity methodsFor: '*Express2Cheddar-CheddarDomainsSchema-classifying' stamp: ''!
isExChdPragmaConvention
	^ false

! !

!ExChdCoreEntity methodsFor: '*Express2Cheddar-CheddarDomainsSchema-classifying' stamp: ''!
isExChdRangeType
	^ false

! !

!ExChdCoreEntity methodsFor: '*Express2Cheddar-RecordAndClassSchema-classifying' stamp: ''!
isExChdRecord
	^ false

! !

!ExChdCoreEntity methodsFor: '*Express2Cheddar-CheddarDtdSchema-classifying' stamp: ''!
isExChdRecordDtdElement
	^ false

! !

!ExChdCoreEntity methodsFor: '*Express2Cheddar-CheddarDtdSchema-classifying' stamp: ''!
isExChdRecordRefDtdElement
	^ false

! !

!ExChdCoreEntity methodsFor: '*Express2Cheddar-CheddarDtdSchema-classifying' stamp: ''!
isExChdRootDtdElement
	^ false

! !

!ExChdCoreEntity methodsFor: '*Express2Cheddar-CheddarDtdSchema-classifying' stamp: ''!
isExChdSimpleDomainDtdElement
	^ false

! !

!ExChdCoreEntity methodsFor: '*Express2Cheddar-CheddarDtdSchema-classifying' stamp: ''!
isExChdUnknownDomainDtdElement
	^ false

! !

!ExChdCoreEntity methodsFor: '*Express2Cheddar-CheddarDomainsSchema-classifying' stamp: ''!
isExChdUnmappedEntityDefinition
	^ false

! !

!ExChdCoreEntity methodsFor: '*Express2Cheddar-CheddarDomainsSchema-classifying' stamp: ''!
isExChdUnmappedTypeReference
	^ false

! !

!ExChdCoreEntity methodsFor: 'platypus-generated-meta-data-accessing' stamp: ''!
platypusMetaData
	^ self class platypusMetaData

! !

ExChdCoreEntity subclass: #ExChdDtdElement
	instanceVariableNames: 'tag owner'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Express2Cheddar-CheddarDtdSchema'!

!ExChdDtdElement commentStamp: 'platypus comment' prior: 0!
<ISO10303-11-EXPRESS>
ENTITY dtd_element 
	ABSTRACT SUPERTYPE;
	owner : OPTIONAL dtd_element;
	tag : STRING;
DERIVE
	dtd_code : STRING := '';
END_ENTITY;
</ISO10303-11-EXPRESS>!

ExChdDtdElement subclass: #ExChdAttributeDtdElement
	instanceVariableNames: 'domain attribute'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Express2Cheddar-CheddarDtdSchema'!

!ExChdAttributeDtdElement commentStamp: 'platypus comment' prior: 0!
<ISO10303-11-EXPRESS>
ENTITY attribute_dtd_element 
	SUBTYPE OF ( dtd_element );
	attribute : attribute;
	domain : domain_dtd_element;
DERIVE
	SELF\dtd_element.tag : STRING := lowerize ( attribute.name );
	SELF\dtd_element.dtd_code : STRING := domain.dtd_code;
END_ENTITY;
</ISO10303-11-EXPRESS>!

!ExChdAttributeDtdElement class methodsFor: 'platypus-generated-platypus-signature' stamp: ''!
iso10303P11Translater
	^ 'Platypus (c) LISYC EA3883, Universite de Bretagne occidentale. Brest.'

! !

!ExChdAttributeDtdElement class methodsFor: 'platypus-generated-meta-data-accessing' stamp: ''!
schemaDefinition
	^ ExChdCheddarDtdSchemaDefinition singleton

! !

!ExChdAttributeDtdElement class methodsFor: 'platypus-generated-meta-data-accessing' stamp: ''!
schemaInstance
	^ ExChdExpress2cheddarSchemaInstance singleton

! !

!ExChdAttributeDtdElement class methodsFor: 'platypus-generated-platypus-signature' stamp: ''!
translatedFromISO10303P11
	^ true

! !

!ExChdAttributeDtdElement class methodsFor: 'platypus-generated-platypus-signature' stamp: ''!
vwNamespaceName
	^ #Express2Cheddar

! !

!ExChdAttributeDtdElement methodsFor: 'platypus-generated-visiting' stamp: ''!
accept: aVisitor
	^ aVisitor acceptAttributeDtdElement: self

! !

!ExChdAttributeDtdElement methodsFor: 'platypus-generated-accessing' stamp: ''!
attribute
	^ attribute

! !

!ExChdAttributeDtdElement methodsFor: 'platypus-generated-accessing' stamp: ''!
attribute: aExChdAttribute
	attribute := aExChdAttribute

! !

!ExChdAttributeDtdElement methodsFor: 'platypus-generated-copying' stamp: ''!
attributeDtdElementCopyTo: another
	another fastSetAttribute: self attribute.
	another fastSetDomain: self domain

! !

!ExChdAttributeDtdElement methodsFor: 'platypus-generated-group-accessing' stamp: ''!
attributeDtdElementFromValues: values
	| valuesloc |
	valuesloc := values asOrderedCollection.
	self setAttribute: valuesloc removeFirst.
	self setDomain: valuesloc removeFirst.
	^ valuesloc

! !

!ExChdAttributeDtdElement methodsFor: 'platypus-generated-group-accessing' stamp: ''!
attributeDtdElementToValues: values
	values add: self attribute.
	values add: self domain.
	^ values

! !

!ExChdAttributeDtdElement methodsFor: 'platypus-generated-with-context-accessing' stamp: ''!
attributeUsingContext: aContext
	^ self attribute

! !

!ExChdAttributeDtdElement methodsFor: 'platypus-generated-accessing' stamp: ''!
domain
	^ domain

! !

!ExChdAttributeDtdElement methodsFor: 'platypus-generated-accessing' stamp: ''!
domain: aExChdDomainDtdElement
	domain := aExChdDomainDtdElement

! !

!ExChdAttributeDtdElement methodsFor: 'platypus-generated-with-context-accessing' stamp: ''!
domainUsingContext: aContext
	^ self domain

! !

!ExChdAttributeDtdElement methodsFor: 'platypus-generated-deriving' stamp: ''!
dtdCode
	^ self dtdCodeUsingContext: self class context

! !

!ExChdAttributeDtdElement methodsFor: 'platypus-generated-deriving' stamp: ''!
dtdCodeUsingContext: aContext
	^ self dtdCodeUsingContext: aContext receiver: self

! !

!ExChdAttributeDtdElement methodsFor: 'platypus-generated-deriving' stamp: ''!
dtdCodeUsingContext: aContext receiver: aReceiver
	^ aReceiver domain dtdCodeUsingContext: aContext

! !

!ExChdAttributeDtdElement methodsFor: 'platypus-generated-fast-set-accessing' stamp: ''!
fastSetAttribute: aExChdAttribute
	attribute := aExChdAttribute

! !

!ExChdAttributeDtdElement methodsFor: 'platypus-generated-fast-set-accessing' stamp: ''!
fastSetDomain: aExChdDomainDtdElement
	domain := aExChdDomainDtdElement

! !

!ExChdAttributeDtdElement methodsFor: 'platypus-generated-group-accessing' stamp: ''!
fromValues: values
	^ self attributeDtdElementFromValues: (super fromValues: values)

! !

!ExChdAttributeDtdElement methodsFor: 'platypus-generated-classifying' stamp: ''!
isExChdAttributeDtdElement
	^ true

! !

!ExChdAttributeDtdElement methodsFor: 'platypus-generated-group-accessing' stamp: ''!
localFromValues: values
	^ self attributeDtdElementFromValues: values

! !

!ExChdAttributeDtdElement methodsFor: 'platypus-generated-group-accessing' stamp: ''!
localToValues: values
	^ self attributeDtdElementToValues: values

! !

!ExChdAttributeDtdElement methodsFor: 'platypus-generated-copying' stamp: ''!
pltCopyGroup: aClassSymbol to: anObject
	self class name == aClassSymbol
		ifTrue: [ self pltCopyTo: anObject ]
		ifFalse: [ super pltCopyGroup: aClassSymbol to: anObject ]

! !

!ExChdAttributeDtdElement methodsFor: 'platypus-generated-copying' stamp: ''!
pltCopyTo: another
	super pltCopyTo: another.
	self attributeDtdElementCopyTo: another

! !

!ExChdAttributeDtdElement methodsFor: 'platypus-generated-copying' stamp: ''!
pltLocalCopyTo: another
	self attributeDtdElementCopyTo: another

! !

!ExChdAttributeDtdElement methodsFor: 'platypus-generated-set-accessing' stamp: ''!
setAttribute: aExChdAttribute
	self attribute: aExChdAttribute

! !

!ExChdAttributeDtdElement methodsFor: 'platypus-generated-set-accessing' stamp: ''!
setDomain: aExChdDomainDtdElement
	self domain: aExChdDomainDtdElement

! !

!ExChdAttributeDtdElement methodsFor: 'platypus-generated-initializing' stamp: ''!
stepInitialize
	super stepInitialize.
	attribute := nil.
	domain := nil

! !

!ExChdAttributeDtdElement methodsFor: 'platypus-generated-deriving' stamp: ''!
tag
	^ self tagUsingContext: self class context

! !

!ExChdAttributeDtdElement methodsFor: 'platypus-generated-deriving' stamp: ''!
tagUsingContext: aContext
	^ self tagUsingContext: aContext receiver: self

! !

!ExChdAttributeDtdElement methodsFor: 'platypus-generated-deriving' stamp: ''!
tagUsingContext: aContext receiver: aReceiver
	^ PTsLowerizeFunction
		invokeFromValues:
			(OrderedCollection new
				add: (aReceiver attribute nameUsingContext: self class context);
				yourself)

! !

!ExChdAttributeDtdElement methodsFor: 'platypus-generated-group-accessing' stamp: ''!
toValues: values
	^ self attributeDtdElementToValues: (super toValues: values)

! !

ExChdDtdElement subclass: #ExChdCompositeDtdElement
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Express2Cheddar-CheddarDtdSchema'!

!ExChdCompositeDtdElement commentStamp: 'platypus comment' prior: 0!
<ISO10303-11-EXPRESS>
ENTITY composite_dtd_element 
	ABSTRACT SUPERTYPE 
	SUBTYPE OF ( dtd_element );
DERIVE
	subs : LIST OF dtd_element := [ ];
END_ENTITY;
</ISO10303-11-EXPRESS>!

!ExChdCompositeDtdElement class methodsFor: 'platypus-generated-platypus-signature' stamp: ''!
iso10303P11Translater
	^ 'Platypus (c) LISYC EA3883, Universite de Bretagne occidentale. Brest.'

! !

!ExChdCompositeDtdElement class methodsFor: 'platypus-generated-meta-data-accessing' stamp: ''!
schemaDefinition
	^ ExChdCheddarDtdSchemaDefinition singleton

! !

!ExChdCompositeDtdElement class methodsFor: 'platypus-generated-meta-data-accessing' stamp: ''!
schemaInstance
	^ ExChdExpress2cheddarSchemaInstance singleton

! !

!ExChdCompositeDtdElement class methodsFor: 'platypus-generated-platypus-signature' stamp: ''!
translatedFromISO10303P11
	^ true

! !

!ExChdCompositeDtdElement class methodsFor: 'platypus-generated-platypus-signature' stamp: ''!
vwNamespaceName
	^ #Express2Cheddar

! !

!ExChdCompositeDtdElement methodsFor: 'platypus-generated-visiting' stamp: ''!
accept: aVisitor
	^ aVisitor acceptCompositeDtdElement: self

! !

!ExChdCompositeDtdElement methodsFor: 'platypus-generated-copying' stamp: ''!
compositeDtdElementCopyTo: another
	

! !

!ExChdCompositeDtdElement methodsFor: 'platypus-generated-group-accessing' stamp: ''!
compositeDtdElementFromValues: values
	| valuesloc |
	valuesloc := values asOrderedCollection.
	^ valuesloc

! !

!ExChdCompositeDtdElement methodsFor: 'platypus-generated-group-accessing' stamp: ''!
compositeDtdElementToValues: values
	^ values

! !

!ExChdCompositeDtdElement methodsFor: 'platypus-generated-group-accessing' stamp: ''!
fromValues: values
	^ self compositeDtdElementFromValues: (super fromValues: values)

! !

!ExChdCompositeDtdElement methodsFor: 'platypus-generated-classifying' stamp: ''!
isExChdCompositeDtdElement
	^ true

! !

!ExChdCompositeDtdElement methodsFor: 'platypus-generated-group-accessing' stamp: ''!
localFromValues: values
	^ self compositeDtdElementFromValues: values

! !

!ExChdCompositeDtdElement methodsFor: 'platypus-generated-group-accessing' stamp: ''!
localToValues: values
	^ self compositeDtdElementToValues: values

! !

!ExChdCompositeDtdElement methodsFor: 'platypus-generated-copying' stamp: ''!
pltCopyGroup: aClassSymbol to: anObject
	self class name == aClassSymbol
		ifTrue: [ self pltCopyTo: anObject ]
		ifFalse: [ super pltCopyGroup: aClassSymbol to: anObject ]

! !

!ExChdCompositeDtdElement methodsFor: 'platypus-generated-copying' stamp: ''!
pltCopyTo: another
	super pltCopyTo: another.
	self compositeDtdElementCopyTo: another

! !

!ExChdCompositeDtdElement methodsFor: 'platypus-generated-copying' stamp: ''!
pltLocalCopyTo: another
	self compositeDtdElementCopyTo: another

! !

!ExChdCompositeDtdElement methodsFor: 'platypus-generated-initializing' stamp: ''!
stepInitialize
	super stepInitialize

! !

!ExChdCompositeDtdElement methodsFor: 'platypus-generated-deriving' stamp: ''!
subs
	^ self subsUsingContext: self class context

! !

!ExChdCompositeDtdElement methodsFor: 'platypus-generated-deriving' stamp: ''!
subsUsingContext: aContext
	^ self subsUsingContext: aContext receiver: self

! !

!ExChdCompositeDtdElement methodsFor: 'platypus-generated-deriving' stamp: ''!
subsUsingContext: aContext receiver: aReceiver
	^ Array new

! !

!ExChdCompositeDtdElement methodsFor: 'platypus-generated-group-accessing' stamp: ''!
toValues: values
	^ self compositeDtdElementToValues: (super toValues: values)

! !

ExChdCompositeDtdElement subclass: #ExChdEntityDtdElement
	instanceVariableNames: 'domain'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Express2Cheddar-CheddarDtdSchema'!

!ExChdEntityDtdElement commentStamp: 'platypus comment' prior: 0!
<ISO10303-11-EXPRESS>
ENTITY entity_dtd_element 
	SUBTYPE OF ( composite_dtd_element );
	domain : ada_entity;
DERIVE
	SELF\dtd_element.tag : STRING := lowerize ( domain.name );
	SELF\composite_dtd_element.subs : LIST OF dtd_element := compute_entity_sub_elements ( SELF );
	SELF\dtd_element.dtd_code : STRING := compute_entity_dtd_code ( SELF );
END_ENTITY;
</ISO10303-11-EXPRESS>!

ExChdEntityDtdElement subclass: #ExChdAdaClassDtdElement
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Express2Cheddar-CheddarDtdSchema'!

!ExChdAdaClassDtdElement commentStamp: 'platypus comment' prior: 0!
<ISO10303-11-EXPRESS>
ENTITY ada_class_dtd_element 
	SUBTYPE OF ( entity_dtd_element );
END_ENTITY;
</ISO10303-11-EXPRESS>!

!ExChdAdaClassDtdElement class methodsFor: 'platypus-generated-platypus-signature' stamp: ''!
iso10303P11Translater
	^ 'Platypus (c) LISYC EA3883, Universite de Bretagne occidentale. Brest.'

! !

!ExChdAdaClassDtdElement class methodsFor: 'platypus-generated-meta-data-accessing' stamp: ''!
schemaDefinition
	^ ExChdCheddarDtdSchemaDefinition singleton

! !

!ExChdAdaClassDtdElement class methodsFor: 'platypus-generated-meta-data-accessing' stamp: ''!
schemaInstance
	^ ExChdExpress2cheddarSchemaInstance singleton

! !

!ExChdAdaClassDtdElement class methodsFor: 'platypus-generated-platypus-signature' stamp: ''!
translatedFromISO10303P11
	^ true

! !

!ExChdAdaClassDtdElement class methodsFor: 'platypus-generated-platypus-signature' stamp: ''!
vwNamespaceName
	^ #Express2Cheddar

! !

!ExChdAdaClassDtdElement methodsFor: 'platypus-generated-visiting' stamp: ''!
accept: aVisitor
	^ aVisitor acceptAdaClassDtdElement: self

! !

!ExChdAdaClassDtdElement methodsFor: 'platypus-generated-copying' stamp: ''!
adaClassDtdElementCopyTo: another
	

! !

!ExChdAdaClassDtdElement methodsFor: 'platypus-generated-group-accessing' stamp: ''!
adaClassDtdElementFromValues: values
	| valuesloc |
	valuesloc := values asOrderedCollection.
	^ valuesloc

! !

!ExChdAdaClassDtdElement methodsFor: 'platypus-generated-group-accessing' stamp: ''!
adaClassDtdElementToValues: values
	^ values

! !

!ExChdAdaClassDtdElement methodsFor: 'platypus-generated-group-accessing' stamp: ''!
fromValues: values
	^ self adaClassDtdElementFromValues: (super fromValues: values)

! !

!ExChdAdaClassDtdElement methodsFor: 'platypus-generated-classifying' stamp: ''!
isExChdAdaClassDtdElement
	^ true

! !

!ExChdAdaClassDtdElement methodsFor: 'platypus-generated-group-accessing' stamp: ''!
localFromValues: values
	^ self adaClassDtdElementFromValues: values

! !

!ExChdAdaClassDtdElement methodsFor: 'platypus-generated-group-accessing' stamp: ''!
localToValues: values
	^ self adaClassDtdElementToValues: values

! !

!ExChdAdaClassDtdElement methodsFor: 'platypus-generated-copying' stamp: ''!
pltCopyGroup: aClassSymbol to: anObject
	self class name == aClassSymbol
		ifTrue: [ self pltCopyTo: anObject ]
		ifFalse: [ super pltCopyGroup: aClassSymbol to: anObject ]

! !

!ExChdAdaClassDtdElement methodsFor: 'platypus-generated-copying' stamp: ''!
pltCopyTo: another
	super pltCopyTo: another.
	self adaClassDtdElementCopyTo: another

! !

!ExChdAdaClassDtdElement methodsFor: 'platypus-generated-copying' stamp: ''!
pltLocalCopyTo: another
	self adaClassDtdElementCopyTo: another

! !

!ExChdAdaClassDtdElement methodsFor: 'platypus-generated-initializing' stamp: ''!
stepInitialize
	super stepInitialize

! !

!ExChdAdaClassDtdElement methodsFor: 'platypus-generated-group-accessing' stamp: ''!
toValues: values
	^ self adaClassDtdElementToValues: (super toValues: values)

! !

ExChdEntityDtdElement subclass: #ExChdDiscriminatedTypeDtdElement
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Express2Cheddar-CheddarDtdSchema'!

!ExChdDiscriminatedTypeDtdElement commentStamp: 'platypus comment' prior: 0!
<ISO10303-11-EXPRESS>
ENTITY discriminated_type_dtd_element 
	SUBTYPE OF ( entity_dtd_element );
DERIVE
	SELF\entity_dtd_element.subs : LIST OF dtd_element := compute_discriminated_type_sub_elements ( SELF );
	SELF\entity_dtd_element.dtd_code : STRING := compute_discriminated_type_code ( SELF );
END_ENTITY;
</ISO10303-11-EXPRESS>!

!ExChdDiscriminatedTypeDtdElement class methodsFor: 'platypus-generated-platypus-signature' stamp: ''!
iso10303P11Translater
	^ 'Platypus (c) LISYC EA3883, Universite de Bretagne occidentale. Brest.'

! !

!ExChdDiscriminatedTypeDtdElement class methodsFor: 'platypus-generated-meta-data-accessing' stamp: ''!
schemaDefinition
	^ ExChdCheddarDtdSchemaDefinition singleton

! !

!ExChdDiscriminatedTypeDtdElement class methodsFor: 'platypus-generated-meta-data-accessing' stamp: ''!
schemaInstance
	^ ExChdExpress2cheddarSchemaInstance singleton

! !

!ExChdDiscriminatedTypeDtdElement class methodsFor: 'platypus-generated-platypus-signature' stamp: ''!
translatedFromISO10303P11
	^ true

! !

!ExChdDiscriminatedTypeDtdElement class methodsFor: 'platypus-generated-platypus-signature' stamp: ''!
vwNamespaceName
	^ #Express2Cheddar

! !

!ExChdDiscriminatedTypeDtdElement methodsFor: 'platypus-generated-visiting' stamp: ''!
accept: aVisitor
	^ aVisitor acceptDiscriminatedTypeDtdElement: self

! !

!ExChdDiscriminatedTypeDtdElement methodsFor: 'platypus-generated-copying' stamp: ''!
discriminatedTypeDtdElementCopyTo: another
	

! !

!ExChdDiscriminatedTypeDtdElement methodsFor: 'platypus-generated-group-accessing' stamp: ''!
discriminatedTypeDtdElementFromValues: values
	| valuesloc |
	valuesloc := values asOrderedCollection.
	^ valuesloc

! !

!ExChdDiscriminatedTypeDtdElement methodsFor: 'platypus-generated-group-accessing' stamp: ''!
discriminatedTypeDtdElementToValues: values
	^ values

! !

!ExChdDiscriminatedTypeDtdElement methodsFor: 'platypus-generated-deriving' stamp: ''!
dtdCode
	^ self dtdCodeUsingContext: self class context

! !

!ExChdDiscriminatedTypeDtdElement methodsFor: 'platypus-generated-deriving' stamp: ''!
dtdCodeUsingContext: aContext
	^ self dtdCodeUsingContext: aContext receiver: self

! !

!ExChdDiscriminatedTypeDtdElement methodsFor: 'platypus-generated-deriving' stamp: ''!
dtdCodeUsingContext: aContext receiver: aReceiver
	^ ExChdComputeDiscriminatedTypeCodeFunction
		invokeFromValues:
			(OrderedCollection new
				add: aReceiver;
				yourself)

! !

!ExChdDiscriminatedTypeDtdElement methodsFor: 'platypus-generated-group-accessing' stamp: ''!
fromValues: values
	^ self discriminatedTypeDtdElementFromValues: (super fromValues: values)

! !

!ExChdDiscriminatedTypeDtdElement methodsFor: 'platypus-generated-classifying' stamp: ''!
isExChdDiscriminatedTypeDtdElement
	^ true

! !

!ExChdDiscriminatedTypeDtdElement methodsFor: 'platypus-generated-group-accessing' stamp: ''!
localFromValues: values
	^ self discriminatedTypeDtdElementFromValues: values

! !

!ExChdDiscriminatedTypeDtdElement methodsFor: 'platypus-generated-group-accessing' stamp: ''!
localToValues: values
	^ self discriminatedTypeDtdElementToValues: values

! !

!ExChdDiscriminatedTypeDtdElement methodsFor: 'platypus-generated-copying' stamp: ''!
pltCopyGroup: aClassSymbol to: anObject
	self class name == aClassSymbol
		ifTrue: [ self pltCopyTo: anObject ]
		ifFalse: [ super pltCopyGroup: aClassSymbol to: anObject ]

! !

!ExChdDiscriminatedTypeDtdElement methodsFor: 'platypus-generated-copying' stamp: ''!
pltCopyTo: another
	super pltCopyTo: another.
	self discriminatedTypeDtdElementCopyTo: another

! !

!ExChdDiscriminatedTypeDtdElement methodsFor: 'platypus-generated-copying' stamp: ''!
pltLocalCopyTo: another
	self discriminatedTypeDtdElementCopyTo: another

! !

!ExChdDiscriminatedTypeDtdElement methodsFor: 'platypus-generated-initializing' stamp: ''!
stepInitialize
	super stepInitialize

! !

!ExChdDiscriminatedTypeDtdElement methodsFor: 'platypus-generated-deriving' stamp: ''!
subs
	^ self subsUsingContext: self class context

! !

!ExChdDiscriminatedTypeDtdElement methodsFor: 'platypus-generated-deriving' stamp: ''!
subsUsingContext: aContext
	^ self subsUsingContext: aContext receiver: self

! !

!ExChdDiscriminatedTypeDtdElement methodsFor: 'platypus-generated-deriving' stamp: ''!
subsUsingContext: aContext receiver: aReceiver
	^ ExChdComputeDiscriminatedTypeSubElementsFunction
		invokeFromValues:
			(OrderedCollection new
				add: aReceiver;
				yourself)

! !

!ExChdDiscriminatedTypeDtdElement methodsFor: 'platypus-generated-group-accessing' stamp: ''!
toValues: values
	^ self discriminatedTypeDtdElementToValues: (super toValues: values)

! !

!ExChdEntityDtdElement class methodsFor: 'platypus-generated-platypus-signature' stamp: ''!
iso10303P11Translater
	^ 'Platypus (c) LISYC EA3883, Universite de Bretagne occidentale. Brest.'

! !

!ExChdEntityDtdElement class methodsFor: 'platypus-generated-meta-data-accessing' stamp: ''!
schemaDefinition
	^ ExChdCheddarDtdSchemaDefinition singleton

! !

!ExChdEntityDtdElement class methodsFor: 'platypus-generated-meta-data-accessing' stamp: ''!
schemaInstance
	^ ExChdExpress2cheddarSchemaInstance singleton

! !

!ExChdEntityDtdElement class methodsFor: 'platypus-generated-platypus-signature' stamp: ''!
translatedFromISO10303P11
	^ true

! !

!ExChdEntityDtdElement class methodsFor: 'platypus-generated-platypus-signature' stamp: ''!
vwNamespaceName
	^ #Express2Cheddar

! !

!ExChdEntityDtdElement methodsFor: 'platypus-generated-visiting' stamp: ''!
accept: aVisitor
	^ aVisitor acceptEntityDtdElement: self

! !

!ExChdEntityDtdElement methodsFor: 'platypus-generated-accessing' stamp: ''!
domain
	^ domain

! !

!ExChdEntityDtdElement methodsFor: 'platypus-generated-accessing' stamp: ''!
domain: aExChdAdaEntity
	domain := aExChdAdaEntity

! !

!ExChdEntityDtdElement methodsFor: 'platypus-generated-with-context-accessing' stamp: ''!
domainUsingContext: aContext
	^ self domain

! !

!ExChdEntityDtdElement methodsFor: 'platypus-generated-deriving' stamp: ''!
dtdCode
	^ self dtdCodeUsingContext: self class context

! !

!ExChdEntityDtdElement methodsFor: 'platypus-generated-deriving' stamp: ''!
dtdCodeUsingContext: aContext
	^ self dtdCodeUsingContext: aContext receiver: self

! !

!ExChdEntityDtdElement methodsFor: 'platypus-generated-deriving' stamp: ''!
dtdCodeUsingContext: aContext receiver: aReceiver
	^ ExChdComputeEntityDtdCodeFunction
		invokeFromValues:
			(OrderedCollection new
				add: aReceiver;
				yourself)

! !

!ExChdEntityDtdElement methodsFor: 'platypus-generated-copying' stamp: ''!
entityDtdElementCopyTo: another
	another fastSetDomain: self domain

! !

!ExChdEntityDtdElement methodsFor: 'platypus-generated-group-accessing' stamp: ''!
entityDtdElementFromValues: values
	| valuesloc |
	valuesloc := values asOrderedCollection.
	self setDomain: valuesloc removeFirst.
	^ valuesloc

! !

!ExChdEntityDtdElement methodsFor: 'platypus-generated-group-accessing' stamp: ''!
entityDtdElementToValues: values
	values add: self domain.
	^ values

! !

!ExChdEntityDtdElement methodsFor: 'platypus-generated-fast-set-accessing' stamp: ''!
fastSetDomain: aExChdAdaEntity
	domain := aExChdAdaEntity

! !

!ExChdEntityDtdElement methodsFor: 'platypus-generated-group-accessing' stamp: ''!
fromValues: values
	^ self entityDtdElementFromValues: (super fromValues: values)

! !

!ExChdEntityDtdElement methodsFor: 'platypus-generated-classifying' stamp: ''!
isExChdEntityDtdElement
	^ true

! !

!ExChdEntityDtdElement methodsFor: 'platypus-generated-group-accessing' stamp: ''!
localFromValues: values
	^ self entityDtdElementFromValues: values

! !

!ExChdEntityDtdElement methodsFor: 'platypus-generated-group-accessing' stamp: ''!
localToValues: values
	^ self entityDtdElementToValues: values

! !

!ExChdEntityDtdElement methodsFor: 'platypus-generated-copying' stamp: ''!
pltCopyGroup: aClassSymbol to: anObject
	self class name == aClassSymbol
		ifTrue: [ self pltCopyTo: anObject ]
		ifFalse: [ super pltCopyGroup: aClassSymbol to: anObject ]

! !

!ExChdEntityDtdElement methodsFor: 'platypus-generated-copying' stamp: ''!
pltCopyTo: another
	super pltCopyTo: another.
	self entityDtdElementCopyTo: another

! !

!ExChdEntityDtdElement methodsFor: 'platypus-generated-copying' stamp: ''!
pltLocalCopyTo: another
	self entityDtdElementCopyTo: another

! !

!ExChdEntityDtdElement methodsFor: 'platypus-generated-set-accessing' stamp: ''!
setDomain: aExChdAdaEntity
	self domain: aExChdAdaEntity

! !

!ExChdEntityDtdElement methodsFor: 'platypus-generated-initializing' stamp: ''!
stepInitialize
	super stepInitialize.
	domain := nil

! !

!ExChdEntityDtdElement methodsFor: 'platypus-generated-deriving' stamp: ''!
subs
	^ self subsUsingContext: self class context

! !

!ExChdEntityDtdElement methodsFor: 'platypus-generated-deriving' stamp: ''!
subsUsingContext: aContext
	^ self subsUsingContext: aContext receiver: self

! !

!ExChdEntityDtdElement methodsFor: 'platypus-generated-deriving' stamp: ''!
subsUsingContext: aContext receiver: aReceiver
	^ ExChdComputeEntitySubElementsFunction
		invokeFromValues:
			(OrderedCollection new
				add: aReceiver;
				yourself)

! !

!ExChdEntityDtdElement methodsFor: 'platypus-generated-deriving' stamp: ''!
tag
	^ self tagUsingContext: self class context

! !

!ExChdEntityDtdElement methodsFor: 'platypus-generated-deriving' stamp: ''!
tagUsingContext: aContext
	^ self tagUsingContext: aContext receiver: self

! !

!ExChdEntityDtdElement methodsFor: 'platypus-generated-deriving' stamp: ''!
tagUsingContext: aContext receiver: aReceiver
	^ PTsLowerizeFunction
		invokeFromValues:
			(OrderedCollection new
				add: (aReceiver domain nameUsingContext: self class context);
				yourself)

! !

!ExChdEntityDtdElement methodsFor: 'platypus-generated-group-accessing' stamp: ''!
toValues: values
	^ self entityDtdElementToValues: (super toValues: values)

! !

ExChdEntityDtdElement subclass: #ExChdRecordDtdElement
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Express2Cheddar-CheddarDtdSchema'!

!ExChdRecordDtdElement commentStamp: 'platypus comment' prior: 0!
<ISO10303-11-EXPRESS>
ENTITY record_dtd_element 
	SUBTYPE OF ( entity_dtd_element );
END_ENTITY;
</ISO10303-11-EXPRESS>!

!ExChdRecordDtdElement class methodsFor: 'platypus-generated-platypus-signature' stamp: ''!
iso10303P11Translater
	^ 'Platypus (c) LISYC EA3883, Universite de Bretagne occidentale. Brest.'

! !

!ExChdRecordDtdElement class methodsFor: 'platypus-generated-meta-data-accessing' stamp: ''!
schemaDefinition
	^ ExChdCheddarDtdSchemaDefinition singleton

! !

!ExChdRecordDtdElement class methodsFor: 'platypus-generated-meta-data-accessing' stamp: ''!
schemaInstance
	^ ExChdExpress2cheddarSchemaInstance singleton

! !

!ExChdRecordDtdElement class methodsFor: 'platypus-generated-platypus-signature' stamp: ''!
translatedFromISO10303P11
	^ true

! !

!ExChdRecordDtdElement class methodsFor: 'platypus-generated-platypus-signature' stamp: ''!
vwNamespaceName
	^ #Express2Cheddar

! !

!ExChdRecordDtdElement methodsFor: 'platypus-generated-visiting' stamp: ''!
accept: aVisitor
	^ aVisitor acceptRecordDtdElement: self

! !

!ExChdRecordDtdElement methodsFor: 'platypus-generated-group-accessing' stamp: ''!
fromValues: values
	^ self recordDtdElementFromValues: (super fromValues: values)

! !

!ExChdRecordDtdElement methodsFor: 'platypus-generated-classifying' stamp: ''!
isExChdRecordDtdElement
	^ true

! !

!ExChdRecordDtdElement methodsFor: 'platypus-generated-group-accessing' stamp: ''!
localFromValues: values
	^ self recordDtdElementFromValues: values

! !

!ExChdRecordDtdElement methodsFor: 'platypus-generated-group-accessing' stamp: ''!
localToValues: values
	^ self recordDtdElementToValues: values

! !

!ExChdRecordDtdElement methodsFor: 'platypus-generated-copying' stamp: ''!
pltCopyGroup: aClassSymbol to: anObject
	self class name == aClassSymbol
		ifTrue: [ self pltCopyTo: anObject ]
		ifFalse: [ super pltCopyGroup: aClassSymbol to: anObject ]

! !

!ExChdRecordDtdElement methodsFor: 'platypus-generated-copying' stamp: ''!
pltCopyTo: another
	super pltCopyTo: another.
	self recordDtdElementCopyTo: another

! !

!ExChdRecordDtdElement methodsFor: 'platypus-generated-copying' stamp: ''!
pltLocalCopyTo: another
	self recordDtdElementCopyTo: another

! !

!ExChdRecordDtdElement methodsFor: 'platypus-generated-copying' stamp: ''!
recordDtdElementCopyTo: another
	

! !

!ExChdRecordDtdElement methodsFor: 'platypus-generated-group-accessing' stamp: ''!
recordDtdElementFromValues: values
	| valuesloc |
	valuesloc := values asOrderedCollection.
	^ valuesloc

! !

!ExChdRecordDtdElement methodsFor: 'platypus-generated-group-accessing' stamp: ''!
recordDtdElementToValues: values
	^ values

! !

!ExChdRecordDtdElement methodsFor: 'platypus-generated-initializing' stamp: ''!
stepInitialize
	super stepInitialize

! !

!ExChdRecordDtdElement methodsFor: 'platypus-generated-group-accessing' stamp: ''!
toValues: values
	^ self recordDtdElementToValues: (super toValues: values)

! !

ExChdCompositeDtdElement subclass: #ExChdPackageDtdElement
	instanceVariableNames: 'package'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Express2Cheddar-CheddarDtdSchema'!

!ExChdPackageDtdElement commentStamp: 'platypus comment' prior: 0!
<ISO10303-11-EXPRESS>
ENTITY package_dtd_element 
	SUBTYPE OF ( composite_dtd_element );
	package : ada_package;
DERIVE
	SELF\dtd_element.tag : STRING := lowerize ( package.name );
	SELF\composite_dtd_element.subs : LIST OF dtd_element := compute_package_sub_elements ( SELF );
	SELF\dtd_element.dtd_code : STRING := compute_package_dtd_code ( SELF );
	attributes : LIST OF attribute_dtd_element := compute_package_attribute_dtd_elements ( SELF );
END_ENTITY;
</ISO10303-11-EXPRESS>!

!ExChdPackageDtdElement class methodsFor: 'platypus-generated-platypus-signature' stamp: ''!
iso10303P11Translater
	^ 'Platypus (c) LISYC EA3883, Universite de Bretagne occidentale. Brest.'

! !

!ExChdPackageDtdElement class methodsFor: 'platypus-generated-meta-data-accessing' stamp: ''!
schemaDefinition
	^ ExChdCheddarDtdSchemaDefinition singleton

! !

!ExChdPackageDtdElement class methodsFor: 'platypus-generated-meta-data-accessing' stamp: ''!
schemaInstance
	^ ExChdExpress2cheddarSchemaInstance singleton

! !

!ExChdPackageDtdElement class methodsFor: 'platypus-generated-platypus-signature' stamp: ''!
translatedFromISO10303P11
	^ true

! !

!ExChdPackageDtdElement class methodsFor: 'platypus-generated-platypus-signature' stamp: ''!
vwNamespaceName
	^ #Express2Cheddar

! !

!ExChdPackageDtdElement methodsFor: 'platypus-generated-visiting' stamp: ''!
accept: aVisitor
	^ aVisitor acceptPackageDtdElement: self

! !

!ExChdPackageDtdElement methodsFor: 'platypus-generated-deriving' stamp: ''!
attributes
	^ self attributesUsingContext: self class context

! !

!ExChdPackageDtdElement methodsFor: 'platypus-generated-deriving' stamp: ''!
attributesUsingContext: aContext
	^ self attributesUsingContext: aContext receiver: self

! !

!ExChdPackageDtdElement methodsFor: 'platypus-generated-deriving' stamp: ''!
attributesUsingContext: aContext receiver: aReceiver
	^ ExChdComputePackageAttributeDtdElementsFunction
		invokeFromValues:
			(OrderedCollection new
				add: aReceiver;
				yourself)

! !

!ExChdPackageDtdElement methodsFor: 'platypus-generated-deriving' stamp: ''!
dtdCode
	^ self dtdCodeUsingContext: self class context

! !

!ExChdPackageDtdElement methodsFor: 'platypus-generated-deriving' stamp: ''!
dtdCodeUsingContext: aContext
	^ self dtdCodeUsingContext: aContext receiver: self

! !

!ExChdPackageDtdElement methodsFor: 'platypus-generated-deriving' stamp: ''!
dtdCodeUsingContext: aContext receiver: aReceiver
	^ ExChdComputePackageDtdCodeFunction
		invokeFromValues:
			(OrderedCollection new
				add: aReceiver;
				yourself)

! !

!ExChdPackageDtdElement methodsFor: 'platypus-generated-fast-set-accessing' stamp: ''!
fastSetPackage: aExChdAdaPackage
	package := aExChdAdaPackage

! !

!ExChdPackageDtdElement methodsFor: 'platypus-generated-group-accessing' stamp: ''!
fromValues: values
	^ self packageDtdElementFromValues: (super fromValues: values)

! !

!ExChdPackageDtdElement methodsFor: 'platypus-generated-classifying' stamp: ''!
isExChdPackageDtdElement
	^ true

! !

!ExChdPackageDtdElement methodsFor: 'platypus-generated-group-accessing' stamp: ''!
localFromValues: values
	^ self packageDtdElementFromValues: values

! !

!ExChdPackageDtdElement methodsFor: 'platypus-generated-group-accessing' stamp: ''!
localToValues: values
	^ self packageDtdElementToValues: values

! !

!ExChdPackageDtdElement methodsFor: 'platypus-generated-accessing' stamp: ''!
package
	^ package

! !

!ExChdPackageDtdElement methodsFor: 'platypus-generated-accessing' stamp: ''!
package: aExChdAdaPackage
	package := aExChdAdaPackage

! !

!ExChdPackageDtdElement methodsFor: 'platypus-generated-copying' stamp: ''!
packageDtdElementCopyTo: another
	another fastSetPackage: self package

! !

!ExChdPackageDtdElement methodsFor: 'platypus-generated-group-accessing' stamp: ''!
packageDtdElementFromValues: values
	| valuesloc |
	valuesloc := values asOrderedCollection.
	self setPackage: valuesloc removeFirst.
	^ valuesloc

! !

!ExChdPackageDtdElement methodsFor: 'platypus-generated-group-accessing' stamp: ''!
packageDtdElementToValues: values
	values add: self package.
	^ values

! !

!ExChdPackageDtdElement methodsFor: 'platypus-generated-with-context-accessing' stamp: ''!
packageUsingContext: aContext
	^ self package

! !

!ExChdPackageDtdElement methodsFor: 'platypus-generated-copying' stamp: ''!
pltCopyGroup: aClassSymbol to: anObject
	self class name == aClassSymbol
		ifTrue: [ self pltCopyTo: anObject ]
		ifFalse: [ super pltCopyGroup: aClassSymbol to: anObject ]

! !

!ExChdPackageDtdElement methodsFor: 'platypus-generated-copying' stamp: ''!
pltCopyTo: another
	super pltCopyTo: another.
	self packageDtdElementCopyTo: another

! !

!ExChdPackageDtdElement methodsFor: 'platypus-generated-copying' stamp: ''!
pltLocalCopyTo: another
	self packageDtdElementCopyTo: another

! !

!ExChdPackageDtdElement methodsFor: 'platypus-generated-set-accessing' stamp: ''!
setPackage: aExChdAdaPackage
	self package: aExChdAdaPackage

! !

!ExChdPackageDtdElement methodsFor: 'platypus-generated-initializing' stamp: ''!
stepInitialize
	super stepInitialize.
	package := nil

! !

!ExChdPackageDtdElement methodsFor: 'platypus-generated-deriving' stamp: ''!
subs
	^ self subsUsingContext: self class context

! !

!ExChdPackageDtdElement methodsFor: 'platypus-generated-deriving' stamp: ''!
subsUsingContext: aContext
	^ self subsUsingContext: aContext receiver: self

! !

!ExChdPackageDtdElement methodsFor: 'platypus-generated-deriving' stamp: ''!
subsUsingContext: aContext receiver: aReceiver
	^ ExChdComputePackageSubElementsFunction
		invokeFromValues:
			(OrderedCollection new
				add: aReceiver;
				yourself)

! !

!ExChdPackageDtdElement methodsFor: 'platypus-generated-deriving' stamp: ''!
tag
	^ self tagUsingContext: self class context

! !

!ExChdPackageDtdElement methodsFor: 'platypus-generated-deriving' stamp: ''!
tagUsingContext: aContext
	^ self tagUsingContext: aContext receiver: self

! !

!ExChdPackageDtdElement methodsFor: 'platypus-generated-deriving' stamp: ''!
tagUsingContext: aContext receiver: aReceiver
	^ PTsLowerizeFunction
		invokeFromValues:
			(OrderedCollection new
				add: (aReceiver package nameUsingContext: self class context);
				yourself)

! !

!ExChdPackageDtdElement methodsFor: 'platypus-generated-group-accessing' stamp: ''!
toValues: values
	^ self packageDtdElementToValues: (super toValues: values)

! !

ExChdCompositeDtdElement subclass: #ExChdRootDtdElement
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Express2Cheddar-CheddarDtdSchema'!

!ExChdRootDtdElement commentStamp: 'platypus comment' prior: 0!
<ISO10303-11-EXPRESS>
ENTITY root_dtd_element 
	SUBTYPE OF ( composite_dtd_element );
DERIVE
	packages : LIST OF ada_package := xml_packages_with_tag ( SELF.tag );
	SELF\composite_dtd_element.subs : LIST OF package_dtd_element := compute_root_sub_elements ( SELF );
	SELF\dtd_element.dtd_code : STRING := compute_root_dtd_code ( SELF );
	declared_domains : LIST OF dtd_element := get_declared_entity_domains ( subs );
	referenced_entities : LIST OF dtd_element := get_referenced_entity_domains ( subs );
	implicit_domains : LIST OF entity_ref_dtd_element := compute_implicit_domains ( SELF );
END_ENTITY;
</ISO10303-11-EXPRESS>!

!ExChdRootDtdElement class methodsFor: 'platypus-generated-platypus-signature' stamp: ''!
iso10303P11Translater
	^ 'Platypus (c) LISYC EA3883, Universite de Bretagne occidentale. Brest.'

! !

!ExChdRootDtdElement class methodsFor: 'platypus-generated-meta-data-accessing' stamp: ''!
schemaDefinition
	^ ExChdCheddarDtdSchemaDefinition singleton

! !

!ExChdRootDtdElement class methodsFor: 'platypus-generated-meta-data-accessing' stamp: ''!
schemaInstance
	^ ExChdExpress2cheddarSchemaInstance singleton

! !

!ExChdRootDtdElement class methodsFor: 'platypus-generated-platypus-signature' stamp: ''!
translatedFromISO10303P11
	^ true

! !

!ExChdRootDtdElement class methodsFor: 'platypus-generated-platypus-signature' stamp: ''!
vwNamespaceName
	^ #Express2Cheddar

! !

!ExChdRootDtdElement methodsFor: 'platypus-generated-visiting' stamp: ''!
accept: aVisitor
	^ aVisitor acceptRootDtdElement: self

! !

!ExChdRootDtdElement methodsFor: 'platypus-generated-deriving' stamp: ''!
declaredDomains
	^ self declaredDomainsUsingContext: self class context

! !

!ExChdRootDtdElement methodsFor: 'platypus-generated-deriving' stamp: ''!
declaredDomainsUsingContext: aContext
	^ self declaredDomainsUsingContext: aContext receiver: self

! !

!ExChdRootDtdElement methodsFor: 'platypus-generated-deriving' stamp: ''!
declaredDomainsUsingContext: aContext receiver: aReceiver
	^ ExChdGetDeclaredEntityDomainsFunction
		invokeFromValues:
			(OrderedCollection new
				add: (aReceiver subsUsingContext: aContext);
				yourself)

! !

!ExChdRootDtdElement methodsFor: 'platypus-generated-deriving' stamp: ''!
dtdCode
	^ self dtdCodeUsingContext: self class context

! !

!ExChdRootDtdElement methodsFor: 'platypus-generated-deriving' stamp: ''!
dtdCodeUsingContext: aContext
	^ self dtdCodeUsingContext: aContext receiver: self

! !

!ExChdRootDtdElement methodsFor: 'platypus-generated-deriving' stamp: ''!
dtdCodeUsingContext: aContext receiver: aReceiver
	^ ExChdComputeRootDtdCodeFunction
		invokeFromValues:
			(OrderedCollection new
				add: aReceiver;
				yourself)

! !

!ExChdRootDtdElement methodsFor: 'platypus-generated-group-accessing' stamp: ''!
fromValues: values
	^ self rootDtdElementFromValues: (super fromValues: values)

! !

!ExChdRootDtdElement methodsFor: 'platypus-generated-deriving' stamp: ''!
implicitDomains
	^ self implicitDomainsUsingContext: self class context

! !

!ExChdRootDtdElement methodsFor: 'platypus-generated-deriving' stamp: ''!
implicitDomainsUsingContext: aContext
	^ self implicitDomainsUsingContext: aContext receiver: self

! !

!ExChdRootDtdElement methodsFor: 'platypus-generated-deriving' stamp: ''!
implicitDomainsUsingContext: aContext receiver: aReceiver
	^ ExChdComputeImplicitDomainsFunction
		invokeFromValues:
			(OrderedCollection new
				add: aReceiver;
				yourself)

! !

!ExChdRootDtdElement methodsFor: 'platypus-generated-classifying' stamp: ''!
isExChdRootDtdElement
	^ true

! !

!ExChdRootDtdElement methodsFor: 'platypus-generated-group-accessing' stamp: ''!
localFromValues: values
	^ self rootDtdElementFromValues: values

! !

!ExChdRootDtdElement methodsFor: 'platypus-generated-group-accessing' stamp: ''!
localToValues: values
	^ self rootDtdElementToValues: values

! !

!ExChdRootDtdElement methodsFor: 'platypus-generated-deriving' stamp: ''!
packages
	^ self packagesUsingContext: self class context

! !

!ExChdRootDtdElement methodsFor: 'platypus-generated-deriving' stamp: ''!
packagesUsingContext: aContext
	^ self packagesUsingContext: aContext receiver: self

! !

!ExChdRootDtdElement methodsFor: 'platypus-generated-deriving' stamp: ''!
packagesUsingContext: aContext receiver: aReceiver
	^ ExChdXmlPackagesWithTagFunction
		invokeFromValues:
			(OrderedCollection new
				add: (aReceiver tagUsingContext: self class context);
				yourself)

! !

!ExChdRootDtdElement methodsFor: 'platypus-generated-copying' stamp: ''!
pltCopyGroup: aClassSymbol to: anObject
	self class name == aClassSymbol
		ifTrue: [ self pltCopyTo: anObject ]
		ifFalse: [ super pltCopyGroup: aClassSymbol to: anObject ]

! !

!ExChdRootDtdElement methodsFor: 'platypus-generated-copying' stamp: ''!
pltCopyTo: another
	super pltCopyTo: another.
	self rootDtdElementCopyTo: another

! !

!ExChdRootDtdElement methodsFor: 'platypus-generated-copying' stamp: ''!
pltLocalCopyTo: another
	self rootDtdElementCopyTo: another

! !

!ExChdRootDtdElement methodsFor: 'platypus-generated-deriving' stamp: ''!
referencedEntities
	^ self referencedEntitiesUsingContext: self class context

! !

!ExChdRootDtdElement methodsFor: 'platypus-generated-deriving' stamp: ''!
referencedEntitiesUsingContext: aContext
	^ self referencedEntitiesUsingContext: aContext receiver: self

! !

!ExChdRootDtdElement methodsFor: 'platypus-generated-deriving' stamp: ''!
referencedEntitiesUsingContext: aContext receiver: aReceiver
	^ ExChdGetReferencedEntityDomainsFunction
		invokeFromValues:
			(OrderedCollection new
				add: (aReceiver subsUsingContext: aContext);
				yourself)

! !

!ExChdRootDtdElement methodsFor: 'platypus-generated-copying' stamp: ''!
rootDtdElementCopyTo: another
	

! !

!ExChdRootDtdElement methodsFor: 'platypus-generated-group-accessing' stamp: ''!
rootDtdElementFromValues: values
	| valuesloc |
	valuesloc := values asOrderedCollection.
	^ valuesloc

! !

!ExChdRootDtdElement methodsFor: 'platypus-generated-group-accessing' stamp: ''!
rootDtdElementToValues: values
	^ values

! !

!ExChdRootDtdElement methodsFor: 'platypus-generated-initializing' stamp: ''!
stepInitialize
	super stepInitialize

! !

!ExChdRootDtdElement methodsFor: 'platypus-generated-deriving' stamp: ''!
subs
	^ self subsUsingContext: self class context

! !

!ExChdRootDtdElement methodsFor: 'platypus-generated-deriving' stamp: ''!
subsUsingContext: aContext
	^ self subsUsingContext: aContext receiver: self

! !

!ExChdRootDtdElement methodsFor: 'platypus-generated-deriving' stamp: ''!
subsUsingContext: aContext receiver: aReceiver
	^ ExChdComputeRootSubElementsFunction
		invokeFromValues:
			(OrderedCollection new
				add: aReceiver;
				yourself)

! !

!ExChdRootDtdElement methodsFor: 'platypus-generated-group-accessing' stamp: ''!
toValues: values
	^ self rootDtdElementToValues: (super toValues: values)

! !

ExChdDtdElement subclass: #ExChdDomainDtdElement
	instanceVariableNames: 'domain'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Express2Cheddar-CheddarDtdSchema'!

!ExChdDomainDtdElement commentStamp: 'platypus comment' prior: 0!
<ISO10303-11-EXPRESS>
ENTITY domain_dtd_element 
	SUBTYPE OF ( dtd_element );
	domain : entity_instance;
DERIVE
	as_collection_element_dtd_code_tail : STRING := '';
END_ENTITY;
</ISO10303-11-EXPRESS>!

ExChdDomainDtdElement subclass: #ExChdCollectionDtdElement
	instanceVariableNames: 'elementDomain'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Express2Cheddar-CheddarDtdSchema'!

!ExChdCollectionDtdElement commentStamp: 'platypus comment' prior: 0!
<ISO10303-11-EXPRESS>
ENTITY collection_dtd_element 
	SUBTYPE OF ( domain_dtd_element );
	element_domain : domain_dtd_element;
DERIVE
	SELF\dtd_element.dtd_code : STRING := '<!!ELEMENT ' + owner.tag + ' ' + element_domain.as_collection_element_dtd_code_tail;
END_ENTITY;
</ISO10303-11-EXPRESS>!

!ExChdCollectionDtdElement class methodsFor: 'platypus-generated-platypus-signature' stamp: ''!
iso10303P11Translater
	^ 'Platypus (c) LISYC EA3883, Universite de Bretagne occidentale. Brest.'

! !

!ExChdCollectionDtdElement class methodsFor: 'platypus-generated-meta-data-accessing' stamp: ''!
schemaDefinition
	^ ExChdCheddarDtdSchemaDefinition singleton

! !

!ExChdCollectionDtdElement class methodsFor: 'platypus-generated-meta-data-accessing' stamp: ''!
schemaInstance
	^ ExChdExpress2cheddarSchemaInstance singleton

! !

!ExChdCollectionDtdElement class methodsFor: 'platypus-generated-platypus-signature' stamp: ''!
translatedFromISO10303P11
	^ true

! !

!ExChdCollectionDtdElement class methodsFor: 'platypus-generated-platypus-signature' stamp: ''!
vwNamespaceName
	^ #Express2Cheddar

! !

!ExChdCollectionDtdElement methodsFor: 'platypus-generated-visiting' stamp: ''!
accept: aVisitor
	^ aVisitor acceptCollectionDtdElement: self

! !

!ExChdCollectionDtdElement methodsFor: 'platypus-generated-copying' stamp: ''!
collectionDtdElementCopyTo: another
	another fastSetElementDomain: self elementDomain

! !

!ExChdCollectionDtdElement methodsFor: 'platypus-generated-group-accessing' stamp: ''!
collectionDtdElementFromValues: values
	| valuesloc |
	valuesloc := values asOrderedCollection.
	self setElementDomain: valuesloc removeFirst.
	^ valuesloc

! !

!ExChdCollectionDtdElement methodsFor: 'platypus-generated-group-accessing' stamp: ''!
collectionDtdElementToValues: values
	values add: self elementDomain.
	^ values

! !

!ExChdCollectionDtdElement methodsFor: 'platypus-generated-deriving' stamp: ''!
dtdCode
	^ self dtdCodeUsingContext: self class context

! !

!ExChdCollectionDtdElement methodsFor: 'platypus-generated-deriving' stamp: ''!
dtdCodeUsingContext: aContext
	^ self dtdCodeUsingContext: aContext receiver: self

! !

!ExChdCollectionDtdElement methodsFor: 'platypus-generated-deriving' stamp: ''!
dtdCodeUsingContext: aContext receiver: aReceiver
	^ (('<!!ELEMENT ' pltPlus: (aReceiver owner tagUsingContext: aContext)) pltPlus: ' ')
		pltPlus: (aReceiver elementDomain asCollectionElementDtdCodeTailUsingContext: aContext)

! !

!ExChdCollectionDtdElement methodsFor: 'platypus-generated-accessing' stamp: ''!
elementDomain
	^ elementDomain

! !

!ExChdCollectionDtdElement methodsFor: 'platypus-generated-accessing' stamp: ''!
elementDomain: aExChdDomainDtdElement
	elementDomain := aExChdDomainDtdElement

! !

!ExChdCollectionDtdElement methodsFor: 'platypus-generated-with-context-accessing' stamp: ''!
elementDomainUsingContext: aContext
	^ self elementDomain

! !

!ExChdCollectionDtdElement methodsFor: 'platypus-generated-fast-set-accessing' stamp: ''!
fastSetElementDomain: aExChdDomainDtdElement
	elementDomain := aExChdDomainDtdElement

! !

!ExChdCollectionDtdElement methodsFor: 'platypus-generated-group-accessing' stamp: ''!
fromValues: values
	^ self collectionDtdElementFromValues: (super fromValues: values)

! !

!ExChdCollectionDtdElement methodsFor: 'platypus-generated-classifying' stamp: ''!
isExChdCollectionDtdElement
	^ true

! !

!ExChdCollectionDtdElement methodsFor: 'platypus-generated-group-accessing' stamp: ''!
localFromValues: values
	^ self collectionDtdElementFromValues: values

! !

!ExChdCollectionDtdElement methodsFor: 'platypus-generated-group-accessing' stamp: ''!
localToValues: values
	^ self collectionDtdElementToValues: values

! !

!ExChdCollectionDtdElement methodsFor: 'platypus-generated-copying' stamp: ''!
pltCopyGroup: aClassSymbol to: anObject
	self class name == aClassSymbol
		ifTrue: [ self pltCopyTo: anObject ]
		ifFalse: [ super pltCopyGroup: aClassSymbol to: anObject ]

! !

!ExChdCollectionDtdElement methodsFor: 'platypus-generated-copying' stamp: ''!
pltCopyTo: another
	super pltCopyTo: another.
	self collectionDtdElementCopyTo: another

! !

!ExChdCollectionDtdElement methodsFor: 'platypus-generated-copying' stamp: ''!
pltLocalCopyTo: another
	self collectionDtdElementCopyTo: another

! !

!ExChdCollectionDtdElement methodsFor: 'platypus-generated-set-accessing' stamp: ''!
setElementDomain: aExChdDomainDtdElement
	self elementDomain: aExChdDomainDtdElement

! !

!ExChdCollectionDtdElement methodsFor: 'platypus-generated-initializing' stamp: ''!
stepInitialize
	super stepInitialize.
	elementDomain := nil

! !

!ExChdCollectionDtdElement methodsFor: 'platypus-generated-group-accessing' stamp: ''!
toValues: values
	^ self collectionDtdElementToValues: (super toValues: values)

! !

!ExChdDomainDtdElement class methodsFor: 'platypus-generated-platypus-signature' stamp: ''!
iso10303P11Translater
	^ 'Platypus (c) LISYC EA3883, Universite de Bretagne occidentale. Brest.'

! !

!ExChdDomainDtdElement class methodsFor: 'platypus-generated-meta-data-accessing' stamp: ''!
schemaDefinition
	^ ExChdCheddarDtdSchemaDefinition singleton

! !

!ExChdDomainDtdElement class methodsFor: 'platypus-generated-meta-data-accessing' stamp: ''!
schemaInstance
	^ ExChdExpress2cheddarSchemaInstance singleton

! !

!ExChdDomainDtdElement class methodsFor: 'platypus-generated-platypus-signature' stamp: ''!
translatedFromISO10303P11
	^ true

! !

!ExChdDomainDtdElement class methodsFor: 'platypus-generated-platypus-signature' stamp: ''!
vwNamespaceName
	^ #Express2Cheddar

! !

!ExChdDomainDtdElement methodsFor: 'platypus-generated-visiting' stamp: ''!
accept: aVisitor
	^ aVisitor acceptDomainDtdElement: self

! !

!ExChdDomainDtdElement methodsFor: 'platypus-generated-deriving' stamp: ''!
asCollectionElementDtdCodeTail
	^ self asCollectionElementDtdCodeTailUsingContext: self class context

! !

!ExChdDomainDtdElement methodsFor: 'platypus-generated-deriving' stamp: ''!
asCollectionElementDtdCodeTailUsingContext: aContext
	^ self asCollectionElementDtdCodeTailUsingContext: aContext receiver: self

! !

!ExChdDomainDtdElement methodsFor: 'platypus-generated-deriving' stamp: ''!
asCollectionElementDtdCodeTailUsingContext: aContext receiver: aReceiver
	^ ''

! !

!ExChdDomainDtdElement methodsFor: 'platypus-generated-accessing' stamp: ''!
domain
	^ domain

! !

!ExChdDomainDtdElement methodsFor: 'platypus-generated-accessing' stamp: ''!
domain: aExChdEntityInstance
	domain := aExChdEntityInstance

! !

!ExChdDomainDtdElement methodsFor: 'platypus-generated-copying' stamp: ''!
domainDtdElementCopyTo: another
	another fastSetDomain: self domain

! !

!ExChdDomainDtdElement methodsFor: 'platypus-generated-group-accessing' stamp: ''!
domainDtdElementFromValues: values
	| valuesloc |
	valuesloc := values asOrderedCollection.
	self setDomain: valuesloc removeFirst.
	^ valuesloc

! !

!ExChdDomainDtdElement methodsFor: 'platypus-generated-group-accessing' stamp: ''!
domainDtdElementToValues: values
	values add: self domain.
	^ values

! !

!ExChdDomainDtdElement methodsFor: 'platypus-generated-with-context-accessing' stamp: ''!
domainUsingContext: aContext
	^ self domain

! !

!ExChdDomainDtdElement methodsFor: 'platypus-generated-fast-set-accessing' stamp: ''!
fastSetDomain: aExChdEntityInstance
	domain := aExChdEntityInstance

! !

!ExChdDomainDtdElement methodsFor: 'platypus-generated-group-accessing' stamp: ''!
fromValues: values
	^ self domainDtdElementFromValues: (super fromValues: values)

! !

!ExChdDomainDtdElement methodsFor: 'platypus-generated-classifying' stamp: ''!
isExChdDomainDtdElement
	^ true

! !

!ExChdDomainDtdElement methodsFor: 'platypus-generated-group-accessing' stamp: ''!
localFromValues: values
	^ self domainDtdElementFromValues: values

! !

!ExChdDomainDtdElement methodsFor: 'platypus-generated-group-accessing' stamp: ''!
localToValues: values
	^ self domainDtdElementToValues: values

! !

!ExChdDomainDtdElement methodsFor: 'platypus-generated-copying' stamp: ''!
pltCopyGroup: aClassSymbol to: anObject
	self class name == aClassSymbol
		ifTrue: [ self pltCopyTo: anObject ]
		ifFalse: [ super pltCopyGroup: aClassSymbol to: anObject ]

! !

!ExChdDomainDtdElement methodsFor: 'platypus-generated-copying' stamp: ''!
pltCopyTo: another
	super pltCopyTo: another.
	self domainDtdElementCopyTo: another

! !

!ExChdDomainDtdElement methodsFor: 'platypus-generated-copying' stamp: ''!
pltLocalCopyTo: another
	self domainDtdElementCopyTo: another

! !

!ExChdDomainDtdElement methodsFor: 'platypus-generated-set-accessing' stamp: ''!
setDomain: aExChdEntityInstance
	self domain: aExChdEntityInstance

! !

!ExChdDomainDtdElement methodsFor: 'platypus-generated-initializing' stamp: ''!
stepInitialize
	super stepInitialize.
	domain := nil

! !

!ExChdDomainDtdElement methodsFor: 'platypus-generated-group-accessing' stamp: ''!
toValues: values
	^ self domainDtdElementToValues: (super toValues: values)

! !

ExChdDomainDtdElement subclass: #ExChdEntityRefDtdElement
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Express2Cheddar-CheddarDtdSchema'!

!ExChdEntityRefDtdElement commentStamp: 'platypus comment' prior: 0!
<ISO10303-11-EXPRESS>
ENTITY entity_ref_dtd_element 
	SUBTYPE OF ( domain_dtd_element );
DERIVE
	infered_element : entity_dtd_element := ?;
	SELF\dtd_element.dtd_code : STRING := '<!!ELEMENT ' + owner.tag + ' (' + lowerize ( domain.name ) + ')>\n';
END_ENTITY;
</ISO10303-11-EXPRESS>!

ExChdEntityRefDtdElement subclass: #ExChdAdaClassRefDtdElement
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Express2Cheddar-CheddarDtdSchema'!

!ExChdAdaClassRefDtdElement commentStamp: 'platypus comment' prior: 0!
<ISO10303-11-EXPRESS>
ENTITY ada_class_ref_dtd_element 
	SUBTYPE OF ( entity_ref_dtd_element );
DERIVE
	SELF\entity_ref_dtd_element.infered_element : entity_dtd_element := dtd_element ( ?, ? ) || composite_dtd_element ( ) || entity_dtd_element ( domain ) || ada_class_dtd_element ( );
	SELF\entity_ref_dtd_element.dtd_code : STRING := '<!!ELEMENT ' + owner.tag + ' EMPTY>\n' 
	+ '<!!ATTLIST ' + owner.tag + ' ref IDREF #REQUIRED>\n';
	SELF\entity_ref_dtd_element.as_collection_element_dtd_code_tail : STRING := ' EMPTY>\n' 
	+ '<!!ATTLIST ' + owner.owner.tag + ' refs IDREFS #REQUIRED>\n';
END_ENTITY;
</ISO10303-11-EXPRESS>!

!ExChdAdaClassRefDtdElement class methodsFor: 'platypus-generated-platypus-signature' stamp: ''!
iso10303P11Translater
	^ 'Platypus (c) LISYC EA3883, Universite de Bretagne occidentale. Brest.'

! !

!ExChdAdaClassRefDtdElement class methodsFor: 'platypus-generated-meta-data-accessing' stamp: ''!
schemaDefinition
	^ ExChdCheddarDtdSchemaDefinition singleton

! !

!ExChdAdaClassRefDtdElement class methodsFor: 'platypus-generated-meta-data-accessing' stamp: ''!
schemaInstance
	^ ExChdExpress2cheddarSchemaInstance singleton

! !

!ExChdAdaClassRefDtdElement class methodsFor: 'platypus-generated-platypus-signature' stamp: ''!
translatedFromISO10303P11
	^ true

! !

!ExChdAdaClassRefDtdElement class methodsFor: 'platypus-generated-platypus-signature' stamp: ''!
vwNamespaceName
	^ #Express2Cheddar

! !

!ExChdAdaClassRefDtdElement methodsFor: 'platypus-generated-visiting' stamp: ''!
accept: aVisitor
	^ aVisitor acceptAdaClassRefDtdElement: self

! !

!ExChdAdaClassRefDtdElement methodsFor: 'platypus-generated-copying' stamp: ''!
adaClassRefDtdElementCopyTo: another
	

! !

!ExChdAdaClassRefDtdElement methodsFor: 'platypus-generated-group-accessing' stamp: ''!
adaClassRefDtdElementFromValues: values
	| valuesloc |
	valuesloc := values asOrderedCollection.
	^ valuesloc

! !

!ExChdAdaClassRefDtdElement methodsFor: 'platypus-generated-group-accessing' stamp: ''!
adaClassRefDtdElementToValues: values
	^ values

! !

!ExChdAdaClassRefDtdElement methodsFor: 'platypus-generated-deriving' stamp: ''!
asCollectionElementDtdCodeTail
	^ self asCollectionElementDtdCodeTailUsingContext: self class context

! !

!ExChdAdaClassRefDtdElement methodsFor: 'platypus-generated-deriving' stamp: ''!
asCollectionElementDtdCodeTailUsingContext: aContext
	^ self asCollectionElementDtdCodeTailUsingContext: aContext receiver: self

! !

!ExChdAdaClassRefDtdElement methodsFor: 'platypus-generated-deriving' stamp: ''!
asCollectionElementDtdCodeTailUsingContext: aContext receiver: aReceiver
	^ ((' EMPTY>\n' pltPlus: '<!!ATTLIST ')
		pltPlus: ((aReceiver owner ownerUsingContext: aContext) tagUsingContext: aContext))
		pltPlus: ' refs IDREFS #REQUIRED>\n'

! !

!ExChdAdaClassRefDtdElement methodsFor: 'platypus-generated-deriving' stamp: ''!
dtdCode
	^ self dtdCodeUsingContext: self class context

! !

!ExChdAdaClassRefDtdElement methodsFor: 'platypus-generated-deriving' stamp: ''!
dtdCodeUsingContext: aContext
	^ self dtdCodeUsingContext: aContext receiver: self

! !

!ExChdAdaClassRefDtdElement methodsFor: 'platypus-generated-deriving' stamp: ''!
dtdCodeUsingContext: aContext receiver: aReceiver
	^ (((('<!!ELEMENT ' pltPlus: (aReceiver owner tagUsingContext: aContext)) pltPlus: ' EMPTY>\n') pltPlus: '<!!ATTLIST ')
		pltPlus: (aReceiver owner tagUsingContext: aContext)) pltPlus: ' ref IDREF #REQUIRED>\n'

! !

!ExChdAdaClassRefDtdElement methodsFor: 'platypus-generated-group-accessing' stamp: ''!
fromValues: values
	^ self adaClassRefDtdElementFromValues: (super fromValues: values)

! !

!ExChdAdaClassRefDtdElement methodsFor: 'platypus-generated-deriving' stamp: ''!
inferedElement
	^ self inferedElementUsingContext: self class context

! !

!ExChdAdaClassRefDtdElement methodsFor: 'platypus-generated-deriving' stamp: ''!
inferedElementUsingContext: aContext
	^ self inferedElementUsingContext: aContext receiver: self

! !

!ExChdAdaClassRefDtdElement methodsFor: 'platypus-generated-deriving' stamp: ''!
inferedElementUsingContext: aContext receiver: aReceiver
	^ (PlatypusComplexInstance
		fromRecords:
			(OrderedCollection new
				add:
						(PlatypusComplexInstance
								fromRecords:
									(OrderedCollection new
										add:
												(PlatypusComplexInstance
														fromRecords:
															(OrderedCollection new
																add:
																		(ExChdDtdElement new
																				dtdElementFromValues:
																						(OrderedCollection new
																								add: nil;
																								add: nil;
																								yourself);
																				yourself);
																add: ExChdCompositeDtdElement new;
																yourself)) pltAsObject;
										add:
												(ExChdEntityDtdElement new
														entityDtdElementFromValues:
																(OrderedCollection new
																		add: aReceiver domain;
																		yourself);
														yourself);
										yourself)) pltAsObject;
				add: ExChdAdaClassDtdElement new;
				yourself)) pltAsObject

! !

!ExChdAdaClassRefDtdElement methodsFor: 'platypus-generated-classifying' stamp: ''!
isExChdAdaClassRefDtdElement
	^ true

! !

!ExChdAdaClassRefDtdElement methodsFor: 'platypus-generated-group-accessing' stamp: ''!
localFromValues: values
	^ self adaClassRefDtdElementFromValues: values

! !

!ExChdAdaClassRefDtdElement methodsFor: 'platypus-generated-group-accessing' stamp: ''!
localToValues: values
	^ self adaClassRefDtdElementToValues: values

! !

!ExChdAdaClassRefDtdElement methodsFor: 'platypus-generated-copying' stamp: ''!
pltCopyGroup: aClassSymbol to: anObject
	self class name == aClassSymbol
		ifTrue: [ self pltCopyTo: anObject ]
		ifFalse: [ super pltCopyGroup: aClassSymbol to: anObject ]

! !

!ExChdAdaClassRefDtdElement methodsFor: 'platypus-generated-copying' stamp: ''!
pltCopyTo: another
	super pltCopyTo: another.
	self adaClassRefDtdElementCopyTo: another

! !

!ExChdAdaClassRefDtdElement methodsFor: 'platypus-generated-copying' stamp: ''!
pltLocalCopyTo: another
	self adaClassRefDtdElementCopyTo: another

! !

!ExChdAdaClassRefDtdElement methodsFor: 'platypus-generated-initializing' stamp: ''!
stepInitialize
	super stepInitialize

! !

!ExChdAdaClassRefDtdElement methodsFor: 'platypus-generated-group-accessing' stamp: ''!
toValues: values
	^ self adaClassRefDtdElementToValues: (super toValues: values)

! !

ExChdEntityRefDtdElement subclass: #ExChdDiscriminatedTypeRefDtdElement
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Express2Cheddar-CheddarDtdSchema'!

!ExChdDiscriminatedTypeRefDtdElement commentStamp: 'platypus comment' prior: 0!
<ISO10303-11-EXPRESS>
ENTITY discriminated_type_ref_dtd_element 
	SUBTYPE OF ( entity_ref_dtd_element );
DERIVE
	SELF\entity_ref_dtd_element.infered_element : entity_dtd_element := dtd_element ( ?, ? ) || composite_dtd_element ( ) || entity_dtd_element ( domain ) || discriminated_type_dtd_element ( );
	SELF\domain_dtd_element.as_collection_element_dtd_code_tail : STRING := '(' + lowerize ( domain.handled.name ) + ')*>\n';
END_ENTITY;
</ISO10303-11-EXPRESS>!

!ExChdDiscriminatedTypeRefDtdElement class methodsFor: 'platypus-generated-platypus-signature' stamp: ''!
iso10303P11Translater
	^ 'Platypus (c) LISYC EA3883, Universite de Bretagne occidentale. Brest.'

! !

!ExChdDiscriminatedTypeRefDtdElement class methodsFor: 'platypus-generated-meta-data-accessing' stamp: ''!
schemaDefinition
	^ ExChdCheddarDtdSchemaDefinition singleton

! !

!ExChdDiscriminatedTypeRefDtdElement class methodsFor: 'platypus-generated-meta-data-accessing' stamp: ''!
schemaInstance
	^ ExChdExpress2cheddarSchemaInstance singleton

! !

!ExChdDiscriminatedTypeRefDtdElement class methodsFor: 'platypus-generated-platypus-signature' stamp: ''!
translatedFromISO10303P11
	^ true

! !

!ExChdDiscriminatedTypeRefDtdElement class methodsFor: 'platypus-generated-platypus-signature' stamp: ''!
vwNamespaceName
	^ #Express2Cheddar

! !

!ExChdDiscriminatedTypeRefDtdElement methodsFor: 'platypus-generated-visiting' stamp: ''!
accept: aVisitor
	^ aVisitor acceptDiscriminatedTypeRefDtdElement: self

! !

!ExChdDiscriminatedTypeRefDtdElement methodsFor: 'platypus-generated-deriving' stamp: ''!
asCollectionElementDtdCodeTail
	^ self asCollectionElementDtdCodeTailUsingContext: self class context

! !

!ExChdDiscriminatedTypeRefDtdElement methodsFor: 'platypus-generated-deriving' stamp: ''!
asCollectionElementDtdCodeTailUsingContext: aContext
	^ self asCollectionElementDtdCodeTailUsingContext: aContext receiver: self

! !

!ExChdDiscriminatedTypeRefDtdElement methodsFor: 'platypus-generated-deriving' stamp: ''!
asCollectionElementDtdCodeTailUsingContext: aContext receiver: aReceiver
	^ ('('
		pltPlus:
			(PTsLowerizeFunction
				invokeFromValues:
					(OrderedCollection new
						add: ((aReceiver domain handledUsingContext: self class context) nameUsingContext: self class context);
						yourself))) pltPlus: ')*>\n'

! !

!ExChdDiscriminatedTypeRefDtdElement methodsFor: 'platypus-generated-copying' stamp: ''!
discriminatedTypeRefDtdElementCopyTo: another
	

! !

!ExChdDiscriminatedTypeRefDtdElement methodsFor: 'platypus-generated-group-accessing' stamp: ''!
discriminatedTypeRefDtdElementFromValues: values
	| valuesloc |
	valuesloc := values asOrderedCollection.
	^ valuesloc

! !

!ExChdDiscriminatedTypeRefDtdElement methodsFor: 'platypus-generated-group-accessing' stamp: ''!
discriminatedTypeRefDtdElementToValues: values
	^ values

! !

!ExChdDiscriminatedTypeRefDtdElement methodsFor: 'platypus-generated-group-accessing' stamp: ''!
fromValues: values
	^ self discriminatedTypeRefDtdElementFromValues: (super fromValues: values)

! !

!ExChdDiscriminatedTypeRefDtdElement methodsFor: 'platypus-generated-deriving' stamp: ''!
inferedElement
	^ self inferedElementUsingContext: self class context

! !

!ExChdDiscriminatedTypeRefDtdElement methodsFor: 'platypus-generated-deriving' stamp: ''!
inferedElementUsingContext: aContext
	^ self inferedElementUsingContext: aContext receiver: self

! !

!ExChdDiscriminatedTypeRefDtdElement methodsFor: 'platypus-generated-deriving' stamp: ''!
inferedElementUsingContext: aContext receiver: aReceiver
	^ (PlatypusComplexInstance
		fromRecords:
			(OrderedCollection new
				add:
						(PlatypusComplexInstance
								fromRecords:
									(OrderedCollection new
										add:
												(PlatypusComplexInstance
														fromRecords:
															(OrderedCollection new
																add:
																		(ExChdDtdElement new
																				dtdElementFromValues:
																						(OrderedCollection new
																								add: nil;
																								add: nil;
																								yourself);
																				yourself);
																add: ExChdCompositeDtdElement new;
																yourself)) pltAsObject;
										add:
												(ExChdEntityDtdElement new
														entityDtdElementFromValues:
																(OrderedCollection new
																		add: aReceiver domain;
																		yourself);
														yourself);
										yourself)) pltAsObject;
				add: ExChdDiscriminatedTypeDtdElement new;
				yourself)) pltAsObject

! !

!ExChdDiscriminatedTypeRefDtdElement methodsFor: 'platypus-generated-classifying' stamp: ''!
isExChdDiscriminatedTypeRefDtdElement
	^ true

! !

!ExChdDiscriminatedTypeRefDtdElement methodsFor: 'platypus-generated-group-accessing' stamp: ''!
localFromValues: values
	^ self discriminatedTypeRefDtdElementFromValues: values

! !

!ExChdDiscriminatedTypeRefDtdElement methodsFor: 'platypus-generated-group-accessing' stamp: ''!
localToValues: values
	^ self discriminatedTypeRefDtdElementToValues: values

! !

!ExChdDiscriminatedTypeRefDtdElement methodsFor: 'platypus-generated-copying' stamp: ''!
pltCopyGroup: aClassSymbol to: anObject
	self class name == aClassSymbol
		ifTrue: [ self pltCopyTo: anObject ]
		ifFalse: [ super pltCopyGroup: aClassSymbol to: anObject ]

! !

!ExChdDiscriminatedTypeRefDtdElement methodsFor: 'platypus-generated-copying' stamp: ''!
pltCopyTo: another
	super pltCopyTo: another.
	self discriminatedTypeRefDtdElementCopyTo: another

! !

!ExChdDiscriminatedTypeRefDtdElement methodsFor: 'platypus-generated-copying' stamp: ''!
pltLocalCopyTo: another
	self discriminatedTypeRefDtdElementCopyTo: another

! !

!ExChdDiscriminatedTypeRefDtdElement methodsFor: 'platypus-generated-initializing' stamp: ''!
stepInitialize
	super stepInitialize

! !

!ExChdDiscriminatedTypeRefDtdElement methodsFor: 'platypus-generated-group-accessing' stamp: ''!
toValues: values
	^ self discriminatedTypeRefDtdElementToValues: (super toValues: values)

! !

!ExChdEntityRefDtdElement class methodsFor: 'platypus-generated-platypus-signature' stamp: ''!
iso10303P11Translater
	^ 'Platypus (c) LISYC EA3883, Universite de Bretagne occidentale. Brest.'

! !

!ExChdEntityRefDtdElement class methodsFor: 'platypus-generated-meta-data-accessing' stamp: ''!
schemaDefinition
	^ ExChdCheddarDtdSchemaDefinition singleton

! !

!ExChdEntityRefDtdElement class methodsFor: 'platypus-generated-meta-data-accessing' stamp: ''!
schemaInstance
	^ ExChdExpress2cheddarSchemaInstance singleton

! !

!ExChdEntityRefDtdElement class methodsFor: 'platypus-generated-platypus-signature' stamp: ''!
translatedFromISO10303P11
	^ true

! !

!ExChdEntityRefDtdElement class methodsFor: 'platypus-generated-platypus-signature' stamp: ''!
vwNamespaceName
	^ #Express2Cheddar

! !

!ExChdEntityRefDtdElement methodsFor: 'platypus-generated-visiting' stamp: ''!
accept: aVisitor
	^ aVisitor acceptEntityRefDtdElement: self

! !

!ExChdEntityRefDtdElement methodsFor: 'platypus-generated-deriving' stamp: ''!
dtdCode
	^ self dtdCodeUsingContext: self class context

! !

!ExChdEntityRefDtdElement methodsFor: 'platypus-generated-deriving' stamp: ''!
dtdCodeUsingContext: aContext
	^ self dtdCodeUsingContext: aContext receiver: self

! !

!ExChdEntityRefDtdElement methodsFor: 'platypus-generated-deriving' stamp: ''!
dtdCodeUsingContext: aContext receiver: aReceiver
	^ ((('<!!ELEMENT ' pltPlus: (aReceiver owner tagUsingContext: aContext)) pltPlus: ' (')
		pltPlus:
			(PTsLowerizeFunction
				invokeFromValues:
					(OrderedCollection new
						add: (aReceiver domain nameUsingContext: self class context);
						yourself))) pltPlus: ')>\n'

! !

!ExChdEntityRefDtdElement methodsFor: 'platypus-generated-copying' stamp: ''!
entityRefDtdElementCopyTo: another
	

! !

!ExChdEntityRefDtdElement methodsFor: 'platypus-generated-group-accessing' stamp: ''!
entityRefDtdElementFromValues: values
	| valuesloc |
	valuesloc := values asOrderedCollection.
	^ valuesloc

! !

!ExChdEntityRefDtdElement methodsFor: 'platypus-generated-group-accessing' stamp: ''!
entityRefDtdElementToValues: values
	^ values

! !

!ExChdEntityRefDtdElement methodsFor: 'platypus-generated-group-accessing' stamp: ''!
fromValues: values
	^ self entityRefDtdElementFromValues: (super fromValues: values)

! !

!ExChdEntityRefDtdElement methodsFor: 'platypus-generated-deriving' stamp: ''!
inferedElement
	^ self inferedElementUsingContext: self class context

! !

!ExChdEntityRefDtdElement methodsFor: 'platypus-generated-deriving' stamp: ''!
inferedElementUsingContext: aContext
	^ self inferedElementUsingContext: aContext receiver: self

! !

!ExChdEntityRefDtdElement methodsFor: 'platypus-generated-deriving' stamp: ''!
inferedElementUsingContext: aContext receiver: aReceiver
	^ nil

! !

!ExChdEntityRefDtdElement methodsFor: 'platypus-generated-classifying' stamp: ''!
isExChdEntityRefDtdElement
	^ true

! !

!ExChdEntityRefDtdElement methodsFor: 'platypus-generated-group-accessing' stamp: ''!
localFromValues: values
	^ self entityRefDtdElementFromValues: values

! !

!ExChdEntityRefDtdElement methodsFor: 'platypus-generated-group-accessing' stamp: ''!
localToValues: values
	^ self entityRefDtdElementToValues: values

! !

!ExChdEntityRefDtdElement methodsFor: 'platypus-generated-copying' stamp: ''!
pltCopyGroup: aClassSymbol to: anObject
	self class name == aClassSymbol
		ifTrue: [ self pltCopyTo: anObject ]
		ifFalse: [ super pltCopyGroup: aClassSymbol to: anObject ]

! !

!ExChdEntityRefDtdElement methodsFor: 'platypus-generated-copying' stamp: ''!
pltCopyTo: another
	super pltCopyTo: another.
	self entityRefDtdElementCopyTo: another

! !

!ExChdEntityRefDtdElement methodsFor: 'platypus-generated-copying' stamp: ''!
pltLocalCopyTo: another
	self entityRefDtdElementCopyTo: another

! !

!ExChdEntityRefDtdElement methodsFor: 'platypus-generated-initializing' stamp: ''!
stepInitialize
	super stepInitialize

! !

!ExChdEntityRefDtdElement methodsFor: 'platypus-generated-group-accessing' stamp: ''!
toValues: values
	^ self entityRefDtdElementToValues: (super toValues: values)

! !

ExChdEntityRefDtdElement subclass: #ExChdRecordRefDtdElement
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Express2Cheddar-CheddarDtdSchema'!

!ExChdRecordRefDtdElement commentStamp: 'platypus comment' prior: 0!
<ISO10303-11-EXPRESS>
ENTITY record_ref_dtd_element 
	SUBTYPE OF ( entity_ref_dtd_element );
DERIVE
	SELF\entity_ref_dtd_element.infered_element : entity_dtd_element := dtd_element ( ?, ? ) || composite_dtd_element ( ) || entity_dtd_element ( domain ) || record_dtd_element ( );
	SELF\domain_dtd_element.as_collection_element_dtd_code_tail : STRING := '(' + lowerize ( domain.handled.name ) + ')*>\n';
END_ENTITY;
</ISO10303-11-EXPRESS>!

!ExChdRecordRefDtdElement class methodsFor: 'platypus-generated-platypus-signature' stamp: ''!
iso10303P11Translater
	^ 'Platypus (c) LISYC EA3883, Universite de Bretagne occidentale. Brest.'

! !

!ExChdRecordRefDtdElement class methodsFor: 'platypus-generated-meta-data-accessing' stamp: ''!
schemaDefinition
	^ ExChdCheddarDtdSchemaDefinition singleton

! !

!ExChdRecordRefDtdElement class methodsFor: 'platypus-generated-meta-data-accessing' stamp: ''!
schemaInstance
	^ ExChdExpress2cheddarSchemaInstance singleton

! !

!ExChdRecordRefDtdElement class methodsFor: 'platypus-generated-platypus-signature' stamp: ''!
translatedFromISO10303P11
	^ true

! !

!ExChdRecordRefDtdElement class methodsFor: 'platypus-generated-platypus-signature' stamp: ''!
vwNamespaceName
	^ #Express2Cheddar

! !

!ExChdRecordRefDtdElement methodsFor: 'platypus-generated-visiting' stamp: ''!
accept: aVisitor
	^ aVisitor acceptRecordRefDtdElement: self

! !

!ExChdRecordRefDtdElement methodsFor: 'platypus-generated-deriving' stamp: ''!
asCollectionElementDtdCodeTail
	^ self asCollectionElementDtdCodeTailUsingContext: self class context

! !

!ExChdRecordRefDtdElement methodsFor: 'platypus-generated-deriving' stamp: ''!
asCollectionElementDtdCodeTailUsingContext: aContext
	^ self asCollectionElementDtdCodeTailUsingContext: aContext receiver: self

! !

!ExChdRecordRefDtdElement methodsFor: 'platypus-generated-deriving' stamp: ''!
asCollectionElementDtdCodeTailUsingContext: aContext receiver: aReceiver
	^ ('('
		pltPlus:
			(PTsLowerizeFunction
				invokeFromValues:
					(OrderedCollection new
						add: ((aReceiver domain handledUsingContext: self class context) nameUsingContext: self class context);
						yourself))) pltPlus: ')*>\n'

! !

!ExChdRecordRefDtdElement methodsFor: 'platypus-generated-group-accessing' stamp: ''!
fromValues: values
	^ self recordRefDtdElementFromValues: (super fromValues: values)

! !

!ExChdRecordRefDtdElement methodsFor: 'platypus-generated-deriving' stamp: ''!
inferedElement
	^ self inferedElementUsingContext: self class context

! !

!ExChdRecordRefDtdElement methodsFor: 'platypus-generated-deriving' stamp: ''!
inferedElementUsingContext: aContext
	^ self inferedElementUsingContext: aContext receiver: self

! !

!ExChdRecordRefDtdElement methodsFor: 'platypus-generated-deriving' stamp: ''!
inferedElementUsingContext: aContext receiver: aReceiver
	^ (PlatypusComplexInstance
		fromRecords:
			(OrderedCollection new
				add:
						(PlatypusComplexInstance
								fromRecords:
									(OrderedCollection new
										add:
												(PlatypusComplexInstance
														fromRecords:
															(OrderedCollection new
																add:
																		(ExChdDtdElement new
																				dtdElementFromValues:
																						(OrderedCollection new
																								add: nil;
																								add: nil;
																								yourself);
																				yourself);
																add: ExChdCompositeDtdElement new;
																yourself)) pltAsObject;
										add:
												(ExChdEntityDtdElement new
														entityDtdElementFromValues:
																(OrderedCollection new
																		add: aReceiver domain;
																		yourself);
														yourself);
										yourself)) pltAsObject;
				add: ExChdRecordDtdElement new;
				yourself)) pltAsObject

! !

!ExChdRecordRefDtdElement methodsFor: 'platypus-generated-classifying' stamp: ''!
isExChdRecordRefDtdElement
	^ true

! !

!ExChdRecordRefDtdElement methodsFor: 'platypus-generated-group-accessing' stamp: ''!
localFromValues: values
	^ self recordRefDtdElementFromValues: values

! !

!ExChdRecordRefDtdElement methodsFor: 'platypus-generated-group-accessing' stamp: ''!
localToValues: values
	^ self recordRefDtdElementToValues: values

! !

!ExChdRecordRefDtdElement methodsFor: 'platypus-generated-copying' stamp: ''!
pltCopyGroup: aClassSymbol to: anObject
	self class name == aClassSymbol
		ifTrue: [ self pltCopyTo: anObject ]
		ifFalse: [ super pltCopyGroup: aClassSymbol to: anObject ]

! !

!ExChdRecordRefDtdElement methodsFor: 'platypus-generated-copying' stamp: ''!
pltCopyTo: another
	super pltCopyTo: another.
	self recordRefDtdElementCopyTo: another

! !

!ExChdRecordRefDtdElement methodsFor: 'platypus-generated-copying' stamp: ''!
pltLocalCopyTo: another
	self recordRefDtdElementCopyTo: another

! !

!ExChdRecordRefDtdElement methodsFor: 'platypus-generated-copying' stamp: ''!
recordRefDtdElementCopyTo: another
	

! !

!ExChdRecordRefDtdElement methodsFor: 'platypus-generated-group-accessing' stamp: ''!
recordRefDtdElementFromValues: values
	| valuesloc |
	valuesloc := values asOrderedCollection.
	^ valuesloc

! !

!ExChdRecordRefDtdElement methodsFor: 'platypus-generated-group-accessing' stamp: ''!
recordRefDtdElementToValues: values
	^ values

! !

!ExChdRecordRefDtdElement methodsFor: 'platypus-generated-initializing' stamp: ''!
stepInitialize
	super stepInitialize

! !

!ExChdRecordRefDtdElement methodsFor: 'platypus-generated-group-accessing' stamp: ''!
toValues: values
	^ self recordRefDtdElementToValues: (super toValues: values)

! !

ExChdDomainDtdElement subclass: #ExChdSimpleDomainDtdElement
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Express2Cheddar-CheddarDtdSchema'!

!ExChdSimpleDomainDtdElement commentStamp: 'platypus comment' prior: 0!
<ISO10303-11-EXPRESS>
ENTITY simple_domain_dtd_element 
	SUBTYPE OF ( domain_dtd_element );
DERIVE
	SELF\dtd_element.dtd_code : STRING := '<!!ELEMENT ' + SELF.owner.tag + ' (#PCDATA)>\n';
	SELF\domain_dtd_element.as_collection_element_dtd_code_tail : STRING := '(#PCDATA)>\n';
END_ENTITY;
</ISO10303-11-EXPRESS>!

!ExChdSimpleDomainDtdElement class methodsFor: 'platypus-generated-platypus-signature' stamp: ''!
iso10303P11Translater
	^ 'Platypus (c) LISYC EA3883, Universite de Bretagne occidentale. Brest.'

! !

!ExChdSimpleDomainDtdElement class methodsFor: 'platypus-generated-meta-data-accessing' stamp: ''!
schemaDefinition
	^ ExChdCheddarDtdSchemaDefinition singleton

! !

!ExChdSimpleDomainDtdElement class methodsFor: 'platypus-generated-meta-data-accessing' stamp: ''!
schemaInstance
	^ ExChdExpress2cheddarSchemaInstance singleton

! !

!ExChdSimpleDomainDtdElement class methodsFor: 'platypus-generated-platypus-signature' stamp: ''!
translatedFromISO10303P11
	^ true

! !

!ExChdSimpleDomainDtdElement class methodsFor: 'platypus-generated-platypus-signature' stamp: ''!
vwNamespaceName
	^ #Express2Cheddar

! !

!ExChdSimpleDomainDtdElement methodsFor: 'platypus-generated-visiting' stamp: ''!
accept: aVisitor
	^ aVisitor acceptSimpleDomainDtdElement: self

! !

!ExChdSimpleDomainDtdElement methodsFor: 'platypus-generated-deriving' stamp: ''!
asCollectionElementDtdCodeTail
	^ self asCollectionElementDtdCodeTailUsingContext: self class context

! !

!ExChdSimpleDomainDtdElement methodsFor: 'platypus-generated-deriving' stamp: ''!
asCollectionElementDtdCodeTailUsingContext: aContext
	^ self asCollectionElementDtdCodeTailUsingContext: aContext receiver: self

! !

!ExChdSimpleDomainDtdElement methodsFor: 'platypus-generated-deriving' stamp: ''!
asCollectionElementDtdCodeTailUsingContext: aContext receiver: aReceiver
	^ '(#PCDATA)>\n'

! !

!ExChdSimpleDomainDtdElement methodsFor: 'platypus-generated-deriving' stamp: ''!
dtdCode
	^ self dtdCodeUsingContext: self class context

! !

!ExChdSimpleDomainDtdElement methodsFor: 'platypus-generated-deriving' stamp: ''!
dtdCodeUsingContext: aContext
	^ self dtdCodeUsingContext: aContext receiver: self

! !

!ExChdSimpleDomainDtdElement methodsFor: 'platypus-generated-deriving' stamp: ''!
dtdCodeUsingContext: aContext receiver: aReceiver
	^ ('<!!ELEMENT ' pltPlus: ((aReceiver ownerUsingContext: aContext) tagUsingContext: aContext)) pltPlus: ' (#PCDATA)>\n'

! !

!ExChdSimpleDomainDtdElement methodsFor: 'platypus-generated-group-accessing' stamp: ''!
fromValues: values
	^ self simpleDomainDtdElementFromValues: (super fromValues: values)

! !

!ExChdSimpleDomainDtdElement methodsFor: 'platypus-generated-classifying' stamp: ''!
isExChdSimpleDomainDtdElement
	^ true

! !

!ExChdSimpleDomainDtdElement methodsFor: 'platypus-generated-group-accessing' stamp: ''!
localFromValues: values
	^ self simpleDomainDtdElementFromValues: values

! !

!ExChdSimpleDomainDtdElement methodsFor: 'platypus-generated-group-accessing' stamp: ''!
localToValues: values
	^ self simpleDomainDtdElementToValues: values

! !

!ExChdSimpleDomainDtdElement methodsFor: 'platypus-generated-copying' stamp: ''!
pltCopyGroup: aClassSymbol to: anObject
	self class name == aClassSymbol
		ifTrue: [ self pltCopyTo: anObject ]
		ifFalse: [ super pltCopyGroup: aClassSymbol to: anObject ]

! !

!ExChdSimpleDomainDtdElement methodsFor: 'platypus-generated-copying' stamp: ''!
pltCopyTo: another
	super pltCopyTo: another.
	self simpleDomainDtdElementCopyTo: another

! !

!ExChdSimpleDomainDtdElement methodsFor: 'platypus-generated-copying' stamp: ''!
pltLocalCopyTo: another
	self simpleDomainDtdElementCopyTo: another

! !

!ExChdSimpleDomainDtdElement methodsFor: 'platypus-generated-copying' stamp: ''!
simpleDomainDtdElementCopyTo: another
	

! !

!ExChdSimpleDomainDtdElement methodsFor: 'platypus-generated-group-accessing' stamp: ''!
simpleDomainDtdElementFromValues: values
	| valuesloc |
	valuesloc := values asOrderedCollection.
	^ valuesloc

! !

!ExChdSimpleDomainDtdElement methodsFor: 'platypus-generated-group-accessing' stamp: ''!
simpleDomainDtdElementToValues: values
	^ values

! !

!ExChdSimpleDomainDtdElement methodsFor: 'platypus-generated-initializing' stamp: ''!
stepInitialize
	super stepInitialize

! !

!ExChdSimpleDomainDtdElement methodsFor: 'platypus-generated-group-accessing' stamp: ''!
toValues: values
	^ self simpleDomainDtdElementToValues: (super toValues: values)

! !

ExChdDomainDtdElement subclass: #ExChdUnknownDomainDtdElement
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Express2Cheddar-CheddarDtdSchema'!

!ExChdUnknownDomainDtdElement commentStamp: 'platypus comment' prior: 0!
<ISO10303-11-EXPRESS>
ENTITY unknown_domain_dtd_element 
	SUBTYPE OF ( domain_dtd_element );
DERIVE
	SELF\dtd_element.dtd_code : STRING := '<!!ELEMENT ' + SELF.owner.tag + ' ANY>\n';
	SELF\domain_dtd_element.as_collection_element_dtd_code_tail : STRING := 'ANY>\n';
END_ENTITY;
</ISO10303-11-EXPRESS>!

!ExChdUnknownDomainDtdElement class methodsFor: 'platypus-generated-platypus-signature' stamp: ''!
iso10303P11Translater
	^ 'Platypus (c) LISYC EA3883, Universite de Bretagne occidentale. Brest.'

! !

!ExChdUnknownDomainDtdElement class methodsFor: 'platypus-generated-meta-data-accessing' stamp: ''!
schemaDefinition
	^ ExChdCheddarDtdSchemaDefinition singleton

! !

!ExChdUnknownDomainDtdElement class methodsFor: 'platypus-generated-meta-data-accessing' stamp: ''!
schemaInstance
	^ ExChdExpress2cheddarSchemaInstance singleton

! !

!ExChdUnknownDomainDtdElement class methodsFor: 'platypus-generated-platypus-signature' stamp: ''!
translatedFromISO10303P11
	^ true

! !

!ExChdUnknownDomainDtdElement class methodsFor: 'platypus-generated-platypus-signature' stamp: ''!
vwNamespaceName
	^ #Express2Cheddar

! !

!ExChdUnknownDomainDtdElement methodsFor: 'platypus-generated-visiting' stamp: ''!
accept: aVisitor
	^ aVisitor acceptUnknownDomainDtdElement: self

! !

!ExChdUnknownDomainDtdElement methodsFor: 'platypus-generated-deriving' stamp: ''!
asCollectionElementDtdCodeTail
	^ self asCollectionElementDtdCodeTailUsingContext: self class context

! !

!ExChdUnknownDomainDtdElement methodsFor: 'platypus-generated-deriving' stamp: ''!
asCollectionElementDtdCodeTailUsingContext: aContext
	^ self asCollectionElementDtdCodeTailUsingContext: aContext receiver: self

! !

!ExChdUnknownDomainDtdElement methodsFor: 'platypus-generated-deriving' stamp: ''!
asCollectionElementDtdCodeTailUsingContext: aContext receiver: aReceiver
	^ 'ANY>\n'

! !

!ExChdUnknownDomainDtdElement methodsFor: 'platypus-generated-deriving' stamp: ''!
dtdCode
	^ self dtdCodeUsingContext: self class context

! !

!ExChdUnknownDomainDtdElement methodsFor: 'platypus-generated-deriving' stamp: ''!
dtdCodeUsingContext: aContext
	^ self dtdCodeUsingContext: aContext receiver: self

! !

!ExChdUnknownDomainDtdElement methodsFor: 'platypus-generated-deriving' stamp: ''!
dtdCodeUsingContext: aContext receiver: aReceiver
	^ ('<!!ELEMENT ' pltPlus: ((aReceiver ownerUsingContext: aContext) tagUsingContext: aContext)) pltPlus: ' ANY>\n'

! !

!ExChdUnknownDomainDtdElement methodsFor: 'platypus-generated-group-accessing' stamp: ''!
fromValues: values
	^ self unknownDomainDtdElementFromValues: (super fromValues: values)

! !

!ExChdUnknownDomainDtdElement methodsFor: 'platypus-generated-classifying' stamp: ''!
isExChdUnknownDomainDtdElement
	^ true

! !

!ExChdUnknownDomainDtdElement methodsFor: 'platypus-generated-group-accessing' stamp: ''!
localFromValues: values
	^ self unknownDomainDtdElementFromValues: values

! !

!ExChdUnknownDomainDtdElement methodsFor: 'platypus-generated-group-accessing' stamp: ''!
localToValues: values
	^ self unknownDomainDtdElementToValues: values

! !

!ExChdUnknownDomainDtdElement methodsFor: 'platypus-generated-copying' stamp: ''!
pltCopyGroup: aClassSymbol to: anObject
	self class name == aClassSymbol
		ifTrue: [ self pltCopyTo: anObject ]
		ifFalse: [ super pltCopyGroup: aClassSymbol to: anObject ]

! !

!ExChdUnknownDomainDtdElement methodsFor: 'platypus-generated-copying' stamp: ''!
pltCopyTo: another
	super pltCopyTo: another.
	self unknownDomainDtdElementCopyTo: another

! !

!ExChdUnknownDomainDtdElement methodsFor: 'platypus-generated-copying' stamp: ''!
pltLocalCopyTo: another
	self unknownDomainDtdElementCopyTo: another

! !

!ExChdUnknownDomainDtdElement methodsFor: 'platypus-generated-initializing' stamp: ''!
stepInitialize
	super stepInitialize

! !

!ExChdUnknownDomainDtdElement methodsFor: 'platypus-generated-group-accessing' stamp: ''!
toValues: values
	^ self unknownDomainDtdElementToValues: (super toValues: values)

! !

!ExChdUnknownDomainDtdElement methodsFor: 'platypus-generated-copying' stamp: ''!
unknownDomainDtdElementCopyTo: another
	

! !

!ExChdUnknownDomainDtdElement methodsFor: 'platypus-generated-group-accessing' stamp: ''!
unknownDomainDtdElementFromValues: values
	| valuesloc |
	valuesloc := values asOrderedCollection.
	^ valuesloc

! !

!ExChdUnknownDomainDtdElement methodsFor: 'platypus-generated-group-accessing' stamp: ''!
unknownDomainDtdElementToValues: values
	^ values

! !

!ExChdDtdElement class methodsFor: 'platypus-generated-platypus-signature' stamp: ''!
iso10303P11Translater
	^ 'Platypus (c) LISYC EA3883, Universite de Bretagne occidentale. Brest.'

! !

!ExChdDtdElement class methodsFor: 'platypus-generated-meta-data-accessing' stamp: ''!
schemaDefinition
	^ ExChdCheddarDtdSchemaDefinition singleton

! !

!ExChdDtdElement class methodsFor: 'platypus-generated-meta-data-accessing' stamp: ''!
schemaInstance
	^ ExChdExpress2cheddarSchemaInstance singleton

! !

!ExChdDtdElement class methodsFor: 'platypus-generated-platypus-signature' stamp: ''!
translatedFromISO10303P11
	^ true

! !

!ExChdDtdElement class methodsFor: 'platypus-generated-platypus-signature' stamp: ''!
vwNamespaceName
	^ #Express2Cheddar

! !

!ExChdDtdElement methodsFor: 'platypus-generated-visiting' stamp: ''!
accept: aVisitor
	^ aVisitor acceptDtdElement: self

! !

!ExChdDtdElement methodsFor: 'platypus-generated-deriving' stamp: ''!
dtdCode
	^ self dtdCodeUsingContext: self class context

! !

!ExChdDtdElement methodsFor: 'platypus-generated-deriving' stamp: ''!
dtdCodeUsingContext: aContext
	^ self dtdCodeUsingContext: aContext receiver: self

! !

!ExChdDtdElement methodsFor: 'platypus-generated-deriving' stamp: ''!
dtdCodeUsingContext: aContext receiver: aReceiver
	^ ''

! !

!ExChdDtdElement methodsFor: 'platypus-generated-copying' stamp: ''!
dtdElementCopyTo: another
	another fastSetOwner: self owner.
	another fastSetTag: self tag

! !

!ExChdDtdElement methodsFor: 'platypus-generated-group-accessing' stamp: ''!
dtdElementFromValues: values
	| valuesloc |
	valuesloc := values asOrderedCollection.
	self setOwner: valuesloc removeFirst.
	self setTag: valuesloc removeFirst.
	^ valuesloc

! !

!ExChdDtdElement methodsFor: 'platypus-generated-group-accessing' stamp: ''!
dtdElementToValues: values
	values add: self owner.
	values add: self tag.
	^ values

! !

!ExChdDtdElement methodsFor: 'platypus-generated-fast-set-accessing' stamp: ''!
fastSetOwner: aExChdDtdElement
	owner := aExChdDtdElement

! !

!ExChdDtdElement methodsFor: 'platypus-generated-fast-set-accessing' stamp: ''!
fastSetTag: aString
	tag := aString

! !

!ExChdDtdElement methodsFor: 'platypus-generated-group-accessing' stamp: ''!
fromValues: values
	^ self dtdElementFromValues: (super fromValues: values)

! !

!ExChdDtdElement methodsFor: 'platypus-generated-classifying' stamp: ''!
isExChdDtdElement
	^ true

! !

!ExChdDtdElement methodsFor: 'platypus-generated-group-accessing' stamp: ''!
localFromValues: values
	^ self dtdElementFromValues: values

! !

!ExChdDtdElement methodsFor: 'platypus-generated-group-accessing' stamp: ''!
localToValues: values
	^ self dtdElementToValues: values

! !

!ExChdDtdElement methodsFor: 'platypus-generated-accessing' stamp: ''!
owner
	^ owner

! !

!ExChdDtdElement methodsFor: 'platypus-generated-accessing' stamp: ''!
owner: aExChdDtdElement
	owner := aExChdDtdElement

! !

!ExChdDtdElement methodsFor: 'platypus-generated-with-context-accessing' stamp: ''!
ownerUsingContext: aContext
	^ self owner

! !

!ExChdDtdElement methodsFor: 'platypus-generated-copying' stamp: ''!
pltCopyGroup: aClassSymbol to: anObject
	self class name == aClassSymbol
		ifTrue: [ self pltCopyTo: anObject ]
		ifFalse: [ super pltCopyGroup: aClassSymbol to: anObject ]

! !

!ExChdDtdElement methodsFor: 'platypus-generated-copying' stamp: ''!
pltCopyTo: another
	super pltCopyTo: another.
	self dtdElementCopyTo: another

! !

!ExChdDtdElement methodsFor: 'platypus-generated-copying' stamp: ''!
pltLocalCopyTo: another
	self dtdElementCopyTo: another

! !

!ExChdDtdElement methodsFor: 'platypus-generated-set-accessing' stamp: ''!
setOwner: aExChdDtdElement
	self owner: aExChdDtdElement

! !

!ExChdDtdElement methodsFor: 'platypus-generated-set-accessing' stamp: ''!
setTag: aString
	self tag: aString

! !

!ExChdDtdElement methodsFor: 'platypus-generated-initializing' stamp: ''!
stepInitialize
	super stepInitialize.
	owner := nil.
	tag := ''

! !

!ExChdDtdElement methodsFor: 'platypus-generated-accessing' stamp: ''!
tag
	^ tag

! !

!ExChdDtdElement methodsFor: 'platypus-generated-accessing' stamp: ''!
tag: aString
	tag := aString

! !

!ExChdDtdElement methodsFor: 'platypus-generated-with-context-accessing' stamp: ''!
tagUsingContext: aContext
	^ self tag

! !

!ExChdDtdElement methodsFor: 'platypus-generated-group-accessing' stamp: ''!
toValues: values
	^ self dtdElementToValues: (super toValues: values)

! !

ExChdCoreEntity subclass: #ExChdInScopeAttribute
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Express2Cheddar-CheddarDomainsSchema'!

!ExChdInScopeAttribute commentStamp: 'platypus comment' prior: 0!
<ISO10303-11-EXPRESS>
ENTITY in_scope_attribute;
DERIVE
	init_code : STRING := in_scope_attribute_init_code ( SELF );
END_ENTITY;
</ISO10303-11-EXPRESS>!

!ExChdInScopeAttribute class methodsFor: 'platypus-generated-platypus-signature' stamp: ''!
iso10303P11Translater
	^ 'Platypus (c) LISYC EA3883, Universite de Bretagne occidentale. Brest.'

! !

!ExChdInScopeAttribute class methodsFor: 'platypus-generated-meta-data-accessing' stamp: ''!
schemaDefinition
	^ ExChdCheddarDomainsSchemaDefinition singleton

! !

!ExChdInScopeAttribute class methodsFor: 'platypus-generated-meta-data-accessing' stamp: ''!
schemaInstance
	^ ExChdExpress2cheddarSchemaInstance singleton

! !

!ExChdInScopeAttribute class methodsFor: 'platypus-generated-platypus-signature' stamp: ''!
translatedFromISO10303P11
	^ true

! !

!ExChdInScopeAttribute class methodsFor: 'platypus-generated-platypus-signature' stamp: ''!
vwNamespaceName
	^ #Express2Cheddar

! !

!ExChdInScopeAttribute methodsFor: 'platypus-generated-visiting' stamp: ''!
accept: aVisitor
	^ aVisitor acceptInScopeAttribute: self

! !

!ExChdInScopeAttribute methodsFor: 'platypus-generated-group-accessing' stamp: ''!
fromValues: values
	^ self inScopeAttributeFromValues: (super fromValues: values)

! !

!ExChdInScopeAttribute methodsFor: 'platypus-generated-copying' stamp: ''!
inScopeAttributeCopyTo: another
	

! !

!ExChdInScopeAttribute methodsFor: 'platypus-generated-group-accessing' stamp: ''!
inScopeAttributeFromValues: values
	| valuesloc |
	valuesloc := values asOrderedCollection.
	^ valuesloc

! !

!ExChdInScopeAttribute methodsFor: 'platypus-generated-group-accessing' stamp: ''!
inScopeAttributeToValues: values
	^ values

! !

!ExChdInScopeAttribute methodsFor: 'platypus-generated-deriving' stamp: ''!
initCode
	^ self initCodeUsingContext: self class context

! !

!ExChdInScopeAttribute methodsFor: 'platypus-generated-deriving' stamp: ''!
initCodeUsingContext: aContext
	^ self initCodeUsingContext: aContext receiver: self

! !

!ExChdInScopeAttribute methodsFor: 'platypus-generated-deriving' stamp: ''!
initCodeUsingContext: aContext receiver: aReceiver
	^ ExChdInScopeAttributeInitCodeFunction
		invokeFromValues:
			(OrderedCollection new
				add: aReceiver;
				yourself)

! !

!ExChdInScopeAttribute methodsFor: 'platypus-generated-classifying' stamp: ''!
isExChdInScopeAttribute
	^ true

! !

!ExChdInScopeAttribute methodsFor: 'platypus-generated-group-accessing' stamp: ''!
localFromValues: values
	^ self inScopeAttributeFromValues: values

! !

!ExChdInScopeAttribute methodsFor: 'platypus-generated-group-accessing' stamp: ''!
localToValues: values
	^ self inScopeAttributeToValues: values

! !

!ExChdInScopeAttribute methodsFor: 'platypus-generated-copying' stamp: ''!
pltCopyGroup: aClassSymbol to: anObject
	self class name == aClassSymbol
		ifTrue: [ self pltCopyTo: anObject ]
		ifFalse: [ super pltCopyGroup: aClassSymbol to: anObject ]

! !

!ExChdInScopeAttribute methodsFor: 'platypus-generated-copying' stamp: ''!
pltCopyTo: another
	super pltCopyTo: another.
	self inScopeAttributeCopyTo: another

! !

!ExChdInScopeAttribute methodsFor: 'platypus-generated-copying' stamp: ''!
pltLocalCopyTo: another
	self inScopeAttributeCopyTo: another

! !

!ExChdInScopeAttribute methodsFor: 'platypus-generated-initializing' stamp: ''!
stepInitialize
	super stepInitialize

! !

!ExChdInScopeAttribute methodsFor: 'platypus-generated-group-accessing' stamp: ''!
toValues: values
	^ self inScopeAttributeToValues: (super toValues: values)

! !

ExChdCoreEntity subclass: #ExChdPackageAlias
	instanceVariableNames: 'packageName attributeName'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Express2Cheddar-PackageSchema'!

!ExChdPackageAlias commentStamp: 'platypus comment' prior: 0!
<ISO10303-11-EXPRESS>
ENTITY package_alias;
	package_name : STRING;
	attribute_name : STRING;
DERIVE
	ptr_type : STRING := SELF.name + '_Ptr';
	ads_interfaces_list : LIST OF ada_interface := [ ];
	adb_interfaces_list : LIST OF ada_interface := [ ada_interface ( SELF.owner.name, ?, true, true ) ];
	ads_code : STRING := 'subtype ' + SELF.name + ' is ' + package_name + '.' + attribute_name + ';\n' 
	+ 'subtype ' + SELF.ptr_type + ' is  ' + package_name + '.' + attribute_name + '_Ptr;\n';
	adb_code : STRING := '';
	init_value : STRING := ?;
	dependencies : LIST OF dictionary_instance := [ SELF ];
	ada_ref_ident : STRING := SELF.ptr_type;
	refed_by_pointer : BOOLEAN := true;
END_ENTITY;
</ISO10303-11-EXPRESS>!

!ExChdPackageAlias class methodsFor: 'platypus-generated-platypus-signature' stamp: ''!
iso10303P11Translater
	^ 'Platypus (c) LISYC EA3883, Universite de Bretagne occidentale. Brest.'

! !

!ExChdPackageAlias class methodsFor: 'platypus-generated-meta-data-accessing' stamp: ''!
schemaDefinition
	^ ExChdPackageSchemaDefinition singleton

! !

!ExChdPackageAlias class methodsFor: 'platypus-generated-meta-data-accessing' stamp: ''!
schemaInstance
	^ ExChdExpress2cheddarSchemaInstance singleton

! !

!ExChdPackageAlias class methodsFor: 'platypus-generated-platypus-signature' stamp: ''!
translatedFromISO10303P11
	^ true

! !

!ExChdPackageAlias class methodsFor: 'platypus-generated-platypus-signature' stamp: ''!
vwNamespaceName
	^ #Express2Cheddar

! !

!ExChdPackageAlias methodsFor: 'platypus-generated-visiting' stamp: ''!
accept: aVisitor
	^ aVisitor acceptPackageAlias: self

! !

!ExChdPackageAlias methodsFor: 'platypus-generated-deriving' stamp: ''!
adaRefIdent
	^ self adaRefIdentUsingContext: self class context

! !

!ExChdPackageAlias methodsFor: 'platypus-generated-deriving' stamp: ''!
adaRefIdentUsingContext: aContext
	^ self adaRefIdentUsingContext: aContext receiver: self

! !

!ExChdPackageAlias methodsFor: 'platypus-generated-deriving' stamp: ''!
adaRefIdentUsingContext: aContext receiver: aReceiver
	^ aReceiver ptrTypeUsingContext: aContext

! !

!ExChdPackageAlias methodsFor: 'platypus-generated-deriving' stamp: ''!
adbCode
	^ self adbCodeUsingContext: self class context

! !

!ExChdPackageAlias methodsFor: 'platypus-generated-deriving' stamp: ''!
adbCodeUsingContext: aContext
	^ self adbCodeUsingContext: aContext receiver: self

! !

!ExChdPackageAlias methodsFor: 'platypus-generated-deriving' stamp: ''!
adbCodeUsingContext: aContext receiver: aReceiver
	^ ''

! !

!ExChdPackageAlias methodsFor: 'platypus-generated-deriving' stamp: ''!
adbInterfacesList
	^ self adbInterfacesListUsingContext: self class context

! !

!ExChdPackageAlias methodsFor: 'platypus-generated-deriving' stamp: ''!
adbInterfacesListUsingContext: aContext
	^ self adbInterfacesListUsingContext: aContext receiver: self

! !

!ExChdPackageAlias methodsFor: 'platypus-generated-deriving' stamp: ''!
adbInterfacesListUsingContext: aContext receiver: aReceiver
	^ PlatypusCoreAggregateInitializer
		collectionFrom:
			(OrderedCollection new
				add:
						(ExChdAdaInterface new
								adaInterfaceFromValues:
										(OrderedCollection new
												add: ((aReceiver ownerUsingContext: self class context) nameUsingContext: self class context);
												add: nil;
												add: true;
												add: true;
												yourself);
								yourself);
				yourself)

! !

!ExChdPackageAlias methodsFor: 'platypus-generated-deriving' stamp: ''!
adsCode
	^ self adsCodeUsingContext: self class context

! !

!ExChdPackageAlias methodsFor: 'platypus-generated-deriving' stamp: ''!
adsCodeUsingContext: aContext
	^ self adsCodeUsingContext: aContext receiver: self

! !

!ExChdPackageAlias methodsFor: 'platypus-generated-deriving' stamp: ''!
adsCodeUsingContext: aContext receiver: aReceiver
	^ (((((((((((('subtype ' pltPlus: (aReceiver nameUsingContext: aContext)) pltPlus: ' is ')
		pltPlus: aReceiver packageName) pltPlus: '.') pltPlus: aReceiver attributeName) pltPlus: ';\n') pltPlus: 'subtype ')
		pltPlus: (aReceiver ptrTypeUsingContext: aContext)) pltPlus: ' is  ') pltPlus: aReceiver packageName) pltPlus: '.')
		pltPlus: aReceiver attributeName) pltPlus: '_Ptr;\n'

! !

!ExChdPackageAlias methodsFor: 'platypus-generated-deriving' stamp: ''!
adsInterfacesList
	^ self adsInterfacesListUsingContext: self class context

! !

!ExChdPackageAlias methodsFor: 'platypus-generated-deriving' stamp: ''!
adsInterfacesListUsingContext: aContext
	^ self adsInterfacesListUsingContext: aContext receiver: self

! !

!ExChdPackageAlias methodsFor: 'platypus-generated-deriving' stamp: ''!
adsInterfacesListUsingContext: aContext receiver: aReceiver
	^ Array new

! !

!ExChdPackageAlias methodsFor: 'platypus-generated-accessing' stamp: ''!
attributeName
	^ attributeName

! !

!ExChdPackageAlias methodsFor: 'platypus-generated-accessing' stamp: ''!
attributeName: aString
	attributeName := aString

! !

!ExChdPackageAlias methodsFor: 'platypus-generated-with-context-accessing' stamp: ''!
attributeNameUsingContext: aContext
	^ self attributeName

! !

!ExChdPackageAlias methodsFor: 'platypus-generated-deriving' stamp: ''!
dependencies
	^ self dependenciesUsingContext: self class context

! !

!ExChdPackageAlias methodsFor: 'platypus-generated-deriving' stamp: ''!
dependenciesUsingContext: aContext
	^ self dependenciesUsingContext: aContext receiver: self

! !

!ExChdPackageAlias methodsFor: 'platypus-generated-deriving' stamp: ''!
dependenciesUsingContext: aContext receiver: aReceiver
	^ PlatypusCoreAggregateInitializer
		collectionFrom:
			(OrderedCollection new
				add: aReceiver;
				yourself)

! !

!ExChdPackageAlias methodsFor: 'platypus-generated-fast-set-accessing' stamp: ''!
fastSetAttributeName: aString
	attributeName := aString

! !

!ExChdPackageAlias methodsFor: 'platypus-generated-fast-set-accessing' stamp: ''!
fastSetPackageName: aString
	packageName := aString

! !

!ExChdPackageAlias methodsFor: 'platypus-generated-group-accessing' stamp: ''!
fromValues: values
	^ self packageAliasFromValues: (super fromValues: values)

! !

!ExChdPackageAlias methodsFor: 'platypus-generated-deriving' stamp: ''!
initValue
	^ self initValueUsingContext: self class context

! !

!ExChdPackageAlias methodsFor: 'platypus-generated-deriving' stamp: ''!
initValueUsingContext: aContext
	^ self initValueUsingContext: aContext receiver: self

! !

!ExChdPackageAlias methodsFor: 'platypus-generated-deriving' stamp: ''!
initValueUsingContext: aContext receiver: aReceiver
	^ nil

! !

!ExChdPackageAlias methodsFor: 'platypus-generated-classifying' stamp: ''!
isExChdPackageAlias
	^ true

! !

!ExChdPackageAlias methodsFor: 'platypus-generated-group-accessing' stamp: ''!
localFromValues: values
	^ self packageAliasFromValues: values

! !

!ExChdPackageAlias methodsFor: 'platypus-generated-group-accessing' stamp: ''!
localToValues: values
	^ self packageAliasToValues: values

! !

!ExChdPackageAlias methodsFor: 'platypus-generated-copying' stamp: ''!
packageAliasCopyTo: another
	another fastSetPackageName: self packageName.
	another fastSetAttributeName: self attributeName

! !

!ExChdPackageAlias methodsFor: 'platypus-generated-group-accessing' stamp: ''!
packageAliasFromValues: values
	| valuesloc |
	valuesloc := values asOrderedCollection.
	self setPackageName: valuesloc removeFirst.
	self setAttributeName: valuesloc removeFirst.
	^ valuesloc

! !

!ExChdPackageAlias methodsFor: 'platypus-generated-group-accessing' stamp: ''!
packageAliasToValues: values
	values add: self packageName.
	values add: self attributeName.
	^ values

! !

!ExChdPackageAlias methodsFor: 'platypus-generated-accessing' stamp: ''!
packageName
	^ packageName

! !

!ExChdPackageAlias methodsFor: 'platypus-generated-accessing' stamp: ''!
packageName: aString
	packageName := aString

! !

!ExChdPackageAlias methodsFor: 'platypus-generated-with-context-accessing' stamp: ''!
packageNameUsingContext: aContext
	^ self packageName

! !

!ExChdPackageAlias methodsFor: 'platypus-generated-copying' stamp: ''!
pltCopyGroup: aClassSymbol to: anObject
	self class name == aClassSymbol
		ifTrue: [ self pltCopyTo: anObject ]
		ifFalse: [ super pltCopyGroup: aClassSymbol to: anObject ]

! !

!ExChdPackageAlias methodsFor: 'platypus-generated-copying' stamp: ''!
pltCopyTo: another
	super pltCopyTo: another.
	self packageAliasCopyTo: another

! !

!ExChdPackageAlias methodsFor: 'platypus-generated-copying' stamp: ''!
pltLocalCopyTo: another
	self packageAliasCopyTo: another

! !

!ExChdPackageAlias methodsFor: 'platypus-generated-deriving' stamp: ''!
ptrType
	^ self ptrTypeUsingContext: self class context

! !

!ExChdPackageAlias methodsFor: 'platypus-generated-deriving' stamp: ''!
ptrTypeUsingContext: aContext
	^ self ptrTypeUsingContext: aContext receiver: self

! !

!ExChdPackageAlias methodsFor: 'platypus-generated-deriving' stamp: ''!
ptrTypeUsingContext: aContext receiver: aReceiver
	^ (aReceiver nameUsingContext: aContext) pltPlus: '_Ptr'

! !

!ExChdPackageAlias methodsFor: 'platypus-generated-deriving' stamp: ''!
refedByPointer
	^ self refedByPointerUsingContext: self class context

! !

!ExChdPackageAlias methodsFor: 'platypus-generated-deriving' stamp: ''!
refedByPointerUsingContext: aContext
	^ self refedByPointerUsingContext: aContext receiver: self

! !

!ExChdPackageAlias methodsFor: 'platypus-generated-deriving' stamp: ''!
refedByPointerUsingContext: aContext receiver: aReceiver
	^ true

! !

!ExChdPackageAlias methodsFor: 'platypus-generated-set-accessing' stamp: ''!
setAttributeName: aString
	self attributeName: aString

! !

!ExChdPackageAlias methodsFor: 'platypus-generated-set-accessing' stamp: ''!
setPackageName: aString
	self packageName: aString

! !

!ExChdPackageAlias methodsFor: 'platypus-generated-initializing' stamp: ''!
stepInitialize
	super stepInitialize.
	packageName := ''.
	attributeName := ''

! !

!ExChdPackageAlias methodsFor: 'platypus-generated-group-accessing' stamp: ''!
toValues: values
	^ self packageAliasToValues: (super toValues: values)

! !

ExChdCoreEntity subclass: #ExChdPragmaConvention
	instanceVariableNames: 'convention'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Express2Cheddar-CheddarDomainsSchema'!

!ExChdPragmaConvention commentStamp: 'platypus comment' prior: 0!
<ISO10303-11-EXPRESS>
ENTITY pragma_convention;
	convention : STRING;
END_ENTITY;
</ISO10303-11-EXPRESS>!

!ExChdPragmaConvention class methodsFor: 'platypus-generated-platypus-signature' stamp: ''!
iso10303P11Translater
	^ 'Platypus (c) LISYC EA3883, Universite de Bretagne occidentale. Brest.'

! !

!ExChdPragmaConvention class methodsFor: 'platypus-generated-meta-data-accessing' stamp: ''!
schemaDefinition
	^ ExChdCheddarDomainsSchemaDefinition singleton

! !

!ExChdPragmaConvention class methodsFor: 'platypus-generated-meta-data-accessing' stamp: ''!
schemaInstance
	^ ExChdExpress2cheddarSchemaInstance singleton

! !

!ExChdPragmaConvention class methodsFor: 'platypus-generated-platypus-signature' stamp: ''!
translatedFromISO10303P11
	^ true

! !

!ExChdPragmaConvention class methodsFor: 'platypus-generated-platypus-signature' stamp: ''!
vwNamespaceName
	^ #Express2Cheddar

! !

!ExChdPragmaConvention methodsFor: 'platypus-generated-visiting' stamp: ''!
accept: aVisitor
	^ aVisitor acceptPragmaConvention: self

! !

!ExChdPragmaConvention methodsFor: 'platypus-generated-accessing' stamp: ''!
convention
	^ convention

! !

!ExChdPragmaConvention methodsFor: 'platypus-generated-accessing' stamp: ''!
convention: aString
	convention := aString

! !

!ExChdPragmaConvention methodsFor: 'platypus-generated-with-context-accessing' stamp: ''!
conventionUsingContext: aContext
	^ self convention

! !

!ExChdPragmaConvention methodsFor: 'platypus-generated-fast-set-accessing' stamp: ''!
fastSetConvention: aString
	convention := aString

! !

!ExChdPragmaConvention methodsFor: 'platypus-generated-group-accessing' stamp: ''!
fromValues: values
	^ self pragmaConventionFromValues: (super fromValues: values)

! !

!ExChdPragmaConvention methodsFor: 'platypus-generated-classifying' stamp: ''!
isExChdPragmaConvention
	^ true

! !

!ExChdPragmaConvention methodsFor: 'platypus-generated-group-accessing' stamp: ''!
localFromValues: values
	^ self pragmaConventionFromValues: values

! !

!ExChdPragmaConvention methodsFor: 'platypus-generated-group-accessing' stamp: ''!
localToValues: values
	^ self pragmaConventionToValues: values

! !

!ExChdPragmaConvention methodsFor: 'platypus-generated-copying' stamp: ''!
pltCopyGroup: aClassSymbol to: anObject
	self class name == aClassSymbol
		ifTrue: [ self pltCopyTo: anObject ]
		ifFalse: [ super pltCopyGroup: aClassSymbol to: anObject ]

! !

!ExChdPragmaConvention methodsFor: 'platypus-generated-copying' stamp: ''!
pltCopyTo: another
	super pltCopyTo: another.
	self pragmaConventionCopyTo: another

! !

!ExChdPragmaConvention methodsFor: 'platypus-generated-copying' stamp: ''!
pltLocalCopyTo: another
	self pragmaConventionCopyTo: another

! !

!ExChdPragmaConvention methodsFor: 'platypus-generated-copying' stamp: ''!
pragmaConventionCopyTo: another
	another fastSetConvention: self convention

! !

!ExChdPragmaConvention methodsFor: 'platypus-generated-group-accessing' stamp: ''!
pragmaConventionFromValues: values
	| valuesloc |
	valuesloc := values asOrderedCollection.
	self setConvention: valuesloc removeFirst.
	^ valuesloc

! !

!ExChdPragmaConvention methodsFor: 'platypus-generated-group-accessing' stamp: ''!
pragmaConventionToValues: values
	values add: self convention.
	^ values

! !

!ExChdPragmaConvention methodsFor: 'platypus-generated-set-accessing' stamp: ''!
setConvention: aString
	self convention: aString

! !

!ExChdPragmaConvention methodsFor: 'platypus-generated-initializing' stamp: ''!
stepInitialize
	super stepInitialize.
	convention := ''

! !

!ExChdPragmaConvention methodsFor: 'platypus-generated-group-accessing' stamp: ''!
toValues: values
	^ self pragmaConventionToValues: (super toValues: values)

! !

ExChdCoreEntity subclass: #ExChdUnmappedEntityDefinition
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Express2Cheddar-CheddarDomainsSchema'!

!ExChdUnmappedEntityDefinition commentStamp: 'platypus comment' prior: 0!
<ISO10303-11-EXPRESS>
ENTITY unmapped_entity_definition;
DERIVE
	ads_interfaces_list : LIST OF ada_interface := [ ];
	adb_interfaces_list : LIST OF ada_interface := [ ];
	ada_ident : STRING := SELF.name;
	ada_ref_ident : STRING := SELF.name;
	init_value : STRING := ?;
	ads_code : STRING := '';
	adb_code : STRING := '';
END_ENTITY;
</ISO10303-11-EXPRESS>!

!ExChdUnmappedEntityDefinition class methodsFor: 'platypus-generated-platypus-signature' stamp: ''!
iso10303P11Translater
	^ 'Platypus (c) LISYC EA3883, Universite de Bretagne occidentale. Brest.'

! !

!ExChdUnmappedEntityDefinition class methodsFor: 'platypus-generated-meta-data-accessing' stamp: ''!
schemaDefinition
	^ ExChdCheddarDomainsSchemaDefinition singleton

! !

!ExChdUnmappedEntityDefinition class methodsFor: 'platypus-generated-meta-data-accessing' stamp: ''!
schemaInstance
	^ ExChdExpress2cheddarSchemaInstance singleton

! !

!ExChdUnmappedEntityDefinition class methodsFor: 'platypus-generated-platypus-signature' stamp: ''!
translatedFromISO10303P11
	^ true

! !

!ExChdUnmappedEntityDefinition class methodsFor: 'platypus-generated-platypus-signature' stamp: ''!
vwNamespaceName
	^ #Express2Cheddar

! !

!ExChdUnmappedEntityDefinition methodsFor: 'platypus-generated-visiting' stamp: ''!
accept: aVisitor
	^ aVisitor acceptUnmappedEntityDefinition: self

! !

!ExChdUnmappedEntityDefinition methodsFor: 'platypus-generated-deriving' stamp: ''!
adaIdent
	^ self adaIdentUsingContext: self class context

! !

!ExChdUnmappedEntityDefinition methodsFor: 'platypus-generated-deriving' stamp: ''!
adaIdentUsingContext: aContext
	^ self adaIdentUsingContext: aContext receiver: self

! !

!ExChdUnmappedEntityDefinition methodsFor: 'platypus-generated-deriving' stamp: ''!
adaIdentUsingContext: aContext receiver: aReceiver
	^ aReceiver nameUsingContext: aContext

! !

!ExChdUnmappedEntityDefinition methodsFor: 'platypus-generated-deriving' stamp: ''!
adaRefIdent
	^ self adaRefIdentUsingContext: self class context

! !

!ExChdUnmappedEntityDefinition methodsFor: 'platypus-generated-deriving' stamp: ''!
adaRefIdentUsingContext: aContext
	^ self adaRefIdentUsingContext: aContext receiver: self

! !

!ExChdUnmappedEntityDefinition methodsFor: 'platypus-generated-deriving' stamp: ''!
adaRefIdentUsingContext: aContext receiver: aReceiver
	^ aReceiver nameUsingContext: aContext

! !

!ExChdUnmappedEntityDefinition methodsFor: 'platypus-generated-deriving' stamp: ''!
adbCode
	^ self adbCodeUsingContext: self class context

! !

!ExChdUnmappedEntityDefinition methodsFor: 'platypus-generated-deriving' stamp: ''!
adbCodeUsingContext: aContext
	^ self adbCodeUsingContext: aContext receiver: self

! !

!ExChdUnmappedEntityDefinition methodsFor: 'platypus-generated-deriving' stamp: ''!
adbCodeUsingContext: aContext receiver: aReceiver
	^ ''

! !

!ExChdUnmappedEntityDefinition methodsFor: 'platypus-generated-deriving' stamp: ''!
adbInterfacesList
	^ self adbInterfacesListUsingContext: self class context

! !

!ExChdUnmappedEntityDefinition methodsFor: 'platypus-generated-deriving' stamp: ''!
adbInterfacesListUsingContext: aContext
	^ self adbInterfacesListUsingContext: aContext receiver: self

! !

!ExChdUnmappedEntityDefinition methodsFor: 'platypus-generated-deriving' stamp: ''!
adbInterfacesListUsingContext: aContext receiver: aReceiver
	^ Array new

! !

!ExChdUnmappedEntityDefinition methodsFor: 'platypus-generated-deriving' stamp: ''!
adsCode
	^ self adsCodeUsingContext: self class context

! !

!ExChdUnmappedEntityDefinition methodsFor: 'platypus-generated-deriving' stamp: ''!
adsCodeUsingContext: aContext
	^ self adsCodeUsingContext: aContext receiver: self

! !

!ExChdUnmappedEntityDefinition methodsFor: 'platypus-generated-deriving' stamp: ''!
adsCodeUsingContext: aContext receiver: aReceiver
	^ ''

! !

!ExChdUnmappedEntityDefinition methodsFor: 'platypus-generated-deriving' stamp: ''!
adsInterfacesList
	^ self adsInterfacesListUsingContext: self class context

! !

!ExChdUnmappedEntityDefinition methodsFor: 'platypus-generated-deriving' stamp: ''!
adsInterfacesListUsingContext: aContext
	^ self adsInterfacesListUsingContext: aContext receiver: self

! !

!ExChdUnmappedEntityDefinition methodsFor: 'platypus-generated-deriving' stamp: ''!
adsInterfacesListUsingContext: aContext receiver: aReceiver
	^ Array new

! !

!ExChdUnmappedEntityDefinition methodsFor: 'platypus-generated-group-accessing' stamp: ''!
fromValues: values
	^ self unmappedEntityDefinitionFromValues: (super fromValues: values)

! !

!ExChdUnmappedEntityDefinition methodsFor: 'platypus-generated-deriving' stamp: ''!
initValue
	^ self initValueUsingContext: self class context

! !

!ExChdUnmappedEntityDefinition methodsFor: 'platypus-generated-deriving' stamp: ''!
initValueUsingContext: aContext
	^ self initValueUsingContext: aContext receiver: self

! !

!ExChdUnmappedEntityDefinition methodsFor: 'platypus-generated-deriving' stamp: ''!
initValueUsingContext: aContext receiver: aReceiver
	^ nil

! !

!ExChdUnmappedEntityDefinition methodsFor: 'platypus-generated-classifying' stamp: ''!
isExChdUnmappedEntityDefinition
	^ true

! !

!ExChdUnmappedEntityDefinition methodsFor: 'platypus-generated-group-accessing' stamp: ''!
localFromValues: values
	^ self unmappedEntityDefinitionFromValues: values

! !

!ExChdUnmappedEntityDefinition methodsFor: 'platypus-generated-group-accessing' stamp: ''!
localToValues: values
	^ self unmappedEntityDefinitionToValues: values

! !

!ExChdUnmappedEntityDefinition methodsFor: 'platypus-generated-copying' stamp: ''!
pltCopyGroup: aClassSymbol to: anObject
	self class name == aClassSymbol
		ifTrue: [ self pltCopyTo: anObject ]
		ifFalse: [ super pltCopyGroup: aClassSymbol to: anObject ]

! !

!ExChdUnmappedEntityDefinition methodsFor: 'platypus-generated-copying' stamp: ''!
pltCopyTo: another
	super pltCopyTo: another.
	self unmappedEntityDefinitionCopyTo: another

! !

!ExChdUnmappedEntityDefinition methodsFor: 'platypus-generated-copying' stamp: ''!
pltLocalCopyTo: another
	self unmappedEntityDefinitionCopyTo: another

! !

!ExChdUnmappedEntityDefinition methodsFor: 'platypus-generated-initializing' stamp: ''!
stepInitialize
	super stepInitialize

! !

!ExChdUnmappedEntityDefinition methodsFor: 'platypus-generated-group-accessing' stamp: ''!
toValues: values
	^ self unmappedEntityDefinitionToValues: (super toValues: values)

! !

!ExChdUnmappedEntityDefinition methodsFor: 'platypus-generated-copying' stamp: ''!
unmappedEntityDefinitionCopyTo: another
	

! !

!ExChdUnmappedEntityDefinition methodsFor: 'platypus-generated-group-accessing' stamp: ''!
unmappedEntityDefinitionFromValues: values
	| valuesloc |
	valuesloc := values asOrderedCollection.
	^ valuesloc

! !

!ExChdUnmappedEntityDefinition methodsFor: 'platypus-generated-group-accessing' stamp: ''!
unmappedEntityDefinitionToValues: values
	^ values

! !

ExChdCoreEntity subclass: #ExChdUnmappedTypeReference
	instanceVariableNames: 'ref'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Express2Cheddar-CheddarDomainsSchema'!

!ExChdUnmappedTypeReference commentStamp: 'platypus comment' prior: 0!
<ISO10303-11-EXPRESS>
ENTITY unmapped_type_reference;
	ref : entity_instance;
DERIVE
	ads_interfaces_list : LIST OF ada_interface := basic_ada_domain ( SELF.ref ).ads_interfaces_list;
	adb_interfaces_list : LIST OF ada_interface := basic_ada_domain ( SELF.ref ).adb_interfaces_list;
	ada_ident : STRING := SELF.name;
	ada_ref_ident : STRING := SELF.name;
	init_value : STRING := basic_ada_domain ( SELF.ref ).init_value;
	ads_code : STRING := '';
	adb_code : STRING := '';
	refed_by_pointer : BOOLEAN := false;
END_ENTITY;
</ISO10303-11-EXPRESS>!

!ExChdUnmappedTypeReference class methodsFor: 'platypus-generated-platypus-signature' stamp: ''!
iso10303P11Translater
	^ 'Platypus (c) LISYC EA3883, Universite de Bretagne occidentale. Brest.'

! !

!ExChdUnmappedTypeReference class methodsFor: 'platypus-generated-meta-data-accessing' stamp: ''!
schemaDefinition
	^ ExChdCheddarDomainsSchemaDefinition singleton

! !

!ExChdUnmappedTypeReference class methodsFor: 'platypus-generated-meta-data-accessing' stamp: ''!
schemaInstance
	^ ExChdExpress2cheddarSchemaInstance singleton

! !

!ExChdUnmappedTypeReference class methodsFor: 'platypus-generated-platypus-signature' stamp: ''!
translatedFromISO10303P11
	^ true

! !

!ExChdUnmappedTypeReference class methodsFor: 'platypus-generated-platypus-signature' stamp: ''!
vwNamespaceName
	^ #Express2Cheddar

! !

!ExChdUnmappedTypeReference methodsFor: 'platypus-generated-visiting' stamp: ''!
accept: aVisitor
	^ aVisitor acceptUnmappedTypeReference: self

! !

!ExChdUnmappedTypeReference methodsFor: 'platypus-generated-deriving' stamp: ''!
adaIdent
	^ self adaIdentUsingContext: self class context

! !

!ExChdUnmappedTypeReference methodsFor: 'platypus-generated-deriving' stamp: ''!
adaIdentUsingContext: aContext
	^ self adaIdentUsingContext: aContext receiver: self

! !

!ExChdUnmappedTypeReference methodsFor: 'platypus-generated-deriving' stamp: ''!
adaIdentUsingContext: aContext receiver: aReceiver
	^ aReceiver nameUsingContext: aContext

! !

!ExChdUnmappedTypeReference methodsFor: 'platypus-generated-deriving' stamp: ''!
adaRefIdent
	^ self adaRefIdentUsingContext: self class context

! !

!ExChdUnmappedTypeReference methodsFor: 'platypus-generated-deriving' stamp: ''!
adaRefIdentUsingContext: aContext
	^ self adaRefIdentUsingContext: aContext receiver: self

! !

!ExChdUnmappedTypeReference methodsFor: 'platypus-generated-deriving' stamp: ''!
adaRefIdentUsingContext: aContext receiver: aReceiver
	^ aReceiver nameUsingContext: aContext

! !

!ExChdUnmappedTypeReference methodsFor: 'platypus-generated-deriving' stamp: ''!
adbCode
	^ self adbCodeUsingContext: self class context

! !

!ExChdUnmappedTypeReference methodsFor: 'platypus-generated-deriving' stamp: ''!
adbCodeUsingContext: aContext
	^ self adbCodeUsingContext: aContext receiver: self

! !

!ExChdUnmappedTypeReference methodsFor: 'platypus-generated-deriving' stamp: ''!
adbCodeUsingContext: aContext receiver: aReceiver
	^ ''

! !

!ExChdUnmappedTypeReference methodsFor: 'platypus-generated-deriving' stamp: ''!
adbInterfacesList
	^ self adbInterfacesListUsingContext: self class context

! !

!ExChdUnmappedTypeReference methodsFor: 'platypus-generated-deriving' stamp: ''!
adbInterfacesListUsingContext: aContext
	^ self adbInterfacesListUsingContext: aContext receiver: self

! !

!ExChdUnmappedTypeReference methodsFor: 'platypus-generated-deriving' stamp: ''!
adbInterfacesListUsingContext: aContext receiver: aReceiver
	^ (ExChdBasicAdaDomainFunction
		invokeFromValues:
			(OrderedCollection new
				add: (aReceiver refUsingContext: self class context);
				yourself)) adbInterfacesListUsingContext: aContext

! !

!ExChdUnmappedTypeReference methodsFor: 'platypus-generated-deriving' stamp: ''!
adsCode
	^ self adsCodeUsingContext: self class context

! !

!ExChdUnmappedTypeReference methodsFor: 'platypus-generated-deriving' stamp: ''!
adsCodeUsingContext: aContext
	^ self adsCodeUsingContext: aContext receiver: self

! !

!ExChdUnmappedTypeReference methodsFor: 'platypus-generated-deriving' stamp: ''!
adsCodeUsingContext: aContext receiver: aReceiver
	^ ''

! !

!ExChdUnmappedTypeReference methodsFor: 'platypus-generated-deriving' stamp: ''!
adsInterfacesList
	^ self adsInterfacesListUsingContext: self class context

! !

!ExChdUnmappedTypeReference methodsFor: 'platypus-generated-deriving' stamp: ''!
adsInterfacesListUsingContext: aContext
	^ self adsInterfacesListUsingContext: aContext receiver: self

! !

!ExChdUnmappedTypeReference methodsFor: 'platypus-generated-deriving' stamp: ''!
adsInterfacesListUsingContext: aContext receiver: aReceiver
	^ (ExChdBasicAdaDomainFunction
		invokeFromValues:
			(OrderedCollection new
				add: (aReceiver refUsingContext: self class context);
				yourself)) adsInterfacesListUsingContext: aContext

! !

!ExChdUnmappedTypeReference methodsFor: 'platypus-generated-fast-set-accessing' stamp: ''!
fastSetRef: aExChdEntityInstance
	ref := aExChdEntityInstance

! !

!ExChdUnmappedTypeReference methodsFor: 'platypus-generated-group-accessing' stamp: ''!
fromValues: values
	^ self unmappedTypeReferenceFromValues: (super fromValues: values)

! !

!ExChdUnmappedTypeReference methodsFor: 'platypus-generated-deriving' stamp: ''!
initValue
	^ self initValueUsingContext: self class context

! !

!ExChdUnmappedTypeReference methodsFor: 'platypus-generated-deriving' stamp: ''!
initValueUsingContext: aContext
	^ self initValueUsingContext: aContext receiver: self

! !

!ExChdUnmappedTypeReference methodsFor: 'platypus-generated-deriving' stamp: ''!
initValueUsingContext: aContext receiver: aReceiver
	^ (ExChdBasicAdaDomainFunction
		invokeFromValues:
			(OrderedCollection new
				add: (aReceiver refUsingContext: self class context);
				yourself)) initValueUsingContext: aContext

! !

!ExChdUnmappedTypeReference methodsFor: 'platypus-generated-classifying' stamp: ''!
isExChdUnmappedTypeReference
	^ true

! !

!ExChdUnmappedTypeReference methodsFor: 'platypus-generated-group-accessing' stamp: ''!
localFromValues: values
	^ self unmappedTypeReferenceFromValues: values

! !

!ExChdUnmappedTypeReference methodsFor: 'platypus-generated-group-accessing' stamp: ''!
localToValues: values
	^ self unmappedTypeReferenceToValues: values

! !

!ExChdUnmappedTypeReference methodsFor: 'platypus-generated-copying' stamp: ''!
pltCopyGroup: aClassSymbol to: anObject
	self class name == aClassSymbol
		ifTrue: [ self pltCopyTo: anObject ]
		ifFalse: [ super pltCopyGroup: aClassSymbol to: anObject ]

! !

!ExChdUnmappedTypeReference methodsFor: 'platypus-generated-copying' stamp: ''!
pltCopyTo: another
	super pltCopyTo: another.
	self unmappedTypeReferenceCopyTo: another

! !

!ExChdUnmappedTypeReference methodsFor: 'platypus-generated-copying' stamp: ''!
pltLocalCopyTo: another
	self unmappedTypeReferenceCopyTo: another

! !

!ExChdUnmappedTypeReference methodsFor: 'platypus-generated-accessing' stamp: ''!
ref
	^ ref

! !

!ExChdUnmappedTypeReference methodsFor: 'platypus-generated-accessing' stamp: ''!
ref: aExChdEntityInstance
	ref := aExChdEntityInstance

! !

!ExChdUnmappedTypeReference methodsFor: 'platypus-generated-with-context-accessing' stamp: ''!
refUsingContext: aContext
	^ self ref

! !

!ExChdUnmappedTypeReference methodsFor: 'platypus-generated-deriving' stamp: ''!
refedByPointer
	^ self refedByPointerUsingContext: self class context

! !

!ExChdUnmappedTypeReference methodsFor: 'platypus-generated-deriving' stamp: ''!
refedByPointerUsingContext: aContext
	^ self refedByPointerUsingContext: aContext receiver: self

! !

!ExChdUnmappedTypeReference methodsFor: 'platypus-generated-deriving' stamp: ''!
refedByPointerUsingContext: aContext receiver: aReceiver
	^ false

! !

!ExChdUnmappedTypeReference methodsFor: 'platypus-generated-set-accessing' stamp: ''!
setRef: aExChdEntityInstance
	self ref: aExChdEntityInstance

! !

!ExChdUnmappedTypeReference methodsFor: 'platypus-generated-initializing' stamp: ''!
stepInitialize
	super stepInitialize.
	ref := nil

! !

!ExChdUnmappedTypeReference methodsFor: 'platypus-generated-group-accessing' stamp: ''!
toValues: values
	^ self unmappedTypeReferenceToValues: (super toValues: values)

! !

!ExChdUnmappedTypeReference methodsFor: 'platypus-generated-copying' stamp: ''!
unmappedTypeReferenceCopyTo: another
	another fastSetRef: self ref

! !

!ExChdUnmappedTypeReference methodsFor: 'platypus-generated-group-accessing' stamp: ''!
unmappedTypeReferenceFromValues: values
	| valuesloc |
	valuesloc := values asOrderedCollection.
	self setRef: valuesloc removeFirst.
	^ valuesloc

! !

!ExChdUnmappedTypeReference methodsFor: 'platypus-generated-group-accessing' stamp: ''!
unmappedTypeReferenceToValues: values
	values add: self ref.
	^ values

! !

PlatypusCoreAbstractVisitor subclass: #Express2CheddarAbstractVisitor
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Express2Cheddar-Express2cheddarSchemaInstance'!

!Express2CheddarAbstractVisitor class methodsFor: 'platypus-generated-platypus-signature' stamp: ''!
iso10303P11Translater
	^ 'Platypus (c) LISYC EA3883, Universite de Bretagne occidentale. Brest.'

! !

!Express2CheddarAbstractVisitor class methodsFor: 'platypus-generated-platypus-signature' stamp: ''!
translatedFromISO10303P11
	^ true

! !

!Express2CheddarAbstractVisitor class methodsFor: 'platypus-generated-platypus-signature' stamp: ''!
vwNamespaceName
	^ #Express2Cheddar

! !

!Express2CheddarAbstractVisitor methodsFor: 'platypus-generated-visitingCheddarDomains' stamp: ''!
acceptAdaArrayType: e
	"my subclasses have to redefine it"

	

! !

!Express2CheddarAbstractVisitor methodsFor: 'platypus-generated-visitingCheddarDomains' stamp: ''!
acceptAdaAttributeReference: e
	"my subclasses have to redefine it"

	

! !

!Express2CheddarAbstractVisitor methodsFor: 'platypus-generated-visitingCheddarDomains' stamp: ''!
acceptAdaBagType: e
	"my subclasses have to redefine it"

	

! !

!Express2CheddarAbstractVisitor methodsFor: 'platypus-generated-visitingCheddarDomains' stamp: ''!
acceptAdaBooleanType: e
	"my subclasses have to redefine it"

	

! !

!Express2CheddarAbstractVisitor methodsFor: 'platypus-generated-visitingRecordAndClass' stamp: ''!
acceptAdaClass: e
	"my subclasses have to redefine it"

	

! !

!Express2CheddarAbstractVisitor methodsFor: 'platypus-generated-visitingCheddarDtd' stamp: ''!
acceptAdaClassDtdElement: e
	"my subclasses have to redefine it"

	

! !

!Express2CheddarAbstractVisitor methodsFor: 'platypus-generated-visitingCheddarDtd' stamp: ''!
acceptAdaClassRefDtdElement: e
	"my subclasses have to redefine it"

	

! !

!Express2CheddarAbstractVisitor methodsFor: 'platypus-generated-visitingCheddarDomains' stamp: ''!
acceptAdaClassReference: e
	"my subclasses have to redefine it"

	

! !

!Express2CheddarAbstractVisitor methodsFor: 'platypus-generated-visitingCheddarConstants' stamp: ''!
acceptAdaConstant: e
	"my subclasses have to redefine it"

	

! !

!Express2CheddarAbstractVisitor methodsFor: 'platypus-generated-visitingCheddarDomains' stamp: ''!
acceptAdaDoubleType: e
	"my subclasses have to redefine it"

	

! !

!Express2CheddarAbstractVisitor methodsFor: 'platypus-generated-visitingRecordAndClass' stamp: ''!
acceptAdaEntity: e
	"my subclasses have to redefine it"

	

! !

!Express2CheddarAbstractVisitor methodsFor: 'platypus-generated-visitingCheddarDomains' stamp: ''!
acceptAdaEnumeration: e
	"my subclasses have to redefine it"

	

! !

!Express2CheddarAbstractVisitor methodsFor: 'platypus-generated-visitingCheddarDomains' stamp: ''!
acceptAdaIntegerType: e
	"my subclasses have to redefine it"

	

! !

!Express2CheddarAbstractVisitor methodsFor: 'platypus-generated-visitingAdaInterface' stamp: ''!
acceptAdaInterface: e
	"my subclasses have to redefine it"

	

! !

!Express2CheddarAbstractVisitor methodsFor: 'platypus-generated-visitingCheddarDomains' stamp: ''!
acceptAdaListType: e
	"my subclasses have to redefine it"

	

! !

!Express2CheddarAbstractVisitor methodsFor: 'platypus-generated-visitingCheddarDomains' stamp: ''!
acceptAdaNamedTypeReference: e
	"my subclasses have to redefine it"

	

! !

!Express2CheddarAbstractVisitor methodsFor: 'platypus-generated-visitingCheddarDomains' stamp: ''!
acceptAdaNaturalType: e
	"my subclasses have to redefine it"

	

! !

!Express2CheddarAbstractVisitor methodsFor: 'platypus-generated-visitingPackage' stamp: ''!
acceptAdaPackage: e
	"my subclasses have to redefine it"

	

! !

!Express2CheddarAbstractVisitor methodsFor: 'platypus-generated-visitingCheddarDomains' stamp: ''!
acceptAdaPrimitiveClassReference: e
	"my subclasses have to redefine it"

	

! !

!Express2CheddarAbstractVisitor methodsFor: 'platypus-generated-visitingCheddarDomains' stamp: ''!
acceptAdaPrimitiveType: e
	"my subclasses have to redefine it"

	

! !

!Express2CheddarAbstractVisitor methodsFor: 'platypus-generated-visitingCheddarDomains' stamp: ''!
acceptAdaRealType: e
	"my subclasses have to redefine it"

	

! !

!Express2CheddarAbstractVisitor methodsFor: 'platypus-generated-visitingCheddarDomains' stamp: ''!
acceptAdaRecordReference: e
	"my subclasses have to redefine it"

	

! !

!Express2CheddarAbstractVisitor methodsFor: 'platypus-generated-visitingCheddarDomains' stamp: ''!
acceptAdaSetType: e
	"my subclasses have to redefine it"

	

! !

!Express2CheddarAbstractVisitor methodsFor: 'platypus-generated-visitingCheddarDomains' stamp: ''!
acceptAdaType: e
	"my subclasses have to redefine it"

	

! !

!Express2CheddarAbstractVisitor methodsFor: 'platypus-generated-visitingCheddarDomains' stamp: ''!
acceptAdaUnboundedStringType: e
	"my subclasses have to redefine it"

	

! !

!Express2CheddarAbstractVisitor methodsFor: 'platypus-generated-visitingCheddarDtd' stamp: ''!
acceptAttributeDtdElement: e
	"my subclasses have to redefine it"

	

! !

!Express2CheddarAbstractVisitor methodsFor: 'platypus-generated-visitingCheddarDomains' stamp: ''!
acceptBasicAdaTypeGetter: e
	"my subclasses have to redefine it"

	

! !

!Express2CheddarAbstractVisitor methodsFor: 'platypus-generated-visitingCheddarDomains' stamp: ''!
acceptBasicAdaTypeValueFormat: e
	"my subclasses have to redefine it"

	

! !

!Express2CheddarAbstractVisitor methodsFor: 'platypus-generated-visitingCheddarDomains' stamp: ''!
acceptCheddarDefinedType: e
	"my subclasses have to redefine it"

	

! !

!Express2CheddarAbstractVisitor methodsFor: 'platypus-generated-visitingCheddarDomains' stamp: ''!
acceptCheddarEntityDefinition: e
	"my subclasses have to redefine it"

	

! !

!Express2CheddarAbstractVisitor methodsFor: 'platypus-generated-visitingRecordAndClass' stamp: ''!
acceptCheddarFunctionPtr: e
	"my subclasses have to redefine it"

	

! !

!Express2CheddarAbstractVisitor methodsFor: 'platypus-generated-visitingCheddarDomains' stamp: ''!
acceptCheddarLawType: e
	"my subclasses have to redefine it"

	

! !

!Express2CheddarAbstractVisitor methodsFor: 'platypus-generated-visitingCheddarDomains' stamp: ''!
acceptCheddarPrimitiveType: e
	"my subclasses have to redefine it"

	

! !

!Express2CheddarAbstractVisitor methodsFor: 'platypus-generated-visitingCheddarDomains' stamp: ''!
acceptCheddarPriorityRange: e
	"my subclasses have to redefine it"

	

! !

!Express2CheddarAbstractVisitor methodsFor: 'platypus-generated-visitingCheddarDomains' stamp: ''!
acceptCheddarXmlIdType: e
	"my subclasses have to redefine it"

	

! !

!Express2CheddarAbstractVisitor methodsFor: 'platypus-generated-visitingCheddarDtd' stamp: ''!
acceptCollectionDtdElement: e
	"my subclasses have to redefine it"

	

! !

!Express2CheddarAbstractVisitor methodsFor: 'platypus-generated-visitingCheddarDtd' stamp: ''!
acceptCompositeDtdElement: e
	"my subclasses have to redefine it"

	

! !

!Express2CheddarAbstractVisitor methodsFor: 'platypus-generated-visitingCheddarDomains' stamp: ''!
acceptConstrainedArrayType: e
	"my subclasses have to redefine it"

	

! !

!Express2CheddarAbstractVisitor methodsFor: 'platypus-generated-visitingDiscriminatedType' stamp: ''!
acceptDiscriminatedType: e
	"my subclasses have to redefine it"

	

! !

!Express2CheddarAbstractVisitor methodsFor: 'platypus-generated-visitingDiscriminatedType' stamp: ''!
acceptDiscriminatedTypeDiscriminant: e
	"my subclasses have to redefine it"

	

! !

!Express2CheddarAbstractVisitor methodsFor: 'platypus-generated-visitingCheddarDtd' stamp: ''!
acceptDiscriminatedTypeDtdElement: e
	"my subclasses have to redefine it"

	

! !

!Express2CheddarAbstractVisitor methodsFor: 'platypus-generated-visitingCheddarDtd' stamp: ''!
acceptDiscriminatedTypeRefDtdElement: e
	"my subclasses have to redefine it"

	

! !

!Express2CheddarAbstractVisitor methodsFor: 'platypus-generated-visitingDiscriminatedType' stamp: ''!
acceptDiscriminatedTypeUnion: e
	"my subclasses have to redefine it"

	

! !

!Express2CheddarAbstractVisitor methodsFor: 'platypus-generated-visitingDiscriminatedType' stamp: ''!
acceptDiscriminatedTypeUnionElementType: e
	"my subclasses have to redefine it"

	

! !

!Express2CheddarAbstractVisitor methodsFor: 'platypus-generated-visitingDiscriminatedType' stamp: ''!
acceptDiscriminatedTypeUnionType: e
	"my subclasses have to redefine it"

	

! !

!Express2CheddarAbstractVisitor methodsFor: 'platypus-generated-visitingCheddarDtd' stamp: ''!
acceptDomainDtdElement: e
	"my subclasses have to redefine it"

	

! !

!Express2CheddarAbstractVisitor methodsFor: 'platypus-generated-visitingCheddarDtd' stamp: ''!
acceptDtdElement: e
	"my subclasses have to redefine it"

	

! !

!Express2CheddarAbstractVisitor methodsFor: 'platypus-generated-visitingCheddarDtd' stamp: ''!
acceptEntityDtdElement: e
	"my subclasses have to redefine it"

	

! !

!Express2CheddarAbstractVisitor methodsFor: 'platypus-generated-visitingCheddarDtd' stamp: ''!
acceptEntityRefDtdElement: e
	"my subclasses have to redefine it"

	

! !

!Express2CheddarAbstractVisitor methodsFor: 'platypus-generated-visitingCheddarDomains' stamp: ''!
acceptExplicitTypeReference: e
	"my subclasses have to redefine it"

	

! !

!Express2CheddarAbstractVisitor methodsFor: 'platypus-generated-visitingPackage' stamp: ''!
acceptGenericPackageInstanciation: e
	"my subclasses have to redefine it"

	

! !

!Express2CheddarAbstractVisitor methodsFor: 'platypus-generated-visitingCheddarDomains' stamp: ''!
acceptInScopeAttribute: e
	"my subclasses have to redefine it"

	

! !

!Express2CheddarAbstractVisitor methodsFor: 'platypus-generated-visitingPackage' stamp: ''!
acceptPackageAlias: e
	"my subclasses have to redefine it"

	

! !

!Express2CheddarAbstractVisitor methodsFor: 'platypus-generated-visitingCheddarDtd' stamp: ''!
acceptPackageDtdElement: e
	"my subclasses have to redefine it"

	

! !

!Express2CheddarAbstractVisitor methodsFor: 'platypus-generated-visitingCheddarDomains' stamp: ''!
acceptPragmaConvention: e
	"my subclasses have to redefine it"

	

! !

!Express2CheddarAbstractVisitor methodsFor: 'platypus-generated-visitingCheddarDomains' stamp: ''!
acceptRangeType: e
	"my subclasses have to redefine it"

	

! !

!Express2CheddarAbstractVisitor methodsFor: 'platypus-generated-visitingRecordAndClass' stamp: ''!
acceptRecord: e
	"my subclasses have to redefine it"

	

! !

!Express2CheddarAbstractVisitor methodsFor: 'platypus-generated-visitingCheddarDtd' stamp: ''!
acceptRecordDtdElement: e
	"my subclasses have to redefine it"

	

! !

!Express2CheddarAbstractVisitor methodsFor: 'platypus-generated-visitingCheddarDtd' stamp: ''!
acceptRecordRefDtdElement: e
	"my subclasses have to redefine it"

	

! !

!Express2CheddarAbstractVisitor methodsFor: 'platypus-generated-visitingCheddarDtd' stamp: ''!
acceptRootDtdElement: e
	"my subclasses have to redefine it"

	

! !

!Express2CheddarAbstractVisitor methodsFor: 'platypus-generated-visitingCheddarDtd' stamp: ''!
acceptSimpleDomainDtdElement: e
	"my subclasses have to redefine it"

	

! !

!Express2CheddarAbstractVisitor methodsFor: 'platypus-generated-visitingCheddarDtd' stamp: ''!
acceptUnknownDomainDtdElement: e
	"my subclasses have to redefine it"

	

! !

!Express2CheddarAbstractVisitor methodsFor: 'platypus-generated-visitingCheddarDomains' stamp: ''!
acceptUnmappedEntityDefinition: e
	"my subclasses have to redefine it"

	

! !

!Express2CheddarAbstractVisitor methodsFor: 'platypus-generated-visitingCheddarDomains' stamp: ''!
acceptUnmappedTypeReference: e
	"my subclasses have to redefine it"

	

! !

PltSetType subclass: #ExChdAdaSetType
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Express2Cheddar-CheddarDomainsSchema'!

!ExChdAdaSetType commentStamp: 'platypus comment' prior: 0!
<ISO10303-11-EXPRESS>
ENTITY ada_set_type 
	SUBTYPE OF ( set_type );
DERIVE
	ads_interfaces_list : LIST OF ada_interface := std_io_interfaces;
	adb_interfaces_list : LIST OF ada_interface := [ ];
	ada_ident : STRING := 'set';
	ada_ref_ident : STRING := SELF.ada_ident;
END_ENTITY;
</ISO10303-11-EXPRESS>!

!ExChdAdaSetType class methodsFor: 'platypus-generated-platypus-signature' stamp: ''!
iso10303P11Translater
	^ 'Platypus (c) LISYC EA3883, Universite de Bretagne occidentale. Brest.'

! !

!ExChdAdaSetType class methodsFor: 'platypus-generated-meta-data-accessing' stamp: ''!
schemaDefinition
	^ ExChdCheddarDomainsSchemaDefinition singleton

! !

!ExChdAdaSetType class methodsFor: 'platypus-generated-meta-data-accessing' stamp: ''!
schemaInstance
	^ ExChdExpress2cheddarSchemaInstance singleton

! !

!ExChdAdaSetType class methodsFor: 'platypus-generated-platypus-signature' stamp: ''!
translatedFromISO10303P11
	^ true

! !

!ExChdAdaSetType class methodsFor: 'platypus-generated-platypus-signature' stamp: ''!
vwNamespaceName
	^ #Express2Cheddar

! !

!ExChdAdaSetType methodsFor: 'platypus-generated-visiting' stamp: ''!
accept: aVisitor
	^ aVisitor acceptAdaSetType: self

! !

!ExChdAdaSetType methodsFor: 'platypus-generated-deriving' stamp: ''!
adaIdent
	^ self adaIdentUsingContext: self class context

! !

!ExChdAdaSetType methodsFor: 'platypus-generated-deriving' stamp: ''!
adaIdentUsingContext: aContext
	^ self adaIdentUsingContext: aContext receiver: self

! !

!ExChdAdaSetType methodsFor: 'platypus-generated-deriving' stamp: ''!
adaIdentUsingContext: aContext receiver: aReceiver
	^ 'set'

! !

!ExChdAdaSetType methodsFor: 'platypus-generated-deriving' stamp: ''!
adaRefIdent
	^ self adaRefIdentUsingContext: self class context

! !

!ExChdAdaSetType methodsFor: 'platypus-generated-deriving' stamp: ''!
adaRefIdentUsingContext: aContext
	^ self adaRefIdentUsingContext: aContext receiver: self

! !

!ExChdAdaSetType methodsFor: 'platypus-generated-deriving' stamp: ''!
adaRefIdentUsingContext: aContext receiver: aReceiver
	^ aReceiver adaIdentUsingContext: aContext

! !

!ExChdAdaSetType methodsFor: 'platypus-generated-copying' stamp: ''!
adaSetTypeCopyTo: another
	

! !

!ExChdAdaSetType methodsFor: 'platypus-generated-group-accessing' stamp: ''!
adaSetTypeFromValues: values
	| valuesloc |
	valuesloc := values asOrderedCollection.
	^ valuesloc

! !

!ExChdAdaSetType methodsFor: 'platypus-generated-group-accessing' stamp: ''!
adaSetTypeToValues: values
	^ values

! !

!ExChdAdaSetType methodsFor: 'platypus-generated-deriving' stamp: ''!
adbInterfacesList
	^ self adbInterfacesListUsingContext: self class context

! !

!ExChdAdaSetType methodsFor: 'platypus-generated-deriving' stamp: ''!
adbInterfacesListUsingContext: aContext
	^ self adbInterfacesListUsingContext: aContext receiver: self

! !

!ExChdAdaSetType methodsFor: 'platypus-generated-deriving' stamp: ''!
adbInterfacesListUsingContext: aContext receiver: aReceiver
	^ Array new

! !

!ExChdAdaSetType methodsFor: 'platypus-generated-deriving' stamp: ''!
adsInterfacesList
	^ self adsInterfacesListUsingContext: self class context

! !

!ExChdAdaSetType methodsFor: 'platypus-generated-deriving' stamp: ''!
adsInterfacesListUsingContext: aContext
	^ self adsInterfacesListUsingContext: aContext receiver: self

! !

!ExChdAdaSetType methodsFor: 'platypus-generated-deriving' stamp: ''!
adsInterfacesListUsingContext: aContext receiver: aReceiver
	^ PlatypusCoreAggregateInitializer
		collectionFrom:
			(OrderedCollection new
				add:
						(ExChdAdaInterface new
								adaInterfaceFromValues:
										(OrderedCollection new
												add: 'standards_io';
												add: nil;
												add: true;
												add: true;
												yourself);
								yourself);
				yourself)

! !

!ExChdAdaSetType methodsFor: 'platypus-generated-group-accessing' stamp: ''!
fromValues: values
	^ self adaSetTypeFromValues: (super fromValues: values)

! !

!ExChdAdaSetType methodsFor: 'platypus-generated-classifying' stamp: ''!
isExChdAdaSetType
	^ true

! !

!ExChdAdaSetType methodsFor: 'platypus-generated-group-accessing' stamp: ''!
localFromValues: values
	^ self adaSetTypeFromValues: values

! !

!ExChdAdaSetType methodsFor: 'platypus-generated-group-accessing' stamp: ''!
localToValues: values
	^ self adaSetTypeToValues: values

! !

!ExChdAdaSetType methodsFor: 'platypus-generated-copying' stamp: ''!
pltCopyGroup: aClassSymbol to: anObject
	self class name == aClassSymbol
		ifTrue: [ self pltCopyTo: anObject ]
		ifFalse: [ super pltCopyGroup: aClassSymbol to: anObject ]

! !

!ExChdAdaSetType methodsFor: 'platypus-generated-copying' stamp: ''!
pltCopyTo: another
	super pltCopyTo: another.
	self adaSetTypeCopyTo: another

! !

!ExChdAdaSetType methodsFor: 'platypus-generated-copying' stamp: ''!
pltLocalCopyTo: another
	self adaSetTypeCopyTo: another

! !

!ExChdAdaSetType methodsFor: 'platypus-generated-initializing' stamp: ''!
stepInitialize
	super stepInitialize

! !

!ExChdAdaSetType methodsFor: 'platypus-generated-group-accessing' stamp: ''!
toValues: values
	^ self adaSetTypeToValues: (super toValues: values)

! !

PltListType subclass: #ExChdAdaListType
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Express2Cheddar-CheddarDomainsSchema'!

!ExChdAdaListType commentStamp: 'platypus comment' prior: 0!
<ISO10303-11-EXPRESS>
ENTITY ada_list_type 
	SUBTYPE OF ( list_type );
DERIVE
	ads_interfaces_list : LIST OF ada_interface := std_io_interfaces;
	adb_interfaces_list : LIST OF ada_interface := [ ];
	ada_ident : STRING := 'list';
	ada_ref_ident : STRING := SELF.ada_ident;
	init_value : STRING := ?;
END_ENTITY;
</ISO10303-11-EXPRESS>!

!ExChdAdaListType class methodsFor: 'platypus-generated-platypus-signature' stamp: ''!
iso10303P11Translater
	^ 'Platypus (c) LISYC EA3883, Universite de Bretagne occidentale. Brest.'

! !

!ExChdAdaListType class methodsFor: 'platypus-generated-meta-data-accessing' stamp: ''!
schemaDefinition
	^ ExChdCheddarDomainsSchemaDefinition singleton

! !

!ExChdAdaListType class methodsFor: 'platypus-generated-meta-data-accessing' stamp: ''!
schemaInstance
	^ ExChdExpress2cheddarSchemaInstance singleton

! !

!ExChdAdaListType class methodsFor: 'platypus-generated-platypus-signature' stamp: ''!
translatedFromISO10303P11
	^ true

! !

!ExChdAdaListType class methodsFor: 'platypus-generated-platypus-signature' stamp: ''!
vwNamespaceName
	^ #Express2Cheddar

! !

!ExChdAdaListType methodsFor: 'platypus-generated-visiting' stamp: ''!
accept: aVisitor
	^ aVisitor acceptAdaListType: self

! !

!ExChdAdaListType methodsFor: 'platypus-generated-deriving' stamp: ''!
adaIdent
	^ self adaIdentUsingContext: self class context

! !

!ExChdAdaListType methodsFor: 'platypus-generated-deriving' stamp: ''!
adaIdentUsingContext: aContext
	^ self adaIdentUsingContext: aContext receiver: self

! !

!ExChdAdaListType methodsFor: 'platypus-generated-deriving' stamp: ''!
adaIdentUsingContext: aContext receiver: aReceiver
	^ 'list'

! !

!ExChdAdaListType methodsFor: 'platypus-generated-copying' stamp: ''!
adaListTypeCopyTo: another
	

! !

!ExChdAdaListType methodsFor: 'platypus-generated-group-accessing' stamp: ''!
adaListTypeFromValues: values
	| valuesloc |
	valuesloc := values asOrderedCollection.
	^ valuesloc

! !

!ExChdAdaListType methodsFor: 'platypus-generated-group-accessing' stamp: ''!
adaListTypeToValues: values
	^ values

! !

!ExChdAdaListType methodsFor: 'platypus-generated-deriving' stamp: ''!
adaRefIdent
	^ self adaRefIdentUsingContext: self class context

! !

!ExChdAdaListType methodsFor: 'platypus-generated-deriving' stamp: ''!
adaRefIdentUsingContext: aContext
	^ self adaRefIdentUsingContext: aContext receiver: self

! !

!ExChdAdaListType methodsFor: 'platypus-generated-deriving' stamp: ''!
adaRefIdentUsingContext: aContext receiver: aReceiver
	^ aReceiver adaIdentUsingContext: aContext

! !

!ExChdAdaListType methodsFor: 'platypus-generated-deriving' stamp: ''!
adbInterfacesList
	^ self adbInterfacesListUsingContext: self class context

! !

!ExChdAdaListType methodsFor: 'platypus-generated-deriving' stamp: ''!
adbInterfacesListUsingContext: aContext
	^ self adbInterfacesListUsingContext: aContext receiver: self

! !

!ExChdAdaListType methodsFor: 'platypus-generated-deriving' stamp: ''!
adbInterfacesListUsingContext: aContext receiver: aReceiver
	^ Array new

! !

!ExChdAdaListType methodsFor: 'platypus-generated-deriving' stamp: ''!
adsInterfacesList
	^ self adsInterfacesListUsingContext: self class context

! !

!ExChdAdaListType methodsFor: 'platypus-generated-deriving' stamp: ''!
adsInterfacesListUsingContext: aContext
	^ self adsInterfacesListUsingContext: aContext receiver: self

! !

!ExChdAdaListType methodsFor: 'platypus-generated-deriving' stamp: ''!
adsInterfacesListUsingContext: aContext receiver: aReceiver
	^ PlatypusCoreAggregateInitializer
		collectionFrom:
			(OrderedCollection new
				add:
						(ExChdAdaInterface new
								adaInterfaceFromValues:
										(OrderedCollection new
												add: 'standards_io';
												add: nil;
												add: true;
												add: true;
												yourself);
								yourself);
				yourself)

! !

!ExChdAdaListType methodsFor: 'platypus-generated-group-accessing' stamp: ''!
fromValues: values
	^ self adaListTypeFromValues: (super fromValues: values)

! !

!ExChdAdaListType methodsFor: 'platypus-generated-deriving' stamp: ''!
initValue
	^ self initValueUsingContext: self class context

! !

!ExChdAdaListType methodsFor: 'platypus-generated-deriving' stamp: ''!
initValueUsingContext: aContext
	^ self initValueUsingContext: aContext receiver: self

! !

!ExChdAdaListType methodsFor: 'platypus-generated-deriving' stamp: ''!
initValueUsingContext: aContext receiver: aReceiver
	^ nil

! !

!ExChdAdaListType methodsFor: 'platypus-generated-classifying' stamp: ''!
isExChdAdaListType
	^ true

! !

!ExChdAdaListType methodsFor: 'platypus-generated-group-accessing' stamp: ''!
localFromValues: values
	^ self adaListTypeFromValues: values

! !

!ExChdAdaListType methodsFor: 'platypus-generated-group-accessing' stamp: ''!
localToValues: values
	^ self adaListTypeToValues: values

! !

!ExChdAdaListType methodsFor: 'platypus-generated-copying' stamp: ''!
pltCopyGroup: aClassSymbol to: anObject
	self class name == aClassSymbol
		ifTrue: [ self pltCopyTo: anObject ]
		ifFalse: [ super pltCopyGroup: aClassSymbol to: anObject ]

! !

!ExChdAdaListType methodsFor: 'platypus-generated-copying' stamp: ''!
pltCopyTo: another
	super pltCopyTo: another.
	self adaListTypeCopyTo: another

! !

!ExChdAdaListType methodsFor: 'platypus-generated-copying' stamp: ''!
pltLocalCopyTo: another
	self adaListTypeCopyTo: another

! !

!ExChdAdaListType methodsFor: 'platypus-generated-initializing' stamp: ''!
stepInitialize
	super stepInitialize

! !

!ExChdAdaListType methodsFor: 'platypus-generated-group-accessing' stamp: ''!
toValues: values
	^ self adaListTypeToValues: (super toValues: values)

! !

PltEntityInstance subclass: #ExChdAdaNamedTypeReference
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Express2Cheddar-CheddarDomainsSchema'!

!ExChdAdaNamedTypeReference commentStamp: 'platypus comment' prior: 0!
<ISO10303-11-EXPRESS>
ENTITY ada_named_type_reference 
	SUBTYPE OF ( entity_instance );
DERIVE
	ads_interfaces_list : LIST OF ada_interface := [ ];
	adb_interfaces_list : LIST OF ada_interface := [ ];
	ada_ident : STRING := SELF.ref.name;
	ada_ref_ident : STRING := SELF.ada_ident;
END_ENTITY;
</ISO10303-11-EXPRESS>!

ExChdAdaNamedTypeReference subclass: #ExChdAdaAttributeReference
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Express2Cheddar-CheddarDomainsSchema'!

!ExChdAdaAttributeReference commentStamp: 'platypus comment' prior: 0!
<ISO10303-11-EXPRESS>
ENTITY ada_attribute_reference 
	SUBTYPE OF ( ada_named_type_reference );
END_ENTITY;
</ISO10303-11-EXPRESS>!

!ExChdAdaAttributeReference class methodsFor: 'platypus-generated-platypus-signature' stamp: ''!
iso10303P11Translater
	^ 'Platypus (c) LISYC EA3883, Universite de Bretagne occidentale. Brest.'

! !

!ExChdAdaAttributeReference class methodsFor: 'platypus-generated-meta-data-accessing' stamp: ''!
schemaDefinition
	^ ExChdCheddarDomainsSchemaDefinition singleton

! !

!ExChdAdaAttributeReference class methodsFor: 'platypus-generated-meta-data-accessing' stamp: ''!
schemaInstance
	^ ExChdExpress2cheddarSchemaInstance singleton

! !

!ExChdAdaAttributeReference class methodsFor: 'platypus-generated-platypus-signature' stamp: ''!
translatedFromISO10303P11
	^ true

! !

!ExChdAdaAttributeReference class methodsFor: 'platypus-generated-platypus-signature' stamp: ''!
vwNamespaceName
	^ #Express2Cheddar

! !

!ExChdAdaAttributeReference methodsFor: 'platypus-generated-visiting' stamp: ''!
accept: aVisitor
	^ aVisitor acceptAdaAttributeReference: self

! !

!ExChdAdaAttributeReference methodsFor: 'platypus-generated-copying' stamp: ''!
adaAttributeReferenceCopyTo: another
	

! !

!ExChdAdaAttributeReference methodsFor: 'platypus-generated-group-accessing' stamp: ''!
adaAttributeReferenceFromValues: values
	| valuesloc |
	valuesloc := values asOrderedCollection.
	^ valuesloc

! !

!ExChdAdaAttributeReference methodsFor: 'platypus-generated-group-accessing' stamp: ''!
adaAttributeReferenceToValues: values
	^ values

! !

!ExChdAdaAttributeReference methodsFor: 'platypus-generated-group-accessing' stamp: ''!
fromValues: values
	^ self adaAttributeReferenceFromValues: (super fromValues: values)

! !

!ExChdAdaAttributeReference methodsFor: 'platypus-generated-classifying' stamp: ''!
isExChdAdaAttributeReference
	^ true

! !

!ExChdAdaAttributeReference methodsFor: 'platypus-generated-group-accessing' stamp: ''!
localFromValues: values
	^ self adaAttributeReferenceFromValues: values

! !

!ExChdAdaAttributeReference methodsFor: 'platypus-generated-group-accessing' stamp: ''!
localToValues: values
	^ self adaAttributeReferenceToValues: values

! !

!ExChdAdaAttributeReference methodsFor: 'platypus-generated-copying' stamp: ''!
pltCopyGroup: aClassSymbol to: anObject
	self class name == aClassSymbol
		ifTrue: [ self pltCopyTo: anObject ]
		ifFalse: [ super pltCopyGroup: aClassSymbol to: anObject ]

! !

!ExChdAdaAttributeReference methodsFor: 'platypus-generated-copying' stamp: ''!
pltCopyTo: another
	super pltCopyTo: another.
	self adaAttributeReferenceCopyTo: another

! !

!ExChdAdaAttributeReference methodsFor: 'platypus-generated-copying' stamp: ''!
pltLocalCopyTo: another
	self adaAttributeReferenceCopyTo: another

! !

!ExChdAdaAttributeReference methodsFor: 'platypus-generated-initializing' stamp: ''!
stepInitialize
	super stepInitialize

! !

!ExChdAdaAttributeReference methodsFor: 'platypus-generated-group-accessing' stamp: ''!
toValues: values
	^ self adaAttributeReferenceToValues: (super toValues: values)

! !

ExChdAdaNamedTypeReference subclass: #ExChdAdaClassReference
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Express2Cheddar-CheddarDomainsSchema'!

!ExChdAdaClassReference commentStamp: 'platypus comment' prior: 0!
<ISO10303-11-EXPRESS>
ENTITY ada_class_reference 
	SUBTYPE OF ( ada_named_type_reference );
DERIVE
	SELF\entity_definition_reference.accepted : entity_instance := SELF.accept_ada_class_reference;
	SELF\ada_named_type_reference.ads_interfaces_list : LIST OF ada_interface := [ ada_interface ( SELF.ref.owner.name, ?, true, true ) ];
	SELF\ada_named_type_reference.ada_ident : STRING := SELF.ref.name + '_Ptr';
	init_value : STRING := 'initialize';
END_ENTITY;
</ISO10303-11-EXPRESS>!

!ExChdAdaClassReference class methodsFor: 'platypus-generated-platypus-signature' stamp: ''!
iso10303P11Translater
	^ 'Platypus (c) LISYC EA3883, Universite de Bretagne occidentale. Brest.'

! !

!ExChdAdaClassReference class methodsFor: 'platypus-generated-meta-data-accessing' stamp: ''!
schemaDefinition
	^ ExChdCheddarDomainsSchemaDefinition singleton

! !

!ExChdAdaClassReference class methodsFor: 'platypus-generated-meta-data-accessing' stamp: ''!
schemaInstance
	^ ExChdExpress2cheddarSchemaInstance singleton

! !

!ExChdAdaClassReference class methodsFor: 'platypus-generated-platypus-signature' stamp: ''!
translatedFromISO10303P11
	^ true

! !

!ExChdAdaClassReference class methodsFor: 'platypus-generated-platypus-signature' stamp: ''!
vwNamespaceName
	^ #Express2Cheddar

! !

!ExChdAdaClassReference methodsFor: 'platypus-generated-visiting' stamp: ''!
accept: aVisitor
	^ aVisitor acceptAdaClassReference: self

! !

!ExChdAdaClassReference methodsFor: 'platypus-generated-deriving' stamp: ''!
accepted
	^ self acceptedUsingContext: self class context

! !

!ExChdAdaClassReference methodsFor: 'platypus-generated-deriving' stamp: ''!
acceptedUsingContext: aContext
	^ self acceptedUsingContext: aContext receiver: self

! !

!ExChdAdaClassReference methodsFor: 'platypus-generated-deriving' stamp: ''!
acceptedUsingContext: aContext receiver: aReceiver
	^ aReceiver acceptAdaClassReferenceUsingContext: aContext

! !

!ExChdAdaClassReference methodsFor: 'platypus-generated-copying' stamp: ''!
adaClassReferenceCopyTo: another
	

! !

!ExChdAdaClassReference methodsFor: 'platypus-generated-group-accessing' stamp: ''!
adaClassReferenceFromValues: values
	| valuesloc |
	valuesloc := values asOrderedCollection.
	^ valuesloc

! !

!ExChdAdaClassReference methodsFor: 'platypus-generated-group-accessing' stamp: ''!
adaClassReferenceToValues: values
	^ values

! !

!ExChdAdaClassReference methodsFor: 'platypus-generated-deriving' stamp: ''!
adaIdent
	^ self adaIdentUsingContext: self class context

! !

!ExChdAdaClassReference methodsFor: 'platypus-generated-deriving' stamp: ''!
adaIdentUsingContext: aContext
	^ self adaIdentUsingContext: aContext receiver: self

! !

!ExChdAdaClassReference methodsFor: 'platypus-generated-deriving' stamp: ''!
adaIdentUsingContext: aContext receiver: aReceiver
	^ ((aReceiver refUsingContext: aContext) nameUsingContext: aContext) pltPlus: '_Ptr'

! !

!ExChdAdaClassReference methodsFor: 'platypus-generated-deriving' stamp: ''!
adsInterfacesList
	^ self adsInterfacesListUsingContext: self class context

! !

!ExChdAdaClassReference methodsFor: 'platypus-generated-deriving' stamp: ''!
adsInterfacesListUsingContext: aContext
	^ self adsInterfacesListUsingContext: aContext receiver: self

! !

!ExChdAdaClassReference methodsFor: 'platypus-generated-deriving' stamp: ''!
adsInterfacesListUsingContext: aContext receiver: aReceiver
	^ PlatypusCoreAggregateInitializer
		collectionFrom:
			(OrderedCollection new
				add:
						(ExChdAdaInterface new
								adaInterfaceFromValues:
										(OrderedCollection new
												add:
														(((aReceiver refUsingContext: self class context) ownerUsingContext: self class context)
																nameUsingContext: self class context);
												add: nil;
												add: true;
												add: true;
												yourself);
								yourself);
				yourself)

! !

!ExChdAdaClassReference methodsFor: 'platypus-generated-group-accessing' stamp: ''!
fromValues: values
	^ self adaClassReferenceFromValues: (super fromValues: values)

! !

!ExChdAdaClassReference methodsFor: 'platypus-generated-deriving' stamp: ''!
initValue
	^ self initValueUsingContext: self class context

! !

!ExChdAdaClassReference methodsFor: 'platypus-generated-deriving' stamp: ''!
initValueUsingContext: aContext
	^ self initValueUsingContext: aContext receiver: self

! !

!ExChdAdaClassReference methodsFor: 'platypus-generated-deriving' stamp: ''!
initValueUsingContext: aContext receiver: aReceiver
	^ 'initialize'

! !

!ExChdAdaClassReference methodsFor: 'platypus-generated-classifying' stamp: ''!
isExChdAdaClassReference
	^ true

! !

!ExChdAdaClassReference methodsFor: 'platypus-generated-group-accessing' stamp: ''!
localFromValues: values
	^ self adaClassReferenceFromValues: values

! !

!ExChdAdaClassReference methodsFor: 'platypus-generated-group-accessing' stamp: ''!
localToValues: values
	^ self adaClassReferenceToValues: values

! !

!ExChdAdaClassReference methodsFor: 'platypus-generated-copying' stamp: ''!
pltCopyGroup: aClassSymbol to: anObject
	self class name == aClassSymbol
		ifTrue: [ self pltCopyTo: anObject ]
		ifFalse: [ super pltCopyGroup: aClassSymbol to: anObject ]

! !

!ExChdAdaClassReference methodsFor: 'platypus-generated-copying' stamp: ''!
pltCopyTo: another
	super pltCopyTo: another.
	self adaClassReferenceCopyTo: another

! !

!ExChdAdaClassReference methodsFor: 'platypus-generated-copying' stamp: ''!
pltLocalCopyTo: another
	self adaClassReferenceCopyTo: another

! !

!ExChdAdaClassReference methodsFor: 'platypus-generated-initializing' stamp: ''!
stepInitialize
	super stepInitialize

! !

!ExChdAdaClassReference methodsFor: 'platypus-generated-group-accessing' stamp: ''!
toValues: values
	^ self adaClassReferenceToValues: (super toValues: values)

! !

ExChdAdaClassReference subclass: #ExChdAdaPrimitiveClassReference
	instanceVariableNames: 'packageName pointedTypeName'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Express2Cheddar-CheddarDomainsSchema'!

!ExChdAdaPrimitiveClassReference commentStamp: 'platypus comment' prior: 0!
<ISO10303-11-EXPRESS>
ENTITY ada_primitive_class_reference 
	SUBTYPE OF ( ada_class_reference );
	pointed_type_name : STRING;
	package_name : STRING;
DERIVE
	SELF\ada_class_reference.ads_interfaces_list : LIST OF ada_interface := [ ada_interface ( package_name, ?, true, true ) ];
	SELF\ada_class_reference.ada_ident : STRING := pointed_type_name + '_Ptr';
END_ENTITY;
</ISO10303-11-EXPRESS>!

!ExChdAdaPrimitiveClassReference class methodsFor: 'platypus-generated-platypus-signature' stamp: ''!
iso10303P11Translater
	^ 'Platypus (c) LISYC EA3883, Universite de Bretagne occidentale. Brest.'

! !

!ExChdAdaPrimitiveClassReference class methodsFor: 'platypus-generated-meta-data-accessing' stamp: ''!
schemaDefinition
	^ ExChdCheddarDomainsSchemaDefinition singleton

! !

!ExChdAdaPrimitiveClassReference class methodsFor: 'platypus-generated-meta-data-accessing' stamp: ''!
schemaInstance
	^ ExChdExpress2cheddarSchemaInstance singleton

! !

!ExChdAdaPrimitiveClassReference class methodsFor: 'platypus-generated-platypus-signature' stamp: ''!
translatedFromISO10303P11
	^ true

! !

!ExChdAdaPrimitiveClassReference class methodsFor: 'platypus-generated-platypus-signature' stamp: ''!
vwNamespaceName
	^ #Express2Cheddar

! !

!ExChdAdaPrimitiveClassReference methodsFor: 'platypus-generated-visiting' stamp: ''!
accept: aVisitor
	^ aVisitor acceptAdaPrimitiveClassReference: self

! !

!ExChdAdaPrimitiveClassReference methodsFor: 'platypus-generated-deriving' stamp: ''!
adaIdent
	^ self adaIdentUsingContext: self class context

! !

!ExChdAdaPrimitiveClassReference methodsFor: 'platypus-generated-deriving' stamp: ''!
adaIdentUsingContext: aContext
	^ self adaIdentUsingContext: aContext receiver: self

! !

!ExChdAdaPrimitiveClassReference methodsFor: 'platypus-generated-deriving' stamp: ''!
adaIdentUsingContext: aContext receiver: aReceiver
	^ aReceiver pointedTypeName pltPlus: '_Ptr'

! !

!ExChdAdaPrimitiveClassReference methodsFor: 'platypus-generated-copying' stamp: ''!
adaPrimitiveClassReferenceCopyTo: another
	another fastSetPointedTypeName: self pointedTypeName.
	another fastSetPackageName: self packageName

! !

!ExChdAdaPrimitiveClassReference methodsFor: 'platypus-generated-group-accessing' stamp: ''!
adaPrimitiveClassReferenceFromValues: values
	| valuesloc |
	valuesloc := values asOrderedCollection.
	self setPointedTypeName: valuesloc removeFirst.
	self setPackageName: valuesloc removeFirst.
	^ valuesloc

! !

!ExChdAdaPrimitiveClassReference methodsFor: 'platypus-generated-group-accessing' stamp: ''!
adaPrimitiveClassReferenceToValues: values
	values add: self pointedTypeName.
	values add: self packageName.
	^ values

! !

!ExChdAdaPrimitiveClassReference methodsFor: 'platypus-generated-deriving' stamp: ''!
adsInterfacesList
	^ self adsInterfacesListUsingContext: self class context

! !

!ExChdAdaPrimitiveClassReference methodsFor: 'platypus-generated-deriving' stamp: ''!
adsInterfacesListUsingContext: aContext
	^ self adsInterfacesListUsingContext: aContext receiver: self

! !

!ExChdAdaPrimitiveClassReference methodsFor: 'platypus-generated-deriving' stamp: ''!
adsInterfacesListUsingContext: aContext receiver: aReceiver
	^ PlatypusCoreAggregateInitializer
		collectionFrom:
			(OrderedCollection new
				add:
						(ExChdAdaInterface new
								adaInterfaceFromValues:
										(OrderedCollection new
												add: aReceiver packageName;
												add: nil;
												add: true;
												add: true;
												yourself);
								yourself);
				yourself)

! !

!ExChdAdaPrimitiveClassReference methodsFor: 'platypus-generated-fast-set-accessing' stamp: ''!
fastSetPackageName: aString
	packageName := aString

! !

!ExChdAdaPrimitiveClassReference methodsFor: 'platypus-generated-fast-set-accessing' stamp: ''!
fastSetPointedTypeName: aString
	pointedTypeName := aString

! !

!ExChdAdaPrimitiveClassReference methodsFor: 'platypus-generated-group-accessing' stamp: ''!
fromValues: values
	^ self adaPrimitiveClassReferenceFromValues: (super fromValues: values)

! !

!ExChdAdaPrimitiveClassReference methodsFor: 'platypus-generated-classifying' stamp: ''!
isExChdAdaPrimitiveClassReference
	^ true

! !

!ExChdAdaPrimitiveClassReference methodsFor: 'platypus-generated-group-accessing' stamp: ''!
localFromValues: values
	^ self adaPrimitiveClassReferenceFromValues: values

! !

!ExChdAdaPrimitiveClassReference methodsFor: 'platypus-generated-group-accessing' stamp: ''!
localToValues: values
	^ self adaPrimitiveClassReferenceToValues: values

! !

!ExChdAdaPrimitiveClassReference methodsFor: 'platypus-generated-accessing' stamp: ''!
packageName
	^ packageName

! !

!ExChdAdaPrimitiveClassReference methodsFor: 'platypus-generated-accessing' stamp: ''!
packageName: aString
	packageName := aString

! !

!ExChdAdaPrimitiveClassReference methodsFor: 'platypus-generated-with-context-accessing' stamp: ''!
packageNameUsingContext: aContext
	^ self packageName

! !

!ExChdAdaPrimitiveClassReference methodsFor: 'platypus-generated-copying' stamp: ''!
pltCopyGroup: aClassSymbol to: anObject
	self class name == aClassSymbol
		ifTrue: [ self pltCopyTo: anObject ]
		ifFalse: [ super pltCopyGroup: aClassSymbol to: anObject ]

! !

!ExChdAdaPrimitiveClassReference methodsFor: 'platypus-generated-copying' stamp: ''!
pltCopyTo: another
	super pltCopyTo: another.
	self adaPrimitiveClassReferenceCopyTo: another

! !

!ExChdAdaPrimitiveClassReference methodsFor: 'platypus-generated-copying' stamp: ''!
pltLocalCopyTo: another
	self adaPrimitiveClassReferenceCopyTo: another

! !

!ExChdAdaPrimitiveClassReference methodsFor: 'platypus-generated-accessing' stamp: ''!
pointedTypeName
	^ pointedTypeName

! !

!ExChdAdaPrimitiveClassReference methodsFor: 'platypus-generated-accessing' stamp: ''!
pointedTypeName: aString
	pointedTypeName := aString

! !

!ExChdAdaPrimitiveClassReference methodsFor: 'platypus-generated-with-context-accessing' stamp: ''!
pointedTypeNameUsingContext: aContext
	^ self pointedTypeName

! !

!ExChdAdaPrimitiveClassReference methodsFor: 'platypus-generated-set-accessing' stamp: ''!
setPackageName: aString
	self packageName: aString

! !

!ExChdAdaPrimitiveClassReference methodsFor: 'platypus-generated-set-accessing' stamp: ''!
setPointedTypeName: aString
	self pointedTypeName: aString

! !

!ExChdAdaPrimitiveClassReference methodsFor: 'platypus-generated-initializing' stamp: ''!
stepInitialize
	super stepInitialize.
	pointedTypeName := ''.
	packageName := ''

! !

!ExChdAdaPrimitiveClassReference methodsFor: 'platypus-generated-group-accessing' stamp: ''!
toValues: values
	^ self adaPrimitiveClassReferenceToValues: (super toValues: values)

! !

!ExChdAdaNamedTypeReference class methodsFor: 'platypus-generated-platypus-signature' stamp: ''!
iso10303P11Translater
	^ 'Platypus (c) LISYC EA3883, Universite de Bretagne occidentale. Brest.'

! !

!ExChdAdaNamedTypeReference class methodsFor: 'platypus-generated-meta-data-accessing' stamp: ''!
schemaDefinition
	^ ExChdCheddarDomainsSchemaDefinition singleton

! !

!ExChdAdaNamedTypeReference class methodsFor: 'platypus-generated-meta-data-accessing' stamp: ''!
schemaInstance
	^ ExChdExpress2cheddarSchemaInstance singleton

! !

!ExChdAdaNamedTypeReference class methodsFor: 'platypus-generated-platypus-signature' stamp: ''!
translatedFromISO10303P11
	^ true

! !

!ExChdAdaNamedTypeReference class methodsFor: 'platypus-generated-platypus-signature' stamp: ''!
vwNamespaceName
	^ #Express2Cheddar

! !

!ExChdAdaNamedTypeReference methodsFor: 'platypus-generated-visiting' stamp: ''!
accept: aVisitor
	^ aVisitor acceptAdaNamedTypeReference: self

! !

!ExChdAdaNamedTypeReference methodsFor: 'platypus-generated-deriving' stamp: ''!
adaIdent
	^ self adaIdentUsingContext: self class context

! !

!ExChdAdaNamedTypeReference methodsFor: 'platypus-generated-deriving' stamp: ''!
adaIdentUsingContext: aContext
	^ self adaIdentUsingContext: aContext receiver: self

! !

!ExChdAdaNamedTypeReference methodsFor: 'platypus-generated-deriving' stamp: ''!
adaIdentUsingContext: aContext receiver: aReceiver
	^ (aReceiver refUsingContext: aContext) nameUsingContext: aContext

! !

!ExChdAdaNamedTypeReference methodsFor: 'platypus-generated-copying' stamp: ''!
adaNamedTypeReferenceCopyTo: another
	

! !

!ExChdAdaNamedTypeReference methodsFor: 'platypus-generated-group-accessing' stamp: ''!
adaNamedTypeReferenceFromValues: values
	| valuesloc |
	valuesloc := values asOrderedCollection.
	^ valuesloc

! !

!ExChdAdaNamedTypeReference methodsFor: 'platypus-generated-group-accessing' stamp: ''!
adaNamedTypeReferenceToValues: values
	^ values

! !

!ExChdAdaNamedTypeReference methodsFor: 'platypus-generated-deriving' stamp: ''!
adaRefIdent
	^ self adaRefIdentUsingContext: self class context

! !

!ExChdAdaNamedTypeReference methodsFor: 'platypus-generated-deriving' stamp: ''!
adaRefIdentUsingContext: aContext
	^ self adaRefIdentUsingContext: aContext receiver: self

! !

!ExChdAdaNamedTypeReference methodsFor: 'platypus-generated-deriving' stamp: ''!
adaRefIdentUsingContext: aContext receiver: aReceiver
	^ aReceiver adaIdentUsingContext: aContext

! !

!ExChdAdaNamedTypeReference methodsFor: 'platypus-generated-deriving' stamp: ''!
adbInterfacesList
	^ self adbInterfacesListUsingContext: self class context

! !

!ExChdAdaNamedTypeReference methodsFor: 'platypus-generated-deriving' stamp: ''!
adbInterfacesListUsingContext: aContext
	^ self adbInterfacesListUsingContext: aContext receiver: self

! !

!ExChdAdaNamedTypeReference methodsFor: 'platypus-generated-deriving' stamp: ''!
adbInterfacesListUsingContext: aContext receiver: aReceiver
	^ Array new

! !

!ExChdAdaNamedTypeReference methodsFor: 'platypus-generated-deriving' stamp: ''!
adsInterfacesList
	^ self adsInterfacesListUsingContext: self class context

! !

!ExChdAdaNamedTypeReference methodsFor: 'platypus-generated-deriving' stamp: ''!
adsInterfacesListUsingContext: aContext
	^ self adsInterfacesListUsingContext: aContext receiver: self

! !

!ExChdAdaNamedTypeReference methodsFor: 'platypus-generated-deriving' stamp: ''!
adsInterfacesListUsingContext: aContext receiver: aReceiver
	^ Array new

! !

!ExChdAdaNamedTypeReference methodsFor: 'platypus-generated-group-accessing' stamp: ''!
fromValues: values
	^ self adaNamedTypeReferenceFromValues: (super fromValues: values)

! !

!ExChdAdaNamedTypeReference methodsFor: 'platypus-generated-classifying' stamp: ''!
isExChdAdaNamedTypeReference
	^ true

! !

!ExChdAdaNamedTypeReference methodsFor: 'platypus-generated-group-accessing' stamp: ''!
localFromValues: values
	^ self adaNamedTypeReferenceFromValues: values

! !

!ExChdAdaNamedTypeReference methodsFor: 'platypus-generated-group-accessing' stamp: ''!
localToValues: values
	^ self adaNamedTypeReferenceToValues: values

! !

!ExChdAdaNamedTypeReference methodsFor: 'platypus-generated-copying' stamp: ''!
pltCopyGroup: aClassSymbol to: anObject
	self class name == aClassSymbol
		ifTrue: [ self pltCopyTo: anObject ]
		ifFalse: [ super pltCopyGroup: aClassSymbol to: anObject ]

! !

!ExChdAdaNamedTypeReference methodsFor: 'platypus-generated-copying' stamp: ''!
pltCopyTo: another
	super pltCopyTo: another.
	self adaNamedTypeReferenceCopyTo: another

! !

!ExChdAdaNamedTypeReference methodsFor: 'platypus-generated-copying' stamp: ''!
pltLocalCopyTo: another
	self adaNamedTypeReferenceCopyTo: another

! !

!ExChdAdaNamedTypeReference methodsFor: 'platypus-generated-initializing' stamp: ''!
stepInitialize
	super stepInitialize

! !

!ExChdAdaNamedTypeReference methodsFor: 'platypus-generated-group-accessing' stamp: ''!
toValues: values
	^ self adaNamedTypeReferenceToValues: (super toValues: values)

! !

ExChdAdaNamedTypeReference subclass: #ExChdAdaRecordReference
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Express2Cheddar-CheddarDomainsSchema'!

!ExChdAdaRecordReference commentStamp: 'platypus comment' prior: 0!
<ISO10303-11-EXPRESS>
ENTITY ada_record_reference 
	SUBTYPE OF ( ada_named_type_reference );
DERIVE
	SELF\entity_definition_reference.accepted : entity_instance := SELF.accept_ada_record_reference;
END_ENTITY;
</ISO10303-11-EXPRESS>!

!ExChdAdaRecordReference class methodsFor: 'platypus-generated-platypus-signature' stamp: ''!
iso10303P11Translater
	^ 'Platypus (c) LISYC EA3883, Universite de Bretagne occidentale. Brest.'

! !

!ExChdAdaRecordReference class methodsFor: 'platypus-generated-meta-data-accessing' stamp: ''!
schemaDefinition
	^ ExChdCheddarDomainsSchemaDefinition singleton

! !

!ExChdAdaRecordReference class methodsFor: 'platypus-generated-meta-data-accessing' stamp: ''!
schemaInstance
	^ ExChdExpress2cheddarSchemaInstance singleton

! !

!ExChdAdaRecordReference class methodsFor: 'platypus-generated-platypus-signature' stamp: ''!
translatedFromISO10303P11
	^ true

! !

!ExChdAdaRecordReference class methodsFor: 'platypus-generated-platypus-signature' stamp: ''!
vwNamespaceName
	^ #Express2Cheddar

! !

!ExChdAdaRecordReference methodsFor: 'platypus-generated-visiting' stamp: ''!
accept: aVisitor
	^ aVisitor acceptAdaRecordReference: self

! !

!ExChdAdaRecordReference methodsFor: 'platypus-generated-deriving' stamp: ''!
accepted
	^ self acceptedUsingContext: self class context

! !

!ExChdAdaRecordReference methodsFor: 'platypus-generated-deriving' stamp: ''!
acceptedUsingContext: aContext
	^ self acceptedUsingContext: aContext receiver: self

! !

!ExChdAdaRecordReference methodsFor: 'platypus-generated-deriving' stamp: ''!
acceptedUsingContext: aContext receiver: aReceiver
	^ aReceiver acceptAdaRecordReferenceUsingContext: aContext

! !

!ExChdAdaRecordReference methodsFor: 'platypus-generated-copying' stamp: ''!
adaRecordReferenceCopyTo: another
	

! !

!ExChdAdaRecordReference methodsFor: 'platypus-generated-group-accessing' stamp: ''!
adaRecordReferenceFromValues: values
	| valuesloc |
	valuesloc := values asOrderedCollection.
	^ valuesloc

! !

!ExChdAdaRecordReference methodsFor: 'platypus-generated-group-accessing' stamp: ''!
adaRecordReferenceToValues: values
	^ values

! !

!ExChdAdaRecordReference methodsFor: 'platypus-generated-group-accessing' stamp: ''!
fromValues: values
	^ self adaRecordReferenceFromValues: (super fromValues: values)

! !

!ExChdAdaRecordReference methodsFor: 'platypus-generated-classifying' stamp: ''!
isExChdAdaRecordReference
	^ true

! !

!ExChdAdaRecordReference methodsFor: 'platypus-generated-group-accessing' stamp: ''!
localFromValues: values
	^ self adaRecordReferenceFromValues: values

! !

!ExChdAdaRecordReference methodsFor: 'platypus-generated-group-accessing' stamp: ''!
localToValues: values
	^ self adaRecordReferenceToValues: values

! !

!ExChdAdaRecordReference methodsFor: 'platypus-generated-copying' stamp: ''!
pltCopyGroup: aClassSymbol to: anObject
	self class name == aClassSymbol
		ifTrue: [ self pltCopyTo: anObject ]
		ifFalse: [ super pltCopyGroup: aClassSymbol to: anObject ]

! !

!ExChdAdaRecordReference methodsFor: 'platypus-generated-copying' stamp: ''!
pltCopyTo: another
	super pltCopyTo: another.
	self adaRecordReferenceCopyTo: another

! !

!ExChdAdaRecordReference methodsFor: 'platypus-generated-copying' stamp: ''!
pltLocalCopyTo: another
	self adaRecordReferenceCopyTo: another

! !

!ExChdAdaRecordReference methodsFor: 'platypus-generated-initializing' stamp: ''!
stepInitialize
	super stepInitialize

! !

!ExChdAdaRecordReference methodsFor: 'platypus-generated-group-accessing' stamp: ''!
toValues: values
	^ self adaRecordReferenceToValues: (super toValues: values)

! !
ExChdExpress2cheddarSchemaInstance initialize!
